"\nJedi is a static analysis tool for Python that is typically used in\nIDEs/editors plugins. Jedi has a focus on autocompletion and goto\nfunctionality. Other features include refactoring, code search and finding\nreferences.\n\nJedi has a simple API to work with. There is a reference implementation as a\n`VIM-Plugin <https://github.com/davidhalter/jedi-vim>`_. Autocompletion in your\nREPL is also possible, IPython uses it natively and for the CPython REPL you\ncan install it. Jedi is well tested and bugs should be rare.\n\nHere's a simple example of the autocompletion feature:\n\n>>> import jedi\n>>> source = '''\n... import json\n... json.lo'''\n>>> script = jedi.Script(source, path='example.py')\n>>> script\n<Script: 'example.py' ...>\n>>> completions = script.complete(3, len('json.lo'))\n>>> completions\n[<Completion: load>, <Completion: loads>]\n>>> print(completions[0].complete)\nad\n>>> print(completions[0].name)\nload\n"
__version__='0.19.1'
from jedi.api import Script,Interpreter,set_debug_function,preload_module
from jedi import settings
from jedi.api.environment import find_virtualenvs,find_system_environments,get_default_environment,InvalidPythonEnvironment,create_environment,get_system_environment,InterpreterEnvironment
from jedi.api.project import Project,get_default_project
from jedi.api.exceptions import InternalError,RefactoringError
from jedi.plugins import registry
del registry