_H='parameters'
_G='decorator'
_F='arglist'
_E='funcdef'
_D='error_node'
_C=False
_B=True
_A=None
import re
from textwrap import dedent
from inspect import Parameter
from parso.python.token import PythonTokenTypes
from parso.python import tree
from parso.tree import search_ancestor,Leaf
from parso import split_lines
from jedi import debug
from jedi import settings
from jedi.api import classes
from jedi.api import helpers
from jedi.api import keywords
from jedi.api.strings import complete_dict
from jedi.api.file_name import complete_file_name
from jedi.inference import imports
from jedi.inference.base_value import ValueSet
from jedi.inference.helpers import infer_call_of_leaf,parse_dotted_names
from jedi.inference.context import get_global_filters
from jedi.inference.value import TreeInstance
from jedi.inference.docstring_utils import DocstringModule
from jedi.inference.names import ParamNameWrapper,SubModuleName
from jedi.inference.gradual.conversion import convert_values,convert_names
from jedi.parser_utils import cut_value_at_position
from jedi.plugins import plugin_manager
class ParamNameWithEquals(ParamNameWrapper):
	def get_public_name(A):return A.string_name+'='
def _get_signature_param_names(signatures,positional_count,used_kwargs):
	for C in signatures:
		for(D,A)in enumerate(C.params):
			B=A.kind
			if D<positional_count and B==Parameter.POSITIONAL_OR_KEYWORD:continue
			if B in(Parameter.POSITIONAL_OR_KEYWORD,Parameter.KEYWORD_ONLY)and A.name not in used_kwargs:yield ParamNameWithEquals(A._name)
def _must_be_kwarg(signatures,positional_count,used_kwargs):
	if used_kwargs:return _B
	A=_B
	for C in signatures:
		for(D,E)in enumerate(C.params):
			B=E.kind
			if B is Parameter.VAR_POSITIONAL:return _C
			if D>=positional_count and B in(Parameter.POSITIONAL_OR_KEYWORD,Parameter.POSITIONAL_ONLY):A=_C;break
		if not A:break
	return A
def filter_names(inference_state,completion_names,stack,like_name,fuzzy,cached_name):
	E=fuzzy;A=like_name;F=set()
	if settings.case_insensitive_completion:A=A.lower()
	for B in completion_names:
		C=B.string_name
		if settings.case_insensitive_completion:C=C.lower()
		if helpers.match(C,A,fuzzy=E):
			D=classes.Completion(inference_state,B,stack,len(A),is_fuzzy=E,cached_name=cached_name);G=D.name,D.complete
			if G not in F:
				F.add(G);H=B.tree_name
				if H is not _A:
					I=H.get_definition()
					if I is not _A and I.type=='del_stmt':continue
				yield D
def _remove_duplicates(completions,other_completions):B={A.name for A in other_completions};return[A for A in completions if A.name not in B]
def get_user_context(module_context,position):'\n    Returns the scope in which the user resides. This includes flows.\n    ';A=module_context;B=A.tree_node.get_leaf_for_position(position,include_prefixes=_B);return A.create_context(B)
def get_flow_scope_node(module_node,position):
	A=module_node.get_leaf_for_position(position,include_prefixes=_B)
	while not isinstance(A,(tree.Scope,tree.Flow)):A=A.parent
	return A
@plugin_manager.decorate()
def complete_param_names(context,function_name,decorator_nodes):return[]
class Completion:
	def __init__(A,inference_state,module_context,code_lines,position,signatures_callback,fuzzy=_C):D=position;C=code_lines;B=module_context;A._inference_state=inference_state;A._module_context=B;A._module_node=B.tree_node;A._code_lines=C;A._like_name=helpers.get_on_completion_name(A._module_node,C,D);A._original_position=D;A._signatures_callback=signatures_callback;A._fuzzy=fuzzy
	def complete(A):
		D=A._module_node.get_leaf_for_position(A._original_position,include_prefixes=_B);B,E,F=_extract_string_while_in_string(D,A._original_position);C=complete_dict(A._module_context,A._code_lines,E or D,A._original_position,_A if B is _A else F+B,fuzzy=A._fuzzy)
		if B is not _A and not C:C=list(complete_file_name(A._inference_state,A._module_context,E,F,B,A._like_name,A._signatures_callback,A._code_lines,A._original_position,A._fuzzy))
		if B is not _A:
			if not C and'\n'in B:C=A._complete_in_string(E,B)
			return C
		H,I=A._complete_python(D);G=list(filter_names(A._inference_state,I,A.stack,A._like_name,A._fuzzy,cached_name=H));return _remove_duplicates(C,G)+sorted(G,key=lambda x:(x.name.startswith('__'),x.name.startswith('_'),x.name.lower()))
	def _complete_python(A,leaf):
		'\n        Analyzes the current context of a completion and decides what to\n        return.\n\n        Technically this works by generating a parser stack and analysing the\n        current stack for possible grammar nodes.\n\n        Possible enhancements:\n        - global/nonlocal search global\n        - yield from / raise from <- could be only exceptions/generators\n        - In args: */**: no completion\n        - In params (also lambda): no completion before =\n        ';Z='trailer';Y='import_from';X='try_stmt';W='for_stmt';V='if_stmt';O='else';B=leaf;a=A._inference_state.grammar;A.stack=J=_A;A._position=A._original_position[0],A._original_position[1]-len(A._like_name);G=_A
		try:A.stack=J=helpers.get_stack_at_position(a,A._code_lines,B,A._position)
		except helpers.OnErrorLeaf as b:
			c=b.error_leaf.value
			if c=='.':return G,[]
			return G,A._complete_global_scope()
		D=list(J._allowed_transition_names_and_token_types())
		if'if'in D:
			B=A._module_node.get_leaf_for_position(A._position,include_prefixes=_B);P=B.get_previous_leaf();Q=A._position[1]
			if not B.start_pos<=A._position<=B.end_pos:Q=B.start_pos[1]
			if P is not _A:
				E=P
				while _B:
					E=search_ancestor(E,V,W,'while_stmt',X,_D)
					if E is _A:break
					H=E.type
					if H==_D:
						R=E.children[0]
						if isinstance(R,Leaf):H=R.value+'_stmt'
					if E.start_pos[1]==Q:
						if H==V:D+=['elif',O]
						elif H==X:D+=['except','finally',O]
						elif H==W:D.append(O)
		C=[];L=_C
		if any(A in D for A in(PythonTokenTypes.NAME,PythonTokenTypes.INDENT)):
			I=[A.nonterminal for A in J];F=_gather_nodes(J)
			if F and F[-1]in('as','def','class'):return G,list(A._complete_inherited(is_function=_B))
			elif'import_stmt'in I:d,e=parse_dotted_names(F,Y in I);f=not(Y in I and'import'in F);C+=A._get_importer_names(e,d,only_modules=f)
			elif I[-1]in(Z,'dotted_name')and F[-1]=='.':
				M=A._module_node.get_leaf_for_position(A._position)
				if M.type=='endmarker':M=B.get_previous_leaf()
				G,g=A._complete_trailer(M.get_previous_leaf());C+=g
			elif A._is_parameter_completion():C+=A._complete_params(B)
			else:
				if F[-1]in['(',',']and I[-1]in(Z,_F,_G):
					K=A._signatures_callback(*A._position)
					if K:S=K[0]._call_details;T=list(S.iter_used_keyword_arguments());U=S.count_positional_arguments();C+=_get_signature_param_names(K,U,T);L=_must_be_kwarg(K,U,T)
				if not L:C+=A._complete_global_scope();C+=A._complete_inherited(is_function=_C)
		if not L:N=A._code_lines[A._position[0]-1][:A._position[1]];C+=A._complete_keywords(D,only_values=not(not N or N[-1]in' \t.;'and N[-3:]!='...'))
		return G,C
	def _is_parameter_completion(B):
		A=B.stack[-1]
		if A.nonterminal=='lambdef'and len(A.nodes)==1:return _B
		if A.nonterminal in _H:return _B
		return A.nonterminal in('typedargslist','varargslist')and A.nodes[-1]==','
	def _complete_params(A,leaf):
		B=A.stack[-2]
		if B.nonterminal==_H:B=A.stack[-3]
		if B.nonterminal==_E:
			F=get_user_context(A._module_context,A._position);C=search_ancestor(leaf,_D,_E)
			if C is not _A:
				if C.type==_D:
					D=C.children[0]
					if D.type=='decorators':E=D.children
					elif D.type==_G:E=[D]
					else:E=[]
				else:E=C.get_decorators()
				G=B.nodes[1];return complete_param_names(F,G.value,E)
		return[]
	def _complete_keywords(B,allowed_transitions,only_values):
		for A in allowed_transitions:
			if isinstance(A,str)and A.isalpha():
				if not only_values or A in('True','False','None'):yield keywords.KeywordName(B._inference_state,A)
	def _complete_global_scope(A):
		B=get_user_context(A._module_context,A._position);debug.dbg('global completion scope: %s',B);D=get_flow_scope_node(A._module_node,A._position);E=get_global_filters(B,A._position,D);C=[]
		for filter in E:C+=filter.values()
		return C
	def _complete_trailer(C,previous_leaf):
		D=previous_leaf;G=C._module_context.create_context(D);A=infer_call_of_leaf(G,D);debug.dbg('trailer completion values: %s',A,color='MAGENTA');E=_A
		if len(A)==1:
			B,=A
			if B.is_module():
				if len(B.string_names)==1:
					F=B.string_names[0]
					if F in('numpy','tensorflow','matplotlib','pandas'):E=F
		return E,C._complete_trailer_for_values(A)
	def _complete_trailer_for_values(A,values):B=get_user_context(A._module_context,A._position);return complete_trailer(B,values)
	def _get_importer_names(A,names,level=0,only_modules=_B):B=names;B=[A.value for A in B];C=imports.Importer(A._inference_state,B,A._module_context,level);return C.completion_names(A._inference_state,only_modules=only_modules)
	def _complete_inherited(A,is_function=_B):
		'\n        Autocomplete inherited methods when overriding in child class.\n        ';C=A._module_node.get_leaf_for_position(A._position,include_prefixes=_B);B=tree.search_ancestor(C,'classdef')
		if B is _A:return
		F=A._module_context.create_value(B)
		if B.start_pos[1]>=C.start_pos[1]:return
		D=F.get_filters(is_instance=_B);next(D)
		for filter in D:
			for E in filter.values():
				if(E.api_type=='function')==is_function:yield E
	def _complete_in_string(D,start_leaf,string):
		'\n        To make it possible for people to have completions in doctests or\n        generally in "Python" code in docstrings, we use the following\n        heuristic:\n\n        - Having an indented block of code\n        - Having some doctest code that starts with `>>>`\n        - Having backticks that doesn\'t have whitespace inside it\n        ';B=string
		def F(lines):
			B=_C
			for A in C:
				if B or A.startswith('>>>')or A.startswith(' '):yield re.sub('^( *>>> ?| +)','',A)
				else:yield _A
				B=bool(re.match(' *>>>',A))
		B=dedent(B);C=split_lines(B,keepends=_B);A=list(F(C))
		if A[-1]is not _A:A=['\n'if A is _A else A for A in A];return D._complete_code_lines(A)
		E=re.search('`([^`\\s]+)',C[-1])
		if E:return D._complete_code_lines([E.group(1)])
		return[]
	def _complete_code_lines(A,code_lines):B=code_lines;C=A._inference_state.grammar.parse(''.join(B));D=DocstringModule(in_module_context=A._module_context,inference_state=A._inference_state,module_node=C,code_lines=B);return Completion(A._inference_state,D.as_context(),code_lines=B,position=C.end_pos,signatures_callback=lambda*A,**B:[],fuzzy=A._fuzzy).complete()
def _gather_nodes(stack):
	A=[]
	for B in stack:
		if B.dfa.from_rule=='small_stmt':A=[]
		else:A+=B.nodes
	return A
_string_start=re.compile('^\\w*(\\\'{3}|"{3}|\\\'|")')
def _extract_string_while_in_string(leaf,position):
	B=position;A=leaf
	def D(leaf):
		A=leaf;D={}
		if A.line==B[0]:D['endpos']=B[1]-A.column
		C=_string_start.match(A.value,**D)
		if not C:return _A,_A,_A
		E=C.group(0)
		if A.line==B[0]and B[1]<A.column+C.end():return _A,_A,_A
		return cut_value_at_position(A,B)[C.end():],A,E
	if B<A.start_pos:return _A,_A,_A
	if A.type=='string':return D(A)
	E=[]
	while A is not _A:
		if A.type=='error_leaf'and('"'in A.value or"'"in A.value):
			if len(A.value)>1:return D(A)
			C=_A
			if not A.prefix:
				C=A.get_previous_leaf()
				if C is _A or C.type!='name'or not all(A in'rubf'for A in C.value.lower()):C=_A
			return''.join(cut_value_at_position(A,B)for A in E),C or A,(''if C is _A else C.value)+cut_value_at_position(A,B)
		if A.line!=B[0]:break
		E.insert(0,A);A=A.get_previous_leaf()
	return _A,_A,_A
def complete_trailer(user_context,values):
	D=values;C=user_context;A=[]
	for B in D:
		for filter in B.get_filters(origin_scope=C.tree_node):A+=filter.values()
		if not B.is_stub()and isinstance(B,TreeInstance):A+=_complete_getattr(C,B)
	F=convert_values(D)
	for E in F:
		if E not in D:
			for filter in E.get_filters(origin_scope=C.tree_node):A+=filter.values()
	return A
def _complete_getattr(user_context,instance):
	"\n    A heuristic to make completion for proxy objects work. This is not\n    intended to work in all cases. It works exactly in this case:\n\n        def __getattr__(self, name):\n            ...\n            return getattr(any_object, name)\n\n    It is important that the return contains getattr directly, otherwise it\n    won't work anymore. It's really just a stupid heuristic. It will not\n    work if you write e.g. `return (getatr(o, name))`, because of the\n    additional parentheses. It will also not work if you move the getattr\n    to some other place that is not the return statement itself.\n\n    It is intentional that it doesn't work in all cases. Generally it's\n    really hard to do even this case (as you can see below). Most people\n    will write it like this anyway and the other ones, well they are just\n    out of luck I guess :) ~dave.\n    ";D=instance;J=D.get_function_slot_names('__getattr__')or D.get_function_slot_names('__getattribute__');K=ValueSet.from_sets(A.infer()for A in J)
	for E in K:
		C=E.tree_node
		if C is _A or C.type!=_E:continue
		for F in C.iter_return_stmts():
			if F.type!='return_stmt':continue
			A=F.children[1]
			if A.type!='atom_expr':continue
			G=A.children[0];L=A.children[1]
			if len(A.children)!=2 or G.type!='name'or G.value!='getattr':continue
			B=L.children[1]
			if B.type!=_F or len(B.children)<3:continue
			H=E.as_context();M=B.children[0];I=B.children[2];N=H.goto(I,I.start_pos)
			if not any(A.api_type=='param'for A in N):continue
			O=H.infer_node(M);return complete_trailer(user_context,O)
	return[]
def search_in_module(inference_state,module_context,names,wanted_names,wanted_type,complete=_C,fuzzy=_C,ignore_imports=_C,convert=_C):
	J=fuzzy;I=wanted_type;H=wanted_names;G=inference_state;C=complete;A=names
	for M in H[:-1]:
		D=[]
		for B in A:
			if M==B.string_name:
				if B.tree_name is not _A and B.api_type in('module','namespace')and ignore_imports:continue
				D+=complete_trailer(module_context,B.infer())
		debug.dbg('dot lookup on search %s from %s',D,A[:10]);A=D
	E=H[-1].lower()
	for B in A:
		K=B.string_name.lower()
		if C and helpers.match(K,E,fuzzy=J)or not C and K==E:
			if isinstance(B,SubModuleName):A=[A.name for A in B.infer()]
			else:A=[B]
			if convert:A=convert_names(A)
			for L in A:
				if C:F=classes.Completion(G,L,stack=_A,like_name_length=len(E),is_fuzzy=J)
				else:F=classes.Name(G,L)
				if not I or I==F.type:yield F