'\nHelpers for the API\n'
_J='async_stmt'
_I='argument'
_H='arglist'
_G='error_leaf'
_F='string'
_E='trailer'
_D=True
_C='name'
_B=False
_A=None
import re
from collections import namedtuple
from textwrap import dedent
from itertools import chain
from functools import wraps
from inspect import Parameter
from parso.python.parser import Parser
from parso.python import tree
from jedi.inference.base_value import NO_VALUES
from jedi.inference.syntax_tree import infer_atom
from jedi.inference.helpers import infer_call_of_leaf
from jedi.inference.compiled import get_string_value_set
from jedi.cache import signature_time_cache,memoize_method
from jedi.parser_utils import get_parent_scope
CompletionParts=namedtuple('CompletionParts',['path','has_dot',_C])
def _start_match(string,like_name):return string.startswith(like_name)
def _fuzzy_match(string,like_name):
	B=string;A=like_name
	if len(A)<=1:return A in B
	C=B.find(A[0])
	if C>=0:return _fuzzy_match(B[C+1:],A[1:])
	return _B
def match(string,like_name,fuzzy=_B):
	B=like_name;A=string
	if fuzzy:return _fuzzy_match(A,B)
	else:return _start_match(A,B)
def sorted_definitions(defs):return sorted(defs,key=lambda x:(str(x.module_path or''),x.line or 0,x.column or 0,x.name))
def get_on_completion_name(module_node,lines,position):
	B=position;A=module_node.get_leaf_for_position(B)
	if A is _A or A.type in(_F,_G):C=lines[B[0]-1];return re.search('(?!\\d)\\w+$|$',C[:B[1]]).group(0)
	elif A.type not in(_C,'keyword'):return''
	return A.value[:B[1]-A.start_pos[1]]
def _get_code(code_lines,start_pos,end_pos):C=end_pos;B=start_pos;A=code_lines[B[0]-1:C[0]];A[-1]=A[-1][:C[1]];A[0]=A[0][B[1]:];return''.join(A)
class OnErrorLeaf(Exception):
	@property
	def error_leaf(self):return self.args[0]
def _get_code_for_stack(code_lines,leaf,position):
	D='newline';C=position;A=leaf
	if A.start_pos>=C:
		A=A.get_previous_leaf()
		if A is _A:return''
	E=A.type==D
	while A.type==D:
		A=A.get_previous_leaf()
		if A is _A:return''
	if A.type==_G or A.type==_F:
		if A.start_pos[0]<C[0]:return''
		raise OnErrorLeaf(A)
	else:
		B=A
		while _D:
			if B.parent.type in('file_input','suite','simple_stmt'):break
			B=B.parent
		if E:
			if B.start_pos[1]>C[1]:return''
		return _get_code(code_lines,B.get_start_pos_of_prefix(),C)
def get_stack_at_position(grammar,code_lines,leaf,pos):
	'\n    Returns the possible node names (e.g. import_from, xor_test or yield_stmt).\n    ';D=grammar
	class B(Exception):0
	def E(code):
		E=D._tokenize(code)
		for A in E:
			if A.string==C:raise B()
			elif A.prefix.endswith(C):raise B()
			elif A.string.endswith(C):yield A;raise B()
			else:yield A
	A=dedent(_get_code_for_stack(code_lines,leaf,pos));C='ZZZ_USER_WANTS_TO_COMPLETE_HERE_WITH_JEDI';A=A+' '+C;F=Parser(D._pgen_grammar,error_recovery=_D)
	try:F.parse(tokens=E(A))
	except B:return F.stack
	raise SystemError("This really shouldn't happen. There's a bug in Jedi:\n%s"%list(E(A)))
def infer(inference_state,context,leaf):
	D=inference_state;B=context;A=leaf
	if A.type==_C:return D.infer(B,A)
	E=A.parent;C=NO_VALUES
	if E.type=='atom':C=B.infer_node(A.parent)
	elif E.type==_E:C=infer_call_of_leaf(B,A)
	elif isinstance(A,tree.Literal):return infer_atom(B,A)
	elif A.type in('fstring_string','fstring_start','fstring_end'):return get_string_value_set(D)
	return C
def filter_follow_imports(names,follow_builtin_imports=_B):
	B=follow_builtin_imports
	for A in names:
		if A.is_import():
			C=list(filter_follow_imports(A.goto(),follow_builtin_imports=B));D=_B
			if B:
				for E in C:
					if E.start_pos is _A:D=_D
			if D:yield A
			else:yield from C
		else:yield A
class CallDetails:
	def __init__(A,bracket_leaf,children,position):A.bracket_leaf=bracket_leaf;A._children=children;A._position=position
	@property
	def index(self):return _get_index_and_key(self._children,self._position)[0]
	@property
	def keyword_name_str(self):return _get_index_and_key(self._children,self._position)[1]
	@memoize_method
	def _list_arguments(self):return list(_iter_arguments(self._children,self._position))
	def calculate_index(L,param_names):
		I=param_names;F=0;J=set();B=-1;G=L._list_arguments()
		if not G:
			if I:return 0
			else:return
		K=_B
		for(A,(B,D,H))in enumerate(G):
			K|=H|(B==2)
			if B:0
			elif A+1!=len(G):
				if H:J.add(D)
				else:F+=1
		for(A,E)in enumerate(I):
			C=E.get_kind()
			if not K:
				if C==Parameter.VAR_POSITIONAL:return A
				if C in(Parameter.POSITIONAL_OR_KEYWORD,Parameter.POSITIONAL_ONLY):
					if A==F:return A
			if D is not _A and not B==1 or B==2:
				if E.string_name not in J and(C==Parameter.KEYWORD_ONLY or C==Parameter.POSITIONAL_OR_KEYWORD and F<=A):
					if B:return A
					if H:
						if E.string_name==D:return A
					elif E.string_name.startswith(D):return A
				if C==Parameter.VAR_KEYWORD:return A
	def iter_used_keyword_arguments(B):
		for(D,A,C)in list(B._list_arguments()):
			if C and A:yield A
	def count_positional_arguments(B):
		A=0
		for(C,D,E)in B._list_arguments()[:-1]:
			if C or D:break
			A+=1
		return A
def _iter_arguments(nodes,position):
	E=position
	def F(name):
		A=name
		if A.type!=_C:return
		return A.value[:E[1]-A.start_pos[1]]
	C=[A for A in nodes if A.start_pos<E]
	if C[-1].type==_H:yield from _iter_arguments(C[-1].children,E);return
	D=_B;B=0
	for(L,A)in enumerate(C):
		if A.type==_I:
			D=_D;G=A.children[0];I=A.children[1]
			if I=='=':
				if I.start_pos<E and G.type==_C:yield(0,G.value,_D)
				else:yield(0,F(G),_B)
			elif G in('*','**'):yield(len(G.value),F(I),_B)
			else:
				J=A.get_first_leaf()
				if J.type==_C and J.start_pos>=E:yield(0,F(J),_B)
				else:yield(0,_A,_B)
			B=0
		elif A.type=='testlist_star_expr':
			for H in A.children[::2]:
				if H.type=='star_expr':B=1;H=H.children[1]
				yield(B,F(H),_B);B=0
			D=bool(len(A.children)%2)
		elif isinstance(A,tree.PythonLeaf)and A.value==',':
			if not D:yield(B,'',_B);B=0
			D=_B
		elif isinstance(A,tree.PythonLeaf)and A.value in('*','**'):B=len(A.value)
		elif A=='='and C[-1]:
			D=_D;K=C[L-1]
			if K.type==_C:yield(0,K.value,_D)
			else:yield(0,_A,_B)
			B=0
	if not D:
		if C[-1].type==_C:yield(B,F(C[-1]),_B)
		else:yield(B,'',_B)
def _get_index_and_key(nodes,position):
	'\n    Returns the amount of commas and the keyword argument string.\n    ';C=position;A=[A for A in nodes if A.start_pos<C]
	if A[-1].type==_H:return _get_index_and_key(A[-1].children,C)
	D=_A;B=A[-1]
	if B.type==_I and B.children[1]=='='and B.children[1].end_pos<=C:D=B.children[0].value
	elif B=='=':D=A[-2].value
	return A.count(','),D
def _get_signature_details_from_error_node(node,additional_children,position):
	C=position
	for(D,A)in reversed(list(enumerate(node.children))):
		if A=='('and A.end_pos<=C and D>0:
			E=node.children[D:];B=A.get_previous_leaf()
			if B is _A:continue
			if B.type==_C or B.parent.type in(_E,'atom'):return CallDetails(A,E+additional_children,C)
def get_signature_details(module,position):
	C=position;B=module.get_leaf_for_position(C,include_prefixes=_D)
	if B.start_pos>=C:
		B=B.get_previous_leaf()
		if B is _A:return
	A=B.parent
	while A is not _A:
		if A.type in('funcdef','classdef','decorated',_J):return
		E=[]
		for D in reversed(A.children):
			if D.start_pos<C:
				if D.type=='error_node':
					F=_get_signature_details_from_error_node(D,E,C)
					if F is not _A:return F
					E[0:0]=D.children;continue
				E.insert(0,D)
		if A.type==_E and A.children[0]=='('or A.type=='decorator'and A.children[2]=='(':
			if not(B is A.children[-1]and C>=B.end_pos):
				B=A.get_previous_leaf()
				if B is _A:return
				return CallDetails(A.children[0]if A.type==_E else A.children[2],A.children,C)
		A=A.parent
@signature_time_cache('call_signatures_validity')
def cache_signatures(inference_state,context,bracket_leaf,code_lines,user_pos):
	'This function calculates the cache key.';D=user_pos;C=code_lines;B=context;A=bracket_leaf;E=D[0]-1;G=C[E][:D[1]];H=C[A.start_pos[0]:E];I=''.join(H+[G]);J=re.match('.*\\(',I,re.DOTALL);F=B.get_root_context().py__file__()
	if F is _A:yield _A
	else:yield(F,J,A.start_pos)
	yield infer(inference_state,B,A.get_previous_leaf())
def validate_line_column(func):
	@wraps(func)
	def A(self,line=_A,column=_A,*F,**G):
		D=self;B=column;A=line;A=max(len(D._code_lines),1)if A is _A else A
		if not 0<A<=len(D._code_lines):raise ValueError('`line` parameter is not in a valid range.')
		E=D._code_lines[A-1];C=len(E)
		if E.endswith('\r\n'):C-=2
		elif E.endswith('\n'):C-=1
		B=C if B is _A else B
		if not 0<=B<=C:raise ValueError('`column` parameter (%d) is not in a valid range (0-%d) for line %d (%r).'%(B,C,A,E))
		return func(D,A,B,*F,**G)
	return A
def get_module_names(module,all_scopes,definitions=_D,references=_B):
	'\n    Returns a dictionary with name parts as keys and their call paths as\n    values.\n    ';B=module
	def C(name):A=name.is_definition();return definitions and A or references and not A
	A=list(chain.from_iterable(B.get_used_names().values()))
	if not all_scopes:
		def D(name):
			A=get_parent_scope(name)
			if A and A.type==_J:A=A.parent
			return A in(B,_A)
		A=[A for A in A if D(A)]
	return filter(C,A)
def split_search_string(name):
	type,B,A=name.rpartition(' ')
	if type=='def':type='function'
	return type,A.split('.')