'\nThis module is here for string completions. This means mostly stuff where\nstrings are returned, like `foo = dict(bar=3); foo["ba` would complete to\n`"bar"]`.\n\nIt however does the same for numbers. The difference between string completions\nand other completions is mostly that this module doesn\'t return defined\nnames in a module, but pretty much an arbitrary string.\n'
_A=None
import re
from jedi.inference.names import AbstractArbitraryName
from jedi.inference.helpers import infer_call_of_leaf
from jedi.api.classes import Completion
from jedi.parser_utils import cut_value_at_position
_sentinel=object()
class StringName(AbstractArbitraryName):api_type='string';is_value_name=False
def complete_dict(module_context,code_lines,leaf,position,string,fuzzy):
	F=position;E=module_context;C=leaf;A=string;B=C
	if B!='[':B=C.get_previous_leaf()
	G=''
	if A:G=get_quote_ending(A,code_lines,F,invert_result=True)
	if B=='[':
		if A is _A and C is not B:A=cut_value_at_position(C,F)
		H=E.create_context(B);D=I=B.get_previous_leaf()
		if D in(')',']','}'):D=D.parent
		if D.type in('atom','trailer','name'):J=infer_call_of_leaf(H,I);return list(_completions_for_dicts(E.inference_state,J,''if A is _A else A,G,fuzzy=fuzzy))
	return[]
def _completions_for_dicts(inference_state,dicts,literal_string,cut_end_quote,fuzzy):
	B=inference_state;A=literal_string
	for D in sorted(_get_python_keys(dicts),key=lambda x:repr(x)):
		C=_create_repr_string(A,D)
		if C.startswith(A):E=StringName(B,C[:-len(cut_end_quote)or _A]);yield Completion(B,E,stack=_A,like_name_length=len(A),is_fuzzy=fuzzy)
def _create_repr_string(literal_string,dict_key):
	D=literal_string;C=dict_key
	if not isinstance(C,(str,bytes))or not D:return repr(C)
	A=repr(C);E,B=_get_string_prefix_and_quote(D)
	if B is _A:return A
	if B==A[0]:return E+A
	return E+B+A[1:-1]+B
def _get_python_keys(dicts):
	for A in dicts:
		if A.array_type=='dict':
			for C in A.get_key_values():
				B=C.get_safe_value(default=_sentinel)
				if B is not _sentinel:yield B
def _get_string_prefix_and_quote(string):
	A=re.match('(\\w*)("""|\\\'{3}|"|\\\')',string)
	if A is _A:return _A,_A
	return A.group(1),A.group(2)
def _matches_quote_at_position(code_lines,quote,position):B=quote;A=position;C=code_lines[A[0]-1][A[1]:A[1]+len(B)];return C==B
def get_quote_ending(string,code_lines,position,invert_result=False):
	B,A=_get_string_prefix_and_quote(string)
	if A is _A:return''
	if _matches_quote_at_position(code_lines,A,position)!=invert_result:return''
	return A