'\nModule for statical analysis.\n'
_C='attribute-error'
_B=False
_A=None
from parso.python import tree
from jedi import debug
from jedi.inference.helpers import is_string
CODES={_C:(1,AttributeError,'Potential AttributeError.'),'name-error':(2,NameError,'Potential NameError.'),'import-error':(3,ImportError,'Potential ImportError.'),'type-error-too-many-arguments':(4,TypeError,_A),'type-error-too-few-arguments':(5,TypeError,_A),'type-error-keyword-argument':(6,TypeError,_A),'type-error-multiple-values':(7,TypeError,_A),'type-error-star-star':(8,TypeError,_A),'type-error-star':(9,TypeError,_A),'type-error-operation':(10,TypeError,_A),'type-error-not-iterable':(11,TypeError,_A),'type-error-isinstance':(12,TypeError,_A),'type-error-not-subscriptable':(13,TypeError,_A),'value-error-too-many-values':(14,ValueError,_A),'value-error-too-few-values':(15,ValueError,_A)}
class Error:
	def __init__(A,name,module_path,start_pos,message=_A):
		B=message;A.path=module_path;A._start_pos=start_pos;A.name=name
		if B is _A:B=CODES[A.name][2]
		A.message=B
	@property
	def line(self):return self._start_pos[0]
	@property
	def column(self):return self._start_pos[1]
	@property
	def code(self):A=self.__class__.__name__[0];return A+str(CODES[self.name][0])
	def __str__(A):return'%s:%s:%s: %s %s'%(A.path,A.line,A.column,A.code,A.message)
	def __eq__(A,other):B=other;return A.path==B.path and A.name==B.name and A._start_pos==B._start_pos
	def __ne__(A,other):return not A.__eq__(other)
	def __hash__(A):return hash((A.path,A._start_pos,A.name))
	def __repr__(A):return'<%s %s: %s@%s,%s>'%(A.__class__.__name__,A.name,A.path,A._start_pos[0],A._start_pos[1])
class Warning(Error):0
def add(node_context,error_name,node,message=_A,typ=Error,payload=_A):
	C=error_name;A=node_context;D=CODES[C][1]
	if _check_for_exception_catch(A,node,D,payload):return
	E=A.get_root_context();F=E.py__file__();B=typ(C,F,node.start_pos,message);debug.warning(str(B),format=_B);A.inference_state.analysis.append(B);return B
def _check_for_setattr(instance):
	"\n    Check if there's any setattr method inside an instance. If so, return True.\n    ";B=instance.get_root_context();A=B.tree_node
	if A is _A:return _B
	try:C=A.get_used_names()['setattr']
	except KeyError:return _B
	return any(A.start_pos<B.start_pos<A.end_pos and not(B.parent.type=='funcdef'and B.parent.name==B)for B in C)
def add_attribute_error(name_context,lookup_value,name):
	B=name;A=lookup_value;D='AttributeError: %s has no attribute %s.'%(A,B);C=Error
	if A.is_instance()and not A.is_compiled():
		if _check_for_setattr(A):C=Warning
	E=A,B;add(name_context,_C,B,D,C,E)
def _check_for_exception_catch(node_context,jedi_name,exception,payload=_A):
	"\n    Checks if a jedi object (e.g. `Statement`) sits inside a try/catch and\n    doesn't count as an error (if equal to `exception`).\n    Also checks `hasattr` for AttributeErrors and uses the `payload` to compare\n    it.\n    Returns True if the exception was catched.\n    ";G=payload;E=exception;D=jedi_name;C=node_context;B=True
	def F(cls,exception):
		A=cls
		if not A.is_class():return _B
		for C in exception.mro():
			if A.py__name__()==C.__name__ and A.parent_context.is_builtins_module():return B
		return _B
	def H(obj,exception):
		G=exception;E=iter(obj.children)
		for H in E:
			next(E);J=next(E)
			if H=='try'and not H.start_pos<D.start_pos<=J.end_pos:return _B
		for I in obj.get_except_clause_tests():
			if I is _A:return B
			else:
				K=C.infer_node(I)
				for A in K:
					from jedi.inference.value import iterable as L
					if isinstance(A,L.Sequence)and A.array_type=='tuple':
						for M in A.py__iter__():
							for N in M.infer():
								if F(N,G):return B
					elif F(A,G):return B
	def I(node,suite):
		H=suite;A=node
		try:assert H.start_pos<=D.start_pos<H.end_pos;assert A.type in('power','atom_expr');I=A.children[0];assert I.type=='name'and I.value=='hasattr';J=A.children[1];assert J.type=='trailer';K=J.children[1];assert K.type=='arglist';from jedi.inference.arguments import TreeArguments as L;M=L(C.inference_state,C,K);B=list(M.unpack());assert len(B)==2;N,E=B[1];F=list(E.infer());assert len(F)==1 and is_string(F[0]);assert F[0].get_safe_value()==G[1].value;N,E=B[0];O=E.infer();return G[0]in O
		except AssertionError:return _B
	A=D
	while A is not _A and not isinstance(A,(tree.Function,tree.Class)):
		if isinstance(A,tree.Flow):
			if A.type=='try_stmt'and H(A,E):return B
			if E==AttributeError and A.type in('if_stmt','while_stmt'):
				if I(A.children[1],A.children[3]):return B
		A=A.parent
	return _B