_C='<%s: %s>'
_B='argument'
_A=None
import re
from itertools import zip_longest
from parso.python import tree
from jedi import debug
from jedi.inference.utils import PushBackIterator
from jedi.inference import analysis
from jedi.inference.lazy_value import LazyKnownValue,LazyKnownValues,LazyTreeValue,get_merged_lazy_value
from jedi.inference.names import ParamName,TreeNameDefinition,AnonymousParamName
from jedi.inference.base_value import NO_VALUES,ValueSet,ContextualizedNode
from jedi.inference.value import iterable
from jedi.inference.cache import inference_state_as_method_param_cache
def try_iter_content(types,depth=0):
	'Helper method for static analysis.';A=depth
	if A>10:return
	for B in types:
		try:C=B.py__iter__
		except AttributeError:pass
		else:
			for D in C():try_iter_content(D.infer(),A+1)
class ParamIssue(Exception):0
def repack_with_argument_clinic(clinic_string):
	"\n    Transforms a function or method with arguments to the signature that is\n    given as an argument clinic notation.\n\n    Argument clinic is part of CPython and used for all the functions that are\n    implemented in C (Python 3.7):\n\n        str.split.__text_signature__\n        # Results in: '($self, /, sep=None, maxsplit=-1)'\n    "
	def A(func):
		def A(value,arguments):
			A=value
			try:B=tuple(iterate_argument_clinic(A.inference_state,arguments,clinic_string))
			except ParamIssue:return NO_VALUES
			else:return func(A,*B)
		return A
	return A
def iterate_argument_clinic(inference_state,arguments,clinic_string):
	'Uses a list with argument clinic information (see PEP 436).';E=list(_parse_argument_clinic(clinic_string));C=PushBackIterator(arguments.unpack())
	for(J,(F,G,K,H))in enumerate(E):
		if H==1:
			D=[]
			for(B,A)in C:
				if B is not _A:C.push_back((B,A));break
				D.append(A)
			yield ValueSet([iterable.FakeTuple(inference_state,D)]);D;continue
		elif H==2:raise NotImplementedError
		B,A=next(C,(_A,_A))
		if B is not _A:debug.warning('Keyword arguments in argument clinic are currently not supported.');raise ParamIssue
		if A is _A and not G:debug.warning('TypeError: %s expected at least %s arguments, got %s',F,len(E),J);raise ParamIssue
		I=NO_VALUES if A is _A else A.infer()
		if not I and not G:debug.warning('argument_clinic "%s" not resolvable.',F);raise ParamIssue
		yield I
def _parse_argument_clinic(string):
	G=False;A=string;D=G;E=G
	while A:
		B=re.match('(?:(?:(\\[),? ?|, ?|)(\\**\\w+)|, ?/)\\]*',A);A=A[len(B.group(0)):]
		if not B.group(2):D=True;continue
		E=E or bool(B.group(1));C=B.group(2);F=C.count('*');C=C[F:];yield(C,E,D,F)
		if F:D=True
class _AbstractArgumentsMixin:
	def unpack(A,funcdef=_A):raise NotImplementedError
	def get_calling_nodes(A):return[]
class AbstractArguments(_AbstractArgumentsMixin):context=_A;argument_node=_A;trailer=_A
def unpack_arglist(arglist):
	C='**';B=arglist
	if B is _A:return
	if B.type!='arglist'and not(B.type==_B and B.children[0]in('*',C)):yield(0,B);return
	D=iter(B.children)
	for A in D:
		if A==',':continue
		elif A in('*',C):E=next(D,_A);assert E is not _A;yield(len(A.value),E)
		elif A.type==_B and A.children[0]in('*',C):assert len(A.children)==2;yield(len(A.children[0].value),A.children[1])
		else:yield(0,A)
class TreeArguments(AbstractArguments):
	def __init__(A,inference_state,context,argument_node,trailer=_A):'\n        :param argument_node: May be an argument_node or a list of nodes.\n        ';A.argument_node=argument_node;A.context=context;A._inference_state=inference_state;A.trailer=trailer
	@classmethod
	@inference_state_as_method_param_cache()
	def create_cached(cls,*A,**B):return cls(*A,**B)
	def unpack(A,funcdef=_A):
		F=funcdef;G=[]
		for(H,B)in unpack_arglist(A.argument_node):
			if H==1:
				D=A.context.infer_node(B);I=[_iterate_star_args(A.context,C,B,F)for C in D]
				for J in list(zip_longest(*I)):yield(_A,get_merged_lazy_value([A for A in J if A is not _A]))
			elif H==2:
				D=A.context.infer_node(B)
				for K in D:yield from _star_star_dict(A.context,K,B,F)
			elif B.type==_B:
				E=B.children
				if len(E)==3:G.append((E[0].value,LazyTreeValue(A.context,E[2])))
				else:
					C=B.children[1]
					if C.type=='comp_for':C=C.children[1]
					L=iterable.GeneratorComprehension(A._inference_state,defining_context=A.context,sync_comp_for_node=C,entry_node=B.children[0]);yield(_A,LazyKnownValue(L))
			else:yield(_A,LazyTreeValue(A.context,B))
		yield from G
	def _as_tree_tuple_objects(C):
		for(D,A)in unpack_arglist(C.argument_node):
			B=_A
			if A.type==_B:
				if len(A.children)==3:A,B=A.children[::2]
			yield(A,B,D)
	def iter_calling_names_with_star(A):
		for(B,D,C)in A._as_tree_tuple_objects():
			if not C or not isinstance(B,tree.Name):continue
			yield TreeNameDefinition(A.context,B)
	def __repr__(A):return _C%(A.__class__.__name__,A.argument_node)
	def get_calling_nodes(D):
		C=[];A=D
		while A not in C:
			if not isinstance(A,TreeArguments):break
			C.append(A)
			for E in reversed(list(A.iter_calling_names_with_star())):
				B=E.goto()
				if len(B)!=1:break
				if isinstance(B[0],AnonymousParamName):return[]
				if not isinstance(B[0],ParamName):break
				F=B[0].get_executed_param_name();A=F.arguments;break
		if A.argument_node is not _A:return[ContextualizedNode(A.context,A.argument_node)]
		if A.trailer is not _A:return[ContextualizedNode(A.context,A.trailer)]
		return[]
class ValuesArguments(AbstractArguments):
	def __init__(A,values_list):A._values_list=values_list
	def unpack(A,funcdef=_A):
		for B in A._values_list:yield(_A,LazyKnownValues(B))
	def __repr__(A):return _C%(A.__class__.__name__,A._values_list)
class TreeArgumentsWrapper(_AbstractArgumentsMixin):
	def __init__(A,arguments):A._wrapped_arguments=arguments
	@property
	def context(self):return self._wrapped_arguments.context
	@property
	def argument_node(self):return self._wrapped_arguments.argument_node
	@property
	def trailer(self):return self._wrapped_arguments.trailer
	def unpack(A,func=_A):raise NotImplementedError
	def get_calling_nodes(A):return A._wrapped_arguments.get_calling_nodes()
	def __repr__(A):return _C%(A.__class__.__name__,A._wrapped_arguments)
def _iterate_star_args(context,array,input_node,funcdef=_A):
	B=funcdef;A=array
	if not A.py__getattribute__('__iter__'):
		if B is not _A:C='TypeError: %s() argument after * must be a sequence, not %s'%(B.name.value,A);analysis.add(context,'type-error-star',input_node,message=C)
	try:D=A.py__iter__
	except AttributeError:pass
	else:yield from D()
def _star_star_dict(context,array,input_node,funcdef):
	C='dict';B=funcdef;A=array;from jedi.inference.value.instance import CompiledInstance as D
	if isinstance(A,D)and A.name.string_name==C:return{}
	elif isinstance(A,iterable.Sequence)and A.array_type==C:return A.exact_key_items()
	else:
		if B is not _A:E='TypeError: %s argument after ** must be a mapping, not %s'%(B.name.value,A);analysis.add(context,'type-error-star-star',input_node,message=E)
		return{}