'\nValues are the "values" that Python would return. However Values are at the\nsame time also the "values" that a user is currently sitting in.\n\nA ValueSet is typically used to specify the return of a function or any other\nstatic analysis operation. In jedi there are always multiple returns and not\njust one.\n'
_D='__await__'
_C=True
_B=False
_A=None
from functools import reduce
from operator import add
from itertools import zip_longest
from parso.python.tree import Name
from jedi import debug
from jedi.parser_utils import clean_scope_docstring
from jedi.inference.helpers import SimpleGetItemNotFound
from jedi.inference.utils import safe_property
from jedi.inference.cache import inference_state_as_method_param_cache
from jedi.cache import memoize_method
sentinel=object()
class HasNoContext(Exception):0
class HelperValueMixin:
	def get_root_context(B):
		A=B
		if A.parent_context is _A:return A.as_context()
		while _C:
			if A.parent_context is _A:return A
			A=A.parent_context
	def execute(A,arguments):return A.inference_state.execute(A,arguments=arguments)
	def execute_with_values(A,*B):from jedi.inference.arguments import ValuesArguments as C;D=C([ValueSet([A])for A in B]);return A.inference_state.execute(A,D)
	def execute_annotation(A):return A.execute_with_values()
	def gather_annotation_classes(A):return ValueSet([A])
	def merge_types_of_iterate(A,contextualized_node=_A,is_async=_B):return ValueSet.from_sets(A.infer()for A in A.iterate(contextualized_node,is_async))
	def _get_value_filters(A,name_or_str):
		B=name_or_str;C=B if isinstance(B,Name)else _A;yield from A.get_filters(origin_scope=C)
		if A.is_stub():
			from jedi.inference.gradual.conversion import convert_values as D
			for E in D(ValueSet({A})):yield from E.get_filters()
	def goto(B,name_or_str,name_context=_A,analysis_errors=_C):A=name_or_str;from jedi.inference import finder as D;E=B._get_value_filters(A);C=D.filter_name(E,A);debug.dbg('context.goto %s in (%s): %s',A,B,C);return C
	def py__getattribute__(C,name_or_str,name_context=_A,position=_A,analysis_errors=_C):
		'\n        :param position: Position of the last statement -> tuple of line, column\n        ';F=analysis_errors;D=name_context;A=name_or_str
		if D is _A:D=C
		E=C.goto(A,D,F);B=ValueSet.from_sets(A.infer()for A in E)
		if not B:G=A.value if isinstance(A,Name)else A;B=C.py__getattribute__alternatives(G)
		if not E and not B and F:
			if isinstance(A,Name):from jedi.inference import analysis as H;H.add_attribute_error(D,C,A)
		debug.dbg('context.names_to_types: %s -> %s',E,B);return B
	def py__await__(A):
		B=A.py__getattribute__(_D)
		if not B:debug.warning('Tried to run __await__ on value %s',A)
		return B.execute_with_values()
	def py__name__(A):return A.name.string_name
	def iterate(A,contextualized_node=_A,is_async=_B):
		debug.dbg('iterate %s',A)
		if is_async:from jedi.inference.lazy_value import LazyKnownValues as B;return iter([B(A.py__getattribute__('__aiter__').execute_with_values().py__getattribute__('__anext__').execute_with_values().py__getattribute__(_D).execute_with_values().py__stop_iteration_returns())])
		return A.py__iter__(contextualized_node)
	def is_sub_class_of(B,class_value):
		C=class_value;A='BLUE'
		with debug.increase_indent_cm('subclass matching of %s <=> %s'%(B,C),color=A):
			for D in B.py__mro__():
				if D.is_same_class(C):debug.dbg('matched subclass True',color=A);return _C
			debug.dbg('matched subclass False',color=A);return _B
	def is_same_class(B,class2):
		A=class2
		if type(A).is_same_class!=HelperValueMixin.is_same_class:return A.is_same_class(B)
		return B==A
	@memoize_method
	def as_context(self,*A,**B):return self._as_context(*A,**B)
class Value(HelperValueMixin):
	'\n    To be implemented by subclasses.\n    ';tree_node=_A;array_type=_A;api_type='not_defined_please_report_bug'
	def __init__(A,inference_state,parent_context=_A):A.inference_state=inference_state;A.parent_context=parent_context
	def py__getitem__(B,index_value_set,contextualized_node):A=contextualized_node;from jedi.inference import analysis as C;C.add(A.context,'type-error-not-subscriptable',A.node,message="TypeError: '%s' object is not subscriptable"%B);return NO_VALUES
	def py__simple_getitem__(A,index):raise SimpleGetItemNotFound
	def py__iter__(B,contextualized_node=_A):
		A=contextualized_node
		if A is not _A:from jedi.inference import analysis as C;C.add(A.context,'type-error-not-iterable',A.node,message="TypeError: '%s' object is not iterable"%B)
		return iter([])
	def py__next__(A,contextualized_node=_A):return A.py__iter__(contextualized_node)
	def get_signatures(A):return[]
	def is_class(A):return _B
	def is_class_mixin(A):return _B
	def is_instance(A):return _B
	def is_function(A):return _B
	def is_module(A):return _B
	def is_namespace(A):return _B
	def is_compiled(A):return _B
	def is_bound_method(A):return _B
	def is_builtins_module(A):return _B
	def py__bool__(A):'\n        Since Wrapper is a super class for classes, functions and modules,\n        the return value will always be true.\n        ';return _C
	def py__doc__(A):
		try:A.tree_node.get_doc_node
		except AttributeError:return''
		else:return clean_scope_docstring(A.tree_node)
	def get_safe_value(B,default=sentinel):
		A=default
		if A is sentinel:raise ValueError('There exists no safe value for value %s'%B)
		return A
	def execute_operation(A,other,operator):debug.warning('%s not possible between %s and %s',operator,A,other);return NO_VALUES
	def py__call__(A,arguments):debug.warning('no execution possible %s',A);return NO_VALUES
	def py__stop_iteration_returns(A):debug.warning('Not possible to return the stop iterations of %s',A);return NO_VALUES
	def py__getattribute__alternatives(A,name_or_str):'\n        For now a way to add values in cases like __getattr__.\n        ';return NO_VALUES
	def py__get__(A,instance,class_value):debug.warning('No __get__ defined on %s',A);return ValueSet([A])
	def py__get__on_class(A,calling_instance,instance,class_value):return NotImplemented
	def get_qualified_names(A):0
	def is_stub(A):return A.parent_context.is_stub()
	def _as_context(A):raise HasNoContext
	@property
	def name(self):raise NotImplementedError
	def get_type_hint(A,add_class_info=_C):0
	def infer_type_vars(A,value_set):"\n        When the current instance represents a type annotation, this method\n        tries to find information about undefined type vars and returns a dict\n        from type var name to value set.\n\n        This is for example important to understand what `iter([1])` returns.\n        According to typeshed, `iter` returns an `Iterator[_T]`:\n\n            def iter(iterable: Iterable[_T]) -> Iterator[_T]: ...\n\n        This functions would generate `int` for `_T` in this case, because it\n        unpacks the `Iterable`.\n\n        Parameters\n        ----------\n\n        `self`: represents the annotation of the current parameter to infer the\n            value for. In the above example, this would initially be the\n            `Iterable[_T]` of the `iterable` parameter and then, when recursing,\n            just the `_T` generic parameter.\n\n        `value_set`: represents the actual argument passed to the parameter\n            we're inferred for, or (for recursive calls) their types. In the\n            above example this would first be the representation of the list\n            `[1]` and then, when recursing, just of `1`.\n        ";return{}
def iterate_values(values,contextualized_node=_A,is_async=_B):'\n    Calls `iterate`, on all values but ignores the ordering and just returns\n    all values that the iterate functions yield.\n    ';return ValueSet.from_sets(A.infer()for A in values.iterate(contextualized_node,is_async=is_async))
class _ValueWrapperBase(HelperValueMixin):
	@safe_property
	def name(self):
		A=self;from jedi.inference.names import ValueName as C;B=A._wrapped_value.name
		if B.tree_name is not _A:return C(A,B.tree_name)
		else:from jedi.inference.compiled import CompiledValueName as D;return D(A,B.string_name)
	@classmethod
	@inference_state_as_method_param_cache()
	def create_cached(cls,inference_state,*A,**B):return cls(*A,**B)
	def __getattr__(A,name):assert name!='_wrapped_value','Problem with _get_wrapped_value';return getattr(A._wrapped_value,name)
class LazyValueWrapper(_ValueWrapperBase):
	@safe_property
	@memoize_method
	def _wrapped_value(self):
		with debug.increase_indent_cm('Resolve lazy value wrapper'):return self._get_wrapped_value()
	def __repr__(A):return'<%s>'%A.__class__.__name__
	def _get_wrapped_value(A):raise NotImplementedError
class ValueWrapper(_ValueWrapperBase):
	def __init__(A,wrapped_value):A._wrapped_value=wrapped_value
	def __repr__(A):return'%s(%s)'%(A.__class__.__name__,A._wrapped_value)
class TreeValue(Value):
	def __init__(A,inference_state,parent_context,tree_node):super().__init__(inference_state,parent_context);A.tree_node=tree_node
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A.tree_node)
class ContextualizedNode:
	def __init__(A,context,node):A.context=context;A.node=node
	def get_root_context(A):return A.context.get_root_context()
	def infer(A):return A.context.infer_node(A.node)
	def __repr__(A):return'<%s: %s in %s>'%(A.__class__.__name__,A.node,A.context)
def _getitem(value,index_values,contextualized_node):
	D=index_values;C=value;A=NO_VALUES;B=set()
	for E in D:
		F=E.get_safe_value(default=_A)
		if type(F)in(float,int,str,slice,bytes):
			try:A|=C.py__simple_getitem__(F);continue
			except SimpleGetItemNotFound:pass
		B.add(E)
	if B or not D:A|=C.py__getitem__(ValueSet(B),contextualized_node)
	debug.dbg('py__getitem__ result: %s',A);return A
class ValueSet:
	def __init__(B,iterable):
		A=iterable;B._set=frozenset(A)
		for C in A:assert not isinstance(C,ValueSet)
	@classmethod
	def _from_frozen_set(A,frozenset_):B=A.__new__(A);B._set=frozenset_;return B
	@classmethod
	def from_sets(C,sets):
		'\n        Used to work with an iterable of set.\n        ';A=set()
		for B in sets:
			if isinstance(B,ValueSet):A|=B._set
			else:A|=frozenset(B)
		return C._from_frozen_set(frozenset(A))
	def __or__(A,other):return A._from_frozen_set(A._set|other._set)
	def __and__(A,other):return A._from_frozen_set(A._set&other._set)
	def __iter__(A):return iter(A._set)
	def __bool__(A):return bool(A._set)
	def __len__(A):return len(A._set)
	def __repr__(A):return'S{%s}'%', '.join(str(A)for A in A._set)
	def filter(A,filter_func):return A.__class__(filter(filter_func,A._set))
	def __getattr__(A,name):
		def B(*B,**C):return A.from_sets(getattr(A,name)(*B,**C)for A in A._set)
		return B
	def __eq__(A,other):return A._set==other._set
	def __ne__(A,other):return not A.__eq__(other)
	def __hash__(A):return hash(A._set)
	def py__class__(A):return ValueSet(A.py__class__()for A in A._set)
	def iterate(A,contextualized_node=_A,is_async=_B):
		from jedi.inference.lazy_value import get_merged_lazy_value as B;C=[A.iterate(contextualized_node,is_async=is_async)for A in A._set]
		for D in zip_longest(*C):yield B([A for A in D if A is not _A])
	def execute(A,arguments):return ValueSet.from_sets(A.inference_state.execute(A,arguments)for A in A._set)
	def execute_with_values(A,*B,**C):return ValueSet.from_sets(A.execute_with_values(*B,**C)for A in A._set)
	def goto(A,*B,**C):return reduce(add,[A.goto(*B,**C)for A in A._set],[])
	def py__getattribute__(A,*B,**C):return ValueSet.from_sets(A.py__getattribute__(*B,**C)for A in A._set)
	def get_item(A,*B,**C):return ValueSet.from_sets(_getitem(A,*B,**C)for A in A._set)
	def try_merge(A,function_name):
		B=A.__class__([])
		for C in A._set:
			try:D=getattr(C,function_name)
			except AttributeError:pass
			else:B|=D()
		return B
	def gather_annotation_classes(A):return ValueSet.from_sets([A.gather_annotation_classes()for A in A._set])
	def get_signatures(A):return[B for A in A._set for B in A.get_signatures()]
	def get_type_hint(E,add_class_info=_C):
		D='None';F=[A.get_type_hint(add_class_info=add_class_info)for A in E._set];A=sorted(filter(_A,F))
		if len(A)==1:return A[0]
		C=D in A
		if C:A.remove(D)
		if len(A)==0:return
		elif len(A)==1:B=A[0]
		else:B='Union[%s]'%', '.join(A)
		if C:B='Optional[%s]'%B
		return B
	def infer_type_vars(B,value_set):
		from jedi.inference.gradual.annotation import merge_type_var_dicts as C;A={}
		for D in B._set:C(A,D.infer_type_vars(value_set))
		return A
NO_VALUES=ValueSet([])
def iterator_to_value_set(func):
	def A(*A,**B):return ValueSet(func(*A,**B))
	return A