'\nUsed only for REPL Completion.\n'
_B='classdef'
_A=None
import inspect
from pathlib import Path
from jedi.parser_utils import get_cached_code_lines
from jedi import settings
from jedi.cache import memoize_method
from jedi.inference import compiled
from jedi.file_io import FileIO
from jedi.inference.names import NameWrapper
from jedi.inference.base_value import ValueSet,ValueWrapper,NO_VALUES
from jedi.inference.value import ModuleValue
from jedi.inference.cache import inference_state_function_cache,inference_state_method_cache
from jedi.inference.compiled.access import ALLOWED_GETITEM_TYPES,get_api_type
from jedi.inference.gradual.conversion import to_stub
from jedi.inference.context import CompiledContext,CompiledModuleContext,TreeContextMixin
_sentinel=object()
class MixedObject(ValueWrapper):
	"\n    A ``MixedObject`` is used in two ways:\n\n    1. It uses the default logic of ``parser.python.tree`` objects,\n    2. except for getattr calls and signatures. The names dicts are generated\n       in a fashion like ``CompiledValue``.\n\n    This combined logic makes it possible to provide more powerful REPL\n    completion. It allows side effects that are not noticable with the default\n    parser structure to still be completable.\n\n    The biggest difference from CompiledValue to MixedObject is that we are\n    generally dealing with Python code and not with C code. This will generate\n    fewer special cases, because we in Python you don't have the same freedoms\n    to modify the runtime.\n    "
	def __init__(A,compiled_value,tree_value):B=compiled_value;super().__init__(tree_value);A.compiled_value=B;A.access_handle=B.access_handle
	def get_filters(A,*B,**C):yield MixedObjectFilter(A.inference_state,A.compiled_value,A._wrapped_value)
	def get_signatures(A):return A.compiled_value.get_signatures()
	@inference_state_method_cache(default=NO_VALUES)
	def py__call__(self,arguments):
		A=to_stub(self._wrapped_value)
		if not A:A=self._wrapped_value
		return A.py__call__(arguments)
	def get_safe_value(A,default=_sentinel):
		B=default
		if B is _sentinel:return A.compiled_value.get_safe_value()
		else:return A.compiled_value.get_safe_value(B)
	@property
	def array_type(self):return self.compiled_value.array_type
	def get_key_values(A):return A.compiled_value.get_key_values()
	def py__simple_getitem__(A,index):
		B=index;C=A.compiled_value.access_handle.access._obj
		if type(C)in ALLOWED_GETITEM_TYPES:return A.compiled_value.py__simple_getitem__(B)
		return A._wrapped_value.py__simple_getitem__(B)
	def negate(A):return A.compiled_value.negate()
	def _as_context(A):
		if A.parent_context is _A:return MixedModuleContext(A)
		return MixedContext(A)
	def __repr__(A):return'<%s: %s; %s>'%(type(A).__name__,A.access_handle.get_repr(),A._wrapped_value)
class MixedContext(CompiledContext,TreeContextMixin):
	@property
	def compiled_value(self):return self._value.compiled_value
class MixedModuleContext(CompiledModuleContext,MixedContext):0
class MixedName(NameWrapper):
	'\n    The ``CompiledName._compiled_value`` is our MixedObject.\n    '
	def __init__(A,wrapped_name,parent_tree_value):super().__init__(wrapped_name);A._parent_tree_value=parent_tree_value
	@property
	def start_pos(self):
		A=list(self.infer())
		if not A:return 0,0
		return A[0].name.start_pos
	@memoize_method
	def infer(self):
		A=self;C=A._wrapped_name.infer_compiled_value();B=A._parent_tree_value
		if B.is_instance()or B.is_class():
			D=B.py__getattribute__(A.string_name)
			if C.is_function():return ValueSet({MixedObject(C,A)for A in D})
		E=B.get_root_context();return _create(A._inference_state,C,E)
class MixedObjectFilter(compiled.CompiledValueFilter):
	def __init__(A,inference_state,compiled_value,tree_value):super().__init__(inference_state,compiled_value);A._tree_value=tree_value
	def _create_name(A,*B,**C):return MixedName(super()._create_name(*B,**C),A._tree_value)
@inference_state_function_cache()
def _load_module(inference_state,path):return inference_state.parse(path=path,cache=True,diff_cache=settings.fast_parser,cache_path=settings.cache_directory).get_root_node()
def _get_object_to_check(python_object):
	'Check if inspect.getfile has a chance to find the source.';A=python_object
	try:A=inspect.unwrap(A)
	except ValueError:pass
	if inspect.ismodule(A)or inspect.isclass(A)or inspect.ismethod(A)or inspect.isfunction(A)or inspect.istraceback(A)or inspect.isframe(A)or inspect.iscode(A):return A
	try:return A.__class__
	except AttributeError:raise TypeError
def _find_syntax_node_name(inference_state,python_object):
	K='funcdef';E=inference_state;B=python_object;L=B
	try:B=_get_object_to_check(B);A=inspect.getsourcefile(B)
	except(OSError,TypeError):return
	A=_A if A is _A else Path(A)
	try:
		if A is _A or not A.exists():return
	except OSError:return
	G=FileIO(A);D=_load_module(E,A)
	if inspect.ismodule(B):F=get_cached_code_lines(E.grammar,A);return D,D,G,F
	try:H=B.__name__
	except AttributeError:return
	if H=='<lambda>':return
	C=D.get_used_names().get(H,[]);C=[A for A in C if A.parent.type in(K,_B)and A.parent.name==A]
	if not C:return
	try:M=B.__code__;N=M.co_firstlineno
	except AttributeError:pass
	else:
		I=[A for A in C if A.start_pos[0]==N]
		if I:C=I
	F=get_cached_code_lines(E.grammar,A);J=C[-1].parent
	if J.type==K and get_api_type(L)=='instance':return
	return D,J,G,F
@inference_state_function_cache()
def _create(inference_state,compiled_value,module_context):
	D=inference_state;C=module_context;A=compiled_value;E=A.access_handle.access._obj;F=_find_syntax_node_name(D,E)
	if F is _A:
		if type(E)in(dict,list,tuple):return ValueSet({A})
		B=to_stub(A)
		if not B:return ValueSet({A})
	else:
		G,H,M,N=F
		if C is _A or C.tree_node!=G:
			I=A.get_root_context().get_value();J=I.py__name__();K=tuple(J.split('.'));L=ModuleValue(D,G,file_io=M,string_names=K,code_lines=N,is_package=I.is_package())
			if J is not _A:D.module_cache.add(K,ValueSet([L]))
			C=L.as_context()
		B=ValueSet({C.create_value(H)})
		if H.type==_B:
			if not A.is_class():B=B.execute_with_values()
	return ValueSet(MixedObject(A,tree_value=B)for B in B)