'\nImitate the parser representation.\n'
_E='<%s: %s>'
_D='None'
_C=True
_B=False
_A=None
import re
from functools import partial
from inspect import Parameter
from pathlib import Path
from typing import Optional
from jedi import debug
from jedi.inference.utils import to_list
from jedi.cache import memoize_method
from jedi.inference.filters import AbstractFilter
from jedi.inference.names import AbstractNameDefinition,ValueNameMixin,ParamNameInterface
from jedi.inference.base_value import Value,ValueSet,NO_VALUES
from jedi.inference.lazy_value import LazyKnownValue
from jedi.inference.compiled.access import _sentinel
from jedi.inference.cache import inference_state_function_cache
from jedi.inference.helpers import reraise_getitem_errors
from jedi.inference.signature import BuiltinSignature
from jedi.inference.context import CompiledContext,CompiledModuleContext
class CheckAttribute:
	'Raises :exc:`AttributeError` if the attribute X is not available.'
	def __init__(A,check_name=_A):A.check_name=check_name
	def __call__(A,func):
		A.func=func
		if A.check_name is _A:A.check_name=func.__name__[2:]
		return A
	def __get__(A,instance,owner):
		B=instance
		if B is _A:return A
		B.access_handle.getattr_paths(A.check_name);return partial(A.func,B)
class CompiledValue(Value):
	def __init__(A,inference_state,access_handle,parent_context=_A):super().__init__(inference_state,parent_context);A.access_handle=access_handle
	def py__call__(A,arguments):
		B=arguments;C=A.access_handle.get_return_annotation()
		if C is not _A:return create_from_access_path(A.inference_state,C).execute_annotation()
		try:A.access_handle.getattr_paths('__call__')
		except AttributeError:return super().py__call__(B)
		else:
			if A.access_handle.is_class():from jedi.inference.value import CompiledInstance as D;return ValueSet([D(A.inference_state,A.parent_context,A,B)])
			else:return ValueSet(A._execute_function(B))
	@CheckAttribute()
	def py__class__(self):return create_from_access_path(self.inference_state,self.access_handle.py__class__())
	@CheckAttribute()
	def py__mro__(self):A=self;return(A,)+tuple(create_from_access_path(A.inference_state,B)for B in A.access_handle.py__mro__accesses())
	@CheckAttribute()
	def py__bases__(self):return tuple(create_from_access_path(self.inference_state,A)for A in self.access_handle.py__bases__())
	def get_qualified_names(A):return A.access_handle.get_qualified_names()
	def py__bool__(A):return A.access_handle.py__bool__()
	def is_class(A):return A.access_handle.is_class()
	def is_function(A):return A.access_handle.is_function()
	def is_module(A):return A.access_handle.is_module()
	def is_compiled(A):return _C
	def is_stub(A):return _B
	def is_instance(A):return A.access_handle.is_instance()
	def py__doc__(A):return A.access_handle.py__doc__()
	@to_list
	def get_param_names(self):
		A=self
		try:D=A.access_handle.get_signature_params()
		except ValueError:
			C,I=A._parse_function_doc()
			if not C:B=[]
			else:B=C.split(',')
			if A.access_handle.ismethoddescriptor():B.insert(0,'self')
			for E in B:F,J,G=E.strip().partition('=');yield UnresolvableParamName(A,F,G)
		else:
			for H in D:yield SignatureParamName(A,H)
	def get_signatures(A):C,B=A._parse_function_doc();return[BuiltinSignature(A,B)]
	def __repr__(A):return _E%(A.__class__.__name__,A.access_handle.get_repr())
	@memoize_method
	def _parse_function_doc(self):
		A=self.py__doc__()
		if A is _A:return'',''
		return _parse_function_doc(A)
	@property
	def api_type(self):return self.access_handle.get_api_type()
	def get_filters(A,is_instance=_B,origin_scope=_A):yield A._ensure_one_filter(is_instance)
	@memoize_method
	def _ensure_one_filter(self,is_instance):return CompiledValueFilter(self.inference_state,self,is_instance)
	def py__simple_getitem__(A,index):
		B=index
		with reraise_getitem_errors(IndexError,KeyError,TypeError):
			try:C=A.access_handle.py__simple_getitem__(B,safe=not A.inference_state.allow_unsafe_executions)
			except AttributeError:return super().py__simple_getitem__(B)
		if C is _A:return super().py__simple_getitem__(B)
		return ValueSet([create_from_access_path(A.inference_state,C)])
	def py__getitem__(A,index_value_set,contextualized_node):
		B=A.access_handle.py__getitem__all_values()
		if B is _A:return super().py__getitem__(index_value_set,contextualized_node)
		return ValueSet(create_from_access_path(A.inference_state,B)for B in B)
	def py__iter__(A,contextualized_node=_A):
		if not A.access_handle.has_iter():yield from super().py__iter__(contextualized_node)
		B=A.access_handle.py__iter__list()
		if B is _A:return
		for C in B:yield LazyKnownValue(create_from_access_path(A.inference_state,C))
	def py__name__(A):return A.access_handle.py__name__()
	@property
	def name(self):
		A=self;B=A.py__name__()
		if B is _A:B=A.access_handle.get_repr()
		return CompiledValueName(A,B)
	def _execute_function(A,params):
		from jedi.inference import docstrings as C;from jedi.inference.compiled import builtin_from_name as D
		if A.api_type!='function':return
		for B in A._parse_function_doc()[1].split():
			try:A.inference_state.builtins_module.access_handle.getattr_paths(B)
			except AttributeError:continue
			else:E=D(A.inference_state,B);yield from A.inference_state.execute(E,params)
		yield from C.infer_return_types(A)
	def get_safe_value(B,default=_sentinel):
		A=default
		try:return B.access_handle.get_safe_value()
		except ValueError:
			if A==_sentinel:raise
			return A
	def execute_operation(A,other,operator):
		try:return ValueSet([create_from_access_path(A.inference_state,A.access_handle.execute_operation(other.access_handle,operator))])
		except TypeError:return NO_VALUES
	def execute_annotation(A):
		if A.access_handle.get_repr()==_D:return ValueSet([A])
		B,D=A.access_handle.get_annotation_name_and_args();C=[ValueSet([create_from_access_path(A.inference_state,B)])for B in D]
		if B=='Union':return ValueSet.from_sets(A.execute_annotation()for A in C)
		elif B:return ValueSet([A.with_generics(C)for A in A.inference_state.typing_module.py__getattribute__(B)]).execute_annotation()
		return super().execute_annotation()
	def negate(A):return create_from_access_path(A.inference_state,A.access_handle.negate())
	def get_metaclasses(A):return NO_VALUES
	def _as_context(A):return CompiledContext(A)
	@property
	def array_type(self):return self.access_handle.get_array_type()
	def get_key_values(A):return[create_from_access_path(A.inference_state,B)for B in A.access_handle.get_key_paths()]
	def get_type_hint(A,add_class_info=_C):
		if A.access_handle.get_repr()in(_D,"<class 'NoneType'>"):return _D
class CompiledModule(CompiledValue):
	file_io=_A
	def _as_context(A):return CompiledModuleContext(A)
	def py__path__(A):return A.access_handle.py__path__()
	def is_package(A):return A.py__path__()is not _A
	@property
	def string_names(self):
		A=self.py__name__()
		if A is _A:return()
		return tuple(A.split('.'))
	def py__file__(A):return A.access_handle.py__file__()
class CompiledName(AbstractNameDefinition):
	def __init__(A,inference_state,parent_value,name,is_descriptor):B=parent_value;A._inference_state=inference_state;A.parent_context=B.as_context();A._parent_value=B;A.string_name=name;A.is_descriptor=is_descriptor
	def py__doc__(A):return A.infer_compiled_value().py__doc__()
	def _get_qualified_names(A):
		B=A.parent_context.get_qualified_names()
		if B is _A:return
		return B+(A.string_name,)
	def get_defining_qualified_value(A):
		B=A.parent_context
		if B.is_module()or B.is_class():return A.parent_context.get_value()
	def __repr__(A):
		try:B=A.parent_context.name
		except AttributeError:B=_A
		return'<%s: (%s).%s>'%(A.__class__.__name__,B,A.string_name)
	@property
	def api_type(self):
		if self.is_descriptor:return'instance'
		return self.infer_compiled_value().api_type
	def infer(A):return ValueSet([A.infer_compiled_value()])
	@memoize_method
	def infer_compiled_value(self):A=self;return create_from_name(A._inference_state,A._parent_value,A.string_name)
class SignatureParamName(ParamNameInterface,AbstractNameDefinition):
	def __init__(A,compiled_value,signature_param):A.parent_context=compiled_value.parent_context;A._signature_param=signature_param
	@property
	def string_name(self):return self._signature_param.name
	def to_string(A):
		B=A._kind_string()+A.string_name
		if A._signature_param.has_annotation:B+=': '+A._signature_param.annotation_string
		if A._signature_param.has_default:B+='='+A._signature_param.default_string
		return B
	def get_kind(A):return getattr(Parameter,A._signature_param.kind_name)
	def infer(C):
		A=C._signature_param;D=C.parent_context.inference_state;B=NO_VALUES
		if A.has_default:B=ValueSet([create_from_access_path(D,A.default)])
		if A.has_annotation:E=create_from_access_path(D,A.annotation);B|=E.execute_with_values()
		return B
class UnresolvableParamName(ParamNameInterface,AbstractNameDefinition):
	def __init__(A,compiled_value,name,default):A.parent_context=compiled_value.parent_context;A.string_name=name;A._default=default
	def get_kind(A):return Parameter.POSITIONAL_ONLY
	def to_string(A):
		B=A.string_name
		if A._default:B+='='+A._default
		return B
	def infer(A):return NO_VALUES
class CompiledValueName(ValueNameMixin,AbstractNameDefinition):
	def __init__(A,value,name):B=value;A.string_name=name;A._value=B;A.parent_context=B.parent_context
class EmptyCompiledName(AbstractNameDefinition):
	'\n    Accessing some names will raise an exception. To avoid not having any\n    completions, just give Jedi the option to return this object. It infers to\n    nothing.\n    '
	def __init__(A,inference_state,name):A.parent_context=inference_state.builtins_module;A.string_name=name
	def infer(A):return NO_VALUES
class CompiledValueFilter(AbstractFilter):
	def __init__(A,inference_state,compiled_value,is_instance=_B):A._inference_state=inference_state;A.compiled_value=compiled_value;A.is_instance=is_instance
	def get(A,name):B=A.compiled_value.access_handle;C=not A._inference_state.allow_unsafe_executions;return A._get(name,lambda name:B.is_allowed_getattr(name,safe=C),lambda name:name in B.dir(),check_has_attribute=_C)
	def _get(A,name,allowed_getattr_callback,in_dir_callback,check_has_attribute=_B):
		'\n        To remove quite a few access calls we introduced the callback here.\n        ';B=name;C,D,E=allowed_getattr_callback(B)
		if E is not _A:
			F=create_from_access_path(A._inference_state,E).execute_annotation()
			if F:return[CompiledValueName(A,B)for A in F]
		if check_has_attribute and not C:return[]
		if(D or not C)and not A._inference_state.allow_unsafe_executions:return[A._get_cached_name(B,is_empty=_C)]
		if A.is_instance and not in_dir_callback(B):return[]
		return[A._get_cached_name(B,is_descriptor=D)]
	@memoize_method
	def _get_cached_name(self,name,is_empty=_B,*,is_descriptor=_B):
		if is_empty:return EmptyCompiledName(self._inference_state,name)
		else:return self._create_name(name,is_descriptor=is_descriptor)
	def values(A):
		from jedi.inference.compiled import builtin_from_name as D;B=[];E,C=A.compiled_value.access_handle.get_dir_infos()
		for F in C:B+=A._get(F,lambda name:C[name],lambda name:name in C)
		if not A.is_instance and E:
			for filter in D(A._inference_state,'type').get_filters():B+=filter.values()
		return B
	def _create_name(A,name,is_descriptor):return CompiledName(A._inference_state,A.compiled_value,name,is_descriptor)
	def __repr__(A):return _E%(A.__class__.__name__,A.compiled_value)
docstr_defaults={'floating point number':'float','character':'str','integer':'int','dictionary':'dict','string':'str'}
def _parse_function_doc(doc):
	"\n    Takes a function and returns the params and return value as a tuple.\n    This is nothing more than a docstring parser.\n\n    TODO docstrings like utime(path, (atime, mtime)) and a(b [, b]) -> None\n    TODO docstrings like 'tuple of integers'\n    ";B=doc
	try:
		E=0;F=B.index('(')
		for(J,G)in enumerate(B[F:]):
			if G=='(':E+=1
			elif G==')':E-=1
			if E==0:C=F+J;break
		A=B[F+1:C]
	except(ValueError,UnboundLocalError):debug.dbg('no brackets found - no param');C=0;A=''
	else:
		def K(m):
			A=m.group(1).split(',')
			for(C,B)in enumerate(A):
				if B and'='not in B:A[C]+='=None'
			return','.join(A)
		while _C:
			A,L=re.subn(' ?\\[([^\\[\\]]+)\\]',K,A)
			if L==0:break
	A=A.replace('-','_');H=re.search('-[>-]* ',B[C:C+7])
	if H is _A:I=''
	else:M=C+H.end();N=re.compile('(,\\n|[^\\n-])+');D=N.match(B,M).group(0).strip();D=re.sub('[nN]ew (.*)','\\1()',D);I=docstr_defaults.get(D,D)
	return A,I
def create_from_name(inference_state,compiled_value,name):
	B=compiled_value.access_handle.getattr_paths(name,default=_A);A=_A
	for C in B:A=create_cached_compiled_value(inference_state,C,parent_context=_A if A is _A else A.as_context())
	return A
def _normalize_create_args(func):
	"The cache doesn't care about keyword vs. normal args."
	def A(inference_state,obj,parent_context=_A):return func(inference_state,obj,parent_context)
	return A
def create_from_access_path(inference_state,access_path):
	A=_A
	for(C,B)in access_path.accesses:A=create_cached_compiled_value(inference_state,B,parent_context=_A if A is _A else A.as_context())
	return A
@_normalize_create_args
@inference_state_function_cache()
def create_cached_compiled_value(inference_state,access_handle,parent_context):
	A=parent_context;assert not isinstance(A,CompiledValue)
	if A is _A:B=CompiledModule
	else:B=CompiledValue
	return B(inference_state,access_handle,A)