_I='%s(%s)'
_H='classdef'
_G='lambdef'
_F='sync_comp_for'
_E='comp_for'
_D='funcdef'
_C=True
_B=False
_A=None
from abc import abstractmethod
from contextlib import contextmanager
from pathlib import Path
from typing import Optional
from parso.tree import search_ancestor
from parso.python.tree import Name
from jedi.inference.filters import ParserTreeFilter,MergedFilter,GlobalNameFilter
from jedi.inference.names import AnonymousParamName,TreeNameDefinition
from jedi.inference.base_value import NO_VALUES,ValueSet
from jedi.parser_utils import get_parent_scope
from jedi import debug
from jedi import parser_utils
class AbstractContext:
	def __init__(A,inference_state):A.inference_state=inference_state;A.predefined_names={}
	@abstractmethod
	def get_filters(self,until_position=_A,origin_scope=_A):raise NotImplementedError
	def goto(B,name_or_str,position):A=name_or_str;from jedi.inference import finder as D;E=_get_global_filters_for_name(B,A if isinstance(A,Name)else _A,position);C=D.filter_name(E,A);debug.dbg('context.goto %s in (%s): %s',A,B,C);return C
	def py__getattribute__(B,name_or_str,name_context=_A,position=_A,analysis_errors=_C):
		'\n        :param position: Position of the last statement -> tuple of line, column\n        ';H=position;E=name_context;A=name_or_str
		if E is _A:E=B
		F=B.goto(A,H);I=A.value if isinstance(A,Name)else A;G=_A
		if B.predefined_names and isinstance(A,Name):
			C=A
			while C is not _A and not parser_utils.is_scope(C):
				C=C.parent
				if C.type in('if_stmt','for_stmt',_E,_F):
					try:K=B.predefined_names[C];L=K[I]
					except KeyError:continue
					else:G=L;break
		if G is not _A and F:
			from jedi.inference import flow_analysis as J;M=J.reachability_check(context=B,value_scope=B.tree_node,node=A)
			if M is J.UNREACHABLE:D=NO_VALUES
			else:D=G
		else:D=ValueSet.from_sets(A.infer()for A in F)
		if not F and not D and analysis_errors:
			if isinstance(A,Name):from jedi.inference import analysis as N;O="NameError: name '%s' is not defined."%I;N.add(E,'name-error',A,O)
		debug.dbg('context.names_to_types: %s -> %s',F,D)
		if D:return D
		return B._check_for_additional_knowledge(A,E,H)
	def _check_for_additional_knowledge(F,name_or_str,name_context,position):
		C=name_or_str;A=name_context;A=A or F
		if isinstance(C,Name)and not A.is_instance():
			B=C;D=[A.tree_node]
			if any(A.type in(_E,_F)for A in D):return NO_VALUES
			from jedi.inference.finder import check_flow_information as G
			while _C:
				B=get_parent_scope(B,include_flows=_C);E=G(A,B,C,position)
				if E is not _A:return E
				if B in D:break
		return NO_VALUES
	def get_root_context(A):
		B=A.parent_context
		if B is _A:return A
		return B.get_root_context()
	def is_module(A):return _B
	def is_builtins_module(A):return _B
	def is_class(A):return _B
	def is_stub(A):return _B
	def is_instance(A):return _B
	def is_compiled(A):return _B
	def is_bound_method(A):return _B
	@abstractmethod
	def py__name__(self):raise NotImplementedError
	def get_value(A):raise NotImplementedError
	@property
	def name(self):0
	def get_qualified_names(A):return()
	def py__doc__(A):return''
	@contextmanager
	def predefine_names(self,flow_scope,dct):
		A=flow_scope;B=self.predefined_names;B[A]=dct
		try:yield
		finally:del B[A]
class ValueContext(AbstractContext):
	'\n    Should be defined, otherwise the API returns empty types.\n    '
	def __init__(B,value):A=value;super().__init__(A.inference_state);B._value=A
	@property
	def tree_node(self):return self._value.tree_node
	@property
	def parent_context(self):return self._value.parent_context
	def is_module(A):return A._value.is_module()
	def is_builtins_module(A):return A._value==A.inference_state.builtins_module
	def is_class(A):return A._value.is_class()
	def is_stub(A):return A._value.is_stub()
	def is_instance(A):return A._value.is_instance()
	def is_compiled(A):return A._value.is_compiled()
	def is_bound_method(A):return A._value.is_bound_method()
	def py__name__(A):return A._value.py__name__()
	@property
	def name(self):return self._value.name
	def get_qualified_names(A):return A._value.get_qualified_names()
	def py__doc__(A):return A._value.py__doc__()
	def get_value(A):return A._value
	def __repr__(A):return _I%(A.__class__.__name__,A._value)
class TreeContextMixin:
	def infer_node(A,node):from jedi.inference.syntax_tree import infer_node as B;return B(A,node)
	def create_value(B,node):
		A=node;from jedi.inference import value as D
		if A==B.tree_node:assert B.is_module();return B.get_value()
		C=B.create_context(A)
		if A.type in(_D,_G):
			E=D.FunctionValue.from_context(C,A)
			if C.is_class():F=C.parent_context.create_value(C.tree_node);G=D.AnonymousInstance(B.inference_state,C.parent_context,F);E=D.BoundMethod(instance=G,class_context=F.as_context(),function=E)
			return E
		elif A.type==_H:return D.ClassValue(B.inference_state,C,A)
		else:raise NotImplementedError("Probably shouldn't happen: %s"%A)
	def create_context(C,node):
		B=node
		def E(scope_node,is_nested=_C):
			A=scope_node
			if A==C.tree_node:return C
			if A.type in(_D,_G,_H):return C.create_value(A).as_context()
			elif A.type in(_E,_F):
				F=E(D(A.parent))
				if B.start_pos>=A.children[-1].start_pos:return F
				return CompForContext(F,A)
			raise Exception("There's a scope that was not managed: %s"%A)
		def D(node):
			A=node
			while _C:
				A=A.parent
				if parser_utils.is_scope(A):return A
				elif A.type in('argument','testlist_comp'):
					if A.children[1].type in(_E,_F):return A.children[1]
				elif A.type=='dictorsetmaker':
					for B in A.children[1:4]:
						if B.type in(_E,_F):return B
		A=D(B)
		if A.type in(_D,_H):
			G=A.children[A.children.index(':')]
			if B.start_pos<G.start_pos:
				F=B.parent
				if not(F.type=='param'and F.name==B):A=D(A)
		return E(A,is_nested=_C)
	def create_name(C,tree_name):
		A=tree_name;B=A.get_definition()
		if B and B.type=='param'and B.name==A:D=search_ancestor(B,_D,_G);E=C.create_value(D);return AnonymousParamName(E,A)
		else:F=C.create_context(A);return TreeNameDefinition(F,A)
class FunctionContext(TreeContextMixin,ValueContext):
	def get_filters(A,until_position=_A,origin_scope=_A):yield ParserTreeFilter(A.inference_state,parent_context=A,until_position=until_position,origin_scope=origin_scope)
class ModuleContext(TreeContextMixin,ValueContext):
	def py__file__(A):return A._value.py__file__()
	def get_filters(A,until_position=_A,origin_scope=_A):B=origin_scope;C=A._value.get_filters(B);next(C,_A);yield MergedFilter(ParserTreeFilter(parent_context=A,until_position=until_position,origin_scope=B),A.get_global_filter());yield from C
	def get_global_filter(A):return GlobalNameFilter(A)
	@property
	def string_names(self):return self._value.string_names
	@property
	def code_lines(self):return self._value.code_lines
	def get_value(A):"\n        This is the only function that converts a context back to a value.\n        This is necessary for stub -> python conversion and vice versa. However\n        this method shouldn't be moved to AbstractContext.\n        ";return A._value
class NamespaceContext(TreeContextMixin,ValueContext):
	def get_filters(A,until_position=_A,origin_scope=_A):return A._value.get_filters()
	def get_value(A):return A._value
	@property
	def string_names(self):return self._value.string_names
	def py__file__(A):return A._value.py__file__()
class ClassContext(TreeContextMixin,ValueContext):
	def get_filters(A,until_position=_A,origin_scope=_A):yield A.get_global_filter(until_position,origin_scope)
	def get_global_filter(A,until_position=_A,origin_scope=_A):return ParserTreeFilter(parent_context=A,until_position=until_position,origin_scope=origin_scope)
class CompForContext(TreeContextMixin,AbstractContext):
	def __init__(A,parent_context,comp_for):B=parent_context;super().__init__(B.inference_state);A.tree_node=comp_for;A.parent_context=B
	def get_filters(A,until_position=_A,origin_scope=_A):yield ParserTreeFilter(A)
	def get_value(A):0
	def py__name__(A):return'<comprehension context>'
	def __repr__(A):return _I%(A.__class__.__name__,A.tree_node)
class CompiledContext(ValueContext):
	def get_filters(A,until_position=_A,origin_scope=_A):return A._value.get_filters()
class CompiledModuleContext(CompiledContext):
	code_lines=_A
	def get_value(A):return A._value
	@property
	def string_names(self):return self._value.string_names
	def py__file__(A):return A._value.py__file__()
def _get_global_filters_for_name(context,name_or_none,position):
	C=name_or_none;B=position
	if C is not _A:
		A=search_ancestor(C,_D,_H,_G);D=_A
		if A==_G:D=A;A=search_ancestor(C,_D,_H)
		if A is not _A:
			E=A.children[-2]
			if B is not _A and B<E.start_pos:
				if D is _A or B<D.children[-2].start_pos:B=A.start_pos
	return get_global_filters(context,B,C)
def get_global_filters(context,until_position,origin_scope):
	'\n    Returns all filters in order of priority for name resolution.\n\n    For global name lookups. The filters will handle name resolution\n    themselves, but here we gather possible filters downwards.\n\n    >>> from jedi import Script\n    >>> script = Script(\'\'\'\n    ... x = [\'a\', \'b\', \'c\']\n    ... def func():\n    ...     y = None\n    ... \'\'\')\n    >>> module_node = script._module_node\n    >>> scope = next(module_node.iter_funcdefs())\n    >>> scope\n    <Function: func@3-5>\n    >>> context = script._get_module_context().create_context(scope)\n    >>> filters = list(get_global_filters(context, (4, 0), None))\n\n    First we get the names from the function scope.\n\n    >>> print(filters[0])  # doctest: +ELLIPSIS\n    MergedFilter(<ParserTreeFilter: ...>, <GlobalNameFilter: ...>)\n    >>> sorted(str(n) for n in filters[0].values())  # doctest: +NORMALIZE_WHITESPACE\n    [\'<TreeNameDefinition: string_name=func start_pos=(3, 4)>\',\n     \'<TreeNameDefinition: string_name=x start_pos=(2, 0)>\']\n    >>> filters[0]._filters[0]._until_position\n    (4, 0)\n    >>> filters[0]._filters[1]._until_position\n\n    Then it yields the names from one level "lower". In this example, this is\n    the module scope (including globals).\n    As a side note, you can see, that the position in the filter is None on the\n    globals filter, because there the whole module is searched.\n\n    >>> list(filters[1].values())  # package modules -> Also empty.\n    []\n    >>> sorted(name.string_name for name in filters[2].values())  # Module attributes\n    [\'__doc__\', \'__name__\', \'__package__\']\n\n    Finally, it yields the builtin filter, if `include_builtin` is\n    true (default).\n\n    >>> list(filters[3].values())  # doctest: +ELLIPSIS\n    [...]\n    ';B=until_position;A=context;D=A;from jedi.inference.value.function import BaseFunctionExecutionContext as E
	while A is not _A:
		yield from A.get_filters(until_position=B,origin_scope=origin_scope)
		if isinstance(A,(E,ModuleContext)):B=_A
		A=A.parent_context
	C=next(D.inference_state.builtins_module.get_filters(),_A);assert C is not _A;yield C