"\nSearching for names with given scope and name. This is very central in Jedi and\nPython. The name resolution is quite complicated with descripter,\n``__getattribute__``, ``__getattr__``, ``global``, etc.\n\nIf you want to understand name resolution, please read the first few chapters\nin http://blog.ionelmc.ro/2015/02/09/understanding-python-metaclasses/.\n\nFlow checks\n+++++++++++\n\nFlow checks are not really mature. There's only a check for ``isinstance``.  It\nwould check whether a flow has the form of ``if isinstance(a, type_or_tuple)``.\nUnfortunately every other thing is being ignored (e.g. a == '' would be easy to\ncheck for -> a is a string). There's big potential in these checks.\n"
_B='atom_expr'
_A=None
from parso.tree import search_ancestor
from parso.python.tree import Name
from jedi import settings
from jedi.inference.arguments import TreeArguments
from jedi.inference.value import iterable
from jedi.inference.base_value import NO_VALUES
from jedi.parser_utils import is_scope
def filter_name(filters,name_or_str):
	'\n    Searches names that are defined in a scope (the different\n    ``filters``), until a name fits.\n    ';A=name_or_str;C=A.value if isinstance(A,Name)else A;B=[]
	for filter in filters:
		B=filter.get(C)
		if B:break
	return list(_remove_del_stmt(B))
def _remove_del_stmt(names):
	for A in names:
		if A.tree_name is not _A:
			B=A.tree_name.get_definition()
			if B is not _A and B.type=='del_stmt':continue
		yield A
def check_flow_information(value,flow,search_name,pos):
	' Try to find out the type of a variable just with the information that\n    is given by the flows: e.g. It is also responsible for assert checks.::\n\n        if isinstance(k, str):\n            k.  # <- completion here\n\n    ensures that `k` is a string.\n    ';E=value;B=search_name;A=flow
	if not settings.dynamic_flow_information:return
	C=_A
	if is_scope(A):
		H=A.get_root_node()
		try:D=H.get_used_names()[B.value]
		except KeyError:return
		D=reversed([B for B in D if A.start_pos<=B.start_pos<(pos or A.end_pos)])
		for I in D:
			F=search_ancestor(I,'assert_stmt')
			if F is not _A:
				C=_check_isinstance_type(E,F.assertion,B)
				if C is not _A:return C
	if A.type in('if_stmt','while_stmt'):
		J=[A for A in A.children[1::4]if A!=':']
		for G in reversed(J):
			if B.start_pos>G.end_pos:return _check_isinstance_type(E,G,B)
	return C
def _get_isinstance_trailer_arglist(node):
	A=node
	if A.type in('power',_B)and len(A.children)==2:
		C,B=A.children
		if C.type=='name'and C.value=='isinstance'and B.type=='trailer'and B.children[0]=='(':return B
def _check_isinstance_type(value,node,search_name):
	F=value;C=_A;A=_get_isinstance_trailer_arglist(node)
	if A is not _A and len(A.children)==3:
		D=A.children[1];H=TreeArguments(F.inference_state,F,D,A);G=list(H.unpack())
		if len(G)==2 and len(D.children)==3:
			(I,O),(J,K)=G
			if I is _A and J is _A:
				L=_get_call_string(search_name);M=_get_call_string(D.children[0])
				if L==M:C=K
	if C is _A:return
	E=NO_VALUES
	for B in C.infer():
		if isinstance(B,iterable.Sequence)and B.array_type=='tuple':
			for N in B.py__iter__():E|=N.infer().execute_with_values()
		else:E|=B.execute_with_values()
	return E
def _get_call_string(node):
	A=node
	if A.parent.type==_B:return _get_call_string(A.parent)
	C='';B=A.get_first_leaf();D=A.get_last_leaf().end_pos
	while B.start_pos<D:C+=B.value;B=B.get_next_leaf()
	return C