_D='%s(%s)'
_C='<%s: %s>'
_B=True
_A=False
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.base_value import ValueSet,NO_VALUES,Value,iterator_to_value_set,LazyValueWrapper,ValueWrapper
from jedi.inference.compiled import builtin_from_name
from jedi.inference.value.klass import ClassFilter
from jedi.inference.value.klass import ClassMixin
from jedi.inference.utils import to_list
from jedi.inference.names import AbstractNameDefinition,ValueName
from jedi.inference.context import ClassContext
from jedi.inference.gradual.generics import TupleGenericManager
class _BoundTypeVarName(AbstractNameDefinition):
	'\n    This type var was bound to a certain type, e.g. int.\n    '
	def __init__(A,type_var,value_set):B=type_var;A._type_var=B;A.parent_context=B.parent_context;A._value_set=value_set
	def infer(A):
		def B():
			for B in A._value_set:
				from jedi.inference.gradual.typing import AnyClass as C
				if isinstance(B,C):yield from A._type_var.constraints
				else:yield B
		return ValueSet(B())
	def py__name__(A):return A._type_var.py__name__()
	def __repr__(A):return'<%s %s -> %s>'%(A.__class__.__name__,A.py__name__(),A._value_set)
class _TypeVarFilter:
	"\n    A filter for all given variables in a class.\n\n        A = TypeVar('A')\n        B = TypeVar('B')\n        class Foo(Mapping[A, B]):\n            ...\n\n    In this example we would have two type vars given: A and B\n    "
	def __init__(A,generics,type_vars):A._generics=generics;A._type_vars=type_vars
	def get(B,name):
		for(C,A)in enumerate(B._type_vars):
			if A.py__name__()==name:
				try:return[_BoundTypeVarName(A,B._generics[C])]
				except IndexError:return[A.name]
		return[]
	def values(A):return[]
class _AnnotatedClassContext(ClassContext):
	def get_filters(A,*B,**C):D=super().get_filters(*B,**C);yield from D;yield A._value.get_type_var_filter()
class DefineGenericBaseClass(LazyValueWrapper):
	def __init__(A,generics_manager):A._generics_manager=generics_manager
	def _create_instance_with_generics(A,generics_manager):raise NotImplementedError
	@inference_state_method_cache()
	def get_generics(self):return self._generics_manager.to_tuple()
	def define_generics(B,type_var_dict):
		from jedi.inference.gradual.type_var import TypeVar as G;D=_A;E=[]
		for H in B.get_generics():
			C=NO_VALUES
			for A in H:
				if isinstance(A,(DefineGenericBaseClass,G)):
					F=A.define_generics(type_var_dict);C|=F
					if F!=ValueSet({A}):D=_B
				else:C|=ValueSet([A])
			E.append(C)
		if not D:return ValueSet([B])
		return ValueSet([B._create_instance_with_generics(TupleGenericManager(tuple(E)))])
	def is_same_class(B,other):
		A=other
		if not isinstance(A,DefineGenericBaseClass):return _A
		if B.tree_node!=A.tree_node:return _A
		C=B.get_generics();D=A.get_generics()
		if len(C)!=len(D):return _A
		return all(any(C.is_same_class(A)for A in A.gather_annotation_classes()for C in B.gather_annotation_classes())for(A,B)in zip(C,D))
	def get_signatures(A):return[]
	def __repr__(A):return'<%s: %s%s>'%(A.__class__.__name__,A._wrapped_value,list(A.get_generics()))
class GenericClass(DefineGenericBaseClass,ClassMixin):
	'\n    A class that is defined with generics, might be something simple like:\n\n        class Foo(Generic[T]): ...\n        my_foo_int_cls = Foo[int]\n    '
	def __init__(A,class_value,generics_manager):super().__init__(generics_manager);A._class_value=class_value
	def _get_wrapped_value(A):return A._class_value
	def get_type_hint(B,add_class_info=_B):
		A=B.py__name__();A=dict(list='List',dict='Dict',set='Set',tuple='Tuple').get(A,A);C=A+B._generics_manager.get_type_hint()
		if add_class_info:return'Type[%s]'%C
		return C
	def get_type_var_filter(A):return _TypeVarFilter(A.get_generics(),A.list_type_vars())
	def py__call__(B,arguments):A,=super().py__call__(arguments);return ValueSet([_GenericInstanceWrapper(A)])
	def _as_context(A):return _AnnotatedClassContext(A)
	@to_list
	def py__bases__(self):
		A=self
		for B in A._wrapped_value.py__bases__():yield _LazyGenericBaseClass(A,B,A._generics_manager)
	def _create_instance_with_generics(A,generics_manager):return GenericClass(A._class_value,generics_manager)
	def is_sub_class_of(B,class_value):
		A=class_value
		if super().is_sub_class_of(A):return _B
		return B._class_value.is_sub_class_of(A)
	def with_generics(A,generics_tuple):return A._class_value.with_generics(generics_tuple)
	def infer_type_vars(B,value_set):
		C=value_set;from jedi.inference.gradual.annotation import merge_pairwise_generics as H,merge_type_var_dicts as I;D=B.py__name__();E={}
		if D=='Iterable':
			F=B.get_generics()
			if F:return F[0].infer_type_vars(C.merge_types_of_iterate())
		else:
			for A in C:
				if A.is_instance()and not A.is_compiled():A=A.get_annotated_class_object()
				else:continue
				if A.api_type!='class':continue
				for G in A.py__mro__():
					J=G.py__name__()
					if D==J:I(E,H(B,G));break
		return E
class _LazyGenericBaseClass:
	def __init__(A,class_value,lazy_base_class,generics_manager):A._class_value=class_value;A._lazy_base_class=lazy_base_class;A._generics_manager=generics_manager
	@iterator_to_value_set
	def infer(self):
		B=self
		for A in B._lazy_base_class.infer():
			if isinstance(A,GenericClass):yield GenericClass.create_cached(A.inference_state,A._wrapped_value,TupleGenericManager(tuple(B._remap_type_vars(A))))
			elif A.is_class_mixin():yield GenericClass.create_cached(A.inference_state,A,B._generics_manager)
			else:yield A
	def _remap_type_vars(C,base):
		from jedi.inference.gradual.type_var import TypeVar as D;filter=C._class_value.get_type_var_filter()
		for E in base.get_generics():
			A=NO_VALUES
			for B in E:
				if isinstance(B,D):F=filter.get(B.py__name__());A|=ValueSet.from_sets(A.infer()for A in F)
				else:A|=ValueSet([B])
			yield A
	def __repr__(A):return _C%(A.__class__.__name__,A._lazy_base_class)
class _GenericInstanceWrapper(ValueWrapper):
	def py__stop_iteration_returns(A):
		for B in A._wrapped_value.class_value.py__mro__():
			if B.py__name__()=='Generator':
				C=B.get_generics()
				try:return C[2].execute_annotation()
				except IndexError:pass
			elif B.py__name__()=='Iterator':return ValueSet([builtin_from_name(A.inference_state,'None')])
		return A._wrapped_value.py__stop_iteration_returns()
	def get_type_hint(A,add_class_info=_B):return A._wrapped_value.class_value.get_type_hint(add_class_info=_A)
class _PseudoTreeNameClass(Value):
	'\n    In typeshed, some classes are defined like this:\n\n        Tuple: _SpecialForm = ...\n\n    Now this is not a real class, therefore we have to do some workarounds like\n    this class. Essentially this class makes it possible to goto that `Tuple`\n    name, without affecting anything else negatively.\n    ';api_type='class'
	def __init__(B,parent_context,tree_name):A=parent_context;super().__init__(A.inference_state,A);B._tree_name=tree_name
	@property
	def tree_node(self):return self._tree_name
	def get_filters(B,*C,**D):
		class A(ClassFilter):
			def __init__(A):0
			def get(A,name,**B):return[]
			def values(A,**B):return[]
		yield A()
	def py__class__(A):return builtin_from_name(A.inference_state,'type')
	@property
	def name(self):return ValueName(self,self._tree_name)
	def get_qualified_names(A):return A._tree_name.value,
	def __repr__(A):return _D%(A.__class__.__name__,A._tree_name.value)
class BaseTypingValue(LazyValueWrapper):
	def __init__(A,parent_context,tree_name):B=parent_context;A.inference_state=B.inference_state;A.parent_context=B;A._tree_name=tree_name
	@property
	def name(self):return ValueName(self,self._tree_name)
	def _get_wrapped_value(A):return _PseudoTreeNameClass(A.parent_context,A._tree_name)
	def get_signatures(A):return A._wrapped_value.get_signatures()
	def __repr__(A):return _D%(A.__class__.__name__,A._tree_name.value)
class BaseTypingClassWithGenerics(DefineGenericBaseClass):
	def __init__(A,parent_context,tree_name,generics_manager):B=parent_context;super().__init__(generics_manager);A.inference_state=B.inference_state;A.parent_context=B;A._tree_name=tree_name
	def _get_wrapped_value(A):return _PseudoTreeNameClass(A.parent_context,A._tree_name)
	def __repr__(A):return'%s(%s%s)'%(A.__class__.__name__,A._tree_name.value,A._generics_manager)
class BaseTypingInstance(LazyValueWrapper):
	def __init__(A,parent_context,class_value,tree_name,generics_manager):B=class_value;A.inference_state=B.inference_state;A.parent_context=parent_context;A._class_value=B;A._tree_name=tree_name;A._generics_manager=generics_manager
	def py__class__(A):return A._class_value
	def get_annotated_class_object(A):return A._class_value
	def get_qualified_names(A):return A.py__name__(),
	@property
	def name(self):return ValueName(self,self._tree_name)
	def _get_wrapped_value(A):B,=builtin_from_name(A.inference_state,'object').execute_annotation();return B
	def __repr__(A):return _C%(A.__class__.__name__,A._generics_manager)