"\nThis module is about generics, like the `int` in `List[int]`. It's not about\nthe Generic class.\n"
_A=False
from jedi import debug
from jedi.cache import memoize_method
from jedi.inference.utils import to_tuple
from jedi.inference.base_value import ValueSet,NO_VALUES
from jedi.inference.value.iterable import SequenceLiteralValue
from jedi.inference.helpers import is_string
def _resolve_forward_references(context,value_set):
	B=context
	for A in value_set:
		if is_string(A):
			from jedi.inference.gradual.annotation import _get_forward_reference_node as D;C=D(B,A.get_safe_value())
			if C is not None:
				for E in B.infer_node(C):yield E
		else:yield A
class _AbstractGenericManager:
	def get_index_and_execute(A,index):
		B=index
		try:return A[B].execute_annotation()
		except IndexError:debug.warning('No param #%s found for annotation %s',B,A);return NO_VALUES
	def get_type_hint(A):return'[%s]'%', '.join(A.get_type_hint(add_class_info=_A)for A in A.to_tuple())
class LazyGenericManager(_AbstractGenericManager):
	def __init__(A,context_of_index,index_value):A._context_of_index=context_of_index;A._index_value=index_value
	@memoize_method
	def __getitem__(self,index):return self._tuple()[index]()
	def __len__(A):return len(A._tuple())
	@memoize_method
	@to_tuple
	def _tuple(self):
		A=self
		def B(lazy_value):return lambda:ValueSet(_resolve_forward_references(A._context_of_index,lazy_value.infer()))
		if isinstance(A._index_value,SequenceLiteralValue):
			for C in A._index_value.py__iter__(contextualized_node=None):yield B(C)
		else:yield lambda:ValueSet(_resolve_forward_references(A._context_of_index,ValueSet([A._index_value])))
	@to_tuple
	def to_tuple(self):
		for A in self._tuple():yield A()
	def is_homogenous_tuple(A):
		if isinstance(A._index_value,SequenceLiteralValue):
			B=A._index_value.get_tree_entries()
			if len(B)==2 and B[1]=='...':return True
		return _A
	def __repr__(A):return'<LazyG>[%s]'%', '.join(repr(A)for A in A.to_tuple())
class TupleGenericManager(_AbstractGenericManager):
	def __init__(A,tup):A._tuple=tup
	def __getitem__(A,index):return A._tuple[index]
	def __len__(A):return len(A._tuple)
	def to_tuple(A):return A._tuple
	def is_homogenous_tuple(A):return _A
	def __repr__(A):return'<TupG>[%s]'%', '.join(repr(A)for A in A.to_tuple())