_C='django-stubs'
_B='__init__.pyi'
_A=None
import os,re
from functools import wraps
from collections import namedtuple
from typing import Dict,Mapping,Tuple
from pathlib import Path
from jedi import settings
from jedi.file_io import FileIO
from jedi.parser_utils import get_cached_code_lines
from jedi.inference.base_value import ValueSet,NO_VALUES
from jedi.inference.gradual.stub_value import TypingModuleWrapper,StubModuleValue
from jedi.inference.value import ModuleValue
_jedi_path=Path(__file__).parent.parent.parent.parent.parent
TYPESHED_PATH=_jedi_path.joinpath('typeshed')
DJANGO_INIT_PATH=_jedi_path.joinpath(_C,_C,_B)
_IMPORT_MAP=dict(_collections='collections',_socket='socket')
PathInfo=namedtuple('PathInfo','path is_third_party')
def _merge_create_stub_map(path_infos):
	A={}
	for B in path_infos:A.update(_create_stub_map(B))
	return A
def _create_stub_map(directory_path_info):
	'\n    Create a mapping of an importable name in Python to a stub file.\n    ';A=directory_path_info
	def B():
		try:F=os.listdir(A.path)
		except(FileNotFoundError,NotADirectoryError):return
		for B in F:
			C=os.path.join(A.path,B)
			if os.path.isdir(C):
				D=os.path.join(C,_B)
				if os.path.isfile(D):yield(B,PathInfo(D,A.is_third_party))
			elif B.endswith('.pyi')and os.path.isfile(C):
				E=B[:-4]
				if E!='__init__':yield(E,PathInfo(C,A.is_third_party))
	return dict(B())
def _get_typeshed_directories(version_info):
	F='stdlib';B=['2and3','3']
	for C in[F,'third_party']:
		D=TYPESHED_PATH.joinpath(C);G=os.listdir(D)
		for E in G:
			A=re.match('(\\d+)\\.(\\d+)$',E)
			if A is not _A:
				if A.group(1)=='3'and int(A.group(2))<=version_info.minor:B.append(E)
		for H in B:I=C!=F;yield PathInfo(str(D.joinpath(H)),I)
_version_cache={}
def _cache_stub_file_map(version_info):
	'\n    Returns a map of an importable name in Python to a stub file.\n    ';A=version_info;B=A[:2]
	try:return _version_cache[B]
	except KeyError:pass
	_version_cache[B]=C=_merge_create_stub_map(_get_typeshed_directories(A));return C
def import_module_decorator(func):
	E=func
	@wraps(E)
	def A(inference_state,import_names,parent_module_value,sys_path,prefer_stubs):
		F=sys_path;D=parent_module_value;C=inference_state;B=import_names;A=C.module_cache.get(B)
		if A is _A:
			if D is not _A and D.is_stub():G=D.non_stub_value_set
			else:G=[D]
			if B==('os','path'):A=ValueSet.from_sets(E(C,(A,),_A,F)for A in['posixpath','ntpath','macpath','os2emxpath'])
			else:A=ValueSet.from_sets(E(C,B,A,F)for A in G)
			C.module_cache.add(B,A)
		if not prefer_stubs or B[0]in settings.auto_import_modules:return A
		H=try_to_load_stub_cached(C,B,A,D,F)
		if H is not _A:return ValueSet([H])
		return A
	return A
def try_to_load_stub_cached(inference_state,import_names,*C,**D):
	B=inference_state;A=import_names
	if A is _A:return
	try:return B.stub_module_cache[A]
	except KeyError:pass
	B.stub_module_cache[A]=_A;B.stub_module_cache[A]=E=_try_to_load_stub(B,A,*C,**D);return E
def _try_to_load_stub(inference_state,import_names,python_value_set,parent_module_value,sys_path):
	'\n    Trying to load a stub for a set of import_names.\n\n    This is modelled to work like "PEP 561 -- Distributing and Packaging Type\n    Information", see https://www.python.org/dev/peps/pep-0561.\n    ';G=sys_path;E=parent_module_value;D=inference_state;C=python_value_set;A=import_names
	if E is _A and len(A)>1:
		try:E=try_to_load_stub_cached(D,A[:-1],NO_VALUES,parent_module_value=_A,sys_path=G)
		except KeyError:pass
	if len(A)==1:
		for H in G:
			M=os.path.join(H,*A)+'-stubs'+os.path.sep+_B;B=_try_to_load_stub_from_file(D,C,file_io=FileIO(M),import_names=A)
			if B is not _A:return B
		if A[0]=='django'and C:return _try_to_load_stub_from_file(D,C,file_io=FileIO(str(DJANGO_INIT_PATH)),import_names=A)
	for I in C:
		try:N=I.py__file__
		except AttributeError:pass
		else:
			F=N();J=[]
			if I.is_namespace():J=[os.path.join(A,_B)for A in I.py__path__()]
			elif F is not _A and F.suffix=='.py':J=[str(F)+'i']
			for F in J:
				B=_try_to_load_stub_from_file(D,C,file_io=FileIO(F),import_names=A)
				if B is not _A:return B
	B=_load_from_typeshed(D,C,E,A)
	if B is not _A:return B
	if not C:
		if E is not _A:K=E.py__path__()or[];L=A[-1],
		else:K=G;L=A
		for H in K:
			B=_try_to_load_stub_from_file(D,C,file_io=FileIO(os.path.join(H,*L)+'.pyi'),import_names=A)
			if B is not _A:return B
def _load_from_typeshed(inference_state,python_value_set,parent_module_value,import_names):
	G=python_value_set;F=inference_state;D=import_names;C=parent_module_value;A=D[-1];B=_A
	if len(D)==1:B=_cache_stub_file_map(F.grammar.version_info);A=_IMPORT_MAP.get(A,A)
	elif isinstance(C,ModuleValue):
		if not C.is_package():return
		H=C.py__path__();B=_merge_create_stub_map([PathInfo(A,is_third_party=False)for A in H])
	if B is not _A:
		E=B.get(A)
		if E is not _A and(not E.is_third_party or G):return _try_to_load_stub_from_file(F,G,file_io=FileIO(E.path),import_names=D)
def _try_to_load_stub_from_file(inference_state,python_value_set,file_io,import_names):
	B=file_io;A=inference_state
	try:C=parse_stub_module(A,B)
	except OSError:return
	else:return create_stub_module(A,A.latest_grammar,python_value_set,C,B,import_names)
def parse_stub_module(inference_state,file_io):return inference_state.parse(file_io=file_io,cache=True,diff_cache=settings.fast_parser,cache_path=settings.cache_directory,use_latest_grammar=True)
def create_stub_module(inference_state,grammar,python_value_set,stub_module_node,file_io,import_names):
	B=import_names;A=file_io
	if B==('typing',):C=TypingModuleWrapper
	else:C=StubModuleValue
	D=os.path.basename(A.path);E=C(python_value_set,inference_state,stub_module_node,file_io=A,string_names=B,code_lines=get_cached_code_lines(grammar,A.path),is_package=D==_B);return E