'\nWe need to somehow work with the typing objects. Since the typing objects are\npretty bare we need to add all the Jedi customizations to make them work as\nvalues.\n\nThis file deals with all the typing.py cases.\n'
_D='Callable'
_C='Optional'
_B='NewType'
_A=None
import itertools
from jedi import debug
from jedi.inference.compiled import builtin_from_name,create_simple_object
from jedi.inference.base_value import ValueSet,NO_VALUES,Value,LazyValueWrapper,ValueWrapper
from jedi.inference.lazy_value import LazyKnownValues
from jedi.inference.arguments import repack_with_argument_clinic
from jedi.inference.filters import FilterWrapper
from jedi.inference.names import NameWrapper,ValueName
from jedi.inference.value.klass import ClassMixin
from jedi.inference.gradual.base import BaseTypingValue,BaseTypingClassWithGenerics,BaseTypingInstance
from jedi.inference.gradual.type_var import TypeVarClass
from jedi.inference.gradual.generics import LazyGenericManager,TupleGenericManager
_PROXY_CLASS_TYPES='Tuple Generic Protocol Callable Type'.split()
_TYPE_ALIAS_TYPES={'List':'builtins.list','Dict':'builtins.dict','Set':'builtins.set','FrozenSet':'builtins.frozenset','ChainMap':'collections.ChainMap','Counter':'collections.Counter','DefaultDict':'collections.defaultdict','Deque':'collections.deque'}
_PROXY_TYPES='Optional Union ClassVar Annotated'.split()
class TypingModuleName(NameWrapper):
	def infer(A):return ValueSet(A._remap())
	def _remap(A):
		B=A.string_name;C=A.parent_context.inference_state
		try:D=_TYPE_ALIAS_TYPES[B]
		except KeyError:pass
		else:yield TypeAlias.create_cached(C,A.parent_context,A.tree_name,D);return
		if B in _PROXY_CLASS_TYPES:yield ProxyTypingClassValue.create_cached(C,A.parent_context,A.tree_name)
		elif B in _PROXY_TYPES:yield ProxyTypingValue.create_cached(C,A.parent_context,A.tree_name)
		elif B=='runtime':return
		elif B=='TypeVar':E,=A._wrapped_name.infer();yield TypeVarClass.create_cached(C,E)
		elif B=='Any':yield AnyClass.create_cached(C,A.parent_context,A.tree_name)
		elif B=='TYPE_CHECKING':yield builtin_from_name(C,'True')
		elif B=='overload':yield OverloadFunction.create_cached(C,A.parent_context,A.tree_name)
		elif B==_B:F,=A._wrapped_name.infer();yield NewTypeFunction.create_cached(C,F)
		elif B=='cast':G,=A._wrapped_name.infer();yield CastFunction.create_cached(C,G)
		elif B=='TypedDict':yield TypedDictClass.create_cached(C,A.parent_context,A.tree_name)
		else:yield from A._wrapped_name.infer()
class TypingModuleFilterWrapper(FilterWrapper):name_wrapper_class=TypingModuleName
class ProxyWithGenerics(BaseTypingClassWithGenerics):
	def execute_annotation(A):
		B=A._tree_name.value
		if B=='Union':return A.gather_annotation_classes().execute_annotation()
		elif B==_C:return A.gather_annotation_classes().execute_annotation()|ValueSet([builtin_from_name(A.inference_state,'None')])
		elif B=='Type':return A._generics_manager[0]
		elif B in['ClassVar','Annotated']:return A._generics_manager[0].execute_annotation()
		C={'Tuple':Tuple,'Generic':Generic,'Protocol':Protocol,_D:Callable};D=C[B];return ValueSet([D(A.parent_context,A,A._tree_name,generics_manager=A._generics_manager)])
	def gather_annotation_classes(A):return ValueSet.from_sets(A._generics_manager.to_tuple())
	def _create_instance_with_generics(A,generics_manager):return ProxyWithGenerics(A.parent_context,A._tree_name,generics_manager)
	def infer_type_vars(A,value_set):
		B=A.get_generics()
		if not B:return{}
		C=A.py__name__()
		if C==_C:D=builtin_from_name(A.inference_state,'None');return B[0].infer_type_vars(value_set.filter(lambda x:x!=D))
		return{}
class ProxyTypingValue(BaseTypingValue):
	index_class=ProxyWithGenerics
	def with_generics(A,generics_tuple):return A.index_class.create_cached(A.inference_state,A.parent_context,A._tree_name,generics_manager=TupleGenericManager(generics_tuple))
	def py__getitem__(A,index_value_set,contextualized_node):return ValueSet(A.index_class.create_cached(A.inference_state,A.parent_context,A._tree_name,generics_manager=LazyGenericManager(context_of_index=contextualized_node.context,index_value=B))for B in index_value_set)
class _TypingClassMixin(ClassMixin):
	def py__bases__(A):return[LazyKnownValues(A.inference_state.builtins_module.py__getattribute__('object'))]
	def get_metaclasses(A):return[]
	@property
	def name(self):return ValueName(self,self._tree_name)
class TypingClassWithGenerics(ProxyWithGenerics,_TypingClassMixin):
	def infer_type_vars(B,value_set):
		C=value_set;E={};A=B.get_generics()
		if not A:return E
		D=B.py__name__()
		if D=='Type':return A[0].infer_type_vars(C.execute_annotation())
		elif D==_D:
			if len(A)==2:return A[1].infer_type_vars(C.execute_annotation())
		elif D=='Tuple':F,=B.execute_annotation();return F.infer_type_vars(C)
		return E
	def _create_instance_with_generics(A,generics_manager):return TypingClassWithGenerics(A.parent_context,A._tree_name,generics_manager)
class ProxyTypingClassValue(ProxyTypingValue,_TypingClassMixin):index_class=TypingClassWithGenerics
class TypeAlias(LazyValueWrapper):
	def __init__(A,parent_context,origin_tree_name,actual):B=parent_context;A.inference_state=B.inference_state;A.parent_context=B;A._origin_tree_name=origin_tree_name;A._actual=actual
	@property
	def name(self):return ValueName(self,self._origin_tree_name)
	def py__name__(A):return A.name.string_name
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A._actual)
	def _get_wrapped_value(A):C,D=A._actual.split('.');from jedi.inference.imports import Importer as E;F,=E(A.inference_state,[C],A.inference_state.builtins_module).follow();B=F.py__getattribute__(D);assert len(B)==1,B;G=next(iter(B));return G
	def gather_annotation_classes(A):return ValueSet([A._get_wrapped_value()])
	def get_signatures(A):return[]
class Callable(BaseTypingInstance):
	def py__call__(A,arguments):
		'\n            def x() -> Callable[[Callable[..., _T]], _T]: ...\n        '
		try:B=A._generics_manager[0];C=A._generics_manager[1]
		except IndexError:debug.warning('Callable[...] defined without two arguments');return NO_VALUES
		else:from jedi.inference.gradual.annotation import infer_return_for_callable as D;return D(arguments,B,C)
	def py__get__(A,instance,class_value):return ValueSet([A])
class Tuple(BaseTypingInstance):
	def _is_homogenous(A):return A._generics_manager.is_homogenous_tuple()
	def py__simple_getitem__(A,index):
		B=index
		if A._is_homogenous():return A._generics_manager.get_index_and_execute(0)
		else:
			if isinstance(B,int):return A._generics_manager.get_index_and_execute(B)
			debug.dbg('The getitem type on Tuple was %s'%B);return NO_VALUES
	def py__iter__(A,contextualized_node=_A):
		if A._is_homogenous():yield LazyKnownValues(A._generics_manager.get_index_and_execute(0))
		else:
			for B in A._generics_manager.to_tuple():yield LazyKnownValues(B.execute_annotation())
	def py__getitem__(A,index_value_set,contextualized_node):
		if A._is_homogenous():return A._generics_manager.get_index_and_execute(0)
		return ValueSet.from_sets(A._generics_manager.to_tuple()).execute_annotation()
	def _get_wrapped_value(A):B,=A.inference_state.builtins_module.py__getattribute__('tuple').execute_annotation();return B
	@property
	def name(self):return self._wrapped_value.name
	def infer_type_vars(B,value_set):
		A=value_set;from jedi.inference.gradual.annotation import merge_pairwise_generics as D,merge_type_var_dicts as E;A=A.filter(lambda x:x.py__name__().lower()=='tuple')
		if B._is_homogenous():return B._class_value.get_generics()[0].infer_type_vars(A.merge_types_of_iterate())
		else:
			C={}
			for F in A:
				try:G=F.get_annotated_class_object
				except AttributeError:continue
				H=G();E(C,D(B._class_value,H))
			return C
class Generic(BaseTypingInstance):0
class Protocol(BaseTypingInstance):0
class AnyClass(BaseTypingValue):
	def execute_annotation(A):debug.warning('Used Any - returned no results');return NO_VALUES
class OverloadFunction(BaseTypingValue):
	@repack_with_argument_clinic('func, /')
	def py__call__(self,func_value_set):return func_value_set
class NewTypeFunction(ValueWrapper):
	def py__call__(D,arguments):
		A=arguments;B=A.unpack();next(B,(_A,_A));E,C=next(B,(_A,_A))
		if C is _A:return NO_VALUES
		return ValueSet(NewType(D.inference_state,A.context,A.node,C.infer())for A in A.get_calling_nodes())
class NewType(Value):
	def __init__(A,inference_state,parent_context,tree_node,type_value_set):super().__init__(inference_state,parent_context);A._type_value_set=type_value_set;A.tree_node=tree_node
	def py__class__(A):B,=A._type_value_set.py__class__();return B
	def py__call__(A,arguments):return A._type_value_set.execute_annotation()
	@property
	def name(self):from jedi.inference.compiled.value import CompiledValueName as A;return A(self,_B)
	def __repr__(A):return'<NewType: %s>%s'%(A.tree_node,A._type_value_set)
class CastFunction(ValueWrapper):
	@repack_with_argument_clinic('type, object, /')
	def py__call__(self,type_value_set,object_value_set):return type_value_set.execute_annotation()
class TypedDictClass(BaseTypingValue):'\n    This class has no responsibilities and is just here to make sure that typed\n    dicts can be identified.\n    '
class TypedDict(LazyValueWrapper):
	'Represents the instance version of ``TypedDictClass``.'
	def __init__(A,definition_class):B=definition_class;A.inference_state=B.inference_state;A.parent_context=B.parent_context;A.tree_node=B.tree_node;A._definition_class=B
	@property
	def name(self):return ValueName(self,self.tree_node.name)
	def py__simple_getitem__(B,index):
		A=index
		if isinstance(A,str):return ValueSet.from_sets(B.infer()for filter in B._definition_class.get_filters(is_instance=True)for B in filter.get(A))
		return NO_VALUES
	def get_key_values(A):B=itertools.chain.from_iterable(A.values()for A in A._definition_class.get_filters(is_instance=True));return ValueSet({create_simple_object(A.inference_state,B.string_name)for B in B})
	def _get_wrapped_value(A):B,=A.inference_state.builtins_module.py__getattribute__('dict');C,=B.execute_with_values();return C