"\n:mod:`jedi.inference.imports` is here to resolve import statements and return\nthe modules/classes/functions/whatever, which they stand for. However there's\nnot any actual importing done. This module is about finding modules in the\nfilesystem. This can be quite tricky sometimes, because Python imports are not\nalways that simple.\n\nThis module also supports import autocompletion, which means to complete\nstatements like ``from datetim`` (cursor at the end would return ``datetime``).\n"
_C=False
_B=True
_A=None
import os
from pathlib import Path
from parso.python import tree
from parso.tree import search_ancestor
from jedi import debug
from jedi import settings
from jedi.file_io import FolderIO
from jedi.parser_utils import get_cached_code_lines
from jedi.inference import sys_path
from jedi.inference import helpers
from jedi.inference import compiled
from jedi.inference import analysis
from jedi.inference.utils import unite
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.names import ImportName,SubModuleName
from jedi.inference.base_value import ValueSet,NO_VALUES
from jedi.inference.gradual.typeshed import import_module_decorator,create_stub_module,parse_stub_module
from jedi.inference.compiled.subprocess.functions import ImplicitNSInfo
from jedi.plugins import plugin_manager
class ModuleCache:
	def __init__(A):A._name_cache={}
	def add(B,string_names,value_set):
		A=string_names
		if A is not _A:B._name_cache[A]=value_set
	def get(A,string_names):return A._name_cache.get(string_names)
@inference_state_method_cache(default=NO_VALUES)
def infer_import(context,tree_name):
	B=context;D=B.get_root_context();C,E,F,A=_prepare_infer_import(D,tree_name)
	if A:
		if C is not _A:
			A=A.py__getattribute__(C,name_context=B,analysis_errors=_C)
			if not A:G=E+(C,);H=Importer(B.inference_state,G,D,F);A=H.follow()
	debug.dbg('after import: %s',A);return A
@inference_state_method_cache(default=[])
def goto_import(context,tree_name):
	E=tree_name;B=context;F=B.get_root_context();C,G,H,A=_prepare_infer_import(F,E)
	if not A:return[]
	if C is not _A:
		D=unite([A.goto(C,name_context=B,analysis_errors=_C)for A in A])
		if D and not any(A.tree_name is E for A in D):return D
		I=G+(C,);J=Importer(B.inference_state,I,F,H);A=J.follow()
	return set(A.name for A in A)
def _prepare_infer_import(module_context,tree_name):
	D=tree_name;C=module_context;B=search_ancestor(D,'import_name','import_from');A=B.get_path_for_name(D);E=_A
	try:F=B.get_from_names()
	except AttributeError:pass
	else:
		if len(F)+1==len(A):E=A[-1];A=F
	G=Importer(C.inference_state,tuple(A),C,B.level);return E,tuple(A),B.level,G.follow()
def _add_error(value,name,message):
	B=message;A=value
	if hasattr(name,'parent')and A is not _A:analysis.add(A,'import-error',name,B)
	else:debug.warning('ImportError without origin: '+B)
def _level_to_base_import_path(project_path,directory,level):
	'\n    In case the level is outside of the currently known package (something like\n    import .....foo), we can still try our best to help the user for\n    completions.\n    ';A=directory
	for F in range(level-1):
		E=A;A=os.path.dirname(A)
		if E==A:return _A,_A
	B=A;C=[]
	while _B:
		if B==project_path:return C,B
		D=os.path.basename(B)
		if D:C.insert(0,D);B=os.path.dirname(B)
		else:return _A,A
class Importer:
	def __init__(B,inference_state,import_path,module_context,level=0):
		'\n        An implementation similar to ``__import__``. Use `follow`\n        to actually follow the imports.\n\n        *level* specifies whether to use absolute or relative imports. 0 (the\n        default) means only perform absolute imports. Positive values for level\n        indicate the number of parent directories to search relative to the\n        directory of the module calling ``__import__()`` (see PEP 328 for the\n        details).\n\n        :param import_path: List of namespaces (strings or Names).\n        ';E=module_context;C=level;A=import_path;debug.speed('import %s %s'%(A,E));B._inference_state=inference_state;B.level=C;B._module_context=E;B._fixed_sys_path=_A;B._infer_possible=_B
		if C:
			D=E.get_value().py__package__()
			if C<=len(D):
				D=tuple(D)
				if C>1:D=D[:-C+1]
				A=D+tuple(A)
			else:
				F=E.py__file__();G=B._inference_state.project.path;A=list(A)
				if F is _A:H=G
				else:H=os.path.dirname(F)
				I,J=_level_to_base_import_path(G,H,C)
				if J is _A:B._infer_possible=_C
				else:B._fixed_sys_path=[J]
				if I is _A:
					if A:_add_error(E,A[0],message='Attempted relative import beyond top-level package.')
				else:A=I+A
		B.import_path=A
	@property
	def _str_import_path(self):'Returns the import path as pure strings instead of `Name`.';return tuple(A.value if isinstance(A,tree.Name)else A for A in self.import_path)
	def _sys_path_with_modifications(A,is_completion):
		if A._fixed_sys_path is not _A:return A._fixed_sys_path
		return A._inference_state.get_sys_path(add_init_paths=not is_completion)+[str(A)for A in sys_path.check_sys_path_modifications(A._module_context)]
	def follow(A):
		if not A.import_path:
			if A._fixed_sys_path:from jedi.inference.value.namespace import ImplicitNamespaceValue as C;D=os.path.basename(A._fixed_sys_path[0]),;E=C(A._inference_state,string_names=D,paths=A._fixed_sys_path);return ValueSet({E})
			return NO_VALUES
		if not A._infer_possible:return NO_VALUES
		B=A._inference_state.stub_module_cache.get(A._str_import_path)
		if B is not _A:return ValueSet({B})
		B=A._inference_state.module_cache.get(A._str_import_path)
		if B is not _A:return B
		F=A._sys_path_with_modifications(is_completion=_C);return import_module_by_names(A._inference_state,A.import_path,F,A._module_context)
	def _get_module_names(A,search_path=_A,in_module=_A):
		'\n        Get the names of all modules in the search_path. This means file names\n        and not names defined in the files.\n        ';C=in_module;B=search_path
		if B is _A:D=A._sys_path_with_modifications(is_completion=_B)
		else:D=B
		return list(iter_module_names(A._inference_state,A._module_context,D,module_cls=ImportName if C is _A else SubModuleName,add_builtin_modules=B is _A and C is _A))
	def completion_names(A,inference_state,only_modules=_C):
		"\n        :param only_modules: Indicates wheter it's possible to import a\n            definition that is not defined in a module.\n        ";G='flask_'
		if not A._infer_possible:return[]
		B=[]
		if A.import_path:
			if A._str_import_path==('flask','ext'):
				for H in A._get_module_names():
					E=H.string_name
					if E.startswith(G):I=E[len(G):];B.append(ImportName(A._module_context,I))
				for dir in A._sys_path_with_modifications(is_completion=_B):
					F=os.path.join(dir,'flaskext')
					if os.path.isdir(F):B+=A._get_module_names([F])
			C=A.follow()
			for D in C:
				if D.api_type not in('module','namespace'):continue
				if not D.is_compiled():B+=D.sub_modules_dict().values()
			if not only_modules:
				from jedi.inference.gradual.conversion import convert_values as J;K=C|J(C)
				for L in K:
					for filter in L.get_filters():B+=filter.values()
		elif A.level:B+=A._get_module_names(A._fixed_sys_path)
		else:B+=A._get_module_names()
		return B
def import_module_by_names(inference_state,import_names,sys_path=_A,module_context=_A,prefer_stubs=_B):
	E=module_context;D=import_names;C=inference_state;B=sys_path
	if B is _A:B=C.get_sys_path()
	F=tuple(A.value if isinstance(A,tree.Name)else A for A in D);A=[_A]
	for(H,I)in enumerate(D):
		A=ValueSet.from_sets([import_module(C,F[:H+1],A,B,prefer_stubs=prefer_stubs)for A in A])
		if not A:
			G='No module named '+'.'.join(F)
			if E is not _A:_add_error(E,I,G)
			else:debug.warning(G)
			return NO_VALUES
	return A
@plugin_manager.decorate()
@import_module_decorator
def import_module(inference_state,import_names,parent_module_value,sys_path):
	"\n    This method is very similar to importlib's `_gcd_import`.\n    ";G=sys_path;F=parent_module_value;C=inference_state;B=import_names
	if B[0]in settings.auto_import_modules:
		A=_load_builtin_module(C,B,G)
		if A is _A:return NO_VALUES
		return ValueSet([A])
	H='.'.join(B)
	if F is _A:
		D,E=C.compiled_subprocess.get_module_info(string=B[-1],full_name=H,sys_path=G,is_global_search=_B)
		if E is _A:return NO_VALUES
	else:
		I=F.py__path__()
		if I is _A:return NO_VALUES
		D,E=C.compiled_subprocess.get_module_info(string=B[-1],path=I,full_name=H,is_global_search=_C)
		if E is _A:return NO_VALUES
	if isinstance(D,ImplicitNSInfo):from jedi.inference.value.namespace import ImplicitNamespaceValue as J;A=J(C,string_names=tuple(D.name.split('.')),paths=D.paths)
	elif D is _A:
		A=_load_builtin_module(C,B,G)
		if A is _A:return NO_VALUES
	else:A=_load_python_module(C,D,import_names=B,is_package=E)
	if F is _A:debug.dbg('global search_module %s: %s',B[-1],A)
	else:debug.dbg('search_module %s in paths %s: %s',H,I,A)
	return ValueSet([A])
def _load_python_module(inference_state,file_io,import_names=_A,is_package=_C):B=file_io;A=inference_state;C=A.parse(file_io=B,cache=_B,diff_cache=settings.fast_parser,cache_path=settings.cache_directory);from jedi.inference.value import ModuleValue as D;return D(A,C,file_io=B,string_names=import_names,code_lines=get_cached_code_lines(A.grammar,B.path),is_package=is_package)
def _load_builtin_module(inference_state,import_names=_A,sys_path=_A):
	B=inference_state;A=sys_path;C=B.project
	if A is _A:A=B.get_sys_path()
	if not C._load_unsafe_extensions:F=C._get_base_sys_path(B);A=[A for A in A if A in F]
	D='.'.join(import_names);assert D is not _A;E=compiled.load_module(B,dotted_name=D,sys_path=A)
	if E is _A:return
	return E
def load_module_from_path(inference_state,file_io,import_names=_A,is_package=_A):
	"\n    This should pretty much only be used for get_modules_containing_name. It's\n    here to ensure that a random path is still properly loaded into the Jedi\n    module structure.\n    ";E=is_package;C=file_io;B=import_names;A=inference_state;F=Path(C.path)
	if B is _A:J=A.get_sys_path();B,E=sys_path.transform_path_to_dotted(J,F)
	else:assert isinstance(E,bool)
	K=F.suffix=='.pyi'
	if K:
		D=C.get_parent_folder()
		if D.path.endswith('-stubs'):D=FolderIO(D.path[:-6])
		if F.name=='__init__.pyi':G=D.get_file_io('__init__.py')
		else:G=D.get_file_io(B[-1]+'.py')
		try:L=load_module_from_path(A,G,B,is_package=E);H=ValueSet([L])
		except FileNotFoundError:H=NO_VALUES
		return create_stub_module(A,A.latest_grammar,H,parse_stub_module(A,C),C,B)
	else:I=_load_python_module(A,C,import_names=B,is_package=E);A.module_cache.add(B,ValueSet([I]));return I
def load_namespace_from_path(inference_state,folder_io):B=folder_io;A=inference_state;C,E=sys_path.transform_path_to_dotted(A.get_sys_path(),Path(B.path));from jedi.inference.value.namespace import ImplicitNamespaceValue as D;return D(A,C,[B.path])
def follow_error_node_imports_if_possible(context,name):
	H='from';C=context;A=name;B=tree.search_ancestor(A,'error_node')
	if B is not _A:
		D=0
		for(I,E)in enumerate(B.children):
			if E.start_pos>A.start_pos:break
			if E==';':D=I+1
		F=B.children[D:];G=F[0].get_first_leaf().value
		if G in(H,'import'):J=G==H;K,L=helpers.parse_dotted_names(F,is_import_from=J,until_node=A);return Importer(C.inference_state,L,C.get_root_context(),K).follow()
def iter_module_names(inference_state,module_context,search_path,module_cls=ImportName,add_builtin_modules=_B):
	'\n    Get the names of all modules in the search_path. This means file names\n    and not names defined in the files.\n    ';D=module_cls;C=module_context;B=inference_state
	if add_builtin_modules:
		for A in B.compiled_subprocess.get_builtin_module_names():yield D(C,A)
	for A in B.compiled_subprocess.iter_module_names(search_path):yield D(C,A)