from jedi.inference.base_value import ValueSet,NO_VALUES
from jedi.common import monkeypatch
class AbstractLazyValue:
	def __init__(A,data,min=1,max=1):A.data=data;A.min=min;A.max=max
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A.data)
	def infer(A):raise NotImplementedError
class LazyKnownValue(AbstractLazyValue):
	'data is a Value.'
	def infer(A):return ValueSet([A.data])
class LazyKnownValues(AbstractLazyValue):
	'data is a ValueSet.'
	def infer(A):return A.data
class LazyUnknownValue(AbstractLazyValue):
	def __init__(A,min=1,max=1):super().__init__(None,min,max)
	def infer(A):return NO_VALUES
class LazyTreeValue(AbstractLazyValue):
	def __init__(A,context,node,min=1,max=1):B=context;super().__init__(node,min,max);A.context=B;A._predefined_names=dict(B.predefined_names)
	def infer(A):
		with monkeypatch(A.context,'predefined_names',A._predefined_names):return A.context.infer_node(A.data)
def get_merged_lazy_value(lazy_values):
	A=lazy_values
	if len(A)>1:return MergedLazyValues(A)
	else:return A[0]
class MergedLazyValues(AbstractLazyValue):
	'data is a list of lazy values.'
	def infer(A):return ValueSet.from_sets(A.infer()for A in A.data)