_J='function'
_I='expr_stmt'
_H='import_from'
_G='import_name'
_F='statement'
_E='param'
_D='module'
_C=True
_B=False
_A=None
from abc import abstractmethod
from inspect import Parameter
from typing import Optional,Tuple
from parso.tree import search_ancestor
from jedi.parser_utils import find_statement_documentation,clean_scope_docstring
from jedi.inference.utils import unite
from jedi.inference.base_value import ValueSet,NO_VALUES
from jedi.inference.cache import inference_state_method_cache
from jedi.inference import docstrings
from jedi.cache import memoize_method
from jedi.inference.helpers import deep_ast_copy,infer_call_of_leaf
from jedi.plugins import plugin_manager
def _merge_name_docs(names):
	A=''
	for B in names:
		if A:A+='\n'+'-'*30+'\n'
		A+=B.py__doc__()
	return A
class AbstractNameDefinition:
	start_pos:Optional[Tuple[int,int]]=_A;string_name:str;parent_context=_A;tree_name=_A;is_value_name=_C;"\n    Used for the Jedi API to know if it's a keyword or an actual name.\n    "
	@abstractmethod
	def infer(self):raise NotImplementedError
	@abstractmethod
	def goto(self):return{self}
	def get_qualified_names(B,include_module_names=_B):
		A=B._get_qualified_names()
		if A is _A or not include_module_names:return A
		C=B.get_root_context().string_names
		if C is _A:return
		return C+A
	def _get_qualified_names(A):0
	def get_root_context(A):return A.parent_context.get_root_context()
	def get_public_name(A):return A.string_name
	def __repr__(A):
		if A.start_pos is _A:return'<%s: string_name=%s>'%(A.__class__.__name__,A.string_name)
		return'<%s: string_name=%s start_pos=%s>'%(A.__class__.__name__,A.string_name,A.start_pos)
	def is_import(A):return _B
	def py__doc__(A):return''
	@property
	def api_type(self):return self.parent_context.api_type
	def get_defining_qualified_value(A):"\n        Returns either None or the value that is public and qualified. Won't\n        return a function, because a name in a function is never public.\n        "
class AbstractArbitraryName(AbstractNameDefinition):
	'\n    When you e.g. want to complete dicts keys, you probably want to complete\n    string literals, which is not really a name, but for Jedi we use this\n    concept of Name for completions as well.\n    ';is_value_name=_B
	def __init__(A,inference_state,string):B=inference_state;A.inference_state=B;A.string_name=string;A.parent_context=B.builtins_module
	def infer(A):return NO_VALUES
class AbstractTreeName(AbstractNameDefinition):
	def __init__(A,parent_context,tree_name):A.parent_context=parent_context;A.tree_name=tree_name
	def get_qualified_names(B,include_module_names=_B):
		C=include_module_names;A=search_ancestor(B.tree_name,_G,_H)
		if A is not _A and not(A.level==1 and B.get_root_context().get_value().is_package()):
			if C and not A.level:return tuple(A.value for A in A.get_path_for_name(B.tree_name))
			else:return
		return super().get_qualified_names(C)
	def _get_qualified_names(A):
		B=A.parent_context.get_qualified_names()
		if B is _A:return
		return B+(A.tree_name.value,)
	def get_defining_qualified_value(A):
		if A.is_import():raise NotImplementedError("Shouldn't really happen, please report")
		elif A.parent_context:return A.parent_context.get_value()
	def goto(F):
		R='lambdef';Q='trailer';C=F.parent_context;A=F.tree_name;K=A.get_definition(import_name_always=_C)
		if K is not _A:
			L=K.type
			if L==_I:
				S=A.parent.type not in('power',Q)
				if S:return[F]
			elif L in(_H,_G):from jedi.inference.imports import goto_import as T;U=T(C,A);return U
			else:return[F]
		else:
			from jedi.inference.imports import follow_error_node_imports_if_possible as V;E=V(C,A)
			if E is not _A:return[A.name for A in E]
		D=A.parent;I=D.type
		if I=='argument'and D.children[1]=='='and D.children[0]==A:
			B=D.parent
			if B.type=='arglist':B=B.parent
			if B.type!='classdef':
				if B.type=='decorator':G=C.infer_node(B.children[1])
				else:
					W=B.parent.children.index(B);H=B.parent.children[:W]
					if H[0]=='await':H.pop(0)
					G=C.infer_node(H[0]);from jedi.inference.syntax_tree import infer_trailer as X
					for B in H[1:]:G=X(C,G,B)
				M=[]
				for Y in G:
					for Z in Y.get_signatures():
						for N in Z.get_param_names():
							if N.string_name==A.value:M.append(N)
				return M
		elif I=='dotted_name':
			O=D.children.index(A)
			if O>0:P=deep_ast_copy(D);P.children[O-1:]=[];E=C.infer_node(P);return unite(B.goto(A,name_context=C)for B in E)
		if I==Q and D.children[0]=='.':E=infer_call_of_leaf(C,A,cut_own_trailer=_C);return E.goto(A,name_context=C)
		else:
			J=search_ancestor(A,_I,R)or A
			if J.type==R:J=A
			return C.goto(A,position=J.start_pos)
	def is_import(A):B=search_ancestor(A.tree_name,_H,_G);return B is not _A
	@property
	def string_name(self):return self.tree_name.value
	@property
	def start_pos(self):return self.tree_name.start_pos
class ValueNameMixin:
	def infer(A):return ValueSet([A._value])
	def py__doc__(A):
		B=A._value.py__doc__()
		if not B and A._value.is_stub():
			from jedi.inference.gradual.conversion import convert_names as D;C=D([A],prefer_stub_to_compiled=_B)
			if A not in C:return _merge_name_docs(C)
		return B
	def _get_qualified_names(A):return A._value.get_qualified_names()
	def get_root_context(A):
		if A.parent_context is _A:return A._value.as_context()
		return super().get_root_context()
	def get_defining_qualified_value(B):
		A=B.parent_context
		if A is not _A and(A.is_module()or A.is_class()):return B.parent_context.get_value()
	@property
	def api_type(self):return self._value.api_type
class ValueName(ValueNameMixin,AbstractTreeName):
	def __init__(B,value,tree_name):A=value;super().__init__(A.parent_context,tree_name);B._value=A
	def goto(A):return ValueSet([A._value.name])
class TreeNameDefinition(AbstractTreeName):
	_API_TYPES=dict(import_name=_D,import_from=_D,funcdef=_J,param=_E,classdef='class')
	def infer(A):from jedi.inference.syntax_tree import tree_name_to_values as B;return B(A.parent_context.inference_state,A.parent_context,A.tree_name)
	@property
	def api_type(self):
		A=self.tree_name.get_definition(import_name_always=_C)
		if A is _A:return _F
		return self._API_TYPES.get(A.type,_F)
	def assignment_indexes(D):
		"\n        Returns an array of tuple(int, node) of the indexes that are used in\n        tuple assignments.\n\n        For example if the name is ``y`` in the following code::\n\n            x, (y, z) = 2, ''\n\n        would result in ``[(1, xyz_node), (0, yz_node)]``.\n\n        When searching for b in the case ``a, *b, c = [...]`` it will return::\n\n            [(slice(1, -1), abc_node)]\n        ";E=[];B=_B;A=D.tree_name.parent;F=D.tree_name
		while A is not _A:
			if A.type in('testlist','testlist_comp','testlist_star_expr','exprlist'):
				for(G,H)in enumerate(A.children):
					if H==F:
						C=int(G/2)
						if B:I=int((len(A.children)-G)/2);C=slice(C,-I)
						E.insert(0,(C,A));break
				else:raise LookupError("Couldn't find the assignment.")
				B=_B
			elif A.type=='star_expr':B=_C
			elif A.type in(_I,'sync_comp_for'):break
			F=A;A=A.parent
		return E
	@property
	def inference_state(self):return self.parent_context.inference_state
	@inference_state_method_cache(default='')
	def py__doc__(self):
		A=self;C=A.api_type
		if C in(_J,'class','property'):
			if A.parent_context.get_root_context().is_stub():
				from jedi.inference.gradual.conversion import convert_names as D;B=D([A],prefer_stub_to_compiled=_B)
				if A not in B:return _merge_name_docs(B)
			return clean_scope_docstring(A.tree_name.get_definition())
		if C==_D:
			B=A.goto()
			if A not in B:return _merge_name_docs(B)
		if C==_F and A.tree_name.is_definition():return find_statement_documentation(A.tree_name.get_definition())
		return''
class _ParamMixin:
	def maybe_positional_argument(B,include_star=_C):
		A=[Parameter.POSITIONAL_ONLY,Parameter.POSITIONAL_OR_KEYWORD]
		if include_star:A.append(Parameter.VAR_POSITIONAL)
		return B.get_kind()in A
	def maybe_keyword_argument(B,include_stars=_C):
		A=[Parameter.KEYWORD_ONLY,Parameter.POSITIONAL_OR_KEYWORD]
		if include_stars:A.append(Parameter.VAR_KEYWORD)
		return B.get_kind()in A
	def _kind_string(B):
		A=B.get_kind()
		if A==Parameter.VAR_POSITIONAL:return'*'
		if A==Parameter.VAR_KEYWORD:return'**'
		return''
	def get_qualified_names(A,include_module_names=_B):0
class ParamNameInterface(_ParamMixin):
	api_type=_E
	def get_kind(A):raise NotImplementedError
	def to_string(A):raise NotImplementedError
	def get_executed_param_name(A):"\n        For dealing with type inference and working around the graph, we\n        sometimes want to have the param name of the execution. This feels a\n        bit strange and we might have to refactor at some point.\n\n        For now however it exists to avoid infering params when we don't really\n        need them (e.g. when we can just instead use annotations.\n        "
	@property
	def star_count(self):
		A=self.get_kind()
		if A==Parameter.VAR_POSITIONAL:return 1
		if A==Parameter.VAR_KEYWORD:return 2
		return 0
	def infer_default(A):return NO_VALUES
class BaseTreeParamName(ParamNameInterface,AbstractTreeName):
	annotation_node=_A;default_node=_A
	def to_string(A):
		B=A._kind_string()+A.get_public_name();C=A.annotation_node;D=A.default_node
		if C is not _A:B+=': '+C.get_code(include_prefix=_B)
		if D is not _A:B+='='+D.get_code(include_prefix=_B)
		return B
	def get_public_name(B):
		A=B.string_name
		if A.startswith('__'):A=A[2:]
		return A
	def goto(A,**B):return[A]
class _ActualTreeParamName(BaseTreeParamName):
	def __init__(B,function_value,tree_name):A=function_value;super().__init__(A.get_default_param_context(),tree_name);B.function_value=A
	def _get_param_node(A):return search_ancestor(A.tree_name,_E)
	@property
	def annotation_node(self):return self._get_param_node().annotation
	def infer_annotation(B,execute_annotation=_C,ignore_stars=_B):
		from jedi.inference.gradual.annotation import infer_param as C;A=C(B.function_value,B._get_param_node(),ignore_stars=ignore_stars)
		if execute_annotation:A=A.execute_annotation()
		return A
	def infer_default(A):
		B=A.default_node
		if B is _A:return NO_VALUES
		return A.parent_context.infer_node(B)
	@property
	def default_node(self):return self._get_param_node().default
	def get_kind(D):
		A=D._get_param_node()
		if A.star_count==1:return Parameter.VAR_POSITIONAL
		if A.star_count==2:return Parameter.VAR_KEYWORD
		if A.name.value.startswith('__'):return Parameter.POSITIONAL_ONLY
		E=A.parent;C=_B
		for B in E.children:
			if C:
				if B=='/':return Parameter.POSITIONAL_ONLY
			else:
				if B=='*':return Parameter.KEYWORD_ONLY
				if B.type==_E:
					if B.star_count:return Parameter.KEYWORD_ONLY
					if B==A:C=_C
		return Parameter.POSITIONAL_OR_KEYWORD
	def infer(A):
		B=A.infer_annotation()
		if B:return B
		C=docstrings.infer_param(A.function_value,A._get_param_node());return C
class AnonymousParamName(_ActualTreeParamName):
	@plugin_manager.decorate(name='goto_anonymous_param')
	def goto(self):return super().goto()
	@plugin_manager.decorate(name='infer_anonymous_param')
	def infer(self):
		A=self;B=super().infer()
		if B:return B
		from jedi.inference.dynamic_params import dynamic_param_lookup as E;C=A._get_param_node();B=E(A.function_value,C.position_index)
		if B:return B
		if C.star_count==1:from jedi.inference.value.iterable import FakeTuple as F;D=F(A.function_value.inference_state,[])
		elif C.star_count==2:from jedi.inference.value.iterable import FakeDict as G;D=G(A.function_value.inference_state,{})
		elif C.default is _A:return NO_VALUES
		else:return A.function_value.parent_context.infer_node(C.default)
		return ValueSet({D})
class ParamName(_ActualTreeParamName):
	def __init__(A,function_value,tree_name,arguments):super().__init__(function_value,tree_name);A.arguments=arguments
	def infer(B):
		A=super().infer()
		if A:return A
		return B.get_executed_param_name().infer()
	def get_executed_param_name(A):from jedi.inference.param import get_executed_param_names as B;C=B(A.function_value,A.arguments);return C[A._get_param_node().position_index]
class ParamNameWrapper(_ParamMixin):
	def __init__(A,param_name):A._wrapped_param_name=param_name
	def __getattr__(A,name):return getattr(A._wrapped_param_name,name)
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A._wrapped_param_name)
class ImportName(AbstractNameDefinition):
	start_pos=1,0;_level=0
	def __init__(A,parent_context,string_name):A._from_module_context=parent_context;A.string_name=string_name
	def get_qualified_names(A,include_module_names=_B):
		if include_module_names:
			if A._level:
				assert A._level==1,'Everything else is not supported for now';B=A._from_module_context.string_names
				if B is _A:return B
				return B+(A.string_name,)
			return A.string_name,
		return()
	@property
	def parent_context(self):
		B=self._from_module_context;A=self.infer()
		if not A:return B
		return next(iter(A)).as_context()
	@memoize_method
	def infer(self):A=self;from jedi.inference.imports import Importer as C;B=A._from_module_context;return C(B.inference_state,[A.string_name],B,level=A._level).follow()
	def goto(A):return[A.name for A in A.infer()]
	@property
	def api_type(self):return _D
	def py__doc__(A):return _merge_name_docs(A.goto())
class SubModuleName(ImportName):_level=1
class NameWrapper:
	def __init__(A,wrapped_name):A._wrapped_name=wrapped_name
	def __getattr__(A,name):return getattr(A._wrapped_name,name)
	def __repr__(A):return'%s(%s)'%(A.__class__.__name__,A._wrapped_name)
class StubNameMixin:
	def py__doc__(A):
		from jedi.inference.gradual.conversion import convert_names as C;B=[A]
		if A.api_type==_F and'='in A.tree_name.get_definition().children:B=[A.name for A in A.infer()]
		B=C(B,prefer_stub_to_compiled=_B)
		if A in B:return super().py__doc__()
		else:return _merge_name_docs(B)
class StubName(StubNameMixin,TreeNameDefinition):
	def infer(A):
		B=super().infer()
		if A.string_name=='version_info'and A.get_root_context().py__name__()=='sys':from jedi.inference.gradual.stub_value import VersionInfo as C;return ValueSet(C(A)for A in B)
		return B
class ModuleName(ValueNameMixin,AbstractNameDefinition):
	start_pos=1,0
	def __init__(A,value,name):A._value=value;A._name=name
	@property
	def string_name(self):return self._name
class StubModuleName(StubNameMixin,ModuleName):0