_B=False
_A=True
from collections import defaultdict
from inspect import Parameter
from jedi import debug
from jedi.inference.utils import PushBackIterator
from jedi.inference import analysis
from jedi.inference.lazy_value import LazyKnownValue,LazyTreeValue,LazyUnknownValue
from jedi.inference.value import iterable
from jedi.inference.names import ParamName
def _add_argument_issue(error_name,lazy_value,message):
	B=lazy_value
	if isinstance(B,LazyTreeValue):
		A=B.data
		if A.parent.type=='argument':A=A.parent
		return analysis.add(B.context,error_name,A,message)
class ExecutedParamName(ParamName):
	def __init__(A,function_value,arguments,param_node,lazy_value,is_default=_B):super().__init__(function_value,param_node.name,arguments=arguments);A._lazy_value=lazy_value;A._is_default=is_default
	def infer(A):return A._lazy_value.infer()
	def matches_signature(A):
		if A._is_default:return _A
		C=A.infer().py__class__()
		if A.get_kind()in(Parameter.VAR_POSITIONAL,Parameter.VAR_KEYWORD):return _A
		B=A.infer_annotation(execute_annotation=_B)
		if not B:return _A
		D=any(A.is_sub_class_of(C)for A in C for C in B.gather_annotation_classes());debug.dbg('param compare %s: %s <=> %s',D,C,B,color='BLUE');return D
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A.string_name)
def get_executed_param_names_and_issues(function_value,arguments):
	"\n    Return a tuple of:\n      - a list of `ExecutedParamName`s corresponding to the arguments of the\n        function execution `function_value`, containing the inferred value of\n        those arguments (whether explicit or default)\n      - a list of the issues encountered while building that list\n\n    For example, given:\n    ```\n    def foo(a, b, c=None, d='d'): ...\n\n    foo(42, c='c')\n    ```\n\n    Then for the execution of `foo`, this will return a tuple containing:\n      - a list with entries for each parameter a, b, c & d; the entries for a,\n        c, & d will have their values (42, 'c' and 'd' respectively) included.\n      - a list with a single entry about the lack of a value for `b`\n    ";Y='type-error-too-few-arguments';J=function_value;G=arguments;D=None
	def U(argument):
		A=_error_argument_count(E,len(Q))
		if G.get_calling_nodes():H.append(_add_argument_issue('type-error-too-many-arguments',argument,message=A))
		else:H.append(D);debug.warning('non-public warning: %s',A)
	H=[];O=[];P={};E=J.tree_node;Z=J.get_default_param_context()
	for A in E.get_params():P[A.name.value]=A
	Q=list(G.unpack(E));L=PushBackIterator(iter(Q));M=defaultdict(lambda:[]);N={};R=_B;V=_B
	for A in E.get_params():
		W=_B;B,C=next(L,(D,D))
		while B is not D:
			R=_A
			try:a=P[B]
			except KeyError:M[B]=C
			else:
				if B in N:
					V=_A;I="TypeError: %s() got multiple values for keyword argument '%s'."%(E.name,B)
					for F in G.get_calling_nodes():H.append(analysis.add(F.context,'type-error-multiple-values',F.node,message=I))
				else:N[B]=ExecutedParamName(J,G,a,C)
			B,C=next(L,(D,D))
		try:O.append(N[A.name.value]);continue
		except KeyError:pass
		if A.star_count==1:
			S=[]
			if C is not D:
				S.append(C)
				for(B,C)in L:
					if B:L.push_back((B,C));break
					S.append(C)
			b=iterable.FakeTuple(J.inference_state,S);K=LazyKnownValue(b)
		elif A.star_count==2:
			if C is not D:U(C)
			c=iterable.FakeDict(J.inference_state,dict(M));K=LazyKnownValue(c);M={}
		elif C is D:
			if A.default is D:
				K=LazyUnknownValue()
				if not R:
					for F in G.get_calling_nodes():I=_error_argument_count(E,len(Q));H.append(analysis.add(F.context,Y,F.node,message=I))
			else:K=LazyTreeValue(Z,A.default);W=_A
		else:K=C
		O.append(ExecutedParamName(J,G,A,K,is_default=W))
		if not isinstance(K,LazyUnknownValue):N[A.name.value]=O[-1]
	if R:
		for d in set(P)-set(N):
			A=P[d]
			if not(M or V or A.star_count or A.default):
				for F in G.get_calling_nodes():I=_error_argument_count(E,len(Q));H.append(analysis.add(F.context,Y,F.node,message=I))
	for(B,T)in M.items():I="TypeError: %s() got an unexpected keyword argument '%s'."%(E.name,B);H.append(_add_argument_issue('type-error-keyword-argument',T,message=I))
	X=list(L)
	if X:e,T=X[0];U(T)
	return O,H
def get_executed_param_names(function_value,arguments):"\n    Return a list of `ExecutedParamName`s corresponding to the arguments of the\n    function execution `function_value`, containing the inferred value of those\n    arguments (whether explicit or default). Any issues building this list (for\n    example required arguments which are missing in the invocation) are ignored.\n\n    For example, given:\n    ```\n    def foo(a, b, c=None, d='d'): ...\n\n    foo(42, c='c')\n    ```\n\n    Then for the execution of `foo`, this will return a list containing entries\n    for each parameter a, b, c & d; the entries for a, c, & d will have their\n    values (42, 'c' and 'd' respectively) included.\n    ";return get_executed_param_names_and_issues(function_value,arguments)[0]
def _error_argument_count(funcdef,actual_count):
	B=funcdef;A=B.get_params();C=sum(1 for A in A if A.default or A.star_count)
	if C==0:D='exactly '
	else:D='from %s to '%(len(A)-C)
	return'TypeError: %s() takes %s%s arguments (%s given).'%(B.name,D,len(A),actual_count)