_B=False
_A=None
import os,re
from parso import python_bytes_to_unicode
from jedi.debug import dbg
from jedi.file_io import KnownContentFileIO,FolderIO
from jedi.inference.names import SubModuleName
from jedi.inference.imports import load_module_from_path
from jedi.inference.filters import ParserTreeFilter
from jedi.inference.gradual.conversion import convert_names
_IGNORE_FOLDERS='.tox','.venv','.mypy_cache','venv','__pycache__'
_OPENED_FILE_LIMIT=2000
"\nStats from a 2016 Lenovo Notebook running Linux:\nWith os.walk, it takes about 10s to scan 11'000 files (without filesystem\ncaching). Once cached it only takes 5s. So it is expected that reading all\nthose files might take a few seconds, but not a lot more.\n"
_PARSED_FILE_LIMIT=30
'\nFor now we keep the amount of parsed files really low, since parsing might take\neasily 100ms for bigger files.\n'
def _resolve_names(definition_names,avoid_names=()):
	B=definition_names
	for A in B:
		if A in avoid_names:continue
		if not isinstance(A,SubModuleName):yield A
		if A.api_type=='module':yield from _resolve_names(A.goto(),B)
def _dictionarize(names):return dict((A if A.tree_name is _A else A.tree_name,A)for A in names)
def _find_defining_names(module_context,tree_name):
	C=tree_name;B=_find_names(module_context,C)
	for A in list(B):B|=set(convert_names([A],only_stubs=not A.get_root_context().is_stub(),prefer_stub_to_compiled=_B))
	B|=set(_find_global_variables(B,C.value))
	for A in list(B):
		if A.api_type=='param'or A.tree_name is _A or A.tree_name.parent.type=='trailer':continue
		B|=set(_add_names_in_same_context(A.parent_context,A.string_name))
	return set(_resolve_names(B))
def _find_names(module_context,tree_name):A=module_context.create_name(tree_name);B=set(A.goto());B.add(A);return set(_resolve_names(B))
def _add_names_in_same_context(context,string_name):
	B=context
	if B.tree_node is _A:return
	C=_A
	while True:
		D=ParserTreeFilter(parent_context=B,until_position=C);A=set(D.get(string_name))
		if not A:break
		yield from A;E=sorted(A,key=lambda x:x.start_pos);C=E[0].start_pos
def _find_global_variables(names,search_name):
	for B in names:
		if B.tree_name is _A:continue
		C=B.get_root_context()
		try:D=C.get_global_filter
		except AttributeError:continue
		else:
			for A in D().get(search_name):yield A;E=C.create_context(A.tree_name);yield from _add_names_in_same_context(E,A.string_name)
def find_references(module_context,tree_name,only_in_module=_B):
	G=only_in_module;B=tree_name;A=module_context;D=A.inference_state;K=B.value
	try:D.flow_analysis_enabled=_B;H=_find_defining_names(A,B)
	finally:D.flow_analysis_enabled=True
	E=_dictionarize(H);I=[A]
	if not G:
		for F in set(A.get_root_context()for A in H):
			if F!=A and F.tree_node is not _A and D.project.path in F.py__file__().parents:I.append(F)
	if G or any(A.api_type=='param'for A in H):L=I
	else:L=get_module_contexts_containing_name(D,I,K)
	J={}
	for A in L:
		for N in A.tree_node.get_used_names().get(K,[]):
			C=_dictionarize(_find_names(A,N))
			if any(A in E for A in C):
				E.update(C)
				for B in C:
					for O in J.get(B,[]):E.update(O)
					try:del J[B]
					except KeyError:pass
			else:
				for P in C:J.setdefault(P,[]).append(C)
	M=E.values()
	if G:return[B for B in M if B.get_root_context()==A]
	return M
def _check_fs(inference_state,file_io,regex):
	B=file_io
	try:A=B.read()
	except FileNotFoundError:return
	A=python_bytes_to_unicode(A,errors='replace')
	if not regex.search(A):return
	D=KnownContentFileIO(B.path,A);C=load_module_from_path(inference_state,D)
	if C.is_compiled():return
	return C.as_context()
def gitignored_paths(folder_io,file_io):
	E=folder_io;D='/';F=set();G=set()
	for A in file_io.read().splitlines():
		if not A or A.startswith(b'#')or A.startswith(b'!')or b'*'in A:continue
		B=A.decode('utf-8','ignore').rstrip(D)
		if D in B:C=B.lstrip(D);F.add(os.path.join(E.path,C))
		else:C=B;G.add((E.path,C))
	return F,G
def expand_relative_ignore_paths(folder_io,relative_paths):A=folder_io.path;return{os.path.join(A,B[1])for B in relative_paths if A.startswith(B[0])}
def recurse_find_python_folders_and_files(folder_io,except_paths=()):
	B=folder_io;A=except_paths;A=set(A);F=set()
	for(G,C,H)in B.walk():
		for D in H:
			E=D.path
			if E.suffix in('.py','.pyi'):
				if E not in A:yield(_A,D)
			if E.name=='.gitignore':I,J=gitignored_paths(G,D);A|=I;F|=J
		K=expand_relative_ignore_paths(G,F);C[:]=[B for B in C if B.path not in A and B.path not in K and B.get_base_name()not in _IGNORE_FOLDERS]
		for B in C:yield(B,_A)
def recurse_find_python_files(folder_io,except_paths=()):
	A=folder_io
	for(A,B)in recurse_find_python_folders_and_files(A,except_paths):
		if B is not _A:yield B
def _find_python_files_in_sys_path(inference_state,module_contexts):
	E=module_contexts;F=inference_state.get_sys_path();C=set();G=[A.py__file__()for A in E]
	for H in E:
		A=H.get_value().file_io
		if A is _A:continue
		B=A.get_parent_folder()
		while True:
			D=B.path
			if not any(D.startswith(A)for A in F)or D in C:break
			for A in recurse_find_python_files(B,C):
				if A.path not in G:yield A
			C.add(D);B=B.get_parent_folder()
def _find_project_modules(inference_state,module_contexts):A=[A.py__file__()for A in module_contexts];yield from recurse_find_python_files(FolderIO(inference_state.project.path),A)
def get_module_contexts_containing_name(inference_state,module_contexts,name,limit_reduction=1):
	'\n    Search a name in the directories of modules.\n\n    :param limit_reduction: Divides the limits on opening/parsing files by this\n        factor.\n    ';B=module_contexts;A=inference_state
	for C in B:
		if C.is_compiled():continue
		yield C
	if len(name)<=2:return
	D=_find_project_modules(A,B);yield from search_in_file_ios(A,D,name,limit_reduction=limit_reduction)
def search_in_file_ios(inference_state,file_io_iterator,name,limit_reduction=1,complete=_B):
	G='\\b';A=limit_reduction;B=_PARSED_FILE_LIMIT/A;C=_OPENED_FILE_LIMIT/A;D=0;E=0;H=re.compile(G+re.escape(name)+(''if complete else G))
	for I in file_io_iterator:
		D+=1;F=_check_fs(inference_state,I,H)
		if F is not _A:
			E+=1;yield F
			if E>=B:dbg('Hit limit of parsed files: %s',B);break
		if D>=C:dbg('Hit limit of opened files: %s',C);break