_C=None
_B=True
_A=False
from inspect import Parameter
from jedi.cache import memoize_method
from jedi import debug
from jedi import parser_utils
class _SignatureMixin:
	def to_string(C):
		def D():
			A=_A;D=_A
			for E in C.get_param_names(resolve_stars=_B):
				B=E.get_kind();A|=B==Parameter.POSITIONAL_ONLY
				if A and B!=Parameter.POSITIONAL_ONLY:yield'/';A=_A
				if B==Parameter.VAR_POSITIONAL:D=_B
				elif B==Parameter.KEYWORD_ONLY and not D:yield'*';D=_B
				yield E.to_string()
			if A:yield'/'
		A=C.name.string_name+'('+', '.join(D())+')';B=C.annotation_string
		if B:A+=' -> '+B
		return A
class AbstractSignature(_SignatureMixin):
	def __init__(A,value,is_bound=_A):A.value=value;A.is_bound=is_bound
	@property
	def name(self):return self.value.name
	@property
	def annotation_string(self):return''
	def get_param_names(A,resolve_stars=_A):
		B=A._function_value.get_param_names()
		if A.is_bound:return B[1:]
		return B
	def bind(A,value):raise NotImplementedError
	def matches_signature(A,arguments):return _B
	def __repr__(A):
		if A.value is A._function_value:return'<%s: %s>'%(A.__class__.__name__,A.value)
		return'<%s: %s, %s>'%(A.__class__.__name__,A.value,A._function_value)
class TreeSignature(AbstractSignature):
	def __init__(B,value,function_value=_C,is_bound=_A):A=value;super().__init__(A,is_bound);B._function_value=function_value or A
	def bind(A,value):return TreeSignature(value,A._function_value,is_bound=_B)
	@property
	def _annotation(self):
		if self.value.is_class():return
		return self._function_value.tree_node.annotation
	@property
	def annotation_string(self):
		A=self._annotation
		if A is _C:return''
		return A.get_code(include_prefix=_A)
	@memoize_method
	def get_param_names(self,resolve_stars=_A):
		A=self._function_value.get_param_names()
		if resolve_stars:from jedi.inference.star_args import process_params as B;A=B(A)
		if self.is_bound:return A[1:]
		return A
	def matches_signature(C,arguments):
		F='BLUE';A=arguments;from jedi.inference.param import get_executed_param_names_and_issues as G;H,I=G(C._function_value,A)
		if I:return _A
		D=all(A.matches_signature()for A in H)
		if debug.enable_notice:
			B=C._function_value.tree_node;E=parser_utils.get_signature(B)
			if D:debug.dbg('Overloading match: %s@%s (%s)',E,B.start_pos[0],A,color=F)
			else:debug.dbg('Overloading no match: %s@%s (%s)',E,B.start_pos[0],A,color=F)
		return D
class BuiltinSignature(AbstractSignature):
	def __init__(A,value,return_string,function_value=_C,is_bound=_A):super().__init__(value,is_bound);A._return_string=return_string;A.__function_value=function_value
	@property
	def annotation_string(self):return self._return_string
	@property
	def _function_value(self):
		A=self
		if A.__function_value is _C:return A.value
		return A.__function_value
	def bind(A,value):return BuiltinSignature(value,A._return_string,function_value=A.value,is_bound=_B)
class SignatureWrapper(_SignatureMixin):
	def __init__(A,wrapped_signature):A._wrapped_signature=wrapped_signature
	def __getattr__(A,name):return getattr(A._wrapped_signature,name)