'\nThis module is responsible for inferring *args and **kwargs for signatures.\n\nThis means for example in this case::\n\n    def foo(a, b, c): ...\n\n    def bar(*args):\n        return foo(1, *args)\n\nThe signature here for bar should be `bar(b, c)` instead of bar(*args).\n'
_B=False
_A=None
from inspect import Parameter
from parso import tree
from jedi.inference.utils import to_list
from jedi.inference.names import ParamNameWrapper
from jedi.inference.helpers import is_big_annoying_library
def _iter_nodes_for_param(param_name):
	A=param_name;from parso.python.tree import search_ancestor as H;from jedi.inference.arguments import TreeArguments as I;G=A.parent_context;C=tree.search_ancestor(A.tree_name,'funcdef','lambdef');J=C.get_root_node();K=C.children[-1].start_pos;L=C.children[-1].end_pos
	for D in J.get_used_names().get(A.string_name):
		if K<=D.start_pos<L:
			E=D.parent
			if E.type=='argument'and E.children[0]=='*'*A.star_count:
				B=H(E,'trailer')
				if B is not _A:
					F=G.create_context(B)
					if _goes_to_param_name(A,F,D):
						M=_to_callables(F,B);N=I.create_cached(G.inference_state,context=F,argument_node=B.children[1],trailer=B)
						for O in M:yield(O,N)
def _goes_to_param_name(param_name,context,potential_name):
	B=potential_name;A=param_name
	if B.type!='name':return _B
	from jedi.inference.names import TreeNameDefinition as C;D=C(context,B).goto();return any(A.parent_context==B.parent_context and A.start_pos==B.start_pos for B in D)
def _to_callables(context,trailer):
	D=trailer;C=context;from jedi.inference.syntax_tree import infer_trailer as G;A=D.parent;E=A.children[0]=='await';B=C.infer_node(A.children[E])
	for F in A.children[E+1:]:
		if D==F:break
		B=G(C,B,F)
	return B
def _remove_given_params(arguments,param_names):
	B=0;C=set()
	for(D,E)in arguments.unpack():
		if D is _A:B+=1
		else:C.add(D)
	for A in param_names:
		if B and A.maybe_positional_argument():B-=1;continue
		if A.string_name in C and A.maybe_keyword_argument():continue
		yield A
@to_list
def process_params(param_names,star_count=3):
	T=True;D=param_names;B=star_count
	if D:
		if is_big_annoying_library(D[0].parent_context):yield from D;return
	E=set();U=[];F=[];C=[];G=[];H=[];I=_A;J=_A
	for A in D:
		K=A.get_kind()
		if K==Parameter.VAR_POSITIONAL:
			if B&1:U=_iter_nodes_for_param(A);I=A
		elif A.get_kind()==Parameter.VAR_KEYWORD:
			if B&2:F=list(_iter_nodes_for_param(A));J=A
		elif K==Parameter.KEYWORD_ONLY:
			if B&2:C.append(A)
		elif K==Parameter.POSITIONAL_ONLY:
			if B&1:yield A
		elif B==1:yield ParamNameFixedKind(A,Parameter.POSITIONAL_ONLY)
		elif B==2:C.append(ParamNameFixedKind(A,Parameter.KEYWORD_ONLY))
		else:E.add(A.string_name);yield A
	L=();V=_B;M=_B
	for N in U:
		O,P=N;Q=B
		if N in F:F.remove(N)
		else:Q=1
		for R in O.get_signatures():
			V=T
			if Q==3:M=T
			S=[]
			for A in process_params(list(_remove_given_params(P,R.get_param_names(resolve_stars=_B))),Q):
				if A.get_kind()==Parameter.VAR_KEYWORD:G.append(A)
				elif A.get_kind()==Parameter.VAR_POSITIONAL:H.append(A)
				elif A.get_kind()==Parameter.KEYWORD_ONLY:C.append(A)
				else:S.append(A)
			if len(S)>len(L):L=S
	for A in L:
		if B==1 and A.get_kind()!=Parameter.VAR_POSITIONAL:yield ParamNameFixedKind(A,Parameter.POSITIONAL_ONLY)
		else:
			if A.get_kind()==Parameter.POSITIONAL_OR_KEYWORD:E.add(A.string_name)
			yield A
	if not V and I is not _A:yield I
	elif H:yield H[0]
	for(O,P)in F:
		for R in O.get_signatures():
			M=T
			for A in process_params(list(_remove_given_params(P,R.get_param_names(resolve_stars=_B))),star_count=2):
				if A.get_kind()==Parameter.VAR_KEYWORD:G.append(A)
				elif A.get_kind()==Parameter.KEYWORD_ONLY:C.append(A)
	for A in C:
		if A.string_name in E:continue
		yield A;E.add(A.string_name)
	if not M and J is not _A:yield J
	elif G:yield G[0]
class ParamNameFixedKind(ParamNameWrapper):
	def __init__(A,param_name,new_kind):super().__init__(param_name);A._new_kind=new_kind
	def get_kind(A):return A._new_kind