'\nFunctions inferring the syntax tree.\n'
_U='classdef'
_T='sync_comp_for'
_S='comp_for'
_R='namedexpr_test'
_Q='operator'
_P='atom_expr'
_O='fstring'
_N='strings'
_M='number'
_L='funcdef'
_K='param'
_J='annassign'
_I='lambdef'
_H='keyword'
_G='name'
_F='if_stmt'
_E='for_stmt'
_D='expr_stmt'
_C=True
_B=False
_A=None
import copy,itertools
from parso.python import tree
from jedi import debug
from jedi import parser_utils
from jedi.inference.base_value import ValueSet,NO_VALUES,ContextualizedNode,iterator_to_value_set,iterate_values
from jedi.inference.lazy_value import LazyTreeValue
from jedi.inference import compiled
from jedi.inference import recursion
from jedi.inference import analysis
from jedi.inference import imports
from jedi.inference import arguments
from jedi.inference.value import ClassValue,FunctionValue
from jedi.inference.value import iterable
from jedi.inference.value.dynamic_arrays import ListModification,DictModification
from jedi.inference.value import TreeInstance
from jedi.inference.helpers import is_string,is_literal,is_number,get_names_of_node,is_big_annoying_library
from jedi.inference.compiled.access import COMPARISON_OPERATORS
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.gradual.stub_value import VersionInfo
from jedi.inference.gradual import annotation
from jedi.inference.names import TreeNameDefinition
from jedi.inference.context import CompForContext
from jedi.inference.value.decorator import Decoratee
from jedi.plugins import plugin_manager
operator_to_magic_method={'+':'__add__','-':'__sub__','*':'__mul__','@':'__matmul__','/':'__truediv__','//':'__floordiv__','%':'__mod__','**':'__pow__','<<':'__lshift__','>>':'__rshift__','&':'__and__','|':'__or__','^':'__xor__'}
reverse_operator_to_magic_method={A:'__r'+B[2:]for(A,B)in operator_to_magic_method.items()}
def _limit_value_infers(func):
	"\n    This is for now the way how we limit type inference going wild. There are\n    other ways to ensure recursion limits as well. This is mostly necessary\n    because of instance (self) access that can be quite tricky to limit.\n\n    I'm still not sure this is the way to go, but it looks okay for now and we\n    can still go anther way in the future. Tests are there. ~ dave\n    "
	def A(context,*E,**F):
		A=context;B=A.tree_node;C=A.inference_state
		try:
			C.inferred_element_counts[B]+=1;D=300
			if A.parent_context is _A and A.get_value()is C.builtins_module:D*=100
			if C.inferred_element_counts[B]>D:debug.warning('In value %s there were too many inferences.',B);return NO_VALUES
		except KeyError:C.inferred_element_counts[B]=1
		return func(A,*E,**F)
	return A
def infer_node(context,element):
	C=element;B=context
	if isinstance(B,CompForContext):return _infer_node(B,C)
	A=C
	while A is not _A:
		A=A.parent
		if A.type in(_F,_E):break
		if parser_utils.is_scope(A):A=_A;break
	I=B.predefined_names.get(A)
	if I is _A and A and A.type==_F and B.inference_state.is_analysis:
		J=A.children[1];D=[{}]
		if C.start_pos>J.end_pos:
			K=get_names_of_node(J);N=get_names_of_node(C);O=[A.value for A in N]
			if any(A.value in O for A in K):
				for H in K:
					F=B.inference_state.infer(B,H)
					if len(F)>1:
						if len(D)*len(F)>16:debug.dbg('Too many options for if branch inference %s.',A);D=[{}];break
						P=list(D);D=[]
						for Q in F:
							G=list(P)
							for(L,E)in enumerate(G):G[L]=E.copy();G[L][H.value]=ValueSet([Q])
							D+=G
					else:
						for E in D:E[H.value]=F
		if len(D)>1:
			M=NO_VALUES
			for E in D:
				with B.predefine_names(A,E):M|=_infer_node(B,C)
			return M
		else:return _infer_node_if_inferred(B,C)
	elif I:return _infer_node(B,C)
	else:return _infer_node_if_inferred(B,C)
def _infer_node_if_inferred(context,element):
	'\n    TODO This function is temporary: Merge with infer_node.\n    ';C=element;B=context;A=C
	while A is not _A:
		A=A.parent;D=B.predefined_names.get(A)
		if D is not _A:return _infer_node(B,C)
	return _infer_node_cached(B,C)
@inference_state_method_cache(default=NO_VALUES)
def _infer_node_cached(context,element):return _infer_node(context,element)
@debug.increase_indent
@_limit_value_infers
def _infer_node(context,element):
	B=context;A=element;debug.dbg('infer_node %s@%s in %s',A,A.start_pos,B);H=B.inference_state;D=A.type
	if D in(_G,_M,'string','atom',_N,_H,_O):return infer_atom(B,A)
	elif D==_I:return ValueSet([FunctionValue.from_context(B,A)])
	elif D==_D:return infer_expr_stmt(B,A)
	elif D in('power',_P):
		E=A.children[0];F=A.children[1:];I=_B
		if E.type==_H and E.value=='await':I=_C;E=F.pop(0)
		C=B.infer_node(E)
		for(J,G)in enumerate(F):
			if G=='**':K=B.infer_node(F[J+1]);C=_infer_comparison(B,C,G,K);break
			C=infer_trailer(B,C,G)
		if I:return C.py__await__().py__stop_iteration_returns()
		return C
	elif D in('testlist_star_expr','testlist'):return ValueSet([iterable.SequenceLiteralValue(H,B,A)])
	elif D in('not_test','factor'):
		C=B.infer_node(A.children[-1])
		for L in A.children[:-1]:C=infer_factor(C,L)
		return C
	elif D=='test':return B.infer_node(A.children[0])|B.infer_node(A.children[-1])
	elif D==_Q:
		if A.value!='...':M=A.parent;raise AssertionError('unhandled operator %s in %s '%(repr(A.value),M))
		return ValueSet([compiled.builtin_from_name(H,'Ellipsis')])
	elif D=='dotted_name':
		C=infer_atom(B,A.children[0])
		for N in A.children[2::2]:C=C.py__getattribute__(N,name_context=B)
		return C
	elif D=='eval_input':return B.infer_node(A.children[0])
	elif D==_J:return annotation.infer_annotation(B,A.children[1]).execute_annotation()
	elif D=='yield_expr':
		if len(A.children)and A.children[1].type=='yield_arg':A=A.children[1].children[1];O=B.infer_node(A).py__getattribute__('__iter__').execute_with_values();return O.py__stop_iteration_returns()
		return NO_VALUES
	elif D==_R:return B.infer_node(A.children[2])
	else:return infer_or_test(B,A)
def infer_trailer(context,atom_values,trailer):
	E=atom_values;C=trailer;B=context;D,A=C.children[:2]
	if A==')':A=_A
	if D=='[':D,A,G=C.children;return E.get_item(_infer_subscript_list(B,A),ContextualizedNode(B,C))
	else:
		debug.dbg('infer_trailer: %s in %s',C,E)
		if D=='.':return E.py__getattribute__(name_context=B,name_or_str=A)
		else:assert D=='(','trailer_op is actually %s'%D;F=arguments.TreeArguments(B.inference_state,B,A,C);return E.execute(F)
def infer_atom(context,atom):
	"\n    Basically to process ``atom`` nodes. The parser sometimes doesn't\n    generate the node (because it has just one child). In that case an atom\n    might be a name or a literal as well.\n    ";B=context;A=atom;D=B.inference_state
	if A.type==_G:
		E=tree.search_ancestor(A,_D,_I,_F)or A
		if E.type==_F:
			if not any(B.start_pos<=A.start_pos<B.end_pos for B in E.get_test_nodes()):E=A
		elif E.type==_I:E=A
		J=E.start_pos
		if _is_annotation_name(A):J=_A
		return B.py__getattribute__(A,position=J)
	elif A.type==_H:
		if A.value in('False','True','None'):return ValueSet([compiled.builtin_from_name(D,A.value)])
		elif A.value=='yield':return NO_VALUES
		assert _B,'Cannot infer the keyword %s'%A
	elif isinstance(A,tree.Literal):F=D.compiled_subprocess.safe_literal_eval(A.value);return ValueSet([compiled.create_simple_object(D,F)])
	elif A.type==_N:
		G=infer_atom(B,A.children[0])
		for F in A.children[1:]:M=infer_atom(B,F);G=_infer_comparison(B,G,'+',M)
		return G
	elif A.type==_O:return compiled.get_string_value_set(D)
	else:
		C=A.children
		if C[0]=='('and not len(C)==2 and not(C[1].type=='testlist_comp'and len(C[1].children)>1):return B.infer_node(C[1])
		try:H=C[1].children[1]
		except(IndexError,AttributeError):pass
		else:
			if H==':':
				try:H=C[1].children[3]
				except IndexError:pass
			if H.type in(_S,_T):return ValueSet([iterable.comprehension_from_atom(D,B,A)])
		K=C[1]
		try:I=K.children
		except AttributeError:I=[]
		if C[0]=='{'and(K=='}'or':'in I or'**'in I):L=iterable.DictLiteralValue(D,B,A)
		else:L=iterable.SequenceLiteralValue(D,B,A)
		return ValueSet([L])
@_limit_value_infers
def infer_expr_stmt(context,stmt,seek_name=_A):
	C=seek_name;B=stmt;A=context
	with recursion.execution_allowed(A.inference_state,B)as E:
		if E:
			if C is not _A:
				D=annotation.find_type_from_comment_hint_assign(A,B,C)
				if D:return D
			return _infer_expr_stmt(A,B,C)
	return NO_VALUES
@debug.increase_indent
def _infer_expr_stmt(context,stmt,seek_name=_A):
	"\n    The starting point of the completion. A statement always owns a call\n    list, which are the calls, that a statement does. In case multiple\n    names are defined in the statement, `seek_name` returns the result for\n    this name.\n\n    expr_stmt: testlist_star_expr (annassign | augassign (yield_expr|testlist) |\n                     ('=' (yield_expr|testlist_star_expr))*)\n    annassign: ':' test ['=' test]\n    augassign: ('+=' | '-=' | '*=' | '@=' | '/=' | '%=' | '&=' | '|=' | '^=' |\n                '<<=' | '>>=' | '**=' | '//=')\n\n    :param stmt: A `tree.ExprStmt`.\n    ";G=seek_name;C=stmt;B=context
	def L(stmt):
		A=stmt.children[0]
		if A.type not in(_P,'power'):return _B,_A
		C=A.children[0]
		if C.type!=_G or len(A.children)!=2:return _B,_A
		B=A.children[-1];return B.children[0]=='[',B.children[1]
	debug.dbg('infer_expr_stmt %s (%s)',C,G);I=C.get_rhs();A=B.infer_node(I)
	if G:M=TreeNameDefinition(B,G);A=check_tuple_assignments(M,A)
	H=next(C.yield_operators(),_A);J,N=L(C);O=H not in('=',_A)and H.type==_Q
	if O or J:
		P=C.get_defined_names(include_setitem=_C)[0].value;E=B.py__getattribute__(P,position=C.start_pos)
		if J:
			def Q(v):
				C=ContextualizedSubscriptListNode(B,N)
				if v.array_type=='dict':return DictModification(v,A,C)
				elif v.array_type=='list':return ListModification(v,A,C)
				return v
			A=ValueSet(Q(A)for A in E)
		else:
			F=copy.copy(H);F.value=F.value[:-1];D=tree.search_ancestor(C,_E)
			if D is not _A and D.type==_E and A and parser_utils.for_stmt_defines_one_name(D):
				R=D.get_testlist();K=ContextualizedNode(B,R);S=list(K.infer().iterate(K))
				for T in S:
					U={D.children[1].value:T.infer()}
					with B.predefine_names(D,U):V=B.infer_node(I);E=_infer_comparison(B,E,F,V)
				A=E
			else:A=_infer_comparison(B,E,F,A)
	debug.dbg('infer_expr_stmt result %s',A);return A
def infer_or_test(context,or_test):
	F='and';C=context;D=iter(or_test.children);A=C.infer_node(next(D))
	for B in D:
		E=next(D)
		if B.type=='comp_op':B=' '.join(A.value for A in B.children)
		if B in(F,'or'):
			G=set(A.py__bool__()for A in A)
			if G=={_C}:
				if B==F:A=C.infer_node(E)
			elif G=={_B}:
				if B!=F:A=C.infer_node(E)
		else:A=_infer_comparison(C,A,B,C.infer_node(E))
	debug.dbg('infer_or_test types %s',A);return A
@iterator_to_value_set
def infer_factor(value_set,operator):
	'\n    Calculates `+`, `-`, `~` and `not` prefixes.\n    ';B=operator
	for A in value_set:
		if B=='-':
			if is_number(A):yield A.negate()
		elif B=='not':
			C=A.py__bool__()
			if C is _A:return
			yield compiled.create_simple_object(A.inference_state,not C)
		else:yield A
def _literals_to_types(inference_state,result):
	A=NO_VALUES
	for B in result:
		if is_literal(B):C=compiled.builtin_from_name(inference_state,B.name.string_name);A|=C.execute_with_values()
		else:A|=ValueSet([B])
	return A
def _infer_comparison(context,left_values,operator,right_values):
	E=context;C=operator;B=right_values;A=left_values;D=E.inference_state
	if isinstance(C,str):F=C
	else:F=str(C.value)
	if not A or not B:G=(A or NO_VALUES)|(B or NO_VALUES);return _literals_to_types(D,G)
	elif F=='|'and all(A.is_class()or A.is_compiled()for A in itertools.chain(A,B)):return ValueSet.from_sets((A,B))
	elif len(A)*len(B)>6:return _literals_to_types(D,A|B)
	else:return ValueSet.from_sets(_infer_comparison_part(D,E,A,C,F)for A in A for F in B)
def _is_annotation_name(name):
	C=name;A=tree.search_ancestor(C,_K,_L,_D)
	if A is _A:return _B
	if A.type in(_K,_L):
		D=A.annotation
		if D is not _A:return D.start_pos<=C.start_pos<D.end_pos
	elif A.type==_D:
		B=A.children
		if len(B)>1 and B[1].type==_J:return B[1].start_pos<=C.start_pos<B[1].end_pos
	return _B
def _is_list(value):return value.array_type=='list'
def _is_tuple(value):return value.array_type=='tuple'
def _bool_to_value(inference_state,bool_):return compiled.builtin_from_name(inference_state,str(bool_))
def _get_tuple_ints(value):
	A=value
	if not isinstance(A,iterable.SequenceLiteralValue):return
	B=[]
	for C in A.py__iter__():
		if not isinstance(C,LazyTreeValue):return
		D=C.data
		if D.type!=_M:return
		try:B.append(int(D.value))
		except ValueError:return
	return B
def _infer_comparison_part(inference_state,context,left,operator,right):
	F=operator;E=inference_state;B=right;A=left;H=is_number(A);I=is_number(B)
	if isinstance(F,str):C=F
	else:C=str(F.value)
	if C=='*':
		if isinstance(A,iterable.Sequence)or is_string(A):return ValueSet([A])
		elif isinstance(B,iterable.Sequence)or is_string(B):return ValueSet([B])
	elif C=='+':
		if H and I or is_string(A)and is_string(B):return A.execute_operation(B,C)
		elif _is_list(A)and _is_list(B)or _is_tuple(A)and _is_tuple(B):return ValueSet([iterable.MergedArray(E,(A,B))])
	elif C=='-':
		if H and I:return A.execute_operation(B,C)
	elif C=='%':return ValueSet([A])
	elif C in COMPARISON_OPERATORS:
		if A.is_compiled()and B.is_compiled():
			D=A.execute_operation(B,C)
			if D:return D
		else:
			if C in('is','!=','==','is not'):
				M=COMPARISON_OPERATORS[C];J=M(A,B)
				if(C in('is','=='))==J:return ValueSet([_bool_to_value(E,J)])
			if isinstance(A,VersionInfo):
				K=_get_tuple_ints(B)
				if K is not _A:N=compiled.access.COMPARISON_OPERATORS[F](E.environment.version_info,tuple(K));return ValueSet([_bool_to_value(E,N)])
		return ValueSet([_bool_to_value(E,_C),_bool_to_value(E,_B)])
	elif C in('in','not in'):return NO_VALUES
	def L(obj):'Checks if a Jedi object is either a float or an int.';return isinstance(obj,TreeInstance)and obj.name.string_name in('int','float')
	if C in('+','-')and H!=I and not(L(A)or L(B)):O='TypeError: unsupported operand type(s) for +: %s and %s';analysis.add(context,'type-error-operation',F,O%(A,B))
	if A.is_class()or B.is_class():return NO_VALUES
	P=operator_to_magic_method[C];G=A.py__getattribute__(P)
	if G:
		D=G.execute_with_values(B)
		if D:return D
	if not G:
		Q=reverse_operator_to_magic_method[C];G=B.py__getattribute__(Q);D=G.execute_with_values(A)
		if D:return D
	D=ValueSet([A,B]);debug.dbg('Used operator %s resulting in %s',F,D);return D
@plugin_manager.decorate()
def tree_name_to_values(inference_state,context,tree_name):
	S='async_stmt';R='with_stmt';Q='import_name';P='import_from';C=tree_name;A=context;J=NO_VALUES;K=A.get_root_context().tree_node
	if K is not _A:
		G=K.get_used_names().get(C.value,[]);L=_B
		for M in G:
			H=M.parent
			if H.type==_D and H.children[1].type==_J:
				T=parser_utils.get_parent_scope(M)==A.tree_node
				if T:L=_C;J|=annotation.infer_annotation(A,H.children[1].children[1]).execute_annotation()
		if L:return J
	B=[];D=C.get_definition(import_name_always=_C,include_setitem=_C)
	if D is _A:
		D=C.parent
		if D.type=='global_stmt':
			F=A.create_context(C)
			if F.is_module():return NO_VALUES
			filter=next(F.get_filters());G=filter.get(C.value);return ValueSet.from_sets(A.infer()for A in G)
		elif D.type not in(P,Q):F=A.create_context(C);return infer_atom(F,C)
	E=D.type
	if E==_E:
		B=annotation.find_type_from_comment_hint_for(A,D,C)
		if B:return B
	if E==R:
		B=annotation.find_type_from_comment_hint_with(A,D,C)
		if B:return B
	if E in(_E,_S,_T):
		try:B=A.predefined_names[D][C.value]
		except KeyError:N=ContextualizedNode(A,D.children[3]);U=iterate_values(N.infer(),contextualized_node=N,is_async=D.parent.type==S);V=TreeNameDefinition(A,C);B=check_tuple_assignments(V,U)
	elif E==_D:B=infer_expr_stmt(A,D,C)
	elif E==R:
		O=A.infer_node(D.get_test_node_from_name(C))
		if D.parent.type==S:I=O.py__getattribute__('__aenter__');W=I.execute_with_values();return W.py__await__().py__stop_iteration_returns()
		I=O.py__getattribute__('__enter__');return I.execute_with_values()
	elif E in(P,Q):B=imports.infer_import(A,C)
	elif E in(_L,_U):B=_apply_decorators(A,D)
	elif E=='try_stmt':X=A.infer_node(C.get_previous_sibling().get_previous_sibling());B=X.execute_with_values()
	elif E==_K:B=NO_VALUES
	elif E=='del_stmt':B=NO_VALUES
	elif E==_R:B=infer_node(A,D)
	else:raise ValueError('Should not happen. type: %s'%E)
	return B
@inference_state_method_cache()
def _apply_decorators(context,node):
	'\n    Returns the function, that should to be executed in the end.\n    This is also the places where the decorators are processed.\n    ';J='MAGENTA';C=node;B=context
	if C.type==_U:F=ClassValue(B.inference_state,parent_context=B,tree_node=C)
	else:F=FunctionValue.from_context(B,C)
	G=A=ValueSet([F])
	if is_big_annoying_library(B):return A
	for D in reversed(C.get_decorators()):
		debug.dbg('decorator: %s %s',D,A,color=J)
		with debug.increase_indent_cm():
			E=B.infer_node(D.children[1]);H=D.children[2:-1]
			if H:I=tree.PythonNode('trailer',H);I.parent=D;E=infer_trailer(B,E,I)
			if not len(E):
				K=D.get_code(include_prefix=_B)
				if K!='@runtime\n':debug.warning('decorator not found: %s on %s',D,C)
				return G
			A=E.execute(arguments.ValuesArguments([A]))
			if not len(A):debug.warning('not possible to resolve wrappers found %s',C);return G
		debug.dbg('decorator end %s',A,color=J)
	if A!=G:return ValueSet([Decoratee(A,F)for A in A])
	return A
def check_tuple_assignments(name,value_set):
	'\n    Checks if tuples are assigned.\n    ';A=value_set;B=_A
	for(C,E)in name.assignment_indexes():
		F=ContextualizedNode(name.parent_context,E);G=A.iterate(F)
		if isinstance(C,slice):return NO_VALUES
		D=0
		while D<=C:
			try:B=next(G)
			except StopIteration:return NO_VALUES
			else:D+=B.max
		A=B.infer()
	return A
class ContextualizedSubscriptListNode(ContextualizedNode):
	def infer(A):return _infer_subscript_list(A.context,A.node)
def _infer_subscript_list(context,index):
	'\n    Handles slices in subscript nodes.\n    ';C=context;A=index
	if A==':':return ValueSet([iterable.Slice(C,_A,_A,_A)])
	elif A.type=='subscript'and not A.children[0]=='.':
		B=[]
		for D in A.children:
			if D==':':
				if not B:B.append(_A)
			elif D.type=='sliceop':
				if len(D.children)==2:B.append(D.children[1])
			else:B.append(D)
		B+=[_A]*(3-len(B));return ValueSet([iterable.Slice(C,*B)])
	elif A.type=='subscriptlist':return ValueSet([iterable.SequenceLiteralValue(C.inference_state,C,A)])
	return C.infer_node(A)