_E='atom_expr'
_D='trailer'
_C='path'
_B='name'
_A=None
import os,re
from pathlib import Path
from importlib.machinery import all_suffixes
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.base_value import ContextualizedNode
from jedi.inference.helpers import is_string,get_str_or_none
from jedi.parser_utils import get_cached_code_lines
from jedi.file_io import FileIO
from jedi import settings
from jedi import debug
_BUILDOUT_PATH_INSERTION_LIMIT=10
def _abs_path(module_context,str_path):
	A=Path(str_path)
	if A.is_absolute():return A
	B=module_context.py__file__()
	if B is _A:return
	C=B.parent;return C.joinpath(A).absolute()
def _paths_from_assignment(module_context,expr_stmt):
	"\n    Extracts the assigned strings from an assignment that looks as follows::\n\n        sys.path[0:0] = ['module/path', 'another/module/path']\n\n    This function is in general pretty tolerant (and therefore 'buggy').\n    However, it's not a big issue usually to add more paths to Jedi's sys_path,\n    because it will only affect Jedi in very random situations and by adding\n    more paths than necessary, it usually benefits the general user.\n    ";D=module_context;A=expr_stmt
	for(B,I)in zip(A.children[::2],A.children[1::2]):
		try:assert I in['=','+='];assert B.type in('power',_E)and len(B.children)>1;C=B.children;assert C[0].type==_B and C[0].value=='sys';E=C[1];assert E.children[0]=='.'and E.children[1].value==_C;"\n            execution = c[2]\n            assert execution.children[0] == '['\n            subscript = execution.children[1]\n            assert subscript.type == 'subscript'\n            assert ':' in subscript.children\n            "
		except AssertionError:continue
		F=ContextualizedNode(D.create_context(A),A)
		for J in F.infer().iterate(F):
			for G in J.infer():
				if is_string(G):
					H=_abs_path(D,G.get_safe_value())
					if H is not _A:yield H
def _paths_from_list_modifications(module_context,trailer1,trailer2):
	' extract the path from either "sys.path.append" or "sys.path.insert" ';H='insert';D=module_context;C=trailer1;B=trailer2
	if not(C.type==_D and C.children[0]=='.'and B.type==_D and B.children[0]=='('and len(B.children)==3):return
	E=C.children[1].value
	if E not in[H,'append']:return
	A=B.children[1]
	if E==H and len(A.children)in(3,4):A=A.children[2]
	for I in D.create_context(A).infer_node(A):
		F=get_str_or_none(I)
		if F is _A:continue
		G=_abs_path(D,F)
		if G is not _A:yield G
@inference_state_method_cache(default=[])
def check_sys_path_modifications(module_context):
	'\n    Detect sys.path modifications within module.\n    ';A=module_context
	def E(names):
		for C in names:
			A=C.parent.parent
			if A is not _A and A.type in('power',_E):
				B=A.children
				if B[0].type==_B and B[0].value=='sys'and B[1].type==_D:
					D=B[1].children[1]
					if D.type==_B and D.value==_C:yield(C,A)
	if A.tree_node is _A:return[]
	B=[]
	try:F=A.tree_node.get_used_names()[_C]
	except KeyError:pass
	else:
		for(G,C)in E(F):
			D=C.parent
			if len(C.children)>=4:B.extend(_paths_from_list_modifications(A,*C.children[2:4]))
			elif D is not _A and D.type=='expr_stmt':B.extend(_paths_from_assignment(A,D))
	return B
def discover_buildout_paths(inference_state,script_path):
	A=set()
	for B in _get_buildout_script_paths(script_path):
		for C in _get_paths_from_buildout_script(inference_state,B):
			A.add(C)
			if len(A)>=_BUILDOUT_PATH_INSERTION_LIMIT:break
	return A
def _get_paths_from_buildout_script(inference_state,buildout_script_path):
	B=buildout_script_path;A=inference_state;C=FileIO(str(B))
	try:D=A.parse(file_io=C,cache=True,cache_path=settings.cache_directory)
	except IOError:debug.warning('Error trying to read buildout_script: %s',B);return
	from jedi.inference.value import ModuleValue as E;F=E(A,D,file_io=C,string_names=_A,code_lines=get_cached_code_lines(A.grammar,B)).as_context();yield from check_sys_path_modifications(F)
def _get_parent_dir_with_file(path,filename):
	for A in path.parents:
		try:
			if A.joinpath(filename).is_file():return A
		except OSError:continue
def _get_buildout_script_paths(search_path):
	"\n    if there is a 'buildout.cfg' file in one of the parent directories of the\n    given module it will return a list of all files in the buildout bin\n    directory that look like python files.\n\n    :param search_path: absolute path to the module.\n    ";B=_get_parent_dir_with_file(search_path,'buildout.cfg')
	if not B:return
	A=B.joinpath('bin')
	if not A.exists():return
	for E in os.listdir(A):
		try:
			C=A.joinpath(E)
			with open(C,'r')as F:
				D=F.readline()
				if D.startswith('#!')and'python'in D:yield C
		except(UnicodeDecodeError,IOError)as G:debug.warning(str(G));continue
def remove_python_path_suffix(path):
	A=path
	for B in all_suffixes()+['.pyi']:
		if A.suffix==B:A=A.with_name(A.stem);break
	return A
def transform_path_to_dotted(sys_path,module_path):
	'\n    Returns the dotted path inside a sys.path as a list of names. e.g.\n\n    >>> transform_path_to_dotted([str(Path("/foo").absolute())], Path(\'/foo/bar/baz.py\').absolute())\n    ((\'bar\', \'baz\'), False)\n\n    Returns (None, False) if the path doesn\'t really resolve to anything.\n    The second return part is if it is a package.\n    ';D=False;A=module_path;A=remove_python_path_suffix(A)
	if A.name.startswith('.'):return _A,D
	B=A.name=='__init__'
	if B:A=A.parent
	def E():
		for C in sys_path:
			if str(A).startswith(C):
				B=str(A)[len(C):]
				if B.startswith(os.path.sep)or B.startswith('/'):B=B[1:]
				if B:
					D=B.split(os.path.sep)
					if not all(D):return
					yield tuple(re.sub('-stubs$','',A)for A in D)
	C=tuple(E())
	if not C:return _A,D
	return sorted(C,key=lambda p:len(p))[0],B