' A universal module with functions / classes without dependencies. '
import functools,re,os
_sep=os.path.sep
if os.path.altsep is not None:_sep+=os.path.altsep
_path_re=re.compile('(?:\\.[^{0}]+|[{0}]__init__\\.py)$'.format(re.escape(_sep)))
del _sep
def to_list(func):
	def A(*A,**B):return list(func(*A,**B))
	return A
def to_tuple(func):
	def A(*A,**B):return tuple(func(*A,**B))
	return A
def unite(iterable):'Turns a two dimensional array into a one dimensional.';return set(B for A in iterable for B in A)
class UncaughtAttributeError(Exception):'\n    Important, because `__getattr__` and `hasattr` catch AttributeErrors\n    implicitly. This is really evil (mainly because of `__getattr__`).\n    Therefore this class originally had to be derived from `BaseException`\n    instead of `Exception`.  But because I removed relevant `hasattr` from\n    the code base, we can now switch back to `Exception`.\n\n    :param base: return values of sys.exc_info().\n    '
def safe_property(func):return property(reraise_uncaught(func))
def reraise_uncaught(func):
	'\n    Re-throw uncaught `AttributeError`.\n\n    Usage:  Put ``@rethrow_uncaught`` in front of the function\n    which does **not** suppose to raise `AttributeError`.\n\n    AttributeError is easily get caught by `hasattr` and another\n    ``except AttributeError`` clause.  This becomes problem when you use\n    a lot of "dynamic" attributes (e.g., using ``@property``) because you\n    can\'t distinguish if the property does not exist for real or some code\n    inside of the "dynamic" attribute through that error.  In a well\n    written code, such error should not exist but getting there is very\n    difficult.  This decorator is to help us getting there by changing\n    `AttributeError` to `UncaughtAttributeError` to avoid unexpected catch.\n    This helps us noticing bugs earlier and facilitates debugging.\n    '
	@functools.wraps(func)
	def A(*B,**C):
		try:return func(*B,**C)
		except AttributeError as A:raise UncaughtAttributeError(A)from A
	return A
class PushBackIterator:
	def __init__(A,iterator):A.pushes=[];A.iterator=iterator;A.current=None
	def push_back(A,value):A.pushes.append(value)
	def __iter__(A):return A
	def __next__(A):
		if A.pushes:A.current=A.pushes.pop()
		else:A.current=next(A.iterator)
		return A.current