_F='funcdef'
_E='function'
_D='lambdef'
_C=False
_B=True
_A=None
from parso.python import tree
from jedi import debug
from jedi.inference.cache import inference_state_method_cache,CachedMetaClass
from jedi.inference import compiled
from jedi.inference import recursion
from jedi.inference import docstrings
from jedi.inference import flow_analysis
from jedi.inference.signature import TreeSignature
from jedi.inference.filters import ParserTreeFilter,FunctionExecutionFilter,AnonymousFunctionExecutionFilter
from jedi.inference.names import ValueName,AbstractNameDefinition,AnonymousParamName,ParamName,NameWrapper
from jedi.inference.base_value import ContextualizedNode,NO_VALUES,ValueSet,TreeValue,ValueWrapper
from jedi.inference.lazy_value import LazyKnownValues,LazyKnownValue,LazyTreeValue
from jedi.inference.context import ValueContext,TreeContextMixin
from jedi.inference.value import iterable
from jedi import parser_utils
from jedi.inference.parser_cache import get_yield_exprs
from jedi.inference.helpers import values_from_qualified_names
from jedi.inference.gradual.generics import TupleGenericManager
class LambdaName(AbstractNameDefinition):
	string_name='<lambda>';api_type=_E
	def __init__(A,lambda_value):B=lambda_value;A._lambda_value=B;A.parent_context=B.parent_context
	@property
	def start_pos(self):return self._lambda_value.tree_node.start_pos
	def infer(A):return ValueSet([A._lambda_value])
class FunctionAndClassBase(TreeValue):
	def get_qualified_names(A):
		if A.parent_context.is_class():
			B=A.parent_context.get_qualified_names()
			if B is _A:return
			return B+(A.py__name__(),)
		elif A.parent_context.is_module():return A.py__name__(),
		else:return
class FunctionMixin:
	api_type=_E
	def get_filters(A,origin_scope=_A):
		B=A.py__class__()
		for C in B.execute_with_values():yield from C.get_filters(origin_scope=origin_scope)
	def py__get__(A,instance,class_value):
		B=instance;from jedi.inference.value.instance import BoundMethod as C
		if B is _A:return ValueSet([A])
		return ValueSet([C(B,class_value.as_context(),A)])
	def get_param_names(A):return[AnonymousParamName(A,B.name)for B in A.tree_node.get_params()]
	@property
	def name(self):
		A=self
		if A.tree_node.type==_D:return LambdaName(A)
		return ValueName(A,A.tree_node.name)
	def is_function(A):return _B
	def py__name__(A):return A.name.string_name
	def get_type_hint(A,add_class_info=_B):
		D=A.tree_node.annotation
		if D is _A:
			def F(n):
				A=n.string_name;B=n.infer().get_type_hint()
				if B is not _A:A+=': '+B
				if n.default_node is not _A:A+='='+n.default_node.get_code(include_prefix=_C)
				return A
			E=A.as_context();G=E.infer();B=G.get_type_hint();C=A.py__name__()+'(%s)'%', '.join([F(A)for A in E.get_param_names()])
			if B is _A:return C
		else:B=D.get_code(include_prefix=_C);C=A.py__name__()+A.tree_node.children[2].get_code(include_prefix=_C)
		return C+' -> '+B
	def py__call__(A,arguments):B=A.as_context(arguments);return B.infer()
	def _as_context(A,arguments=_A):
		B=arguments
		if B is _A:return AnonymousFunctionExecution(A)
		return FunctionExecutionContext(A,B)
	def get_signatures(A):return[TreeSignature(A)for A in A.get_signature_functions()]
class FunctionValue(FunctionMixin,FunctionAndClassBase,metaclass=CachedMetaClass):
	@classmethod
	def from_context(G,context,tree_node):
		C=tree_node;A=context
		def D(tree_node):
			C=tree_node
			if A.is_class():return MethodValue(A.inference_state,A,parent_context=B,tree_node=C)
			else:return G(A.inference_state,parent_context=B,tree_node=C)
		E=list(_find_overload_functions(A,C));B=A
		while B.is_class()or B.is_instance():B=B.parent_context
		F=D(C)
		if E:return OverloadedFunctionValue(F,list(reversed([D(A)for A in E])))
		return F
	def py__class__(A):B,=values_from_qualified_names(A.inference_state,'types','FunctionType');return B
	def get_default_param_context(A):return A.parent_context
	def get_signature_functions(A):return[A]
class FunctionNameInClass(NameWrapper):
	def __init__(A,class_context,name):super().__init__(name);A._class_context=class_context
	def get_defining_qualified_value(A):return A._class_context.get_value()
class MethodValue(FunctionValue):
	def __init__(A,inference_state,class_context,*B,**C):super().__init__(inference_state,*B,**C);A.class_context=class_context
	def get_default_param_context(A):return A.class_context
	def get_qualified_names(A):
		B=A.class_context.get_qualified_names()
		if B is _A:return
		return B+(A.py__name__(),)
	@property
	def name(self):return FunctionNameInClass(self.class_context,super().name)
class BaseFunctionExecutionContext(ValueContext,TreeContextMixin):
	def infer_annotations(A):raise NotImplementedError
	@inference_state_method_cache(default=NO_VALUES)
	@recursion.execution_recursion_decorator()
	def get_return_values(self,check_yields=_C):
		E=check_yields;A=self;C=A.tree_node
		if C.type==_D:return A.infer_node(C.children[-1])
		if E:B=NO_VALUES;F=get_yield_exprs(A.inference_state,C)
		else:
			B=A.infer_annotations()
			if B:return B
			B|=docstrings.infer_return_types(A._value);F=C.iter_return_stmts()
		for D in F:
			if E:B|=ValueSet.from_sets(A.infer()for A in A._get_yield_lazy_value(D))
			else:
				G=flow_analysis.reachability_check(A,C,D)
				if G is flow_analysis.UNREACHABLE:debug.dbg('Return unreachable: %s',D)
				else:
					try:H=D.children
					except AttributeError:I=compiled.builtin_from_name(A.inference_state,'None');B|=ValueSet([I])
					else:B|=A.infer_node(H[1])
				if G is flow_analysis.REACHABLE:debug.dbg('Return reachable: %s',D);break
		return B
	def _get_yield_lazy_value(A,yield_expr):
		C=yield_expr
		if C.type=='keyword':E=compiled.builtin_from_name(A.inference_state,'None');yield LazyKnownValue(E);return
		B=C.children[1]
		if B.type=='yield_arg':D=ContextualizedNode(A,B.children[1]);yield from D.infer().iterate(D)
		else:yield LazyTreeValue(A,B)
	@recursion.execution_recursion_decorator(default=iter([]))
	def get_yield_lazy_values(self,is_async=_C):
		K='for_stmt';B=self;L=[(A,tree.search_ancestor(A,K,_F,'while_stmt','if_stmt'))for A in get_yield_exprs(B.inference_state,B.tree_node)];D=[];G=_A
		for(C,A)in L:
			E=A.parent
			if E.type=='suite':E=E.parent
			if A.type==K and E==B.tree_node and parser_utils.for_stmt_defines_one_name(A):
				if A==G:D[-1][1].append(C)
				else:D.append((A,[C]))
			elif A==B.tree_node:D.append((_A,[C]))
			else:
				H=B.get_return_values(check_yields=_B)
				if H:yield LazyKnownValues(H,min=0,max=float('inf'))
				return
			G=A
		for(A,I)in D:
			if A is _A:
				for C in I:yield from B._get_yield_lazy_value(C)
			else:
				M=A.get_testlist();J=ContextualizedNode(B,M);F=J.infer().iterate(J);F=list(F)
				for N in F:
					O={str(A.children[1].value):N.infer()}
					with B.predefine_names(A,O):
						for P in I:yield from B._get_yield_lazy_value(P)
	def merge_yield_values(A,is_async=_C):return ValueSet.from_sets(A.infer()for A in A.get_yield_lazy_values())
	def is_generator(A):return bool(get_yield_exprs(A.inference_state,A.tree_node))
	def infer(A):
		'\n        Created to be used by inheritance.\n        ';B=A.inference_state;E=A.tree_node.parent.type in('async_stmt','async_funcdef');from jedi.inference.gradual.base import GenericClass as D
		if E:
			if A.is_generator():F=B.typing_module.py__getattribute__('AsyncGenerator');G=A.merge_yield_values(is_async=_B);C=G.py__class__(),NO_VALUES;return ValueSet(D(A,TupleGenericManager(C))for A in F).execute_annotation()
			else:H=B.typing_module.py__getattribute__('Coroutine');I=A.get_return_values();C=I.py__class__(),NO_VALUES,NO_VALUES;return ValueSet(D(A,TupleGenericManager(C))for A in H).execute_annotation()
		elif A.is_generator()and not A.infer_annotations():return ValueSet([iterable.Generator(B,A)])
		else:return A.get_return_values()
class FunctionExecutionContext(BaseFunctionExecutionContext):
	def __init__(A,function_value,arguments):super().__init__(function_value);A._arguments=arguments
	def get_filters(A,until_position=_A,origin_scope=_A):yield FunctionExecutionFilter(A,A._value,until_position=until_position,origin_scope=origin_scope,arguments=A._arguments)
	def infer_annotations(A):from jedi.inference.gradual.annotation import infer_return_types as B;return B(A._value,A._arguments)
	def get_param_names(A):return[ParamName(A._value,B.name,A._arguments)for B in A._value.tree_node.get_params()]
class AnonymousFunctionExecution(BaseFunctionExecutionContext):
	def infer_annotations(A):return NO_VALUES
	def get_filters(A,until_position=_A,origin_scope=_A):yield AnonymousFunctionExecutionFilter(A,A._value,until_position=until_position,origin_scope=origin_scope)
	def get_param_names(A):return A._value.get_param_names()
class OverloadedFunctionValue(FunctionMixin,ValueWrapper):
	def __init__(A,function,overloaded_functions):super().__init__(function);A._overloaded_functions=overloaded_functions
	def py__call__(A,arguments):
		B=arguments;debug.dbg('Execute overloaded function %s',A._wrapped_value,color='BLUE');C=[]
		for D in A.get_signatures():
			E=D.value.as_context(B);C.append(E)
			if D.matches_signature(B):return E.infer()
		if A.inference_state.is_analysis:return NO_VALUES
		return ValueSet.from_sets(A.infer()for A in C)
	def get_signature_functions(A):return A._overloaded_functions
	def get_type_hint(A,add_class_info=_B):return'Union[%s]'%', '.join(A.get_type_hint()for A in A._overloaded_functions)
def _find_overload_functions(context,tree_node):
	A=tree_node
	def D(funcdef):
		B=funcdef
		if B.parent.type=='decorated':
			A=B.parent.children[0]
			if A.type=='decorator':A=[A]
			else:A=A.children
			for D in A:
				C=D.children[1]
				if C.type=='name'and C.value=='overload':return _B
		return _C
	if A.type==_D:return
	if D(A):yield A
	while _B:
		filter=ParserTreeFilter(context,until_position=A.start_pos);C=filter.get(A.name.value);assert isinstance(C,list)
		if not C:break
		E=_C
		for F in C:
			B=F.tree_name.parent
			if B.type==_F and D(B):A=B;E=_B;yield B
		if not E:break