_F='__init__'
_E='funcdef'
_D='__call__'
_C='dict'
_B=True
_A=None
from abc import abstractproperty
from parso.tree import search_ancestor
from jedi import debug
from jedi import settings
from jedi.inference import compiled
from jedi.inference.compiled.value import CompiledValueFilter
from jedi.inference.helpers import values_from_qualified_names,is_big_annoying_library
from jedi.inference.filters import AbstractFilter,AnonymousFunctionExecutionFilter
from jedi.inference.names import ValueName,TreeNameDefinition,ParamName,NameWrapper
from jedi.inference.base_value import Value,NO_VALUES,ValueSet,iterator_to_value_set,ValueWrapper
from jedi.inference.lazy_value import LazyKnownValue,LazyKnownValues
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.arguments import ValuesArguments,TreeArgumentsWrapper
from jedi.inference.value.function import FunctionValue,FunctionMixin,OverloadedFunctionValue,BaseFunctionExecutionContext,FunctionExecutionContext,FunctionNameInClass
from jedi.inference.value.klass import ClassFilter
from jedi.inference.value.dynamic_arrays import get_dynamic_array_instance
from jedi.parser_utils import function_is_staticmethod,function_is_classmethod
class InstanceExecutedParamName(ParamName):
	def __init__(A,instance,function_value,tree_name):super().__init__(function_value,tree_name,arguments=_A);A._instance=instance
	def infer(A):return ValueSet([A._instance])
	def matches_signature(A):return _B
class AnonymousMethodExecutionFilter(AnonymousFunctionExecutionFilter):
	def __init__(A,instance,*B,**C):super().__init__(*B,**C);A._instance=instance
	def _convert_param(A,param,name):
		C=param;B=name
		if C.position_index==0:
			if function_is_classmethod(A._function_value.tree_node):return InstanceExecutedParamName(A._instance.py__class__(),A._function_value,B)
			elif not function_is_staticmethod(A._function_value.tree_node):return InstanceExecutedParamName(A._instance,A._function_value,B)
		return super()._convert_param(C,B)
class AnonymousMethodExecutionContext(BaseFunctionExecutionContext):
	def __init__(A,instance,value):super().__init__(value);A.instance=instance
	def get_filters(A,until_position=_A,origin_scope=_A):yield AnonymousMethodExecutionFilter(A.instance,A,A._value,until_position=until_position,origin_scope=origin_scope)
	def get_param_names(A):B=list(A._value.get_param_names());B[0]=InstanceExecutedParamName(A.instance,A._value,B[0].tree_name);return B
class MethodExecutionContext(FunctionExecutionContext):
	def __init__(A,instance,*B,**C):super().__init__(*B,**C);A.instance=instance
class AbstractInstanceValue(Value):
	api_type='instance'
	def __init__(A,inference_state,parent_context,class_value):super().__init__(inference_state,parent_context);A.class_value=class_value
	def is_instance(A):return _B
	def get_qualified_names(A):return A.class_value.get_qualified_names()
	def get_annotated_class_object(A):return A.class_value
	def py__class__(A):return A.class_value
	def py__bool__(A):0
	@abstractproperty
	def name(self):raise NotImplementedError
	def get_signatures(A):B=A.py__getattribute__(_D).py__get__(A,A.class_value);return[B.bind(A)for B in B.get_signatures()]
	def get_function_slot_names(B,name):
		for filter in B.get_filters(include_self_names=False):
			A=filter.get(name)
			if A:return A
		return[]
	def execute_function_slots(B,names,*A):return ValueSet.from_sets(B.infer().execute_with_values(*A)for B in names)
	def get_type_hint(A,add_class_info=_B):return A.py__name__()
	def py__getitem__(C,index_value_set,contextualized_node):
		A=index_value_set;B=C.get_function_slot_names('__getitem__')
		if not B:return super().py__getitem__(A,contextualized_node)
		D=ValuesArguments([A]);return ValueSet.from_sets(A.infer().execute(D)for A in B)
	def py__iter__(A,contextualized_node=_A):
		B=contextualized_node;C=A.get_function_slot_names('__iter__')
		if not C:return super().py__iter__(B)
		def D():
			for D in A.execute_function_slots(C):yield from D.py__next__(B)
		return D()
	def __repr__(A):return'<%s of %s>'%(A.__class__.__name__,A.class_value)
class CompiledInstance(AbstractInstanceValue):
	def __init__(A,inference_state,parent_context,class_value,arguments):super().__init__(inference_state,parent_context,class_value);A._arguments=arguments
	def get_filters(A,origin_scope=_A,include_self_names=_B):
		B=A.get_annotated_class_object();C=B.get_filters(origin_scope=origin_scope,is_instance=_B)
		for D in C:yield CompiledInstanceClassFilter(A,D)
	@property
	def name(self):return compiled.CompiledValueName(self,self.class_value.name.string_name)
	def is_stub(A):return False
class _BaseTreeInstance(AbstractInstanceValue):
	@property
	def array_type(self):
		A=self.class_value.py__name__()
		if A in['list','set',_C]and self.parent_context.get_root_context().is_builtins_module():return A
	@property
	def name(self):return ValueName(self,self.class_value.name.tree_name)
	def get_filters(B,origin_scope=_A,include_self_names=_B):
		D=origin_scope;C=B.get_annotated_class_object()
		if include_self_names:
			for E in C.py__mro__():
				if not E.is_compiled():yield SelfAttributeFilter(B,C,E.as_context(),D)
		F=C.get_filters(origin_scope=D,is_instance=_B)
		for A in F:
			if isinstance(A,ClassFilter):yield InstanceClassFilter(B,A)
			elif isinstance(A,CompiledValueFilter):yield CompiledInstanceClassFilter(B,A)
			else:yield A
	@inference_state_method_cache()
	def create_instance_context(self,class_context,node):
		B=class_context;A=node
		while _B:
			C=A;A=search_ancestor(A,_E,'classdef')
			if B.tree_node is A:
				F=FunctionValue.from_context(B,C);D=BoundMethod(self,B,F)
				if C.name.value==_F:E=D.as_context(self._arguments)
				else:E=D.as_context()
				break
		return E.create_context(node)
	def py__getattribute__alternatives(A,string_name):
		"\n        Since nothing was inferred, now check the __getattr__ and\n        __getattribute__ methods. Stubs don't need to be checked, because\n        they don't contain any logic.\n        "
		if A.is_stub():return NO_VALUES
		B=compiled.create_simple_object(A.inference_state,string_name)
		if is_big_annoying_library(A.parent_context):return NO_VALUES
		C=A.get_function_slot_names('__getattr__')or A.get_function_slot_names('__getattribute__');return A.execute_function_slots(C,B)
	def py__next__(A,contextualized_node=_A):
		C='__next__';B=A.get_function_slot_names(C)
		if B:yield LazyKnownValues(A.execute_function_slots(B))
		else:debug.warning('Instance has no __next__ function in %s.',A)
	def py__call__(C,arguments):
		A=arguments;B=C.get_function_slot_names(_D)
		if not B:return super().py__call__(A)
		return ValueSet.from_sets(B.infer().execute(A)for B in B)
	def py__get__(A,instance,class_value):
		'\n        obj may be None.\n        ';C=class_value;B=instance
		for F in A.class_value.py__mro__():
			D=F.py__get__on_class(A,B,C)
			if D is not NotImplemented:return D
		E=A.get_function_slot_names('__get__')
		if E:
			if B is _A:B=compiled.builtin_from_name(A.inference_state,'None')
			return A.execute_function_slots(E,B,C)
		else:return ValueSet([A])
class TreeInstance(_BaseTreeInstance):
	def __init__(A,inference_state,parent_context,class_value,arguments):
		D=parent_context;C=arguments;B=class_value
		if B.py__name__()in['list','set']and D.get_root_context().is_builtins_module():
			if settings.dynamic_array_additions:C=get_dynamic_array_instance(A,C)
		super().__init__(inference_state,D,B);A._arguments=C;A.tree_node=B.tree_node
	@inference_state_method_cache(default=_A)
	def _get_annotated_class_object(self):
		A=self;from jedi.inference.gradual.annotation import py__annotations__ as H,infer_type_vars_for_execution as E;C=InstanceArguments(A,A._arguments)
		for B in A.class_value.py__getattribute__(_F).get_signatures():
			D=B.value.tree_node
			if D is _A or D.type!=_E or not B.matches_signature(C):continue
			I=BoundMethod(A,A.class_value.as_context(),B.value);F=H(D);J=E(I,C,F)
			if J:G,=A.class_value.define_generics(E(B.value,C,F));debug.dbg('Inferred instance value as %s',G,color='BLUE');return G
	def get_annotated_class_object(A):return A._get_annotated_class_object()or A.class_value
	def get_key_values(A):
		B=NO_VALUES
		if A.array_type==_C:
			for(D,(C,E))in enumerate(A._arguments.unpack()):
				if C is _A and D==0:B|=ValueSet.from_sets(A.get_key_values()for A in E.infer()if A.array_type==_C)
				if C:B|=ValueSet([compiled.create_simple_object(A.inference_state,C)])
		return B
	def py__simple_getitem__(B,index):
		A=index
		if B.array_type==_C:
			for(C,D)in reversed(list(B._arguments.unpack())):
				if C is _A:
					E=ValueSet.from_sets(B.py__simple_getitem__(A)for B in D.infer()if B.array_type==_C)
					if E:return E
				elif C==A:return D.infer()
		return super().py__simple_getitem__(A)
	def __repr__(A):return'<%s of %s(%s)>'%(A.__class__.__name__,A.class_value,A._arguments)
class AnonymousInstance(_BaseTreeInstance):_arguments=_A
class CompiledInstanceName(NameWrapper):
	@iterator_to_value_set
	def infer(self):
		for A in self._wrapped_name.infer():
			if A.api_type=='function':yield CompiledBoundMethod(A)
			else:yield A
class CompiledInstanceClassFilter(AbstractFilter):
	def __init__(A,instance,f):A._instance=instance;A._class_filter=f
	def get(A,name):return A._convert(A._class_filter.get(name))
	def values(A):return A._convert(A._class_filter.values())
	def _convert(A,names):return[CompiledInstanceName(A)for A in names]
class BoundMethod(FunctionMixin,ValueWrapper):
	def __init__(A,instance,class_context,function):super().__init__(function);A.instance=instance;A._class_context=class_context
	def is_bound_method(A):return _B
	@property
	def name(self):return FunctionNameInClass(self._class_context,super().name)
	def py__class__(A):B,=values_from_qualified_names(A.inference_state,'types','MethodType');return B
	def _get_arguments(B,arguments):A=arguments;assert A is not _A;return InstanceArguments(B.instance,A)
	def _as_context(A,arguments=_A):
		B=arguments
		if B is _A:return AnonymousMethodExecutionContext(A.instance,A)
		B=A._get_arguments(B);return MethodExecutionContext(A.instance,A,B)
	def py__call__(A,arguments):
		B=arguments
		if isinstance(A._wrapped_value,OverloadedFunctionValue):return A._wrapped_value.py__call__(A._get_arguments(B))
		C=A.as_context(B);return C.infer()
	def get_signature_functions(A):return[BoundMethod(A.instance,A._class_context,B)for B in A._wrapped_value.get_signature_functions()]
	def get_signatures(A):return[B.bind(A)for B in super().get_signatures()]
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A._wrapped_value)
class CompiledBoundMethod(ValueWrapper):
	def is_bound_method(A):return _B
	def get_signatures(A):return[B.bind(A)for B in A._wrapped_value.get_signatures()]
class SelfName(TreeNameDefinition):
	'\n    This name calculates the parent_context lazily.\n    '
	def __init__(A,instance,class_context,tree_name):A._instance=instance;A.class_context=class_context;A.tree_name=tree_name
	@property
	def parent_context(self):A=self;return A._instance.create_instance_context(A.class_context,A.tree_name)
	def get_defining_qualified_value(A):return A._instance
	def infer(B):
		A=search_ancestor(B.tree_name,'expr_stmt')
		if A is not _A:
			if A.children[1].type=='annassign':
				from jedi.inference.gradual.annotation import infer_annotation as D;C=D(B.parent_context,A.children[1].children[1]).execute_annotation()
				if C:return C
		return super().infer()
class LazyInstanceClassName(NameWrapper):
	def __init__(A,instance,class_member_name):super().__init__(class_member_name);A._instance=instance
	@iterator_to_value_set
	def infer(self):
		A=self
		for B in A._wrapped_name.infer():yield from B.py__get__(A._instance,A._instance.py__class__())
	def get_signatures(A):return A.infer().get_signatures()
	def get_defining_qualified_value(A):return A._instance
class InstanceClassFilter(AbstractFilter):
	'\n    This filter is special in that it uses the class filter and wraps the\n    resulting names in LazyInstanceClassName. The idea is that the class name\n    filtering can be very flexible and always be reflected in instances.\n    '
	def __init__(A,instance,class_filter):A._instance=instance;A._class_filter=class_filter
	def get(A,name):return A._convert(A._class_filter.get(name))
	def values(A):return A._convert(A._class_filter.values())
	def _convert(A,names):return[LazyInstanceClassName(A._instance,B)for B in names]
	def __repr__(A):return'<%s for %s>'%(A.__class__.__name__,A._class_filter)
class SelfAttributeFilter(ClassFilter):
	'\n    This class basically filters all the use cases where `self.*` was assigned.\n    '
	def __init__(A,instance,instance_class,node_context,origin_scope):super().__init__(class_value=instance_class,node_context=node_context,origin_scope=origin_scope,is_instance=_B);A._instance=instance
	def _filter(A,names):B=names;C,D=A._parser_scope.start_pos,A._parser_scope.end_pos;B=[A for A in B if C<A.start_pos<D];return A._filter_self_names(B)
	def _filter_self_names(C,names):
		for A in names:
			B=A.parent
			if B.type=='trailer'and len(B.parent.children)==2 and B.children[0]=='.':
				if A.is_definition()and C._access_possible(A):
					if C._is_in_right_scope(B.parent.children[0],A):yield A
	def _is_in_right_scope(B,self_name,name):A=self_name;C=B._node_context.create_context(A);D=C.goto(A,position=A.start_pos);return any(A.api_type=='param'and A.tree_name.get_definition().position_index==0 and A.parent_context.tree_node is B._parser_scope for A in D)
	def _convert_names(A,names):return[SelfName(A._instance,A._node_context,B)for B in names]
	def _check_flows(A,names):return names
class InstanceArguments(TreeArgumentsWrapper):
	def __init__(A,instance,arguments):super().__init__(arguments);A.instance=instance
	def unpack(A,func=_A):yield(_A,LazyKnownValue(A.instance));yield from A._wrapped_arguments.unpack(func)