'\nContains all classes and functions to deal with lists, dicts, generators and\niterators in general.\n'
_M='testlist_comp'
_L='subscript'
_K='testlist'
_J='testlist_star_expr'
_I='sync_comp_for'
_H='Generator'
_G='values'
_F='comp_for'
_E='star_expr'
_D='<%s of %s>'
_C='tuple'
_B='dict'
_A=None
from jedi.inference import compiled,analysis
from jedi.inference.lazy_value import LazyKnownValue,LazyKnownValues,LazyTreeValue
from jedi.inference.helpers import get_int_or_none,is_string,reraise_getitem_errors,SimpleGetItemNotFound
from jedi.inference.utils import safe_property,to_list
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.filters import LazyAttributeOverwrite,publish_method
from jedi.inference.base_value import ValueSet,Value,NO_VALUES,ContextualizedNode,iterate_values,sentinel,LazyValueWrapper
from jedi.parser_utils import get_sync_comp_fors
from jedi.inference.context import CompForContext
from jedi.inference.value.dynamic_arrays import check_array_additions
class IterableMixin:
	def py__next__(A,contextualized_node=_A):return A.py__iter__(contextualized_node)
	def py__stop_iteration_returns(A):return ValueSet([compiled.builtin_from_name(A.inference_state,'None')])
	get_safe_value=Value.get_safe_value
class GeneratorBase(LazyAttributeOverwrite,IterableMixin):
	array_type=_A
	def _get_wrapped_value(A):B,=A._get_cls().execute_annotation();return B
	def _get_cls(A):B,=A.inference_state.typing_module.py__getattribute__(_H);return B
	def py__bool__(A):return True
	@publish_method('__iter__')
	def _iter(self,arguments):return ValueSet([self])
	@publish_method('send')
	@publish_method('__next__')
	def _next(self,arguments):return ValueSet.from_sets(A.infer()for A in self.py__iter__())
	def py__stop_iteration_returns(A):return ValueSet([compiled.builtin_from_name(A.inference_state,'None')])
	@property
	def name(self):return compiled.CompiledValueName(self,_H)
	def get_annotated_class_object(A):from jedi.inference.gradual.generics import TupleGenericManager as B;C=A.merge_types_of_iterate().py__class__();D=B((C,NO_VALUES,NO_VALUES));return A._get_cls().with_generics(D)
class Generator(GeneratorBase):
	'Handling of `yield` functions.'
	def __init__(A,inference_state,func_execution_context):super().__init__(inference_state);A._func_execution_context=func_execution_context
	def py__iter__(A,contextualized_node=_A):
		B=A._func_execution_context.infer_annotations()
		if B:return B.iterate(contextualized_node)
		return A._func_execution_context.get_yield_lazy_values()
	def py__stop_iteration_returns(A):return A._func_execution_context.get_return_values()
	def __repr__(A):return _D%(type(A).__name__,A._func_execution_context)
def comprehension_from_atom(inference_state,value,atom):
	G=value;F=inference_state;C=atom;D=C.children[0];B=C.children[1]
	if D=='{':
		if C.children[1].children[1]==':':
			A=B.children[3]
			if A.type==_F:A=A.children[1]
			return DictComprehension(F,G,sync_comp_for_node=A,key_node=B.children[0],value_node=B.children[2])
		else:E=SetComprehension
	elif D=='(':E=GeneratorComprehension
	elif D=='[':E=ListComprehension
	A=B.children[1]
	if A.type==_F:A=A.children[1]
	return E(F,defining_context=G,sync_comp_for_node=A,entry_node=B.children[0])
class ComprehensionMixin:
	@inference_state_method_cache()
	def _get_comp_for_context(self,parent_context,comp_for):return CompForContext(parent_context,comp_for)
	def _nested(A,comp_fors,parent_context=_A):
		F=comp_fors;B=parent_context;C=F[0];H=C.parent.type==_F;G=C.children[3];B=B or A._defining_context;I=B.infer_node(G);J=ContextualizedNode(B,G);D=I.iterate(J,is_async=H);K=C.children[1]
		for(O,L)in enumerate(D):
			M=L.infer();N=unpack_tuple_to_dict(B,M,K);E=A._get_comp_for_context(B,C)
			with E.predefine_names(C,N):
				try:yield from A._nested(F[1:],E)
				except IndexError:
					D=E.infer_node(A._entry_node)
					if A.array_type==_B:yield(D,E.infer_node(A._value_node))
					else:yield D
	@inference_state_method_cache(default=[])
	@to_list
	def _iterate(self):A=tuple(get_sync_comp_fors(self._sync_comp_for_node));yield from self._nested(A)
	def py__iter__(A,contextualized_node=_A):
		for B in A._iterate():yield LazyKnownValues(B)
	def __repr__(A):return _D%(type(A).__name__,A._sync_comp_for_node)
class _DictMixin:
	def _get_generics(A):return tuple(A.py__class__()for A in A.get_mapping_item_values())
class Sequence(LazyAttributeOverwrite,IterableMixin):
	api_type='instance'
	@property
	def name(self):return compiled.CompiledValueName(self,self.array_type)
	def _get_generics(A):return A.merge_types_of_iterate().py__class__(),
	@inference_state_method_cache(default=())
	def _cached_generics(self):return self._get_generics()
	def _get_wrapped_value(A):from jedi.inference.gradual.base import GenericClass as B;from jedi.inference.gradual.generics import TupleGenericManager as C;D=compiled.builtin_from_name(A.inference_state,A.array_type);E,=B(D,C(A._cached_generics())).execute_annotation();return E
	def py__bool__(A):0
	@safe_property
	def parent(self):return self.inference_state.builtins_module
	def py__getitem__(A,index_value_set,contextualized_node):
		if A.array_type==_B:return A._dict_values()
		return iterate_values(ValueSet([A]))
class _BaseComprehension(ComprehensionMixin):
	def __init__(A,inference_state,defining_context,sync_comp_for_node,entry_node):B=sync_comp_for_node;assert B.type==_I;super().__init__(inference_state);A._defining_context=defining_context;A._sync_comp_for_node=B;A._entry_node=entry_node
class ListComprehension(_BaseComprehension,Sequence):
	array_type='list'
	def py__simple_getitem__(A,index):
		B=index
		if isinstance(B,slice):return ValueSet([A])
		C=list(A.py__iter__())
		with reraise_getitem_errors(IndexError,TypeError):D=C[B]
		return D.infer()
class SetComprehension(_BaseComprehension,Sequence):array_type='set'
class GeneratorComprehension(_BaseComprehension,GeneratorBase):0
class _DictKeyMixin:
	def get_mapping_item_values(A):return A._dict_keys(),A._dict_values()
	def get_key_values(A):return A._dict_keys()
class DictComprehension(ComprehensionMixin,Sequence,_DictKeyMixin):
	array_type=_B
	def __init__(A,inference_state,defining_context,sync_comp_for_node,key_node,value_node):B=sync_comp_for_node;assert B.type==_I;super().__init__(inference_state);A._defining_context=defining_context;A._sync_comp_for_node=B;A._entry_node=key_node;A._value_node=value_node
	def py__iter__(A,contextualized_node=_A):
		for(B,C)in A._iterate():yield LazyKnownValues(B)
	def py__simple_getitem__(A,index):
		for(B,C)in A._iterate():
			for D in B:
				if D.get_safe_value(default=object())==index:return C
		raise SimpleGetItemNotFound()
	def _dict_keys(A):return ValueSet.from_sets(A for(A,B)in A._iterate())
	def _dict_values(A):return ValueSet.from_sets(A for(B,A)in A._iterate())
	@publish_method(_G)
	def _imitate_values(self,arguments):A=LazyKnownValues(self._dict_values());return ValueSet([FakeList(self.inference_state,[A])])
	@publish_method('items')
	def _imitate_items(self,arguments):A=self;B=[LazyKnownValue(FakeTuple(A.inference_state,[LazyKnownValues(B),LazyKnownValues(C)]))for(B,C)in A._iterate()];return ValueSet([FakeList(A.inference_state,B)])
	def exact_key_items(A):return[]
class SequenceLiteralValue(Sequence):
	_TUPLE_LIKE=_J,_K,'subscriptlist';mapping={'(':_C,'[':'list','{':'set'}
	def __init__(A,inference_state,defining_context,atom):
		super().__init__(inference_state);A.atom=atom;A._defining_context=defining_context
		if A.atom.type in A._TUPLE_LIKE:A.array_type=_C
		else:A.array_type=SequenceLiteralValue.mapping[atom.children[0]];'The builtin name of the array (list, set, tuple or dict).'
	def _get_generics(A):
		if A.array_type==_C:return tuple(A.infer().py__class__()for A in A.py__iter__())
		return super()._get_generics()
	def py__simple_getitem__(A,index):
		'Here the index is an int/str. Raises IndexError/KeyError.';C=index
		if isinstance(C,slice):return ValueSet([A])
		else:
			with reraise_getitem_errors(TypeError,KeyError,IndexError):B=A.get_tree_entries()[C]
			if B==':'or B.type==_L:return NO_VALUES
			return A._defining_context.infer_node(B)
	def py__iter__(A,contextualized_node=_A):
		'\n        While values returns the possible values for any array field, this\n        function returns the value for a certain index.\n        '
		for B in A.get_tree_entries():
			if B==':'or B.type==_L:yield LazyKnownValue(Slice(A._defining_context,_A,_A,_A))
			else:yield LazyTreeValue(A._defining_context,B)
		yield from check_array_additions(A._defining_context,A)
	def py__len__(A):return len(A.get_tree_entries())
	def get_tree_entries(D):
		G=D.atom.children
		if D.atom.type in D._TUPLE_LIKE:return G[::2]
		A=G[1]
		if A in(']','}',')'):return[]
		if A.type==_M:return[A for A in A.children[::2]if A.type!=_E]
		elif A.type=='dictorsetmaker':
			E=[];B=iter(A.children)
			for C in B:
				if C=='**':next(B);next(B,_A)
				else:
					F=next(B,_A)
					if F is _A or F==',':
						if C.type==_E:0
						else:E.append(C)
					else:assert F==':';E.append((C,next(B)));next(B,_A)
			return E
		elif A.type==_E:return[]
		else:return[A]
	def __repr__(A):return _D%(A.__class__.__name__,A.atom)
class DictLiteralValue(_DictMixin,SequenceLiteralValue,_DictKeyMixin):
	array_type=_B
	def __init__(A,inference_state,defining_context,atom):Sequence.__init__(A,inference_state);A._defining_context=defining_context;A.atom=atom
	def py__simple_getitem__(A,index):
		'Here the index is an int/str. Raises IndexError/KeyError.';B=compiled.create_simple_object(A.inference_state,index)
		for(C,D)in A.get_tree_entries():
			for E in A._defining_context.infer_node(C):
				for F in E.execute_operation(B,'=='):
					if F.get_safe_value():return A._defining_context.infer_node(D)
		raise SimpleGetItemNotFound('No key found in dictionary %s.'%A)
	def py__iter__(B,contextualized_node=_A):
		'\n        While values returns the possible values for any array field, this\n        function returns the value for a certain index.\n        ';A=NO_VALUES
		for(C,D)in B.get_tree_entries():A|=B._defining_context.infer_node(C)
		for D in A:yield LazyKnownValues(A)
	@publish_method(_G)
	def _imitate_values(self,arguments):A=LazyKnownValues(self._dict_values());return ValueSet([FakeList(self.inference_state,[A])])
	@publish_method('items')
	def _imitate_items(self,arguments):A=self;B=[LazyKnownValue(FakeTuple(A.inference_state,(LazyTreeValue(A._defining_context,B),LazyTreeValue(A._defining_context,C))))for(B,C)in A.get_tree_entries()];return ValueSet([FakeList(A.inference_state,B)])
	def exact_key_items(A):
		'\n        Returns a generator of tuples like dict.items(), where the key is\n        resolved (as a string) and the values are still lazy values.\n        '
		for(C,D)in A.get_tree_entries():
			for B in A._defining_context.infer_node(C):
				if is_string(B):yield(B.get_safe_value(),LazyTreeValue(A._defining_context,D))
	def _dict_values(A):return ValueSet.from_sets(A._defining_context.infer_node(B)for(C,B)in A.get_tree_entries())
	def _dict_keys(A):return ValueSet.from_sets(A._defining_context.infer_node(B)for(B,C)in A.get_tree_entries())
class _FakeSequence(Sequence):
	def __init__(A,inference_state,lazy_value_list):'\n        type should be one of "tuple", "list"\n        ';super().__init__(inference_state);A._lazy_value_list=lazy_value_list
	def py__simple_getitem__(A,index):
		B=index
		if isinstance(B,slice):return ValueSet([A])
		with reraise_getitem_errors(IndexError,TypeError):C=A._lazy_value_list[B]
		return C.infer()
	def py__iter__(A,contextualized_node=_A):return A._lazy_value_list
	def py__bool__(A):return bool(len(A._lazy_value_list))
	def __repr__(A):return _D%(type(A).__name__,A._lazy_value_list)
class FakeTuple(_FakeSequence):array_type=_C
class FakeList(_FakeSequence):array_type=_C
class FakeDict(_DictMixin,Sequence,_DictKeyMixin):
	array_type=_B
	def __init__(A,inference_state,dct):super().__init__(inference_state);A._dct=dct
	def py__iter__(A,contextualized_node=_A):
		for B in A._dct:yield LazyKnownValue(compiled.create_simple_object(A.inference_state,B))
	def py__simple_getitem__(A,index):
		with reraise_getitem_errors(KeyError,TypeError):B=A._dct[index]
		return B.infer()
	@publish_method(_G)
	def _values(self,arguments):return ValueSet([FakeTuple(self.inference_state,[LazyKnownValues(self._dict_values())])])
	def _dict_values(A):return ValueSet.from_sets(A.infer()for A in A._dct.values())
	def _dict_keys(A):return ValueSet.from_sets(A.infer()for A in A.py__iter__())
	def exact_key_items(A):return A._dct.items()
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A._dct)
class MergedArray(Sequence):
	def __init__(A,inference_state,arrays):B=arrays;super().__init__(inference_state);A.array_type=B[-1].array_type;A._arrays=B
	def py__iter__(A,contextualized_node=_A):
		for B in A._arrays:yield from B.py__iter__()
	def py__simple_getitem__(A,index):return ValueSet.from_sets(A.infer()for A in A.py__iter__())
def unpack_tuple_to_dict(context,types,exprlist):
	'\n    Unpacking tuple assignments in for statements and expr_stmts.\n    ';C=types;B=context;A=exprlist
	if A.type=='name':return{A.value:C}
	elif A.type=='atom'and A.children[0]in('(','['):return unpack_tuple_to_dict(B,C,A.children[1])
	elif A.type in(_K,_M,'exprlist',_J):
		E={};F=iter(A.children[::2]);D=0
		for I in C.iterate(ContextualizedNode(B,A)):
			D+=1
			try:G=next(F)
			except StopIteration:analysis.add(B,'value-error-too-many-values',G,message='ValueError: too many values to unpack (expected %s)'%D)
			else:E.update(unpack_tuple_to_dict(B,I.infer(),G))
		H=next(F,_A)
		if C and H is not _A:analysis.add(B,'value-error-too-few-values',H,message='ValueError: need more than %s values to unpack'%D)
		return E
	elif A.type=='power'or A.type=='atom_expr':return{}
	elif A.type==_E:return{}
	raise NotImplementedError
class Slice(LazyValueWrapper):
	def __init__(A,python_context,start,stop,step):B=python_context;A.inference_state=B.inference_state;A._context=B;A._start=start;A._stop=stop;A._step=step
	def _get_wrapped_value(A):B=compiled.builtin_from_name(A._context.inference_state,'slice');C,=B.execute_with_values();return C
	def get_safe_value(A,default=sentinel):
		'\n        Imitate CompiledValue.obj behavior and return a ``builtin.slice()``\n        object.\n        '
		def B(element):
			B=element
			if B is _A:return
			C=A._context.infer_node(B)
			if len(C)!=1:raise IndexError
			D,=C;return get_int_or_none(D)
		try:return slice(B(A._start),B(A._stop),B(A._step))
		except IndexError:return slice(_A,_A,_A)