_A=None
import os
from pathlib import Path
from typing import Optional
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.names import AbstractNameDefinition,ModuleName
from jedi.inference.filters import GlobalNameFilter,ParserTreeFilter,DictFilter,MergedFilter
from jedi.inference import compiled
from jedi.inference.base_value import TreeValue
from jedi.inference.names import SubModuleName
from jedi.inference.helpers import values_from_qualified_names
from jedi.inference.compiled import create_simple_object
from jedi.inference.base_value import ValueSet
from jedi.inference.context import ModuleContext
class _ModuleAttributeName(AbstractNameDefinition):
	'\n    For module attributes like __file__, __str__ and so on.\n    ';api_type='instance'
	def __init__(A,parent_module,string_name,string_value=_A):A.parent_context=parent_module;A.string_name=string_name;A._string_value=string_value
	def infer(A):
		if A._string_value is not _A:B=A._string_value;return ValueSet([create_simple_object(A.parent_context.inference_state,B)])
		return compiled.get_string_value_set(A.parent_context.inference_state)
class SubModuleDictMixin:
	@inference_state_method_cache()
	def sub_modules_dict(self):
		'\n        Lists modules in the directory of this module (if this module is a\n        package).\n        ';A=self;B={}
		if A.is_package():
			D=A.inference_state.compiled_subprocess.iter_module_names(A.py__path__())
			for C in D:B[C]=SubModuleName(A.as_context(),C)
		return B
class ModuleMixin(SubModuleDictMixin):
	_module_name_class=ModuleName
	def get_filters(A,origin_scope=_A):yield MergedFilter(ParserTreeFilter(parent_context=A.as_context(),origin_scope=origin_scope),GlobalNameFilter(A.as_context()));yield DictFilter(A.sub_modules_dict());yield DictFilter(A._module_attributes_dict());yield from A.iter_star_filters()
	def py__class__(A):B,=values_from_qualified_names(A.inference_state,'types','ModuleType');return B
	def is_module(A):return True
	def is_stub(A):return False
	@property
	@inference_state_method_cache()
	def name(self):A=self;return A._module_name_class(A,A.string_names[-1])
	@inference_state_method_cache()
	def _module_attributes_dict(self):
		D='__file__';A=self;E=['__package__','__doc__','__name__'];B=dict((B,_ModuleAttributeName(A,B))for B in E);C=A.py__file__()
		if C is not _A:B[D]=_ModuleAttributeName(A,D,str(C))
		return B
	def iter_star_filters(B):
		for C in B.star_imports():A=next(C.get_filters(),_A);assert A is not _A;yield A
	@inference_state_method_cache([])
	def star_imports(self):
		A=self;from jedi.inference.imports import Importer as F;B=[];G=A.as_context()
		for C in A.tree_node.iter_imports():
			if C.is_star_import():
				D=F(A.inference_state,import_path=C.get_paths()[-1],module_context=G,level=C.level).follow()
				for E in D:
					if isinstance(E,ModuleValue):B+=E.star_imports()
				B+=D
		return B
	def get_qualified_names(A):"\n        A module doesn't have a qualified name, but it's important to note that\n        it's reachable and not `None`. With this information we can add\n        qualified names on top for all value children.\n        ";return()
class ModuleValue(ModuleMixin,TreeValue):
	api_type='module'
	def __init__(A,inference_state,module_node,code_lines,file_io=_A,string_names=_A,is_package=False):
		B=file_io;super().__init__(inference_state,parent_context=_A,tree_node=module_node);A.file_io=B
		if B is _A:A._path=_A
		else:A._path=B.path
		A.string_names=string_names;A.code_lines=code_lines;A._is_package=is_package
	def is_stub(A):
		if A._path is not _A and A._path.suffix=='.pyi':return True
		return super().is_stub()
	def py__name__(A):
		if A.string_names is _A:return
		return'.'.join(A.string_names)
	def py__file__(A):
		"\n        In contrast to Python's __file__ can be None.\n        "
		if A._path is _A:return
		return A._path.absolute()
	def is_package(A):return A._is_package
	def py__package__(A):
		if A.string_names is _A:return[]
		if A._is_package:return A.string_names
		return A.string_names[:-1]
	def py__path__(A):
		"\n        In case of a package, this returns Python's __path__ attribute, which\n        is a list of paths (strings).\n        Returns None if the module is not a package.\n        "
		if not A._is_package:return
		C=''.join(A.code_lines[:50]);D='declare_namespace(__name__)','extend_path(__path__'
		if D[0]in C or D[1]in C:
			B=set()
			for G in A.inference_state.get_sys_path():
				E=os.path.join(G,A.name.string_name)
				if os.path.isdir(E):B.add(E)
			if B:return list(B)
		F=A.py__file__();assert F is not _A;return[os.path.dirname(F)]
	def _as_context(A):return ModuleContext(A)
	def __repr__(A):return'<%s: %s@%s-%s is_stub=%s>'%(A.__class__.__name__,A.py__name__(),A.tree_node.start_pos[0],A.tree_node.end_pos[0],A.is_stub())