from pathlib import Path
from typing import Optional
from jedi.inference.cache import inference_state_method_cache
from jedi.inference.filters import DictFilter
from jedi.inference.names import ValueNameMixin,AbstractNameDefinition
from jedi.inference.base_value import Value
from jedi.inference.value.module import SubModuleDictMixin
from jedi.inference.context import NamespaceContext
class ImplicitNSName(ValueNameMixin,AbstractNameDefinition):
	'\n    Accessing names for implicit namespace packages should infer to nothing.\n    This object will prevent Jedi from raising exceptions\n    '
	def __init__(A,implicit_ns_value,string_name):A._value=implicit_ns_value;A.string_name=string_name
class ImplicitNamespaceValue(Value,SubModuleDictMixin):
	'\n    Provides support for implicit namespace packages\n    ';api_type='namespace';parent_context=None
	def __init__(A,inference_state,string_names,paths):B=inference_state;super().__init__(B,parent_context=None);A.inference_state=B;A.string_names=string_names;A._paths=paths
	def get_filters(A,origin_scope=None):yield DictFilter(A.sub_modules_dict())
	def get_qualified_names(A):return()
	@property
	@inference_state_method_cache()
	def name(self):A=self.py__package__()[-1];return ImplicitNSName(self,A)
	def py__file__(A):0
	def py__package__(A):'Return the fullname\n        ';return A.string_names
	def py__path__(A):return A._paths
	def py__name__(A):return'.'.join(A.string_names)
	def is_namespace(A):return True
	def is_stub(A):return False
	def is_package(A):return True
	def as_context(A):return NamespaceContext(A)
	def __repr__(A):return'<%s: %s>'%(A.__class__.__name__,A.py__name__())