_K='comp_for'
_J='expr_stmt'
_I='atom_expr'
_H='lambdef'
_G='sync_comp_for'
_F='name'
_E='classdef'
_D='funcdef'
_C=True
_B=None
_A=False
import re,textwrap
from ast import literal_eval
from inspect import cleandoc
from weakref import WeakKeyDictionary
from parso.python import tree
from parso.cache import parser_cache
from parso import split_lines
_EXECUTE_NODES={_D,_E,'import_from','import_name','test','or_test','and_test','not_test','comparison','expr','xor_expr','and_expr','shift_expr','arith_expr',_I,'term','factor','power','atom'}
_FLOW_KEYWORDS='try','except','finally','else','if','elif','with','for','while'
def get_executable_nodes(node,last_added=_A):
	'\n    For static analysis.\n    ';C=last_added;A=node;B=[];D=A.type
	if D==_F:
		F=A.get_next_leaf()
		if C is _A and A.parent.type!='param'and F!='=':B.append(A)
	elif D==_J:
		B.append(A)
		for E in A.children:B+=get_executable_nodes(E,last_added=_C)
	elif D=='decorator':
		if A.children[-2]==')':
			A=A.children[-3]
			if A!='(':B+=get_executable_nodes(A)
	else:
		try:G=A.children
		except AttributeError:pass
		else:
			if A.type in _EXECUTE_NODES and not C:B.append(A)
			for E in G:B+=get_executable_nodes(E,C)
	return B
def get_sync_comp_fors(comp_for):
	B=comp_for;yield B;A=B.children[-1]
	while _C:
		if A.type==_K:yield A.children[1]
		elif A.type==_G:yield A
		elif not A.type=='comp_if':break
		A=A.children[-1]
def for_stmt_defines_one_name(for_stmt):'\n    Returns True if only one name is returned: ``for x in y``.\n    Returns False if the for loop is more complicated: ``for x, z in y``.\n\n    :returns: bool\n    ';return for_stmt.children[1].type==_F
def get_flow_branch_keyword(flow_node,node):
	A=flow_node;B=node.start_pos
	if not A.start_pos<B<=A.end_pos:raise ValueError('The node is not part of the flow.')
	C=_B
	for(F,D)in enumerate(A.children):
		if B<D.start_pos:return C
		E=D.get_first_leaf()
		if E in _FLOW_KEYWORDS:C=E
def clean_scope_docstring(scope_node):
	' Returns a cleaned version of the docstring token. ';A=scope_node.get_doc_node()
	if A is not _B:return cleandoc(safe_literal_eval(A.value))
	return''
def find_statement_documentation(tree_node):
	B=tree_node
	if B.type==_J:
		B=B.parent;A=B.get_next_sibling()
		if A is not _B:
			if A.type=='simple_stmt':
				A=A.children[0]
				if A.type=='string':return cleandoc(safe_literal_eval(A.value))
	return''
def safe_literal_eval(value):
	A=value;B=A[:2].lower()
	if B[0]=='f'or B in('fr','rf'):return''
	return literal_eval(A)
def get_signature(funcdef,width=72,call_string=_B,omit_first_param=_A,omit_return_annotation=_A):
	'\n    Generate a string signature of a function.\n\n    :param width: Fold lines if a line is longer than this value.\n    :type width: int\n    :arg func_name: Override function name when given.\n    :type func_name: str\n\n    :rtype: str\n    ';B=call_string;A=funcdef
	if B is _B:
		if A.type==_H:B='<lambda>'
		else:B=A.name.value
	C=A.get_params()
	if omit_first_param:C=C[1:]
	D='('+''.join(A.get_code()for A in C).strip()+')';D=re.sub('\\s+',' ',D)
	if A.annotation and not omit_return_annotation:E=' ->'+A.annotation.get_code()
	else:E=''
	F=B+D+E;return'\n'.join(textwrap.wrap(F,width))
def move(node,line_offset):
	'\n    Move the `Node` start_pos.\n    ';A=line_offset
	try:B=node.children
	except AttributeError:node.line+=A
	else:
		for C in B:move(C,A)
def get_following_comment_same_line(node):
	'\n    returns (as string) any comment that appears on the same line,\n    after the node, including the #\n    ';B=node
	try:
		if B.type=='for_stmt':C=B.children[5].get_first_leaf().prefix
		elif B.type=='with_stmt':C=B.children[3].get_first_leaf().prefix
		elif B.type==_D:C=B.children[4].get_first_leaf().get_next_leaf().prefix
		else:C=B.get_last_leaf().get_next_leaf().prefix
	except AttributeError:return
	except ValueError:return
	if'#'not in C:return
	A=C[C.index('#'):]
	if'\r'in A:A=A[:A.index('\r')]
	if'\n'in A:A=A[:A.index('\n')]
	return A
def is_scope(node):
	A=node.type
	if A==_K:return node.children[1].type!=_G
	return A in('file_input',_E,_D,_H,_G)
def _get_parent_scope_cache(func):
	D=WeakKeyDictionary()
	def A(parso_cache_node,node,include_flows=_A):
		E=include_flows;B=parso_cache_node;A=node
		if B is _B:return func(A,E)
		try:C=D[B]
		except KeyError:C=D[B]={}
		try:return C[A]
		except KeyError:F=C[A]=func(A,E);return F
	return A
def get_parent_scope(node,include_flows=_A):
	'\n    Returns the underlying scope.\n    ';B=node;A=B.parent
	if A is _B:return
	while _C:
		if is_scope(A):
			if A.type in(_E,_D,_H):
				C=A.children.index(':')
				if A.children[C].start_pos>=B.start_pos:
					if B.parent.type=='param'and B.parent.name==B:0
					elif B.parent.type=='tfpdef'and B.parent.children[0]==B:0
					else:A=A.parent;continue
			return A
		elif include_flows and isinstance(A,tree.Flow):
			if not(A.type=='if_stmt'and any(A.start_pos<=B.start_pos<A.end_pos for A in A.get_test_nodes())):return A
		A=A.parent
get_cached_parent_scope=_get_parent_scope_cache(get_parent_scope)
def get_cached_code_lines(grammar,path):'\n    Basically access the cached code lines in parso. This is not the nicest way\n    to do this, but we avoid splitting all the lines again.\n    ';return get_parso_cache_node(grammar,path).lines
def get_parso_cache_node(grammar,path):"\n    This is of course not public. But as long as I control parso, this\n    shouldn't be a problem. ~ Dave\n\n    The reason for this is mostly caching. This is obviously also a sign of a\n    broken caching architecture.\n    ";return parser_cache[grammar._hashed][path]
def cut_value_at_position(leaf,position):
	'\n    Cuts of the value of the leaf at position\n    ';C=position;A=leaf;B=split_lines(A.value,keepends=_C)[:C[0]-A.line+1];D=C[1]
	if A.line==C[0]:D-=A.column
	if not B:return''
	B[-1]=B[-1][:D];return''.join(B)
def expr_is_dotted(node):
	'\n    Checks if a path looks like `name` or `name.foo.bar` and not `name()`.\n    ';A=node
	if A.type=='atom':
		if len(A.children)==3 and A.children[0]=='(':return expr_is_dotted(A.children[1])
		return _A
	if A.type==_I:
		B=A.children
		if B[0]=='await':return _A
		if not expr_is_dotted(B[0]):return _A
		return all(A.children[0]=='.'for A in B[1:])
	return A.type==_F
def _function_is_x_method(*A):
	def B(function_node):
		"\n        This is a heuristic. It will not hold ALL the times, but it will be\n        correct pretty much for anyone that doesn't try to beat it.\n        staticmethod/classmethod are builtins and unless overwritten, this will\n        be correct.\n        "
		for B in function_node.get_decorators():
			C=B.children[1]
			if C.get_code()in A:return _C
		return _A
	return B
function_is_staticmethod=_function_is_x_method('staticmethod')
function_is_classmethod=_function_is_x_method('classmethod')
function_is_property=_function_is_x_method('property','cached_property')