"\nImplementations of standard library functions, because it's not possible to\nunderstand them with Jedi.\n\nTo add a new implementation, create a function and add it to the\n``_implemented`` dict at the bottom of this module.\n\nNote that this module exists only to implement very specific functionality in\nthe standard library. The usual way to understand the standard library is the\ncompiled module that returns the types for C-builtins.\n"
_M='frozen'
_L='define'
_K='os.path'
_J='*args, /'
_I='property'
_H='iterator[, default], /'
_G='__next__'
_F='builtins'
_E='func, /'
_D='sequence, /'
_C=False
_B=True
_A=None
import parso,os
from inspect import Parameter
from jedi import debug
from jedi.inference.utils import safe_property
from jedi.inference.helpers import get_str_or_none
from jedi.inference.arguments import iterate_argument_clinic,ParamIssue,repack_with_argument_clinic,AbstractArguments,TreeArgumentsWrapper
from jedi.inference import analysis
from jedi.inference import compiled
from jedi.inference.value.instance import AnonymousMethodExecutionContext,MethodExecutionContext
from jedi.inference.base_value import ContextualizedNode,NO_VALUES,ValueSet,ValueWrapper,LazyValueWrapper
from jedi.inference.value import ClassValue,ModuleValue
from jedi.inference.value.klass import ClassMixin
from jedi.inference.value.function import FunctionMixin
from jedi.inference.value import iterable
from jedi.inference.lazy_value import LazyTreeValue,LazyKnownValue,LazyKnownValues
from jedi.inference.names import ValueName,BaseTreeParamName
from jedi.inference.filters import AttributeOverwrite,publish_method,ParserTreeFilter,DictFilter
from jedi.inference.signature import AbstractSignature,SignatureWrapper
_NAMEDTUPLE_CLASS_TEMPLATE="_property = property\n_tuple = tuple\nfrom operator import itemgetter as _itemgetter\nfrom collections import OrderedDict\n\nclass {typename}(tuple):\n    __slots__ = ()\n\n    _fields = {field_names!r}\n\n    def __new__(_cls, {arg_list}):\n        'Create new instance of {typename}({arg_list})'\n        return _tuple.__new__(_cls, ({arg_list}))\n\n    @classmethod\n    def _make(cls, iterable, new=tuple.__new__, len=len):\n        'Make a new {typename} object from a sequence or iterable'\n        result = new(cls, iterable)\n        if len(result) != {num_fields:d}:\n            raise TypeError('Expected {num_fields:d} arguments, got %d' % len(result))\n        return result\n\n    def _replace(_self, **kwds):\n        'Return a new {typename} object replacing specified fields with new values'\n        result = _self._make(map(kwds.pop, {field_names!r}, _self))\n        if kwds:\n            raise ValueError('Got unexpected field names: %r' % list(kwds))\n        return result\n\n    def __repr__(self):\n        'Return a nicely formatted representation string'\n        return self.__class__.__name__ + '({repr_fmt})' % self\n\n    def _asdict(self):\n        'Return a new OrderedDict which maps field names to their values.'\n        return OrderedDict(zip(self._fields, self))\n\n    def __getnewargs__(self):\n        'Return self as a plain tuple.  Used by copy and pickle.'\n        return tuple(self)\n\n    # These methods were added by Jedi.\n    # __new__ doesn't really work with Jedi. So adding this to nametuples seems\n    # like the easiest way.\n    def __init__(self, {arg_list}):\n        'A helper function for namedtuple.'\n        self.__iterable = ({arg_list})\n\n    def __iter__(self):\n        for i in self.__iterable:\n            yield i\n\n    def __getitem__(self, y):\n        return self.__iterable[y]\n\n{field_defs}\n"
_NAMEDTUPLE_FIELD_TEMPLATE="    {name} = _property(_itemgetter({index:d}), doc='Alias for field number {index:d}')\n"
def execute(callback):
	def A(value,arguments):
		D=arguments;A=value
		def C():return callback(A,arguments=D)
		try:F=A.name.string_name
		except AttributeError:pass
		else:
			B=A.parent_context
			if B is not _A and B.is_builtins_module():E=_F
			elif B is not _A and B.is_module():E=B.py__name__()
			else:return C()
			if A.is_bound_method()or A.is_instance():return C()
			try:G=_implemented[E][F]
			except KeyError:pass
			else:return G(A,arguments=D,callback=C)
		return C()
	return A
def _follow_param(inference_state,arguments,index):
	try:B,A=list(arguments.unpack())[index]
	except IndexError:return NO_VALUES
	else:return A.infer()
def argument_clinic(clinic_string,want_value=_C,want_context=_C,want_arguments=_C,want_inference_state=_C,want_callback=_C):
	'\n    Works like Argument Clinic (PEP 436), to validate function params.\n    '
	def A(func):
		def A(value,arguments,callback):
			E='MAGENTA';C=arguments;B=value
			try:F=tuple(iterate_argument_clinic(B.inference_state,C,clinic_string))
			except ParamIssue:return NO_VALUES
			debug.dbg('builtin start %s'%B,color=E);A={}
			if want_context:A['context']=C.context
			if want_value:A['value']=B
			if want_inference_state:A['inference_state']=B.inference_state
			if want_arguments:A['arguments']=C
			if want_callback:A['callback']=callback
			D=func(*F,**A);debug.dbg('builtin end: %s',D,color=E);return D
		return A
	return A
@argument_clinic(_H,want_inference_state=_B)
def builtins_next(iterators,defaults,inference_state):return defaults|iterators.py__getattribute__(_G).execute_with_values()
@argument_clinic(_H)
def builtins_iter(iterators_or_callables,defaults):return iterators_or_callables.py__getattribute__('__iter__').execute_with_values()
@argument_clinic('object, name[, default], /')
def builtins_getattr(objects,names,defaults=_A):
	for B in objects:
		for C in names:
			A=get_str_or_none(C)
			if A is _A:debug.warning('getattr called without str');continue
			else:return B.py__getattribute__(A)
	return NO_VALUES
@argument_clinic('object[, bases, dict], /')
def builtins_type(objects,bases,dicts):
	if bases or dicts:return NO_VALUES
	else:return objects.py__class__()
class SuperInstance(LazyValueWrapper):
	'To be used like the object ``super`` returns.'
	def __init__(A,inference_state,instance):A.inference_state=inference_state;A._instance=instance
	def _get_bases(A):return A._instance.py__class__().py__bases__()
	def _get_wrapped_value(A):
		B=A._get_bases()[0].infer().execute_with_values()
		if not B:return A._instance
		return next(iter(B))
	def get_filters(A,origin_scope=_A):
		for B in A._get_bases():
			for C in B.infer().execute_with_values():
				for D in C.get_filters():yield D
@argument_clinic('[type[, value]], /',want_context=_B)
def builtins_super(types,objects,context):
	B=context;A=_A
	if isinstance(B,AnonymousMethodExecutionContext):A=B.instance
	elif isinstance(B,MethodExecutionContext):A=B.instance
	if A is _A:return NO_VALUES
	return ValueSet({SuperInstance(A.inference_state,A)})
class ReversedObject(AttributeOverwrite):
	def __init__(A,reversed_obj,iter_list):super().__init__(reversed_obj);A._iter_list=iter_list
	def py__iter__(A,contextualized_node=_A):return A._iter_list
	@publish_method(_G)
	def _next(self,arguments):return ValueSet.from_sets(A.infer()for A in self._iter_list)
@argument_clinic(_D,want_value=_B,want_arguments=_B)
def builtins_reversed(sequences,value,arguments):
	E,A=next(arguments.unpack());B=_A
	if isinstance(A,LazyTreeValue):B=ContextualizedNode(A.context,A.data)
	C=list(sequences.iterate(B));D,=value.inference_state.typing_module.py__getattribute__('Iterator').execute_with_values();return ValueSet([ReversedObject(D,list(reversed(C)))])
@argument_clinic('value, type, /',want_arguments=_B,want_inference_state=_B)
def builtins_isinstance(objects,types,arguments,inference_state):
	B=set()
	for F in objects:
		D=F.py__class__()
		try:D.py__bases__
		except AttributeError:B=set([_B,_C]);break
		E=list(D.py__mro__())
		for A in types:
			if A.is_class():B.add(A in E)
			elif A.name.string_name=='tuple'and A.get_root_context().is_builtins_module():G=ValueSet.from_sets(A.infer()for A in A.iterate());B.add(any(A in E for A in G))
			else:
				J,C=list(arguments.unpack())[1]
				if isinstance(C,LazyTreeValue):H=C.data;I='TypeError: isinstance() arg 2 must be a class, type, or tuple of classes and types, not %s.'%A;analysis.add(C.context,'type-error-isinstance',H,I)
	return ValueSet(compiled.builtin_from_name(inference_state,str(A))for A in B)
class StaticMethodObject(ValueWrapper):
	def py__get__(A,instance,class_value):return ValueSet([A._wrapped_value])
@argument_clinic(_D)
def builtins_staticmethod(functions):return ValueSet(StaticMethodObject(A)for A in functions)
class ClassMethodObject(ValueWrapper):
	def __init__(A,class_method_obj,function):super().__init__(class_method_obj);A._function=function
	def py__get__(A,instance,class_value):return ValueSet([ClassMethodGet(__get__,class_value,A._function)for __get__ in A._wrapped_value.py__getattribute__('__get__')])
class ClassMethodGet(ValueWrapper):
	def __init__(A,get_method,klass,function):super().__init__(get_method);A._class=klass;A._function=function
	def get_signatures(A):return[B.bind(A._function)for B in A._function.get_signatures()]
	def py__call__(A,arguments):return A._function.execute(ClassMethodArguments(A._class,arguments))
class ClassMethodArguments(TreeArgumentsWrapper):
	def __init__(A,klass,arguments):super().__init__(arguments);A._class=klass
	def unpack(A,func=_A):
		yield(_A,LazyKnownValue(A._class))
		for B in A._wrapped_arguments.unpack(func):yield B
@argument_clinic(_D,want_value=_B,want_arguments=_B)
def builtins_classmethod(functions,value,arguments):return ValueSet(ClassMethodObject(A,B)for A in value.py__call__(arguments=arguments)for B in functions)
class PropertyObject(AttributeOverwrite,ValueWrapper):
	api_type=_I
	def __init__(A,property_obj,function):super().__init__(property_obj);A._function=function
	def py__get__(A,instance,class_value):
		B=instance
		if B is _A:return ValueSet([A])
		return A._function.execute_with_values(B)
	@publish_method('deleter')
	@publish_method('getter')
	@publish_method('setter')
	def _return_self(self,arguments):return ValueSet({self})
@argument_clinic(_E,want_callback=_B)
def builtins_property(functions,callback):return ValueSet(PropertyObject(A,B)for A in callback()for B in functions)
def collections_namedtuple(value,arguments,callback):
	'\n    Implementation of the namedtuple function.\n\n    This has to be done by processing the namedtuple class template and\n    inferring the result.\n\n    ';D=arguments;B=value.inference_state;E='jedi_unknown_namedtuple'
	for K in _follow_param(B,D,0):
		F=get_str_or_none(K)
		if F is not _A:E=F;break
	G=_follow_param(B,D,1)
	if not G:return NO_VALUES
	C=list(G)[0];H=get_str_or_none(C)
	if H is not _A:A=H.replace(',',' ').split()
	elif isinstance(C,iterable.Sequence):A=[get_str_or_none(B)for A in C.py__iter__()for B in A.infer()];A=[A for A in A if A is not _A]
	else:return NO_VALUES
	I=_NAMEDTUPLE_CLASS_TEMPLATE.format(typename=E,field_names=tuple(A),num_fields=len(A),arg_list=repr(tuple(A)).replace("'",'')[1:-1],repr_fmt='',field_defs='\n'.join(_NAMEDTUPLE_FIELD_TEMPLATE.format(index=A,name=B)for(A,B)in enumerate(A)));J=B.grammar.parse(I);L=next(J.iter_classdefs());M=ModuleValue(B,J,code_lines=parso.split_lines(I,keepends=_B)).as_context();return ValueSet([ClassValue(B,M,L)])
class PartialObject(ValueWrapper):
	def __init__(A,actual_value,arguments,instance=_A):super().__init__(actual_value);A._arguments=arguments;A._instance=instance
	def _get_functions(B,unpacked_arguments):
		C,A=next(unpacked_arguments,(_A,_A))
		if C is not _A or A is _A:debug.warning('Partial should have a proper function %s',B._arguments);return
		return A.infer()
	def get_signatures(A):
		C=A._arguments.unpack();D=A._get_functions(C)
		if D is _A:return[]
		B=0
		if A._instance is not _A:B=1
		E=set()
		for(F,G)in C:
			if F is _A:B+=1
			else:E.add(F)
		return[PartialSignature(A,B,E)for A in D.get_signatures()]
	def py__call__(A,arguments):
		B=A._get_functions(A._arguments.unpack())
		if B is _A:return NO_VALUES
		return B.execute(MergedPartialArguments(A._arguments,arguments,A._instance))
	def py__doc__(A):
		'\n        In CPython partial does not replace the docstring. However we are still\n        imitating it here, because we want this docstring to be worth something\n        for the user.\n        ';B=A._get_functions(A._arguments.unpack())
		if B is _A:return''
		for C in B:return C.py__doc__()
		return''
	def py__get__(A,instance,class_value):return ValueSet([A])
class PartialMethodObject(PartialObject):
	def py__get__(A,instance,class_value):
		B=instance
		if B is _A:return ValueSet([A])
		return ValueSet([PartialObject(A._wrapped_value,A._arguments,B)])
class PartialSignature(SignatureWrapper):
	def __init__(A,wrapped_signature,skipped_arg_count,skipped_arg_set):super().__init__(wrapped_signature);A._skipped_arg_count=skipped_arg_count;A._skipped_arg_set=skipped_arg_set
	def get_param_names(A,resolve_stars=_C):B=A._wrapped_signature.get_param_names()[A._skipped_arg_count:];return[B for B in B if B.string_name not in A._skipped_arg_set]
class MergedPartialArguments(AbstractArguments):
	def __init__(A,partial_arguments,call_arguments,instance=_A):A._partial_arguments=partial_arguments;A._call_arguments=call_arguments;A._instance=instance
	def unpack(A,funcdef=_A):
		C=funcdef;D=A._partial_arguments.unpack(C);next(D,_A)
		if A._instance is not _A:yield(_A,LazyKnownValue(A._instance))
		for B in D:yield B
		for B in A._call_arguments.unpack(C):yield B
def functools_partial(value,arguments,callback):A=arguments;return ValueSet(PartialObject(B,A)for B in value.py__call__(A))
def functools_partialmethod(value,arguments,callback):A=arguments;return ValueSet(PartialMethodObject(B,A)for B in value.py__call__(A))
@argument_clinic('first, /')
def _return_first_param(firsts):return firsts
@argument_clinic('seq')
def _random_choice(sequences):return ValueSet.from_sets(B.infer()for A in sequences for B in A.py__iter__())
def _dataclass(value,arguments,callback):
	A=value
	for B in _follow_param(A.inference_state,arguments,0):
		if B.is_class():return ValueSet([DataclassWrapper(B)])
		else:return ValueSet([A])
	return NO_VALUES
class DataclassWrapper(ValueWrapper,ClassMixin):
	def get_signatures(G):
		C=[]
		for A in reversed(list(G.py__mro__())):
			if isinstance(A,DataclassWrapper):
				H=A.as_context().get_global_filter()
				for D in sorted(H.values(),key=lambda name:name.start_pos):
					E=D.tree_name.get_definition();B=E.children[1]
					if E.type=='expr_stmt'and B.type=='annassign':
						if len(B.children)<4:F=_A
						else:F=B.children[3]
						C.append(DataclassParamName(parent_context=A.parent_context,tree_name=D.tree_name,annotation_node=B.children[1],default_node=F))
		return[DataclassSignature(A,C)]
class DataclassSignature(AbstractSignature):
	def __init__(A,value,param_names):super().__init__(value);A._param_names=param_names
	def get_param_names(A,resolve_stars=_C):return A._param_names
class DataclassParamName(BaseTreeParamName):
	def __init__(A,parent_context,tree_name,annotation_node,default_node):super().__init__(parent_context,tree_name);A.annotation_node=annotation_node;A.default_node=default_node
	def get_kind(A):return Parameter.POSITIONAL_OR_KEYWORD
	def infer(A):
		if A.annotation_node is _A:return NO_VALUES
		else:return A.parent_context.infer_node(A.annotation_node)
class ItemGetterCallable(ValueWrapper):
	def __init__(A,instance,args_value_set):super().__init__(instance);A._args_value_set=args_value_set
	@repack_with_argument_clinic('item, /')
	def py__call__(self,item_value_set):
		C=item_value_set;A=NO_VALUES
		for D in self._args_value_set:
			B=list(D.py__iter__())
			if len(B)==1:A|=C.get_item(B[0].infer(),_A)
			else:A|=ValueSet([iterable.FakeList(self._wrapped_value.inference_state,[LazyKnownValues(C.get_item(A.infer(),_A))for A in B])])
		return A
@argument_clinic(_E)
def _functools_wraps(funcs):return ValueSet(WrapsCallable(A)for A in funcs)
class WrapsCallable(ValueWrapper):
	@repack_with_argument_clinic(_E)
	def py__call__(self,funcs):return ValueSet({Wrapped(A,self._wrapped_value)for A in funcs})
class Wrapped(ValueWrapper,FunctionMixin):
	def __init__(A,func,original_function):super().__init__(func);A._original_function=original_function
	@property
	def name(self):return self._original_function.name
	def get_signature_functions(A):return[A]
@argument_clinic(_J,want_value=_B,want_arguments=_B)
def _operator_itemgetter(args_value_set,value,arguments):return ValueSet([ItemGetterCallable(A,args_value_set)for A in value.py__call__(arguments)])
def _create_string_input_function(func):
	@argument_clinic('string, /',want_value=_B,want_arguments=_B)
	def A(strings,value,arguments):
		def B():
			for B in strings:
				A=get_str_or_none(B)
				if A is not _A:A=func(A);yield compiled.create_simple_object(B.inference_state,A)
		A=ValueSet(B())
		if A:return A
		return value.py__call__(arguments)
	return A
@argument_clinic(_J,want_callback=_B)
def _os_path_join(args_set,callback):
	B=args_set
	if len(B)==1:
		A='';C,=B;D=_B
		for G in C.py__iter__():
			E=G.infer()
			if len(E)!=1:break
			F=get_str_or_none(next(iter(E)))
			if F is _A:break
			if not D:A+=os.path.sep
			A+=F;D=_C
		else:return ValueSet([compiled.create_simple_object(C.inference_state,A)])
	return callback()
_implemented={_F:{'getattr':builtins_getattr,'type':builtins_type,'super':builtins_super,'reversed':builtins_reversed,'isinstance':builtins_isinstance,'next':builtins_next,'iter':builtins_iter,'staticmethod':builtins_staticmethod,'classmethod':builtins_classmethod,_I:builtins_property},'copy':{'copy':_return_first_param,'deepcopy':_return_first_param},'json':{'load':lambda value,arguments,callback:NO_VALUES,'loads':lambda value,arguments,callback:NO_VALUES},'collections':{'namedtuple':collections_namedtuple},'functools':{'partial':functools_partial,'partialmethod':functools_partialmethod,'wraps':_functools_wraps},'_weakref':{'proxy':_return_first_param},'random':{'choice':_random_choice},'operator':{'itemgetter':_operator_itemgetter},'abc':{'abstractmethod':_return_first_param},'typing':{'_alias':lambda value,arguments,callback:NO_VALUES,'runtime_checkable':lambda value,arguments,callback:NO_VALUES},'dataclasses':{'dataclass':_dataclass},'attr':{_L:_dataclass,_M:_dataclass},'attrs':{_L:_dataclass,_M:_dataclass},_K:{'dirname':_create_string_input_function(os.path.dirname),'abspath':_create_string_input_function(os.path.abspath),'relpath':_create_string_input_function(os.path.relpath),'join':_os_path_join}}
def get_metaclass_filters(func):
	def A(cls,metaclasses,is_instance):
		B=metaclasses;A=cls
		for C in B:
			if C.py__name__()=='EnumMeta'and C.get_root_context().py__name__()=='enum':D=ParserTreeFilter(parent_context=A.as_context());return[DictFilter({B.string_name:EnumInstance(A,B).name for B in D.values()})]
		return func(A,B,is_instance)
	return A
class EnumInstance(LazyValueWrapper):
	def __init__(A,cls,name):A.inference_state=cls.inference_state;A._cls=cls;A._name=name;A.tree_node=A._name.tree_name
	@safe_property
	def name(self):return ValueName(self,self._name.tree_name)
	def _get_wrapped_value(A):
		B=A._name.string_name
		if B.startswith('__')and B.endswith('__')or A._name.api_type=='function':
			C=A._name.infer()
			if C:return next(iter(C))
			D,=A.inference_state.builtins_module.py__getattribute__('object');return D
		E,=A._cls.execute_with_values();return E
	def get_filters(A,origin_scope=_A):
		yield DictFilter(dict(name=compiled.create_simple_object(A.inference_state,A._name.string_name).name,value=A._name))
		for B in A._get_wrapped_value().get_filters():yield B
def tree_name_to_values(func):
	def A(inference_state,context,tree_name):
		C=tree_name;B=inference_state;A=context
		if C.value=='sep'and A.is_module()and A.py__name__()==_K:return ValueSet({compiled.create_simple_object(B,os.path.sep)})
		return func(B,A,C)
	return A