'\nUtilities for end-users.\n'
import __main__
from collections import namedtuple
import logging,traceback,re,os,sys
from jedi import Interpreter
READLINE_DEBUG=False
def setup_readline(namespace_module=__main__,fuzzy=False):
	'\n    This function sets up :mod:`readline` to use Jedi in a Python interactive\n    shell.\n\n    If you want to use a custom ``PYTHONSTARTUP`` file (typically\n    ``$HOME/.pythonrc.py``), you can add this piece of code::\n\n        try:\n            from jedi.utils import setup_readline\n        except ImportError:\n            # Fallback to the stdlib readline completer if it is installed.\n            # Taken from http://docs.python.org/2/library/rlcompleter.html\n            print("Jedi is not installed, falling back to readline")\n            try:\n                import readline\n                import rlcompleter\n                readline.parse_and_bind("tab: complete")\n            except ImportError:\n                print("Readline is not installed either. No tab completion is enabled.")\n        else:\n            setup_readline()\n\n    This will fallback to the readline completer if Jedi is not installed.\n    The readline completer will only complete names in the global namespace,\n    so for example::\n\n        ran<TAB>\n\n    will complete to ``range``.\n\n    With Jedi the following code::\n\n        range(10).cou<TAB>\n\n    will complete to ``range(10).count``, this does not work with the default\n    cPython :mod:`readline` completer.\n\n    You will also need to add ``export PYTHONSTARTUP=$HOME/.pythonrc.py`` to\n    your shell profile (usually ``.bash_profile`` or ``.profile`` if you use\n    bash).\n    '
	if READLINE_DEBUG:logging.basicConfig(filename='/tmp/jedi.log',filemode='a',level=logging.DEBUG)
	class B:
		def complete(B,text,state):
			'\n            This complete stuff is pretty weird, a generator would make\n            a lot more sense, but probably due to backwards compatibility\n            this is still the way how it works.\n\n            The only important part is stuff in the ``state == 0`` flow,\n            everything else has been copied from the ``rlcompleter`` std.\n            library module.\n            ';C=state;A=text
			if C==0:
				sys.path.insert(0,os.getcwd())
				try:logging.debug('Start REPL completion: '+repr(A));E=Interpreter(A,[namespace_module.__dict__]);D=E.complete(fuzzy=fuzzy);logging.debug('REPL completions: %s',D);B.matches=[A[:len(A)-B._like_name_length]+B.name_with_symbols for B in D]
				except:logging.error('REPL Completion error:\n'+traceback.format_exc());raise
				finally:sys.path.pop(0)
			try:return B.matches[C]
			except IndexError:return
	try:import rlcompleter,readline as A
	except ImportError:print('Jedi: Module readline not available.')
	else:A.set_completer(B().complete);A.parse_and_bind('tab: complete');A.parse_and_bind('set completion-ignore-case on');A.parse_and_bind('set show-all-if-unmodified');A.parse_and_bind('set show-all-if-ambiguous on');A.parse_and_bind('set completion-prefix-display-length 2');A.set_completer_delims('')
def version_info():"\n    Returns a namedtuple of Jedi's version, similar to Python's\n    ``sys.version_info``.\n    ";A=namedtuple('Version','major, minor, micro');from jedi import __version__;B=re.findall('[a-z]+|\\d+',__version__);return A(*[A if B==3 else int(A)for(B,A)in enumerate(B)])