'\n.. include:: ../README.md\n\n----\n'
from __future__ import annotations
_A=None
import logging,typing as t
from sqlglot import expressions as exp
from sqlglot.dialects.dialect import Dialect as Dialect,Dialects as Dialects
from sqlglot.diff import diff as diff
from sqlglot.errors import ErrorLevel as ErrorLevel,ParseError as ParseError,TokenError as TokenError,UnsupportedError as UnsupportedError
from sqlglot.expressions import Expression as Expression,alias_ as alias,and_ as and_,case as case,cast as cast,column as column,condition as condition,delete as delete,except_ as except_,from_ as from_,func as func,insert as insert,intersect as intersect,maybe_parse as maybe_parse,merge as merge,not_ as not_,or_ as or_,select as select,subquery as subquery,table_ as table,to_column as to_column,to_identifier as to_identifier,to_table as to_table,union as union
from sqlglot.generator import Generator as Generator
from sqlglot.parser import Parser as Parser
from sqlglot.schema import MappingSchema as MappingSchema,Schema as Schema
from sqlglot.tokens import Token as Token,Tokenizer as Tokenizer,TokenType as TokenType
if t.TYPE_CHECKING:from sqlglot._typing import E;from sqlglot.dialects.dialect import DialectType as DialectType
logger=logging.getLogger('sqlglot')
try:from sqlglot._version import __version__,__version_tuple__
except ImportError:logger.error('Unable to set __version__, run `pip install -e .` or `python setup.py develop` first.')
pretty=False
'Whether to format generated SQL by default.'
def tokenize(sql,read=_A,dialect=_A):'\n    Tokenizes the given SQL string.\n\n    Args:\n        sql: the SQL code string to tokenize.\n        read: the SQL dialect to apply during tokenizing (eg. "spark", "hive", "presto", "mysql").\n        dialect: the SQL dialect (alias for read).\n\n    Returns:\n        The resulting list of tokens.\n    ';return Dialect.get_or_raise(read or dialect).tokenize(sql)
def parse(sql,read=_A,dialect=_A,**A):'\n    Parses the given SQL string into a collection of syntax trees, one per parsed SQL statement.\n\n    Args:\n        sql: the SQL code string to parse.\n        read: the SQL dialect to apply during parsing (eg. "spark", "hive", "presto", "mysql").\n        dialect: the SQL dialect (alias for read).\n        **opts: other `sqlglot.parser.Parser` options.\n\n    Returns:\n        The resulting syntax tree collection.\n    ';return Dialect.get_or_raise(read or dialect).parse(sql,**A)
@t.overload
def parse_one(sql,*,into,**A):...
@t.overload
def parse_one(sql,**A):...
def parse_one(sql,read=_A,dialect=_A,into=_A,**C):
	'\n    Parses the given SQL string and returns a syntax tree for the first parsed SQL statement.\n\n    Args:\n        sql: the SQL code string to parse.\n        read: the SQL dialect to apply during parsing (eg. "spark", "hive", "presto", "mysql").\n        dialect: the SQL dialect (alias for read)\n        into: the SQLGlot Expression to parse into.\n        **opts: other `sqlglot.parser.Parser` options.\n\n    Returns:\n        The syntax tree for the first parsed statement.\n    ';B=dialect;A=sql;B=Dialect.get_or_raise(read or B)
	if into:D=B.parse_into(into,A,**C)
	else:D=B.parse(A,**C)
	for E in D:
		if not E:raise ParseError(f"No expression was parsed from '{A}'")
		return E
	else:raise ParseError(f"No expression was parsed from '{A}'")
def transpile(sql,read=_A,write=_A,identity=True,error_level=_A,**C):'\n    Parses the given SQL string in accordance with the source dialect and returns a list of SQL strings transformed\n    to conform to the target dialect. Each string in the returned list represents a single transformed SQL statement.\n\n    Args:\n        sql: the SQL code string to transpile.\n        read: the source dialect used to parse the input string (eg. "spark", "hive", "presto", "mysql").\n        write: the target dialect into which the input should be transformed (eg. "spark", "hive", "presto", "mysql").\n        identity: if set to `True` and if the target dialect is not specified the source dialect will be used as both:\n            the source and the target dialect.\n        error_level: the desired error level of the parser.\n        **opts: other `sqlglot.generator.Generator` options.\n\n    Returns:\n        The list of transpiled SQL statements.\n    ';A=write;A=(read if A is _A else A)if identity else A;A=Dialect.get_or_raise(A);return[A.generate(B,copy=False,**C)if B else''for B in parse(sql,read,error_level=error_level)]