from __future__ import annotations
_B='this'
_A=True
import typing as t
from sqlglot import exp
from sqlglot.dialects.trino import Trino
from sqlglot.dialects.hive import Hive
from sqlglot.tokens import TokenType
def _generate_as_hive(expression):
	D=False;C='VIEW';A=expression
	if isinstance(A,exp.Create):
		if A.kind=='TABLE':
			B=A.args.get('properties')
			if B and B.find(exp.ExternalProperty):return _A
			if not isinstance(A.expression,exp.Select):return _A
		else:return A.kind!=C
	elif isinstance(A,(exp.Alter,exp.Drop,exp.Describe)):
		if isinstance(A,exp.Drop)and A.kind==C:return D
		return _A
	return D
def _location_property_sql(self,e):
	A='external_location'
	if isinstance(e.parent,exp.Properties):
		B=next((A for A in e.parent.expressions if isinstance(A,exp.Property)and A.name=='table_type'),None)
		if B and B.text('value').lower()=='iceberg':A='location'
	return f"{A}={self.sql(e,_B)}"
class Athena(Trino):
	'\n    Over the years, it looks like AWS has taken various execution engines, bolted on AWS-specific modifications and then\n    built the Athena service around them.\n\n    Thus, Athena is not simply hosted Trino, it\'s more like a router that routes SQL queries to an execution engine depending\n    on the query type.\n\n    As at 2024-09-10, assuming your Athena workgroup is configured to use "Athena engine version 3", the following engines exist:\n\n    Hive:\n     - Accepts mostly the same syntax as Hadoop / Hive\n     - Uses backticks to quote identifiers\n     - Has a distinctive DDL syntax (around things like setting table properties, storage locations etc) that is different from Trino\n     - Used for *most* DDL, with some exceptions that get routed to the Trino engine instead:\n        - CREATE [EXTERNAL] TABLE (without AS SELECT)\n        - ALTER\n        - DROP\n\n    Trino:\n      - Uses double quotes to quote identifiers\n      - Used for DDL operations that involve SELECT queries, eg:\n        - CREATE VIEW / DROP VIEW\n        - CREATE TABLE... AS SELECT\n      - Used for DML operations\n        - SELECT, INSERT, UPDATE, DELETE, MERGE\n\n    The SQLGlot Athena dialect tries to identify which engine a query would be routed to and then uses the parser / generator for that engine\n    rather than trying to create a universal syntax that can handle both types.\n    '
	class Tokenizer(Trino.Tokenizer):'\n        The Tokenizer is flexible enough to tokenize queries across both the Hive and Trino engines\n        ';IDENTIFIERS=['"','`'];KEYWORDS={**Hive.Tokenizer.KEYWORDS,**Trino.Tokenizer.KEYWORDS,'UNLOAD':TokenType.COMMAND}
	class Parser(Trino.Parser):'\n        Parse queries for the Athena Trino execution engine\n        ';STATEMENT_PARSERS={**Trino.Parser.STATEMENT_PARSERS,TokenType.USING:lambda self:self._parse_as_command(self._prev)}
	class _HiveGenerator(Hive.Generator):
		def alter_sql(C,expression):
			A=expression
			if isinstance(A,exp.Alter)and A.kind=='TABLE':
				if A.actions and isinstance(A.actions[0],exp.ColumnDef):B=exp.Schema(expressions=A.actions);A.set('actions',[B])
			return super().alter_sql(A)
	class Generator(Trino.Generator):
		'\n        Generate queries for the Athena Trino execution engine\n        ';PROPERTIES_LOCATION={**Trino.Generator.PROPERTIES_LOCATION,exp.LocationProperty:exp.Properties.Location.POST_WITH};TRANSFORMS={**Trino.Generator.TRANSFORMS,exp.FileFormatProperty:lambda self,e:f"format={self.sql(e,_B)}",exp.PartitionedByProperty:lambda self,e:f"partitioned_by={self.sql(e,_B)}",exp.LocationProperty:_location_property_sql}
		def __init__(C,*A,**B):super().__init__(*A,**B);D={**B,'dialect':'hive'};C._hive_generator=Athena._HiveGenerator(*A,**D)
		def generate(B,expression,copy=_A):
			A=expression
			if _generate_as_hive(A):return B._hive_generator.generate(A,copy)
			return super().generate(A,copy)