from __future__ import annotations
_r='windows'
_q='default'
_p='offset'
_o='quoted_column'
_n='FORMAT_DATETIME'
_m='TO_JSON_STRING'
_l='REGEXP_EXTRACT'
_k='REGEXP_CONTAINS'
_j='GENERATE_ARRAY'
_i='FORMAT_DATE'
_h='DATE_TRUNC'
_g='BEGIN TRANSACTION'
_f='ANY TYPE'
_e='TIMESTAMP_MICROS'
_d='TIMESTAMP_MILLIS'
_c='DATE_DIFF'
_b='bigquery'
_a='is_table'
_Z='qualify'
_Y='OPTIONS'
_X='MD5'
_W='DIV'
_V='NOT DETERMINISTIC'
_U='FLOAT64'
_T='quoted_table'
_S='safe'
_R='TIMESTAMP_SECONDS'
_Q='alias'
_P='INT64'
_O='SUB'
_N='TO_HEX'
_M='BYTES'
_L='zone'
_K='TIME'
_J='ADD'
_I='STRING'
_H='DATE'
_G=None
_F='DATETIME'
_E='.'
_D='TIMESTAMP'
_C='this'
_B=False
_A=True
import logging,re,typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,arg_max_or_min_no_count,binary_from_function,date_add_interval_sql,datestrtodate_sql,build_formatted_time,filter_array_using_unnest,if_sql,inline_array_unless_query,max_or_greatest,min_or_least,no_ilike_sql,build_date_delta_with_interval,regexp_replace_sql,rename_func,sha256_sql,timestrtotime_sql,ts_or_ds_add_cast,unit_to_var
from sqlglot.helper import seq_get,split_num_words
from sqlglot.tokens import TokenType
if t.TYPE_CHECKING:from sqlglot._typing import E,Lit;from sqlglot.optimizer.annotate_types import TypeAnnotator
logger=logging.getLogger('sqlglot')
def _derived_table_values_to_unnest(self,expression):
	B=expression
	if not B.find_ancestor(exp.From,exp.Join):return self.values_sql(B)
	C=[];A=B.args.get(_Q)
	for D in B.find_all(exp.Tuple):E=A.columns if A and A.columns else(f"_c{A}"for A in range(len(D.expressions)));F=[exp.PropertyEQ(this=exp.to_identifier(A),expression=B)for(A,B)in zip(E,D.expressions)];C.append(exp.Struct(expressions=F))
	G=exp.TableAlias(columns=[A.this])if A else _G;return self.unnest_sql(exp.Unnest(expressions=[exp.array(*C,copy=_B)],alias=G))
def _returnsproperty_sql(self,expression):
	B=self;A=expression.this
	if isinstance(A,exp.Schema):A=f"{B.sql(A,_C)} <{B.expressions(A)}>"
	else:A=B.sql(A)
	return f"RETURNS {A}"
def _create_sql(self,expression):
	A=expression;B=A.find(exp.ReturnsProperty)
	if A.kind=='FUNCTION'and B and B.args.get(_a):
		A.set('kind','TABLE FUNCTION')
		if isinstance(A.expression,(exp.Subquery,exp.Literal)):A.set('expression',A.expression.this)
	return self.create_sql(A)
def _alias_ordered_group(expression):
	A=expression
	if isinstance(A,exp.Select):
		C=A.args.get('group');E=A.args.get('order')
		if C and E:
			F={A.this:A.args[_Q]for A in A.selects if isinstance(A,exp.Alias)}
			for B in C.expressions:
				if B.is_int:continue
				D=F.get(B)
				if D:B.replace(exp.column(D))
	return A
def _pushdown_cte_column_names(expression):
	"BigQuery doesn't allow column names when defining a CTE, so we try to push them down.";A=expression
	if isinstance(A,exp.CTE)and A.alias_column_names:
		C=A.this
		if C.is_star:logger.warning("Can't push down CTE column names for star queries. Run the query through the optimizer or use 'qualify' to expand the star projections first.");return A
		D=A.alias_column_names;A.args[_Q].set('columns',_G)
		for(E,B)in zip(D,C.selects):
			F=B
			if isinstance(B,exp.Alias):B=B.this
			F.replace(exp.alias_(B,E))
	return A
def _build_parse_timestamp(args):A=args;B=build_formatted_time(exp.StrToTime,_b)([seq_get(A,1),seq_get(A,0)]);B.set(_L,seq_get(A,2));return B
def _build_timestamp(args):A=exp.Timestamp.from_arg_list(args);A.set('with_tz',_A);return A
def _build_date(args):A=exp.DateFromParts if len(args)==3 else exp.Date;return A.from_arg_list(args)
def _build_to_hex(args):A=seq_get(args,0);return exp.MD5(this=A.this)if isinstance(A,exp.MD5Digest)else exp.LowerHex(this=A)
def _array_contains_sql(self,expression):B='_col';A=expression;return self.sql(exp.Exists(this=exp.select('1').from_(exp.Unnest(expressions=[A.left]).as_('_unnest',table=[B])).where(exp.column(B).eq(A.right))))
def _ts_or_ds_add_sql(self,expression):return date_add_interval_sql(_H,_J)(self,ts_or_ds_add_cast(expression))
def _ts_or_ds_diff_sql(self,expression):A=expression;A.this.replace(exp.cast(A.this,exp.DataType.Type.TIMESTAMP));A.expression.replace(exp.cast(A.expression,exp.DataType.Type.TIMESTAMP));B=unit_to_var(A);return self.func(_c,A.this,A.expression,B)
def _unix_to_time_sql(self,expression):
	D=expression;A=self;B=D.args.get('scale');C=D.this
	if B in(_G,exp.UnixToTime.SECONDS):return A.func(_R,C)
	if B==exp.UnixToTime.MILLIS:return A.func(_d,C)
	if B==exp.UnixToTime.MICROS:return A.func(_e,C)
	E=exp.cast(exp.Div(this=C,expression=exp.func('POW',10,B)),exp.DataType.Type.BIGINT);return A.func(_R,E)
def _build_time(args):
	A=args
	if len(A)==1:return exp.TsOrDsToTime(this=A[0])
	if len(A)==2:return exp.Time.from_arg_list(A)
	return exp.TimeFromParts.from_arg_list(A)
def _build_datetime(args):
	A=args
	if len(A)==1:return exp.TsOrDsToTimestamp.from_arg_list(A)
	if len(A)==2:return exp.Datetime.from_arg_list(A)
	return exp.TimestampFromParts.from_arg_list(A)
def _build_regexp_extract(args):
	A=args
	try:B=re.compile(A[1].name).groups==1
	except re.error:B=_B
	return exp.RegexpExtract(this=seq_get(A,0),expression=seq_get(A,1),position=seq_get(A,2),occurrence=seq_get(A,3),group=exp.Literal.number(1)if B else _G)
def _str_to_datetime_sql(self,expression):
	B=expression;A=self;D=A.sql(B,_C);E=_H if isinstance(B,exp.StrToDate)else _D
	if B.args.get(_S):C=A.format_time(B,A.dialect.INVERSE_FORMAT_MAPPING,A.dialect.INVERSE_FORMAT_TRIE);return f"SAFE_CAST({D} AS {E} FORMAT {C})"
	C=A.format_time(B);return A.func(f"PARSE_{E}",C,D,B.args.get(_L))
def _annotate_math_functions(self,expression):'\n    Many BigQuery math functions such as CEIL, FLOOR etc follow this return type convention:\n    +---------+---------+---------+------------+---------+\n    |  INPUT  | INT64   | NUMERIC | BIGNUMERIC | FLOAT64 |\n    +---------+---------+---------+------------+---------+\n    |  OUTPUT | FLOAT64 | NUMERIC | BIGNUMERIC | FLOAT64 |\n    +---------+---------+---------+------------+---------+\n    ';A=expression;self._annotate_args(A);B=A.this;self._set_type(A,exp.DataType.Type.DOUBLE if B.is_type(*exp.DataType.INTEGER_TYPES)else B.type);return A
class BigQuery(Dialect):
	WEEK_OFFSET=-1;UNNEST_COLUMN_ONLY=_A;SUPPORTS_USER_DEFINED_TYPES=_B;SUPPORTS_SEMI_ANTI_JOIN=_B;LOG_BASE_FIRST=_B;HEX_LOWERCASE=_A;FORCE_EARLY_ALIAS_REF_EXPANSION=_A;EXPAND_ALIAS_REFS_EARLY_ONLY_IN_GROUP_BY=_A;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE;NORMALIZE_FUNCTIONS=_B;TIME_MAPPING={'%D':'%m/%d/%y','%E6S':'%S.%f','%e':'%-d'};FORMAT_MAPPING={'DD':'%d','MM':'%m','MON':'%b','MONTH':'%B','YYYY':'%Y','YY':'%y','HH':'%I','HH12':'%I','HH24':'%H','MI':'%M','SS':'%S','SSSSS':'%f','TZH':'%z'};PSEUDOCOLUMNS={'_PARTITIONTIME','_PARTITIONDATE'};SET_OP_DISTINCT_BY_DEFAULT=dict.fromkeys((exp.Except,exp.Intersect,exp.Union),_G);ANNOTATORS={**Dialect.ANNOTATORS,**{A:lambda self,e:_annotate_math_functions(self,e)for A in(exp.Floor,exp.Ceil,exp.Log,exp.Ln,exp.Sqrt,exp.Exp,exp.Round)},exp.Sign:lambda self,e:self._annotate_by_args(e,_C)}
	def normalize_identifier(C,expression):
		B=expression
		if isinstance(B,exp.Identifier)and C.normalization_strategy is not NormalizationStrategy.CASE_SENSITIVE:
			A=B.parent
			while isinstance(A,exp.Dot):A=A.parent
			D=isinstance(A,exp.UserDefinedFunction)or isinstance(A,exp.Table)and A.db and(A.meta.get(_T)or not A.meta.get('maybe_column'))or B.meta.get(_a)
			if not D:B.set(_C,B.this.lower())
		return B
	class Tokenizer(tokens.Tokenizer):QUOTES=["'",'"','"""',"'''"];COMMENTS=['--','#',('/*','*/')];IDENTIFIERS=['`'];STRING_ESCAPES=['\\'];HEX_STRINGS=[('0x',''),('0X','')];BYTE_STRINGS=[(B+A,A)for A in t.cast(t.List[str],QUOTES)for B in('b','B')];RAW_STRINGS=[(B+A,A)for A in t.cast(t.List[str],QUOTES)for B in('r','R')];KEYWORDS={**tokens.Tokenizer.KEYWORDS,_f:TokenType.VARIANT,'BEGIN':TokenType.COMMAND,_g:TokenType.BEGIN,'BYTEINT':TokenType.INT,_M:TokenType.BINARY,'CURRENT_DATETIME':TokenType.CURRENT_DATETIME,_F:TokenType.TIMESTAMP,'DECLARE':TokenType.COMMAND,'ELSEIF':TokenType.COMMAND,'EXCEPTION':TokenType.COMMAND,_U:TokenType.DOUBLE,'FOR SYSTEM_TIME':TokenType.TIMESTAMP_SNAPSHOT,'MODEL':TokenType.MODEL,_V:TokenType.VOLATILE,'RECORD':TokenType.STRUCT,_D:TokenType.TIMESTAMPTZ};KEYWORDS.pop(_W);KEYWORDS.pop('VALUES');KEYWORDS.pop('/*+')
	class Parser(parser.Parser):
		PREFIXED_PIVOT_COLUMNS=_A;LOG_DEFAULTS_TO_LN=_A;SUPPORTS_IMPLICIT_UNNEST=_A;FUNCTIONS={**parser.Parser.FUNCTIONS,_H:_build_date,'DATE_ADD':build_date_delta_with_interval(exp.DateAdd),'DATE_SUB':build_date_delta_with_interval(exp.DateSub),_h:lambda args:exp.DateTrunc(unit=exp.Literal.string(str(seq_get(args,1))),this=seq_get(args,0)),_F:_build_datetime,'DATETIME_ADD':build_date_delta_with_interval(exp.DatetimeAdd),'DATETIME_SUB':build_date_delta_with_interval(exp.DatetimeSub),_W:binary_from_function(exp.IntDiv),_i:lambda args:exp.TimeToStr(this=exp.TsOrDsToDate(this=seq_get(args,1)),format=seq_get(args,0)),_j:exp.GenerateSeries.from_arg_list,'JSON_EXTRACT_SCALAR':lambda args:exp.JSONExtractScalar(this=seq_get(args,0),expression=seq_get(args,1)or exp.Literal.string('$')),'LENGTH':lambda args:exp.Length(this=seq_get(args,0),binary=_A),_X:exp.MD5Digest.from_arg_list,_N:_build_to_hex,'PARSE_DATE':lambda args:build_formatted_time(exp.StrToDate,_b)([seq_get(args,1),seq_get(args,0)]),'PARSE_TIMESTAMP':_build_parse_timestamp,_k:exp.RegexpLike.from_arg_list,_l:_build_regexp_extract,'SHA256':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(256)),'SHA512':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(512)),'SPLIT':lambda args:exp.Split(this=seq_get(args,0),expression=seq_get(args,1)or exp.Literal.string(',')),_K:_build_time,'TIME_ADD':build_date_delta_with_interval(exp.TimeAdd),'TIME_SUB':build_date_delta_with_interval(exp.TimeSub),_D:_build_timestamp,'TIMESTAMP_ADD':build_date_delta_with_interval(exp.TimestampAdd),'TIMESTAMP_SUB':build_date_delta_with_interval(exp.TimestampSub),_e:lambda args:exp.UnixToTime(this=seq_get(args,0),scale=exp.UnixToTime.MICROS),_d:lambda args:exp.UnixToTime(this=seq_get(args,0),scale=exp.UnixToTime.MILLIS),_R:lambda args:exp.UnixToTime(this=seq_get(args,0)),_m:exp.JSONFormat.from_arg_list,_n:lambda args:exp.TimeToStr(this=exp.TsOrDsToTimestamp(this=seq_get(args,1)),format=seq_get(args,0))};FUNCTION_PARSERS={**parser.Parser.FUNCTION_PARSERS,'ARRAY':lambda self:self.expression(exp.Array,expressions=[self._parse_statement()])};FUNCTION_PARSERS.pop('TRIM');NO_PAREN_FUNCTIONS={**parser.Parser.NO_PAREN_FUNCTIONS,TokenType.CURRENT_DATETIME:exp.CurrentDatetime};NESTED_TYPE_TOKENS={*parser.Parser.NESTED_TYPE_TOKENS,TokenType.TABLE};PROPERTY_PARSERS={**parser.Parser.PROPERTY_PARSERS,_V:lambda self:self.expression(exp.StabilityProperty,this=exp.Literal.string('VOLATILE')),_Y:lambda self:self._parse_with_property()};CONSTRAINT_PARSERS={**parser.Parser.CONSTRAINT_PARSERS,_Y:lambda self:exp.Properties(expressions=self._parse_with_property())};RANGE_PARSERS=parser.Parser.RANGE_PARSERS.copy();RANGE_PARSERS.pop(TokenType.OVERLAPS);NULL_TOKENS={TokenType.NULL,TokenType.UNKNOWN};STATEMENT_PARSERS={**parser.Parser.STATEMENT_PARSERS,TokenType.ELSE:lambda self:self._parse_as_command(self._prev),TokenType.END:lambda self:self._parse_as_command(self._prev),TokenType.FOR:lambda self:self._parse_for_in()};BRACKET_OFFSETS={'OFFSET':(0,_B),'ORDINAL':(1,_B),'SAFE_OFFSET':(0,_A),'SAFE_ORDINAL':(1,_A)}
		def _parse_for_in(A):B=A._parse_range();A._match_text_seq('DO');return A.expression(exp.ForIn,this=B,expression=A._parse_statement())
		def _parse_table_part(A,schema=_B):
			B=super()._parse_table_part(schema=schema)or A._parse_number()
			if isinstance(B,exp.Identifier):
				C=B.name
				while A._match(TokenType.DASH,advance=_B)and A._next:
					D=''
					while A._is_connected()and A._curr.token_type!=TokenType.DOT:A._advance();D+=A._prev.text
					C+=D
				B=exp.Identifier(this=C,quoted=B.args.get('quoted'))
			elif isinstance(B,exp.Literal):
				C=B.name
				if A._is_connected()and A._parse_var(any_token=_A):C+=A._prev.text
				B=exp.Identifier(this=C,quoted=_A)
			return B
		def _parse_table_parts(H,schema=_B,is_db_reference=_B,wildcard=_B):
			D='db';A=super()._parse_table_parts(schema=schema,is_db_reference=is_db_reference,wildcard=_A)
			if not A.catalog:
				if A.db:
					B=A.db.split(_E)
					if len(B)==2 and not A.args[D].quoted:A.set('catalog',exp.Identifier(this=B[0]));A.set(D,exp.Identifier(this=B[1]))
				else:
					B=A.name.split(_E)
					if len(B)==2 and not A.this.quoted:A.set(D,exp.Identifier(this=B[0]));A.set(_C,exp.Identifier(this=B[1]))
			if isinstance(A.this,exp.Identifier)and any(_E in A.name for A in A.parts):
				F,G,C,*E=(exp.to_identifier(A,quoted=_A)for A in split_num_words(_E.join(A.name for A in A.parts),_E,3))
				if E and C:C=exp.Dot.build([C,*E])
				A=exp.Table(this=C,db=G,catalog=F,pivots=A.args.get('pivots'));A.meta[_T]=_A
			return A
		def _parse_column(H):
			A=super()._parse_column()
			if isinstance(A,exp.Column):
				C=A.parts
				if any(_E in A.name for A in C):
					E,F,G,B,*D=(exp.to_identifier(A,quoted=_A)for A in split_num_words(_E.join(A.name for A in C),_E,4))
					if D and B:B=exp.Dot.build([B,*D])
					A=exp.Column(this=B,table=G,db=F,catalog=E);A.meta[_o]=_A
			return A
		@t.overload
		def _parse_json_object(self,agg):...
		@t.overload
		def _parse_json_object(self,agg):...
		def _parse_json_object(E,agg=_B):
			B=super()._parse_json_object();A=seq_get(B.expressions,0)
			if A and isinstance(A.this,exp.Array)and isinstance(A.expression,exp.Array):C=A.this.expressions;D=A.expression.expressions;B.set('expressions',[exp.JSONKeyValue(this=A,expression=B)for(A,B)in zip(C,D)])
			return B
		def _parse_bracket(C,this=_G):
			A=super()._parse_bracket(this)
			if this is A:return A
			if isinstance(A,exp.Bracket):
				for B in A.expressions:
					D=B.name.upper()
					if D not in C.BRACKET_OFFSETS:break
					E,F=C.BRACKET_OFFSETS[D];A.set(_p,E);A.set(_S,F);B.replace(B.expressions[0])
			return A
		def _parse_unnest(D,with_alias=_A):
			B=super()._parse_unnest(with_alias=with_alias)
			if not B:return
			A=seq_get(B.expressions,0)
			if A:
				from sqlglot.optimizer.annotate_types import annotate_types as C;A=C(A)
				if A.is_type(exp.DataType.Type.ARRAY)and any(A.is_type(exp.DataType.Type.STRUCT)for A in A._type.expressions):B.set('explode_array',_A)
			return B
	class Generator(generator.Generator):
		INTERVAL_ALLOWS_PLURAL_FORM=_B;JOIN_HINTS=_B;QUERY_HINTS=_B;TABLE_HINTS=_B;LIMIT_FETCH='LIMIT';RENAME_TABLE_WITH_DB=_B;NVL2_SUPPORTED=_B;UNNEST_WITH_ORDINALITY=_B;COLLATE_IS_FUNC=_A;LIMIT_ONLY_LITERALS=_A;SUPPORTS_TABLE_ALIAS_COLUMNS=_B;UNPIVOT_ALIASES_ARE_IDENTIFIERS=_B;JSON_KEY_VALUE_PAIR_SEP=',';NULL_ORDERING_SUPPORTED=_B;IGNORE_NULLS_IN_FUNC=_A;JSON_PATH_SINGLE_QUOTE_ESCAPE=_A;CAN_IMPLEMENT_ARRAY_ANY=_A;SUPPORTS_TO_NUMBER=_B;NAMED_PLACEHOLDER_TOKEN='@';HEX_FUNC=_N;WITH_PROPERTIES_PREFIX=_Y;SUPPORTS_EXPLODING_PROJECTIONS=_B;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_B;TRANSFORMS={**generator.Generator.TRANSFORMS,exp.ApproxDistinct:rename_func('APPROX_COUNT_DISTINCT'),exp.ArgMax:arg_max_or_min_no_count('MAX_BY'),exp.ArgMin:arg_max_or_min_no_count('MIN_BY'),exp.Array:inline_array_unless_query,exp.ArrayContains:_array_contains_sql,exp.ArrayFilter:filter_array_using_unnest,exp.ArraySize:rename_func('ARRAY_LENGTH'),exp.Cast:transforms.preprocess([transforms.remove_precision_parameterized_types]),exp.CollateProperty:lambda self,e:f"DEFAULT COLLATE {self.sql(e,_C)}"if e.args.get(_q)else f"COLLATE {self.sql(e,_C)}",exp.Commit:lambda*A:'COMMIT TRANSACTION',exp.CountIf:rename_func('COUNTIF'),exp.Create:_create_sql,exp.CTE:transforms.preprocess([_pushdown_cte_column_names]),exp.DateAdd:date_add_interval_sql(_H,_J),exp.DateDiff:lambda self,e:self.func(_c,e.this,e.expression,unit_to_var(e)),exp.DateFromParts:rename_func(_H),exp.DateStrToDate:datestrtodate_sql,exp.DateSub:date_add_interval_sql(_H,_O),exp.DatetimeAdd:date_add_interval_sql(_F,_J),exp.DatetimeSub:date_add_interval_sql(_F,_O),exp.DateTrunc:lambda self,e:self.func(_h,e.this,e.text('unit')),exp.FromTimeZone:lambda self,e:self.func(_F,self.func(_D,e.this,e.args.get(_L)),"'UTC'"),exp.GenerateSeries:rename_func(_j),exp.GroupConcat:rename_func('STRING_AGG'),exp.Hex:lambda self,e:self.func('UPPER',self.func(_N,self.sql(e,_C))),exp.If:if_sql(false_value='NULL'),exp.ILike:no_ilike_sql,exp.IntDiv:rename_func(_W),exp.JSONFormat:rename_func(_m),exp.Max:max_or_greatest,exp.MD5:lambda self,e:self.func(_N,self.func(_X,e.this)),exp.MD5Digest:rename_func(_X),exp.Min:min_or_least,exp.PartitionedByProperty:lambda self,e:f"PARTITION BY {self.sql(e,_C)}",exp.RegexpExtract:lambda self,e:self.func(_l,e.this,e.expression,e.args.get('position'),e.args.get('occurrence')),exp.RegexpReplace:regexp_replace_sql,exp.RegexpLike:rename_func(_k),exp.ReturnsProperty:_returnsproperty_sql,exp.Rollback:lambda*A:'ROLLBACK TRANSACTION',exp.Select:transforms.preprocess([transforms.explode_to_unnest(),transforms.unqualify_unnest,transforms.eliminate_distinct_on,_alias_ordered_group,transforms.eliminate_semi_and_anti_joins]),exp.SHA:rename_func('SHA1'),exp.SHA2:sha256_sql,exp.StabilityProperty:lambda self,e:'DETERMINISTIC'if e.name=='IMMUTABLE'else _V,exp.StrToDate:_str_to_datetime_sql,exp.StrToTime:_str_to_datetime_sql,exp.TimeAdd:date_add_interval_sql(_K,_J),exp.TimeFromParts:rename_func(_K),exp.TimestampFromParts:rename_func(_F),exp.TimeSub:date_add_interval_sql(_K,_O),exp.TimestampAdd:date_add_interval_sql(_D,_J),exp.TimestampDiff:rename_func('TIMESTAMP_DIFF'),exp.TimestampSub:date_add_interval_sql(_D,_O),exp.TimeStrToTime:timestrtotime_sql,exp.Transaction:lambda*A:_g,exp.TsOrDsAdd:_ts_or_ds_add_sql,exp.TsOrDsDiff:_ts_or_ds_diff_sql,exp.TsOrDsToTime:rename_func(_K),exp.TsOrDsToTimestamp:rename_func(_F),exp.Unhex:rename_func('FROM_HEX'),exp.UnixDate:rename_func('UNIX_DATE'),exp.UnixToTime:_unix_to_time_sql,exp.Uuid:lambda*A:'GENERATE_UUID()',exp.Values:_derived_table_values_to_unnest,exp.VariancePop:rename_func('VAR_POP')};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.BIGDECIMAL:'BIGNUMERIC',exp.DataType.Type.BIGINT:_P,exp.DataType.Type.BINARY:_M,exp.DataType.Type.BOOLEAN:'BOOL',exp.DataType.Type.CHAR:_I,exp.DataType.Type.DECIMAL:'NUMERIC',exp.DataType.Type.DOUBLE:_U,exp.DataType.Type.FLOAT:_U,exp.DataType.Type.INT:_P,exp.DataType.Type.NCHAR:_I,exp.DataType.Type.NVARCHAR:_I,exp.DataType.Type.SMALLINT:_P,exp.DataType.Type.TEXT:_I,exp.DataType.Type.TIMESTAMP:_F,exp.DataType.Type.TIMESTAMPTZ:_D,exp.DataType.Type.TIMESTAMPLTZ:_D,exp.DataType.Type.TINYINT:_P,exp.DataType.Type.ROWVERSION:_M,exp.DataType.Type.UUID:_I,exp.DataType.Type.VARBINARY:_M,exp.DataType.Type.VARCHAR:_I,exp.DataType.Type.VARIANT:_f};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.PartitionedByProperty:exp.Properties.Location.POST_SCHEMA,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED};AFTER_HAVING_MODIFIER_TRANSFORMS={_Z:generator.Generator.AFTER_HAVING_MODIFIER_TRANSFORMS[_Z],_r:generator.Generator.AFTER_HAVING_MODIFIER_TRANSFORMS[_r]};RESERVED_KEYWORDS={'all','and','any','array','as','asc','assert_rows_modified','at','between','by','case','cast','collate','contains','create','cross','cube','current',_q,'define','desc','distinct','else','end','enum','escape','except','exclude','exists','extract','false','fetch','following','for','from','full','group','grouping','groups','hash','having','if','ignore','in','inner','intersect','interval','into','is','join','lateral','left','like','limit','lookup','merge','natural','new','no','not','null','nulls','of','on','or','order','outer','over','partition','preceding','proto',_Z,'range','recursive','respect','right','rollup','rows','select','set','some','struct','tablesample','then','to','treat','true','unbounded','union','unnest','using','when','where','window','with','within'}
		def mod_sql(D,expression):C=expression;A=C.this;B=C.expression;return D.func('MOD',A.unnest()if isinstance(A,exp.Paren)else A,B.unnest()if isinstance(B,exp.Paren)else B)
		def column_parts(B,expression):
			A=expression
			if A.meta.get(_o):C=_E.join(A.name for A in A.parts[:-1]);D=B.sql(exp.Identifier(this=C,quoted=_A));return f"{D}.{B.sql(A,_C)}"
			return super().column_parts(A)
		def table_parts(B,expression):
			A=expression
			if A.meta.get(_T):C=_E.join(A.name for A in A.parts);return B.sql(exp.Identifier(this=C,quoted=_A))
			return super().table_parts(A)
		def timetostr_sql(B,expression):
			A=expression
			if isinstance(A.this,exp.TsOrDsToTimestamp):C=_n
			else:C=_i
			D=A.this if isinstance(A.this,(exp.TsOrDsToTimestamp,exp.TsOrDsToDate))else A;return B.func(C,B.format_time(A),D.this)
		def eq_sql(B,expression):
			A=expression
			if isinstance(A.left,exp.Null)or isinstance(A.right,exp.Null):
				if not isinstance(A.parent,exp.Update):return'NULL'
			return B.binary(A,'=')
		def attimezone_sql(B,expression):
			A=expression;C=A.parent
			if not isinstance(C,exp.Cast)or not C.to.is_type('text'):return B.func(_D,B.func(_F,A.this,A.args.get(_L)))
			return super().attimezone_sql(A)
		def trycast_sql(A,expression):return A.cast_sql(expression,safe_prefix='SAFE_')
		def bracket_sql(D,expression):
			C=expression;E=C.this;G=C.expressions
			if len(G)==1 and E and E.is_type(exp.DataType.Type.STRUCT):
				B=G[0]
				if B.type is _G:from sqlglot.optimizer.annotate_types import annotate_types as H;B=H(B)
				if B.type and B.type.this in exp.DataType.TEXT_TYPES:return f"{D.sql(E)}.{B.name}"
			A=D.expressions(C,flat=_A);F=C.args.get(_p)
			if F==0:A=f"OFFSET({A})"
			elif F==1:A=f"ORDINAL({A})"
			elif F is not _G:D.unsupported(f"Unsupported array offset: {F}")
			if C.args.get(_S):A=f"SAFE_{A}"
			return f"{D.sql(E)}[{A}]"
		def in_unnest_op(A,expression):return A.sql(expression)
		def version_sql(B,expression):
			A=expression
			if A.name==_D:A.set(_C,'SYSTEM_TIME')
			return super().version_sql(A)