from __future__ import annotations
_j='default'
_i='offset'
_h='position'
_g='JSONExtractString'
_f='params'
_e='argMax'
_d='argMin'
_c='varSamp'
_b='stddevSamp'
_a='TIMESTAMP_ADD'
_Z='TIMESTAMP_SUB'
_Y='DATE_SUB'
_X='DATE_DIFF'
_W='DATE_ADD'
_V='PREWHERE'
_U='SAMPLE'
_T='DICTIONARY'
_S='SCHEMA'
_R='DATABASE'
_Q='STR_TO_DATE'
_P='countIf'
_O='quantiles'
_N='DateTime'
_M='INDEX'
_L='format'
_K='settings'
_J='MD5'
_I='TUPLE'
_H='quantile'
_G='zone'
_F='nullable'
_E='String'
_D='this'
_C=True
_B=None
_A=False
import typing as t,datetime
from sqlglot import exp,generator,parser,tokens
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,arg_max_or_min_no_count,build_date_delta,build_formatted_time,inline_array_sql,json_extract_segments,json_path_key_only_name,no_pivot_sql,build_json_extract_path,rename_func,sha256_sql,var_map_sql,timestamptrunc_sql,unit_to_var,trim_sql
from sqlglot.generator import Generator
from sqlglot.helper import is_int,seq_get
from sqlglot.tokens import Token,TokenType
DATEΤΙΜΕ_DELTA=t.Union[exp.DateAdd,exp.DateDiff,exp.DateSub,exp.TimestampSub,exp.TimestampAdd]
def _build_date_format(args):
	A=build_formatted_time(exp.TimeToStr,'clickhouse')(args);B=seq_get(args,2)
	if B:A.set(_G,B)
	return A
def _unix_to_time_sql(self,expression):
	E='fromUnixTimestamp';D=expression;A=self;B=D.args.get('scale');C=D.this
	if B in(_B,exp.UnixToTime.SECONDS):return A.func(E,exp.cast(C,exp.DataType.Type.BIGINT))
	if B==exp.UnixToTime.MILLIS:return A.func('fromUnixTimestamp64Milli',exp.cast(C,exp.DataType.Type.BIGINT))
	if B==exp.UnixToTime.MICROS:return A.func('fromUnixTimestamp64Micro',exp.cast(C,exp.DataType.Type.BIGINT))
	if B==exp.UnixToTime.NANOS:return A.func('fromUnixTimestamp64Nano',exp.cast(C,exp.DataType.Type.BIGINT))
	return A.func(E,exp.cast(exp.Div(this=C,expression=exp.func('POW',10,B)),exp.DataType.Type.BIGINT))
def _lower_func(sql):A=sql;B=A.index('(');return A[:B].lower()+A[B:]
def _quantile_sql(self,expression):
	C=expression;A=self;B=C.args[_H];E=f"({A.sql(C,_D)})"
	if isinstance(B,exp.Array):D=A.func(_O,*B)
	else:D=A.func(_H,B)
	return D+E
def _build_count_if(args):
	A=args
	if len(A)==1:return exp.CountIf(this=seq_get(A,0))
	return exp.CombinedAggFunc(this=_P,expressions=A,parts=('count','If'))
def _build_str_to_date(args):
	A=args
	if len(A)==3:return exp.Anonymous(this=_Q,expressions=A)
	B=exp.StrToDate.from_arg_list(A);return exp.cast(B,exp.DataType.build(exp.DataType.Type.DATETIME))
def _datetime_delta_sql(name):
	def A(self,expression):
		A=expression
		if not A.unit:return rename_func(name)(self,A)
		return self.func(name,unit_to_var(A),A.expression,A.this)
	return A
def _timestrtotime_sql(self,expression):
	B=expression;C=B.args.get(_G);D=exp.DataType.build(exp.DataType.Type.TIMESTAMP);A=B.this
	if C:
		D=exp.DataType.build(exp.DataType.Type.TIMESTAMPTZ,expressions=[exp.DataTypeParam(this=C)])
		if isinstance(A,exp.Literal):E=datetime.datetime.fromisoformat(A.name).replace(tzinfo=_B).isoformat(sep=' ');A=exp.Literal.string(E)
	return self.sql(exp.cast(A,D,dialect=self.dialect))
class ClickHouse(Dialect):
	NORMALIZE_FUNCTIONS:bool|str=_A;NULL_ORDERING='nulls_are_last';SUPPORTS_USER_DEFINED_TYPES=_A;SAFE_DIVISION=_C;LOG_BASE_FIRST:t.Optional[bool]=_B;FORCE_EARLY_ALIAS_REF_EXPANSION=_C;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_SENSITIVE;UNESCAPED_SEQUENCES={'\\0':'\x00'};CREATABLE_KIND_MAPPING={_R:_S};SET_OP_DISTINCT_BY_DEFAULT:t.Dict[t.Type[exp.Expression],t.Optional[bool]]={exp.Except:_A,exp.Intersect:_A,exp.Union:_B}
	class Tokenizer(tokens.Tokenizer):COMMENTS=['--','#','#!',('/*','*/')];IDENTIFIERS=['"','`'];STRING_ESCAPES=["'",'\\'];BIT_STRINGS=[('0b','')];HEX_STRINGS=[('0x',''),('0X','')];HEREDOC_STRINGS=['$'];KEYWORDS={**tokens.Tokenizer.KEYWORDS,'ATTACH':TokenType.COMMAND,'DATE32':TokenType.DATE32,'DATETIME64':TokenType.DATETIME64,_T:TokenType.DICTIONARY,'ENUM8':TokenType.ENUM8,'ENUM16':TokenType.ENUM16,'FINAL':TokenType.FINAL,'FIXEDSTRING':TokenType.FIXEDSTRING,'FLOAT32':TokenType.FLOAT,'FLOAT64':TokenType.DOUBLE,'GLOBAL':TokenType.GLOBAL,'INT256':TokenType.INT256,'LOWCARDINALITY':TokenType.LOWCARDINALITY,'MAP':TokenType.MAP,'NESTED':TokenType.NESTED,_U:TokenType.TABLE_SAMPLE,_I:TokenType.STRUCT,'UINT128':TokenType.UINT128,'UINT16':TokenType.USMALLINT,'UINT256':TokenType.UINT256,'UINT32':TokenType.UINT,'UINT64':TokenType.UBIGINT,'UINT8':TokenType.UTINYINT,'IPV4':TokenType.IPV4,'IPV6':TokenType.IPV6,'AGGREGATEFUNCTION':TokenType.AGGREGATEFUNCTION,'SIMPLEAGGREGATEFUNCTION':TokenType.SIMPLEAGGREGATEFUNCTION,'SYSTEM':TokenType.COMMAND,_V:TokenType.PREWHERE};KEYWORDS.pop('/*+');SINGLE_TOKENS={**tokens.Tokenizer.SINGLE_TOKENS,'$':TokenType.HEREDOC_STRING}
	class Parser(parser.Parser):
		MODIFIERS_ATTACHED_TO_SET_OP=_A;INTERVAL_SPANS=_A;FUNCTIONS={**parser.Parser.FUNCTIONS,'ANY':exp.AnyValue.from_arg_list,'ARRAYSUM':exp.ArraySum.from_arg_list,'COUNTIF':_build_count_if,_W:build_date_delta(exp.DateAdd,default_unit=_B),'DATEADD':build_date_delta(exp.DateAdd,default_unit=_B),_X:build_date_delta(exp.DateDiff,default_unit=_B),'DATEDIFF':build_date_delta(exp.DateDiff,default_unit=_B),'DATE_FORMAT':_build_date_format,_Y:build_date_delta(exp.DateSub,default_unit=_B),'DATESUB':build_date_delta(exp.DateSub,default_unit=_B),'FORMATDATETIME':_build_date_format,'JSONEXTRACTSTRING':build_json_extract_path(exp.JSONExtractScalar,zero_based_indexing=_A),'MAP':parser.build_var_map,'MATCH':exp.RegexpLike.from_arg_list,'RANDCANONICAL':exp.Rand.from_arg_list,_Q:_build_str_to_date,_I:exp.Struct.from_arg_list,_Z:build_date_delta(exp.TimestampSub,default_unit=_B),'TIMESTAMPSUB':build_date_delta(exp.TimestampSub,default_unit=_B),_a:build_date_delta(exp.TimestampAdd,default_unit=_B),'TIMESTAMPADD':build_date_delta(exp.TimestampAdd,default_unit=_B),'UNIQ':exp.ApproxDistinct.from_arg_list,'XOR':lambda args:exp.Xor(expressions=args),_J:exp.MD5Digest.from_arg_list,'SHA256':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(256)),'SHA512':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(512))};AGG_FUNCTIONS={'count','min','max','sum','avg','any','stddevPop',_b,'varPop',_c,'corr','covarPop','covarSamp','entropy','exponentialMovingAverage','intervalLengthSum','kolmogorovSmirnovTest','mannWhitneyUTest','median','rankCorr','sumKahan','studentTTest','welchTTest','anyHeavy','anyLast','boundingRatio','first_value','last_value',_d,_e,'avgWeighted','topK','topKWeighted','deltaSum','deltaSumTimestamp','groupArray','groupArrayLast','groupUniqArray','groupArrayInsertAt','groupArrayMovingAvg','groupArrayMovingSum','groupArraySample','groupBitAnd','groupBitOr','groupBitXor','groupBitmap','groupBitmapAnd','groupBitmapOr','groupBitmapXor','sumWithOverflow','sumMap','minMap','maxMap','skewSamp','skewPop','kurtSamp','kurtPop','uniq','uniqExact','uniqCombined','uniqCombined64','uniqHLL12','uniqTheta',_H,_O,'quantileExact','quantilesExact','quantileExactLow','quantilesExactLow','quantileExactHigh','quantilesExactHigh','quantileExactWeighted','quantilesExactWeighted','quantileTiming','quantilesTiming','quantileTimingWeighted','quantilesTimingWeighted','quantileDeterministic','quantilesDeterministic','quantileTDigest','quantilesTDigest','quantileTDigestWeighted','quantilesTDigestWeighted','quantileBFloat16','quantilesBFloat16','quantileBFloat16Weighted','quantilesBFloat16Weighted','simpleLinearRegression','stochasticLinearRegression','stochasticLogisticRegression','categoricalInformationValue','contingency','cramersV','cramersVBiasCorrected','theilsU','maxIntersections','maxIntersectionsPosition','meanZTest','quantileInterpolatedWeighted','quantilesInterpolatedWeighted','quantileGK','quantilesGK','sparkBar','sumCount','largestTriangleThreeBuckets','histogram','sequenceMatch','sequenceCount','windowFunnel','retention','uniqUpTo','sequenceNextNode','exponentialTimeDecayedAvg'};AGG_FUNCTIONS_SUFFIXES=['If','Array','ArrayIf','Map','SimpleState','State','Merge','MergeState','ForEach','Distinct','OrDefault','OrNull','Resample','ArgMin','ArgMax'];FUNC_TOKENS={*parser.Parser.FUNC_TOKENS,TokenType.SET};RESERVED_TOKENS=parser.Parser.RESERVED_TOKENS-{TokenType.SELECT};ID_VAR_TOKENS={*parser.Parser.ID_VAR_TOKENS,TokenType.LIKE};AGG_FUNC_MAPPING=(lambda functions,suffixes:{f"{B}{A}":(B,A)for A in suffixes+['']for B in functions})(AGG_FUNCTIONS,AGG_FUNCTIONS_SUFFIXES);FUNCTIONS_WITH_ALIASED_ARGS={*parser.Parser.FUNCTIONS_WITH_ALIASED_ARGS,_I};FUNCTION_PARSERS={**parser.Parser.FUNCTION_PARSERS,'ARRAYJOIN':lambda self:self.expression(exp.Explode,this=self._parse_expression()),'QUANTILE':lambda self:self._parse_quantile(),'COLUMNS':lambda self:self._parse_columns()};FUNCTION_PARSERS.pop('MATCH');NO_PAREN_FUNCTION_PARSERS=parser.Parser.NO_PAREN_FUNCTION_PARSERS.copy();NO_PAREN_FUNCTION_PARSERS.pop('ANY');NO_PAREN_FUNCTIONS=parser.Parser.NO_PAREN_FUNCTIONS.copy();NO_PAREN_FUNCTIONS.pop(TokenType.CURRENT_TIMESTAMP);RANGE_PARSERS={**parser.Parser.RANGE_PARSERS,TokenType.GLOBAL:lambda self,this:self._match(TokenType.IN)and self._parse_in(this,is_global=_C)};COLUMN_OPERATORS=parser.Parser.COLUMN_OPERATORS.copy();COLUMN_OPERATORS.pop(TokenType.PLACEHOLDER);JOIN_KINDS={*parser.Parser.JOIN_KINDS,TokenType.ANY,TokenType.ASOF,TokenType.ARRAY};TABLE_ALIAS_TOKENS=parser.Parser.TABLE_ALIAS_TOKENS-{TokenType.ANY,TokenType.ARRAY,TokenType.FINAL,TokenType.FORMAT,TokenType.SETTINGS};ALIAS_TOKENS=parser.Parser.ALIAS_TOKENS-{TokenType.FORMAT};LOG_DEFAULTS_TO_LN=_C;QUERY_MODIFIER_PARSERS={**parser.Parser.QUERY_MODIFIER_PARSERS,TokenType.SETTINGS:lambda self:(_K,self._advance()or self._parse_csv(self._parse_assignment)),TokenType.FORMAT:lambda self:(_L,self._advance()or self._parse_id_var())};CONSTRAINT_PARSERS={**parser.Parser.CONSTRAINT_PARSERS,_M:lambda self:self._parse_index_constraint(),'CODEC':lambda self:self._parse_compress()};ALTER_PARSERS={**parser.Parser.ALTER_PARSERS,'REPLACE':lambda self:self._parse_alter_table_replace()};SCHEMA_UNNAMED_CONSTRAINTS={*parser.Parser.SCHEMA_UNNAMED_CONSTRAINTS,_M};PLACEHOLDER_PARSERS={**parser.Parser.PLACEHOLDER_PARSERS,TokenType.L_BRACE:lambda self:self._parse_query_parameter()}
		def _parse_types(B,check_func=_A,schema=_A,allow_identifiers=_C):
			A=super()._parse_types(check_func=check_func,schema=schema,allow_identifiers=allow_identifiers)
			if isinstance(A,exp.DataType)and A.args.get(_F)is not _C:A.set(_F,_A)
			return A
		def _parse_extract(A):
			B=A._index;C=A._parse_bitwise()
			if A._match(TokenType.FROM):A._retreat(B);return super()._parse_extract()
			A._match(TokenType.COMMA);return A.expression(exp.Anonymous,this='extract',expressions=[C,A._parse_bitwise()])
		def _parse_assignment(A):
			B=super()._parse_assignment()
			if A._match(TokenType.PLACEHOLDER):return A.expression(exp.If,this=B,true=A._parse_assignment(),false=A._match(TokenType.COLON)and A._parse_assignment())
			return B
		def _parse_query_parameter(A):
			'\n            Parse a placeholder expression like SELECT {abc: UInt32} or FROM {table: Identifier}\n            https://clickhouse.com/docs/en/sql-reference/syntax#defining-and-using-query-parameters\n            ';C=A._parse_id_var();A._match(TokenType.COLON);B=A._parse_types(check_func=_A,allow_identifiers=_A)or A._match_text_seq('IDENTIFIER')and'Identifier'
			if not B:A.raise_error("Expecting a placeholder type or 'Identifier' for tables")
			elif not A._match(TokenType.R_BRACE):A.raise_error('Expecting }')
			return A.expression(exp.Placeholder,this=C,kind=B)
		def _parse_in(B,this,is_global=_A):A=this;A=super()._parse_in(A);A.set('is_global',is_global);return A
		def _parse_table(B,schema=_A,joins=_A,alias_tokens=_B,parse_bracket=_A,is_db_reference=_A,parse_partition=_A):
			A=super()._parse_table(schema=schema,joins=joins,alias_tokens=alias_tokens,parse_bracket=parse_bracket,is_db_reference=is_db_reference)
			if B._match(TokenType.FINAL):A=B.expression(exp.Final,this=A)
			return A
		def _parse_position(A,haystack_first=_A):return super()._parse_position(haystack_first=_C)
		def _parse_cte(A):
			B=A._try_parse(super()._parse_cte)
			if not B:B=A.expression(exp.CTE,this=A._parse_assignment(),alias=A._parse_table_alias(),scalar=_C)
			return B
		def _parse_join_parts(A):
			B=A._match(TokenType.GLOBAL)and A._prev;C=A._match_set(A.JOIN_KINDS,advance=_A)and A._prev
			if C:D=A._match_set(A.JOIN_KINDS)and A._prev;E=A._match_set(A.JOIN_SIDES)and A._prev;return B,E,D
			return B,A._match_set(A.JOIN_SIDES)and A._prev,A._match_set(A.JOIN_KINDS)and A._prev
		def _parse_join(B,skip_join_token=_A,parse_bracket=_A):
			A=super()._parse_join(skip_join_token=skip_join_token,parse_bracket=_C)
			if A:A.set('global',A.args.pop('method',_B))
			return A
		def _parse_function(D,functions=_B,anonymous=_A,optional_parens=_C,any_token=_A):
			B=super()._parse_function(functions=functions,anonymous=anonymous,optional_parens=optional_parens,any_token=any_token);A=B.this if isinstance(B,exp.Window)else B;F=D.AGG_FUNC_MAPPING.get(A.this)if isinstance(A,exp.Anonymous)else _B
			if F:
				C=D._parse_func_params(A);E={_D:A.this,'expressions':A.expressions}
				if F[1]:E['parts']=F;G=exp.CombinedParameterizedAgg if C else exp.CombinedAggFunc
				else:G=exp.ParameterizedAgg if C else exp.AnonymousAggFunc
				E['exp_class']=G
				if C:E[_f]=C
				A=D.expression(**E)
				if isinstance(B,exp.Window):B.set(_D,A)
				elif C:B=D._parse_window(A)
				else:B=A
			return B
		def _parse_func_params(A,this=_B):
			if A._match_pair(TokenType.R_PAREN,TokenType.L_PAREN):return A._parse_csv(A._parse_lambda)
			if A._match(TokenType.L_PAREN):B=A._parse_csv(A._parse_lambda);A._match_r_paren(this);return B
		def _parse_quantile(A):
			B=A._parse_lambda();C=A._parse_func_params()
			if C:return A.expression(exp.Quantile,this=C[0],quantile=B)
			return A.expression(exp.Quantile,this=B,quantile=exp.Literal.number(.5))
		def _parse_wrapped_id_vars(A,optional=_A):return super()._parse_wrapped_id_vars(optional=_C)
		def _parse_primary_key(B,wrapped_optional=_A,in_props=_A):A=in_props;return super()._parse_primary_key(wrapped_optional=wrapped_optional or A,in_props=A)
		def _parse_on_property(A):
			C=A._index
			if A._match_text_seq('CLUSTER'):
				B=A._parse_id_var()
				if B:return A.expression(exp.OnCluster,this=B)
				else:A._retreat(C)
		def _parse_index_constraint(A,kind=_B):B=A._parse_id_var();C=A._parse_assignment();D=A._match_text_seq('TYPE')and(A._parse_function()or A._parse_var());E=A._match_text_seq('GRANULARITY')and A._parse_term();return A.expression(exp.IndexColumnConstraint,this=B,expression=C,index_type=D,granularity=E)
		def _parse_partition(A):
			if not A._match(TokenType.PARTITION):return
			if A._match_text_seq('ID'):B=[A.expression(exp.PartitionId,this=A._parse_string())]
			else:B=A._parse_expressions()
			return A.expression(exp.Partition,expressions=B)
		def _parse_alter_table_replace(A):
			B=A._parse_partition()
			if not B or not A._match(TokenType.FROM):return
			return A.expression(exp.ReplacePartition,expression=B,source=A._parse_table_parts())
		def _parse_projection_def(A):
			if not A._match_text_seq('PROJECTION'):return
			return A.expression(exp.ProjectionDef,this=A._parse_id_var(),expression=A._parse_wrapped(A._parse_statement))
		def _parse_constraint(A):return super()._parse_constraint()or A._parse_projection_def()
		def _parse_alias(A,this,explicit=_A):
			if A._match_pair(TokenType.APPLY,TokenType.L_PAREN,advance=_A):return this
			return super()._parse_alias(this=this,explicit=explicit)
		def _parse_expression(A):
			B=super()._parse_expression()
			while A._match_pair(TokenType.APPLY,TokenType.L_PAREN):B=exp.Apply(this=B,expression=A._parse_var(any_token=_C));A._match(TokenType.R_PAREN)
			return B
		def _parse_columns(A):
			B=A.expression(exp.Columns,this=A._parse_lambda())
			while A._next and A._match_text_seq(')','APPLY','('):A._match(TokenType.R_PAREN);B=exp.Apply(this=B,expression=A._parse_var(any_token=_C))
			return B
	class Generator(generator.Generator):
		QUERY_HINTS=_A;STRUCT_DELIMITER='(',')';NVL2_SUPPORTED=_A;TABLESAMPLE_REQUIRES_PARENS=_A;TABLESAMPLE_SIZE_IS_ROWS=_A;TABLESAMPLE_KEYWORDS=_U;LAST_DAY_SUPPORTS_DATE_PART=_A;CAN_IMPLEMENT_ARRAY_ANY=_C;SUPPORTS_TO_NUMBER=_A;JOIN_HINTS=_A;TABLE_HINTS=_A;GROUPINGS_SEP='';SET_OP_MODIFIERS=_A;SUPPORTS_TABLE_ALIAS_COLUMNS=_A;VALUES_AS_TABLE=_A;STRING_TYPE_MAPPING={exp.DataType.Type.CHAR:_E,exp.DataType.Type.LONGBLOB:_E,exp.DataType.Type.LONGTEXT:_E,exp.DataType.Type.MEDIUMBLOB:_E,exp.DataType.Type.MEDIUMTEXT:_E,exp.DataType.Type.TINYBLOB:_E,exp.DataType.Type.TINYTEXT:_E,exp.DataType.Type.TEXT:_E,exp.DataType.Type.VARBINARY:_E,exp.DataType.Type.VARCHAR:_E};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,**STRING_TYPE_MAPPING,exp.DataType.Type.ARRAY:'Array',exp.DataType.Type.BIGINT:'Int64',exp.DataType.Type.DATE32:'Date32',exp.DataType.Type.DATETIME:_N,exp.DataType.Type.DATETIME64:'DateTime64',exp.DataType.Type.TIMESTAMP:_N,exp.DataType.Type.TIMESTAMPTZ:_N,exp.DataType.Type.DOUBLE:'Float64',exp.DataType.Type.ENUM:'Enum',exp.DataType.Type.ENUM8:'Enum8',exp.DataType.Type.ENUM16:'Enum16',exp.DataType.Type.FIXEDSTRING:'FixedString',exp.DataType.Type.FLOAT:'Float32',exp.DataType.Type.INT:'Int32',exp.DataType.Type.MEDIUMINT:'Int32',exp.DataType.Type.INT128:'Int128',exp.DataType.Type.INT256:'Int256',exp.DataType.Type.LOWCARDINALITY:'LowCardinality',exp.DataType.Type.MAP:'Map',exp.DataType.Type.NESTED:'Nested',exp.DataType.Type.SMALLINT:'Int16',exp.DataType.Type.STRUCT:'Tuple',exp.DataType.Type.TINYINT:'Int8',exp.DataType.Type.UBIGINT:'UInt64',exp.DataType.Type.UINT:'UInt32',exp.DataType.Type.UINT128:'UInt128',exp.DataType.Type.UINT256:'UInt256',exp.DataType.Type.USMALLINT:'UInt16',exp.DataType.Type.UTINYINT:'UInt8',exp.DataType.Type.IPV4:'IPv4',exp.DataType.Type.IPV6:'IPv6',exp.DataType.Type.AGGREGATEFUNCTION:'AggregateFunction',exp.DataType.Type.SIMPLEAGGREGATEFUNCTION:'SimpleAggregateFunction'};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.AnyValue:rename_func('any'),exp.ApproxDistinct:rename_func('uniq'),exp.ArrayFilter:lambda self,e:self.func('arrayFilter',e.expression,e.this),exp.ArraySize:rename_func('LENGTH'),exp.ArraySum:rename_func('arraySum'),exp.ArgMax:arg_max_or_min_no_count(_e),exp.ArgMin:arg_max_or_min_no_count(_d),exp.Array:inline_array_sql,exp.CastToStrType:rename_func('CAST'),exp.CountIf:rename_func(_P),exp.CompressColumnConstraint:lambda self,e:f"CODEC({self.expressions(e,key=_D,flat=_C)})",exp.ComputedColumnConstraint:lambda self,e:f"{"MATERIALIZED"if e.args.get("persisted")else"ALIAS"} {self.sql(e,_D)}",exp.CurrentDate:lambda self,e:self.func('CURRENT_DATE'),exp.DateAdd:_datetime_delta_sql(_W),exp.DateDiff:_datetime_delta_sql(_X),exp.DateStrToDate:rename_func('toDate'),exp.DateSub:_datetime_delta_sql(_Y),exp.Explode:rename_func('arrayJoin'),exp.Final:lambda self,e:f"{self.sql(e,_D)} FINAL",exp.IsNan:rename_func('isNaN'),exp.JSONExtract:json_extract_segments(_g,quoted_index=_A),exp.JSONExtractScalar:json_extract_segments(_g,quoted_index=_A),exp.JSONPathKey:json_path_key_only_name,exp.JSONPathRoot:lambda*A:'',exp.Map:lambda self,e:_lower_func(var_map_sql(self,e)),exp.Nullif:rename_func('nullIf'),exp.PartitionedByProperty:lambda self,e:f"PARTITION BY {self.sql(e,_D)}",exp.Pivot:no_pivot_sql,exp.Quantile:_quantile_sql,exp.RegexpLike:lambda self,e:self.func('match',e.this,e.expression),exp.Rand:rename_func('randCanonical'),exp.StartsWith:rename_func('startsWith'),exp.StrPosition:lambda self,e:self.func(_h,e.this,e.args.get('substr'),e.args.get(_h)),exp.TimeToStr:lambda self,e:self.func('formatDateTime',e.this,self.format_time(e),e.args.get(_G)),exp.TimeStrToTime:_timestrtotime_sql,exp.TimestampAdd:_datetime_delta_sql(_a),exp.TimestampSub:_datetime_delta_sql(_Z),exp.VarMap:lambda self,e:_lower_func(var_map_sql(self,e)),exp.Xor:lambda self,e:self.func('xor',e.this,e.expression,*e.expressions),exp.MD5Digest:rename_func(_J),exp.MD5:lambda self,e:self.func('LOWER',self.func('HEX',self.func(_J,e.this))),exp.SHA:rename_func('SHA1'),exp.SHA2:sha256_sql,exp.UnixToTime:_unix_to_time_sql,exp.TimestampTrunc:timestamptrunc_sql(zone=_C),exp.Trim:trim_sql,exp.Variance:rename_func(_c),exp.SchemaCommentProperty:lambda self,e:self.naked_property(e),exp.Stddev:rename_func(_b),exp.Chr:rename_func('CHAR'),exp.Lag:lambda self,e:self.func('lagInFrame',e.this,e.args.get(_i),e.args.get(_j)),exp.Lead:lambda self,e:self.func('leadInFrame',e.this,e.args.get(_i),e.args.get(_j))};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.OnCluster:exp.Properties.Location.POST_NAME,exp.PartitionedByProperty:exp.Properties.Location.POST_SCHEMA,exp.ToTableProperty:exp.Properties.Location.POST_NAME,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED};ON_CLUSTER_TARGETS={_S,_R,'TABLE','VIEW',_T,_M,'FUNCTION','NAMED COLLECTION'};NON_NULLABLE_TYPES={exp.DataType.Type.ARRAY,exp.DataType.Type.MAP,exp.DataType.Type.STRUCT}
		def strtodate_sql(C,expression):
			A=expression;B=C.function_fallback_sql(A)
			if not isinstance(A.parent,exp.Cast):return f"CAST({B} AS DATE)"
			return B
		def cast_sql(C,expression,safe_prefix=_B):
			A=expression;B=A.this
			if isinstance(B,exp.StrToDate)and A.to==exp.DataType.build('datetime'):return C.sql(B)
			return super().cast_sql(A,safe_prefix=safe_prefix)
		def trycast_sql(C,expression):
			A=expression;B=A.to
			if not B.is_type(*C.NON_NULLABLE_TYPES,check_nullable=_C):B.set(_F,_C)
			return super().cast_sql(A)
		def _jsonpathsubscript_sql(B,expression):A=B.json_path_part(expression.this);return str(int(A)+1)if is_int(A)else A
		def likeproperty_sql(A,expression):return f"AS {A.sql(expression,_D)}"
		def _any_to_has(D,expression,default,prefix=''):
			A=expression
			if isinstance(A.left,exp.Any):B=A.left;C=A.right
			elif isinstance(A.right,exp.Any):B=A.right;C=A.left
			else:return default(A)
			return prefix+D.func('has',B.this.unnest(),C)
		def eq_sql(A,expression):return A._any_to_has(expression,super().eq_sql)
		def neq_sql(A,expression):return A._any_to_has(expression,super().neq_sql,'NOT ')
		def regexpilike_sql(A,expression):B=expression;C=A.func('CONCAT',"'(?i)'",B.expression);return A.func('match',B.this,C)
		def datatype_sql(C,expression):
			A=expression
			if A.this in C.STRING_TYPE_MAPPING:B=_E
			else:B=super().datatype_sql(A)
			D=A.parent;E=A.args.get(_F)
			if E is _C or E is _B and not(isinstance(D,exp.DataType)and D.is_type(exp.DataType.Type.MAP,check_nullable=_C)and A.index in(_B,0))and not A.is_type(*C.NON_NULLABLE_TYPES,check_nullable=_C):B=f"Nullable({B})"
			return B
		def cte_sql(B,expression):
			A=expression
			if A.args.get('scalar'):C=B.sql(A,_D);D=B.sql(A,'alias');return f"{C} AS {D}"
			return super().cte_sql(A)
		def after_limit_modifiers(B,expression):A=expression;return super().after_limit_modifiers(A)+[B.seg('SETTINGS ')+B.expressions(A,key=_K,flat=_C)if A.args.get(_K)else'',B.seg('FORMAT ')+B.sql(A,_L)if A.args.get(_L)else'']
		def parameterizedagg_sql(B,expression):A=expression;C=B.expressions(A,key=_f,flat=_C);return B.func(A.name,*A.expressions)+f"({C})"
		def anonymousaggfunc_sql(B,expression):A=expression;return B.func(A.name,*A.expressions)
		def combinedaggfunc_sql(A,expression):return A.anonymousaggfunc_sql(expression)
		def combinedparameterizedagg_sql(A,expression):return A.parameterizedagg_sql(expression)
		def placeholder_sql(B,expression):A=expression;return f"{{{A.name}: {B.sql(A,"kind")}}}"
		def oncluster_sql(A,expression):return f"ON CLUSTER {A.sql(expression,_D)}"
		def createable_sql(A,expression,locations):
			D=locations;B=expression
			if B.kind in A.ON_CLUSTER_TARGETS and D.get(exp.Properties.Location.POST_NAME):E=A.sql(B.this if isinstance(B.this,exp.Schema)else B,_D);F=' '.join([A.sql(B)for B in D[exp.Properties.Location.POST_NAME]]);C=A.schema_columns_sql(B.this);C=f"{A.sep()}{C}"if C else'';return f"{E}{A.sep()}{F}{C}"
			return super().createable_sql(B,D)
		def create_sql(E,expression):
			C=expression;D=C.expression
			if isinstance(D,exp.Query):
				A=C.find(exp.SchemaCommentProperty)
				if A:A.pop();D.replace(exp.paren(D))
			else:A=_B
			F=super().create_sql(C);B=E.sql(A);B=f" {B}"if B else'';return f"{F}{B}"
		def prewhere_sql(A,expression):B=A.indent(A.sql(expression,_D));return f"{A.seg(_V)}{A.sep()}{B}"
		def indexcolumnconstraint_sql(A,expression):B=expression;C=A.sql(B,_D);C=f" {C}"if C else'';D=A.sql(B,'expression');D=f" {D}"if D else'';E=A.sql(B,'index_type');E=f" TYPE {E}"if E else'';F=A.sql(B,'granularity');F=f" GRANULARITY {F}"if F else'';return f"INDEX{C}{D}{E}{F}"
		def partition_sql(A,expression):return f"PARTITION {A.expressions(expression,flat=_C)}"
		def partitionid_sql(A,expression):return f"ID {A.sql(expression.this)}"
		def replacepartition_sql(A,expression):B=expression;return f"REPLACE {A.sql(B.expression)} FROM {A.sql(B,"source")}"
		def projectiondef_sql(A,expression):B=expression;return f"PROJECTION {A.sql(B.this)} {A.wrap(B.expression)}"