from __future__ import annotations
_i='occurrence'
_h='substr'
_g='spark2'
_f='presto'
_e='databricks'
_d='bigquery'
_c='athena'
_b='false'
_a='true'
_Z='MILLENIUM'
_Y='DECADE'
_X='WEEKISO'
_W='DAYOFYEAR'
_V='DAYOFWEEKISO'
_U='zone'
_T='expression'
_S='CENTURY'
_R='SECOND'
_Q='QUARTER'
_P='DAYOFWEEK'
_O='MONTH'
_N='position'
_M='MINUTE'
_L='HOUR'
_K='WEEK'
_J='NANOSECOND'
_I='DAY'
_H='YEAR'
_G='MICROSECOND'
_F='expressions'
_E='MILLISECOND'
_D='this'
_C=False
_B=True
_A=None
import logging,typing as t
from enum import Enum,auto
from functools import reduce
from sqlglot import exp
from sqlglot.errors import ParseError
from sqlglot.generator import Generator,unsupported_args
from sqlglot.helper import AutoName,flatten,is_int,seq_get,subclasses
from sqlglot.jsonpath import JSONPathTokenizer,parse as parse_json_path
from sqlglot.parser import Parser
from sqlglot.time import TIMEZONES,format_time,subsecond_precision
from sqlglot.tokens import Token,Tokenizer,TokenType
from sqlglot.trie import new_trie
DATE_ADD_OR_DIFF=t.Union[exp.DateAdd,exp.TsOrDsAdd,exp.DateDiff,exp.TsOrDsDiff]
DATE_ADD_OR_SUB=t.Union[exp.DateAdd,exp.TsOrDsAdd,exp.DateSub]
JSON_EXTRACT_TYPE=t.Union[exp.JSONExtract,exp.JSONExtractScalar]
if t.TYPE_CHECKING:from sqlglot._typing import B,E,F;from sqlglot.optimizer.annotate_types import TypeAnnotator;AnnotatorsType=t.Dict[t.Type[E],t.Callable[[TypeAnnotator,E],E]]
logger=logging.getLogger('sqlglot')
UNESCAPED_SEQUENCES={'\\a':'\x07','\\b':'\x08','\\f':'\x0c','\\n':'\n','\\r':'\r','\\t':'\t','\\v':'\x0b','\\\\':'\\'}
def _annotate_with_type_lambda(data_type):return lambda self,e:self._annotate_with_type(e,data_type)
class Dialects(str,Enum):'Dialects supported by SQLGLot.';DIALECT='';ATHENA=_c;BIGQUERY=_d;CLICKHOUSE='clickhouse';DATABRICKS=_e;DORIS='doris';DRILL='drill';DUCKDB='duckdb';HIVE='hive';MATERIALIZE='materialize';MYSQL='mysql';ORACLE='oracle';POSTGRES='postgres';PRESTO=_f;PRQL='prql';REDSHIFT='redshift';RISINGWAVE='risingwave';SNOWFLAKE='snowflake';SPARK='spark';SPARK2=_g;SQLITE='sqlite';STARROCKS='starrocks';TABLEAU='tableau';TERADATA='teradata';TRINO='trino';TSQL='tsql'
class NormalizationStrategy(str,AutoName):'Specifies the strategy according to which identifiers should be normalized.';LOWERCASE=auto();'Unquoted identifiers are lowercased.';UPPERCASE=auto();'Unquoted identifiers are uppercased.';CASE_SENSITIVE=auto();'Always case-sensitive, regardless of quotes.';CASE_INSENSITIVE=auto();'Always case-insensitive, regardless of quotes.'
class _Dialect(type):
	classes:t.Dict[str,t.Type[Dialect]]={}
	def __eq__(B,other):
		A=other
		if B is A:return _B
		if isinstance(A,str):return B is B.get(A)
		if isinstance(A,Dialect):return B is type(A)
		return _C
	def __hash__(A):return hash(A.__name__.lower())
	@classmethod
	def __getitem__(A,key):return A.classes[key]
	@classmethod
	def get(A,key,default=_A):return A.classes.get(key,default)
	def __new__(F,clsname,bases,attrs):
		L='Generator';K='Parser';J='JSONPathTokenizer';I='Tokenizer';G=bases;E=clsname;A=super().__new__(F,E,G,attrs);B=Dialects.__members__.get(E.upper());F.classes[B.value if B is not _A else E.lower()]=A;A.TIME_TRIE=new_trie(A.TIME_MAPPING);A.FORMAT_TRIE=new_trie(A.FORMAT_MAPPING)if A.FORMAT_MAPPING else A.TIME_TRIE;A.INVERSE_TIME_MAPPING={B:A for(A,B)in A.TIME_MAPPING.items()};A.INVERSE_TIME_TRIE=new_trie(A.INVERSE_TIME_MAPPING);A.INVERSE_FORMAT_MAPPING={B:A for(A,B)in A.FORMAT_MAPPING.items()};A.INVERSE_FORMAT_TRIE=new_trie(A.INVERSE_FORMAT_MAPPING);A.INVERSE_CREATABLE_KIND_MAPPING={B:A for(A,B)in A.CREATABLE_KIND_MAPPING.items()};C=seq_get(G,0);M=getattr(C,'tokenizer_class',Tokenizer),;N=getattr(C,'jsonpath_tokenizer_class',JSONPathTokenizer),;O=getattr(C,'parser_class',Parser),;P=getattr(C,'generator_class',Generator),;A.tokenizer_class=A.__dict__.get(I,type(I,M,{}));A.jsonpath_tokenizer_class=A.__dict__.get(J,type(J,N,{}));A.parser_class=A.__dict__.get(K,type(K,O,{}));A.generator_class=A.__dict__.get(L,type(L,P,{}));A.QUOTE_START,A.QUOTE_END=list(A.tokenizer_class._QUOTES.items())[0];A.IDENTIFIER_START,A.IDENTIFIER_END=list(A.tokenizer_class._IDENTIFIERS.items())[0]
		def D(token_type):return next(((A,B)for(A,(B,C))in A.tokenizer_class._FORMAT_STRINGS.items()if C==token_type),(_A,_A))
		A.BIT_START,A.BIT_END=D(TokenType.BIT_STRING);A.HEX_START,A.HEX_END=D(TokenType.HEX_STRING);A.BYTE_START,A.BYTE_END=D(TokenType.BYTE_STRING);A.UNICODE_START,A.UNICODE_END=D(TokenType.UNICODE_STRING)
		if'\\'in A.tokenizer_class.STRING_ESCAPES:A.UNESCAPED_SEQUENCES={**UNESCAPED_SEQUENCES,**A.UNESCAPED_SEQUENCES}
		A.ESCAPED_SEQUENCES={B:A for(A,B)in A.UNESCAPED_SEQUENCES.items()};A.SUPPORTS_COLUMN_JOIN_MARKS='(+)'in A.tokenizer_class.KEYWORDS
		if B not in('',_d):A.generator_class.SELECT_KINDS=()
		if B not in('',_c,_f,'trino'):A.generator_class.TRY_SUPPORTED=_C;A.generator_class.SUPPORTS_UESCAPE=_C
		if B not in('',_e,'hive','spark',_g):
			H=A.generator_class.AFTER_HAVING_MODIFIER_TRANSFORMS.copy()
			for Q in('cluster','distribute','sort'):H.pop(Q,_A)
			A.generator_class.AFTER_HAVING_MODIFIER_TRANSFORMS=H
		if B not in('','doris','mysql'):A.parser_class.ID_VAR_TOKENS=A.parser_class.ID_VAR_TOKENS|{TokenType.STRAIGHT_JOIN};A.parser_class.TABLE_ALIAS_TOKENS=A.parser_class.TABLE_ALIAS_TOKENS|{TokenType.STRAIGHT_JOIN}
		if not A.SUPPORTS_SEMI_ANTI_JOIN:A.parser_class.TABLE_ALIAS_TOKENS=A.parser_class.TABLE_ALIAS_TOKENS|{TokenType.ANTI,TokenType.SEMI}
		return A
class Dialect(metaclass=_Dialect):
	INDEX_OFFSET=0;'The base index offset for arrays.';WEEK_OFFSET=0;'First day of the week in DATE_TRUNC(week). Defaults to 0 (Monday). -1 would be Sunday.';UNNEST_COLUMN_ONLY=_C;'Whether `UNNEST` table aliases are treated as column aliases.';ALIAS_POST_TABLESAMPLE=_C;'Whether the table alias comes after tablesample.';TABLESAMPLE_SIZE_IS_PERCENT=_C;'Whether a size in the table sample clause represents percentage.';NORMALIZATION_STRATEGY=NormalizationStrategy.LOWERCASE;'Specifies the strategy according to which identifiers should be normalized.';IDENTIFIERS_CAN_START_WITH_DIGIT=_C;'Whether an unquoted identifier can start with a digit.';DPIPE_IS_STRING_CONCAT=_B;'Whether the DPIPE token (`||`) is a string concatenation operator.';STRICT_STRING_CONCAT=_C;"Whether `CONCAT`'s arguments must be strings.";SUPPORTS_USER_DEFINED_TYPES=_B;'Whether user-defined data types are supported.';SUPPORTS_SEMI_ANTI_JOIN=_B;'Whether `SEMI` or `ANTI` joins are supported.';SUPPORTS_COLUMN_JOIN_MARKS=_C;'Whether the old-style outer join (+) syntax is supported.';COPY_PARAMS_ARE_CSV=_B;'Separator of COPY statement parameters.';NORMALIZE_FUNCTIONS:bool|str='upper';'\n    Determines how function names are going to be normalized.\n    Possible values:\n        "upper" or True: Convert names to uppercase.\n        "lower": Convert names to lowercase.\n        False: Disables function name normalization.\n    ';LOG_BASE_FIRST:t.Optional[bool]=_B;'\n    Whether the base comes first in the `LOG` function.\n    Possible values: `True`, `False`, `None` (two arguments are not supported by `LOG`)\n    ';NULL_ORDERING='nulls_are_small';'\n    Default `NULL` ordering method to use if not explicitly set.\n    Possible values: `"nulls_are_small"`, `"nulls_are_large"`, `"nulls_are_last"`\n    ';TYPED_DIVISION=_C;'\n    Whether the behavior of `a / b` depends on the types of `a` and `b`.\n    False means `a / b` is always float division.\n    True means `a / b` is integer division if both `a` and `b` are integers.\n    ';SAFE_DIVISION=_C;'Whether division by zero throws an error (`False`) or returns NULL (`True`).';CONCAT_COALESCE=_C;'A `NULL` arg in `CONCAT` yields `NULL` by default, but in some dialects it yields an empty string.';HEX_LOWERCASE=_C;'Whether the `HEX` function returns a lowercase hexadecimal string.';DATE_FORMAT="'%Y-%m-%d'";DATEINT_FORMAT="'%Y%m%d'";TIME_FORMAT="'%Y-%m-%d %H:%M:%S'";TIME_MAPPING:t.Dict[str,str]={};"Associates this dialect's time formats with their equivalent Python `strftime` formats.";FORMAT_MAPPING:t.Dict[str,str]={};"\n    Helper which is used for parsing the special syntax `CAST(x AS DATE FORMAT 'yyyy')`.\n    If empty, the corresponding trie will be constructed off of `TIME_MAPPING`.\n    ";UNESCAPED_SEQUENCES:t.Dict[str,str]={};'Mapping of an escaped sequence (`\\n`) to its unescaped version (`\n`).';PSEUDOCOLUMNS:t.Set[str]=set();'\n    Columns that are auto-generated by the engine corresponding to this dialect.\n    For example, such columns may be excluded from `SELECT *` queries.\n    ';PREFER_CTE_ALIAS_COLUMN=_C;'\n    Some dialects, such as Snowflake, allow you to reference a CTE column alias in the\n    HAVING clause of the CTE. This flag will cause the CTE alias columns to override\n    any projection aliases in the subquery.\n\n    For example,\n        WITH y(c) AS (\n            SELECT SUM(a) FROM (SELECT 1 a) AS x HAVING c > 0\n        ) SELECT c FROM y;\n\n        will be rewritten as\n\n        WITH y(c) AS (\n            SELECT SUM(a) AS c FROM (SELECT 1 AS a) AS x HAVING c > 0\n        ) SELECT c FROM y;\n    ';COPY_PARAMS_ARE_CSV=_B;'\n    Whether COPY statement parameters are separated by comma or whitespace\n    ';FORCE_EARLY_ALIAS_REF_EXPANSION=_C;'\n    Whether alias reference expansion (_expand_alias_refs()) should run before column qualification (_qualify_columns()).\n\n    For example:\n        WITH data AS (\n        SELECT\n            1 AS id,\n            2 AS my_id\n        )\n        SELECT\n            id AS my_id\n        FROM\n            data\n        WHERE\n            my_id = 1\n        GROUP BY\n            my_id,\n        HAVING\n            my_id = 1\n\n    In most dialects, "my_id" would refer to "data.my_id" across the query, except:\n        - BigQuery, which will forward the alias to GROUP BY + HAVING clauses i.e\n          it resolves to "WHERE my_id = 1 GROUP BY id HAVING id = 1"\n        - Clickhouse, which will forward the alias across the query i.e it resolves\n        to "WHERE id = 1 GROUP BY id HAVING id = 1"\n    ';EXPAND_ALIAS_REFS_EARLY_ONLY_IN_GROUP_BY=_C;'Whether alias reference expansion before qualification should only happen for the GROUP BY clause.';SUPPORTS_ORDER_BY_ALL=_C;'\n    Whether ORDER BY ALL is supported (expands to all the selected columns) as in DuckDB, Spark3/Databricks\n    ';HAS_DISTINCT_ARRAY_CONSTRUCTORS=_C;'\n    Whether the ARRAY constructor is context-sensitive, i.e in Redshift ARRAY[1, 2, 3] != ARRAY(1, 2, 3)\n    as the former is of type INT[] vs the latter which is SUPER\n    ';SUPPORTS_FIXED_SIZE_ARRAYS=_C;"\n    Whether expressions such as x::INT[5] should be parsed as fixed-size array defs/casts e.g.\n    in DuckDB. In dialects which don't support fixed size arrays such as Snowflake, this should\n    be interpreted as a subscript/index operator.\n    ";STRICT_JSON_PATH_SYNTAX=_B;'Whether failing to parse a JSON path expression using the JSONPath dialect will log a warning.';ON_CONDITION_EMPTY_BEFORE_ERROR=_B;'Whether "X ON EMPTY" should come before "X ON ERROR" (for dialects like T-SQL, MySQL, Oracle).';ARRAY_AGG_INCLUDES_NULLS:t.Optional[bool]=_B;'Whether ArrayAgg needs to filter NULL values.';REGEXP_EXTRACT_DEFAULT_GROUP=0;'The default value for the capturing group.';SET_OP_DISTINCT_BY_DEFAULT:t.Dict[t.Type[exp.Expression],t.Optional[bool]]={exp.Except:_B,exp.Intersect:_B,exp.Union:_B};'\n    Whether a set operation uses DISTINCT by default. This is `None` when either `DISTINCT` or `ALL`\n    must be explicitly specified.\n    ';CREATABLE_KIND_MAPPING:dict[str,str]={};'\n    Helper for dialects that use a different name for the same creatable kind. For example, the Clickhouse\n    equivalent of CREATE SCHEMA is CREATE DATABASE.\n    ';tokenizer_class=Tokenizer;jsonpath_tokenizer_class=JSONPathTokenizer;parser_class=Parser;generator_class=Generator;TIME_TRIE:t.Dict={};FORMAT_TRIE:t.Dict={};INVERSE_TIME_MAPPING:t.Dict[str,str]={};INVERSE_TIME_TRIE:t.Dict={};INVERSE_FORMAT_MAPPING:t.Dict[str,str]={};INVERSE_FORMAT_TRIE:t.Dict={};INVERSE_CREATABLE_KIND_MAPPING:dict[str,str]={};ESCAPED_SEQUENCES:t.Dict[str,str]={};QUOTE_START="'";QUOTE_END="'";IDENTIFIER_START='"';IDENTIFIER_END='"';BIT_START:t.Optional[str]=_A;BIT_END:t.Optional[str]=_A;HEX_START:t.Optional[str]=_A;HEX_END:t.Optional[str]=_A;BYTE_START:t.Optional[str]=_A;BYTE_END:t.Optional[str]=_A;UNICODE_START:t.Optional[str]=_A;UNICODE_END:t.Optional[str]=_A;DATE_PART_MAPPING={'Y':_H,'YY':_H,'YYY':_H,'YYYY':_H,'YR':_H,'YEARS':_H,'YRS':_H,'MM':_O,'MON':_O,'MONS':_O,'MONTHS':_O,'D':_I,'DD':_I,'DAYS':_I,'DAYOFMONTH':_I,'DAY OF WEEK':_P,'WEEKDAY':_P,'DOW':_P,'DW':_P,'WEEKDAY_ISO':_V,'DOW_ISO':_V,'DW_ISO':_V,'DAY OF YEAR':_W,'DOY':_W,'DY':_W,'W':_K,'WK':_K,'WEEKOFYEAR':_K,'WOY':_K,'WY':_K,'WEEK_ISO':_X,'WEEKOFYEARISO':_X,'WEEKOFYEAR_ISO':_X,'Q':_Q,'QTR':_Q,'QTRS':_Q,'QUARTERS':_Q,'H':_L,'HH':_L,'HR':_L,'HOURS':_L,'HRS':_L,'M':_M,'MI':_M,'MIN':_M,'MINUTES':_M,'MINS':_M,'S':_R,'SEC':_R,'SECONDS':_R,'SECS':_R,'MS':_E,'MSEC':_E,'MSECS':_E,'MSECOND':_E,'MSECONDS':_E,'MILLISEC':_E,'MILLISECS':_E,'MILLISECON':_E,'MILLISECONDS':_E,'US':_G,'USEC':_G,'USECS':_G,'MICROSEC':_G,'MICROSECS':_G,'USECOND':_G,'USECONDS':_G,'MICROSECONDS':_G,'NS':_J,'NSEC':_J,'NANOSEC':_J,'NSECOND':_J,'NSECONDS':_J,'NANOSECS':_J,'EPOCH_SECOND':'EPOCH','EPOCH_SECONDS':'EPOCH','EPOCH_MILLISECONDS':'EPOCH_MILLISECOND','EPOCH_MICROSECONDS':'EPOCH_MICROSECOND','EPOCH_NANOSECONDS':'EPOCH_NANOSECOND','TZH':'TIMEZONE_HOUR','TZM':'TIMEZONE_MINUTE','DEC':_Y,'DECS':_Y,'DECADES':_Y,'MIL':_Z,'MILS':_Z,'MILLENIA':_Z,'C':_S,'CENT':_S,'CENTS':_S,'CENTURIES':_S};TYPE_TO_EXPRESSIONS:t.Dict[exp.DataType.Type,t.Set[t.Type[exp.Expression]]]={exp.DataType.Type.BIGINT:{exp.ApproxDistinct,exp.ArraySize,exp.Length},exp.DataType.Type.BOOLEAN:{exp.Between,exp.Boolean,exp.In,exp.RegexpLike},exp.DataType.Type.DATE:{exp.CurrentDate,exp.Date,exp.DateFromParts,exp.DateStrToDate,exp.DiToDate,exp.StrToDate,exp.TimeStrToDate,exp.TsOrDsToDate},exp.DataType.Type.DATETIME:{exp.CurrentDatetime,exp.Datetime,exp.DatetimeAdd,exp.DatetimeSub},exp.DataType.Type.DOUBLE:{exp.ApproxQuantile,exp.Avg,exp.Exp,exp.Ln,exp.Log,exp.Pow,exp.Quantile,exp.Round,exp.SafeDivide,exp.Sqrt,exp.Stddev,exp.StddevPop,exp.StddevSamp,exp.Variance,exp.VariancePop},exp.DataType.Type.INT:{exp.Ceil,exp.DatetimeDiff,exp.DateDiff,exp.TimestampDiff,exp.TimeDiff,exp.DateToDi,exp.Levenshtein,exp.Sign,exp.StrPosition,exp.TsOrDiToDi},exp.DataType.Type.JSON:{exp.ParseJSON},exp.DataType.Type.TIME:{exp.Time},exp.DataType.Type.TIMESTAMP:{exp.CurrentTime,exp.CurrentTimestamp,exp.StrToTime,exp.TimeAdd,exp.TimeStrToTime,exp.TimeSub,exp.TimestampAdd,exp.TimestampSub,exp.UnixToTime},exp.DataType.Type.TINYINT:{exp.Day,exp.Month,exp.Week,exp.Year,exp.Quarter},exp.DataType.Type.VARCHAR:{exp.ArrayConcat,exp.Concat,exp.ConcatWs,exp.DateToDateStr,exp.GroupConcat,exp.Initcap,exp.Lower,exp.Substring,exp.TimeToStr,exp.TimeToTimeStr,exp.Trim,exp.TsOrDsToDateStr,exp.UnixToStr,exp.UnixToTimeStr,exp.Upper}};ANNOTATORS:AnnotatorsType={**{A:lambda self,e:self._annotate_unary(e)for A in subclasses(exp.__name__,(exp.Unary,exp.Alias))},**{A:lambda self,e:self._annotate_binary(e)for A in subclasses(exp.__name__,exp.Binary)},**{C:_annotate_with_type_lambda(A)for(A,B)in TYPE_TO_EXPRESSIONS.items()for C in B},exp.Abs:lambda self,e:self._annotate_by_args(e,_D),exp.Anonymous:lambda self,e:self._annotate_with_type(e,exp.DataType.Type.UNKNOWN),exp.Array:lambda self,e:self._annotate_by_args(e,_F,array=_B),exp.ArrayAgg:lambda self,e:self._annotate_by_args(e,_D,array=_B),exp.ArrayConcat:lambda self,e:self._annotate_by_args(e,_D,_F),exp.Bracket:lambda self,e:self._annotate_bracket(e),exp.Cast:lambda self,e:self._annotate_with_type(e,e.args['to']),exp.Case:lambda self,e:self._annotate_by_args(e,'default','ifs'),exp.Coalesce:lambda self,e:self._annotate_by_args(e,_D,_F),exp.Count:lambda self,e:self._annotate_with_type(e,exp.DataType.Type.BIGINT if e.args.get('big_int')else exp.DataType.Type.INT),exp.DataType:lambda self,e:self._annotate_with_type(e,e.copy()),exp.DateAdd:lambda self,e:self._annotate_timeunit(e),exp.DateSub:lambda self,e:self._annotate_timeunit(e),exp.DateTrunc:lambda self,e:self._annotate_timeunit(e),exp.Distinct:lambda self,e:self._annotate_by_args(e,_F),exp.Div:lambda self,e:self._annotate_div(e),exp.Dot:lambda self,e:self._annotate_dot(e),exp.Explode:lambda self,e:self._annotate_explode(e),exp.Extract:lambda self,e:self._annotate_extract(e),exp.Filter:lambda self,e:self._annotate_by_args(e,_D),exp.GenerateDateArray:lambda self,e:self._annotate_with_type(e,exp.DataType.build('ARRAY<DATE>')),exp.GenerateTimestampArray:lambda self,e:self._annotate_with_type(e,exp.DataType.build('ARRAY<TIMESTAMP>')),exp.Greatest:lambda self,e:self._annotate_by_args(e,_D,_F),exp.If:lambda self,e:self._annotate_by_args(e,_a,_b),exp.Interval:lambda self,e:self._annotate_with_type(e,exp.DataType.Type.INTERVAL),exp.Least:lambda self,e:self._annotate_by_args(e,_D,_F),exp.Literal:lambda self,e:self._annotate_literal(e),exp.Map:lambda self,e:self._annotate_map(e),exp.Max:lambda self,e:self._annotate_by_args(e,_D,_F),exp.Min:lambda self,e:self._annotate_by_args(e,_D,_F),exp.Null:lambda self,e:self._annotate_with_type(e,exp.DataType.Type.NULL),exp.Nullif:lambda self,e:self._annotate_by_args(e,_D,_T),exp.PropertyEQ:lambda self,e:self._annotate_by_args(e,_T),exp.Slice:lambda self,e:self._annotate_with_type(e,exp.DataType.Type.UNKNOWN),exp.Struct:lambda self,e:self._annotate_struct(e),exp.Sum:lambda self,e:self._annotate_by_args(e,_D,_F,promote=_B),exp.Timestamp:lambda self,e:self._annotate_with_type(e,exp.DataType.Type.TIMESTAMPTZ if e.args.get('with_tz')else exp.DataType.Type.TIMESTAMP),exp.ToMap:lambda self,e:self._annotate_to_map(e),exp.TryCast:lambda self,e:self._annotate_with_type(e,e.args['to']),exp.Unnest:lambda self,e:self._annotate_unnest(e),exp.VarMap:lambda self,e:self._annotate_map(e)}
	@classmethod
	def get_or_raise(E,dialect):
		'\n        Look up a dialect in the global dialect registry and return it if it exists.\n\n        Args:\n            dialect: The target dialect. If this is a string, it can be optionally followed by\n                additional key-value pairs that are separated by commas and are used to specify\n                dialect settings, such as whether the dialect\'s identifiers are case-sensitive.\n\n        Example:\n            >>> dialect = dialect_class = get_or_raise("duckdb")\n            >>> dialect = get_or_raise("mysql, normalization_strategy = case_sensitive")\n\n        Returns:\n            The corresponding Dialect instance.\n        ';A=dialect
		if not A:return E()
		if isinstance(A,_Dialect):return A()
		if isinstance(A,Dialect):return A
		if isinstance(A,str):
			try:
				F,*J=A.split(',');K=(A.split('=')for A in J);G={}
				for C in K:
					L=C[0].strip();B=_A
					if len(C)==1:B=_B
					elif len(C)==2:
						B=C[1].strip();H=B.lower()
						if H in(_a,'1'):B=_B
						elif H in(_b,'0'):B=_C
					G[L]=B
			except ValueError:raise ValueError(f"Invalid dialect format: '{A}'. Please use the correct format: 'dialect [, k1 = v2 [, ...]]'.")
			I=E.get(F.strip())
			if not I:
				from difflib import get_close_matches as M;D=seq_get(M(F,E.classes,n=1),0)or''
				if D:D=f" Did you mean {D}?"
				raise ValueError(f"Unknown dialect '{F}'.{D}")
			return I(**G)
		raise ValueError(f"Invalid dialect type for '{A}': '{type(A)}'.")
	@classmethod
	def format_time(B,expression):
		'Converts a time format in this dialect to its equivalent Python `strftime` format.';A=expression
		if isinstance(A,str):return exp.Literal.string(format_time(A[1:-1],B.TIME_MAPPING,B.TIME_TRIE))
		if A and A.is_string:return exp.Literal.string(format_time(A.this,B.TIME_MAPPING,B.TIME_TRIE))
		return A
	def __init__(A,**B):
		C=B.pop('normalization_strategy',_A)
		if C is _A:A.normalization_strategy=A.NORMALIZATION_STRATEGY
		else:A.normalization_strategy=NormalizationStrategy(C.upper())
		A.settings=B
	def __eq__(A,other):return type(A)==other
	def __hash__(A):return hash(type(A))
	def normalize_identifier(B,expression):
		'\n        Transforms an identifier in a way that resembles how it\'d be resolved by this dialect.\n\n        For example, an identifier like `FoO` would be resolved as `foo` in Postgres, because it\n        lowercases all unquoted identifiers. On the other hand, Snowflake uppercases them, so\n        it would resolve it as `FOO`. If it was quoted, it\'d need to be treated as case-sensitive,\n        and so any normalization would be prohibited in order to avoid "breaking" the identifier.\n\n        There are also dialects like Spark, which are case-insensitive even when quotes are\n        present, and dialects like MySQL, whose resolution rules match those employed by the\n        underlying operating system, for example they may always be case-sensitive in Linux.\n\n        Finally, the normalization behavior of some engines can even be controlled through flags,\n        like in Redshift\'s case, where users can explicitly set enable_case_sensitive_identifier.\n\n        SQLGlot aims to understand and handle all of these different behaviors gracefully, so\n        that it can analyze queries in the optimizer and successfully capture their semantics.\n        ';A=expression
		if isinstance(A,exp.Identifier)and B.normalization_strategy is not NormalizationStrategy.CASE_SENSITIVE and(not A.quoted or B.normalization_strategy is NormalizationStrategy.CASE_INSENSITIVE):A.set(_D,A.this.upper()if B.normalization_strategy is NormalizationStrategy.UPPERCASE else A.this.lower())
		return A
	def case_sensitive(A,text):
		"Checks if text contains any case sensitive characters, based on the dialect's rules."
		if A.normalization_strategy is NormalizationStrategy.CASE_INSENSITIVE:return _C
		B=str.islower if A.normalization_strategy is NormalizationStrategy.UPPERCASE else str.isupper;return any(B(A)for A in text)
	def can_identify(B,text,identify='safe'):
		'Checks if text can be identified given an identify option.\n\n        Args:\n            text: The text to check.\n            identify:\n                `"always"` or `True`: Always returns `True`.\n                `"safe"`: Only returns `True` if the identifier is case-insensitive.\n\n        Returns:\n            Whether the given text can be identified.\n        ';A=identify
		if A is _B or A=='always':return _B
		if A=='safe':return not B.case_sensitive(text)
		return _C
	def quote_identifier(C,expression,identify=_B):
		'\n        Adds quotes to a given identifier.\n\n        Args:\n            expression: The expression of interest. If it\'s not an `Identifier`, this method is a no-op.\n            identify: If set to `False`, the quotes will only be added if the identifier is deemed\n                "unsafe", with respect to its characters and this dialect\'s normalization strategy.\n        ';A=expression
		if isinstance(A,exp.Identifier)and not isinstance(A.parent,exp.Func):B=A.this;A.set('quoted',identify or C.case_sensitive(B)or not exp.SAFE_IDENTIFIER_RE.match(B))
		return A
	def to_json_path(C,path):
		A=path
		if isinstance(A,exp.Literal):
			B=A.name
			if A.is_number:B=f"[{B}]"
			try:return parse_json_path(B,C)
			except ParseError as D:
				if C.STRICT_JSON_PATH_SYNTAX:logger.warning(f"Invalid JSON path syntax. {str(D)}")
		return A
	def parse(A,sql,**B):return A.parser(**B).parse(A.tokenize(sql),sql)
	def parse_into(A,expression_type,sql,**B):return A.parser(**B).parse_into(expression_type,A.tokenize(sql),sql)
	def generate(A,expression,copy=_B,**B):return A.generator(**B).generate(expression,copy=copy)
	def transpile(A,sql,**C):return[A.generate(B,copy=_C,**C)if B else''for B in A.parse(sql)]
	def tokenize(A,sql):return A.tokenizer.tokenize(sql)
	@property
	def tokenizer(self):return self.tokenizer_class(dialect=self)
	@property
	def jsonpath_tokenizer(self):return self.jsonpath_tokenizer_class(dialect=self)
	def parser(A,**B):return A.parser_class(dialect=A,**B)
	def generator(A,**B):return A.generator_class(dialect=A,**B)
DialectType=t.Union[str,Dialect,t.Type[Dialect],_A]
def rename_func(name):return lambda self,expression:self.func(name,*flatten(expression.args.values()))
@unsupported_args('accuracy')
def approx_count_distinct_sql(self,expression):return self.func('APPROX_COUNT_DISTINCT',expression.this)
def if_sql(name='IF',false_value=_A):
	def A(self,expression):A=expression;return self.func(name,A.this,A.args.get(_a),A.args.get(_b)or false_value)
	return A
def arrow_json_extract_sql(self,expression):
	B=expression;A=B.this
	if self.JSON_TYPE_REQUIRED_FOR_EXTRACTION and isinstance(A,exp.Literal)and A.is_string:A.replace(exp.cast(A,exp.DataType.Type.JSON))
	return self.binary(B,'->'if isinstance(B,exp.JSONExtract)else'->>')
def inline_array_sql(self,expression):return f"[{self.expressions(expression,dynamic=_B,new_line=_B,skip_first=_B,skip_last=_B)}]"
def inline_array_unless_query(self,expression):
	B=expression;A=seq_get(B.expressions,0)
	if isinstance(A,exp.Expression)and A.find(exp.Query):return self.func('ARRAY',A)
	return inline_array_sql(self,B)
def no_ilike_sql(self,expression):A=expression;return self.like_sql(exp.Like(this=exp.Lower(this=A.this),expression=exp.Lower(this=A.expression)))
def no_paren_current_date_sql(self,expression):A=self.sql(expression,_D);return f"CURRENT_DATE AT TIME ZONE {A}"if A else'CURRENT_DATE'
def no_recursive_cte_sql(self,expression):
	B='recursive';A=expression
	if A.args.get(B):self.unsupported('Recursive CTEs are unsupported');A.args[B]=_C
	return self.with_sql(A)
def no_safe_divide_sql(self,expression):A=expression;C=self.sql(A,_D);B=self.sql(A,_T);return f"IF(({B}) <> 0, ({C}) / ({B}), NULL)"
def no_tablesample_sql(self,expression):self.unsupported('TABLESAMPLE unsupported');return self.sql(expression.this)
def no_pivot_sql(self,expression):self.unsupported('PIVOT unsupported');return''
def no_trycast_sql(self,expression):return self.cast_sql(expression)
def no_comment_column_constraint_sql(self,expression):self.unsupported('CommentColumnConstraint unsupported');return''
def no_map_from_entries_sql(self,expression):self.unsupported('MAP_FROM_ENTRIES unsupported');return''
def property_sql(self,expression):A=expression;return f"{self.property_name(A,string_key=_B)}={self.sql(A,"value")}"
def str_position_sql(self,expression,generate_instance=_C,str_position_func_name='STRPOS'):
	B=expression;A=self;C=A.sql(B,_D);F=A.sql(B,_h);D=A.sql(B,_N);G=B.args.get('instance')if generate_instance else _A;E=''
	if D:C=A.func('SUBSTR',C,D);E=f" + {D} - 1"
	return A.func(str_position_func_name,C,F,G)+E
def struct_extract_sql(self,expression):A=expression;return f"{self.sql(A,_D)}.{self.sql(exp.to_identifier(A.expression.name))}"
def var_map_sql(self,expression,map_func_name='MAP'):
	F=map_func_name;E=expression;A=self;B=E.args['keys'];C=E.args['values']
	if not isinstance(B,exp.Array)or not isinstance(C,exp.Array):A.unsupported('Cannot convert array columns into map.');return A.func(F,B,C)
	D=[]
	for(G,H)in zip(B.expressions,C.expressions):D.append(A.sql(G));D.append(A.sql(H))
	return A.func(F,*D)
def build_formatted_time(exp_class,dialect,default=_A):
	'Helper used for time expressions.\n\n    Args:\n        exp_class: the expression class to instantiate.\n        dialect: target sql dialect.\n        default: the default format, True being time.\n\n    Returns:\n        A callable that can be used to return the appropriately formatted time expression.\n    ';B=default;A=dialect
	def C(args):return exp_class(this=seq_get(args,0),format=Dialect[A].format_time(seq_get(args,1)or(Dialect[A].TIME_FORMAT if B is _B else B or _A)))
	return C
def time_format(dialect=_A):
	def A(self,expression):"\n        Returns the time format for a given expression, unless it's equivalent\n        to the default time format of the dialect of interest.\n        ";A=self.format_time(expression);return A if A!=Dialect.get_or_raise(dialect).TIME_FORMAT else _A
	return A
def build_date_delta(exp_class,unit_mapping=_A,default_unit=_I):
	E=default_unit;D=unit_mapping
	def A(args):
		B=args;C=len(B)==3;F=B[2]if C else seq_get(B,0);A=_A
		if C or E:A=B[0]if C else exp.Literal.string(E);A=exp.var(D.get(A.name.lower(),A.name))if D else A
		return exp_class(this=F,expression=seq_get(B,1),unit=A)
	return A
def build_date_delta_with_interval(expression_class):
	def A(args):
		B=args
		if len(B)<2:return
		A=B[1]
		if not isinstance(A,exp.Interval):raise ParseError(f"INTERVAL expression expected but got '{A}'")
		return expression_class(this=B[0],expression=A.this,unit=unit_to_str(A))
	return A
def date_trunc_to_time(args):
	B=seq_get(args,0);A=seq_get(args,1)
	if isinstance(A,exp.Cast)and A.is_type('date'):return exp.DateTrunc(unit=B,this=A)
	return exp.TimestampTrunc(this=A,unit=B)
def date_add_interval_sql(data_type,kind):
	def A(self,expression):A=expression;B=self.sql(A,_D);C=exp.Interval(this=A.expression,unit=unit_to_var(A));return f"{data_type}_{kind}({B}, {self.sql(C)})"
	return A
def timestamptrunc_sql(zone=_C):
	def A(self,expression):
		A=expression;B=[unit_to_str(A),A.this]
		if zone:B.append(A.args.get(_U))
		return self.func('DATE_TRUNC',*B)
	return A
def no_timestamp_sql(self,expression):
	C=self;A=expression;B=A.args.get(_U)
	if not B:from sqlglot.optimizer.annotate_types import annotate_types as D;E=D(A).type or exp.DataType.Type.TIMESTAMP;return C.sql(exp.cast(A.this,E))
	if B.name.lower()in TIMEZONES:return C.sql(exp.AtTimeZone(this=exp.cast(A.this,exp.DataType.Type.TIMESTAMP),zone=B))
	return C.func('TIMESTAMP',A.this,B)
def no_time_sql(self,expression):A=expression;B=exp.cast(A.this,exp.DataType.Type.TIMESTAMPTZ);C=exp.cast(exp.AtTimeZone(this=B,zone=A.args.get(_U)),exp.DataType.Type.TIME);return self.sql(C)
def no_datetime_sql(self,expression):
	C=expression;A=C.this;B=C.expression
	if B.name.lower()in TIMEZONES:A=exp.cast(A,exp.DataType.Type.TIMESTAMPTZ);A=exp.cast(exp.AtTimeZone(this=A,zone=B),exp.DataType.Type.TIMESTAMP);return self.sql(A)
	A=exp.cast(A,exp.DataType.Type.DATE);B=exp.cast(B,exp.DataType.Type.TIME);return self.sql(exp.cast(exp.Add(this=A,expression=B),exp.DataType.Type.TIMESTAMP))
def locate_to_strposition(args):A=args;return exp.StrPosition(this=seq_get(A,1),substr=seq_get(A,0),position=seq_get(A,2))
def strposition_to_locate_sql(self,expression):A=expression;return self.func('LOCATE',A.args.get(_h),A.this,A.args.get(_N))
def left_to_substring_sql(self,expression):A=expression;return self.sql(exp.Substring(this=A.this,start=exp.Literal.number(1),length=A.expression))
def right_to_substring_sql(self,expression):A=expression;return self.sql(exp.Substring(this=A.this,start=exp.Length(this=A.this)-exp.paren(A.expression-1)))
def timestrtotime_sql(self,expression,include_precision=_C):
	A=expression;B=exp.DataType.build(exp.DataType.Type.TIMESTAMPTZ if A.args.get(_U)else exp.DataType.Type.TIMESTAMP)
	if isinstance(A.this,exp.Literal)and include_precision:
		C=subsecond_precision(A.this.name)
		if C>0:B=exp.DataType.build(B.this,expressions=[exp.DataTypeParam(this=exp.Literal.number(C))])
	return self.sql(exp.cast(A.this,B,dialect=self.dialect))
def datestrtodate_sql(self,expression):return self.sql(exp.cast(expression.this,exp.DataType.Type.DATE))
def encode_decode_sql(self,expression,name,replace=_B):
	A=expression;B=A.args.get('charset')
	if B and B.name.lower()!='utf-8':self.unsupported(f"Expected utf-8 character set, got {B}.")
	return self.func(name,A.this,A.args.get('replace')if replace else _A)
def min_or_least(self,expression):A=expression;B='LEAST'if A.expressions else'MIN';return rename_func(B)(self,A)
def max_or_greatest(self,expression):A=expression;B='GREATEST'if A.expressions else'MAX';return rename_func(B)(self,A)
def count_if_to_sum(self,expression):
	A=expression;B=A.this
	if isinstance(A.this,exp.Distinct):B=A.this.expressions[0];self.unsupported('DISTINCT is not supported when converting COUNT_IF to SUM')
	return self.func('sum',exp.func('if',B,1,0))
def trim_sql(self,expression):
	C=expression;B=self;F=B.sql(C,_D);D=B.sql(C,_N);A=B.sql(C,_T);E=B.sql(C,'collation')
	if not A:return B.trim_sql(C)
	D=f"{D} "if D else'';A=f"{A} "if A else'';G='FROM 'if D or A else'';E=f" COLLATE {E}"if E else'';return f"TRIM({D}{A}{G}{F}{E})"
def str_to_time_sql(self,expression):A=expression;return self.func('STRPTIME',A.this,self.format_time(A))
def concat_to_dpipe_sql(self,expression):return self.sql(reduce(lambda x,y:exp.DPipe(this=x,expression=y),expression.expressions))
def concat_ws_to_dpipe_sql(self,expression):A,*B=expression.expressions;return self.sql(reduce(lambda x,y:exp.DPipe(this=x,expression=exp.DPipe(this=A,expression=y)),B))
@unsupported_args(_N,_i,'parameters')
def regexp_extract_sql(self,expression):
	B=expression;A=B.args.get('group')
	if A and A.name==str(self.dialect.REGEXP_EXTRACT_DEFAULT_GROUP):A=_A
	return self.func('REGEXP_EXTRACT',B.this,B.expression,A)
@unsupported_args(_N,_i,'modifiers')
def regexp_replace_sql(self,expression):A=expression;return self.func('REGEXP_REPLACE',A.this,A.expression,A.args['replacement'])
def pivot_column_names(aggregations,dialect):
	A=[]
	for B in aggregations:
		if isinstance(B,exp.Alias):A.append(B.alias)
		else:"\n            This case corresponds to aggregations without aliases being used as suffixes\n            (e.g. col_avg(foo)). We need to unquote identifiers because they're going to\n            be quoted in the base parser's `_parse_pivot` method, due to `to_identifier`.\n            Otherwise, we'd end up with `col_avg(`foo`)` (notice the double quotes).\n            ";C=B.transform(lambda node:exp.Identifier(this=node.name,quoted=_C)if isinstance(node,exp.Identifier)else node);A.append(C.sql(dialect=dialect,normalize_functions='lower'))
	return A
def binary_from_function(expr_type):return lambda args:expr_type(this=seq_get(args,0),expression=seq_get(args,1))
def build_timestamp_trunc(args):return exp.TimestampTrunc(this=seq_get(args,1),unit=seq_get(args,0))
def any_value_to_max_sql(self,expression):return self.func('MAX',expression.this)
def bool_xor_sql(self,expression):A=expression;B=self.sql(A.left);C=self.sql(A.right);return f"({B} AND (NOT {C})) OR ((NOT {B}) AND {C})"
def is_parse_json(expression):A=expression;return isinstance(A,exp.ParseJSON)or isinstance(A,exp.Cast)and A.is_type('json')
def isnull_to_is_null(args):return exp.Paren(this=exp.Is(this=seq_get(args,0),expression=exp.null()))
def generatedasidentitycolumnconstraint_sql(self,expression):A=expression;B=self.sql(A,'start')or'1';C=self.sql(A,'increment')or'1';return f"IDENTITY({B}, {C})"
def arg_max_or_min_no_count(name):
	@unsupported_args('count')
	def A(self,expression):A=expression;return self.func(name,A.this,A.expression)
	return A
def ts_or_ds_add_cast(expression):
	A=expression;B=A.this.copy();C=A.return_type
	if C.is_type(exp.DataType.Type.DATE):B=exp.cast(B,exp.DataType.Type.TIMESTAMP)
	A.this.replace(exp.cast(B,C));return A
def date_delta_sql(name,cast=_C):
	def A(self,expression):
		A=expression
		if cast and isinstance(A,exp.TsOrDsAdd):A=ts_or_ds_add_cast(A)
		return self.func(name,unit_to_var(A),A.expression,A.this)
	return A
def unit_to_str(expression,default=_I):
	B=default;A=expression.args.get('unit')
	if isinstance(A,exp.Placeholder):return A
	if A:return exp.Literal.string(A.name)
	return exp.Literal.string(B)if B else _A
def unit_to_var(expression,default=_I):
	A=default;B=expression.args.get('unit')
	if isinstance(B,(exp.Var,exp.Placeholder)):return B
	return exp.Var(this=A)if A else _A
@t.overload
def map_date_part(part,dialect=Dialect):0
@t.overload
def map_date_part(part,dialect=Dialect):0
def map_date_part(part,dialect=Dialect):A=part;B=Dialect.get_or_raise(dialect).DATE_PART_MAPPING.get(A.name.upper())if A else _A;return exp.var(B)if B else A
def no_last_day_sql(self,expression):A='month';B=exp.func('date_trunc',A,expression.this);C=exp.func('date_add',B,1,A);D=exp.func('date_sub',C,1,'day');return self.sql(exp.cast(D,exp.DataType.Type.DATE))
def merge_without_target_sql(self,expression):
	'Remove table refs from columns in when statements.';A=expression;C=A.this.args.get('alias')
	def B(identifier):A=identifier;return self.dialect.normalize_identifier(A).name if A else _A
	D={B(A.this.this)}
	if C:D.add(B(C.this))
	for F in A.expressions:
		E=F.args.get('then')
		if E:E.transform(lambda node:exp.column(node.this)if isinstance(node,exp.Column)and B(node.args.get('table'))in D else node,copy=_C)
	return self.merge_sql(A)
def build_json_extract_path(expr_type,zero_based_indexing=_B,arrow_req_json_type=_C):
	D=expr_type
	def A(args):
		A=args;B=[exp.JSONPathRoot()]
		for E in A[1:]:
			if not isinstance(E,exp.Literal):return D.from_arg_list(A)
			C=E.name
			if is_int(C):F=int(C);B.append(exp.JSONPathSubscript(this=F if zero_based_indexing else F-1))
			else:B.append(exp.JSONPathKey(this=C))
		del A[2:];return D(this=seq_get(A,0),expression=exp.JSONPath(expressions=B),only_json_types=arrow_req_json_type)
	return A
def json_extract_segments(name,quoted_index=_B,op=_A):
	def A(self,expression):
		C=expression;B=self;A=C.expression
		if not isinstance(A,exp.JSONPath):return rename_func(name)(B,C)
		F=A.args.get('escape');D=[]
		for E in A.expressions:
			A=B.sql(E)
			if A:
				if isinstance(E,exp.JSONPathPart)and(quoted_index or not isinstance(E,exp.JSONPathSubscript)):
					if F:A=B.escape_str(A)
					A=f"{B.dialect.QUOTE_START}{A}{B.dialect.QUOTE_END}"
				D.append(A)
		if op:return f" {op} ".join([B.sql(C.this),*D])
		return B.func(name,C.this,*D)
	return A
def json_path_key_only_name(self,expression):
	A=expression
	if isinstance(A.this,exp.JSONPathWildcard):self.unsupported('Unsupported wildcard in JSONPathKey expression')
	return A.name
def filter_array_using_unnest(self,expression):
	C=expression;A=C.expression
	if isinstance(A,exp.Lambda)and len(A.expressions)==1:B=A.expressions[0];A=A.this
	elif isinstance(A,exp.Predicate):B='_u'
	else:self.unsupported('Unsupported filter condition');return''
	D=exp.Unnest(expressions=[C.this]);E=exp.select(B).from_(exp.alias_(D,_A,table=[B])).where(A);return self.sql(exp.Array(expressions=[E]))
def to_number_with_nls_param(self,expression):A=expression;return self.func('TO_NUMBER',A.this,A.args.get('format'),A.args.get('nlsparam'))
def build_default_decimal_type(precision=_A,scale=_A):
	B=scale;A=precision
	def C(dtype):
		C=dtype
		if C.expressions or A is _A:return C
		D=f"{A}{f", {B}"if B is not _A else""}";return exp.DataType.build(f"DECIMAL({D})")
	return C
def build_timestamp_from_parts(args):
	A=args
	if len(A)==2:return exp.Anonymous(this='TIMESTAMP_FROM_PARTS',expressions=A)
	return exp.TimestampFromParts.from_arg_list(A)
def sha256_sql(self,expression):A=expression;return self.func(f"SHA{A.text("length")or"256"}",A.this)
def sequence_sql(self,expression):
	D=expression;A=D.args.get('start');C=D.args.get('end');E=D.args.get('step')
	if isinstance(A,exp.Cast):B=A.to
	elif isinstance(C,exp.Cast):B=C.to
	else:B=_A
	if A and C and B and B.is_type('date','timestamp'):
		if isinstance(A,exp.Cast)and B is A.to:C=exp.cast(C,B)
		else:A=exp.cast(A,B)
	return self.func('SEQUENCE',A,C,E)
def build_regexp_extract(args,dialect):A=args;return exp.RegexpExtract(this=seq_get(A,0),expression=seq_get(A,1),group=seq_get(A,2)or exp.Literal.number(dialect.REGEXP_EXTRACT_DEFAULT_GROUP))