from __future__ import annotations
_i='EXPLODE'
_h='CONCAT'
_g='BINARY'
_f='UNBASE64'
_e='PERCENTILE_APPROX'
_d='PERCENTILE'
_c='DATE_FORMAT'
_b='COLLECT_SET'
_a='COLLECT_LIST'
_Z='BASE64'
_Y='SMALLINT'
_X='SERDEPROPERTIES'
_W='REGEXP_EXTRACT'
_V='DATEDIFF'
_U='MONTHS_BETWEEN'
_T='QUARTER'
_S='TIMESTAMP'
_R='SPLIT'
_Q='GET_JSON_OBJECT'
_P='TO_JSON'
_O='expression'
_N='ADD_MONTHS'
_M='MONTH'
_L='YEAR'
_K='%Y'
_J='TO_DATE'
_I='FROM_UNIXTIME'
_H='UNIX_TIMESTAMP'
_G='DAY'
_F='DATE_ADD'
_E='hive'
_D=None
_C='this'
_B=True
_A=False
import typing as t
from functools import partial
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import DATE_ADD_OR_SUB,Dialect,NormalizationStrategy,approx_count_distinct_sql,arg_max_or_min_no_count,datestrtodate_sql,build_formatted_time,if_sql,is_parse_json,left_to_substring_sql,locate_to_strposition,max_or_greatest,min_or_least,no_ilike_sql,no_recursive_cte_sql,no_safe_divide_sql,no_trycast_sql,regexp_extract_sql,regexp_replace_sql,rename_func,right_to_substring_sql,strposition_to_locate_sql,struct_extract_sql,time_format,timestrtotime_sql,unit_to_str,var_map_sql,sequence_sql,property_sql,build_regexp_extract
from sqlglot.transforms import remove_unique_constraints,ctas_with_tmp_tables_to_create_tmp_view,preprocess,move_schema_columns_to_partitioned_by
from sqlglot.helper import seq_get
from sqlglot.tokens import TokenType
DATE_DELTA_INTERVAL={_L:(_N,12),_M:(_N,1),_T:(_N,3),'WEEK':(_F,7),_G:(_F,1)}
TIME_DIFF_FACTOR={'MILLISECOND':' * 1000','SECOND':'','MINUTE':' / 60','HOUR':' / 3600'}
DIFF_MONTH_SWITCH=_L,_T,_M
def _add_date_sql(self,expression):
	A=expression
	if isinstance(A,exp.TsOrDsAdd)and not A.unit:return self.func(_F,A.this,A.expression)
	D=A.text('unit').upper();E,B=DATE_DELTA_INTERVAL.get(D,(_F,1))
	if isinstance(A,exp.DateSub):B*=-1
	if A.expression.is_number:C=exp.Literal.number(A.expression.to_py()*B)
	else:
		C=A.expression
		if B!=1:C=exp.Mul(this=C,expression=exp.Literal.number(B))
	return self.func(E,A.this,C)
def _date_diff_sql(self,expression):
	B=self;A=expression;C=A.text('unit').upper();D=TIME_DIFF_FACTOR.get(C)
	if D is not _D:J=B.sql(A,_C);K=B.sql(A,_O);F=f"UNIX_TIMESTAMP({J}) - UNIX_TIMESTAMP({K})";return f"({F}){D}"if D else F
	G=C in DIFF_MONTH_SWITCH;L=_U if G else _V;M,H=DATE_DELTA_INTERVAL.get(C,('',1));I=f" / {H}"if H>1 else'';E=f"{L}({B.format_args(A.this,A.expression)})"
	if G or I:E=f"CAST({E}{I} AS INT)"
	return E
def _json_format_sql(self,expression):
	C=expression;A=self;B=C.this
	if is_parse_json(B):
		if B.this.is_string:D=exp.Literal.string(f"[{B.this.name}]");E=A.func('FROM_JSON',D,A.func('SCHEMA_OF_JSON',D));F=A.func(_P,E);return A.func(_W,F,"'^.(.*).$'",'1')
		return A.sql(B)
	return A.func(_P,B,C.args.get('options'))
@generator.unsupported_args((_O,"Hive's SORT_ARRAY does not support a comparator."))
def _array_sort_sql(self,expression):return self.func('SORT_ARRAY',expression.this)
def _str_to_unix_sql(self,expression):A=expression;return self.func(_H,A.this,time_format(_E)(self,A))
def _unix_to_time_sql(self,expression):
	A=expression;C=self.sql(A,_C);B=A.args.get('scale')
	if B in(_D,exp.UnixToTime.SECONDS):return rename_func(_I)(self,A)
	return f"FROM_UNIXTIME({C} / POW(10, {B}))"
def _str_to_date_sql(self,expression):
	B=expression;A=self.sql(B,_C);C=self.format_time(B)
	if C not in(Hive.TIME_FORMAT,Hive.DATE_FORMAT):A=f"FROM_UNIXTIME(UNIX_TIMESTAMP({A}, {C}))"
	return f"CAST({A} AS DATE)"
def _str_to_time_sql(self,expression):
	B=expression;A=self.sql(B,_C);C=self.format_time(B)
	if C not in(Hive.TIME_FORMAT,Hive.DATE_FORMAT):A=f"FROM_UNIXTIME(UNIX_TIMESTAMP({A}, {C}))"
	return f"CAST({A} AS TIMESTAMP)"
def _to_date_sql(self,expression):
	B=self;A=expression;C=B.format_time(A)
	if C and C not in(Hive.TIME_FORMAT,Hive.DATE_FORMAT):return B.func(_J,A.this,C)
	if isinstance(A.this,exp.TsOrDsToDate):return B.sql(A,_C)
	return B.func(_J,A.this)
def _build_with_ignore_nulls(exp_class):
	def A(args):
		A=exp_class(this=seq_get(args,0))
		if seq_get(args,1)==exp.true():return exp.IgnoreNulls(this=A)
		return A
	return A
class Hive(Dialect):
	ALIAS_POST_TABLESAMPLE=_B;IDENTIFIERS_CAN_START_WITH_DIGIT=_B;SUPPORTS_USER_DEFINED_TYPES=_A;SAFE_DIVISION=_B;ARRAY_AGG_INCLUDES_NULLS=_D;REGEXP_EXTRACT_DEFAULT_GROUP=1;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE;TIME_MAPPING={'y':_K,'Y':_K,'YYYY':_K,'yyyy':_K,'YY':'%y','yy':'%y','MMMM':'%B','MMM':'%b','MM':'%m','M':'%-m','dd':'%d','d':'%-d','HH':'%H','H':'%-H','hh':'%I','h':'%-I','mm':'%M','m':'%-M','ss':'%S','s':'%-S','SSSSSS':'%f','a':'%p','DD':'%j','D':'%-j','E':'%a','EE':'%a','EEE':'%a','EEEE':'%A'};DATE_FORMAT="'yyyy-MM-dd'";DATEINT_FORMAT="'yyyyMMdd'";TIME_FORMAT="'yyyy-MM-dd HH:mm:ss'"
	class Tokenizer(tokens.Tokenizer):QUOTES=["'",'"'];IDENTIFIERS=['`'];STRING_ESCAPES=['\\'];SINGLE_TOKENS={**tokens.Tokenizer.SINGLE_TOKENS,'$':TokenType.PARAMETER};KEYWORDS={**tokens.Tokenizer.KEYWORDS,'ADD ARCHIVE':TokenType.COMMAND,'ADD ARCHIVES':TokenType.COMMAND,'ADD FILE':TokenType.COMMAND,'ADD FILES':TokenType.COMMAND,'ADD JAR':TokenType.COMMAND,'ADD JARS':TokenType.COMMAND,'MINUS':TokenType.EXCEPT,'MSCK REPAIR':TokenType.COMMAND,'REFRESH':TokenType.REFRESH,'TIMESTAMP AS OF':TokenType.TIMESTAMP_SNAPSHOT,'VERSION AS OF':TokenType.VERSION_SNAPSHOT,_X:TokenType.SERDE_PROPERTIES};NUMERIC_LITERALS={'L':'BIGINT','S':_Y,'Y':'TINYINT','D':'DOUBLE','F':'FLOAT','BD':'DECIMAL'}
	class Parser(parser.Parser):
		LOG_DEFAULTS_TO_LN=_B;STRICT_CAST=_A;VALUES_FOLLOWED_BY_PAREN=_A;FUNCTIONS={**parser.Parser.FUNCTIONS,_Z:exp.ToBase64.from_arg_list,_a:lambda args:exp.ArrayAgg(this=seq_get(args,0),nulls_excluded=_B),_b:exp.ArrayUniqueAgg.from_arg_list,_F:lambda args:exp.TsOrDsAdd(this=seq_get(args,0),expression=seq_get(args,1),unit=exp.Literal.string(_G)),_c:lambda args:build_formatted_time(exp.TimeToStr,_E)([exp.TimeStrToTime(this=seq_get(args,0)),seq_get(args,1)]),'DATE_SUB':lambda args:exp.TsOrDsAdd(this=seq_get(args,0),expression=exp.Mul(this=seq_get(args,1),expression=exp.Literal.number(-1)),unit=exp.Literal.string(_G)),_V:lambda args:exp.DateDiff(this=exp.TsOrDsToDate(this=seq_get(args,0)),expression=exp.TsOrDsToDate(this=seq_get(args,1))),_G:lambda args:exp.Day(this=exp.TsOrDsToDate(this=seq_get(args,0))),'FIRST':_build_with_ignore_nulls(exp.First),'FIRST_VALUE':_build_with_ignore_nulls(exp.FirstValue),_I:build_formatted_time(exp.UnixToStr,_E,_B),_Q:exp.JSONExtractScalar.from_arg_list,'LAST':_build_with_ignore_nulls(exp.Last),'LAST_VALUE':_build_with_ignore_nulls(exp.LastValue),'LOCATE':locate_to_strposition,'MAP':parser.build_var_map,_M:lambda args:exp.Month(this=exp.TsOrDsToDate.from_arg_list(args)),_d:exp.Quantile.from_arg_list,_e:exp.ApproxQuantile.from_arg_list,_W:build_regexp_extract,'SEQUENCE':exp.GenerateSeries.from_arg_list,'SIZE':exp.ArraySize.from_arg_list,_R:exp.RegexpSplit.from_arg_list,'STR_TO_MAP':lambda args:exp.StrToMap(this=seq_get(args,0),pair_delim=seq_get(args,1)or exp.Literal.string(','),key_value_delim=seq_get(args,2)or exp.Literal.string(':')),_J:build_formatted_time(exp.TsOrDsToDate,_E),_P:exp.JSONFormat.from_arg_list,'TRUNC':exp.TimestampTrunc.from_arg_list,_f:exp.FromBase64.from_arg_list,_H:lambda args:build_formatted_time(exp.StrToUnix,_E,_B)(args or[exp.CurrentTimestamp()]),_L:lambda args:exp.Year(this=exp.TsOrDsToDate.from_arg_list(args))};NO_PAREN_FUNCTION_PARSERS={**parser.Parser.NO_PAREN_FUNCTION_PARSERS,'TRANSFORM':lambda self:self._parse_transform()};PROPERTY_PARSERS={**parser.Parser.PROPERTY_PARSERS,_X:lambda self:exp.SerdeProperties(expressions=self._parse_wrapped_csv(self._parse_property))}
		def _parse_transform(A):
			if not A._match(TokenType.L_PAREN,advance=_A):A._retreat(A._index-1);return
			B=A._parse_wrapped_csv(A._parse_lambda);E=A._parse_row_format(match_row=_B);C=_D
			if A._match_text_seq('RECORDWRITER'):C=A._parse_string()
			if not A._match(TokenType.USING):return exp.Transform.from_arg_list(B)
			F=A._parse_string();A._match(TokenType.ALIAS);G=A._parse_schema();H=A._parse_row_format(match_row=_B);D=_D
			if A._match_text_seq('RECORDREADER'):D=A._parse_string()
			return A.expression(exp.QueryTransform,expressions=B,command_script=F,schema=G,row_format_before=E,record_writer=C,row_format_after=H,record_reader=D)
		def _parse_types(C,check_func=_A,schema=_A,allow_identifiers=_B):
			"\n            Spark (and most likely Hive) treats casts to CHAR(length) and VARCHAR(length) as casts to\n            STRING in all contexts except for schema definitions. For example, this is in Spark v3.4.0:\n\n                spark-sql (default)> select cast(1234 as varchar(2));\n                23/06/06 15:51:18 WARN CharVarcharUtils: The Spark cast operator does not support\n                char/varchar type and simply treats them as string type. Please use string type\n                directly to avoid confusion. Otherwise, you can set spark.sql.legacy.charVarcharAsString\n                to true, so that Spark treat them as string type as same as Spark 3.0 and earlier\n\n                1234\n                Time taken: 4.265 seconds, Fetched 1 row(s)\n\n            This shows that Spark doesn't truncate the value into '12', which is inconsistent with\n            what other dialects (e.g. postgres) do, so we need to drop the length to transpile correctly.\n\n            Reference: https://spark.apache.org/docs/latest/sql-ref-datatypes.html\n            ";B=schema;A=super()._parse_types(check_func=check_func,schema=B,allow_identifiers=allow_identifiers)
			if A and not B:return A.transform(lambda node:node.replace(exp.DataType.build('text'))if isinstance(node,exp.DataType)and node.is_type('char','varchar')else node,copy=_A)
			return A
		def _parse_partition_and_order(A):return A._parse_csv(A._parse_assignment)if A._match_set({TokenType.PARTITION_BY,TokenType.DISTRIBUTE_BY})else[],super()._parse_order(skip_order_token=A._match(TokenType.SORT_BY))
		def _parse_parameter(A):A._match(TokenType.L_BRACE);B=A._parse_identifier()or A._parse_primary_or_var();C=A._match(TokenType.COLON)and(A._parse_identifier()or A._parse_primary_or_var());A._match(TokenType.R_BRACE);return A.expression(exp.Parameter,this=B,expression=C)
		def _to_prop_eq(C,expression,index):
			A=expression
			if isinstance(A,exp.Column):B=A.this
			else:B=exp.to_identifier(f"col{index+1}")
			return C.expression(exp.PropertyEQ,this=B,expression=A)
	class Generator(generator.Generator):
		LIMIT_FETCH='LIMIT';TABLESAMPLE_WITH_METHOD=_A;JOIN_HINTS=_A;TABLE_HINTS=_A;QUERY_HINTS=_A;INDEX_ON='ON TABLE';EXTRACT_ALLOWS_QUOTES=_A;NVL2_SUPPORTED=_A;LAST_DAY_SUPPORTS_DATE_PART=_A;JSON_PATH_SINGLE_QUOTE_ESCAPE=_B;SUPPORTS_TO_NUMBER=_A;WITH_PROPERTIES_PREFIX='TBLPROPERTIES';PARSE_JSON_NAME=_D;PAD_FILL_PATTERN_IS_REQUIRED=_B;EXPRESSIONS_WITHOUT_NESTED_CTES={exp.Insert,exp.Select,exp.Subquery,exp.SetOperation};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript,exp.JSONPathWildcard};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.BIT:'BOOLEAN',exp.DataType.Type.DATETIME:_S,exp.DataType.Type.ROWVERSION:_g,exp.DataType.Type.TEXT:'STRING',exp.DataType.Type.TIME:_S,exp.DataType.Type.TIMESTAMPTZ:_S,exp.DataType.Type.UTINYINT:_Y,exp.DataType.Type.VARBINARY:_g};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.Group:transforms.preprocess([transforms.unalias_group]),exp.Property:property_sql,exp.AnyValue:rename_func('FIRST'),exp.ApproxDistinct:approx_count_distinct_sql,exp.ArgMax:arg_max_or_min_no_count('MAX_BY'),exp.ArgMin:arg_max_or_min_no_count('MIN_BY'),exp.ArrayConcat:rename_func(_h),exp.ArrayToString:lambda self,e:self.func('CONCAT_WS',e.expression,e.this),exp.ArraySize:rename_func('SIZE'),exp.ArraySort:_array_sort_sql,exp.With:no_recursive_cte_sql,exp.DateAdd:_add_date_sql,exp.DateDiff:_date_diff_sql,exp.DateStrToDate:datestrtodate_sql,exp.DateSub:_add_date_sql,exp.DateToDi:lambda self,e:f"CAST(DATE_FORMAT({self.sql(e,_C)}, {Hive.DATEINT_FORMAT}) AS INT)",exp.DiToDate:lambda self,e:f"TO_DATE(CAST({self.sql(e,_C)} AS STRING), {Hive.DATEINT_FORMAT})",exp.FileFormatProperty:lambda self,e:f"STORED AS {self.sql(e,_C)if isinstance(e.this,exp.InputOutputFormat)else e.name.upper()}",exp.FromBase64:rename_func(_f),exp.GenerateSeries:sequence_sql,exp.GenerateDateArray:sequence_sql,exp.If:if_sql(),exp.ILike:no_ilike_sql,exp.IsNan:rename_func('ISNAN'),exp.JSONExtract:lambda self,e:self.func(_Q,e.this,e.expression),exp.JSONExtractScalar:lambda self,e:self.func(_Q,e.this,e.expression),exp.JSONFormat:_json_format_sql,exp.Left:left_to_substring_sql,exp.Map:var_map_sql,exp.Max:max_or_greatest,exp.MD5Digest:lambda self,e:self.func('UNHEX',self.func('MD5',e.this)),exp.Min:min_or_least,exp.MonthsBetween:lambda self,e:self.func(_U,e.this,e.expression),exp.NotNullColumnConstraint:lambda _,e:''if e.args.get('allow_null')else'NOT NULL',exp.VarMap:var_map_sql,exp.Create:preprocess([remove_unique_constraints,ctas_with_tmp_tables_to_create_tmp_view,move_schema_columns_to_partitioned_by]),exp.Quantile:rename_func(_d),exp.ApproxQuantile:rename_func(_e),exp.RegexpExtract:regexp_extract_sql,exp.RegexpReplace:regexp_replace_sql,exp.RegexpLike:lambda self,e:self.binary(e,'RLIKE'),exp.RegexpSplit:rename_func(_R),exp.Right:right_to_substring_sql,exp.SafeDivide:no_safe_divide_sql,exp.SchemaCommentProperty:lambda self,e:self.naked_property(e),exp.ArrayUniqueAgg:rename_func(_b),exp.Split:lambda self,e:self.func(_R,e.this,self.func(_h,"'\\\\Q'",e.expression,"'\\\\E'")),exp.Select:transforms.preprocess([transforms.eliminate_qualify,transforms.eliminate_distinct_on,partial(transforms.unnest_to_explode,unnest_using_arrays_zip=_A)]),exp.StrPosition:strposition_to_locate_sql,exp.StrToDate:_str_to_date_sql,exp.StrToTime:_str_to_time_sql,exp.StrToUnix:_str_to_unix_sql,exp.StructExtract:struct_extract_sql,exp.Table:transforms.preprocess([transforms.unnest_generate_series]),exp.TimeStrToDate:rename_func(_J),exp.TimeStrToTime:timestrtotime_sql,exp.TimeStrToUnix:rename_func(_H),exp.TimestampTrunc:lambda self,e:self.func('TRUNC',e.this,unit_to_str(e)),exp.TimeToStr:lambda self,e:self.func(_c,e.this,self.format_time(e)),exp.TimeToUnix:rename_func(_H),exp.ToBase64:rename_func(_Z),exp.TsOrDiToDi:lambda self,e:f"CAST(SUBSTR(REPLACE(CAST({self.sql(e,_C)} AS STRING), '-', ''), 1, 8) AS INT)",exp.TsOrDsAdd:_add_date_sql,exp.TsOrDsDiff:_date_diff_sql,exp.TsOrDsToDate:_to_date_sql,exp.TryCast:no_trycast_sql,exp.UnixToStr:lambda self,e:self.func(_I,e.this,time_format(_E)(self,e)),exp.UnixToTime:_unix_to_time_sql,exp.UnixToTimeStr:rename_func(_I),exp.Unnest:rename_func(_i),exp.PartitionedByProperty:lambda self,e:f"PARTITIONED BY {self.sql(e,_C)}",exp.NumberToStr:rename_func('FORMAT_NUMBER'),exp.National:lambda self,e:self.national_sql(e,prefix=''),exp.ClusteredColumnConstraint:lambda self,e:f"({self.expressions(e,_C,indent=_A)})",exp.NonClusteredColumnConstraint:lambda self,e:f"({self.expressions(e,_C,indent=_A)})",exp.NotForReplicationColumnConstraint:lambda*A:'',exp.OnProperty:lambda*A:'',exp.PrimaryKeyColumnConstraint:lambda*A:'PRIMARY KEY',exp.WeekOfYear:rename_func('WEEKOFYEAR'),exp.DayOfMonth:rename_func('DAYOFMONTH'),exp.DayOfWeek:rename_func('DAYOFWEEK')};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.FileFormatProperty:exp.Properties.Location.POST_SCHEMA,exp.PartitionedByProperty:exp.Properties.Location.POST_SCHEMA,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED,exp.WithDataProperty:exp.Properties.Location.UNSUPPORTED}
		def unnest_sql(A,expression):return rename_func(_i)(A,expression)
		def _jsonpathkey_sql(B,expression):
			A=expression
			if isinstance(A.this,exp.JSONPathWildcard):B.unsupported('Unsupported wildcard in JSONPathKey expression');return''
			return super()._jsonpathkey_sql(A)
		def parameter_sql(C,expression):
			B=expression;A=C.sql(B,_C);D=C.sql(B,_O);E=B.parent;A=f"{A}:{D}"if D else A
			if isinstance(E,exp.EQ)and isinstance(E.parent,exp.SetItem):return A
			return f"${{{A}}}"
		def schema_sql(D,expression):
			C='desc';A=expression
			for B in A.find_all(exp.Ordered):
				if B.args.get(C)is _A:B.set(C,_D)
			return super().schema_sql(A)
		def constraint_sql(B,expression):
			A=expression
			for C in list(A.find_all(exp.Properties)):C.pop()
			D=B.sql(A,_C);E=B.expressions(A,sep=' ',flat=_B);return f"CONSTRAINT {D} {E}"
		def rowformatserdeproperty_sql(B,expression):C=expression;A=B.sql(C,'serde_properties');A=f" {A}"if A else'';return f"ROW FORMAT SERDE {B.sql(C,_C)}{A}"
		def arrayagg_sql(B,expression):A=expression;return B.func(_a,A.this.this if isinstance(A.this,exp.Order)else A.this)
		def datatype_sql(D,expression):
			C='float';A=expression
			if A.this in D.PARAMETERIZABLE_TEXT_TYPES and(not A.expressions or A.expressions[0].name=='MAX'):A=exp.DataType.build('text')
			elif A.is_type(exp.DataType.Type.TEXT)and A.expressions:A.set(_C,exp.DataType.Type.VARCHAR)
			elif A.this in exp.DataType.TEMPORAL_TYPES:A=exp.DataType.build(A.this)
			elif A.is_type(C):
				B=A.find(exp.DataTypeParam)
				if B:E=int(B.name);A=exp.DataType.build(C)if E<=32 else exp.DataType.build('double')
			return super().datatype_sql(A)
		def version_sql(B,expression):A=super().version_sql(expression);return A.replace('FOR ','',1)
		def struct_sql(C,expression):
			A=[]
			for(D,B)in enumerate(expression.expressions):
				if isinstance(B,exp.PropertyEQ):C.unsupported('Hive does not support named structs.');A.append(B.expression)
				else:A.append(B)
			return C.func('STRUCT',*A)
		def alterset_sql(A,expression):B=expression;C=A.expressions(B,flat=_B);C=f" {C}"if C else'';D=A.sql(B,'location');D=f" LOCATION {D}"if D else'';E=A.expressions(B,key='file_format',flat=_B,sep=' ');E=f" FILEFORMAT {E}"if E else'';F=A.sql(B,'serde');F=f" SERDE {F}"if F else'';G=A.expressions(B,key='tag',flat=_B,sep='');G=f" TAGS {G}"if G else'';return f"SET{F}{C}{D}{E}{G}"
		def serdeproperties_sql(B,expression):A=expression;C='WITH 'if A.args.get('with')else'';D=B.expressions(A,flat=_B);return f"{C}SERDEPROPERTIES ({D})"