from __future__ import annotations
_B='LIST'
_A='MAP'
from sqlglot import exp
from sqlglot.helper import seq_get
from sqlglot.dialects.postgres import Postgres
from sqlglot.tokens import TokenType
from sqlglot.transforms import remove_unique_constraints,ctas_with_tmp_tables_to_create_tmp_view,preprocess
import typing as t
class Materialize(Postgres):
	class Parser(Postgres.Parser):
		NO_PAREN_FUNCTION_PARSERS={**Postgres.Parser.NO_PAREN_FUNCTION_PARSERS,_A:lambda self:self._parse_map()};LAMBDAS={**Postgres.Parser.LAMBDAS,TokenType.FARROW:lambda self,expressions:self.expression(exp.Kwarg,this=seq_get(expressions,0),expression=self._parse_assignment())}
		def _parse_lambda_arg(A):return A._parse_field()
		def _parse_map(A):
			if A._match(TokenType.L_PAREN):B=A.expression(exp.ToMap,this=A._parse_select());A._match_r_paren();return B
			if not A._match(TokenType.L_BRACKET):A.raise_error('Expecting [')
			C=[exp.PropertyEQ(this=A.this,expression=A.expression)for A in A._parse_csv(A._parse_lambda)]
			if not A._match(TokenType.R_BRACKET):A.raise_error('Expecting ]')
			return A.expression(exp.ToMap,this=A.expression(exp.Struct,expressions=C))
	class Generator(Postgres.Generator):
		SUPPORTS_CREATE_TABLE_LIKE=False;TRANSFORMS={**Postgres.Generator.TRANSFORMS,exp.AutoIncrementColumnConstraint:lambda self,e:'',exp.Create:preprocess([remove_unique_constraints,ctas_with_tmp_tables_to_create_tmp_view]),exp.GeneratedAsIdentityColumnConstraint:lambda self,e:'',exp.OnConflict:lambda self,e:'',exp.PrimaryKeyColumnConstraint:lambda self,e:''};TRANSFORMS.pop(exp.ToMap)
		def propertyeq_sql(A,expression):return A.binary(expression,'=>')
		def datatype_sql(B,expression):
			A=expression
			if A.is_type(exp.DataType.Type.LIST):
				if A.expressions:return f"{B.expressions(A,flat=True)} LIST"
				return _B
			if A.is_type(exp.DataType.Type.MAP)and len(A.expressions)==2:C,D=A.expressions;return f"MAP[{B.sql(C)} => {B.sql(D)}]"
			return super().datatype_sql(A)
		def list_sql(A,expression):
			B=expression
			if isinstance(seq_get(B.expressions,0),exp.Select):return A.func(_B,seq_get(B.expressions,0))
			return f"{A.normalize_func(_B)}[{A.expressions(B,flat=True)}]"
		def tomap_sql(A,expression):
			B=expression
			if isinstance(B.this,exp.Select):return A.func(_A,B.this)
			return f"{A.normalize_func(_A)}[{A.expressions(B.this)}]"