from __future__ import annotations
_AH='UNIX_TIMESTAMP'
_AG='separator'
_AF='expression'
_AE='PERSIST_ONLY'
_AD='TABLE STATUS'
_AC='PRIVILEGES'
_AB='PROCEDURE STATUS'
_AA='PROCEDURE CODE'
_A9='OPEN TABLES'
_A8='MASTER STATUS'
_A7='FUNCTION STATUS'
_A6='FUNCTION CODE'
_A5='CREATE VIEW'
_A4='CREATE TRIGGER'
_A3='CREATE TABLE'
_A2='CREATE PROCEDURE'
_A1='CREATE FUNCTION'
_A0='CREATE EVENT'
_z='CREATE DATABASE'
_y='COLLATION'
_x='VALUES'
_w='GROUP_CONCAT'
_v='WEEKOFYEAR'
_u='TIMESTAMPDIFF'
_t='MAKETIME'
_s='DAYOFYEAR'
_r='DAYOFWEEK'
_q='DAYOFMONTH'
_p='DATE_FORMAT'
_o='CONVERT_TZ'
_n='UNSIGNED'
_m='SIGNED'
_l='MEDIUMINT'
_k='format'
_j='limit'
_i='TIMESTAMP'
_h='ADD'
_g='SPATIAL'
_f='FULLTEXT'
_e='FOR'
_d='TABLES'
_c='REPLICA STATUS'
_b='REPLICAS'
_a='RELAYLOG EVENTS'
_Z='PROCESSLIST'
_Y='GRANTS'
_X='ENGINES'
_W='ENGINE'
_V='DATABASES'
_U='BINLOG EVENTS'
_T='BINARY LOGS'
_S='CHARSET'
_R='FROM_UNIXTIME'
_Q='STR_TO_DATE'
_P='DAY'
_O='YEAR'
_N='LIMIT'
_M='VARIABLES'
_L='PROFILE'
_K='COLUMNS'
_J='KEY'
_I='STATUS'
_H='DATE'
_G='FROM'
_F='INDEX'
_E='CHARACTER SET'
_D='this'
_C=False
_B=None
_A=True
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,arrow_json_extract_sql,date_add_interval_sql,datestrtodate_sql,build_formatted_time,isnull_to_is_null,locate_to_strposition,max_or_greatest,min_or_least,no_ilike_sql,no_paren_current_date_sql,no_pivot_sql,no_tablesample_sql,no_trycast_sql,build_date_delta,build_date_delta_with_interval,rename_func,strposition_to_locate_sql,unit_to_var,trim_sql,timestrtotime_sql
from sqlglot.helper import seq_get
from sqlglot.tokens import TokenType
def _show_parser(*A,**B):
	def C(self):return self._parse_show_mysql(*A,**B)
	return C
def _date_trunc_sql(self,expression):
	G=expression;F='%Y %c %e';C=self;A=C.sql(G,_D);B=G.text('unit').upper()
	if B=='WEEK':D=f"CONCAT(YEAR({A}), ' ', WEEK({A}, 1), ' 1')";E='%Y %u %w'
	elif B=='MONTH':D=f"CONCAT(YEAR({A}), ' ', MONTH({A}), ' 1')";E=F
	elif B=='QUARTER':D=f"CONCAT(YEAR({A}), ' ', QUARTER({A}) * 3 - 2, ' 1')";E=F
	elif B==_O:D=f"CONCAT(YEAR({A}), ' 1 1')";E=F
	else:
		if B!=_P:C.unsupported(f"Unexpected interval unit: {B}")
		return C.func(_H,A)
	return C.func(_Q,D,f"'{E}'")
TIME_SPECIFIERS={'f','H','h','I','i','k','l','p','r','S','s','T'}
def _has_time_specifier(date_format):
	B=date_format;A=0;C=len(B)
	while A<C:
		if B[A]=='%':
			A+=1
			if A<C and B[A]in TIME_SPECIFIERS:return _A
		A+=1
	return _C
def _str_to_date(args):
	A=seq_get(args,1);B=MySQL.format_time(A);C=seq_get(args,0)
	if A and _has_time_specifier(A.name):return exp.StrToTime(this=C,format=B)
	return exp.StrToDate(this=C,format=B)
def _str_to_date_sql(self,expression):A=expression;return self.func(_Q,A.this,self.format_time(A))
def _unix_to_time_sql(self,expression):
	B=expression;A=self;C=B.args.get('scale');D=B.this
	if C in(_B,exp.UnixToTime.SECONDS):return A.func(_R,D,A.format_time(B))
	return A.func(_R,exp.Div(this=D,expression=exp.func('POW',10,C)),A.format_time(B))
def date_add_sql(kind):
	def A(self,expression):A=expression;return self.func(f"DATE_{kind}",A.this,exp.Interval(this=A.expression,unit=unit_to_var(A)))
	return A
def _ts_or_ds_to_date_sql(self,expression):A=expression;B=A.args.get(_k);return _str_to_date_sql(self,A)if B else self.func(_H,A.this)
def _remove_ts_or_ds_to_date(to_sql=_B,args=(_D,)):
	C=to_sql
	def A(self,expression):
		A=expression
		for D in args:
			B=A.args.get(D)
			if isinstance(B,exp.TsOrDsToDate)and not B.args.get(_k):A.set(D,B.this)
		return C(self,A)if C else self.function_fallback_sql(A)
	return A
class MySQL(Dialect):
	IDENTIFIERS_CAN_START_WITH_DIGIT=_A;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_SENSITIVE;TIME_FORMAT="'%Y-%m-%d %T'";DPIPE_IS_STRING_CONCAT=_C;SUPPORTS_USER_DEFINED_TYPES=_C;SUPPORTS_SEMI_ANTI_JOIN=_C;SAFE_DIVISION=_A;TIME_MAPPING={'%M':'%B','%c':'%-m','%e':'%-d','%h':'%I','%i':'%M','%s':'%S','%u':'%W','%k':'%-H','%l':'%-I','%T':'%H:%M:%S','%W':'%A'}
	class Tokenizer(tokens.Tokenizer):QUOTES=["'",'"'];COMMENTS=['--','#',('/*','*/')];IDENTIFIERS=['`'];STRING_ESCAPES=["'",'"','\\'];BIT_STRINGS=[("b'","'"),("B'","'"),('0b','')];HEX_STRINGS=[("x'","'"),("X'","'"),('0x','')];KEYWORDS={**tokens.Tokenizer.KEYWORDS,_S:TokenType.CHARACTER_SET,'FORCE':TokenType.FORCE,'IGNORE':TokenType.IGNORE,_J:TokenType.KEY,'LOCK TABLES':TokenType.COMMAND,'LONGBLOB':TokenType.LONGBLOB,'LONGTEXT':TokenType.LONGTEXT,'MEDIUMBLOB':TokenType.MEDIUMBLOB,'TINYBLOB':TokenType.TINYBLOB,'TINYTEXT':TokenType.TINYTEXT,'MEDIUMTEXT':TokenType.MEDIUMTEXT,_l:TokenType.MEDIUMINT,'MEMBER OF':TokenType.MEMBER_OF,'SEPARATOR':TokenType.SEPARATOR,'START':TokenType.BEGIN,_m:TokenType.BIGINT,'SIGNED INTEGER':TokenType.BIGINT,'UNLOCK TABLES':TokenType.COMMAND,_n:TokenType.UBIGINT,'UNSIGNED INTEGER':TokenType.UBIGINT,_O:TokenType.YEAR,'_ARMSCII8':TokenType.INTRODUCER,'_ASCII':TokenType.INTRODUCER,'_BIG5':TokenType.INTRODUCER,'_BINARY':TokenType.INTRODUCER,'_CP1250':TokenType.INTRODUCER,'_CP1251':TokenType.INTRODUCER,'_CP1256':TokenType.INTRODUCER,'_CP1257':TokenType.INTRODUCER,'_CP850':TokenType.INTRODUCER,'_CP852':TokenType.INTRODUCER,'_CP866':TokenType.INTRODUCER,'_CP932':TokenType.INTRODUCER,'_DEC8':TokenType.INTRODUCER,'_EUCJPMS':TokenType.INTRODUCER,'_EUCKR':TokenType.INTRODUCER,'_GB18030':TokenType.INTRODUCER,'_GB2312':TokenType.INTRODUCER,'_GBK':TokenType.INTRODUCER,'_GEOSTD8':TokenType.INTRODUCER,'_GREEK':TokenType.INTRODUCER,'_HEBREW':TokenType.INTRODUCER,'_HP8':TokenType.INTRODUCER,'_KEYBCS2':TokenType.INTRODUCER,'_KOI8R':TokenType.INTRODUCER,'_KOI8U':TokenType.INTRODUCER,'_LATIN1':TokenType.INTRODUCER,'_LATIN2':TokenType.INTRODUCER,'_LATIN5':TokenType.INTRODUCER,'_LATIN7':TokenType.INTRODUCER,'_MACCE':TokenType.INTRODUCER,'_MACROMAN':TokenType.INTRODUCER,'_SJIS':TokenType.INTRODUCER,'_SWE7':TokenType.INTRODUCER,'_TIS620':TokenType.INTRODUCER,'_UCS2':TokenType.INTRODUCER,'_UJIS':TokenType.INTRODUCER,'_UTF8':TokenType.INTRODUCER,'_UTF16':TokenType.INTRODUCER,'_UTF16LE':TokenType.INTRODUCER,'_UTF32':TokenType.INTRODUCER,'_UTF8MB3':TokenType.INTRODUCER,'_UTF8MB4':TokenType.INTRODUCER,'@@':TokenType.SESSION_PARAMETER};COMMANDS={*tokens.Tokenizer.COMMANDS,TokenType.REPLACE}-{TokenType.SHOW}
	class Parser(parser.Parser):
		FUNC_TOKENS={*parser.Parser.FUNC_TOKENS,TokenType.DATABASE,TokenType.SCHEMA,TokenType.VALUES};CONJUNCTION={**parser.Parser.CONJUNCTION,TokenType.DAMP:exp.And,TokenType.XOR:exp.Xor};DISJUNCTION={**parser.Parser.DISJUNCTION,TokenType.DPIPE:exp.Or};TABLE_ALIAS_TOKENS=parser.Parser.TABLE_ALIAS_TOKENS-parser.Parser.TABLE_INDEX_HINT_TOKENS;RANGE_PARSERS={**parser.Parser.RANGE_PARSERS,TokenType.MEMBER_OF:lambda self,this:self.expression(exp.JSONArrayContains,this=this,expression=self._parse_wrapped(self._parse_expression))};FUNCTIONS={**parser.Parser.FUNCTIONS,_o:lambda args:exp.ConvertTimezone(source_tz=seq_get(args,1),target_tz=seq_get(args,2),timestamp=seq_get(args,0)),_H:lambda args:exp.TsOrDsToDate(this=seq_get(args,0)),'DATE_ADD':build_date_delta_with_interval(exp.DateAdd),_p:build_formatted_time(exp.TimeToStr,'mysql'),'DATE_SUB':build_date_delta_with_interval(exp.DateSub),_P:lambda args:exp.Day(this=exp.TsOrDsToDate(this=seq_get(args,0))),_q:lambda args:exp.DayOfMonth(this=exp.TsOrDsToDate(this=seq_get(args,0))),_r:lambda args:exp.DayOfWeek(this=exp.TsOrDsToDate(this=seq_get(args,0))),_s:lambda args:exp.DayOfYear(this=exp.TsOrDsToDate(this=seq_get(args,0))),_R:build_formatted_time(exp.UnixToTime,'mysql'),'ISNULL':isnull_to_is_null,'LOCATE':locate_to_strposition,_t:exp.TimeFromParts.from_arg_list,'MONTH':lambda args:exp.Month(this=exp.TsOrDsToDate(this=seq_get(args,0))),'MONTHNAME':lambda args:exp.TimeToStr(this=exp.TsOrDsToDate(this=seq_get(args,0)),format=exp.Literal.string('%B')),_Q:_str_to_date,_u:build_date_delta(exp.TimestampDiff),'TO_DAYS':lambda args:exp.paren(exp.DateDiff(this=exp.TsOrDsToDate(this=seq_get(args,0)),expression=exp.TsOrDsToDate(this=exp.Literal.string('0000-01-01')),unit=exp.var(_P))+1),'WEEK':lambda args:exp.Week(this=exp.TsOrDsToDate(this=seq_get(args,0)),mode=seq_get(args,1)),_v:lambda args:exp.WeekOfYear(this=exp.TsOrDsToDate(this=seq_get(args,0))),_O:lambda args:exp.Year(this=exp.TsOrDsToDate(this=seq_get(args,0)))};FUNCTION_PARSERS={**parser.Parser.FUNCTION_PARSERS,'CHAR':lambda self:self.expression(exp.Chr,expressions=self._parse_csv(self._parse_assignment),charset=self._match(TokenType.USING)and self._parse_var()),_w:lambda self:self._parse_group_concat(),_x:lambda self:self.expression(exp.Anonymous,this=_x,expressions=[self._parse_id_var()]),'JSON_VALUE':lambda self:self._parse_json_value()};STATEMENT_PARSERS={**parser.Parser.STATEMENT_PARSERS,TokenType.SHOW:lambda self:self._parse_show()};SHOW_PARSERS={_T:_show_parser(_T),'MASTER LOGS':_show_parser(_T),_U:_show_parser(_U),_E:_show_parser(_E),_S:_show_parser(_E),_y:_show_parser(_y),'FULL COLUMNS':_show_parser(_K,target=_G,full=_A),_K:_show_parser(_K,target=_G),_z:_show_parser(_z,target=_A),_A0:_show_parser(_A0,target=_A),_A1:_show_parser(_A1,target=_A),_A2:_show_parser(_A2,target=_A),_A3:_show_parser(_A3,target=_A),_A4:_show_parser(_A4,target=_A),_A5:_show_parser(_A5,target=_A),_V:_show_parser(_V),'SCHEMAS':_show_parser(_V),_W:_show_parser(_W,target=_A),'STORAGE ENGINES':_show_parser(_X),_X:_show_parser(_X),'ERRORS':_show_parser('ERRORS'),'EVENTS':_show_parser('EVENTS'),_A6:_show_parser(_A6,target=_A),_A7:_show_parser(_A7),_Y:_show_parser(_Y,target=_e),_F:_show_parser(_F,target=_G),_A8:_show_parser(_A8),_A9:_show_parser(_A9),'PLUGINS':_show_parser('PLUGINS'),_AA:_show_parser(_AA,target=_A),_AB:_show_parser(_AB),_AC:_show_parser(_AC),'FULL PROCESSLIST':_show_parser(_Z,full=_A),_Z:_show_parser(_Z),_L:_show_parser(_L),'PROFILES':_show_parser('PROFILES'),_a:_show_parser(_a),_b:_show_parser(_b),'SLAVE HOSTS':_show_parser(_b),_c:_show_parser(_c),'SLAVE STATUS':_show_parser(_c),'GLOBAL STATUS':_show_parser(_I,global_=_A),'SESSION STATUS':_show_parser(_I),_I:_show_parser(_I),_AD:_show_parser(_AD),'FULL TABLES':_show_parser(_d,full=_A),_d:_show_parser(_d),'TRIGGERS':_show_parser('TRIGGERS'),'GLOBAL VARIABLES':_show_parser(_M,global_=_A),'SESSION VARIABLES':_show_parser(_M),_M:_show_parser(_M),'WARNINGS':_show_parser('WARNINGS')};PROPERTY_PARSERS={**parser.Parser.PROPERTY_PARSERS,'LOCK':lambda self:self._parse_property_assignment(exp.LockProperty)};SET_PARSERS={**parser.Parser.SET_PARSERS,'PERSIST':lambda self:self._parse_set_item_assignment('PERSIST'),_AE:lambda self:self._parse_set_item_assignment(_AE),_E:lambda self:self._parse_set_item_charset(_E),_S:lambda self:self._parse_set_item_charset(_E),'NAMES':lambda self:self._parse_set_item_names()};CONSTRAINT_PARSERS={**parser.Parser.CONSTRAINT_PARSERS,_f:lambda self:self._parse_index_constraint(kind=_f),_F:lambda self:self._parse_index_constraint(),_J:lambda self:self._parse_index_constraint(),_g:lambda self:self._parse_index_constraint(kind=_g)};ALTER_PARSERS={**parser.Parser.ALTER_PARSERS,'MODIFY':lambda self:self._parse_alter_table_alter()};SCHEMA_UNNAMED_CONSTRAINTS={*parser.Parser.SCHEMA_UNNAMED_CONSTRAINTS,_f,_F,_J,_g};PROFILE_TYPES:parser.OPTIONS_TYPE={**dict.fromkeys(('ALL','CPU','IPC','MEMORY','SOURCE','SWAPS'),tuple()),'BLOCK':('IO',),'CONTEXT':('SWITCHES',),'PAGE':('FAULTS',)};TYPE_TOKENS={*parser.Parser.TYPE_TOKENS,TokenType.SET};ENUM_TYPE_TOKENS={*parser.Parser.ENUM_TYPE_TOKENS,TokenType.SET};LOG_DEFAULTS_TO_LN=_A;STRING_ALIASES=_A;VALUES_FOLLOWED_BY_PAREN=_C;SUPPORTS_PARTITION_SELECTION=_A
		def _parse_primary_key_part(A):
			B=A._parse_id_var()
			if not A._match(TokenType.L_PAREN):return B
			C=A._parse_number();A._match_r_paren();return A.expression(exp.ColumnPrefix,this=B,expression=C)
		def _parse_index_constraint(A,kind=_B):
			if kind:A._match_texts((_F,_J))
			D=A._parse_id_var(any_token=_C);E=A._match(TokenType.USING)and A._advance_any()and A._prev.text;F=A._parse_wrapped_csv(A._parse_ordered);C=[]
			while _A:
				if A._match_text_seq('KEY_BLOCK_SIZE'):A._match(TokenType.EQ);B=exp.IndexConstraintOption(key_block_size=A._parse_number())
				elif A._match(TokenType.USING):B=exp.IndexConstraintOption(using=A._advance_any()and A._prev.text)
				elif A._match_text_seq('WITH','PARSER'):B=exp.IndexConstraintOption(parser=A._parse_var(any_token=_A))
				elif A._match(TokenType.COMMENT):B=exp.IndexConstraintOption(comment=A._parse_string())
				elif A._match_text_seq('VISIBLE'):B=exp.IndexConstraintOption(visible=_A)
				elif A._match_text_seq('INVISIBLE'):B=exp.IndexConstraintOption(visible=_C)
				elif A._match_text_seq('ENGINE_ATTRIBUTE'):A._match(TokenType.EQ);B=exp.IndexConstraintOption(engine_attr=A._parse_string())
				elif A._match_text_seq('SECONDARY_ENGINE_ATTRIBUTE'):A._match(TokenType.EQ);B=exp.IndexConstraintOption(secondary_engine_attr=A._parse_string())
				else:B=_B
				if not B:break
				C.append(B)
			return A.expression(exp.IndexColumnConstraint,this=D,expressions=F,kind=kind,index_type=E,options=C)
		def _parse_show_mysql(A,this,target=_C,full=_B,global_=_B):
			E=target;D=this
			if E:
				if isinstance(E,str):A._match_text_seq(E)
				B=A._parse_id_var()
			else:B=_B
			L=A._parse_string()if A._match_text_seq('IN')else _B
			if D in(_U,_a):G=A._parse_number()if A._match_text_seq(_G)else _B;C=_B
			else:
				G=_B;C=_B
				if A._match(TokenType.FROM):C=A._parse_id_var()
				elif A._match(TokenType.DOT):C=B;B=A._parse_id_var()
			M=A._parse_id_var()if A._match_text_seq(_e,'CHANNEL')else _B;N=A._parse_string()if A._match_text_seq('LIKE')else _B;O=A._parse_where()
			if D==_L:H=A._parse_csv(lambda:A._parse_var_from_options(A.PROFILE_TYPES));I=A._parse_number()if A._match_text_seq(_e,'QUERY')else _B;J=A._parse_number()if A._match_text_seq('OFFSET')else _B;K=A._parse_number()if A._match_text_seq(_N)else _B
			else:H,I=_B,_B;J,K=A._parse_oldstyle_limit()
			F=_A if A._match_text_seq('MUTEX')else _B;F=_C if A._match_text_seq(_I)else F;return A.expression(exp.Show,this=D,target=B,full=full,log=L,position=G,db=C,channel=M,like=N,where=O,types=H,query=I,offset=J,limit=K,mutex=F,**{'global':global_})
		def _parse_oldstyle_limit(B):
			C=_B;D=_B
			if B._match_text_seq(_N):
				A=B._parse_csv(B._parse_number)
				if len(A)==1:C=A[0]
				elif len(A)==2:C=A[1];D=A[0]
			return D,C
		def _parse_set_item_charset(A,kind):B=A._parse_string()or A._parse_unquoted_field();return A.expression(exp.SetItem,this=B,kind=kind)
		def _parse_set_item_names(A):
			C=A._parse_string()or A._parse_unquoted_field()
			if A._match_text_seq('COLLATE'):B=A._parse_string()or A._parse_unquoted_field()
			else:B=_B
			return A.expression(exp.SetItem,this=C,collate=B,kind='NAMES')
		def _parse_type(A,parse_interval=_A,fallback_to_identifier=_C):
			if A._match(TokenType.BINARY,advance=_C):
				B=A._parse_types(check_func=_A,allow_identifiers=_C)
				if isinstance(B,exp.DataType):return A.expression(exp.Cast,this=A._parse_column(),to=B)
			return super()._parse_type(parse_interval=parse_interval,fallback_to_identifier=fallback_to_identifier)
		def _parse_group_concat(B):
			def D(node,exprs):
				D=exprs;C=node
				if isinstance(C,exp.Distinct)and len(C.expressions)>1:E=[B.expression(exp.Concat,expressions=C.expressions,safe=_A)];C.set('expressions',E);return C
				if len(D)==1:return D[0]
				return B.expression(exp.Concat,expressions=A,safe=_A)
			A=B._parse_csv(B._parse_lambda)
			if A:
				C=A[-1]if isinstance(A[-1],exp.Order)else _B
				if C:A[-1]=C.this;C.set(_D,D(C.this,A))
				E=C or D(A[0],A)
			else:E=_B
			F=B._parse_field()if B._match(TokenType.SEPARATOR)else _B;return B.expression(exp.GroupConcat,this=E,separator=F)
		def _parse_json_value(A):B=A._parse_bitwise();A._match(TokenType.COMMA);C=A._parse_bitwise();D=A._match(TokenType.RETURNING)and A._parse_type();return A.expression(exp.JSONValue,this=B,path=A.dialect.to_json_path(C),returning=D,on_condition=A._parse_on_condition())
	class Generator(generator.Generator):
		INTERVAL_ALLOWS_PLURAL_FORM=_C;LOCKING_READS_SUPPORTED=_A;NULL_ORDERING_SUPPORTED=_B;JOIN_HINTS=_C;TABLE_HINTS=_A;DUPLICATE_KEY_UPDATE_WITH_SET=_C;QUERY_HINT_SEP=' ';VALUES_AS_TABLE=_C;NVL2_SUPPORTED=_C;LAST_DAY_SUPPORTS_DATE_PART=_C;JSON_TYPE_REQUIRED_FOR_EXTRACTION=_A;JSON_PATH_BRACKETED_KEY_SUPPORTED=_C;JSON_KEY_VALUE_PAIR_SEP=',';SUPPORTS_TO_NUMBER=_C;PARSE_JSON_NAME:t.Optional[str]=_B;PAD_FILL_PATTERN_IS_REQUIRED=_A;WRAP_DERIVED_VALUES=_C;VARCHAR_REQUIRES_SIZE=_A;TRANSFORMS={**generator.Generator.TRANSFORMS,exp.ArrayAgg:rename_func(_w),exp.CurrentDate:no_paren_current_date_sql,exp.DateDiff:_remove_ts_or_ds_to_date(lambda self,e:self.func('DATEDIFF',e.this,e.expression),(_D,_AF)),exp.DateAdd:_remove_ts_or_ds_to_date(date_add_sql(_h)),exp.DateStrToDate:datestrtodate_sql,exp.DateSub:_remove_ts_or_ds_to_date(date_add_sql('SUB')),exp.DateTrunc:_date_trunc_sql,exp.Day:_remove_ts_or_ds_to_date(),exp.DayOfMonth:_remove_ts_or_ds_to_date(rename_func(_q)),exp.DayOfWeek:_remove_ts_or_ds_to_date(rename_func(_r)),exp.DayOfYear:_remove_ts_or_ds_to_date(rename_func(_s)),exp.GroupConcat:lambda self,e:f"GROUP_CONCAT({self.sql(e,_D)} SEPARATOR {self.sql(e,_AG)or"','"})",exp.ILike:no_ilike_sql,exp.JSONExtractScalar:arrow_json_extract_sql,exp.Max:max_or_greatest,exp.Min:min_or_least,exp.Month:_remove_ts_or_ds_to_date(),exp.NullSafeEQ:lambda self,e:self.binary(e,'<=>'),exp.NullSafeNEQ:lambda self,e:f"NOT {self.binary(e,"<=>")}",exp.Pivot:no_pivot_sql,exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_semi_and_anti_joins,transforms.eliminate_qualify,transforms.eliminate_full_outer_join,transforms.unnest_generate_date_array_using_recursive_cte]),exp.StrPosition:strposition_to_locate_sql,exp.StrToDate:_str_to_date_sql,exp.StrToTime:_str_to_date_sql,exp.Stuff:rename_func('INSERT'),exp.TableSample:no_tablesample_sql,exp.TimeFromParts:rename_func(_t),exp.TimestampAdd:date_add_interval_sql(_H,_h),exp.TimestampDiff:lambda self,e:self.func(_u,unit_to_var(e),e.expression,e.this),exp.TimestampSub:date_add_interval_sql(_H,'SUB'),exp.TimeStrToUnix:rename_func(_AH),exp.TimeStrToTime:lambda self,e:timestrtotime_sql(self,e,include_precision=not e.args.get('zone')),exp.TimeToStr:_remove_ts_or_ds_to_date(lambda self,e:self.func(_p,e.this,self.format_time(e))),exp.Trim:trim_sql,exp.TryCast:no_trycast_sql,exp.TsOrDsAdd:date_add_sql(_h),exp.TsOrDsDiff:lambda self,e:self.func('DATEDIFF',e.this,e.expression),exp.TsOrDsToDate:_ts_or_ds_to_date_sql,exp.UnixToTime:_unix_to_time_sql,exp.Week:_remove_ts_or_ds_to_date(),exp.WeekOfYear:_remove_ts_or_ds_to_date(rename_func(_v)),exp.Year:_remove_ts_or_ds_to_date()};UNSIGNED_TYPE_MAPPING={exp.DataType.Type.UBIGINT:'BIGINT',exp.DataType.Type.UINT:'INT',exp.DataType.Type.UMEDIUMINT:_l,exp.DataType.Type.USMALLINT:'SMALLINT',exp.DataType.Type.UTINYINT:'TINYINT',exp.DataType.Type.UDECIMAL:'DECIMAL'};TIMESTAMP_TYPE_MAPPING={exp.DataType.Type.TIMESTAMP:'DATETIME',exp.DataType.Type.TIMESTAMPTZ:_i,exp.DataType.Type.TIMESTAMPLTZ:_i};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,**UNSIGNED_TYPE_MAPPING,**TIMESTAMP_TYPE_MAPPING};TYPE_MAPPING.pop(exp.DataType.Type.MEDIUMTEXT);TYPE_MAPPING.pop(exp.DataType.Type.LONGTEXT);TYPE_MAPPING.pop(exp.DataType.Type.TINYTEXT);TYPE_MAPPING.pop(exp.DataType.Type.MEDIUMBLOB);TYPE_MAPPING.pop(exp.DataType.Type.LONGBLOB);TYPE_MAPPING.pop(exp.DataType.Type.TINYBLOB);PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.TransientProperty:exp.Properties.Location.UNSUPPORTED,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED};LIMIT_FETCH=_N;LIMIT_ONLY_LITERALS=_A;CHAR_CAST_MAPPING=dict.fromkeys((exp.DataType.Type.LONGTEXT,exp.DataType.Type.LONGBLOB,exp.DataType.Type.MEDIUMBLOB,exp.DataType.Type.MEDIUMTEXT,exp.DataType.Type.TEXT,exp.DataType.Type.TINYBLOB,exp.DataType.Type.TINYTEXT,exp.DataType.Type.VARCHAR),'CHAR');SIGNED_CAST_MAPPING=dict.fromkeys((exp.DataType.Type.BIGINT,exp.DataType.Type.BOOLEAN,exp.DataType.Type.INT,exp.DataType.Type.SMALLINT,exp.DataType.Type.TINYINT,exp.DataType.Type.MEDIUMINT),_m);CAST_MAPPING={**CHAR_CAST_MAPPING,**SIGNED_CAST_MAPPING,exp.DataType.Type.UBIGINT:_n};TIMESTAMP_FUNC_TYPES={exp.DataType.Type.TIMESTAMPTZ,exp.DataType.Type.TIMESTAMPLTZ};RESERVED_KEYWORDS={'accessible','add','all','alter','analyze','and','as','asc','asensitive','before','between','bigint','binary','blob','both','by','call','cascade','case','change','char','character','check','collate','column','condition','constraint','continue','convert','create','cross','cube','cume_dist','current_date','current_time','current_timestamp','current_user','cursor','database','databases','day_hour','day_microsecond','day_minute','day_second','dec','decimal','declare','default','delayed','delete','dense_rank','desc','describe','deterministic','distinct','distinctrow','div','double','drop','dual','each','else','elseif','empty','enclosed','escaped','except','exists','exit','explain','false','fetch','first_value','float','float4','float8','for','force','foreign','from','fulltext','function','generated','get','grant','group','grouping','groups','having','high_priority','hour_microsecond','hour_minute','hour_second','if','ignore','in','index','infile','inner','inout','insensitive','insert','int','int1','int2','int3','int4','int8','integer','intersect','interval','into','io_after_gtids','io_before_gtids','is','iterate','join','json_table','key','keys','kill','lag','last_value','lateral','lead','leading','leave','left','like',_j,'linear','lines','load','localtime','localtimestamp','lock','long','longblob','longtext','loop','low_priority','master_bind','master_ssl_verify_server_cert','match','maxvalue','mediumblob','mediumint','mediumtext','middleint','minute_microsecond','minute_second','mod','modifies','natural','not','no_write_to_binlog','nth_value','ntile','null','numeric','of','on','optimize','optimizer_costs','option','optionally','or','order','out','outer','outfile','over','partition','percent_rank','precision','primary','procedure','purge','range','rank','read','reads','read_write','real','recursive','references','regexp','release','rename','repeat','replace','require','resignal','restrict','return','revoke','right','rlike','row','rows','row_number','schema','schemas','second_microsecond','select','sensitive',_AG,'set','show','signal','smallint','spatial','specific','sql','sqlexception','sqlstate','sqlwarning','sql_big_result','sql_calc_found_rows','sql_small_result','ssl','starting','stored','straight_join','system','table','terminated','then','tinyblob','tinyint','tinytext','to','trailing','trigger','true','undo','union','unique','unlock','unsigned','update','usage','use','using','utc_date','utc_time','utc_timestamp','values','varbinary','varchar','varcharacter','varying','virtual','when','where','while','window','with','write','xor','year_month','zerofill'}
		def array_sql(A,expression):A.unsupported('Arrays are not supported by MySQL');return A.function_fallback_sql(expression)
		def arraycontainsall_sql(A,expression):A.unsupported('Array operations are not supported by MySQL');return A.function_fallback_sql(expression)
		def dpipe_sql(A,expression):return A.func('CONCAT',*expression.flatten())
		def extract_sql(C,expression):
			A=expression;B=A.name
			if B and B.lower()=='epoch':return C.func(_AH,A.expression)
			return super().extract_sql(A)
		def datatype_sql(C,expression):
			A=expression
			if C.VARCHAR_REQUIRES_SIZE and A.is_type(exp.DataType.Type.VARCHAR)and not A.expressions:return'TEXT'
			B=super().datatype_sql(A)
			if A.this in C.UNSIGNED_TYPE_MAPPING:B=f"{B} UNSIGNED"
			return B
		def jsonarraycontains_sql(A,expression):B=expression;return f"{A.sql(B,_D)} MEMBER OF({A.sql(B,_AF)})"
		def cast_sql(B,expression,safe_prefix=_B):
			A=expression
			if A.to.this in B.TIMESTAMP_FUNC_TYPES:return B.func(_i,A.this)
			C=B.CAST_MAPPING.get(A.to.this)
			if C:A.to.set(_D,C)
			return super().cast_sql(A)
		def show_sql(B,expression):
			A=expression;H=f" {A.name}";I=' FULL'if A.args.get('full')else'';J=' GLOBAL'if A.args.get('global')else'';C=B.sql(A,'target');C=f" {C}"if C else''
			if A.name in(_K,_F):C=f" FROM{C}"
			elif A.name==_Y:C=f" FOR{C}"
			K=B._prefixed_sql(_G,A,'db');L=B._prefixed_sql('LIKE',A,'like');M=B.sql(A,'where');D=B.expressions(A,key='types');D=f" {D}"if D else D;N=B._prefixed_sql('FOR QUERY',A,'query')
			if A.name==_L:E=B._prefixed_sql('OFFSET',A,'offset');F=B._prefixed_sql(_N,A,_j)
			else:E='';F=B._oldstyle_limit_sql(A)
			O=B._prefixed_sql('IN',A,'log');P=B._prefixed_sql(_G,A,'position');Q=B._prefixed_sql('FOR CHANNEL',A,'channel')
			if A.name==_W:G=' MUTEX'if A.args.get('mutex')else' STATUS'
			else:G=''
			return f"SHOW{I}{J}{H}{C}{D}{K}{N}{O}{P}{Q}{G}{L}{M}{E}{F}"
		def altercolumn_sql(B,expression):
			A=expression;C=B.sql(A,'dtype')
			if not C:return super().altercolumn_sql(A)
			D=B.sql(A,_D);return f"MODIFY COLUMN {D} {C}"
		def _prefixed_sql(B,prefix,expression,arg):A=B.sql(expression,arg);return f" {prefix} {A}"if A else''
		def _oldstyle_limit_sql(B,expression):
			C=expression;A=B.sql(C,_j);D=B.sql(C,'offset')
			if A:E=f"{D}, {A}"if D else A;return f" LIMIT {E}"
			return''
		def chr_sql(B,expression):A=expression;D=B.expressions(sqls=[A.this]+A.expressions);C=A.args.get('charset');E=f" USING {B.sql(C)}"if C else'';return f"CHAR({D}{E})"
		def timestamptrunc_sql(D,expression):A=expression;B=A.args.get('unit');C="'0000-01-01 00:00:00'";E=build_date_delta(exp.TimestampDiff)([B,C,A.this]);F=exp.Interval(this=E,unit=B);G=build_date_delta_with_interval(exp.DateAdd)([C,F]);return D.sql(G)
		def converttimezone_sql(B,expression):A=expression;C=A.args.get('source_tz');D=A.args.get('target_tz');E=A.args.get('timestamp');return B.func(_o,E,C,D)
		def attimezone_sql(A,expression):A.unsupported('AT TIME ZONE is not supported by MySQL');return A.sql(expression.this)