from __future__ import annotations
_U='RETURNING'
_T='PASSING'
_S='TEMPORARY'
_R='PRIVATE'
_Q='SYSDATE'
_P='TO_TIMESTAMP'
_O='TO_CHAR'
_N='VARCHAR2'
_M='SAMPLE'
_L='NVARCHAR2'
_K='COLUMNS'
_J='BULK COLLECT INTO'
_I='BLOB'
_H='GLOBAL'
_G='TO_DATE'
_F='oracle'
_E='this'
_D='%p'
_C='NUMBER'
_B=False
_A=True
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,build_formatted_time,no_ilike_sql,rename_func,to_number_with_nls_param,trim_sql
from sqlglot.helper import seq_get
from sqlglot.parser import OPTIONS_TYPE,build_coalesce
from sqlglot.tokens import TokenType
if t.TYPE_CHECKING:from sqlglot._typing import E
def _build_timetostr_or_tochar(args):
	B=args;A=seq_get(B,0)
	if A and not A.type:
		from sqlglot.optimizer.annotate_types import annotate_types as C;C(A)
		if A.is_type(*exp.DataType.TEMPORAL_TYPES):return build_formatted_time(exp.TimeToStr,_F,default=_A)(B)
	return exp.ToChar.from_arg_list(B)
def _trim_sql(self,expression):
	A=expression;B=A.args.get('position')
	if B and B.upper()in('LEADING','TRAILING'):return self.trim_sql(A)
	return trim_sql(self,A)
class Oracle(Dialect):
	ALIAS_POST_TABLESAMPLE=_A;LOCKING_READS_SUPPORTED=_A;TABLESAMPLE_SIZE_IS_PERCENT=_A;NULL_ORDERING='nulls_are_large';ON_CONDITION_EMPTY_BEFORE_ERROR=_B;NORMALIZATION_STRATEGY=NormalizationStrategy.UPPERCASE;TIME_MAPPING={'AM':_D,'A.M.':_D,'PM':_D,'P.M.':_D,'D':'%u','DAY':'%A','DD':'%d','DDD':'%j','DY':'%a','HH':'%I','HH12':'%I','HH24':'%H','IW':'%V','MI':'%M','MM':'%m','MON':'%b','MONTH':'%B','SS':'%S','WW':'%W','YY':'%y','YYYY':'%Y','FF6':'%f'}
	class Tokenizer(tokens.Tokenizer):VAR_SINGLE_TOKENS={'@','$','#'};UNICODE_STRINGS=[(B+A,A)for A in t.cast(t.List[str],tokens.Tokenizer.QUOTES)for B in('U','u')];NESTED_COMMENTS=_B;KEYWORDS={**tokens.Tokenizer.KEYWORDS,'(+)':TokenType.JOIN_MARKER,'BINARY_DOUBLE':TokenType.DOUBLE,'BINARY_FLOAT':TokenType.FLOAT,_J:TokenType.BULK_COLLECT_INTO,_K:TokenType.COLUMN,'MATCH_RECOGNIZE':TokenType.MATCH_RECOGNIZE,'MINUS':TokenType.EXCEPT,_L:TokenType.NVARCHAR,'ORDER SIBLINGS BY':TokenType.ORDER_SIBLINGS_BY,_M:TokenType.TABLE_SAMPLE,'START':TokenType.BEGIN,'TOP':TokenType.TOP,_N:TokenType.VARCHAR}
	class Parser(parser.Parser):
		ALTER_TABLE_ADD_REQUIRED_FOR_EACH_COLUMN=_B;WINDOW_BEFORE_PAREN_TOKENS={TokenType.OVER,TokenType.KEEP};VALUES_FOLLOWED_BY_PAREN=_B;FUNCTIONS={**parser.Parser.FUNCTIONS,'NVL':lambda args:build_coalesce(args,is_nvl=_A),'SQUARE':lambda args:exp.Pow(this=seq_get(args,0),expression=exp.Literal.number(2)),_O:_build_timetostr_or_tochar,_P:build_formatted_time(exp.StrToTime,_F),_G:build_formatted_time(exp.StrToDate,_F),'TRUNC':lambda args:exp.DateTrunc(unit=seq_get(args,1)or exp.Literal.string('DD'),this=seq_get(args,0))};NO_PAREN_FUNCTION_PARSERS={**parser.Parser.NO_PAREN_FUNCTION_PARSERS,_Q:lambda self:self.expression(exp.CurrentTimestamp,sysdate=_A)};FUNCTION_PARSERS:t.Dict[str,t.Callable]={**parser.Parser.FUNCTION_PARSERS,'JSON_ARRAY':lambda self:self._parse_json_array(exp.JSONArray,expressions=self._parse_csv(lambda:self._parse_format_json(self._parse_bitwise()))),'JSON_ARRAYAGG':lambda self:self._parse_json_array(exp.JSONArrayAgg,this=self._parse_format_json(self._parse_bitwise()),order=self._parse_order()),'XMLTABLE':lambda self:self._parse_xml_table(),'JSON_EXISTS':lambda self:self._parse_json_exists()};PROPERTY_PARSERS={**parser.Parser.PROPERTY_PARSERS,_H:lambda self:self._match_text_seq(_S)and self.expression(exp.TemporaryProperty,this=_H),_R:lambda self:self._match_text_seq(_S)and self.expression(exp.TemporaryProperty,this=_R)};QUERY_MODIFIER_PARSERS={**parser.Parser.QUERY_MODIFIER_PARSERS,TokenType.ORDER_SIBLINGS_BY:lambda self:('order',self._parse_order()),TokenType.WITH:lambda self:('options',[self._parse_query_restrictions()])};TYPE_LITERAL_PARSERS={exp.DataType.Type.DATE:lambda self,this,_:self.expression(exp.DateStrToDate,this=this)};DISTINCT_TOKENS={TokenType.DISTINCT,TokenType.UNIQUE};QUERY_RESTRICTIONS:OPTIONS_TYPE={'WITH':(('READ','ONLY'),('CHECK','OPTION'))}
		def _parse_xml_table(A):
			D=A._parse_string();B=None;C=None
			if A._match_text_seq(_T):A._match_text_seq('BY','VALUE');B=A._parse_csv(A._parse_column)
			E=A._match_text_seq(_U,'SEQUENCE','BY','REF')
			if A._match_text_seq(_K):C=A._parse_csv(A._parse_field_def)
			return A.expression(exp.XMLTable,this=D,passing=B,columns=C,by_ref=E)
		def _parse_json_array(A,expr_type,**C):B='NULL';return A.expression(expr_type,null_handling=A._parse_on_handling(B,B,'ABSENT'),return_type=A._match_text_seq(_U)and A._parse_type(),strict=A._match_text_seq('STRICT'),**C)
		def _parse_hint(A):
			if A._match(TokenType.HINT):
				B=A._curr
				while A._curr and not A._match_pair(TokenType.STAR,TokenType.SLASH):A._advance()
				if not A._curr:A.raise_error('Expected */ after HINT')
				C=A._tokens[A._index-3];return exp.Hint(expressions=[A._find_sql(B,C)])
		def _parse_query_restrictions(A):
			B=A._parse_var_from_options(A.QUERY_RESTRICTIONS,raise_unmatched=_B)
			if not B:return
			return A.expression(exp.QueryOption,this=B,expression=A._match(TokenType.CONSTRAINT)and A._parse_field())
		def _parse_json_exists(A):B=A._parse_format_json(A._parse_bitwise());A._match(TokenType.COMMA);return A.expression(exp.JSONExists,this=B,path=A.dialect.to_json_path(A._parse_bitwise()),passing=A._match_text_seq(_T)and A._parse_csv(lambda:A._parse_alias(A._parse_bitwise())),on_condition=A._parse_on_condition())
		def _parse_into(A):
			B=A._match(TokenType.BULK_COLLECT_INTO)
			if not B and not A._match(TokenType.INTO):return
			D=A._index;C=A._parse_expressions()
			if len(C)==1:A._retreat(D);A._match(TokenType.TABLE);return A.expression(exp.Into,this=A._parse_table(schema=_A),bulk_collect=B)
			return A.expression(exp.Into,bulk_collect=B,expressions=C)
	class Generator(generator.Generator):
		LOCKING_READS_SUPPORTED=_A;JOIN_HINTS=_B;TABLE_HINTS=_B;DATA_TYPE_SPECIFIERS_ALLOWED=_A;ALTER_TABLE_INCLUDE_COLUMN_KEYWORD=_B;LIMIT_FETCH='FETCH';TABLESAMPLE_KEYWORDS=_M;LAST_DAY_SUPPORTS_DATE_PART=_B;SUPPORTS_SELECT_INTO=_A;TZ_TO_WITH_TIME_ZONE=_A;TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.TINYINT:_C,exp.DataType.Type.SMALLINT:_C,exp.DataType.Type.INT:_C,exp.DataType.Type.BIGINT:_C,exp.DataType.Type.DECIMAL:_C,exp.DataType.Type.DOUBLE:'DOUBLE PRECISION',exp.DataType.Type.VARCHAR:_N,exp.DataType.Type.NVARCHAR:_L,exp.DataType.Type.NCHAR:'NCHAR',exp.DataType.Type.TEXT:'CLOB',exp.DataType.Type.TIMETZ:'TIME',exp.DataType.Type.TIMESTAMPTZ:'TIMESTAMP',exp.DataType.Type.BINARY:_I,exp.DataType.Type.VARBINARY:_I,exp.DataType.Type.ROWVERSION:_I};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.DateStrToDate:lambda self,e:self.func(_G,e.this,exp.Literal.string('YYYY-MM-DD')),exp.DateTrunc:lambda self,e:self.func('TRUNC',e.this,e.unit),exp.Group:transforms.preprocess([transforms.unalias_group]),exp.ILike:no_ilike_sql,exp.Mod:rename_func('MOD'),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_qualify]),exp.StrToTime:lambda self,e:self.func(_P,e.this,self.format_time(e)),exp.StrToDate:lambda self,e:self.func(_G,e.this,self.format_time(e)),exp.Subquery:lambda self,e:self.subquery_sql(e,sep=' '),exp.Substring:rename_func('SUBSTR'),exp.Table:lambda self,e:self.table_sql(e,sep=' '),exp.TableSample:lambda self,e:self.tablesample_sql(e),exp.TemporaryProperty:lambda _,e:f"{e.name or _H} TEMPORARY",exp.TimeToStr:lambda self,e:self.func(_O,e.this,self.format_time(e)),exp.ToChar:lambda self,e:self.function_fallback_sql(e),exp.ToNumber:to_number_with_nls_param,exp.Trim:_trim_sql,exp.UnixToTime:lambda self,e:f"TO_DATE('1970-01-01', 'YYYY-MM-DD') + ({self.sql(e,_E)} / 86400)"};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED}
		def currenttimestamp_sql(D,expression):
			C='CURRENT_TIMESTAMP';A=expression
			if A.args.get('sysdate'):return _Q
			B=A.this;return D.func(C,B)if B else C
		def offset_sql(A,expression):return f"{super().offset_sql(expression)} ROWS"
		def xmltable_sql(A,expression):B=expression;E=A.sql(B,_E);C=A.expressions(B,key='passing');C=f"{A.sep()}PASSING{A.seg(C)}"if C else'';D=A.expressions(B,key='columns');D=f"{A.sep()}COLUMNS{A.seg(D)}"if D else'';F=f"{A.sep()}RETURNING SEQUENCE BY REF"if B.args.get('by_ref')else'';return f"XMLTABLE({A.sep("")}{A.indent(E+C+F+D)}{A.seg(")",sep="")}"
		def add_column_sql(D,expression):
			C='actions';A=expression;B=D.expressions(A,key=C,flat=_A)
			if len(A.args.get(C,[]))>1:return f"ADD ({B})"
			return f"ADD {B}"
		def queryoption_sql(B,expression):C=expression;D=B.sql(C,_E);A=B.sql(C,'expression');A=f" CONSTRAINT {A}"if A else'';return f"{D}{A}"
		def coalesce_sql(B,expression):A=expression;C='NVL'if A.args.get('is_nvl')else'COALESCE';return rename_func(C)(B,A)
		def into_sql(A,expression):
			B=expression;C='INTO'if not B.args.get('bulk_collect')else _J
			if B.this:return f"{A.seg(C)} {A.sql(B,_E)}"
			return f"{A.seg(C)} {A.expressions(B)}"