from __future__ import annotations
_T='DATE_PART'
_S='UNNEST'
_R='TO_DATE'
_Q='TO_CHAR'
_P='MAKE_TIMESTAMP'
_O='MAKE_TIME'
_N='JSON_EXTRACT_PATH_TEXT'
_M='JSON_EXTRACT_PATH'
_L='GENERATE_SERIES'
_K='constraints'
_J='ARRAY'
_I='BYTEA'
_H='DIV'
_G='postgres'
_F='unit'
_E='TO_TIMESTAMP'
_D=None
_C='this'
_B=False
_A=True
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import DATE_ADD_OR_SUB,Dialect,JSON_EXTRACT_TYPE,any_value_to_max_sql,binary_from_function,bool_xor_sql,datestrtodate_sql,build_formatted_time,filter_array_using_unnest,json_extract_segments,json_path_key_only_name,max_or_greatest,merge_without_target_sql,min_or_least,no_last_day_sql,no_map_from_entries_sql,no_paren_current_date_sql,no_pivot_sql,no_trycast_sql,build_json_extract_path,build_timestamp_trunc,rename_func,sha256_sql,str_position_sql,struct_extract_sql,timestamptrunc_sql,timestrtotime_sql,trim_sql,ts_or_ds_add_cast
from sqlglot.helper import is_int,seq_get
from sqlglot.parser import binary_range_parser
from sqlglot.tokens import TokenType
DATE_DIFF_FACTOR={'MICROSECOND':' * 1000000','MILLISECOND':' * 1000','SECOND':'','MINUTE':' / 60','HOUR':' / 3600','DAY':' / 86400'}
def _date_add_sql(kind):
	def A(self,expression):
		C=self;A=expression
		if isinstance(A,exp.TsOrDsAdd):A=ts_or_ds_add_cast(A)
		D=C.sql(A,_C);E=A.args.get(_F);B=C._simplify_unless_literal(A.expression)
		if isinstance(B,exp.Literal):B.args['is_string']=_A
		elif B.is_number:B=exp.Literal.string(B.to_py())
		else:C.unsupported('Cannot add non literal')
		return f"{D} {kind} {C.sql(exp.Interval(this=B,unit=E))}"
	return A
def _date_diff_sql(self,expression):
	C=expression;A=C.text(_F).upper();F=DATE_DIFF_FACTOR.get(A);D=f"CAST({self.sql(C,_C)} AS TIMESTAMP)";E=f"CAST({self.sql(C,"expression")} AS TIMESTAMP)"
	if F is not _D:return f"CAST(EXTRACT(epoch FROM {D} - {E}){F} AS BIGINT)"
	B=f"AGE({D}, {E})"
	if A=='WEEK':A=f"EXTRACT(days FROM ({D} - {E})) / 7"
	elif A=='MONTH':A=f"EXTRACT(year FROM {B}) * 12 + EXTRACT(month FROM {B})"
	elif A=='QUARTER':A=f"EXTRACT(year FROM {B}) * 4 + EXTRACT(month FROM {B}) / 3"
	elif A=='YEAR':A=f"EXTRACT(year FROM {B})"
	else:A=B
	return f"CAST({A} AS BIGINT)"
def _substring_sql(self,expression):B=expression;A=self;E=A.sql(B,_C);C=A.sql(B,'start');D=A.sql(B,'length');F=f" FROM {C}"if C else'';G=f" FOR {D}"if D else'';return f"SUBSTRING({E}{F}{G})"
def _string_agg_sql(self,expression):
	B=expression;D=B.args.get('separator')or exp.Literal.string(',');C='';A=B.this
	if isinstance(A,exp.Order):
		if A.this:A=A.this.pop()
		C=self.sql(B.this)
	return f"STRING_AGG({self.format_args(A,D)}{C})"
def _auto_increment_to_serial(expression):
	B=expression;C=B.find(exp.AutoIncrementColumnConstraint)
	if C:
		B.args[_K].remove(C.parent);A=B.args['kind']
		if A.this==exp.DataType.Type.INT:A.replace(exp.DataType(this=exp.DataType.Type.SERIAL))
		elif A.this==exp.DataType.Type.SMALLINT:A.replace(exp.DataType(this=exp.DataType.Type.SMALLSERIAL))
		elif A.this==exp.DataType.Type.BIGINT:A.replace(exp.DataType(this=exp.DataType.Type.BIGSERIAL))
	return B
def _serial_to_generated(expression):
	A=expression
	if not isinstance(A,exp.ColumnDef):return A
	C=A.kind
	if not C:return A
	if C.this==exp.DataType.Type.SERIAL:B=exp.DataType(this=exp.DataType.Type.INT)
	elif C.this==exp.DataType.Type.SMALLSERIAL:B=exp.DataType(this=exp.DataType.Type.SMALLINT)
	elif C.this==exp.DataType.Type.BIGSERIAL:B=exp.DataType(this=exp.DataType.Type.BIGINT)
	else:B=_D
	if B:
		A.args['kind'].replace(B);D=A.args[_K];E=exp.ColumnConstraint(kind=exp.GeneratedAsIdentityColumnConstraint(this=_B));F=exp.ColumnConstraint(kind=exp.NotNullColumnConstraint())
		if F not in D:D.insert(0,F)
		if E not in D:D.insert(0,E)
	return A
def _build_generate_series(args):
	B=args;A=seq_get(B,2)
	if A is not _D:
		if A.is_string:B[2]=exp.to_interval(A.this)
		elif isinstance(A,exp.Interval)and not A.args.get(_F):B[2]=exp.to_interval(A.this.this)
	return exp.ExplodingGenerateSeries.from_arg_list(B)
def _build_to_timestamp(args):
	A=args
	if len(A)==1:return exp.UnixToTime.from_arg_list(A)
	return build_formatted_time(exp.StrToTime,_G)(A)
def _json_extract_sql(name,op):
	def A(self,expression):
		A=expression
		if A.args.get('only_json_types'):return json_extract_segments(name,quoted_index=_B,op=op)(self,A)
		return json_extract_segments(name)(self,A)
	return A
def _build_regexp_replace(args):
	B=args
	if len(B)>3:
		A=B[-1]
		if not is_int(A.name):
			if not A.type or A.is_type(exp.DataType.Type.UNKNOWN,exp.DataType.Type.NULL):from sqlglot.optimizer.annotate_types import annotate_types as D;A=D(A)
			if A.is_type(*exp.DataType.TEXT_TYPES):C=exp.RegexpReplace.from_arg_list(B[:-1]);C.set('modifiers',A);return C
	return exp.RegexpReplace.from_arg_list(B)
def _unix_to_time_sql(self,expression):
	B=expression;A=self;C=B.args.get('scale');D=B.this
	if C in(_D,exp.UnixToTime.SECONDS):return A.func(_E,D,A.format_time(B))
	return A.func(_E,exp.Div(this=D,expression=exp.func('POW',10,C)),A.format_time(B))
class Postgres(Dialect):
	INDEX_OFFSET=1;TYPED_DIVISION=_A;CONCAT_COALESCE=_A;NULL_ORDERING='nulls_are_large';TIME_FORMAT="'YYYY-MM-DD HH24:MI:SS'";TABLESAMPLE_SIZE_IS_PERCENT=_A;TIME_MAPPING={'AM':'%p','PM':'%p','D':'%u','DD':'%d','DDD':'%j','FMDD':'%-d','FMDDD':'%-j','FMHH12':'%-I','FMHH24':'%-H','FMMI':'%-M','FMMM':'%-m','FMSS':'%-S','HH12':'%I','HH24':'%H','MI':'%M','MM':'%m','OF':'%z','SS':'%S','TMDay':'%A','TMDy':'%a','TMMon':'%b','TMMonth':'%B','TZ':'%Z','US':'%f','WW':'%U','YY':'%y','YYYY':'%Y'}
	class Tokenizer(tokens.Tokenizer):BIT_STRINGS=[("b'","'"),("B'","'")];HEX_STRINGS=[("x'","'"),("X'","'")];BYTE_STRINGS=[("e'","'"),("E'","'")];HEREDOC_STRINGS=['$'];HEREDOC_TAG_IS_IDENTIFIER=_A;HEREDOC_STRING_ALTERNATIVE=TokenType.PARAMETER;KEYWORDS={**tokens.Tokenizer.KEYWORDS,'~':TokenType.RLIKE,'@@':TokenType.DAT,'@>':TokenType.AT_GT,'<@':TokenType.LT_AT,'|/':TokenType.PIPE_SLASH,'||/':TokenType.DPIPE_SLASH,'BEGIN':TokenType.COMMAND,'BEGIN TRANSACTION':TokenType.BEGIN,'BIGSERIAL':TokenType.BIGSERIAL,'CHARACTER VARYING':TokenType.VARCHAR,'CONSTRAINT TRIGGER':TokenType.COMMAND,'CSTRING':TokenType.PSEUDO_TYPE,'DECLARE':TokenType.COMMAND,'DO':TokenType.COMMAND,'EXEC':TokenType.COMMAND,'HSTORE':TokenType.HSTORE,'INT8':TokenType.BIGINT,'MONEY':TokenType.MONEY,'NAME':TokenType.NAME,'OID':TokenType.OBJECT_IDENTIFIER,'ONLY':TokenType.ONLY,'OPERATOR':TokenType.OPERATOR,'REFRESH':TokenType.COMMAND,'REINDEX':TokenType.COMMAND,'RESET':TokenType.COMMAND,'REVOKE':TokenType.COMMAND,'SERIAL':TokenType.SERIAL,'SMALLSERIAL':TokenType.SMALLSERIAL,'TEMP':TokenType.TEMPORARY,'REGCLASS':TokenType.OBJECT_IDENTIFIER,'REGCOLLATION':TokenType.OBJECT_IDENTIFIER,'REGCONFIG':TokenType.OBJECT_IDENTIFIER,'REGDICTIONARY':TokenType.OBJECT_IDENTIFIER,'REGNAMESPACE':TokenType.OBJECT_IDENTIFIER,'REGOPER':TokenType.OBJECT_IDENTIFIER,'REGOPERATOR':TokenType.OBJECT_IDENTIFIER,'REGPROC':TokenType.OBJECT_IDENTIFIER,'REGPROCEDURE':TokenType.OBJECT_IDENTIFIER,'REGROLE':TokenType.OBJECT_IDENTIFIER,'REGTYPE':TokenType.OBJECT_IDENTIFIER,'FLOAT':TokenType.DOUBLE};KEYWORDS.pop('/*+');KEYWORDS.pop(_H);SINGLE_TOKENS={**tokens.Tokenizer.SINGLE_TOKENS,'$':TokenType.HEREDOC_STRING};VAR_SINGLE_TOKENS={'$'}
	class Parser(parser.Parser):
		PROPERTY_PARSERS={**parser.Parser.PROPERTY_PARSERS,'SET':lambda self:self.expression(exp.SetConfigProperty,this=self._parse_set())};PROPERTY_PARSERS.pop('INPUT');FUNCTIONS={**parser.Parser.FUNCTIONS,'DATE_TRUNC':build_timestamp_trunc,_H:lambda args:exp.cast(binary_from_function(exp.IntDiv)(args),exp.DataType.Type.DECIMAL),_L:_build_generate_series,_M:build_json_extract_path(exp.JSONExtract),_N:build_json_extract_path(exp.JSONExtractScalar),_O:exp.TimeFromParts.from_arg_list,_P:exp.TimestampFromParts.from_arg_list,'NOW':exp.CurrentTimestamp.from_arg_list,'REGEXP_REPLACE':_build_regexp_replace,_Q:build_formatted_time(exp.TimeToStr,_G),_R:build_formatted_time(exp.StrToDate,_G),_E:_build_to_timestamp,_S:exp.Explode.from_arg_list,'SHA256':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(256)),'SHA384':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(384)),'SHA512':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(512))};FUNCTION_PARSERS={**parser.Parser.FUNCTION_PARSERS,_T:lambda self:self._parse_date_part()};BITWISE={**parser.Parser.BITWISE,TokenType.HASH:exp.BitwiseXor};EXPONENT={TokenType.CARET:exp.Pow};RANGE_PARSERS={**parser.Parser.RANGE_PARSERS,TokenType.DAMP:binary_range_parser(exp.ArrayOverlaps),TokenType.DAT:lambda self,this:self.expression(exp.MatchAgainst,this=self._parse_bitwise(),expressions=[this]),TokenType.OPERATOR:lambda self,this:self._parse_operator(this)};STATEMENT_PARSERS={**parser.Parser.STATEMENT_PARSERS,TokenType.END:lambda self:self._parse_commit_or_rollback()};JSON_ARROWS_REQUIRE_JSON_TYPE=_A;COLUMN_OPERATORS={**parser.Parser.COLUMN_OPERATORS,TokenType.ARROW:lambda self,this,path:build_json_extract_path(exp.JSONExtract,arrow_req_json_type=self.JSON_ARROWS_REQUIRE_JSON_TYPE)([this,path]),TokenType.DARROW:lambda self,this,path:build_json_extract_path(exp.JSONExtractScalar,arrow_req_json_type=self.JSON_ARROWS_REQUIRE_JSON_TYPE)([this,path])}
		def _parse_operator(A,this):
			B=this
			while _A:
				if not A._match(TokenType.L_PAREN):break
				C=''
				while A._curr and not A._match(TokenType.R_PAREN):C+=A._curr.text;A._advance()
				B=A.expression(exp.Operator,comments=A._prev_comments,this=B,operator=C,expression=A._parse_bitwise())
				if not A._match(TokenType.OPERATOR):break
			return B
		def _parse_date_part(B):
			A=B._parse_type();B._match(TokenType.COMMA);C=B._parse_bitwise()
			if A and isinstance(A,(exp.Column,exp.Literal)):A=exp.var(A.name)
			return B.expression(exp.Extract,this=A,expression=C)
		def _parse_unique_key(A):0
	class Generator(generator.Generator):
		SINGLE_STRING_INTERVAL=_A;RENAME_TABLE_WITH_DB=_B;LOCKING_READS_SUPPORTED=_A;JOIN_HINTS=_B;TABLE_HINTS=_B;QUERY_HINTS=_B;NVL2_SUPPORTED=_B;PARAMETER_TOKEN='$';TABLESAMPLE_SIZE_IS_ROWS=_B;TABLESAMPLE_SEED_KEYWORD='REPEATABLE';SUPPORTS_SELECT_INTO=_A;JSON_TYPE_REQUIRED_FOR_EXTRACTION=_A;SUPPORTS_UNLOGGED_TABLES=_A;LIKE_PROPERTY_INSIDE_SCHEMA=_A;MULTI_ARG_DISTINCT=_B;CAN_IMPLEMENT_ARRAY_ANY=_A;COPY_HAS_INTO_KEYWORD=_B;ARRAY_CONCAT_IS_VAR_LEN=_B;SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.TINYINT:'SMALLINT',exp.DataType.Type.FLOAT:'REAL',exp.DataType.Type.DOUBLE:'DOUBLE PRECISION',exp.DataType.Type.BINARY:_I,exp.DataType.Type.VARBINARY:_I,exp.DataType.Type.ROWVERSION:_I,exp.DataType.Type.DATETIME:'TIMESTAMP'};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.AnyValue:any_value_to_max_sql,exp.ArrayConcat:lambda self,e:self.arrayconcat_sql(e,name='ARRAY_CAT'),exp.ArrayFilter:filter_array_using_unnest,exp.ArraySize:lambda self,e:self.func('ARRAY_LENGTH',e.this,e.expression or'1'),exp.BitwiseXor:lambda self,e:self.binary(e,'#'),exp.ColumnDef:transforms.preprocess([_auto_increment_to_serial,_serial_to_generated]),exp.CurrentDate:no_paren_current_date_sql,exp.CurrentTimestamp:lambda*A:'CURRENT_TIMESTAMP',exp.CurrentUser:lambda*A:'CURRENT_USER',exp.DateAdd:_date_add_sql('+'),exp.DateDiff:_date_diff_sql,exp.DateStrToDate:datestrtodate_sql,exp.DateSub:_date_add_sql('-'),exp.Explode:rename_func(_S),exp.ExplodingGenerateSeries:rename_func(_L),exp.GroupConcat:_string_agg_sql,exp.IntDiv:rename_func(_H),exp.JSONExtract:_json_extract_sql(_M,'->'),exp.JSONExtractScalar:_json_extract_sql(_N,'->>'),exp.JSONBExtract:lambda self,e:self.binary(e,'#>'),exp.JSONBExtractScalar:lambda self,e:self.binary(e,'#>>'),exp.JSONBContains:lambda self,e:self.binary(e,'?'),exp.ParseJSON:lambda self,e:self.sql(exp.cast(e.this,exp.DataType.Type.JSON)),exp.JSONPathKey:json_path_key_only_name,exp.JSONPathRoot:lambda*A:'',exp.JSONPathSubscript:lambda self,e:self.json_path_part(e.this),exp.LastDay:no_last_day_sql,exp.LogicalOr:rename_func('BOOL_OR'),exp.LogicalAnd:rename_func('BOOL_AND'),exp.Max:max_or_greatest,exp.MapFromEntries:no_map_from_entries_sql,exp.Min:min_or_least,exp.Merge:merge_without_target_sql,exp.PartitionedByProperty:lambda self,e:f"PARTITION BY {self.sql(e,_C)}",exp.PercentileCont:transforms.preprocess([transforms.add_within_group_for_percentiles]),exp.PercentileDisc:transforms.preprocess([transforms.add_within_group_for_percentiles]),exp.Pivot:no_pivot_sql,exp.Pow:lambda self,e:self.binary(e,'^'),exp.Rand:rename_func('RANDOM'),exp.RegexpLike:lambda self,e:self.binary(e,'~'),exp.RegexpILike:lambda self,e:self.binary(e,'~*'),exp.Select:transforms.preprocess([transforms.eliminate_semi_and_anti_joins,transforms.eliminate_qualify]),exp.SHA2:sha256_sql,exp.StrPosition:str_position_sql,exp.StrToDate:lambda self,e:self.func(_R,e.this,self.format_time(e)),exp.StrToTime:lambda self,e:self.func(_E,e.this,self.format_time(e)),exp.StructExtract:struct_extract_sql,exp.Substring:_substring_sql,exp.TimeFromParts:rename_func(_O),exp.TimestampFromParts:rename_func(_P),exp.TimestampTrunc:timestamptrunc_sql(zone=_A),exp.TimeStrToTime:timestrtotime_sql,exp.TimeToStr:lambda self,e:self.func(_Q,e.this,self.format_time(e)),exp.ToChar:lambda self,e:self.function_fallback_sql(e),exp.Trim:trim_sql,exp.TryCast:no_trycast_sql,exp.TsOrDsAdd:_date_add_sql('+'),exp.TsOrDsDiff:_date_diff_sql,exp.UnixToTime:lambda self,e:self.func(_E,e.this),exp.Uuid:lambda*A:'GEN_RANDOM_UUID()',exp.TimeToUnix:lambda self,e:self.func(_T,exp.Literal.string('epoch'),e.this),exp.VariancePop:rename_func('VAR_POP'),exp.Variance:rename_func('VAR_SAMP'),exp.Xor:bool_xor_sql,exp.UnixToTime:_unix_to_time_sql};TRANSFORMS.pop(exp.CommentColumnConstraint);PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.PartitionedByProperty:exp.Properties.Location.POST_SCHEMA,exp.TransientProperty:exp.Properties.Location.UNSUPPORTED,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED}
		def schemacommentproperty_sql(A,expression):A.unsupported('Table comments are not supported in the CREATE statement');return''
		def commentcolumnconstraint_sql(A,expression):A.unsupported('Column comments are not supported in the CREATE statement');return''
		def unnest_sql(C,expression):
			G='alias';A=expression
			if len(A.expressions)==1:
				E=A.expressions[0]
				if isinstance(E,exp.GenerateDateArray):
					F=exp.GenerateSeries(**E.args)
					if isinstance(A.parent,(exp.From,exp.Join)):F=exp.select('value::date').from_(F.as_('value')).subquery(A.args.get(G)or'_unnested_generate_series')
					return C.sql(F)
				from sqlglot.optimizer.annotate_types import annotate_types as H;B=H(E)
				if B.is_type('array<json>'):
					while isinstance(B,exp.Cast):B=B.this
					I=C.sql(exp.cast(B,exp.DataType.Type.JSON));D=C.sql(A,G);D=f" AS {D}"if D else''
					if A.args.get('offset'):C.unsupported('Unsupported JSON_ARRAY_ELEMENTS with offset')
					return f"JSON_ARRAY_ELEMENTS({I}){D}"
			return super().unnest_sql(A)
		def bracket_sql(B,expression):
			"Forms like ARRAY[1, 2, 3][3] aren't allowed; we need to wrap the ARRAY.";A=expression
			if isinstance(A.this,exp.Array):A.set(_C,exp.paren(A.this,copy=_B))
			return super().bracket_sql(A)
		def matchagainst_sql(A,expression):B=expression;E=A.sql(B,_C);C=[f"{A.sql(B)} @@ {E}"for B in B.expressions];D=' OR '.join(C);return f"({D})"if len(C)>1 else D
		def alterset_sql(A,expression):B=expression;C=A.expressions(B,flat=_A);C=f"({C})"if C else'';D=A.sql(B,'access_method');D=f"ACCESS METHOD {D}"if D else'';E=A.sql(B,'tablespace');E=f"TABLESPACE {E}"if E else'';F=A.sql(B,'option');return f"SET {C}{D}{E}{F}"
		def datatype_sql(B,expression):
			A=expression
			if A.is_type(exp.DataType.Type.ARRAY):
				if A.expressions:C=B.expressions(A,key='values',flat=_A);return f"{B.expressions(A,flat=_A)}[{C}]"
				return _J
			return super().datatype_sql(A)
		def cast_sql(C,expression,safe_prefix=_D):
			A=expression;B=A.this
			if isinstance(B,exp.IntDiv)and A.to==exp.DataType.build('decimal'):return C.sql(B)
			return super().cast_sql(A,safe_prefix=safe_prefix)
		def array_sql(A,expression):B=expression;C=B.expressions;return f"{A.normalize_func(_J)}({A.sql(C[0])})"if isinstance(seq_get(C,0),exp.Select)else f"{A.normalize_func(_J)}[{A.expressions(B,flat=_A)}]"