from __future__ import annotations
_j='offset'
_i='ARRAY_JOIN'
_h='TO_HEX'
_g='presto'
_f='TO_UTF8'
_e='SPLIT_TO_MAP'
_d='SET_AGG'
_c='FROM_UTF8'
_b='FROM_HEX'
_a='ELEMENT_AT'
_Z='CONTAINS'
_Y='CARDINALITY'
_X='BITWISE_XOR'
_W='BITWISE_OR'
_V='BITWISE_NOT'
_U='BITWISE_AND'
_T='HYPERLOGLOG'
_S='expression'
_R='FROM_UNIXTIME'
_Q='TIMESTAMP'
_P='utf-8'
_O='MD5'
_N='DAY_OF_WEEK'
_M='ARBITRARY'
_L='DATE_DIFF'
_K='APPROX_PERCENTILE'
_J='TO_UNIXTIME'
_I='DATE_FORMAT'
_H='ROW'
_G='DATE_PARSE'
_F=', '
_E='DATE_ADD'
_D=None
_C=True
_B=False
_A='this'
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,binary_from_function,bool_xor_sql,date_trunc_to_time,datestrtodate_sql,encode_decode_sql,build_formatted_time,if_sql,left_to_substring_sql,no_ilike_sql,no_pivot_sql,no_safe_divide_sql,no_timestamp_sql,regexp_extract_sql,rename_func,right_to_substring_sql,sha256_sql,struct_extract_sql,str_position_sql,timestamptrunc_sql,timestrtotime_sql,ts_or_ds_add_cast,unit_to_str,sequence_sql,build_regexp_extract
from sqlglot.dialects.hive import Hive
from sqlglot.dialects.mysql import MySQL
from sqlglot.helper import apply_index_offset,seq_get
from sqlglot.tokens import TokenType
from sqlglot.transforms import unqualify_columns
DATE_ADD_OR_SUB=t.Union[exp.DateAdd,exp.TimestampAdd,exp.DateSub]
def _explode_to_unnest_sql(self,expression):
	A=expression
	if isinstance(A.this,exp.Explode):return self.sql(exp.Join(this=exp.Unnest(expressions=[A.this.this],alias=A.args.get('alias'),offset=isinstance(A.this,exp.Posexplode)),kind='cross'))
	return self.lateral_sql(A)
def _initcap_sql(self,expression):A='(\\w)(\\w*)';return f"REGEXP_REPLACE({self.sql(expression,_A)}, '{A}', x -> UPPER(x[1]) || LOWER(x[2]))"
def _no_sort_array(self,expression):
	A=expression
	if A.args.get('asc')==exp.false():B='(a, b) -> CASE WHEN a < b THEN 1 WHEN a > b THEN -1 ELSE 0 END'
	else:B=_D
	return self.func('ARRAY_SORT',A.this,B)
def _schema_sql(self,expression):
	A=expression
	if isinstance(A.parent,exp.Property):D=_F.join(f"'{A.name}'"for A in A.expressions);return f"ARRAY[{D}]"
	if A.parent:
		for B in A.parent.find_all(exp.Schema):
			C=B.find_all(exp.ColumnDef)
			if C and isinstance(B.parent,exp.Property):A.expressions.extend(C)
	return self.schema_sql(A)
def _quantile_sql(self,expression):A=expression;self.unsupported('Presto does not support exact quantiles');return self.func(_K,A.this,A.args.get('quantile'))
def _str_to_time_sql(self,expression):A=expression;return self.func(_G,A.this,self.format_time(A))
def _ts_or_ds_to_date_sql(self,expression):
	B=expression;A=self;C=A.format_time(B)
	if C and C not in(Presto.TIME_FORMAT,Presto.DATE_FORMAT):return A.sql(exp.cast(_str_to_time_sql(A,B),exp.DataType.Type.DATE))
	return A.sql(exp.cast(exp.cast(B.this,exp.DataType.Type.TIMESTAMP),exp.DataType.Type.DATE))
def _ts_or_ds_add_sql(self,expression):A=expression;A=ts_or_ds_add_cast(A);B=unit_to_str(A);return self.func(_E,B,A.expression,A.this)
def _ts_or_ds_diff_sql(self,expression):A=expression;B=exp.cast(A.this,exp.DataType.Type.TIMESTAMP);C=exp.cast(A.expression,exp.DataType.Type.TIMESTAMP);D=unit_to_str(A);return self.func(_L,D,C,B)
def _build_approx_percentile(args):
	A=args
	if len(A)==4:return exp.ApproxQuantile(this=seq_get(A,0),weight=seq_get(A,1),quantile=seq_get(A,2),accuracy=seq_get(A,3))
	if len(A)==3:return exp.ApproxQuantile(this=seq_get(A,0),quantile=seq_get(A,1),accuracy=seq_get(A,2))
	return exp.ApproxQuantile.from_arg_list(A)
def _build_from_unixtime(args):
	A=args
	if len(A)==3:return exp.UnixToTime(this=seq_get(A,0),hours=seq_get(A,1),minutes=seq_get(A,2))
	if len(A)==2:return exp.UnixToTime(this=seq_get(A,0),zone=seq_get(A,1))
	return exp.UnixToTime.from_arg_list(A)
def _first_last_sql(self,expression):
	"\n    Trino doesn't support FIRST / LAST as functions, but they're valid in the context\n    of MATCH_RECOGNIZE, so we need to preserve them in that case. In all other cases\n    they're converted into an ARBITRARY call.\n\n    Reference: https://trino.io/docs/current/sql/match-recognize.html#logical-navigation-functions\n    ";A=expression
	if isinstance(A.find_ancestor(exp.MatchRecognize,exp.Select),exp.MatchRecognize):return self.function_fallback_sql(A)
	return rename_func(_M)(self,A)
def _unix_to_time_sql(self,expression):
	A=expression;B=A.args.get('scale');C=self.sql(A,_A)
	if B in(_D,exp.UnixToTime.SECONDS):return rename_func(_R)(self,A)
	return f"FROM_UNIXTIME(CAST({C} AS DOUBLE) / POW(10, {B}))"
def _to_int(self,expression):
	A=expression
	if not A.type:from sqlglot.optimizer.annotate_types import annotate_types as B;B(A,dialect=self.dialect)
	if A.type and A.type.this not in exp.DataType.INTEGER_TYPES:return exp.cast(A,to=exp.DataType.Type.BIGINT)
	return A
def _build_to_char(args):
	A=seq_get(args,1)
	if isinstance(A,exp.Literal):A.set(_A,A.this.upper())
	return build_formatted_time(exp.TimeToStr,'teradata')(args)
def _date_delta_sql(name,negate_interval=_B):
	def A(self,expression):A=expression;B=_to_int(self,A.expression);return self.func(name,unit_to_str(A),B*-1 if negate_interval else B,A.this)
	return A
class Presto(Dialect):
	INDEX_OFFSET=1;NULL_ORDERING='nulls_are_last';TIME_FORMAT=MySQL.TIME_FORMAT;STRICT_STRING_CONCAT=_C;SUPPORTS_SEMI_ANTI_JOIN=_B;TYPED_DIVISION=_C;TABLESAMPLE_SIZE_IS_PERCENT=_C;LOG_BASE_FIRST:t.Optional[bool]=_D;TIME_MAPPING=MySQL.TIME_MAPPING;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE;ANNOTATORS={**Dialect.ANNOTATORS,exp.Floor:lambda self,e:self._annotate_by_args(e,_A),exp.Ceil:lambda self,e:self._annotate_by_args(e,_A),exp.Mod:lambda self,e:self._annotate_by_args(e,_A,_S),exp.Round:lambda self,e:self._annotate_by_args(e,_A),exp.Sign:lambda self,e:self._annotate_by_args(e,_A),exp.Abs:lambda self,e:self._annotate_by_args(e,_A),exp.Rand:lambda self,e:self._annotate_by_args(e,_A)if e.this else self._set_type(e,exp.DataType.Type.DOUBLE)}
	class Tokenizer(tokens.Tokenizer):UNICODE_STRINGS=[(B+A,A)for A in t.cast(t.List[str],tokens.Tokenizer.QUOTES)for B in('U&','u&')];KEYWORDS={**tokens.Tokenizer.KEYWORDS,'START':TokenType.BEGIN,'MATCH_RECOGNIZE':TokenType.MATCH_RECOGNIZE,_H:TokenType.STRUCT,'IPADDRESS':TokenType.IPADDRESS,'IPPREFIX':TokenType.IPPREFIX,'TDIGEST':TokenType.TDIGEST,_T:TokenType.HLLSKETCH};KEYWORDS.pop('/*+');KEYWORDS.pop('QUALIFY')
	class Parser(parser.Parser):VALUES_FOLLOWED_BY_PAREN=_B;FUNCTIONS={**parser.Parser.FUNCTIONS,_M:exp.AnyValue.from_arg_list,'APPROX_DISTINCT':exp.ApproxDistinct.from_arg_list,_K:_build_approx_percentile,_U:binary_from_function(exp.BitwiseAnd),_V:lambda args:exp.BitwiseNot(this=seq_get(args,0)),_W:binary_from_function(exp.BitwiseOr),_X:binary_from_function(exp.BitwiseXor),_Y:exp.ArraySize.from_arg_list,_Z:exp.ArrayContains.from_arg_list,_E:lambda args:exp.DateAdd(this=seq_get(args,2),expression=seq_get(args,1),unit=seq_get(args,0)),_L:lambda args:exp.DateDiff(this=seq_get(args,2),expression=seq_get(args,1),unit=seq_get(args,0)),_I:build_formatted_time(exp.TimeToStr,_g),_G:build_formatted_time(exp.StrToTime,_g),'DATE_TRUNC':date_trunc_to_time,_N:exp.DayOfWeekIso.from_arg_list,_a:lambda args:exp.Bracket(this=seq_get(args,0),expressions=[seq_get(args,1)],offset=1,safe=_C),_b:exp.Unhex.from_arg_list,_R:_build_from_unixtime,_c:lambda args:exp.Decode(this=seq_get(args,0),replace=seq_get(args,1),charset=exp.Literal.string(_P)),'NOW':exp.CurrentTimestamp.from_arg_list,'REGEXP_EXTRACT':build_regexp_extract,'REGEXP_REPLACE':lambda args:exp.RegexpReplace(this=seq_get(args,0),expression=seq_get(args,1),replacement=seq_get(args,2)or exp.Literal.string('')),_H:exp.Struct.from_arg_list,'SEQUENCE':exp.GenerateSeries.from_arg_list,_d:exp.ArrayUniqueAgg.from_arg_list,_e:exp.StrToMap.from_arg_list,'STRPOS':lambda args:exp.StrPosition(this=seq_get(args,0),substr=seq_get(args,1),instance=seq_get(args,2)),'TO_CHAR':_build_to_char,_J:exp.TimeToUnix.from_arg_list,_f:lambda args:exp.Encode(this=seq_get(args,0),charset=exp.Literal.string(_P)),_O:exp.MD5Digest.from_arg_list,'SHA256':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(256)),'SHA512':lambda args:exp.SHA2(this=seq_get(args,0),length=exp.Literal.number(512))};FUNCTION_PARSERS=parser.Parser.FUNCTION_PARSERS.copy();FUNCTION_PARSERS.pop('TRIM')
	class Generator(generator.Generator):
		INTERVAL_ALLOWS_PLURAL_FORM=_B;JOIN_HINTS=_B;TABLE_HINTS=_B;QUERY_HINTS=_B;IS_BOOL_ALLOWED=_B;TZ_TO_WITH_TIME_ZONE=_C;NVL2_SUPPORTED=_B;STRUCT_DELIMITER='(',')';LIMIT_ONLY_LITERALS=_C;SUPPORTS_SINGLE_ARG_CONCAT=_B;LIKE_PROPERTY_INSIDE_SCHEMA=_C;MULTI_ARG_DISTINCT=_B;SUPPORTS_TO_NUMBER=_B;HEX_FUNC=_h;PARSE_JSON_NAME='JSON_PARSE';PAD_FILL_PATTERN_IS_REQUIRED=_C;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_B;PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.LocationProperty:exp.Properties.Location.UNSUPPORTED,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.INT:'INTEGER',exp.DataType.Type.FLOAT:'REAL',exp.DataType.Type.BINARY:'VARBINARY',exp.DataType.Type.TEXT:'VARCHAR',exp.DataType.Type.TIMETZ:'TIME',exp.DataType.Type.TIMESTAMPTZ:_Q,exp.DataType.Type.STRUCT:_H,exp.DataType.Type.DATETIME:_Q,exp.DataType.Type.DATETIME64:_Q,exp.DataType.Type.HLLSKETCH:_T};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.AnyValue:rename_func(_M),exp.ApproxQuantile:rename_func(_K),exp.ArgMax:rename_func('MAX_BY'),exp.ArgMin:rename_func('MIN_BY'),exp.Array:lambda self,e:f"ARRAY[{self.expressions(e,flat=_C)}]",exp.ArrayAny:rename_func('ANY_MATCH'),exp.ArrayConcat:rename_func('CONCAT'),exp.ArrayContains:rename_func(_Z),exp.ArraySize:rename_func(_Y),exp.ArrayToString:rename_func(_i),exp.ArrayUniqueAgg:rename_func(_d),exp.AtTimeZone:rename_func('AT_TIMEZONE'),exp.BitwiseAnd:lambda self,e:self.func(_U,e.this,e.expression),exp.BitwiseLeftShift:lambda self,e:self.func('BITWISE_ARITHMETIC_SHIFT_LEFT',e.this,e.expression),exp.BitwiseNot:lambda self,e:self.func(_V,e.this),exp.BitwiseOr:lambda self,e:self.func(_W,e.this,e.expression),exp.BitwiseRightShift:lambda self,e:self.func('BITWISE_ARITHMETIC_SHIFT_RIGHT',e.this,e.expression),exp.BitwiseXor:lambda self,e:self.func(_X,e.this,e.expression),exp.Cast:transforms.preprocess([transforms.epoch_cast_to_ts]),exp.CurrentTimestamp:lambda*A:'CURRENT_TIMESTAMP',exp.DateAdd:_date_delta_sql(_E),exp.DateDiff:lambda self,e:self.func(_L,unit_to_str(e),e.expression,e.this),exp.DateStrToDate:datestrtodate_sql,exp.DateToDi:lambda self,e:f"CAST(DATE_FORMAT({self.sql(e,_A)}, {Presto.DATEINT_FORMAT}) AS INT)",exp.DateSub:_date_delta_sql(_E,negate_interval=_C),exp.DayOfWeek:lambda self,e:f"(({self.func(_N,e.this)} % 7) + 1)",exp.DayOfWeekIso:rename_func(_N),exp.Decode:lambda self,e:encode_decode_sql(self,e,_c),exp.DiToDate:lambda self,e:f"CAST(DATE_PARSE(CAST({self.sql(e,_A)} AS VARCHAR), {Presto.DATEINT_FORMAT}) AS DATE)",exp.Encode:lambda self,e:encode_decode_sql(self,e,_f),exp.FileFormatProperty:lambda self,e:f"FORMAT='{e.name.upper()}'",exp.First:_first_last_sql,exp.FirstValue:_first_last_sql,exp.FromTimeZone:lambda self,e:f"WITH_TIMEZONE({self.sql(e,_A)}, {self.sql(e,"zone")}) AT TIME ZONE 'UTC'",exp.GenerateSeries:sequence_sql,exp.GenerateDateArray:sequence_sql,exp.Group:transforms.preprocess([transforms.unalias_group]),exp.GroupConcat:lambda self,e:self.func(_i,self.func('ARRAY_AGG',e.this),e.args.get('separator')),exp.If:if_sql(),exp.ILike:no_ilike_sql,exp.Initcap:_initcap_sql,exp.JSONExtract:lambda self,e:self.jsonextract_sql(e),exp.Last:_first_last_sql,exp.LastValue:_first_last_sql,exp.LastDay:lambda self,e:self.func('LAST_DAY_OF_MONTH',e.this),exp.Lateral:_explode_to_unnest_sql,exp.Left:left_to_substring_sql,exp.Levenshtein:rename_func('LEVENSHTEIN_DISTANCE'),exp.LogicalAnd:rename_func('BOOL_AND'),exp.LogicalOr:rename_func('BOOL_OR'),exp.Pivot:no_pivot_sql,exp.Quantile:_quantile_sql,exp.RegexpExtract:regexp_extract_sql,exp.Right:right_to_substring_sql,exp.SafeDivide:no_safe_divide_sql,exp.Schema:_schema_sql,exp.SchemaCommentProperty:lambda self,e:self.naked_property(e),exp.Select:transforms.preprocess([transforms.eliminate_qualify,transforms.eliminate_distinct_on,transforms.explode_to_unnest(1),transforms.eliminate_semi_and_anti_joins]),exp.SortArray:_no_sort_array,exp.StrPosition:lambda self,e:str_position_sql(self,e,generate_instance=_C),exp.StrToDate:lambda self,e:f"CAST({_str_to_time_sql(self,e)} AS DATE)",exp.StrToMap:rename_func(_e),exp.StrToTime:_str_to_time_sql,exp.StructExtract:struct_extract_sql,exp.Table:transforms.preprocess([transforms.unnest_generate_series]),exp.Timestamp:no_timestamp_sql,exp.TimestampAdd:_date_delta_sql(_E),exp.TimestampTrunc:timestamptrunc_sql(),exp.TimeStrToDate:timestrtotime_sql,exp.TimeStrToTime:timestrtotime_sql,exp.TimeStrToUnix:lambda self,e:self.func(_J,self.func(_G,e.this,Presto.TIME_FORMAT)),exp.TimeToStr:lambda self,e:self.func(_I,e.this,self.format_time(e)),exp.TimeToUnix:rename_func(_J),exp.ToChar:lambda self,e:self.func(_I,e.this,self.format_time(e)),exp.TryCast:transforms.preprocess([transforms.epoch_cast_to_ts]),exp.TsOrDiToDi:lambda self,e:f"CAST(SUBSTR(REPLACE(CAST({self.sql(e,_A)} AS VARCHAR), '-', ''), 1, 8) AS INT)",exp.TsOrDsAdd:_ts_or_ds_add_sql,exp.TsOrDsDiff:_ts_or_ds_diff_sql,exp.TsOrDsToDate:_ts_or_ds_to_date_sql,exp.Unhex:rename_func(_b),exp.UnixToStr:lambda self,e:f"DATE_FORMAT(FROM_UNIXTIME({self.sql(e,_A)}), {self.format_time(e)})",exp.UnixToTime:_unix_to_time_sql,exp.UnixToTimeStr:lambda self,e:f"CAST(FROM_UNIXTIME({self.sql(e,_A)}) AS VARCHAR)",exp.VariancePop:rename_func('VAR_POP'),exp.With:transforms.preprocess([transforms.add_recursive_cte_column_names]),exp.WithinGroup:transforms.preprocess([transforms.remove_within_group_for_percentiles]),exp.Xor:bool_xor_sql,exp.MD5Digest:rename_func(_O),exp.SHA:rename_func('SHA1'),exp.SHA2:sha256_sql};RESERVED_KEYWORDS={'alter','and','as','between','by','case','cast','constraint','create','cross','current_time','current_timestamp','deallocate','delete','describe','distinct','drop','else','end','escape','except','execute','exists','extract','false','for','from','full','group','having','in','inner','insert','intersect','into','is','join','left','like','natural','not','null','on','or','order','outer','prepare','right','select','table','then','true','union','using','values','when','where','with'}
		def md5_sql(B,expression):
			A=expression.this
			if not A.type:from sqlglot.optimizer.annotate_types import annotate_types as C;A=C(A)
			if A.is_type(*exp.DataType.TEXT_TYPES):A=exp.Encode(this=A,charset=exp.Literal.string(_P))
			return B.func('LOWER',B.func(_h,B.func(_O,B.sql(A))))
		def strtounix_sql(A,expression):B=expression;C=B.this;D=exp.cast(C,exp.DataType.Type.TEXT);E=exp.cast(C,exp.DataType.Type.TIMESTAMP)if C.is_string else C;F=A.func(_G,D,A.format_time(B));G=A.func(_I,E,A.format_time(B));H=A.func('PARSE_DATETIME',G,A.format_time(B,Hive.INVERSE_TIME_MAPPING,Hive.INVERSE_TIME_TRIE));I=A.func('COALESCE',A.func('TRY',F),H);return A.func(_J,I)
		def bracket_sql(B,expression):
			A=expression
			if A.args.get('safe'):return B.func(_a,A.this,seq_get(apply_index_offset(A.this,A.expressions,1-A.args.get(_j,0)),0))
			return super().bracket_sql(A)
		def struct_sql(B,expression):
			C=expression;from sqlglot.optimizer.annotate_types import annotate_types as H;C=H(C);D=[];E=[];F=_B
			for A in C.expressions:
				if isinstance(A,exp.PropertyEQ):
					if A.type and A.type.is_type(exp.DataType.Type.UNKNOWN):F=_C
					else:E.append(f"{B.sql(A,_A)} {B.sql(A.type)}")
					D.append(B.sql(A,_S))
				else:D.append(B.sql(A))
			G=len(C.expressions)
			if not G or len(E)!=G:
				if F:B.unsupported('Cannot convert untyped key-value definitions (try annotate_types).')
				return B.func(_H,*D)
			return f"CAST(ROW({_F.join(D)}) AS ROW({_F.join(E)}))"
		def interval_sql(B,expression):
			A=expression
			if A.this and A.text('unit').upper().startswith('WEEK'):return f"({A.this.name} * INTERVAL '7' DAY)"
			return super().interval_sql(A)
		def transaction_sql(B,expression):A=expression.args.get('modes');A=f" {_F.join(A)}"if A else'';return f"START TRANSACTION{A}"
		def offset_limit_modifiers(A,expression,fetch,limit):return[A.sql(expression,_j),A.sql(limit)]
		def create_sql(D,expression):
			"\n            Presto doesn't support CREATE VIEW with expressions (ex: `CREATE VIEW x (cola)` then `(cola)` is the expression),\n            so we need to remove them\n            ";A=expression;B=A.args['kind'];C=A.this
			if B=='VIEW'and C.expressions:A.this.set('expressions',_D)
			return super().create_sql(A)
		def delete_sql(F,expression):
			"\n            Presto only supports DELETE FROM for a single table without an alias, so we need\n            to remove the unnecessary parts. If the original DELETE statement contains more\n            than one table to be deleted, we can't safely map it 1-1 to a Presto statement.\n            ";E='tables';A=expression;C=A.args.get(E)or[A.this]
			if len(C)>1:return super().delete_sql(A)
			B=C[0];A.set(_A,B);A.set(E,_D)
			if isinstance(B,exp.Table):
				D=B.args.get('alias')
				if D:D.pop();A=t.cast(exp.Delete,A.transform(unqualify_columns))
			return super().delete_sql(A)
		def jsonextract_sql(B,expression):
			A=expression;F=B.dialect.settings.get('variant_extract_is_json_extract',_C)
			if not A.args.get('variant_extract')or F:return B.func('JSON_EXTRACT',A.this,A.expression,*A.expressions)
			G=B.sql(A,_A);E=[]
			for D in A.expression.expressions[1:]:
				if not isinstance(D,exp.JSONPathKey):B.unsupported(f"Cannot transpile JSONPath segment '{D}' to ROW access");continue
				C=D.this
				if not exp.SAFE_IDENTIFIER_RE.match(C):C=f'"{C}"'
				E.append(f".{C}")
			H=''.join(E);return f"{G}{H}"