from __future__ import annotations
_A6='CONVERT_TIMEZONE'
_A5='starts_with'
_A4='scope_kind'
_A3='STREAMLIT'
_A2='WAREHOUSE'
_A1='STORAGE INTEGRATION'
_A0='PROJECTION'
_z='MASKING'
_y='COLUMNS'
_x='OBJECT_CONSTRUCT_KEEP_NULL'
_w='DATE_PART'
_v='TO_TIMESTAMP_TZ'
_u='TO_TIMESTAMP_NTZ'
_t='TO_TIMESTAMP_LTZ'
_s='TO_TIME'
_r='TO_NUMBER'
_q='TRY_PARSE_JSON'
_p='TIMESTAMP_FROM_PARTS'
_o='TIMESTAMPDIFF'
_n='TIMEADD'
_m='REGEXP_SUBSTR'
_l='LISTAGG'
_k='GET_PATH'
_j='FLATTEN'
_i='BOOLXOR'
_h='BITXOR'
_g='ARRAY_CONTAINS'
_f='APPROX_PERCENTILE'
_e='expressions'
_d='OBJECT'
_c='columns'
_b='WITH'
_a='USERS'
_Z='PRIMARY KEYS'
_Y='SCHEMAS'
_X='TO_DATE'
_W='TRY_TO_DATE'
_V='DATEDIFF'
_U='DATEADD'
_T='ARRAY_GENERATE_RANGE'
_S='value'
_R='alias'
_Q='start'
_P='unit'
_O='safe'
_N='SEQUENCES'
_M='UNIQUE KEYS'
_L='IMPORTED KEYS'
_K='VIEWS'
_J='TABLES'
_I='OBJECTS'
_H='TAG'
_G='TO_TIMESTAMP'
_F='%f'
_E='OBJECT_CONSTRUCT'
_D='this'
_C=None
_B=False
_A=True
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,binary_from_function,build_default_decimal_type,build_timestamp_from_parts,date_delta_sql,date_trunc_to_time,datestrtodate_sql,build_formatted_time,if_sql,inline_array_sql,max_or_greatest,min_or_least,rename_func,timestamptrunc_sql,timestrtotime_sql,var_map_sql,map_date_part
from sqlglot.helper import flatten,is_float,is_int,seq_get
from sqlglot.tokens import TokenType
if t.TYPE_CHECKING:from sqlglot._typing import E
def _build_datetime(name,kind,safe=_B):
	C=kind
	def A(args):
		F='snowflake';B=args;A=seq_get(B,0);D=A is not _C and is_int(A.name)
		if isinstance(A,exp.Literal):
			if len(B)==1 and A.is_string and not D:return exp.cast(A,C)
			if C==exp.DataType.Type.TIMESTAMP:
				if D:return exp.UnixToTime(this=A,scale=seq_get(B,1))
				if not is_float(A.this):return build_formatted_time(exp.StrToTime,F)(B)
		if C==exp.DataType.Type.DATE and not D:E=build_formatted_time(exp.TsOrDsToDate,F)(B);E.set(_O,safe);return E
		return exp.Anonymous(this=name,expressions=B)
	return A
def _build_object_construct(args):
	A=parser.build_var_map(args)
	if isinstance(A,exp.StarMap):return A
	return exp.Struct(expressions=[exp.PropertyEQ(this=A,expression=B)for(A,B)in zip(A.keys,A.values)])
def _build_datediff(args):A=args;return exp.DateDiff(this=seq_get(A,2),expression=seq_get(A,1),unit=map_date_part(seq_get(A,0)))
def _build_date_time_add(expr_type):
	def A(args):A=args;return expr_type(this=seq_get(A,2),expression=seq_get(A,1),unit=map_date_part(seq_get(A,0)))
	return A
def _build_if_from_div0(args):A=args;B=exp.EQ(this=seq_get(A,1),expression=exp.Literal.number(0)).and_(exp.Is(this=seq_get(A,0),expression=exp.null()).not_());C=exp.Literal.number(0);D=exp.Div(this=seq_get(A,0),expression=seq_get(A,1));return exp.If(this=B,true=C,false=D)
def _build_if_from_zeroifnull(args):A=exp.Is(this=seq_get(args,0),expression=exp.Null());return exp.If(this=A,true=exp.Literal.number(0),false=seq_get(args,0))
def _build_if_from_nullifzero(args):A=exp.EQ(this=seq_get(args,0),expression=exp.Literal.number(0));return exp.If(this=A,true=exp.Null(),false=seq_get(args,0))
def _regexpilike_sql(self,expression):
	A=expression;B=A.text('flag')
	if'i'not in B:B+='i'
	return self.func('REGEXP_LIKE',A.this,A.expression,exp.Literal.string(B))
def _build_regexp_replace(args):
	B='replacement';A=exp.RegexpReplace.from_arg_list(args)
	if not A.args.get(B):A.set(B,exp.Literal.string(''))
	return A
def _show_parser(*A,**B):
	def C(self):return self._parse_show_snowflake(*A,**B)
	return C
def _date_trunc_to_time(args):A=date_trunc_to_time(args);A.set(_P,map_date_part(A.args[_P]));return A
def _unqualify_unpivot_columns(expression):
	'\n    Snowflake doesn\'t allow columns referenced in UNPIVOT to be qualified,\n    so we need to unqualify them.\n\n    Example:\n        >>> from sqlglot import parse_one\n        >>> expr = parse_one("SELECT * FROM m_sales UNPIVOT(sales FOR month IN (m_sales.jan, feb, mar, april))")\n        >>> print(_unqualify_unpivot_columns(expr).sql(dialect="snowflake"))\n        SELECT * FROM m_sales UNPIVOT(sales FOR month IN (jan, feb, mar, april))\n    ';A=expression
	if isinstance(A,exp.Pivot)and A.unpivot:A=transforms.unqualify_columns(A)
	return A
def _flatten_structured_types_unless_iceberg(expression):
	A=expression;assert isinstance(A,exp.Create)
	def E(expression):
		A=expression
		if A.this in exp.DataType.NESTED_TYPES:A.set(_e,_C)
		return A
	B=A.args.get('properties')
	if isinstance(A.this,exp.Schema)and not(B and B.find(exp.IcebergProperty)):
		for C in A.this.expressions:
			if isinstance(C,exp.ColumnDef):
				D=C.kind
				if isinstance(D,exp.DataType):D.transform(E,copy=_B)
	return A
def _unnest_generate_date_array(expression):
	C=expression
	if isinstance(C,exp.Select):
		for A in C.find_all(exp.Unnest):
			if isinstance(A.parent,(exp.From,exp.Join))and len(A.expressions)==1 and isinstance(A.expressions[0],exp.GenerateDateArray):
				D=A.expressions[0];E=D.args.get(_Q);H=D.args.get('end');F=D.args.get('step')
				if not E or not H or not isinstance(F,exp.Interval)or F.name!='1':continue
				I=F.args.get(_P);B=A.args.get(_R)
				if B:B=B.copy();G=seq_get(B.columns,0)or _S
				else:G=_S
				J=_build_date_time_add(exp.DateAdd)([I,exp.cast(G,'int'),exp.cast(E,'date')]).as_(G);K=Snowflake.Parser.FUNCTIONS[_T]([exp.Literal.number(0),_build_datediff([I,E,H])+1]);A.set(_e,[K]);A.replace(exp.select(J).from_(A.copy()).subquery(B))
	return C
class Snowflake(Dialect):
	NORMALIZATION_STRATEGY=NormalizationStrategy.UPPERCASE;NULL_ORDERING='nulls_are_large';TIME_FORMAT="'YYYY-MM-DD HH24:MI:SS'";SUPPORTS_USER_DEFINED_TYPES=_B;SUPPORTS_SEMI_ANTI_JOIN=_B;PREFER_CTE_ALIAS_COLUMN=_A;TABLESAMPLE_SIZE_IS_PERCENT=_A;COPY_PARAMS_ARE_CSV=_B;ARRAY_AGG_INCLUDES_NULLS=_C;TIME_MAPPING={'YYYY':'%Y','yyyy':'%Y','YY':'%y','yy':'%y','MMMM':'%B','mmmm':'%B','MON':'%b','mon':'%b','MM':'%m','mm':'%m','DD':'%d','dd':'%-d','DY':'%a','dy':'%w','HH24':'%H','hh24':'%H','HH12':'%I','hh12':'%I','MI':'%M','mi':'%M','SS':'%S','ss':'%S','FF':_F,'ff':_F,'FF6':_F,'ff6':_F}
	def quote_identifier(B,expression,identify=_A):
		A=expression
		if isinstance(A,exp.Identifier)and isinstance(A.parent,exp.Table)and A.name.lower()=='dual':return A
		return super().quote_identifier(A,identify=identify)
	class Parser(parser.Parser):
		IDENTIFY_PIVOT_STRINGS=_A;DEFAULT_SAMPLING_METHOD='BERNOULLI';COLON_IS_VARIANT_EXTRACT=_A;ID_VAR_TOKENS={*parser.Parser.ID_VAR_TOKENS,TokenType.MATCH_CONDITION};TABLE_ALIAS_TOKENS=parser.Parser.TABLE_ALIAS_TOKENS|{TokenType.WINDOW};TABLE_ALIAS_TOKENS.discard(TokenType.MATCH_CONDITION);FUNCTIONS={**parser.Parser.FUNCTIONS,_f:exp.ApproxQuantile.from_arg_list,'ARRAY_CONSTRUCT':lambda args:exp.Array(expressions=args),_g:lambda args:exp.ArrayContains(this=seq_get(args,1),expression=seq_get(args,0)),_T:lambda args:exp.GenerateSeries(start=seq_get(args,0),end=exp.Sub(this=seq_get(args,1),expression=exp.Literal.number(1)),step=seq_get(args,2)),_h:binary_from_function(exp.BitwiseXor),'BIT_XOR':binary_from_function(exp.BitwiseXor),_i:binary_from_function(exp.Xor),'DATE':_build_datetime('DATE',exp.DataType.Type.DATE),'DATE_TRUNC':_date_trunc_to_time,_U:_build_date_time_add(exp.DateAdd),_V:_build_datediff,'DIV0':_build_if_from_div0,_j:exp.Explode.from_arg_list,_k:lambda args,dialect:exp.JSONExtract(this=seq_get(args,0),expression=dialect.to_json_path(seq_get(args,1))),'IFF':exp.If.from_arg_list,'LAST_DAY':lambda args:exp.LastDay(this=seq_get(args,0),unit=map_date_part(seq_get(args,1))),'LEN':lambda args:exp.Length(this=seq_get(args,0),binary=_A),'LENGTH':lambda args:exp.Length(this=seq_get(args,0),binary=_A),_l:exp.GroupConcat.from_arg_list,'MEDIAN':lambda args:exp.PercentileCont(this=seq_get(args,0),expression=exp.Literal.number(.5)),'NULLIFZERO':_build_if_from_nullifzero,_E:_build_object_construct,'REGEXP_REPLACE':_build_regexp_replace,_m:lambda args:exp.RegexpExtract(this=seq_get(args,0),expression=seq_get(args,1),position=seq_get(args,2),occurrence=seq_get(args,3),parameters=seq_get(args,4),group=seq_get(args,5)or exp.Literal.number(0)),'RLIKE':exp.RegexpLike.from_arg_list,'SQUARE':lambda args:exp.Pow(this=seq_get(args,0),expression=exp.Literal.number(2)),_n:_build_date_time_add(exp.TimeAdd),'TIMEDIFF':_build_datediff,'TIMESTAMPADD':_build_date_time_add(exp.DateAdd),_o:_build_datediff,'TIMESTAMPFROMPARTS':build_timestamp_from_parts,_p:build_timestamp_from_parts,_q:lambda args:exp.ParseJSON(this=seq_get(args,0),safe=_A),_W:_build_datetime(_W,exp.DataType.Type.DATE,safe=_A),_X:_build_datetime(_X,exp.DataType.Type.DATE),_r:lambda args:exp.ToNumber(this=seq_get(args,0),format=seq_get(args,1),precision=seq_get(args,2),scale=seq_get(args,3)),_s:_build_datetime(_s,exp.DataType.Type.TIME),_G:_build_datetime(_G,exp.DataType.Type.TIMESTAMP),_t:_build_datetime(_t,exp.DataType.Type.TIMESTAMPLTZ),_u:_build_datetime(_u,exp.DataType.Type.TIMESTAMP),_v:_build_datetime(_v,exp.DataType.Type.TIMESTAMPTZ),'TO_VARCHAR':exp.ToChar.from_arg_list,'ZEROIFNULL':_build_if_from_zeroifnull};FUNCTION_PARSERS={**parser.Parser.FUNCTION_PARSERS,_w:lambda self:self._parse_date_part(),_x:lambda self:self._parse_json_object()};FUNCTION_PARSERS.pop('TRIM');TIMESTAMPS=parser.Parser.TIMESTAMPS-{TokenType.TIME};RANGE_PARSERS={**parser.Parser.RANGE_PARSERS,TokenType.LIKE_ANY:parser.binary_range_parser(exp.LikeAny),TokenType.ILIKE_ANY:parser.binary_range_parser(exp.ILikeAny)};ALTER_PARSERS={**parser.Parser.ALTER_PARSERS,'UNSET':lambda self:self.expression(exp.Set,tag=self._match_text_seq(_H),expressions=self._parse_csv(self._parse_id_var),unset=_A),'SWAP':lambda self:self._parse_alter_table_swap()};STATEMENT_PARSERS={**parser.Parser.STATEMENT_PARSERS,TokenType.SHOW:lambda self:self._parse_show()};PROPERTY_PARSERS={**parser.Parser.PROPERTY_PARSERS,'LOCATION':lambda self:self._parse_location_property()};TYPE_CONVERTERS={exp.DataType.Type.DECIMAL:build_default_decimal_type(precision=38,scale=0)};SHOW_PARSERS={_Y:_show_parser(_Y),'TERSE SCHEMAS':_show_parser(_Y),_I:_show_parser(_I),'TERSE OBJECTS':_show_parser(_I),_J:_show_parser(_J),'TERSE TABLES':_show_parser(_J),_K:_show_parser(_K),'TERSE VIEWS':_show_parser(_K),_Z:_show_parser(_Z),'TERSE PRIMARY KEYS':_show_parser(_Z),_L:_show_parser(_L),'TERSE IMPORTED KEYS':_show_parser(_L),_M:_show_parser(_M),'TERSE UNIQUE KEYS':_show_parser(_M),_N:_show_parser(_N),'TERSE SEQUENCES':_show_parser(_N),_y:_show_parser(_y),_a:_show_parser(_a),'TERSE USERS':_show_parser(_a)};CONSTRAINT_PARSERS={**parser.Parser.CONSTRAINT_PARSERS,_b:lambda self:self._parse_with_constraint(),_z:lambda self:self._parse_with_constraint(),_A0:lambda self:self._parse_with_constraint(),_H:lambda self:self._parse_with_constraint()};STAGED_FILE_SINGLE_TOKENS={TokenType.DOT,TokenType.MOD,TokenType.SLASH};FLATTEN_COLUMNS=['SEQ','KEY','PATH','INDEX','VALUE','THIS'];SCHEMA_KINDS={_I,_J,_K,_N,_M,_L};NON_TABLE_CREATABLES={_A1,_H,_A2,_A3};LAMBDAS={**parser.Parser.LAMBDAS,TokenType.ARROW:lambda self,expressions:self.expression(exp.Lambda,this=self._replace_lambda(self._parse_assignment(),expressions),expressions=[A.this if isinstance(A,exp.Cast)else A for A in expressions])}
		def _negate_range(B,this=_C):
			A=this
			if not A:return A
			C=A.args.get('query')
			if isinstance(A,exp.In)and isinstance(C,exp.Query):return B.expression(exp.NEQ,this=A.this,expression=exp.All(this=C.unnest()))
			return B.expression(exp.Not,this=A)
		def _parse_with_constraint(A):
			C='POLICY'
			if A._prev.token_type!=TokenType.WITH:A._retreat(A._index-1)
			if A._match_text_seq(_z,C):B=A._parse_column();return A.expression(exp.MaskingPolicyColumnConstraint,this=B.to_dot()if isinstance(B,exp.Column)else B,expressions=A._match(TokenType.USING)and A._parse_wrapped_csv(A._parse_id_var))
			if A._match_text_seq(_A0,C):B=A._parse_column();return A.expression(exp.ProjectionPolicyColumnConstraint,this=B.to_dot()if isinstance(B,exp.Column)else B)
			if A._match(TokenType.TAG):return A.expression(exp.TagColumnConstraint,expressions=A._parse_wrapped_csv(A._parse_property))
		def _parse_create(B):
			A=super()._parse_create()
			if isinstance(A,exp.Create)and A.kind in B.NON_TABLE_CREATABLES:A.this.replace(A.this.this)
			return A
		def _parse_date_part(A):
			B=A._parse_var()or A._parse_type()
			if not B:return
			A._match(TokenType.COMMA);F=A._parse_bitwise();B=map_date_part(B);D=B.name.upper()
			if D.startswith('EPOCH'):
				if D=='EPOCH_MILLISECOND':C=10**3
				elif D=='EPOCH_MICROSECOND':C=10**6
				elif D=='EPOCH_NANOSECOND':C=10**9
				else:C=_C
				G=A.expression(exp.Cast,this=F,to=exp.DataType.build('TIMESTAMP'));E=A.expression(exp.TimeToUnix,this=G)
				if C:E=exp.Mul(this=E,expression=exp.Literal.number(C))
				return E
			return A.expression(exp.Extract,this=B,expression=F)
		def _parse_bracket_key_value(A,is_map=_B):
			if is_map:return A._parse_slice(A._parse_string())
			return A._parse_slice(A._parse_alias(A._parse_assignment(),explicit=_A))
		def _parse_lateral(D):
			A=super()._parse_lateral()
			if not A:return A
			if isinstance(A.this,exp.Explode):
				B=A.args.get(_R);C=[exp.to_identifier(A)for A in D.FLATTEN_COLUMNS]
				if B and not B.args.get(_c):B.set(_c,C)
				elif not B:exp.alias_(A,'_flattened',table=C,copy=_B)
			return A
		def _parse_table_parts(A,schema=_B,is_db_reference=_B,wildcard=_B):
			C=is_db_reference
			if A._match(TokenType.STRING,advance=_B):B=A._parse_string()
			elif A._match_text_seq('@',advance=_B):B=A._parse_location_path()
			else:B=_C
			if B:
				D=_C;E=_C;F=A._match(TokenType.L_PAREN)
				while A._curr and F and not A._match(TokenType.R_PAREN):
					if A._match_text_seq('FILE_FORMAT','=>'):D=A._parse_string()or super()._parse_table_parts(is_db_reference=C)
					elif A._match_text_seq('PATTERN','=>'):E=A._parse_string()
					else:break
					A._match(TokenType.COMMA)
				B=A.expression(exp.Table,this=B,format=D,pattern=E)
			else:B=super()._parse_table_parts(schema=schema,is_db_reference=C)
			return B
		def _parse_id_var(A,any_token=_A,tokens=_C):
			D='IDENTIFIER';C=tokens;B=any_token
			if A._match_text_seq(D,'('):E=super()._parse_id_var(any_token=B,tokens=C)or A._parse_string();A._match_r_paren();return A.expression(exp.Anonymous,this=D,expressions=[E])
			return super()._parse_id_var(any_token=B,tokens=C)
		def _parse_show_snowflake(A,this):
			D='ACCOUNT';C=_C;B=_C;E=A._tokens[A._index-2].text.upper()=='TERSE';F=A._match_text_seq('HISTORY');G=A._parse_string()if A._match(TokenType.LIKE)else _C
			if A._match(TokenType.IN):
				if A._match_text_seq(D):B=D
				elif A._match_set(A.DB_CREATABLES):
					B=A._prev.text.upper()
					if A._curr:C=A._parse_table_parts()
				elif A._curr:B='SCHEMA'if this in A.SCHEMA_KINDS else'TABLE';C=A._parse_table_parts()
			return A.expression(exp.Show,**{'terse':E,_D:this,'history':F,'like':G,'scope':C,_A4:B,_A5:A._match_text_seq('STARTS',_b)and A._parse_string(),'limit':A._parse_limit(),'from':A._parse_string()if A._match(TokenType.FROM)else _C})
		def _parse_alter_table_swap(A):A._match_text_seq(_b);return A.expression(exp.SwapTable,this=A._parse_table(schema=_A))
		def _parse_location_property(A):A._match(TokenType.EQ);return A.expression(exp.LocationProperty,this=A._parse_location_path())
		def _parse_file_location(A):return A._parse_select(table=_A,parse_subquery_alias=_B)if A._match(TokenType.L_PAREN,advance=_B)else A._parse_table_parts()
		def _parse_location_path(A):
			B=[A._advance_any(ignore_reserved=_A)]
			while A._is_connected()and not A._match_set((TokenType.COMMA,TokenType.L_PAREN,TokenType.R_PAREN),advance=_B):B.append(A._advance_any(ignore_reserved=_A))
			return exp.var(''.join(A.text for A in B if A))
		def _parse_lambda_arg(B):
			A=super()._parse_lambda_arg()
			if not A:return A
			C=B._parse_types()
			if C:return B.expression(exp.Cast,this=A,to=C)
			return A
	class Tokenizer(tokens.Tokenizer):STRING_ESCAPES=['\\',"'"];HEX_STRINGS=[("x'","'"),("X'","'")];RAW_STRINGS=['$$'];COMMENTS=['--','//',('/*','*/')];NESTED_COMMENTS=_B;KEYWORDS={**tokens.Tokenizer.KEYWORDS,'BYTEINT':TokenType.INT,'CHAR VARYING':TokenType.VARCHAR,'CHARACTER VARYING':TokenType.VARCHAR,'EXCLUDE':TokenType.EXCEPT,'ILIKE ANY':TokenType.ILIKE_ANY,'LIKE ANY':TokenType.LIKE_ANY,'MATCH_CONDITION':TokenType.MATCH_CONDITION,'MATCH_RECOGNIZE':TokenType.MATCH_RECOGNIZE,'MINUS':TokenType.EXCEPT,'NCHAR VARYING':TokenType.VARCHAR,'PUT':TokenType.COMMAND,'REMOVE':TokenType.COMMAND,'RM':TokenType.COMMAND,'SAMPLE':TokenType.TABLE_SAMPLE,'SQL_DOUBLE':TokenType.DOUBLE,'SQL_VARCHAR':TokenType.VARCHAR,_A1:TokenType.STORAGE_INTEGRATION,_H:TokenType.TAG,'TIMESTAMP_TZ':TokenType.TIMESTAMPTZ,'TOP':TokenType.TOP,_A2:TokenType.WAREHOUSE,_A3:TokenType.STREAMLIT};KEYWORDS.pop('/*+');SINGLE_TOKENS={**tokens.Tokenizer.SINGLE_TOKENS,'$':TokenType.PARAMETER};VAR_SINGLE_TOKENS={'$'};COMMANDS=tokens.Tokenizer.COMMANDS-{TokenType.SHOW}
	class Generator(generator.Generator):
		PARAMETER_TOKEN='$';MATCHED_BY_SOURCE=_B;SINGLE_STRING_INTERVAL=_A;JOIN_HINTS=_B;TABLE_HINTS=_B;QUERY_HINTS=_B;AGGREGATE_FILTER_SUPPORTED=_B;SUPPORTS_TABLE_COPY=_B;COLLATE_IS_FUNC=_A;LIMIT_ONLY_LITERALS=_A;JSON_KEY_VALUE_PAIR_SEP=',';INSERT_OVERWRITE=' OVERWRITE INTO';STRUCT_DELIMITER='(',')';COPY_PARAMS_ARE_WRAPPED=_B;COPY_PARAMS_EQ_REQUIRED=_A;STAR_EXCEPT='EXCLUDE';SUPPORTS_EXPLODING_PROJECTIONS=_B;ARRAY_CONCAT_IS_VAR_LEN=_B;SUPPORTS_CONVERT_TIMEZONE=_A;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_B;TRANSFORMS={**generator.Generator.TRANSFORMS,exp.ApproxDistinct:rename_func('APPROX_COUNT_DISTINCT'),exp.ArgMax:rename_func('MAX_BY'),exp.ArgMin:rename_func('MIN_BY'),exp.Array:inline_array_sql,exp.ArrayConcat:lambda self,e:self.arrayconcat_sql(e,name='ARRAY_CAT'),exp.ArrayContains:lambda self,e:self.func(_g,e.expression,e.this),exp.AtTimeZone:lambda self,e:self.func(_A6,e.args.get('zone'),e.this),exp.BitwiseXor:rename_func(_h),exp.Create:transforms.preprocess([_flatten_structured_types_unless_iceberg]),exp.DateAdd:date_delta_sql(_U),exp.DateDiff:date_delta_sql(_V),exp.DateStrToDate:datestrtodate_sql,exp.DayOfMonth:rename_func('DAYOFMONTH'),exp.DayOfWeek:rename_func('DAYOFWEEK'),exp.DayOfYear:rename_func('DAYOFYEAR'),exp.Explode:rename_func(_j),exp.Extract:rename_func(_w),exp.FromTimeZone:lambda self,e:self.func(_A6,e.args.get('zone'),"'UTC'",e.this),exp.GenerateSeries:lambda self,e:self.func(_T,e.args[_Q],e.args['end']+1,e.args.get('step')),exp.GroupConcat:rename_func(_l),exp.If:if_sql(name='IFF',false_value='NULL'),exp.JSONExtract:lambda self,e:self.func(_k,e.this,e.expression),exp.JSONExtractScalar:lambda self,e:self.func('JSON_EXTRACT_PATH_TEXT',e.this,e.expression),exp.JSONObject:lambda self,e:self.func(_x,*e.expressions),exp.JSONPathRoot:lambda*A:'',exp.LogicalAnd:rename_func('BOOLAND_AGG'),exp.LogicalOr:rename_func('BOOLOR_AGG'),exp.Map:lambda self,e:var_map_sql(self,e,_E),exp.Max:max_or_greatest,exp.Min:min_or_least,exp.ParseJSON:lambda self,e:self.func(_q if e.args.get(_O)else'PARSE_JSON',e.this),exp.PartitionedByProperty:lambda self,e:f"PARTITION BY {self.sql(e,_D)}",exp.PercentileCont:transforms.preprocess([transforms.add_within_group_for_percentiles]),exp.PercentileDisc:transforms.preprocess([transforms.add_within_group_for_percentiles]),exp.Pivot:transforms.preprocess([_unqualify_unpivot_columns]),exp.RegexpILike:_regexpilike_sql,exp.Rand:rename_func('RANDOM'),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.explode_to_unnest(),transforms.eliminate_semi_and_anti_joins,_unnest_generate_date_array]),exp.SHA:rename_func('SHA1'),exp.StarMap:rename_func(_E),exp.StartsWith:rename_func('STARTSWITH'),exp.StrPosition:lambda self,e:self.func('POSITION',e.args.get('substr'),e.this,e.args.get('position')),exp.StrToTime:lambda self,e:self.func(_G,e.this,self.format_time(e)),exp.Stuff:rename_func('INSERT'),exp.TimeAdd:date_delta_sql(_n),exp.TimestampDiff:lambda self,e:self.func(_o,e.unit,e.expression,e.this),exp.TimestampTrunc:timestamptrunc_sql(),exp.TimeStrToTime:timestrtotime_sql,exp.TimeToStr:lambda self,e:self.func('TO_CHAR',exp.cast(e.this,exp.DataType.Type.TIMESTAMP),self.format_time(e)),exp.TimeToUnix:lambda self,e:f"EXTRACT(epoch_second FROM {self.sql(e,_D)})",exp.ToArray:rename_func('TO_ARRAY'),exp.ToChar:lambda self,e:self.function_fallback_sql(e),exp.TsOrDsAdd:date_delta_sql(_U,cast=_A),exp.TsOrDsDiff:date_delta_sql(_V),exp.TsOrDsToDate:lambda self,e:self.func(_W if e.args.get(_O)else _X,e.this,self.format_time(e)),exp.UnixToTime:rename_func(_G),exp.Uuid:rename_func('UUID_STRING'),exp.VarMap:lambda self,e:var_map_sql(self,e,_E),exp.WeekOfYear:rename_func('WEEKOFYEAR'),exp.Xor:rename_func(_i)};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.NESTED:_d,exp.DataType.Type.STRUCT:_d};PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.SetProperty:exp.Properties.Location.UNSUPPORTED,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED};UNSUPPORTED_VALUES_EXPRESSIONS={exp.Map,exp.StarMap,exp.Struct,exp.VarMap}
		def with_properties(A,properties):return A.properties(properties,wrapped=_B,prefix=A.sep(''),sep=' ')
		def values_sql(C,expression,values_as_table=_A):
			B=values_as_table;A=expression
			if A.find(*C.UNSUPPORTED_VALUES_EXPRESSIONS):B=_B
			return super().values_sql(A,values_as_table=B)
		def datatype_sql(C,expression):
			A=expression;B=A.expressions
			if B and A.is_type(*exp.DataType.STRUCT_TYPES)and any(isinstance(A,exp.DataType)for A in B):return _d
			return super().datatype_sql(A)
		def tonumber_sql(B,expression):A=expression;return B.func(_r,A.this,A.args.get('format'),A.args.get('precision'),A.args.get('scale'))
		def timestampfromparts_sql(C,expression):
			A=expression;B=A.args.get('milli')
			if B is not _C:D=B.pop()*exp.Literal.number(1000000);A.set('nano',D)
			return rename_func(_p)(C,A)
		def cast_sql(B,expression,safe_prefix=_C):
			A=expression
			if A.is_type(exp.DataType.Type.GEOGRAPHY):return B.func('TO_GEOGRAPHY',A.this)
			if A.is_type(exp.DataType.Type.GEOMETRY):return B.func('TO_GEOMETRY',A.this)
			return super().cast_sql(A,safe_prefix=safe_prefix)
		def trycast_sql(C,expression):
			B=expression;A=B.this
			if A.type is _C:from sqlglot.optimizer.annotate_types import annotate_types as D;A=D(A)
			if A.is_type(*exp.DataType.TEXT_TYPES,exp.DataType.Type.UNKNOWN):return super().trycast_sql(B)
			return C.cast_sql(B)
		def log_sql(B,expression):
			A=expression
			if not A.expression:return B.func('LN',A.this)
			return super().log_sql(A)
		def unnest_sql(D,expression):
			C=expression;A=C.args.get(_R);E=C.args.get('offset');F=[exp.to_identifier('seq'),exp.to_identifier('key'),exp.to_identifier('path'),E.pop()if isinstance(E,exp.Expression)else exp.to_identifier('index'),seq_get(A.columns if A else[],0)or exp.to_identifier(_S),exp.to_identifier(_D)]
			if A:A.set(_c,F)
			else:A=exp.TableAlias(this='_u',columns=F)
			G=f"TABLE(FLATTEN(INPUT => {D.sql(C.expressions[0])}))";B=D.sql(A);B=f" AS {B}"if B else'';return f"{G}{B}"
		def show_sql(B,expression):
			A=expression;H='TERSE 'if A.args.get('terse')else'';I=' HISTORY'if A.args.get('history')else'';C=B.sql(A,'like');C=f" LIKE {C}"if C else'';D=B.sql(A,'scope');D=f" {D}"if D else'';E=B.sql(A,_A4)
			if E:E=f" IN {E}"
			F=B.sql(A,_A5)
			if F:F=f" STARTS WITH {F}"
			J=B.sql(A,'limit');G=B.sql(A,'from')
			if G:G=f" FROM {G}"
			return f"SHOW {H}{A.name}{I}{C}{E}{D}{F}{J}{G}"
		def regexpextract_sql(E,expression):
			A=expression;B=A.args.get('group')
			if B and B.name=='0':B=_C
			C=A.args.get('parameters')or B and exp.Literal.string('c');D=A.args.get('occurrence')or C and exp.Literal.number(1);F=A.args.get('position')or D and exp.Literal.number(1);return E.func(_m,A.this,A.expression,F,D,C,B)
		def describe_sql(C,expression):B=expression;D=B.args.get('kind')or'TABLE';E=f" {D}"if D else'';F=f" {C.sql(B,_D)}";A=C.expressions(B,flat=_A);A=f" {A}"if A else'';return f"DESCRIBE{E}{F}{A}"
		def generatedasidentitycolumnconstraint_sql(D,expression):C=expression;A=C.args.get(_Q);A=f" START {A}"if A else'';B=C.args.get('increment');B=f" INCREMENT {B}"if B else'';return f"AUTOINCREMENT{A}{B}"
		def swaptable_sql(A,expression):B=A.sql(expression,_D);return f"SWAP WITH {B}"
		def cluster_sql(A,expression):return f"CLUSTER BY ({A.expressions(expression,flat=_A)})"
		def struct_sql(D,expression):
			B=[];C=[]
			for(E,A)in enumerate(expression.expressions):
				if isinstance(A,exp.PropertyEQ):B.append(exp.Literal.string(A.name)if isinstance(A.this,exp.Identifier)else A.this);C.append(A.expression)
				else:B.append(exp.Literal.string(f"_{E}"));C.append(A)
			return D.func(_E,*flatten(zip(B,C)))
		@generator.unsupported_args('weight','accuracy')
		def approxquantile_sql(self,expression):A=expression;return self.func(_f,A.this,A.args.get('quantile'))
		def alterset_sql(A,expression):B=expression;C=A.expressions(B,flat=_A);C=f" {C}"if C else'';D=A.expressions(B,key='file_format',flat=_A,sep=' ');D=f" STAGE_FILE_FORMAT = ({D})"if D else'';E=A.expressions(B,key='copy_options',flat=_A,sep=' ');E=f" STAGE_COPY_OPTIONS = ({E})"if E else'';F=A.expressions(B,key='tag',flat=_A);F=f" TAG {F}"if F else'';return f"SET{C}{D}{E}{F}"