from __future__ import annotations
_X='SHUFFLE_REPLICATE_NL'
_W='SHUFFLE_HASH'
_V='MERGEJOIN'
_U='SHUFFLEMERGE'
_T='MAPJOIN'
_S='BROADCASTJOIN'
_R='BROADCAST'
_Q='timestamp'
_P='WEEKOFYEAR'
_O='TO_UTC_TIMESTAMP'
_N='TO_TIMESTAMP'
_M='SHIFTRIGHT'
_L='SHIFTLEFT'
_K='FROM_UTC_TIMESTAMP'
_J='DAYOFYEAR'
_I='DAYOFMONTH'
_H='DATE_TRUNC'
_G='AGGREGATE'
_F='expressions'
_E='MAP_FROM_ARRAYS'
_D='DAYOFWEEK'
_C='this'
_B=True
_A=False
import typing as t
from sqlglot import exp,transforms
from sqlglot.dialects.dialect import binary_from_function,build_formatted_time,is_parse_json,pivot_column_names,rename_func,trim_sql,unit_to_str
from sqlglot.dialects.hive import Hive
from sqlglot.helper import seq_get,ensure_list
from sqlglot.transforms import preprocess,remove_unique_constraints,ctas_with_tmp_tables_to_create_tmp_view,move_schema_columns_to_partitioned_by
if t.TYPE_CHECKING:from sqlglot._typing import E;from sqlglot.optimizer.annotate_types import TypeAnnotator
def _map_sql(self,expression):
	A=expression;B=A.args.get('keys');C=A.args.get('values')
	if not B or not C:return self.func('MAP')
	return self.func(_E,B,C)
def _build_as_cast(to_type):return lambda args:exp.Cast(this=seq_get(args,0),to=exp.DataType.build(to_type))
def _str_to_date(self,expression):
	D='TO_DATE';B=expression;A=self;C=A.format_time(B)
	if C==Hive.DATE_FORMAT:return A.func(D,B.this)
	return A.func(D,B.this,C)
def _unix_to_time_sql(self,expression):
	E='TIMESTAMP_SECONDS';D=expression;A=self;B=D.args.get('scale');C=D.this
	if B is None:return A.sql(exp.cast(exp.func('from_unixtime',C),exp.DataType.Type.TIMESTAMP))
	if B==exp.UnixToTime.SECONDS:return A.func(E,C)
	if B==exp.UnixToTime.MILLIS:return A.func('TIMESTAMP_MILLIS',C)
	if B==exp.UnixToTime.MICROS:return A.func('TIMESTAMP_MICROS',C)
	F=exp.Div(this=C,expression=exp.func('POW',10,B));return A.func(E,F)
def _unalias_pivot(expression):
	'\n    Spark doesn\'t allow PIVOT aliases, so we need to remove them and possibly wrap a\n    pivoted source in a subquery with the same alias to preserve the query\'s semantics.\n\n    Example:\n        >>> from sqlglot import parse_one\n        >>> expr = parse_one("SELECT piv.x FROM tbl PIVOT (SUM(a) FOR b IN (\'x\')) piv")\n        >>> print(_unalias_pivot(expr).sql(dialect="spark"))\n        SELECT piv.x FROM (SELECT * FROM tbl PIVOT(SUM(a) FOR b IN (\'x\'))) AS piv\n    ';C='pivots';A=expression
	if isinstance(A,exp.From)and A.this.args.get(C):
		B=A.this.args[C][0]
		if B.alias:D=B.args['alias'].pop();return exp.From(this=A.this.replace(exp.select('*').from_(A.this.copy(),copy=_A).subquery(alias=D,copy=_A)))
	return A
def _unqualify_pivot_columns(expression):
	'\n    Spark doesn\'t allow the column referenced in the PIVOT\'s field to be qualified,\n    so we need to unqualify it.\n\n    Example:\n        >>> from sqlglot import parse_one\n        >>> expr = parse_one("SELECT * FROM tbl PIVOT (SUM(tbl.sales) FOR tbl.quarter IN (\'Q1\', \'Q2\'))")\n        >>> print(_unqualify_pivot_columns(expr).sql(dialect="spark"))\n        SELECT * FROM tbl PIVOT(SUM(tbl.sales) FOR quarter IN (\'Q1\', \'Q1\'))\n    ';B='field';A=expression
	if isinstance(A,exp.Pivot):A.set(B,transforms.unqualify_columns(A.args[B]))
	return A
def temporary_storage_provider(expression):A=expression;B=exp.FileFormatProperty(this=exp.Literal.string('parquet'));A.args['properties'].append(_F,B);return A
def _annotate_by_similar_args(self,expression,*G,target_type):
	'\n    Infers the type of the expression according to the following rules:\n    - If all args are of the same type OR any arg is of target_type, the expr is inferred as such\n    - If any arg is of UNKNOWN type and none of target_type, the expr is inferred as UNKNOWN\n    ';E=target_type;A=expression;self._annotate_args(A);F=[]
	for H in G:I=A.args.get(H);F.extend(A for A in ensure_list(I)if A)
	B=None;C=_A
	for D in F:
		if D.is_type(exp.DataType.Type.UNKNOWN):C=_B
		elif D.is_type(E):C=_A;B=E;break
		else:B=D.type
	self._set_type(A,exp.DataType.Type.UNKNOWN if C else B);return A
class Spark2(Hive):
	ANNOTATORS={**Hive.ANNOTATORS,exp.Substring:lambda self,e:self._annotate_by_args(e,_C),exp.Concat:lambda self,e:_annotate_by_similar_args(self,e,_F,target_type=exp.DataType.Type.TEXT),exp.Pad:lambda self,e:_annotate_by_similar_args(self,e,_C,'fill_pattern',target_type=exp.DataType.Type.TEXT)}
	class Parser(Hive.Parser):
		TRIM_PATTERN_FIRST=_B;FUNCTIONS={**Hive.Parser.FUNCTIONS,_G:exp.Reduce.from_arg_list,'APPROX_PERCENTILE':exp.ApproxQuantile.from_arg_list,'BOOLEAN':_build_as_cast('boolean'),'DATE':_build_as_cast('date'),_H:lambda args:exp.TimestampTrunc(this=seq_get(args,1),unit=exp.var(seq_get(args,0))),_I:lambda args:exp.DayOfMonth(this=exp.TsOrDsToDate(this=seq_get(args,0))),_D:lambda args:exp.DayOfWeek(this=exp.TsOrDsToDate(this=seq_get(args,0))),_J:lambda args:exp.DayOfYear(this=exp.TsOrDsToDate(this=seq_get(args,0))),'DOUBLE':_build_as_cast('double'),'FLOAT':_build_as_cast('float'),_K:lambda args:exp.AtTimeZone(this=exp.cast(seq_get(args,0)or exp.Var(this=''),exp.DataType.Type.TIMESTAMP),zone=seq_get(args,1)),'INT':_build_as_cast('int'),_E:exp.Map.from_arg_list,'RLIKE':exp.RegexpLike.from_arg_list,_L:binary_from_function(exp.BitwiseLeftShift),_M:binary_from_function(exp.BitwiseRightShift),'STRING':_build_as_cast('string'),'TIMESTAMP':_build_as_cast(_Q),_N:lambda args:_build_as_cast(_Q)(args)if len(args)==1 else build_formatted_time(exp.StrToTime,'spark')(args),'TO_UNIX_TIMESTAMP':exp.StrToUnix.from_arg_list,_O:lambda args:exp.FromTimeZone(this=exp.cast(seq_get(args,0)or exp.Var(this=''),exp.DataType.Type.TIMESTAMP),zone=seq_get(args,1)),'TRUNC':lambda args:exp.DateTrunc(unit=seq_get(args,1),this=seq_get(args,0)),_P:lambda args:exp.WeekOfYear(this=exp.TsOrDsToDate(this=seq_get(args,0)))};FUNCTION_PARSERS={**Hive.Parser.FUNCTION_PARSERS,_R:lambda self:self._parse_join_hint(_R),_S:lambda self:self._parse_join_hint(_S),_T:lambda self:self._parse_join_hint(_T),'MERGE':lambda self:self._parse_join_hint('MERGE'),_U:lambda self:self._parse_join_hint(_U),_V:lambda self:self._parse_join_hint(_V),_W:lambda self:self._parse_join_hint(_W),_X:lambda self:self._parse_join_hint(_X)}
		def _parse_drop_column(A):B='COLUMNS';return A._match_text_seq('DROP',B)and A.expression(exp.Drop,this=A._parse_schema(),kind=B)
		def _pivot_column_names(B,aggregations):
			A=aggregations
			if len(A)==1:return['']
			return pivot_column_names(A,dialect='spark')
	class Generator(Hive.Generator):
		QUERY_HINTS=_B;NVL2_SUPPORTED=_B;CAN_IMPLEMENT_ARRAY_ANY=_B;PROPERTIES_LOCATION={**Hive.Generator.PROPERTIES_LOCATION,exp.EngineProperty:exp.Properties.Location.UNSUPPORTED,exp.AutoIncrementProperty:exp.Properties.Location.UNSUPPORTED,exp.CharacterSetProperty:exp.Properties.Location.UNSUPPORTED,exp.CollateProperty:exp.Properties.Location.UNSUPPORTED};TRANSFORMS={**Hive.Generator.TRANSFORMS,exp.ApproxDistinct:rename_func('APPROX_COUNT_DISTINCT'),exp.ArraySum:lambda self,e:f"AGGREGATE({self.sql(e,_C)}, 0, (acc, x) -> acc + x, acc -> acc)",exp.ArrayToString:rename_func('ARRAY_JOIN'),exp.AtTimeZone:lambda self,e:self.func(_K,e.this,e.args.get('zone')),exp.BitwiseLeftShift:rename_func(_L),exp.BitwiseRightShift:rename_func(_M),exp.Create:preprocess([remove_unique_constraints,lambda e:ctas_with_tmp_tables_to_create_tmp_view(e,temporary_storage_provider),move_schema_columns_to_partitioned_by]),exp.DateFromParts:rename_func('MAKE_DATE'),exp.DateTrunc:lambda self,e:self.func('TRUNC',e.this,unit_to_str(e)),exp.DayOfMonth:rename_func(_I),exp.DayOfWeek:rename_func(_D),exp.DayOfWeekIso:lambda self,e:f"(({self.func(_D,e.this)} % 7) + 1)",exp.DayOfYear:rename_func(_J),exp.FileFormatProperty:lambda self,e:f"USING {e.name.upper()}",exp.From:transforms.preprocess([_unalias_pivot]),exp.FromTimeZone:lambda self,e:self.func(_O,e.this,e.args.get('zone')),exp.LogicalAnd:rename_func('BOOL_AND'),exp.LogicalOr:rename_func('BOOL_OR'),exp.Map:_map_sql,exp.Pivot:transforms.preprocess([_unqualify_pivot_columns]),exp.Reduce:rename_func(_G),exp.RegexpReplace:lambda self,e:self.func('REGEXP_REPLACE',e.this,e.expression,e.args['replacement'],e.args.get('position')),exp.Select:transforms.preprocess([transforms.eliminate_qualify,transforms.eliminate_distinct_on,transforms.unnest_to_explode]),exp.StrToDate:_str_to_date,exp.StrToTime:lambda self,e:self.func(_N,e.this,self.format_time(e)),exp.TimestampTrunc:lambda self,e:self.func(_H,unit_to_str(e),e.this),exp.Trim:trim_sql,exp.UnixToTime:_unix_to_time_sql,exp.VariancePop:rename_func('VAR_POP'),exp.WeekOfYear:rename_func(_P),exp.WithinGroup:transforms.preprocess([transforms.remove_within_group_for_percentiles])};TRANSFORMS.pop(exp.ArraySort);TRANSFORMS.pop(exp.ILike);TRANSFORMS.pop(exp.Left);TRANSFORMS.pop(exp.MonthsBetween);TRANSFORMS.pop(exp.Right);WRAP_DERIVED_VALUES=_A;CREATE_FUNCTION_RETURN_AS=_A
		def struct_sql(A,expression):from sqlglot.generator import Generator as B;return B.struct_sql(A,expression)
		def cast_sql(C,expression,safe_prefix=None):
			A=expression;B=A.this;D=isinstance(B,(exp.JSONExtract,exp.JSONExtractScalar))
			if A.to.args.get('nested')and(is_parse_json(B)or D):E=f"'{C.sql(A,"to")}'";return C.func('FROM_JSON',B if D else B.this,E)
			if is_parse_json(A):return C.func('TO_JSON',B)
			return super(Hive.Generator,C).cast_sql(A,safe_prefix=safe_prefix)
		def columndef_sql(B,expression,sep=' '):A=expression;return super().columndef_sql(A,sep=': 'if isinstance(A.parent,exp.DataType)and A.parent.is_type('struct')else sep)
	class Tokenizer(Hive.Tokenizer):HEX_STRINGS=[("X'","'"),("x'","'")]