from __future__ import annotations
_J='DATETIME'
_I='EDITDIST3'
_H='constraints'
_G='REAL'
_F='STRFTIME'
_E='TEXT'
_D=None
_C='this'
_B='INTEGER'
_A=False
import typing as t
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,any_value_to_max_sql,arrow_json_extract_sql,concat_to_dpipe_sql,count_if_to_sum,no_ilike_sql,no_pivot_sql,no_tablesample_sql,no_trycast_sql,rename_func,str_position_sql
from sqlglot.tokens import TokenType
def _date_add_sql(self,expression):B=expression;A=B.expression;A=A.name if A.is_string else self.sql(A);C=B.args.get('unit');A=f"'{A} {C.name}'"if C else f"'{A}'";return self.func('DATE',B.this,A)
def _json_extract_sql(self,expression):
	A=expression
	if A.expressions:return self.function_fallback_sql(A)
	return arrow_json_extract_sql(self,A)
def _build_strftime(args):
	A=args
	if len(A)==1:A.append(exp.CurrentTimestamp())
	if len(A)==2:return exp.TimeToStr(this=exp.TsOrDsToTimestamp(this=A[1]),format=A[0])
	return exp.Anonymous(this=_F,expressions=A)
def _transform_create(expression):
	'Move primary key to a column and enforce auto_increment on primary keys.';D=expression;E=D.this
	if isinstance(D,exp.Create)and isinstance(E,exp.Schema):
		F={};A=_D
		for B in E.expressions:
			if isinstance(B,exp.ColumnDef):F[B.name]=B
			elif isinstance(B,exp.PrimaryKey):A=B
		if A and len(A.expressions)==1:C=F[A.expressions[0].name];C.append(_H,exp.ColumnConstraint(kind=exp.PrimaryKeyColumnConstraint()));E.expressions.remove(A)
		else:
			for C in F.values():
				G=_D
				for H in C.constraints:
					if isinstance(H.kind,exp.PrimaryKeyColumnConstraint):break
					if isinstance(H.kind,exp.AutoIncrementColumnConstraint):G=H
				if G:C.constraints.remove(G)
	return D
def _generated_to_auto_increment(expression):
	A=expression
	if not isinstance(A,exp.ColumnDef):return A
	B=A.find(exp.GeneratedAsIdentityColumnConstraint)
	if B:
		t.cast(exp.ColumnConstraint,B.parent).pop();C=A.find(exp.NotNullColumnConstraint)
		if C:t.cast(exp.ColumnConstraint,C.parent).pop()
		A.append(_H,exp.ColumnConstraint(kind=exp.AutoIncrementColumnConstraint()))
	return A
class SQLite(Dialect):
	NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE;SUPPORTS_SEMI_ANTI_JOIN=_A;TYPED_DIVISION=True;SAFE_DIVISION=True
	class Tokenizer(tokens.Tokenizer):IDENTIFIERS=['"',('[',']'),'`'];HEX_STRINGS=[("x'","'"),("X'","'"),('0x',''),('0X','')];KEYWORDS=tokens.Tokenizer.KEYWORDS.copy();KEYWORDS.pop('/*+')
	class Parser(parser.Parser):FUNCTIONS={**parser.Parser.FUNCTIONS,_I:exp.Levenshtein.from_arg_list,_F:_build_strftime,_J:lambda args:exp.Anonymous(this=_J,expressions=args),'TIME':lambda args:exp.Anonymous(this='TIME',expressions=args)};STRING_ALIASES=True
	class Generator(generator.Generator):
		JOIN_HINTS=_A;TABLE_HINTS=_A;QUERY_HINTS=_A;NVL2_SUPPORTED=_A;JSON_PATH_BRACKETED_KEY_SUPPORTED=_A;SUPPORTS_CREATE_TABLE_LIKE=_A;SUPPORTS_TABLE_ALIAS_COLUMNS=_A;SUPPORTS_TO_NUMBER=_A;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_A;SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.BOOLEAN:_B,exp.DataType.Type.TINYINT:_B,exp.DataType.Type.SMALLINT:_B,exp.DataType.Type.INT:_B,exp.DataType.Type.BIGINT:_B,exp.DataType.Type.FLOAT:_G,exp.DataType.Type.DOUBLE:_G,exp.DataType.Type.DECIMAL:_G,exp.DataType.Type.CHAR:_E,exp.DataType.Type.NCHAR:_E,exp.DataType.Type.VARCHAR:_E,exp.DataType.Type.NVARCHAR:_E,exp.DataType.Type.BINARY:'BLOB',exp.DataType.Type.VARBINARY:'BLOB'};TOKEN_MAPPING={TokenType.AUTO_INCREMENT:'AUTOINCREMENT'};TRANSFORMS={**generator.Generator.TRANSFORMS,exp.AnyValue:any_value_to_max_sql,exp.Concat:concat_to_dpipe_sql,exp.CountIf:count_if_to_sum,exp.Create:transforms.preprocess([_transform_create]),exp.CurrentDate:lambda*A:'CURRENT_DATE',exp.CurrentTime:lambda*A:'CURRENT_TIME',exp.CurrentTimestamp:lambda*A:'CURRENT_TIMESTAMP',exp.ColumnDef:transforms.preprocess([_generated_to_auto_increment]),exp.DateAdd:_date_add_sql,exp.DateStrToDate:lambda self,e:self.sql(e,_C),exp.If:rename_func('IIF'),exp.ILike:no_ilike_sql,exp.JSONExtract:_json_extract_sql,exp.JSONExtractScalar:arrow_json_extract_sql,exp.Levenshtein:rename_func(_I),exp.LogicalOr:rename_func('MAX'),exp.LogicalAnd:rename_func('MIN'),exp.Pivot:no_pivot_sql,exp.Rand:rename_func('RANDOM'),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_qualify,transforms.eliminate_semi_and_anti_joins]),exp.StrPosition:lambda self,e:str_position_sql(self,e,str_position_func_name='INSTR'),exp.TableSample:no_tablesample_sql,exp.TimeStrToTime:lambda self,e:self.sql(e,_C),exp.TimeToStr:lambda self,e:self.func(_F,e.args.get('format'),e.this),exp.TryCast:no_trycast_sql,exp.TsOrDsToTimestamp:lambda self,e:self.sql(e,_C)};PROPERTIES_LOCATION={A:exp.Properties.Location.UNSUPPORTED for A in generator.Generator.PROPERTIES_LOCATION};PROPERTIES_LOCATION[exp.LikeProperty]=exp.Properties.Location.POST_SCHEMA;PROPERTIES_LOCATION[exp.TemporaryProperty]=exp.Properties.Location.POST_CREATE;LIMIT_FETCH='LIMIT'
		def cast_sql(B,expression,safe_prefix=_D):
			A=expression
			if A.is_type('date'):return B.func('DATE',A.this)
			return super().cast_sql(A)
		def generateseries_sql(C,expression):
			B=expression;D=B.parent;A=D and D.args.get('alias')
			if isinstance(A,exp.TableAlias)and A.columns:F=A.columns[0];A.set('columns',_D);E=C.sql(exp.select(exp.alias_('value',F)).from_(B).subquery())
			else:E=C.function_fallback_sql(B)
			return E
		def datediff_sql(C,expression):
			D=expression;B=D.args.get('unit');B=B.name.upper()if B else'DAY';A=f"(JULIANDAY({C.sql(D,_C)}) - JULIANDAY({C.sql(D,"expression")}))"
			if B=='MONTH':A=f"{A} / 30.0"
			elif B=='YEAR':A=f"{A} / 365.0"
			elif B=='HOUR':A=f"{A} * 24.0"
			elif B=='MINUTE':A=f"{A} * 1440.0"
			elif B=='SECOND':A=f"{A} * 86400.0"
			elif B=='MILLISECOND':A=f"{A} * 86400000.0"
			elif B=='MICROSECOND':A=f"{A} * 86400000000.0"
			elif B=='NANOSECOND':A=f"{A} * 8640000000000.0"
			else:C.unsupported(f"DATEDIFF unsupported for '{B}'.")
			return f"CAST({A} AS INTEGER)"
		def groupconcat_sql(D,expression):
			A=expression;B=A.this;C=A.find(exp.Distinct)
			if C:B=C.expressions[0];E='DISTINCT '
			else:E=''
			if isinstance(A.this,exp.Order):
				D.unsupported("SQLite GROUP_CONCAT doesn't support ORDER BY.")
				if A.this.this and not C:B=A.this.this
			F=A.args.get('separator');return f"GROUP_CONCAT({E}{D.format_args(B,F)})"
		def least_sql(B,expression):
			A=expression
			if len(A.expressions)>1:return rename_func('MIN')(B,A)
			return B.sql(A,_C)
		def transaction_sql(B,expression):A=expression.this;A=f" {A}"if A else'';return f"BEGIN{A} TRANSACTION"