from __future__ import annotations
_A5='TRANSACTION'
_A4='TIMEFROMPARTS'
_A3='REPLICATE'
_A2='DATETIMEFROMPARTS'
_A1='COUNT_BIG'
_A0='CHARINDEX'
_z='options'
_y='TINYINT'
_x='TIMESTAMP'
_w='SYSTEM_USER'
_v='SQL_VARIANT'
_u='ROWVERSION'
_t='OUTPUT'
_s='DATETIMEOFFSET'
_r='%B %-d'
_q='%m/%d/%Y'
_p='%H:%M:%S:%f'
_o='%b %d %Y %-I:%M:%S:%f%p'
_n='%b %d %Y %-I:%M%p'
_m='ISNULL'
_l='JSON_VALUE'
_k='JSON_QUERY'
_j='FORMAT'
_i='SCALEOUTEXECUTION'
_h='EXTERNALPUSHDOWN'
_g='MIN_GRANT_PERCENT'
_f='MAX_GRANT_PERCENT'
_e='weekday'
_d='temporary'
_c='GETDATE'
_b='DATEDIFF'
_a='DATEADD'
_Z='DATETIME2'
_Y='%Y-%m-%d %H:%M:%S.%f'
_X='%Y-%m-%d %H:%M:%S'
_W='%H:%M:%S'
_V='expression'
_U='DATEPART'
_T='JOIN'
_S='UNION'
_R='kind'
_Q='properties'
_P='%M'
_O='PLAN'
_N='quarter'
_M='%B'
_L='%A'
_K='%W'
_J='%Y'
_I='HASHBYTES'
_H='day'
_G='week'
_F='year'
_E='month'
_D='this'
_C=True
_B=None
_A=False
import datetime,re,typing as t
from functools import partial,reduce
from sqlglot import exp,generator,parser,tokens,transforms
from sqlglot.dialects.dialect import Dialect,NormalizationStrategy,any_value_to_max_sql,date_delta_sql,datestrtodate_sql,generatedasidentitycolumnconstraint_sql,max_or_greatest,min_or_least,build_date_delta,rename_func,trim_sql,timestrtotime_sql
from sqlglot.helper import seq_get
from sqlglot.parser import build_coalesce
from sqlglot.time import format_time
from sqlglot.tokens import TokenType
if t.TYPE_CHECKING:from sqlglot._typing import E
FULL_FORMAT_TIME_MAPPING={_e:_L,'dw':_L,'w':_L,_E:_M,'mm':_M,'m':_M}
DATE_DELTA_INTERVAL={_F:_F,'yyyy':_F,'yy':_F,_N:_N,'qq':_N,'q':_N,_E:_E,'mm':_E,'m':_E,_G:_G,'ww':_G,'wk':_G,_H:_H,'dd':_H,'d':_H}
DATE_FMT_RE=re.compile('([dD]{1,2})|([mM]{1,2})|([yY]{1,4})|([hH]{1,2})|([sS]{1,2})')
TRANSPILE_SAFE_NUMBER_FMT={'N','C'}
DEFAULT_START_DATE=datetime.date(1900,1,1)
BIT_TYPES={exp.EQ,exp.NEQ,exp.Is,exp.In,exp.Select,exp.Alias}
OPTIONS={**dict.fromkeys(('DISABLE_OPTIMIZED_PLAN_FORCING','FAST','IGNORE_NONCLUSTERED_COLUMNSTORE_INDEX','LABEL','MAXDOP','MAXRECURSION',_f,_g,'NO_PERFORMANCE_SPOOL','QUERYTRACEON','RECOMPILE'),tuple()),'CONCAT':(_S,),'DISABLE':(_h,_i),'EXPAND':('VIEWS',),'FORCE':(_h,'ORDER',_i),'HASH':('GROUP',_T,_S),'KEEP':(_O,),'KEEPFIXED':(_O,),'LOOP':(_T,),'MERGE':(_T,_S),'OPTIMIZE':(('FOR','UNKNOWN'),),'ORDER':('GROUP',),'PARAMETERIZATION':('FORCED','SIMPLE'),'ROBUST':(_O,),'USE':(_O,)}
OPTIONS_THAT_REQUIRE_EQUAL=_f,_g,'LABEL'
def _build_formatted_time(exp_class,full_format_mapping=_B):
	def A(args):A=args;assert len(A)==2;return exp_class(this=exp.cast(A[1],exp.DataType.Type.DATETIME),format=exp.Literal.string(format_time(A[0].name.lower(),{**TSQL.TIME_MAPPING,**FULL_FORMAT_TIME_MAPPING}if full_format_mapping else TSQL.TIME_MAPPING)))
	return A
def _build_format(args):
	B=args;C=seq_get(B,0);A=seq_get(B,1);D=seq_get(B,2);E=A and(A.name in TRANSPILE_SAFE_NUMBER_FMT or not DATE_FMT_RE.search(A.name))
	if E:return exp.NumberToStr(this=C,format=A,culture=D)
	if A:A=exp.Literal.string(format_time(A.name,TSQL.FORMAT_TIME_MAPPING)if len(A.name)==1 else format_time(A.name,TSQL.TIME_MAPPING))
	return exp.TimeToStr(this=C,format=A,culture=D)
def _build_eomonth(args):
	A=exp.TsOrDsToDate(this=seq_get(args,0));B=seq_get(args,1)
	if B is _B:C=A
	else:D=DATE_DELTA_INTERVAL.get(_E);C=exp.DateAdd(this=A,expression=B,unit=D and exp.var(D))
	return exp.LastDay(this=C)
def _build_hashbytes(args):
	B=args;A,C=B;A=A.name.upper()if A.is_string else''
	if A=='MD5':B.pop(0);return exp.MD5(this=C)
	if A in('SHA','SHA1'):B.pop(0);return exp.SHA(this=C)
	if A=='SHA2_256':return exp.SHA2(this=C,length=exp.Literal.number(256))
	if A=='SHA2_512':return exp.SHA2(this=C,length=exp.Literal.number(512))
	return exp.func(_I,*B)
DATEPART_ONLY_FORMATS={'DW','HOUR','QUARTER'}
def _format_sql(self,expression):
	B=expression;A=self;C=B.args['format']
	if not isinstance(B,exp.NumberToStr):
		if C.is_string:
			E=format_time(C.name,TSQL.INVERSE_TIME_MAPPING);F=(E or'').upper()
			if F in DATEPART_ONLY_FORMATS:return A.func(_U,F,B.this)
			D=A.sql(exp.Literal.string(E))
		else:D=A.format_time(B)or A.sql(C)
	else:D=A.sql(C)
	return A.func(_j,B.this,D,B.args.get('culture'))
def _string_agg_sql(self,expression):
	B=self;A=expression;C=A.this;D=A.find(exp.Distinct)
	if D:B.unsupported("T-SQL STRING_AGG doesn't support DISTINCT.");C=D.pop().expressions[0]
	E=''
	if isinstance(A.this,exp.Order):
		if A.this.this:C=A.this.this.pop()
		E=f" WITHIN GROUP ({B.sql(A.this)[1:]})"
	F=A.args.get('separator')or exp.Literal.string(',');return f"STRING_AGG({B.format_args(C,F)}){E}"
def _build_date_delta(exp_class,unit_mapping=_B):
	E=unit_mapping;D=exp_class
	def A(args):
		C=args;B=seq_get(C,0)
		if B and E:B=exp.var(E.get(B.name.lower(),B.name))
		A=seq_get(C,1)
		if A and A.is_number:
			if A.is_int:F=DEFAULT_START_DATE+datetime.timedelta(days=int(A.this));A=exp.Literal.string(F.strftime('%F'))
			else:return D(this=seq_get(C,2),expression=A,unit=B)
		return D(this=exp.TimeStrToTime(this=seq_get(C,2)),expression=exp.TimeStrToTime(this=A),unit=B)
	return A
def qualify_derived_table_outputs(expression):
	'Ensures all (unnamed) output columns are aliased for CTEs and Subqueries.';E='alias';B=expression;A=B.args.get(E)
	if isinstance(B,(exp.CTE,exp.Subquery))and isinstance(A,exp.TableAlias)and not A.columns:
		from sqlglot.optimizer.qualify_columns import qualify_outputs as F;C=B.this;G=(B for(B,A)in enumerate(C.selects)if isinstance(A,exp.Column)and not A.alias);F(C);H=C.selects
		for I in G:
			A=H[I];D=A.this
			if isinstance(D.this,exp.Identifier):A.args[E].set('quoted',D.this.quoted)
	return B
def _build_datetimefromparts(args):A=args;return exp.TimestampFromParts(year=seq_get(A,0),month=seq_get(A,1),day=seq_get(A,2),hour=seq_get(A,3),min=seq_get(A,4),sec=seq_get(A,5),milli=seq_get(A,6))
def _build_timefromparts(args):A=args;return exp.TimeFromParts(hour=seq_get(A,0),min=seq_get(A,1),sec=seq_get(A,2),fractions=seq_get(A,3),precision=seq_get(A,4))
def _build_with_arg_as_text(klass):
	def A(args):
		A=seq_get(args,0)
		if A and not A.is_string:A=exp.cast(A,exp.DataType.Type.TEXT)
		B=seq_get(args,1);C={_D:A}
		if B:C[_V]=B
		return klass(**C)
	return A
def _build_json_query(args,dialect):
	A=args
	if len(A)==1:A.append(exp.Literal.string('$'))
	return parser.build_extract_json_with_path(exp.JSONExtract)(A,dialect)
def _json_extract_sql(self,expression):B=self;A=expression;C=B.func(_k,A.this,A.expression);D=B.func(_l,A.this,A.expression);return B.func(_m,C,D)
def _timestrtotime_sql(self,expression):
	A=expression;B=timestrtotime_sql(self,A)
	if A.args.get('zone'):return self.sql(exp.AtTimeZone(this=B,zone=exp.Literal.string('UTC')))
	return B
class TSQL(Dialect):
	SUPPORTS_SEMI_ANTI_JOIN=_A;LOG_BASE_FIRST=_A;TYPED_DIVISION=_C;CONCAT_COALESCE=_C;NORMALIZATION_STRATEGY=NormalizationStrategy.CASE_INSENSITIVE;TIME_FORMAT="'yyyy-mm-dd hh:mm:ss'";TIME_MAPPING={_F:_J,'dayofyear':'%j',_H:'%d','dy':'%d','y':_J,_G:_K,'ww':_K,'wk':_K,'hour':'%h','hh':'%I','minute':_P,'mi':_P,'n':_P,'second':'%S','ss':'%S','s':'%-S','millisecond':'%f','ms':'%f',_e:_K,'dw':_K,_E:'%m','mm':_P,'m':'%-M','Y':_J,'YYYY':_J,'YY':'%y','MMMM':_M,'MMM':'%b','MM':'%m','M':'%-m','dddd':_L,'dd':'%d','d':'%-d','HH':'%H','H':'%-H','h':'%-I','ffffff':'%f','yyyy':_J,'yy':'%y'};CONVERT_FORMAT_MAPPING={'0':_n,'1':'%m/%d/%y','2':'%y.%m.%d','3':'%d/%m/%y','4':'%d.%m.%y','5':'%d-%m-%y','6':'%d %b %y','7':'%b %d, %y','8':_W,'9':_o,'10':'mm-dd-yy','11':'yy/mm/dd','12':'yymmdd','13':'%d %b %Y %H:%M:ss:%f','14':_p,'20':_X,'21':_Y,'22':'%m/%d/%y %-I:%M:%S %p','23':'%Y-%m-%d','24':_W,'25':_Y,'100':_n,'101':_q,'102':'%Y.%m.%d','103':'%d/%m/%Y','104':'%d.%m.%Y','105':'%d-%m-%Y','106':'%d %b %Y','107':'%b %d, %Y','108':_W,'109':_o,'110':'%m-%d-%Y','111':'%Y/%m/%d','112':'%Y%m%d','113':'%d %b %Y %H:%M:%S:%f','114':_p,'120':_X,'121':_Y};FORMAT_TIME_MAPPING={'y':'%B %Y','d':_q,'H':'%-H','h':'%-I','s':_X,'D':'%A,%B,%Y','f':'%A,%B,%Y %-I:%M %p','F':'%A,%B,%Y %-I:%M:%S %p','g':'%m/%d/%Y %-I:%M %p','G':'%m/%d/%Y %-I:%M:%S %p','M':_r,'m':_r,'O':'%Y-%m-%dT%H:%M:%S','u':'%Y-%M-%D %H:%M:%S%z','U':'%A, %B %D, %Y %H:%M:%S%z','T':'%-I:%M:%S %p','t':'%-I:%M','Y':'%a %Y'}
	class Tokenizer(tokens.Tokenizer):IDENTIFIERS=[('[',']'),'"'];QUOTES=["'",'"'];HEX_STRINGS=[('0x',''),('0X','')];VAR_SINGLE_TOKENS={'@','$','#'};KEYWORDS={**tokens.Tokenizer.KEYWORDS,'CLUSTERED INDEX':TokenType.INDEX,_Z:TokenType.DATETIME,_s:TokenType.TIMESTAMPTZ,'DECLARE':TokenType.DECLARE,'EXEC':TokenType.COMMAND,'FOR SYSTEM_TIME':TokenType.TIMESTAMP_SNAPSHOT,'IMAGE':TokenType.IMAGE,'MONEY':TokenType.MONEY,'NONCLUSTERED INDEX':TokenType.INDEX,'NTEXT':TokenType.TEXT,'OPTION':TokenType.OPTION,_t:TokenType.RETURNING,'PRINT':TokenType.COMMAND,'PROC':TokenType.PROCEDURE,'REAL':TokenType.FLOAT,_u:TokenType.ROWVERSION,'SMALLDATETIME':TokenType.DATETIME,'SMALLMONEY':TokenType.SMALLMONEY,_v:TokenType.VARIANT,_w:TokenType.CURRENT_USER,'TOP':TokenType.TOP,_x:TokenType.ROWVERSION,_y:TokenType.UTINYINT,'UNIQUEIDENTIFIER':TokenType.UNIQUEIDENTIFIER,'UPDATE STATISTICS':TokenType.COMMAND,'XML':TokenType.XML};KEYWORDS.pop('/*+');COMMANDS={*tokens.Tokenizer.COMMANDS,TokenType.END}
	class Parser(parser.Parser):
		SET_REQUIRES_ASSIGNMENT_DELIMITER=_A;LOG_DEFAULTS_TO_LN=_C;ALTER_TABLE_ADD_REQUIRED_FOR_EACH_COLUMN=_A;STRING_ALIASES=_C;NO_PAREN_IF_COMMANDS=_A;QUERY_MODIFIER_PARSERS={**parser.Parser.QUERY_MODIFIER_PARSERS,TokenType.OPTION:lambda self:(_z,self._parse_options())};FUNCTIONS={**parser.Parser.FUNCTIONS,_A0:lambda args:exp.StrPosition(this=seq_get(args,1),substr=seq_get(args,0),position=seq_get(args,2)),'COUNT':lambda args:exp.Count(this=seq_get(args,0),expressions=args[1:],big_int=_A),_A1:lambda args:exp.Count(this=seq_get(args,0),expressions=args[1:],big_int=_C),_a:build_date_delta(exp.DateAdd,unit_mapping=DATE_DELTA_INTERVAL),_b:_build_date_delta(exp.DateDiff,unit_mapping=DATE_DELTA_INTERVAL),'DATENAME':_build_formatted_time(exp.TimeToStr,full_format_mapping=_C),_U:_build_formatted_time(exp.TimeToStr),_A2:_build_datetimefromparts,'EOMONTH':_build_eomonth,_j:_build_format,_c:exp.CurrentTimestamp.from_arg_list,_I:_build_hashbytes,_m:build_coalesce,_k:_build_json_query,_l:parser.build_extract_json_with_path(exp.JSONExtractScalar),'LEN':_build_with_arg_as_text(exp.Length),'LEFT':_build_with_arg_as_text(exp.Left),'RIGHT':_build_with_arg_as_text(exp.Right),_A3:exp.Repeat.from_arg_list,'SQUARE':lambda args:exp.Pow(this=seq_get(args,0),expression=exp.Literal.number(2)),'SYSDATETIME':exp.CurrentTimestamp.from_arg_list,'SUSER_NAME':exp.CurrentUser.from_arg_list,'SUSER_SNAME':exp.CurrentUser.from_arg_list,_w:exp.CurrentUser.from_arg_list,_A4:_build_timefromparts};JOIN_HINTS={'LOOP','HASH','MERGE','REMOTE'};RETURNS_TABLE_TOKENS=parser.Parser.ID_VAR_TOKENS-{TokenType.TABLE,*parser.Parser.TYPE_TOKENS};STATEMENT_PARSERS={**parser.Parser.STATEMENT_PARSERS,TokenType.DECLARE:lambda self:self._parse_declare()};RANGE_PARSERS={**parser.Parser.RANGE_PARSERS,TokenType.DCOLON:lambda self,this:self.expression(exp.ScopeResolution,this=this,expression=self._parse_function()or self._parse_var(any_token=_C))};COLUMN_OPERATORS={**parser.Parser.COLUMN_OPERATORS,TokenType.DCOLON:lambda self,this,to:self.expression(exp.Cast,this=this,to=to)if isinstance(to,exp.DataType)and to.this!=exp.DataType.Type.USERDEFINED else self.expression(exp.ScopeResolution,this=this,expression=to)}
		def _parse_dcolon(A):
			if A._match_set(A.TYPE_TOKENS,advance=_A):return A._parse_types()
			return A._parse_function()or A._parse_types()
		def _parse_options(A):
			if not A._match(TokenType.OPTION):return
			def B():
				B=A._parse_var_from_options(OPTIONS)
				if not B:return
				A._match(TokenType.EQ);return A.expression(exp.QueryOption,this=B,expression=A._parse_primary_or_var())
			return A._parse_wrapped_csv(B)
		def _parse_projections(A):"\n            T-SQL supports the syntax alias = expression in the SELECT's projection list,\n            so we transform all parsed Selects to convert their EQ projections into Aliases.\n\n            See: https://learn.microsoft.com/en-us/sql/t-sql/queries/select-clause-transact-sql?view=sql-server-ver16#syntax\n            ";return[exp.alias_(A.expression,A.this.this,copy=_A)if isinstance(A,exp.EQ)and isinstance(A.this,exp.Column)else A for A in super()._parse_projections()]
		def _parse_commit_or_rollback(A):
			'Applies to SQL Server and Azure SQL Database\n            COMMIT [ { TRAN | TRANSACTION }\n                [ transaction_name | @tran_name_variable ] ]\n                [ WITH ( DELAYED_DURABILITY = { OFF | ON } ) ]\n\n            ROLLBACK { TRAN | TRANSACTION }\n                [ transaction_name | @tran_name_variable\n                | savepoint_name | @savepoint_variable ]\n            ';D=A._prev.token_type==TokenType.ROLLBACK;A._match_texts(('TRAN',_A5));C=A._parse_id_var()
			if D:return A.expression(exp.Rollback,this=C)
			B=_B
			if A._match_pair(TokenType.WITH,TokenType.L_PAREN):
				A._match_text_seq('DELAYED_DURABILITY');A._match(TokenType.EQ)
				if A._match_text_seq('OFF'):B=_A
				else:A._match(TokenType.ON);B=_C
				A._match_r_paren()
			return A.expression(exp.Commit,this=C,durability=B)
		def _parse_transaction(A):
			"Applies to SQL Server and Azure SQL Database\n            BEGIN { TRAN | TRANSACTION }\n            [ { transaction_name | @tran_name_variable }\n            [ WITH MARK [ 'description' ] ]\n            ]\n            "
			if A._match_texts(('TRAN',_A5)):
				B=A.expression(exp.Transaction,this=A._parse_id_var())
				if A._match_text_seq('WITH','MARK'):B.set('mark',A._parse_string())
				return B
			return A._parse_as_command(A._prev)
		def _parse_returns(A):C=A._parse_id_var(any_token=_A,tokens=A.RETURNS_TABLE_TOKENS);B=super()._parse_returns();B.set('table',C);return B
		def _parse_convert(A,strict,safe=_B):C=A._parse_types();A._match(TokenType.COMMA);D=[C,*A._parse_csv(A._parse_assignment)];B=exp.Convert.from_arg_list(D);B.set('safe',safe);B.set('strict',strict);return B
		def _parse_user_defined_function(A,kind=_B):
			B=super()._parse_user_defined_function(kind=kind)
			if kind==TokenType.FUNCTION or isinstance(B,exp.UserDefinedFunction)or A._match(TokenType.ALIAS,advance=_A):return B
			C=A._parse_csv(A._parse_function_parameter);return A.expression(exp.UserDefinedFunction,this=B,expressions=C)
		def _parse_id_var(B,any_token=_C,tokens=_B):
			C=B._match(TokenType.HASH);D=C and B._match(TokenType.HASH);A=super()._parse_id_var(any_token=any_token,tokens=tokens)
			if A:
				if D:A.set('global',_C)
				elif C:A.set(_d,_C)
			return A
		def _parse_create(C):
			A=super()._parse_create()
			if isinstance(A,exp.Create):
				B=A.this.this if isinstance(A.this,exp.Schema)else A.this
				if isinstance(B,exp.Table)and B.this.args.get(_d):
					if not A.args.get(_Q):A.set(_Q,exp.Properties(expressions=[]))
					A.args[_Q].append('expressions',exp.TemporaryProperty())
			return A
		def _parse_if(A):
			B=A._index
			if A._match_text_seq('OBJECT_ID'):
				A._parse_wrapped_csv(A._parse_string)
				if A._match_text_seq('IS','NOT','NULL')and A._match(TokenType.DROP):return A._parse_drop(exists=_C)
				A._retreat(B)
			return super()._parse_if()
		def _parse_unique(A):
			if A._match_texts(('CLUSTERED','NONCLUSTERED')):B=A.CONSTRAINT_PARSERS[A._prev.text.upper()](A)
			else:B=A._parse_schema(A._parse_id_var(any_token=_A))
			return A.expression(exp.UniqueColumnConstraint,this=B)
		def _parse_partition(A):
			if not A._match_text_seq('WITH','(','PARTITIONS'):return
			def B():B=A._parse_bitwise();C=A._parse_bitwise()if A._match_text_seq('TO')else _B;return A.expression(exp.PartitionRange,this=B,expression=C)if C else B
			C=A.expression(exp.Partition,expressions=A._parse_wrapped_csv(B));A._match_r_paren();return C
		def _parse_declare(A):
			C=A._index;B=A._try_parse(partial(A._parse_csv,A._parse_declareitem))
			if not B or A._curr:A._retreat(C);return A._parse_as_command(A._prev)
			return A.expression(exp.Declare,expressions=B)
		def _parse_declareitem(A):
			B=A._parse_id_var()
			if not B:return
			C=_B;A._match(TokenType.ALIAS)
			if A._match(TokenType.TABLE):D=A._parse_schema()
			else:
				D=A._parse_types()
				if A._match(TokenType.EQ):C=A._parse_bitwise()
			return A.expression(exp.DeclareItem,this=B,kind=D,default=C)
	class Generator(generator.Generator):
		LIMIT_IS_TOP=_C;QUERY_HINTS=_A;RETURNING_END=_A;NVL2_SUPPORTED=_A;ALTER_TABLE_INCLUDE_COLUMN_KEYWORD=_A;LIMIT_FETCH='FETCH';COMPUTED_COLUMN_WITH_TYPE=_A;CTE_RECURSIVE_KEYWORD_REQUIRED=_A;ENSURE_BOOLS=_C;NULL_ORDERING_SUPPORTED=_B;SUPPORTS_SINGLE_ARG_CONCAT=_A;TABLESAMPLE_SEED_KEYWORD='REPEATABLE';SUPPORTS_SELECT_INTO=_C;JSON_PATH_BRACKETED_KEY_SUPPORTED=_A;SUPPORTS_TO_NUMBER=_A;SET_OP_MODIFIERS=_A;COPY_PARAMS_EQ_REQUIRED=_C;PARSE_JSON_NAME=_B;EXCEPT_INTERSECT_SUPPORT_ALL_CLAUSE=_A;EXPRESSIONS_WITHOUT_NESTED_CTES={exp.Create,exp.Delete,exp.Insert,exp.Intersect,exp.Except,exp.Merge,exp.Select,exp.Subquery,exp.Union,exp.Update};SUPPORTED_JSON_PATH_PARTS={exp.JSONPathKey,exp.JSONPathRoot,exp.JSONPathSubscript};TYPE_MAPPING={**generator.Generator.TYPE_MAPPING,exp.DataType.Type.BOOLEAN:'BIT',exp.DataType.Type.DECIMAL:'NUMERIC',exp.DataType.Type.DATETIME:_Z,exp.DataType.Type.DOUBLE:'FLOAT',exp.DataType.Type.INT:'INTEGER',exp.DataType.Type.ROWVERSION:_u,exp.DataType.Type.TEXT:'VARCHAR(MAX)',exp.DataType.Type.TIMESTAMP:_Z,exp.DataType.Type.TIMESTAMPTZ:_s,exp.DataType.Type.UTINYINT:_y,exp.DataType.Type.VARIANT:_v};TYPE_MAPPING.pop(exp.DataType.Type.NCHAR);TYPE_MAPPING.pop(exp.DataType.Type.NVARCHAR);TRANSFORMS={**generator.Generator.TRANSFORMS,exp.AnyValue:any_value_to_max_sql,exp.ArrayToString:rename_func('STRING_AGG'),exp.AutoIncrementColumnConstraint:lambda*A:'IDENTITY',exp.DateAdd:date_delta_sql(_a),exp.DateDiff:date_delta_sql(_b),exp.CTE:transforms.preprocess([qualify_derived_table_outputs]),exp.CurrentDate:rename_func(_c),exp.CurrentTimestamp:rename_func(_c),exp.DateStrToDate:datestrtodate_sql,exp.Extract:rename_func(_U),exp.GeneratedAsIdentityColumnConstraint:generatedasidentitycolumnconstraint_sql,exp.GroupConcat:_string_agg_sql,exp.If:rename_func('IIF'),exp.JSONExtract:_json_extract_sql,exp.JSONExtractScalar:_json_extract_sql,exp.LastDay:lambda self,e:self.func('EOMONTH',e.this),exp.Max:max_or_greatest,exp.MD5:lambda self,e:self.func(_I,exp.Literal.string('MD5'),e.this),exp.Min:min_or_least,exp.NumberToStr:_format_sql,exp.Repeat:rename_func(_A3),exp.Select:transforms.preprocess([transforms.eliminate_distinct_on,transforms.eliminate_semi_and_anti_joins,transforms.eliminate_qualify,transforms.unnest_generate_date_array_using_recursive_cte]),exp.Stddev:rename_func('STDEV'),exp.StrPosition:lambda self,e:self.func(_A0,e.args.get('substr'),e.this,e.args.get('position')),exp.Subquery:transforms.preprocess([qualify_derived_table_outputs]),exp.SHA:lambda self,e:self.func(_I,exp.Literal.string('SHA1'),e.this),exp.SHA2:lambda self,e:self.func(_I,exp.Literal.string(f"SHA2_{e.args.get("length",256)}"),e.this),exp.TemporaryProperty:lambda self,e:'',exp.TimeStrToTime:_timestrtotime_sql,exp.TimeToStr:_format_sql,exp.Trim:trim_sql,exp.TsOrDsAdd:date_delta_sql(_a,cast=_C),exp.TsOrDsDiff:date_delta_sql(_b)};TRANSFORMS.pop(exp.ReturnsProperty);PROPERTIES_LOCATION={**generator.Generator.PROPERTIES_LOCATION,exp.VolatileProperty:exp.Properties.Location.UNSUPPORTED}
		def scope_resolution(A,rhs,scope_name):return f"{scope_name}::{rhs}"
		def select_sql(C,expression):
			A=expression
			if A.args.get('offset'):
				if not A.args.get('order'):A.order_by(exp.select(exp.null()).subquery(),copy=_A)
				B=A.args.get('limit')
				if isinstance(B,exp.Limit):B.replace(exp.Fetch(direction='FIRST',count=B.expression))
			return super().select_sql(A)
		def convert_sql(B,expression):A=expression;C='TRY_CONVERT'if A.args.get('safe')else'CONVERT';return B.func(C,A.this,A.expression,A.args.get('style'))
		def queryoption_sql(B,expression):
			C=expression;A=B.sql(C,_D);D=B.sql(C,_V)
			if D:E='= 'if A in OPTIONS_THAT_REQUIRE_EQUAL else'';return f"{A} {E}{D}"
			return A
		def lateral_op(B,expression):
			A=expression.args.get('cross_apply')
			if A is _C:return'CROSS APPLY'
			if A is _A:return'OUTER APPLY'
			B.unsupported('LATERAL clause is not supported.');return'LATERAL'
		def timefromparts_sql(B,expression):
			E='precision';D='fractions';A=expression;C=A.args.get('nano')
			if C is not _B:C.pop();B.unsupported('Specifying nanoseconds is not supported in TIMEFROMPARTS.')
			if A.args.get(D)is _B:A.set(D,exp.Literal.number(0))
			if A.args.get(E)is _B:A.set(E,exp.Literal.number(0))
			return rename_func(_A4)(B,A)
		def timestampfromparts_sql(B,expression):
			E='milli';A=expression;C=A.args.get('zone')
			if C is not _B:C.pop();B.unsupported('Time zone is not supported in DATETIMEFROMPARTS.')
			D=A.args.get('nano')
			if D is not _B:D.pop();B.unsupported('Specifying nanoseconds is not supported in DATETIMEFROMPARTS.')
			if A.args.get(E)is _B:A.set(E,exp.Literal.number(0))
			return rename_func(_A2)(B,A)
		def setitem_sql(B,expression):
			C=expression;A=C.this
			if isinstance(A,exp.EQ)and not isinstance(A.left,exp.Parameter):return f"{B.sql(A.left)} {B.sql(A.right)}"
			return super().setitem_sql(C)
		def boolean_sql(B,expression):
			A=expression
			if type(A.parent)in BIT_TYPES or isinstance(A.find_ancestor(exp.Values,exp.Select),exp.Values):return'1'if A.this else'0'
			return'(1 = 1)'if A.this else'(1 = 0)'
		def is_sql(B,expression):
			A=expression
			if isinstance(A.expression,exp.Boolean):return B.binary(A,'=')
			return B.binary(A,'IS')
		def createable_sql(D,expression,locations):
			B=expression;A=D.sql(B,_D);C=B.args.get(_Q)
			if A[:1]!='#'and any(isinstance(A,exp.TemporaryProperty)for A in(C.expressions if C else[])):A=f"[#{A[1:]}"if A.startswith('[')else f"#{A}"
			return A
		def create_sql(E,expression):
			L='TABLE';K='with';B=expression;F=B.kind;M=B.args.pop('exists',_B);G=B.find(exp.LikeProperty)
			if G:D=G.this
			else:D=B.expression
			if F=='VIEW':
				B.this.set('catalog',_B);I=B.args.get(K)
				if D and I:D.set(K,I.pop())
			A=super().create_sql(B);C=B.find(exp.Table)
			if F==L and D:
				if isinstance(D,exp.UNWRAPPED_QUERIES):D=D.subquery()
				H=exp.select('*').from_(exp.alias_(D,'temp',table=_C));H.set('into',exp.Into(this=C))
				if G:H.limit(0,copy=_A)
				A=E.sql(H)
			if M:
				J=E.sql(exp.Literal.string(exp.table_name(C)if C else''));A=E.sql(exp.Literal.string(A))
				if F=='SCHEMA':A=f"IF NOT EXISTS (SELECT * FROM information_schema.schemata WHERE schema_name = {J}) EXEC({A})"
				elif F==L:assert C;N=exp.and_(exp.column('table_name').eq(C.name),exp.column('table_schema').eq(C.db)if C.db else _B,exp.column('table_catalog').eq(C.catalog)if C.catalog else _B);A=f"IF NOT EXISTS (SELECT * FROM information_schema.tables WHERE {N}) EXEC({A})"
				elif F=='INDEX':O=E.sql(exp.Literal.string(B.this.text(_D)));A=f"IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = object_id({J}) AND name = {O}) EXEC({A})"
			elif B.args.get('replace'):A=A.replace('CREATE OR REPLACE ','CREATE OR ALTER ',1)
			return E.prepend_ctes(B,A)
		def count_sql(B,expression):A=expression;C=_A1 if A.args.get('big_int')else'COUNT';return rename_func(C)(B,A)
		def offset_sql(A,expression):return f"{super().offset_sql(expression)} ROWS"
		def version_sql(C,expression):
			G='FROM';B=expression;H='SYSTEM_TIME'if B.name==_x else B.name;I=f"FOR {H}";E=B.expression;D=B.text(_R)
			if D in(G,'BETWEEN'):F=E.expressions;J='TO'if D==G else'AND';A=f"{C.sql(seq_get(F,0))} {J} {C.sql(seq_get(F,1))}"
			else:A=C.sql(E)
			A=f" {A}"if A else'';return f"{I} {D}{A}"
		def returnsproperty_sql(C,expression):B=expression;A=B.args.get('table');A=f"{A} "if A else'';return f"RETURNS {A}{C.sql(B,_D)}"
		def returning_sql(A,expression):C=expression;B=A.sql(C,'into');B=A.seg(f"INTO {B}")if B else'';return f"{A.seg(_t)} {A.expressions(C,flat=_C)}{B}"
		def transaction_sql(C,expression):D=expression;A=C.sql(D,_D);A=f" {A}"if A else'';B=C.sql(D,'mark');B=f" WITH MARK {B}"if B else'';return f"BEGIN TRANSACTION{A}{B}"
		def commit_sql(D,expression):C=expression;A=D.sql(C,_D);A=f" {A}"if A else'';B=C.args.get('durability');B=f" WITH (DELAYED_DURABILITY = {"ON"if B else"OFF"})"if B is not _B else'';return f"COMMIT TRANSACTION{A}{B}"
		def rollback_sql(B,expression):A=B.sql(expression,_D);A=f" {A}"if A else'';return f"ROLLBACK TRANSACTION{A}"
		def identifier_sql(C,expression):
			B=expression;A=super().identifier_sql(B)
			if B.args.get('global'):A=f"##{A}"
			elif B.args.get(_d):A=f"#{A}"
			return A
		def constraint_sql(A,expression):B=expression;C=A.sql(B,_D);D=A.expressions(B,flat=_C,sep=' ');return f"CONSTRAINT {C} {D}"
		def length_sql(A,expression):return A._uncast_text(expression,'LEN')
		def right_sql(A,expression):return A._uncast_text(expression,'RIGHT')
		def left_sql(A,expression):return A._uncast_text(expression,'LEFT')
		def _uncast_text(A,expression,name):
			C=expression;B=C.this
			if isinstance(B,exp.Cast)and B.is_type(exp.DataType.Type.TEXT):D=A.sql(B,_D)
			else:D=A.sql(B)
			E=A.sql(C,_V);return A.func(name,D,E if E else _B)
		def partition_sql(A,expression):return f"WITH (PARTITIONS({A.expressions(expression,flat=_C)}))"
		def alter_sql(C,expression):
			A=expression;B=seq_get(A.args.get('actions')or[],0)
			if isinstance(B,exp.RenameTable):return f"EXEC sp_rename '{C.sql(A.this)}', '{B.this.name}'"
			return super().alter_sql(A)
		def drop_sql(B,expression):
			A=expression
			if A.args[_R]=='VIEW':A.this.set('catalog',_B)
			return super().drop_sql(A)
		def declare_sql(A,expression):return f"DECLARE {A.expressions(expression,flat=_C)}"
		def declareitem_sql(C,expression):
			A=expression;E=C.sql(A,_D);B=C.sql(A,'default');B=f" = {B}"if B else'';D=C.sql(A,_R)
			if isinstance(A.args.get(_R),exp.Schema):D=f"TABLE {D}"
			return f"{E} AS {D}{B}"
		def options_modifier(A,expression):B=A.expressions(expression,key=_z);return f" OPTION{A.wrap(B)}"if B else''
		def dpipe_sql(A,expression):return A.sql(reduce(lambda x,y:exp.Add(this=x,expression=y),expression.flatten()))