from __future__ import annotations
_A=None
import typing as t
from enum import auto
from sqlglot.helper import AutoName
class ErrorLevel(AutoName):IGNORE=auto();'Ignore all errors.';WARN=auto();'Log all errors.';RAISE=auto();'Collect all errors and raise a single exception.';IMMEDIATE=auto();'Immediately raise an exception on the first error found.'
class SqlglotError(Exception):0
class UnsupportedError(SqlglotError):0
class ParseError(SqlglotError):
	def __init__(A,message,errors=_A):super().__init__(message);A.errors=errors or[]
	@classmethod
	def new(A,message,description=_A,line=_A,col=_A,start_context=_A,highlight=_A,end_context=_A,into_expression=_A):return A(message,[{'description':description,'line':line,'col':col,'start_context':start_context,'highlight':highlight,'end_context':end_context,'into_expression':into_expression}])
class TokenError(SqlglotError):0
class OptimizeError(SqlglotError):0
class SchemaError(SqlglotError):0
class ExecuteError(SqlglotError):0
def concat_messages(errors,maximum):
	B=maximum;A=errors;C=[str(A)for A in A[:B]];D=len(A)-B
	if D>0:C.append(f"... and {D} more")
	return'\n\n'.join(C)
def merge_errors(errors):return[B for A in errors for B in A.errors]