'\n.. include:: ../../posts/python_sql_engine.md\n\n----\n'
from __future__ import annotations
_A=None
import logging,time,typing as t
from sqlglot import exp
from sqlglot.errors import ExecuteError
from sqlglot.executor.python import PythonExecutor
from sqlglot.executor.table import Table,ensure_tables
from sqlglot.helper import dict_depth
from sqlglot.optimizer import optimize
from sqlglot.optimizer.annotate_types import annotate_types
from sqlglot.planner import Plan
from sqlglot.schema import ensure_schema,flatten_schema,nested_get,nested_set
logger=logging.getLogger('sqlglot')
if t.TYPE_CHECKING:from sqlglot.dialects.dialect import DialectType;from sqlglot.expressions import Expression;from sqlglot.schema import Schema
def execute(sql,schema=_A,read=_A,dialect=_A,tables=_A):
	'\n    Run a sql query against data.\n\n    Args:\n        sql: a sql statement.\n        schema: database schema.\n            This can either be an instance of `Schema` or a mapping in one of the following forms:\n            1. {table: {col: type}}\n            2. {db: {table: {col: type}}}\n            3. {catalog: {db: {table: {col: type}}}}\n        read: the SQL dialect to apply during parsing (eg. "spark", "hive", "presto", "mysql").\n        dialect: the SQL dialect (alias for read).\n        tables: additional tables to register.\n\n    Returns:\n        Simple columnar data structure.\n    ';G=True;C=read;A=schema;C=C or dialect;B=ensure_tables(tables,dialect=C)
	if not A:
		A={};L=flatten_schema(B.mapping,depth=dict_depth(B.mapping))
		for D in L:
			E=nested_get(B.mapping,*zip(D,D));assert E is not _A
			for H in E.columns:I=E[0][H];M=annotate_types(exp.convert(I)).type or type(I).__name__;nested_set(A,[*D,H],M)
	A=ensure_schema(A,dialect=C)
	if B.supported_table_args and B.supported_table_args!=A.supported_table_args:raise ExecuteError('Tables must support the same table args as schema')
	F=time.time();J=optimize(sql,A,leave_tables_isolated=G,infer_csv_schemas=G,dialect=C);logger.debug('Optimization finished: %f',time.time()-F);logger.debug('Optimized SQL: %s',J.sql(pretty=G));K=Plan(J);logger.debug('Logical Plan: %s',K);F=time.time();N=PythonExecutor(tables=B).execute(K);logger.debug('Query finished: %f',time.time()-F);return N