from __future__ import annotations
_B=None
_A='scope'
import typing as t
from sqlglot.executor.env import ENV
if t.TYPE_CHECKING:from sqlglot.executor.table import Table,TableIter
class Context:
	'\n    Execution context for sql expressions.\n\n    Context is used to hold relevant data tables which can then be queried on with eval.\n\n    References to columns can either be scalar or vectors. When set_row is used, column references\n    evaluate to scalars while set_range evaluates to vectors. This allows convenient and efficient\n    evaluation of aggregation functions.\n    '
	def __init__(self,tables,env=_B):'\n        Args\n            tables: representing the scope of the current execution context.\n            env: dictionary of functions within the execution context.\n        ';self.tables=tables;self._table=_B;self.range_readers={name:table.range_reader for(name,table)in self.tables.items()};self.row_readers={name:table.reader for(name,table)in tables.items()};self.env={**ENV,**(env or{}),_A:self.row_readers}
	def eval(self,code):return eval(code,self.env)
	def eval_tuple(self,codes):return tuple(self.eval(code)for code in codes)
	@property
	def table(self):
		if self._table is _B:
			self._table=list(self.tables.values())[0]
			for other in self.tables.values():
				if self._table.columns!=other.columns:raise Exception('Columns are different.')
				if len(self._table.rows)!=len(other.rows):raise Exception('Rows are different.')
		return self._table
	def add_columns(self,*columns):
		for table in self.tables.values():table.add_columns(*columns)
	@property
	def columns(self):return self.table.columns
	def __iter__(self):
		self.env[_A]=self.row_readers
		for i in range(len(self.table.rows)):
			for table in self.tables.values():reader=table[i]
			yield(reader,self)
	def table_iter(self,table):self.env[_A]=self.row_readers;return iter(self.tables[table])
	def filter(self,condition):
		rows=[reader.row for(reader,_)in self if self.eval(condition)]
		for table in self.tables.values():table.rows=rows
	def sort(self,key):
		def sort_key(row):self.set_row(row);return tuple((t is _B,t)for t in self.eval_tuple(key))
		self.table.rows.sort(key=sort_key)
	def set_row(self,row):
		for table in self.tables.values():table.reader.row=row
		self.env[_A]=self.row_readers
	def set_index(self,index):
		for table in self.tables.values():table[index]
		self.env[_A]=self.row_readers
	def set_range(self,start,end):
		for name in self.tables:self.range_readers[name].range=range(start,end)
		self.env[_A]=self.range_readers
	def __contains__(self,table):return table in self.tables