_C='expression'
_B='this'
_A=None
import datetime,inspect,re,statistics
from functools import wraps
from sqlglot import exp
from sqlglot.generator import Generator
from sqlglot.helper import PYTHON_VERSION,is_int,seq_get
class reverse_key:
	def __init__(A,obj):A.obj=obj
	def __eq__(A,other):return other.obj==A.obj
	def __lt__(A,other):return other.obj<A.obj
def filter_nulls(func,empty_null=True):
	@wraps(func)
	def A(values):
		A=tuple(A for A in values if A is not _A)
		if not A and empty_null:return
		return func(A)
	return A
def null_if_any(*A):
	'\n    Decorator that makes a function return `None` if any of the `required` arguments are `None`.\n\n    This also supports decoration with no arguments, e.g.:\n\n        @null_if_any\n        def foo(a, b): ...\n\n    In which case all arguments are required.\n    ';B=_A
	if len(A)==1 and callable(A[0]):B=A[0];A=()
	def C(func):
		B=func
		if A:
			D=[B for(B,C)in enumerate(inspect.signature(B).parameters)if C in A]
			def C(*A):return any(A[B]is _A for B in D)
		else:
			def C(*A):return any(A is _A for A in A)
		@wraps(B)
		def E(*A):
			if C(*A):return
			return B(*A)
		return E
	if B:return C(B)
	return C
@null_if_any('substr',_B)
def str_position(substr,this,position=_A):A=position;A=A-1 if A is not _A else A;return this.find(substr,A)+1
@null_if_any(_B)
def substring(this,start=_A,length=_A):
	C=length;B=this;A=start
	if A is _A:return B
	elif A==0:return''
	elif A<0:A=len(B)+A
	else:A-=1
	D=_A if C is _A else A+C;return B[A:D]
@null_if_any
def cast(this,to):
	B=to;A=this
	if B==exp.DataType.Type.DATE:
		if isinstance(A,datetime.datetime):return A.date()
		if isinstance(A,datetime.date):return A
		if isinstance(A,str):return datetime.date.fromisoformat(A)
	if B==exp.DataType.Type.TIME:
		if isinstance(A,datetime.datetime):return A.time()
		if isinstance(A,datetime.time):return A
		if isinstance(A,str):return datetime.time.fromisoformat(A)
	if B in(exp.DataType.Type.DATETIME,exp.DataType.Type.TIMESTAMP):
		if isinstance(A,datetime.datetime):return A
		if isinstance(A,datetime.date):return datetime.datetime(A.year,A.month,A.day)
		if isinstance(A,str):return datetime.datetime.fromisoformat(A)
	if B==exp.DataType.Type.BOOLEAN:return bool(A)
	if B in exp.DataType.TEXT_TYPES:return str(A)
	if B in{exp.DataType.Type.FLOAT,exp.DataType.Type.DOUBLE}:return float(A)
	if B in exp.DataType.NUMERIC_TYPES:return int(A)
	raise NotImplementedError(f"Casting {A} to '{B}' not implemented.")
def ordered(this,desc,nulls_first):
	if desc:return reverse_key(this)
	return this
@null_if_any
def interval(this,unit):
	A=unit;B=A+'S'
	if B in Generator.TIME_PART_SINGULARS:A=B
	return datetime.timedelta(**{A.lower():float(this)})
@null_if_any(_B,_C)
def arraytostring(this,expression,null=_A):return expression.join(A for A in(A if A is not _A else null for A in this)if A is not _A)
@null_if_any(_B,_C)
def jsonextract(this,expression):
	A=this
	for B in expression:
		if isinstance(A,dict):A=A.get(B)
		elif isinstance(A,list)and is_int(B):A=seq_get(A,int(B))
		else:raise NotImplementedError(f"Unable to extract value for {A} at {B}.")
		if A is _A:break
	return A
ENV={'exp':exp,'ARRAYAGG':list,'ARRAYUNIQUEAGG':filter_nulls(lambda acc:list(set(acc))),'AVG':filter_nulls(statistics.fmean if PYTHON_VERSION>=(3,8)else statistics.mean),'COUNT':filter_nulls(lambda acc:sum(1 for A in acc),False),'MAX':filter_nulls(max),'MIN':filter_nulls(min),'SUM':filter_nulls(sum),'ABS':null_if_any(lambda this:abs(this)),'ADD':null_if_any(lambda e,this:e+this),'ARRAYANY':null_if_any(lambda arr,func:any(func(A)for A in arr)),'ARRAYTOSTRING':arraytostring,'BETWEEN':null_if_any(lambda this,low,high:low<=this and this<=high),'BITWISEAND':null_if_any(lambda this,e:this&e),'BITWISELEFTSHIFT':null_if_any(lambda this,e:this<<e),'BITWISEOR':null_if_any(lambda this,e:this|e),'BITWISERIGHTSHIFT':null_if_any(lambda this,e:this>>e),'BITWISEXOR':null_if_any(lambda this,e:this^e),'CAST':cast,'COALESCE':lambda*A:next((A for A in A if A is not _A),_A),'CONCAT':null_if_any(lambda*A:''.join(A)),'SAFECONCAT':null_if_any(lambda*A:''.join(str(A)for A in A)),'CONCATWS':null_if_any(lambda this,*A:this.join(A)),'DATEDIFF':null_if_any(lambda this,expression,*A:(this-expression).days),'DATESTRTODATE':null_if_any(lambda arg:datetime.date.fromisoformat(arg)),'DIV':null_if_any(lambda e,this:e/this),'DOT':null_if_any(lambda e,this:e[this]),'EQ':null_if_any(lambda this,e:this==e),'EXTRACT':null_if_any(lambda this,e:getattr(e,this)),'GT':null_if_any(lambda this,e:this>e),'GTE':null_if_any(lambda this,e:this>=e),'IF':lambda predicate,true,false:true if predicate else false,'INTDIV':null_if_any(lambda e,this:e//this),'INTERVAL':interval,'JSONEXTRACT':jsonextract,'LEFT':null_if_any(lambda this,e:this[:e]),'LIKE':null_if_any(lambda this,e:bool(re.match(e.replace('_','.').replace('%','.*'),this))),'LOWER':null_if_any(lambda arg:arg.lower()),'LT':null_if_any(lambda this,e:this<e),'LTE':null_if_any(lambda this,e:this<=e),'MAP':null_if_any(lambda*A:dict(zip(*A))),'MOD':null_if_any(lambda e,this:e%this),'MUL':null_if_any(lambda e,this:e*this),'NEQ':null_if_any(lambda this,e:this!=e),'ORD':null_if_any(ord),'ORDERED':ordered,'POW':pow,'RIGHT':null_if_any(lambda this,e:this[-e:]),'ROUND':null_if_any(lambda this,decimals=_A,truncate=_A:round(this,ndigits=decimals)),'STRPOSITION':str_position,'SUB':null_if_any(lambda e,this:e-this),'SUBSTRING':substring,'TIMESTRTOTIME':null_if_any(lambda arg:datetime.datetime.fromisoformat(arg)),'UPPER':null_if_any(lambda arg:arg.upper()),'YEAR':null_if_any(lambda arg:arg.year),'MONTH':null_if_any(lambda arg:arg.month),'DAY':null_if_any(lambda arg:arg.day),'CURRENTDATETIME':datetime.datetime.now,'CURRENTTIMESTAMP':datetime.datetime.now,'CURRENTTIME':datetime.datetime.now,'CURRENTDATE':datetime.date.today,'STRFTIME':null_if_any(lambda fmt,arg:datetime.datetime.fromisoformat(arg).strftime(fmt)),'STRTOTIME':null_if_any(lambda arg,format:datetime.datetime.strptime(arg,format)),'TRIM':null_if_any(lambda this,e=_A:this.strip(e)),'STRUCT':lambda*A:{A[B]:A[B+1]for B in range(0,len(A),2)if A[B+1]is not _A and A[B]is not _A},'UNIXTOTIME':null_if_any(lambda arg:datetime.datetime.fromtimestamp(arg,datetime.timezone.utc))}