_F='expression'
_E='source_key'
_D='False'
_C='True'
_B='this'
_A=None
import ast,collections,itertools,math
from sqlglot import exp,generator,planner,tokens
from sqlglot.dialects.dialect import Dialect,inline_array_sql
from sqlglot.errors import ExecuteError
from sqlglot.executor.context import Context
from sqlglot.executor.env import ENV
from sqlglot.executor.table import RowReader,Table
from sqlglot.helper import csv_reader,ensure_list,subclasses
class PythonExecutor:
	def __init__(A,env=_A,tables=_A):A.generator=Python().generator(identify=True,comments=False);A.env={**ENV,**(env or{})};A.tables=tables or{}
	def execute(C,plan):
		G=set();F=set(plan.leaves);B={}
		while F:
			A=F.pop()
			try:
				D=C.context({C:D for A in A.dependencies for(C,D)in B[A].tables.items()})
				if isinstance(A,planner.Scan):B[A]=C.scan(A,D)
				elif isinstance(A,planner.Aggregate):B[A]=C.aggregate(A,D)
				elif isinstance(A,planner.Join):B[A]=C.join(A,D)
				elif isinstance(A,planner.Sort):B[A]=C.sort(A,D)
				elif isinstance(A,planner.SetOperation):B[A]=C.set_operation(A,D)
				else:raise NotImplementedError
				G.add(A)
				for E in A.dependents:
					if all(A in B for A in E.dependencies):F.add(E)
				for E in A.dependencies:
					if all(A in G for A in E.dependents):B.pop(E)
			except Exception as H:raise ExecuteError(f"Step '{A.id}' failed: {H}")from H
		I=plan.root;return B[I].tables[I.name]
	def generate(C,expression):
		'Convert a SQL expression into literal Python code and compile it into bytecode.';A=expression
		if not A:return
		B=C.generator.generate(A);return compile(B,B,'eval',optimize=2)
	def generate_tuple(B,expressions):
		'Convert an array of SQL expressions into tuple of Python byte code.';A=expressions
		if not A:return tuple()
		return tuple(B.generate(A)for A in A)
	def context(A,tables):return Context(tables,env=A.env)
	def table(A,expressions):return Table(A.alias_or_name if isinstance(A,exp.Expression)else A for A in expressions)
	def scan(D,step,context):
		C=context;A=step;B=A.source
		if B and isinstance(B,exp.Expression):B=B.name or B.alias
		if B is _A:C,E=D.static()
		elif B in C:
			if not A.projections and not A.condition:return D.context({A.name:C.tables[B]})
			E=C.table_iter(B)
		elif isinstance(A.source,exp.Table)and isinstance(A.source.this,exp.ReadCSV):E=D.scan_csv(A);C=next(E)
		else:C,E=D.scan_table(A)
		return D.context({A.name:D._project_and_filter(C,A,E)})
	def _project_and_filter(C,context,step,table_iter):
		D=context;A=step;B=C.table(A.projections if A.projections else D.columns);E=C.generate(A.condition);F=C.generate_tuple(A.projections)
		for G in table_iter:
			if len(B)>=A.limit:break
			if E and not D.eval(E):continue
			if F:B.append(D.eval_tuple(F))
			else:B.append(G.row)
		return B
	def static(A):return A.context({}),[RowReader(())]
	def scan_table(A,step):B=A.tables.find(step.source);C=A.context({step.source.alias_or_name:B});return C,iter(B)
	def scan_csv(E,step):
		F=step.source.alias;G=step.source.this
		with csv_reader(G)as C:
			H=next(C);I=Table(H);B=E.context({F:I});yield B;A=[]
			for D in C:
				if not A:
					for J in D:
						try:A.append(type(ast.literal_eval(J)))
						except(ValueError,SyntaxError):A.append(str)
				B.set_row(tuple(_A if A is not str and B==''else A(B)for(A,B)in zip(A,D)));yield B.table.reader
	def join(A,step,context):
		I=context;C=step;F=C.source_name;J=I.tables[F];B=A.context({F:J});G={F:range(0,len(J.columns))}
		for(H,E)in C.joins.items():
			D=I.tables[H];K=max(A.stop for A in G.values());G[H]=range(K,len(D.columns)+K);L=A.context({H:D})
			if E.get(_E):D=A.hash_join(E,B,L)
			else:D=A.nested_loop_join(E,B,L)
			B=A.context({A:Table(D.columns,D.rows,B)for(A,B)in G.items()});M=A.generate(E['condition'])
			if M:B.filter(M)
		if not C.condition and not C.projections:return B
		N=A._project_and_filter(B,C,(A for(A,B)in iter(B)))
		if C.projections:return A.context({C.name:N})
		else:return A.context({B:Table(A.columns,N.rows,A.column_range)for(B,A)in B.tables.items()})
	def nested_loop_join(G,_join,source_context,join_context):
		B=join_context;A=source_context;C=Table(A.columns+B.columns)
		for(D,E)in A:
			for(F,E)in B:C.append(D.row+F.row)
		return C
	def hash_join(I,join,source_context,join_context):
		M='side';C=join_context;B=source_context;A=join;N=I.generate_tuple(A[_E]);O=I.generate_tuple(A['join_key']);J=A.get(M)=='LEFT';P=A.get(M)=='RIGHT';D=collections.defaultdict(lambda:([],[]))
		for(E,F)in B:D[F.eval_tuple(N)][0].append(E.row)
		for(E,F)in C:D[F.eval_tuple(O)][1].append(E.row)
		K=Table(B.columns+C.columns);L=[(_A,)*len(C.columns if J else B.columns)]
		for(G,H)in D.values():
			if J:H=H or L
			elif P:G=G or L
			for(Q,R)in itertools.product(G,H):K.append(Q+R)
		return K
	def aggregate(C,step,context):
		B=step;A=context;I=C.generate_tuple(B.group.values());M=C.generate_tuple(B.aggregations);N=C.generate_tuple(B.operands)
		if N:
			D=Table(C.table(B.operands).columns)
			for(T,Q)in A:D.append(Q.eval_tuple(N))
			for(G,(R,S))in enumerate(zip(A.table.rows,D.rows)):A.table.rows[G]=R+S
			O=len(A.columns);A.add_columns(*D.columns);D=Table(A.columns,A.table.rows,range(O,O+len(D.columns)));A=C.context({_A:D,**A.tables})
		A.sort(I);E=_A;J=0;H=1;K=len(A.table);F=C.table(list(B.group)+B.aggregations)
		def P():F.append(E+A.eval_tuple(M))
		if K:
			for G in range(K):
				A.set_index(G);L=A.eval_tuple(I);E=L if E is _A else E;H+=1
				if L!=E:A.set_range(J,H-2);P();E=L;J=H-2
				if len(F.rows)>=B.limit:break
				if G==K-1:A.set_range(J,H-1);P()
		elif B.limit>0 and not I:A.set_range(0,0);F.append(A.eval_tuple(M))
		A=C.context({B.name:F,**{A:F for A in A.tables}})
		if B.projections or B.condition:return C.scan(B,A)
		return A
	def sort(B,step,context):
		C=context;A=step;H=B.generate_tuple(A.projections);F=[A.alias_or_name for A in A.projections];G=list(C.columns)+F;E=B.table(G)
		for(I,J)in C:E.append(I.row+J.eval_tuple(H))
		D=B.context({_A:E,**{A:E for A in C.tables}});D.sort(B.generate_tuple(A.key))
		if not math.isinf(A.limit):D.table.rows=D.table.rows[0:A.limit]
		K=Table(F,rows=[A[len(C.columns):len(G)]for A in D.table.rows]);return B.context({A.name:K})
	def set_operation(E,step,context):
		F=context;A=step;C=F.tables[A.left];D=F.tables[A.right];B=E.table(C.columns)
		if issubclass(A.op,exp.Intersect):B.rows=list(set(C.rows).intersection(set(D.rows)))
		elif issubclass(A.op,exp.Except):B.rows=list(set(C.rows).difference(set(D.rows)))
		elif issubclass(A.op,exp.Union)and A.distinct:B.rows=list(set(C.rows).union(set(D.rows)))
		else:B.rows=C.rows+D.rows
		if not math.isinf(A.limit):B.rows=B.rows[0:A.limit]
		return E.context({A.name:B})
def _ordered_py(self,expression):A=expression;B=self.sql(A,_B);C=_C if A.args.get('desc')else _D;D=_C if A.args.get('nulls_first')else _D;return f"ORDERED({B}, {C}, {D})"
def _rename(self,e):
	B=self
	try:
		A=list(e.args.values())
		if len(A)==1:
			A=A[0]
			if not isinstance(A,list):return B.func(e.key,A)
			return B.func(e.key,*A)
		if isinstance(e,exp.Func)and e.is_var_len_args:*C,D=A;return B.func(e.key,*C,*ensure_list(D))
		return B.func(e.key,*A)
	except Exception as E:raise Exception(f"Could not rename {repr(e)}")from E
def _case_sql(self,expression):
	C=expression;A=self;E=A.sql(C,_B);D=A.sql(C,'default')or'None'
	for F in reversed(C.args['ifs']):G=A.sql(F,'true');B=A.sql(F,_B);B=f"{E} = ({B})"if E else B;D=f"{G} if {B} else ({D})"
	return D
def _lambda_sql(self,e):A={A.name.lower()for A in e.expressions};e=e.transform(lambda n:exp.var(n.name)if isinstance(n,exp.Identifier)and n.name.lower()in A else n).assert_is(exp.Lambda);return f"lambda {self.expressions(e,flat=True)}: {self.sql(e,_B)}"
def _div_sql(self,e):
	B=self.sql(e,_F)
	if e.args.get('safe'):B+=' or None'
	A=f"DIV({self.sql(e,_B)}, {B})"
	if e.args.get('typed'):A=f"int({A})"
	return A
class Python(Dialect):
	class Tokenizer(tokens.Tokenizer):STRING_ESCAPES=['\\']
	class Generator(generator.Generator):TRANSFORMS={**{A:_rename for A in subclasses(exp.__name__,exp.Binary)},**{A:_rename for A in exp.ALL_FUNCTIONS},exp.Case:_case_sql,exp.Alias:lambda self,e:self.sql(e.this),exp.Array:inline_array_sql,exp.And:lambda self,e:self.binary(e,'and'),exp.Between:_rename,exp.Boolean:lambda self,e:_C if e.this else _D,exp.Cast:lambda self,e:f"CAST({self.sql(e.this)}, exp.DataType.Type.{e.args["to"]})",exp.Column:lambda self,e:f"scope[{self.sql(e,"table")or _A}][{self.sql(e.this)}]",exp.Concat:lambda self,e:self.func('SAFECONCAT'if e.args.get('safe')else'CONCAT',*e.expressions),exp.Distinct:lambda self,e:f"set({self.sql(e,_B)})",exp.Div:_div_sql,exp.Extract:lambda self,e:f"EXTRACT('{e.name.lower()}', {self.sql(e,_F)})",exp.In:lambda self,e:f"{self.sql(e,_B)} in {{{self.expressions(e,flat=True)}}}",exp.Interval:lambda self,e:f"INTERVAL({self.sql(e.this)}, '{self.sql(e.unit)}')",exp.Is:lambda self,e:self.binary(e,'==')if isinstance(e.this,exp.Literal)else self.binary(e,'is'),exp.JSONExtract:lambda self,e:self.func(e.key,e.this,e.expression,*e.expressions),exp.JSONPath:lambda self,e:f"[{",".join(self.sql(A)for A in e.expressions[1:])}]",exp.JSONPathKey:lambda self,e:f"'{self.sql(e.this)}'",exp.JSONPathSubscript:lambda self,e:f"'{e.this}'",exp.Lambda:_lambda_sql,exp.Not:lambda self,e:f"not {self.sql(e.this)}",exp.Null:lambda*A:'None',exp.Or:lambda self,e:self.binary(e,'or'),exp.Ordered:_ordered_py,exp.Star:lambda*A:'1'}