from __future__ import annotations
_A=None
import typing as t
from sqlglot.dialects.dialect import DialectType
from sqlglot.helper import dict_depth
from sqlglot.schema import AbstractMappingSchema,normalize_name
class Table:
	def __init__(A,columns,rows=_A,column_range=_A):
		B=rows;A.columns=tuple(columns);A.column_range=column_range;A.reader=RowReader(A.columns,A.column_range);A.rows=B or[]
		if B:assert len(B[0])==len(A.columns)
		A.range_reader=RangeReader(A)
	def add_columns(A,*B):
		A.columns+=B
		if A.column_range:A.column_range=range(A.column_range.start,A.column_range.stop+len(B))
		A.reader=RowReader(A.columns,A.column_range)
	def append(A,row):assert len(row)==len(A.columns);A.rows.append(row)
	def pop(A):A.rows.pop()
	@property
	def width(self):return len(self.columns)
	def __len__(A):return len(A.rows)
	def __iter__(A):return TableIter(A)
	def __getitem__(A,index):A.reader.row=A.rows[index];return A.reader
	def __repr__(A):
		B=tuple(C for(B,C)in enumerate(A.columns)if not A.column_range or B in A.column_range);C={A:len(A)for A in B};D=[' '.join(A for A in B)]
		for(E,F)in enumerate(A):
			if E>10:break
			D.append(' '.join(str(F[A]).rjust(C[A])[0:C[A]]for A in B))
		return'\n'.join(D)
class TableIter:
	def __init__(A,table):A.table=table;A.index=-1
	def __iter__(A):return A
	def __next__(A):
		A.index+=1
		if A.index<len(A.table):return A.table[A.index]
		raise StopIteration
class RangeReader:
	def __init__(A,table):A.table=table;A.range=range(0)
	def __len__(A):return len(A.range)
	def __getitem__(A,column):return(A.table[B][column]for B in A.range)
class RowReader:
	def __init__(A,columns,column_range=_A):B=column_range;A.columns={C:A for(A,C)in enumerate(columns)if not B or A in B};A.row=_A
	def __getitem__(A,column):return A.row[A.columns[column]]
class Tables(AbstractMappingSchema):0
def ensure_tables(d,dialect=_A):return Tables(_ensure_tables(d,dialect=dialect))
def _ensure_tables(d,dialect=_A):
	B=dialect
	if not d:return{}
	F=dict_depth(d)
	if F>1:return{normalize_name(A,dialect=B,is_table=True).name:_ensure_tables(C,dialect=B)for(A,C)in d.items()}
	D={}
	for(C,A)in d.items():
		C=normalize_name(C,dialect=B).name
		if isinstance(A,Table):D[C]=A
		else:A=[{normalize_name(A,dialect=B).name:C for(A,C)in A.items()}for A in A];E=tuple(A for A in A[0])if A else();G=[tuple(A[B]for B in E)for A in A];D[C]=Table(columns=E,rows=G)
	return D