from sqlglot.optimizer.scope import Scope,build_scope
def eliminate_ctes(expression):
	'\n    Remove unused CTEs from an expression.\n\n    Example:\n        >>> import sqlglot\n        >>> sql = "WITH y AS (SELECT a FROM x) SELECT a FROM z"\n        >>> expression = sqlglot.parse_one(sql)\n        >>> eliminate_ctes(expression).sql()\n        \'SELECT a FROM z\'\n\n    Args:\n        expression (sqlglot.Expression): expression to optimize\n    Returns:\n        sqlglot.Expression: optimized expression\n    ';D=expression;B=build_scope(D)
	if B:
		E=B.ref_count()
		for A in reversed(list(B.traverse())):
			if A.is_cte:
				H=E[id(A)]
				if H<=0:
					F=A.expression.parent;C=F.parent;F.pop()
					if C and len(C.expressions)<=0:C.pop()
					for(I,G)in A.selected_sources.values():
						if isinstance(G,Scope):E[id(G)]-=1
	return D