_A=True
from collections import defaultdict
from sqlglot import alias,exp
from sqlglot.optimizer.qualify_columns import Resolver
from sqlglot.optimizer.scope import Scope,traverse_scope
from sqlglot.schema import ensure_schema
SELECT_ALL=object()
def default_selection(is_agg):return alias(exp.Max(this=exp.Literal.number(1))if is_agg else'1','_')
def pushdown_projections(expression,schema=None,remove_unused_selections=_A):
	'\n    Rewrite sqlglot AST to remove unused columns projections.\n\n    Example:\n        >>> import sqlglot\n        >>> sql = "SELECT y.a AS a FROM (SELECT x.a AS a, x.b AS b FROM x) AS y"\n        >>> expression = sqlglot.parse_one(sql)\n        >>> pushdown_projections(expression).sql()\n        \'SELECT y.a AS a FROM (SELECT x.a AS a FROM x) AS y\'\n\n    Args:\n        expression (sqlglot.Expression): expression to optimize\n        remove_unused_selections (bool): remove selects that are unused\n    Returns:\n        sqlglot.Expression: optimized expression\n    ';H=expression;F=schema;F=ensure_schema(F);I={};B=defaultdict(set)
	for A in reversed(traverse_scope(H)):
		C=B.get(A,{SELECT_ALL});M=I.get(A,0)
		if A.expression.args.get('distinct'):C={SELECT_ALL}
		if isinstance(A.expression,exp.SetOperation):
			E,D=A.union_scopes;B[E]=C
			if any(A.is_star for A in D.expression.selects):B[D]=C
			elif not any(A.is_star for A in E.expression.selects):
				if A.expression.args.get('by_name'):B[D]=B[E]
				else:B[D]=[D.expression.selects[A].alias_or_name for(A,B)in enumerate(E.expression.selects)if SELECT_ALL in C or B.alias_or_name in C]
		if isinstance(A.expression,exp.Select):
			if remove_unused_selections:_remove_unused_selections(A,C,F,M)
			if A.expression.is_star:continue
			J=defaultdict(set)
			for K in A.columns:N=K.table;O=K.name;J[N].add(O)
			for(P,(Q,G))in A.selected_sources.items():
				if isinstance(G,Scope):R={SELECT_ALL}if A.pivots else J.get(P)or set();B[G].update(R)
				L=Q.alias_column_names
				if L:I[G]=len(L)
	return H
def _remove_unused_selections(scope,parent_selections,schema,alias_count):
	H=alias_count;F=parent_selections;D=scope;C=False;I=D.expression.args.get('order')
	if I:J={A.name for A in I.find_all(exp.Column)if not A.table}
	else:J=set()
	B=[];K=C;L=C;G=C;M=SELECT_ALL in F
	for E in D.expression.selects:
		A=E.alias_or_name
		if M or A in F or A in J or H>0:B.append(E);H-=1
		else:
			if E.is_star:L=_A
			K=_A
		if not G and E.find(exp.AggFunc):G=_A
	if L:
		N=Resolver(D,schema);O={A.alias_or_name for A in B}
		for A in sorted(F):
			if A not in O:B.append(alias(exp.column(A,table=N.get_table(A)),A,copy=C))
	if not B:B.append(default_selection(G))
	D.expression.select(*B,append=C,copy=C)
	if K:D.clear_cache()