from __future__ import annotations
_B8='Expecting ('
_B7='Expected }'
_B6='NO ACTION'
_B5='TABLESPACE'
_B4='Expecting >'
_B3='CONNECTION'
_B2='retention_period'
_B1='INPUTFORMAT'
_B0='CONCURRENTLY'
_A_='FILE_FORMAT'
_Az='ENCRYPTION'
_Ay='TIMESTAMP'
_Ax='EVOLUTION'
_Aw='REPEATABLE'
_Av='IMMEDIATE'
_Au='FOREIGN KEY'
_At='NONCLUSTERED'
_As='CASESPECIFIC'
_Ar='SYSTEM_VERSIONING'
_Aq='DISTSTYLE'
_Ap='DUPLICATE'
_Ao='CLUSTER BY'
_An='CHARACTER SET'
_Am='AUTO_INCREMENT'
_Al='value'
_Ak='COLUMNS'
_Aj='GROUP'
_Ai='RESTRICT'
_Ah='Expecting )'
_Ag='SERDE'
_Af='QUERY'
_Ae='ACCESS'
_Ad='AFTER'
_Ac='START'
_Ab='increment'
_Aa='INCREMENT'
_AZ='UPDATE'
_AY='REPLACE'
_AX='IGNORE'
_AW='WRITE'
_AV='EXCLUSIVE'
_AU='order'
_AT='RENAME'
_AS='DELETE'
_AR='UNLOGGED'
_AQ='USING'
_AP='SOURCE'
_AO='PRIMARY KEY'
_AN='IMMUTABLE'
_AM='DISTKEY'
_AL='DEFINER'
_AK='CLUSTERED'
_AJ='CHECKSUM'
_AI='ARRAY'
_AH='ZONE'
_AG='TIME'
_AF='WITHOUT'
_AE='columns'
_AD='side'
_AC='FIRST'
_AB='LAST'
_AA='joins'
_A9='VALUES'
_A8='SHARE'
_A7='start'
_A6='CASCADE'
_A5='VALUE'
_A4='DATABASE'
_A3='CYCLE'
_A2='LEVEL'
_A1='SESSION'
_A0='sample'
_z='UNIQUE'
_y='IDENTITY'
_x='EXCLUDE'
_w='SORTKEY'
_v='SET'
_u='AUTO'
_t='LIKE'
_s='expression'
_r='pivots'
_q='ROWS'
_p='IN'
_o='KEY'
_n='with'
_m='on'
_l='SQL'
_k='MINVALUE'
_j='MAXVALUE'
_i='offset'
_h='limit'
_g='MATCH'
_f='ADD'
_e='FORMAT'
_d='from'
_c='TABLE'
_b='DATA'
_a='ERROR'
_Z='ALL'
_Y='READ'
_X='TRANSACTION'
_W='DEFAULT'
_V='GLOBAL'
_U='MATERIALIZED'
_T='EMPTY'
_S=' '
_R='NULLS'
_Q='LOCAL'
_P='NOT'
_O='alias'
_N='this'
_M='FOR'
_L='ROW'
_K='='
_J='ON'
_I='NO'
_H='expressions'
_G='NULL'
_F='TO'
_E='WITH'
_D='BY'
_C=True
_B=False
_A=None
import logging,typing as t
from collections import defaultdict
from sqlglot import exp
from sqlglot.errors import ErrorLevel,ParseError,concat_messages,merge_errors
from sqlglot.helper import apply_index_offset,ensure_list,seq_get
from sqlglot.time import format_time
from sqlglot.tokens import Token,Tokenizer,TokenType
from sqlglot.trie import TrieResult,in_trie,new_trie
if t.TYPE_CHECKING:from sqlglot._typing import E,Lit;from sqlglot.dialects.dialect import Dialect,DialectType;T=t.TypeVar('T')
logger=logging.getLogger('sqlglot')
OPTIONS_TYPE=t.Dict[str,t.Sequence[t.Union[t.Sequence[str],str]]]
def build_var_map(args):
	A=args
	if len(A)==1 and A[0].is_star:return exp.StarMap(this=A[0])
	B=[];C=[]
	for D in range(0,len(A),2):B.append(A[D]);C.append(A[D+1])
	return exp.VarMap(keys=exp.array(*B,copy=_B),values=exp.array(*C,copy=_B))
def build_like(args):A=args;B=exp.Like(this=seq_get(A,1),expression=seq_get(A,0));return exp.Escape(this=B,expression=seq_get(A,2))if len(A)>2 else B
def binary_range_parser(expr_type,reverse_args=_B):
	def A(self,this):
		B=this;A=self;C=A._parse_bitwise()
		if reverse_args:B,C=C,B
		return A._parse_escape(A.expression(expr_type,this=B,expression=C))
	return A
def build_logarithm(args,dialect):
	C=dialect;A=seq_get(args,0);B=seq_get(args,1)
	if B:
		if not C.LOG_BASE_FIRST:A,B=B,A
		return exp.Log(this=A,expression=B)
	return(exp.Ln if C.parser_class.LOG_DEFAULTS_TO_LN else exp.Log)(this=A)
def build_hex(args,dialect):A=seq_get(args,0);return exp.LowerHex(this=A)if dialect.HEX_LOWERCASE else exp.Hex(this=A)
def build_lower(args):A=seq_get(args,0);return exp.LowerHex(this=A.this)if isinstance(A,exp.Hex)else exp.Lower(this=A)
def build_upper(args):A=seq_get(args,0);return exp.Hex(this=A.this)if isinstance(A,exp.Hex)else exp.Upper(this=A)
def build_extract_json_with_path(expr_type):
	B=expr_type
	def A(args,dialect):
		A=args;C=B(this=seq_get(A,0),expression=dialect.to_json_path(seq_get(A,1)))
		if len(A)>2 and B is exp.JSONExtract:C.set(_H,A[2:])
		return C
	return A
def build_mod(args):A=seq_get(args,0);B=seq_get(args,1);A=exp.Paren(this=A)if isinstance(A,exp.Binary)else A;B=exp.Paren(this=B)if isinstance(B,exp.Binary)else B;return exp.Mod(this=A,expression=B)
def build_pad(args,is_left=_C):A=args;return exp.Pad(this=seq_get(A,0),expression=seq_get(A,1),fill_pattern=seq_get(A,2),is_left=is_left)
def build_array_constructor(exp_class,args,bracket_kind,dialect):
	A=exp_class;B=A(expressions=args)
	if A==exp.Array and dialect.HAS_DISTINCT_ARRAY_CONSTRUCTORS:B.set('bracket_notation',bracket_kind==TokenType.L_BRACKET)
	return B
def build_convert_timezone(args,default_source_tz=_A):
	B=default_source_tz;A=args
	if len(A)==2:C=exp.Literal.string(B)if B else _A;return exp.ConvertTimezone(source_tz=C,target_tz=seq_get(A,0),timestamp=seq_get(A,1))
	return exp.ConvertTimezone.from_arg_list(A)
def build_trim(args,is_left=_C):return exp.Trim(this=seq_get(args,0),expression=seq_get(args,1),position='LEADING'if is_left else'TRAILING')
def build_coalesce(args,is_nvl=_A):return exp.Coalesce(this=seq_get(args,0),expressions=args[1:],is_nvl=is_nvl)
class _Parser(type):
	def __new__(B,clsname,bases,attrs):A=super().__new__(B,clsname,bases,attrs);A.SHOW_TRIE=new_trie(A.split(_S)for A in A.SHOW_PARSERS);A.SET_TRIE=new_trie(A.split(_S)for A in A.SET_PARSERS);return A
class Parser(metaclass=_Parser):
	'\n    Parser consumes a list of tokens produced by the Tokenizer and produces a parsed syntax tree.\n\n    Args:\n        error_level: The desired error level.\n            Default: ErrorLevel.IMMEDIATE\n        error_message_context: The amount of context to capture from a query string when displaying\n            the error message (in number of characters).\n            Default: 100\n        max_errors: Maximum number of error messages to include in a raised ParseError.\n            This is only relevant if error_level is ErrorLevel.RAISE.\n            Default: 3\n    ';FUNCTIONS:t.Dict[str,t.Callable]={**{A:B.from_arg_list for(A,B)in exp.FUNCTION_BY_NAME.items()},**dict.fromkeys(('COALESCE','IFNULL','NVL'),build_coalesce),_AI:lambda args,dialect:exp.Array(expressions=args),'ARRAYAGG':lambda args,dialect:exp.ArrayAgg(this=seq_get(args,0),nulls_excluded=dialect.ARRAY_AGG_INCLUDES_NULLS is _A or _A),'ARRAY_AGG':lambda args,dialect:exp.ArrayAgg(this=seq_get(args,0),nulls_excluded=dialect.ARRAY_AGG_INCLUDES_NULLS is _A or _A),'CHAR':lambda args:exp.Chr(expressions=args),'CHR':lambda args:exp.Chr(expressions=args),'COUNT':lambda args:exp.Count(this=seq_get(args,0),expressions=args[1:],big_int=_C),'CONCAT':lambda args,dialect:exp.Concat(expressions=args,safe=not dialect.STRICT_STRING_CONCAT,coalesce=dialect.CONCAT_COALESCE),'CONCAT_WS':lambda args,dialect:exp.ConcatWs(expressions=args,safe=not dialect.STRICT_STRING_CONCAT,coalesce=dialect.CONCAT_COALESCE),'CONVERT_TIMEZONE':build_convert_timezone,'DATE_TO_DATE_STR':lambda args:exp.Cast(this=seq_get(args,0),to=exp.DataType(this=exp.DataType.Type.TEXT)),'GENERATE_DATE_ARRAY':lambda args:exp.GenerateDateArray(start=seq_get(args,0),end=seq_get(args,1),step=seq_get(args,2)or exp.Interval(this=exp.Literal.number(1),unit=exp.var('DAY'))),'GLOB':lambda args:exp.Glob(this=seq_get(args,1),expression=seq_get(args,0)),'HEX':build_hex,'INSTR':lambda args:exp.StrPosition(this=seq_get(args,0),substr=seq_get(args,1)),'JSON_EXTRACT':build_extract_json_with_path(exp.JSONExtract),'JSON_EXTRACT_SCALAR':build_extract_json_with_path(exp.JSONExtractScalar),'JSON_EXTRACT_PATH_TEXT':build_extract_json_with_path(exp.JSONExtractScalar),_t:build_like,'LOG':build_logarithm,'LOG2':lambda args:exp.Log(this=exp.Literal.number(2),expression=seq_get(args,0)),'LOG10':lambda args:exp.Log(this=exp.Literal.number(10),expression=seq_get(args,0)),'LOWER':build_lower,'LPAD':lambda args:build_pad(args),'LEFTPAD':lambda args:build_pad(args),'LTRIM':lambda args:build_trim(args),'MOD':build_mod,'RIGHTPAD':lambda args:build_pad(args,is_left=_B),'RPAD':lambda args:build_pad(args,is_left=_B),'RTRIM':lambda args:build_trim(args,is_left=_B),'SCOPE_RESOLUTION':lambda args:exp.ScopeResolution(expression=seq_get(args,0))if len(args)!=2 else exp.ScopeResolution(this=seq_get(args,0),expression=seq_get(args,1)),'TIME_TO_TIME_STR':lambda args:exp.Cast(this=seq_get(args,0),to=exp.DataType(this=exp.DataType.Type.TEXT)),'TO_HEX':build_hex,'TS_OR_DS_TO_DATE_STR':lambda args:exp.Substring(this=exp.Cast(this=seq_get(args,0),to=exp.DataType(this=exp.DataType.Type.TEXT)),start=exp.Literal.number(1),length=exp.Literal.number(10)),'UNNEST':lambda args:exp.Unnest(expressions=ensure_list(seq_get(args,0))),'UPPER':build_upper,'VAR_MAP':build_var_map};NO_PAREN_FUNCTIONS={TokenType.CURRENT_DATE:exp.CurrentDate,TokenType.CURRENT_DATETIME:exp.CurrentDate,TokenType.CURRENT_TIME:exp.CurrentTime,TokenType.CURRENT_TIMESTAMP:exp.CurrentTimestamp,TokenType.CURRENT_USER:exp.CurrentUser};STRUCT_TYPE_TOKENS={TokenType.NESTED,TokenType.OBJECT,TokenType.STRUCT,TokenType.UNION};NESTED_TYPE_TOKENS={TokenType.ARRAY,TokenType.LIST,TokenType.LOWCARDINALITY,TokenType.MAP,TokenType.NULLABLE,TokenType.RANGE,*STRUCT_TYPE_TOKENS};ENUM_TYPE_TOKENS={TokenType.ENUM,TokenType.ENUM8,TokenType.ENUM16};AGGREGATE_TYPE_TOKENS={TokenType.AGGREGATEFUNCTION,TokenType.SIMPLEAGGREGATEFUNCTION};TYPE_TOKENS={TokenType.BIT,TokenType.BOOLEAN,TokenType.TINYINT,TokenType.UTINYINT,TokenType.SMALLINT,TokenType.USMALLINT,TokenType.INT,TokenType.UINT,TokenType.BIGINT,TokenType.UBIGINT,TokenType.INT128,TokenType.UINT128,TokenType.INT256,TokenType.UINT256,TokenType.MEDIUMINT,TokenType.UMEDIUMINT,TokenType.FIXEDSTRING,TokenType.FLOAT,TokenType.DOUBLE,TokenType.CHAR,TokenType.NCHAR,TokenType.VARCHAR,TokenType.NVARCHAR,TokenType.BPCHAR,TokenType.TEXT,TokenType.MEDIUMTEXT,TokenType.LONGTEXT,TokenType.MEDIUMBLOB,TokenType.LONGBLOB,TokenType.BINARY,TokenType.VARBINARY,TokenType.JSON,TokenType.JSONB,TokenType.INTERVAL,TokenType.TINYBLOB,TokenType.TINYTEXT,TokenType.TIME,TokenType.TIMETZ,TokenType.TIMESTAMP,TokenType.TIMESTAMP_S,TokenType.TIMESTAMP_MS,TokenType.TIMESTAMP_NS,TokenType.TIMESTAMPTZ,TokenType.TIMESTAMPLTZ,TokenType.TIMESTAMPNTZ,TokenType.DATETIME,TokenType.DATETIME64,TokenType.DATE,TokenType.DATE32,TokenType.INT4RANGE,TokenType.INT4MULTIRANGE,TokenType.INT8RANGE,TokenType.INT8MULTIRANGE,TokenType.NUMRANGE,TokenType.NUMMULTIRANGE,TokenType.TSRANGE,TokenType.TSMULTIRANGE,TokenType.TSTZRANGE,TokenType.TSTZMULTIRANGE,TokenType.DATERANGE,TokenType.DATEMULTIRANGE,TokenType.DECIMAL,TokenType.DECIMAL32,TokenType.DECIMAL64,TokenType.DECIMAL128,TokenType.UDECIMAL,TokenType.BIGDECIMAL,TokenType.UUID,TokenType.GEOGRAPHY,TokenType.GEOMETRY,TokenType.HLLSKETCH,TokenType.HSTORE,TokenType.PSEUDO_TYPE,TokenType.SUPER,TokenType.SERIAL,TokenType.SMALLSERIAL,TokenType.BIGSERIAL,TokenType.XML,TokenType.YEAR,TokenType.UNIQUEIDENTIFIER,TokenType.USERDEFINED,TokenType.MONEY,TokenType.SMALLMONEY,TokenType.ROWVERSION,TokenType.IMAGE,TokenType.VARIANT,TokenType.VECTOR,TokenType.OBJECT,TokenType.OBJECT_IDENTIFIER,TokenType.INET,TokenType.IPADDRESS,TokenType.IPPREFIX,TokenType.IPV4,TokenType.IPV6,TokenType.UNKNOWN,TokenType.NULL,TokenType.NAME,TokenType.TDIGEST,*ENUM_TYPE_TOKENS,*NESTED_TYPE_TOKENS,*AGGREGATE_TYPE_TOKENS};SIGNED_TO_UNSIGNED_TYPE_TOKEN={TokenType.BIGINT:TokenType.UBIGINT,TokenType.INT:TokenType.UINT,TokenType.MEDIUMINT:TokenType.UMEDIUMINT,TokenType.SMALLINT:TokenType.USMALLINT,TokenType.TINYINT:TokenType.UTINYINT,TokenType.DECIMAL:TokenType.UDECIMAL};SUBQUERY_PREDICATES={TokenType.ANY:exp.Any,TokenType.ALL:exp.All,TokenType.EXISTS:exp.Exists,TokenType.SOME:exp.Any};RESERVED_TOKENS={*Tokenizer.SINGLE_TOKENS.values(),TokenType.SELECT}-{TokenType.IDENTIFIER};DB_CREATABLES={TokenType.DATABASE,TokenType.DICTIONARY,TokenType.MODEL,TokenType.SCHEMA,TokenType.SEQUENCE,TokenType.STORAGE_INTEGRATION,TokenType.TABLE,TokenType.TAG,TokenType.VIEW,TokenType.WAREHOUSE,TokenType.STREAMLIT};CREATABLES={TokenType.COLUMN,TokenType.CONSTRAINT,TokenType.FOREIGN_KEY,TokenType.FUNCTION,TokenType.INDEX,TokenType.PROCEDURE,*DB_CREATABLES};ALTERABLES={TokenType.INDEX,TokenType.TABLE,TokenType.VIEW};ID_VAR_TOKENS={TokenType.ALL,TokenType.VAR,TokenType.ANTI,TokenType.APPLY,TokenType.ASC,TokenType.ASOF,TokenType.AUTO_INCREMENT,TokenType.BEGIN,TokenType.BPCHAR,TokenType.CACHE,TokenType.CASE,TokenType.COLLATE,TokenType.COMMAND,TokenType.COMMENT,TokenType.COMMIT,TokenType.CONSTRAINT,TokenType.COPY,TokenType.CUBE,TokenType.DEFAULT,TokenType.DELETE,TokenType.DESC,TokenType.DESCRIBE,TokenType.DICTIONARY,TokenType.DIV,TokenType.END,TokenType.EXECUTE,TokenType.ESCAPE,TokenType.FALSE,TokenType.FIRST,TokenType.FILTER,TokenType.FINAL,TokenType.FORMAT,TokenType.FULL,TokenType.IDENTIFIER,TokenType.IS,TokenType.ISNULL,TokenType.INTERVAL,TokenType.KEEP,TokenType.KILL,TokenType.LEFT,TokenType.LOAD,TokenType.MERGE,TokenType.NATURAL,TokenType.NEXT,TokenType.OFFSET,TokenType.OPERATOR,TokenType.ORDINALITY,TokenType.OVERLAPS,TokenType.OVERWRITE,TokenType.PARTITION,TokenType.PERCENT,TokenType.PIVOT,TokenType.PRAGMA,TokenType.RANGE,TokenType.RECURSIVE,TokenType.REFERENCES,TokenType.REFRESH,TokenType.RENAME,TokenType.REPLACE,TokenType.RIGHT,TokenType.ROLLUP,TokenType.ROW,TokenType.ROWS,TokenType.SEMI,TokenType.SET,TokenType.SETTINGS,TokenType.SHOW,TokenType.TEMPORARY,TokenType.TOP,TokenType.TRUE,TokenType.TRUNCATE,TokenType.UNIQUE,TokenType.UNNEST,TokenType.UNPIVOT,TokenType.UPDATE,TokenType.USE,TokenType.VOLATILE,TokenType.WINDOW,*CREATABLES,*SUBQUERY_PREDICATES,*TYPE_TOKENS,*NO_PAREN_FUNCTIONS};ID_VAR_TOKENS.remove(TokenType.UNION);INTERVAL_VARS=ID_VAR_TOKENS-{TokenType.END};TABLE_ALIAS_TOKENS=ID_VAR_TOKENS-{TokenType.ANTI,TokenType.APPLY,TokenType.ASOF,TokenType.FULL,TokenType.LEFT,TokenType.LOCK,TokenType.NATURAL,TokenType.OFFSET,TokenType.RIGHT,TokenType.SEMI,TokenType.WINDOW};ALIAS_TOKENS=ID_VAR_TOKENS;ARRAY_CONSTRUCTORS={_AI:exp.Array,'LIST':exp.List};COMMENT_TABLE_ALIAS_TOKENS=TABLE_ALIAS_TOKENS-{TokenType.IS};UPDATE_ALIAS_TOKENS=TABLE_ALIAS_TOKENS-{TokenType.SET};TRIM_TYPES={'LEADING','TRAILING','BOTH'};FUNC_TOKENS={TokenType.COLLATE,TokenType.COMMAND,TokenType.CURRENT_DATE,TokenType.CURRENT_DATETIME,TokenType.CURRENT_TIMESTAMP,TokenType.CURRENT_TIME,TokenType.CURRENT_USER,TokenType.FILTER,TokenType.FIRST,TokenType.FORMAT,TokenType.GLOB,TokenType.IDENTIFIER,TokenType.INDEX,TokenType.ISNULL,TokenType.ILIKE,TokenType.INSERT,TokenType.LIKE,TokenType.MERGE,TokenType.OFFSET,TokenType.PRIMARY_KEY,TokenType.RANGE,TokenType.REPLACE,TokenType.RLIKE,TokenType.ROW,TokenType.UNNEST,TokenType.VAR,TokenType.LEFT,TokenType.RIGHT,TokenType.SEQUENCE,TokenType.DATE,TokenType.DATETIME,TokenType.TABLE,TokenType.TIMESTAMP,TokenType.TIMESTAMPTZ,TokenType.TRUNCATE,TokenType.WINDOW,TokenType.XOR,*TYPE_TOKENS,*SUBQUERY_PREDICATES};CONJUNCTION:t.Dict[TokenType,t.Type[exp.Expression]]={TokenType.AND:exp.And};ASSIGNMENT:t.Dict[TokenType,t.Type[exp.Expression]]={TokenType.COLON_EQ:exp.PropertyEQ};DISJUNCTION:t.Dict[TokenType,t.Type[exp.Expression]]={TokenType.OR:exp.Or};EQUALITY={TokenType.EQ:exp.EQ,TokenType.NEQ:exp.NEQ,TokenType.NULLSAFE_EQ:exp.NullSafeEQ};COMPARISON={TokenType.GT:exp.GT,TokenType.GTE:exp.GTE,TokenType.LT:exp.LT,TokenType.LTE:exp.LTE};BITWISE={TokenType.AMP:exp.BitwiseAnd,TokenType.CARET:exp.BitwiseXor,TokenType.PIPE:exp.BitwiseOr};TERM={TokenType.DASH:exp.Sub,TokenType.PLUS:exp.Add,TokenType.MOD:exp.Mod,TokenType.COLLATE:exp.Collate};FACTOR={TokenType.DIV:exp.IntDiv,TokenType.LR_ARROW:exp.Distance,TokenType.SLASH:exp.Div,TokenType.STAR:exp.Mul};EXPONENT:t.Dict[TokenType,t.Type[exp.Expression]]={};TIMES={TokenType.TIME,TokenType.TIMETZ};TIMESTAMPS={TokenType.TIMESTAMP,TokenType.TIMESTAMPTZ,TokenType.TIMESTAMPLTZ,*TIMES};SET_OPERATIONS={TokenType.UNION,TokenType.INTERSECT,TokenType.EXCEPT};JOIN_METHODS={TokenType.ASOF,TokenType.NATURAL,TokenType.POSITIONAL};JOIN_SIDES={TokenType.LEFT,TokenType.RIGHT,TokenType.FULL};JOIN_KINDS={TokenType.ANTI,TokenType.CROSS,TokenType.INNER,TokenType.OUTER,TokenType.SEMI,TokenType.STRAIGHT_JOIN};JOIN_HINTS:t.Set[str]=set();LAMBDAS={TokenType.ARROW:lambda self,expressions:self.expression(exp.Lambda,this=self._replace_lambda(self._parse_assignment(),expressions),expressions=expressions),TokenType.FARROW:lambda self,expressions:self.expression(exp.Kwarg,this=exp.var(expressions[0].name),expression=self._parse_assignment())};COLUMN_OPERATORS={TokenType.DOT:_A,TokenType.DCOLON:lambda self,this,to:self.expression(exp.Cast if self.STRICT_CAST else exp.TryCast,this=this,to=to),TokenType.ARROW:lambda self,this,path:self.expression(exp.JSONExtract,this=this,expression=self.dialect.to_json_path(path),only_json_types=self.JSON_ARROWS_REQUIRE_JSON_TYPE),TokenType.DARROW:lambda self,this,path:self.expression(exp.JSONExtractScalar,this=this,expression=self.dialect.to_json_path(path),only_json_types=self.JSON_ARROWS_REQUIRE_JSON_TYPE),TokenType.HASH_ARROW:lambda self,this,path:self.expression(exp.JSONBExtract,this=this,expression=path),TokenType.DHASH_ARROW:lambda self,this,path:self.expression(exp.JSONBExtractScalar,this=this,expression=path),TokenType.PLACEHOLDER:lambda self,this,key:self.expression(exp.JSONBContains,this=this,expression=key)};EXPRESSION_PARSERS={exp.Cluster:lambda self:self._parse_sort(exp.Cluster,TokenType.CLUSTER_BY),exp.Column:lambda self:self._parse_column(),exp.Condition:lambda self:self._parse_assignment(),exp.DataType:lambda self:self._parse_types(allow_identifiers=_B,schema=_C),exp.Expression:lambda self:self._parse_expression(),exp.From:lambda self:self._parse_from(joins=_C),exp.Group:lambda self:self._parse_group(),exp.Having:lambda self:self._parse_having(),exp.Identifier:lambda self:self._parse_id_var(),exp.Join:lambda self:self._parse_join(),exp.Lambda:lambda self:self._parse_lambda(),exp.Lateral:lambda self:self._parse_lateral(),exp.Limit:lambda self:self._parse_limit(),exp.Offset:lambda self:self._parse_offset(),exp.Order:lambda self:self._parse_order(),exp.Ordered:lambda self:self._parse_ordered(),exp.Properties:lambda self:self._parse_properties(),exp.Qualify:lambda self:self._parse_qualify(),exp.Returning:lambda self:self._parse_returning(),exp.Select:lambda self:self._parse_select(),exp.Sort:lambda self:self._parse_sort(exp.Sort,TokenType.SORT_BY),exp.Table:lambda self:self._parse_table_parts(),exp.TableAlias:lambda self:self._parse_table_alias(),exp.When:lambda self:seq_get(self._parse_when_matched(),0),exp.Where:lambda self:self._parse_where(),exp.Window:lambda self:self._parse_named_window(),exp.With:lambda self:self._parse_with(),'JOIN_TYPE':lambda self:self._parse_join_parts()};STATEMENT_PARSERS={TokenType.ALTER:lambda self:self._parse_alter(),TokenType.BEGIN:lambda self:self._parse_transaction(),TokenType.CACHE:lambda self:self._parse_cache(),TokenType.COMMENT:lambda self:self._parse_comment(),TokenType.COMMIT:lambda self:self._parse_commit_or_rollback(),TokenType.COPY:lambda self:self._parse_copy(),TokenType.CREATE:lambda self:self._parse_create(),TokenType.DELETE:lambda self:self._parse_delete(),TokenType.DESC:lambda self:self._parse_describe(),TokenType.DESCRIBE:lambda self:self._parse_describe(),TokenType.DROP:lambda self:self._parse_drop(),TokenType.GRANT:lambda self:self._parse_grant(),TokenType.INSERT:lambda self:self._parse_insert(),TokenType.KILL:lambda self:self._parse_kill(),TokenType.LOAD:lambda self:self._parse_load(),TokenType.MERGE:lambda self:self._parse_merge(),TokenType.PIVOT:lambda self:self._parse_simplified_pivot(),TokenType.PRAGMA:lambda self:self.expression(exp.Pragma,this=self._parse_expression()),TokenType.REFRESH:lambda self:self._parse_refresh(),TokenType.ROLLBACK:lambda self:self._parse_commit_or_rollback(),TokenType.SET:lambda self:self._parse_set(),TokenType.TRUNCATE:lambda self:self._parse_truncate_table(),TokenType.UNCACHE:lambda self:self._parse_uncache(),TokenType.UPDATE:lambda self:self._parse_update(),TokenType.USE:lambda self:self.expression(exp.Use,kind=self._parse_var_from_options(self.USABLES,raise_unmatched=_B),this=self._parse_table(schema=_B)),TokenType.SEMICOLON:lambda self:self.expression(exp.Semicolon)};UNARY_PARSERS={TokenType.PLUS:lambda self:self._parse_unary(),TokenType.NOT:lambda self:self.expression(exp.Not,this=self._parse_equality()),TokenType.TILDA:lambda self:self.expression(exp.BitwiseNot,this=self._parse_unary()),TokenType.DASH:lambda self:self.expression(exp.Neg,this=self._parse_unary()),TokenType.PIPE_SLASH:lambda self:self.expression(exp.Sqrt,this=self._parse_unary()),TokenType.DPIPE_SLASH:lambda self:self.expression(exp.Cbrt,this=self._parse_unary())};STRING_PARSERS={TokenType.HEREDOC_STRING:lambda self,token:self.expression(exp.RawString,this=token.text),TokenType.NATIONAL_STRING:lambda self,token:self.expression(exp.National,this=token.text),TokenType.RAW_STRING:lambda self,token:self.expression(exp.RawString,this=token.text),TokenType.STRING:lambda self,token:self.expression(exp.Literal,this=token.text,is_string=_C),TokenType.UNICODE_STRING:lambda self,token:self.expression(exp.UnicodeString,this=token.text,escape=self._match_text_seq('UESCAPE')and self._parse_string())};NUMERIC_PARSERS={TokenType.BIT_STRING:lambda self,token:self.expression(exp.BitString,this=token.text),TokenType.BYTE_STRING:lambda self,token:self.expression(exp.ByteString,this=token.text),TokenType.HEX_STRING:lambda self,token:self.expression(exp.HexString,this=token.text),TokenType.NUMBER:lambda self,token:self.expression(exp.Literal,this=token.text,is_string=_B)};PRIMARY_PARSERS={**STRING_PARSERS,**NUMERIC_PARSERS,TokenType.INTRODUCER:lambda self,token:self._parse_introducer(token),TokenType.NULL:lambda self,_:self.expression(exp.Null),TokenType.TRUE:lambda self,_:self.expression(exp.Boolean,this=_C),TokenType.FALSE:lambda self,_:self.expression(exp.Boolean,this=_B),TokenType.SESSION_PARAMETER:lambda self,_:self._parse_session_parameter(),TokenType.STAR:lambda self,_:self._parse_star_ops()};PLACEHOLDER_PARSERS={TokenType.PLACEHOLDER:lambda self:self.expression(exp.Placeholder),TokenType.PARAMETER:lambda self:self._parse_parameter(),TokenType.COLON:lambda self:self.expression(exp.Placeholder,this=self._prev.text)if self._match_set(self.ID_VAR_TOKENS)else _A};RANGE_PARSERS={TokenType.AT_GT:binary_range_parser(exp.ArrayContainsAll),TokenType.BETWEEN:lambda self,this:self._parse_between(this),TokenType.GLOB:binary_range_parser(exp.Glob),TokenType.ILIKE:binary_range_parser(exp.ILike),TokenType.IN:lambda self,this:self._parse_in(this),TokenType.IRLIKE:binary_range_parser(exp.RegexpILike),TokenType.IS:lambda self,this:self._parse_is(this),TokenType.LIKE:binary_range_parser(exp.Like),TokenType.LT_AT:binary_range_parser(exp.ArrayContainsAll,reverse_args=_C),TokenType.OVERLAPS:binary_range_parser(exp.Overlaps),TokenType.RLIKE:binary_range_parser(exp.RegexpLike),TokenType.SIMILAR_TO:binary_range_parser(exp.SimilarTo),TokenType.FOR:lambda self,this:self._parse_comprehension(this)};PROPERTY_PARSERS:t.Dict[str,t.Callable]={'ALLOWED_VALUES':lambda self:self.expression(exp.AllowedValuesProperty,expressions=self._parse_csv(self._parse_primary)),'ALGORITHM':lambda self:self._parse_property_assignment(exp.AlgorithmProperty),_u:lambda self:self._parse_auto_property(),_Am:lambda self:self._parse_property_assignment(exp.AutoIncrementProperty),'BACKUP':lambda self:self.expression(exp.BackupProperty,this=self._parse_var(any_token=_C)),'BLOCKCOMPRESSION':lambda self:self._parse_blockcompression(),'CHARSET':lambda self,**A:self._parse_character_set(**A),_An:lambda self,**A:self._parse_character_set(**A),_AJ:lambda self:self._parse_checksum(),_Ao:lambda self:self._parse_cluster(),_AK:lambda self:self._parse_clustered_by(),'COLLATE':lambda self,**A:self._parse_property_assignment(exp.CollateProperty,**A),'COMMENT':lambda self:self._parse_property_assignment(exp.SchemaCommentProperty),'CONTAINS':lambda self:self._parse_contains_property(),'COPY':lambda self:self._parse_copy_property(),'DATABLOCKSIZE':lambda self,**A:self._parse_datablocksize(**A),'DATA_DELETION':lambda self:self._parse_data_deletion_property(),_AL:lambda self:self._parse_definer(),'DETERMINISTIC':lambda self:self.expression(exp.StabilityProperty,this=exp.Literal.string(_AN)),'DISTRIBUTED':lambda self:self._parse_distributed_property(),_Ap:lambda self:self._parse_duplicate(),'DYNAMIC':lambda self:self.expression(exp.DynamicProperty),_AM:lambda self:self._parse_distkey(),_Aq:lambda self:self._parse_property_assignment(exp.DistStyleProperty),_T:lambda self:self.expression(exp.EmptyProperty),'ENGINE':lambda self:self._parse_property_assignment(exp.EngineProperty),'EXECUTE':lambda self:self._parse_property_assignment(exp.ExecuteAsProperty),'EXTERNAL':lambda self:self.expression(exp.ExternalProperty),'FALLBACK':lambda self,**A:self._parse_fallback(**A),_e:lambda self:self._parse_property_assignment(exp.FileFormatProperty),'FREESPACE':lambda self:self._parse_freespace(),_V:lambda self:self.expression(exp.GlobalProperty),'HEAP':lambda self:self.expression(exp.HeapProperty),'ICEBERG':lambda self:self.expression(exp.IcebergProperty),_AN:lambda self:self.expression(exp.StabilityProperty,this=exp.Literal.string(_AN)),'INHERITS':lambda self:self.expression(exp.InheritsProperty,expressions=self._parse_wrapped_csv(self._parse_table)),'INPUT':lambda self:self.expression(exp.InputModelProperty,this=self._parse_schema()),'JOURNAL':lambda self,**A:self._parse_journal(**A),'LANGUAGE':lambda self:self._parse_property_assignment(exp.LanguageProperty),'LAYOUT':lambda self:self._parse_dict_property(this='LAYOUT'),'LIFETIME':lambda self:self._parse_dict_range(this='LIFETIME'),_t:lambda self:self._parse_create_like(),'LOCATION':lambda self:self._parse_property_assignment(exp.LocationProperty),'LOCK':lambda self:self._parse_locking(),'LOCKING':lambda self:self._parse_locking(),'LOG':lambda self,**A:self._parse_log(**A),_U:lambda self:self.expression(exp.MaterializedProperty),'MERGEBLOCKRATIO':lambda self,**A:self._parse_mergeblockratio(**A),'MODIFIES':lambda self:self._parse_modifies_property(),'MULTISET':lambda self:self.expression(exp.SetProperty,multi=_C),_I:lambda self:self._parse_no_property(),_J:lambda self:self._parse_on_property(),'ORDER BY':lambda self:self._parse_order(skip_order_token=_C),'OUTPUT':lambda self:self.expression(exp.OutputModelProperty,this=self._parse_schema()),'PARTITION':lambda self:self._parse_partitioned_of(),'PARTITION BY':lambda self:self._parse_partitioned_by(),'PARTITIONED BY':lambda self:self._parse_partitioned_by(),'PARTITIONED_BY':lambda self:self._parse_partitioned_by(),_AO:lambda self:self._parse_primary_key(in_props=_C),'RANGE':lambda self:self._parse_dict_range(this='RANGE'),'READS':lambda self:self._parse_reads_property(),'REMOTE':lambda self:self._parse_remote_with_connection(),'RETURNS':lambda self:self._parse_returns(),'STRICT':lambda self:self.expression(exp.StrictProperty),'STREAMING':lambda self:self.expression(exp.StreamingTableProperty),_L:lambda self:self._parse_row(),'ROW_FORMAT':lambda self:self._parse_property_assignment(exp.RowFormatProperty),'SAMPLE':lambda self:self.expression(exp.SampleProperty,this=self._match_text_seq(_D)and self._parse_bitwise()),'SECURE':lambda self:self.expression(exp.SecureProperty),'SECURITY':lambda self:self._parse_security(),_v:lambda self:self.expression(exp.SetProperty,multi=_B),'SETTINGS':lambda self:self._parse_settings_property(),'SHARING':lambda self:self._parse_property_assignment(exp.SharingProperty),_w:lambda self:self._parse_sortkey(),_AP:lambda self:self._parse_dict_property(this=_AP),'STABLE':lambda self:self.expression(exp.StabilityProperty,this=exp.Literal.string('STABLE')),'STORED':lambda self:self._parse_stored(),_Ar:lambda self:self._parse_system_versioning_property(),'TBLPROPERTIES':lambda self:self._parse_wrapped_properties(),'TEMP':lambda self:self.expression(exp.TemporaryProperty),'TEMPORARY':lambda self:self.expression(exp.TemporaryProperty),_F:lambda self:self._parse_to_table(),'TRANSIENT':lambda self:self.expression(exp.TransientProperty),'TRANSFORM':lambda self:self.expression(exp.TransformModelProperty,expressions=self._parse_wrapped_csv(self._parse_expression)),'TTL':lambda self:self._parse_ttl(),_AQ:lambda self:self._parse_property_assignment(exp.FileFormatProperty),_AR:lambda self:self.expression(exp.UnloggedProperty),'VOLATILE':lambda self:self._parse_volatile_property(),_E:lambda self:self._parse_with_property()};CONSTRAINT_PARSERS={'AUTOINCREMENT':lambda self:self._parse_auto_increment(),_Am:lambda self:self._parse_auto_increment(),_As:lambda self:self.expression(exp.CaseSpecificColumnConstraint,not_=_B),_An:lambda self:self.expression(exp.CharacterSetColumnConstraint,this=self._parse_var_or_string()),'CHECK':lambda self:self.expression(exp.CheckColumnConstraint,this=self._parse_wrapped(self._parse_assignment),enforced=self._match_text_seq('ENFORCED')),'COLLATE':lambda self:self.expression(exp.CollateColumnConstraint,this=self._parse_identifier()or self._parse_column()),'COMMENT':lambda self:self.expression(exp.CommentColumnConstraint,this=self._parse_string()),'COMPRESS':lambda self:self._parse_compress(),_AK:lambda self:self.expression(exp.ClusteredColumnConstraint,this=self._parse_wrapped_csv(self._parse_ordered)),_At:lambda self:self.expression(exp.NonClusteredColumnConstraint,this=self._parse_wrapped_csv(self._parse_ordered)),_W:lambda self:self.expression(exp.DefaultColumnConstraint,this=self._parse_bitwise()),'ENCODE':lambda self:self.expression(exp.EncodeColumnConstraint,this=self._parse_var()),'EPHEMERAL':lambda self:self.expression(exp.EphemeralColumnConstraint,this=self._parse_bitwise()),_x:lambda self:self.expression(exp.ExcludeColumnConstraint,this=self._parse_index_params()),_Au:lambda self:self._parse_foreign_key(),_e:lambda self:self.expression(exp.DateFormatColumnConstraint,this=self._parse_var_or_string()),'GENERATED':lambda self:self._parse_generated_as_identity(),_y:lambda self:self._parse_auto_increment(),'INLINE':lambda self:self._parse_inline(),_t:lambda self:self._parse_create_like(),_P:lambda self:self._parse_not_constraint(),_G:lambda self:self.expression(exp.NotNullColumnConstraint,allow_null=_C),_J:lambda self:self._match(TokenType.UPDATE)and self.expression(exp.OnUpdateColumnConstraint,this=self._parse_function())or self.expression(exp.OnProperty,this=self._parse_id_var()),'PATH':lambda self:self.expression(exp.PathColumnConstraint,this=self._parse_string()),'PERIOD':lambda self:self._parse_period_for_system_time(),_AO:lambda self:self._parse_primary_key(),'REFERENCES':lambda self:self._parse_references(match=_B),'TITLE':lambda self:self.expression(exp.TitleColumnConstraint,this=self._parse_var_or_string()),'TTL':lambda self:self.expression(exp.MergeTreeTTL,expressions=[self._parse_bitwise()]),_z:lambda self:self._parse_unique(),'UPPERCASE':lambda self:self.expression(exp.UppercaseColumnConstraint),_E:lambda self:self.expression(exp.Properties,expressions=self._parse_wrapped_properties())};ALTER_PARSERS={_f:lambda self:self._parse_alter_table_add(),'ALTER':lambda self:self._parse_alter_table_alter(),_Ao:lambda self:self._parse_cluster(wrapped=_C),_AS:lambda self:self.expression(exp.Delete,where=self._parse_where()),'DROP':lambda self:self._parse_alter_table_drop(),_AT:lambda self:self._parse_alter_table_rename(),_v:lambda self:self._parse_alter_table_set(),'AS':lambda self:self._parse_select()};ALTER_ALTER_PARSERS={_AM:lambda self:self._parse_alter_diststyle(),_Aq:lambda self:self._parse_alter_diststyle(),_w:lambda self:self._parse_alter_sortkey(),'COMPOUND':lambda self:self._parse_alter_sortkey(compound=_C)};SCHEMA_UNNAMED_CONSTRAINTS={'CHECK',_x,_Au,_t,'PERIOD',_AO,_z};NO_PAREN_FUNCTION_PARSERS={'ANY':lambda self:self.expression(exp.Any,this=self._parse_bitwise()),'CASE':lambda self:self._parse_case(),'CONNECT_BY_ROOT':lambda self:self.expression(exp.ConnectByRoot,this=self._parse_column()),'IF':lambda self:self._parse_if(),'NEXT':lambda self:self._parse_next_value_for()};INVALID_FUNC_NAME_TOKENS={TokenType.IDENTIFIER,TokenType.STRING};FUNCTIONS_WITH_ALIASED_ARGS={'STRUCT'};KEY_VALUE_DEFINITIONS=exp.Alias,exp.EQ,exp.PropertyEQ,exp.Slice;FUNCTION_PARSERS={'CAST':lambda self:self._parse_cast(self.STRICT_CAST),'CONVERT':lambda self:self._parse_convert(self.STRICT_CAST),'DECODE':lambda self:self._parse_decode(),'EXTRACT':lambda self:self._parse_extract(),'GAP_FILL':lambda self:self._parse_gap_fill(),'JSON_OBJECT':lambda self:self._parse_json_object(),'JSON_OBJECTAGG':lambda self:self._parse_json_object(agg=_C),'JSON_TABLE':lambda self:self._parse_json_table(),_g:lambda self:self._parse_match_against(),'NORMALIZE':lambda self:self._parse_normalize(),'OPENJSON':lambda self:self._parse_open_json(),'OVERLAY':lambda self:self._parse_overlay(),'POSITION':lambda self:self._parse_position(),'PREDICT':lambda self:self._parse_predict(),'SAFE_CAST':lambda self:self._parse_cast(_B,safe=_C),'STRING_AGG':lambda self:self._parse_string_agg(),'SUBSTRING':lambda self:self._parse_substring(),'TRIM':lambda self:self._parse_trim(),'TRY_CAST':lambda self:self._parse_cast(_B,safe=_C),'TRY_CONVERT':lambda self:self._parse_convert(_B,safe=_C)};QUERY_MODIFIER_PARSERS={TokenType.MATCH_RECOGNIZE:lambda self:('match',self._parse_match_recognize()),TokenType.PREWHERE:lambda self:('prewhere',self._parse_prewhere()),TokenType.WHERE:lambda self:('where',self._parse_where()),TokenType.GROUP_BY:lambda self:('group',self._parse_group()),TokenType.HAVING:lambda self:('having',self._parse_having()),TokenType.QUALIFY:lambda self:('qualify',self._parse_qualify()),TokenType.WINDOW:lambda self:('windows',self._parse_window_clause()),TokenType.ORDER_BY:lambda self:(_AU,self._parse_order()),TokenType.LIMIT:lambda self:(_h,self._parse_limit()),TokenType.FETCH:lambda self:(_h,self._parse_limit()),TokenType.OFFSET:lambda self:(_i,self._parse_offset()),TokenType.FOR:lambda self:('locks',self._parse_locks()),TokenType.LOCK:lambda self:('locks',self._parse_locks()),TokenType.TABLE_SAMPLE:lambda self:(_A0,self._parse_table_sample(as_modifier=_C)),TokenType.USING:lambda self:(_A0,self._parse_table_sample(as_modifier=_C)),TokenType.CLUSTER_BY:lambda self:('cluster',self._parse_sort(exp.Cluster,TokenType.CLUSTER_BY)),TokenType.DISTRIBUTE_BY:lambda self:('distribute',self._parse_sort(exp.Distribute,TokenType.DISTRIBUTE_BY)),TokenType.SORT_BY:lambda self:('sort',self._parse_sort(exp.Sort,TokenType.SORT_BY)),TokenType.CONNECT_BY:lambda self:('connect',self._parse_connect(skip_start_token=_C)),TokenType.START_WITH:lambda self:('connect',self._parse_connect())};SET_PARSERS={_V:lambda self:self._parse_set_item_assignment(_V),_Q:lambda self:self._parse_set_item_assignment(_Q),_A1:lambda self:self._parse_set_item_assignment(_A1),_X:lambda self:self._parse_set_transaction()};SHOW_PARSERS:t.Dict[str,t.Callable]={};TYPE_LITERAL_PARSERS={exp.DataType.Type.JSON:lambda self,this,_:self.expression(exp.ParseJSON,this=this)};TYPE_CONVERTERS:t.Dict[exp.DataType.Type,t.Callable[[exp.DataType],exp.DataType]]={};DDL_SELECT_TOKENS={TokenType.SELECT,TokenType.WITH,TokenType.L_PAREN};PRE_VOLATILE_TOKENS={TokenType.CREATE,TokenType.REPLACE,TokenType.UNIQUE};TRANSACTION_KIND={'DEFERRED',_Av,_AV};TRANSACTION_CHARACTERISTICS:OPTIONS_TYPE={'ISOLATION':((_A2,_Aw,_Y),(_A2,_Y,'COMMITTED'),(_A2,_Y,'UNCOMITTED'),(_A2,'SERIALIZABLE')),_Y:(_AW,'ONLY')};CONFLICT_ACTIONS:OPTIONS_TYPE=dict.fromkeys(('ABORT','FAIL',_AX,_AY,'ROLLBACK',_AZ),tuple());CONFLICT_ACTIONS['DO']='NOTHING',_AZ;CREATE_SEQUENCE:OPTIONS_TYPE={'SCALE':('EXTEND','NOEXTEND'),'SHARD':('EXTEND','NOEXTEND'),_I:(_A3,'CACHE',_j,_k),**dict.fromkeys((_A1,_V,'KEEP','NOKEEP','ORDER','NOORDER','NOCACHE',_A3,'NOCYCLE','NOMINVALUE','NOMAXVALUE','NOSCALE','NOSHARD'),tuple())};ISOLATED_LOADING_OPTIONS:OPTIONS_TYPE={_M:(_Z,'INSERT','NONE')};USABLES:OPTIONS_TYPE=dict.fromkeys(('ROLE','WAREHOUSE',_A4,'SCHEMA','CATALOG'),tuple());CAST_ACTIONS:OPTIONS_TYPE=dict.fromkeys((_AT,_f),('FIELDS',));SCHEMA_BINDING_OPTIONS:OPTIONS_TYPE={'TYPE':(_Ax,),**dict.fromkeys(('BINDING','COMPENSATION',_Ax),tuple())};KEY_CONSTRAINT_OPTIONS:OPTIONS_TYPE={_P:('ENFORCED',),_g:('FULL','PARTIAL','SIMPLE'),'INITIALLY':('DEFERRED',_Av),**dict.fromkeys(('DEFERRABLE','NORELY'),tuple())};INSERT_ALTERNATIVES={'ABORT','FAIL',_AX,_AY,'ROLLBACK'};CLONE_KEYWORDS={'CLONE','COPY'};HISTORICAL_DATA_PREFIX={'AT','BEFORE','END'};HISTORICAL_DATA_KIND={_Ay,'OFFSET','STATEMENT','STREAM'};OPCLASS_FOLLOW_KEYWORDS={'ASC','DESC',_R,_E};OPTYPE_FOLLOW_TOKENS={TokenType.COMMA,TokenType.R_PAREN};TABLE_INDEX_HINT_TOKENS={TokenType.FORCE,TokenType.IGNORE,TokenType.USE};VIEW_ATTRIBUTES={_Az,'SCHEMABINDING','VIEW_METADATA'};WINDOW_ALIAS_TOKENS=ID_VAR_TOKENS-{TokenType.ROWS};WINDOW_BEFORE_PAREN_TOKENS={TokenType.OVER};WINDOW_SIDES={'FOLLOWING','PRECEDING'};JSON_KEY_VALUE_SEPARATOR_TOKENS={TokenType.COLON,TokenType.COMMA,TokenType.IS};FETCH_TOKENS=ID_VAR_TOKENS-{TokenType.ROW,TokenType.ROWS,TokenType.PERCENT};ADD_CONSTRAINT_TOKENS={TokenType.CONSTRAINT,TokenType.FOREIGN_KEY,TokenType.INDEX,TokenType.KEY,TokenType.PRIMARY_KEY,TokenType.UNIQUE};DISTINCT_TOKENS={TokenType.DISTINCT};NULL_TOKENS={TokenType.NULL};UNNEST_OFFSET_ALIAS_TOKENS=ID_VAR_TOKENS-SET_OPERATIONS;SELECT_START_TOKENS={TokenType.L_PAREN,TokenType.WITH,TokenType.SELECT};COPY_INTO_VARLEN_OPTIONS={_A_,'COPY_OPTIONS','FORMAT_OPTIONS','CREDENTIAL'};IS_JSON_PREDICATE_KIND={_A5,'SCALAR',_AI,'OBJECT'};ODBC_DATETIME_LITERALS={'d':exp.Date,'t':exp.Time,'ts':exp.Timestamp};ON_CONDITION_TOKENS={_a,_G,'TRUE','FALSE',_T};PRIVILEGE_FOLLOW_TOKENS={TokenType.ON,TokenType.COMMA,TokenType.L_PAREN};STRICT_CAST=_C;PREFIXED_PIVOT_COLUMNS=_B;IDENTIFY_PIVOT_STRINGS=_B;LOG_DEFAULTS_TO_LN=_B;ALTER_TABLE_ADD_REQUIRED_FOR_EACH_COLUMN=_C;TABLESAMPLE_CSV=_B;DEFAULT_SAMPLING_METHOD:t.Optional[str]=_A;SET_REQUIRES_ASSIGNMENT_DELIMITER=_C;TRIM_PATTERN_FIRST=_B;STRING_ALIASES=_B;MODIFIERS_ATTACHED_TO_SET_OP=_C;SET_OP_MODIFIERS={_AU,_h,_i};NO_PAREN_IF_COMMANDS=_C;JSON_ARROWS_REQUIRE_JSON_TYPE=_B;COLON_IS_VARIANT_EXTRACT=_B;VALUES_FOLLOWED_BY_PAREN=_C;SUPPORTS_IMPLICIT_UNNEST=_B;INTERVAL_SPANS=_C;SUPPORTS_PARTITION_SELECTION=_B;__slots__='error_level','error_message_context','max_errors','dialect','sql','errors','_tokens','_index','_curr','_next','_prev','_prev_comments';SHOW_TRIE:t.Dict={};SET_TRIE:t.Dict={}
	def __init__(A,error_level=_A,error_message_context=100,max_errors=3,dialect=_A):from sqlglot.dialects import Dialect as B;A.error_level=error_level or ErrorLevel.IMMEDIATE;A.error_message_context=error_message_context;A.max_errors=max_errors;A.dialect=B.get_or_raise(dialect);A.reset()
	def reset(A):A.sql='';A.errors=[];A._tokens=[];A._index=0;A._curr=_A;A._next=_A;A._prev=_A;A._prev_comments=_A
	def parse(A,raw_tokens,sql=_A):'\n        Parses a list of tokens and returns a list of syntax trees, one tree\n        per parsed SQL statement.\n\n        Args:\n            raw_tokens: The list of tokens.\n            sql: The original SQL string, used to produce helpful debug messages.\n\n        Returns:\n            The list of the produced syntax trees.\n        ';return A._parse(parse_method=A.__class__._parse_statement,raw_tokens=raw_tokens,sql=sql)
	def parse_into(C,expression_types,raw_tokens,sql=_A):
		'\n        Parses a list of tokens into a given Expression type. If a collection of Expression\n        types is given instead, this method will try to parse the token list into each one\n        of them, stopping at the first for which the parsing succeeds.\n\n        Args:\n            expression_types: The expression type(s) to try and parse the token list into.\n            raw_tokens: The list of tokens.\n            sql: The original SQL string, used to produce helpful debug messages.\n\n        Returns:\n            The target Expression.\n        ';E=raw_tokens;D=expression_types;A=[]
		for B in ensure_list(D):
			F=C.EXPRESSION_PARSERS.get(B)
			if not F:raise TypeError(f"No parser registered for {B}")
			try:return C._parse(F,E,sql)
			except ParseError as G:G.errors[0]['into_expression']=B;A.append(G)
		raise ParseError(f"Failed to parse '{sql or E}' into {D}",errors=merge_errors(A))from A[-1]
	def _parse(A,parse_method,raw_tokens,sql=_A):
		D=raw_tokens;A.reset();A.sql=sql or'';F=len(D);B=[[]]
		for(G,C)in enumerate(D):
			if C.token_type==TokenType.SEMICOLON:
				if C.comments:B.append([C])
				if G<F-1:B.append([])
			else:B[-1].append(C)
		E=[]
		for H in B:
			A._index=-1;A._tokens=H;A._advance();E.append(parse_method(A))
			if A._index<len(A._tokens):A.raise_error('Invalid expression / Unexpected token')
			A.check_errors()
		return E
	def check_errors(A):
		'Logs or raises any found errors, depending on the chosen error level setting.'
		if A.error_level==ErrorLevel.WARN:
			for B in A.errors:logger.error(str(B))
		elif A.error_level==ErrorLevel.RAISE and A.errors:raise ParseError(concat_messages(A.errors,A.max_errors),errors=merge_errors(A.errors))
	def raise_error(A,message,token=_A):
		'\n        Appends an error in the list of recorded errors or raises it, depending on the chosen\n        error level setting.\n        ';E=message;B=token;B=B or A._curr or A._prev or Token.string('');C=B.start;D=B.end+1;F=A.sql[max(C-A.error_message_context,0):C];G=A.sql[C:D];H=A.sql[D:D+A.error_message_context];I=ParseError.new(f"{E}. Line {B.line}, Col: {B.col}.\n  {F}[4m{G}[0m{H}",description=E,line=B.line,col=B.col,start_context=F,highlight=G,end_context=H)
		if A.error_level==ErrorLevel.IMMEDIATE:raise I
		A.errors.append(I)
	def expression(B,exp_class,comments=_A,**D):'\n        Creates a new, validated Expression.\n\n        Args:\n            exp_class: The expression class to instantiate.\n            comments: An optional list of comments to attach to the expression.\n            kwargs: The arguments to set for the expression along with their respective values.\n\n        Returns:\n            The target expression.\n        ';C=comments;A=exp_class(**D);A.add_comments(C)if C else B._add_comments(A);return B.validate_expression(A)
	def _add_comments(A,expression):
		B=expression
		if B and A._prev_comments:B.add_comments(A._prev_comments);A._prev_comments=_A
	def validate_expression(A,expression,args=_A):
		"\n        Validates an Expression, making sure that all its mandatory arguments are set.\n\n        Args:\n            expression: The expression to validate.\n            args: An optional list of items that was used to instantiate the expression, if it's a Func.\n\n        Returns:\n            The validated expression.\n        ";B=expression
		if A.error_level!=ErrorLevel.IGNORE:
			for C in B.error_messages(args):A.raise_error(C)
		return B
	def _find_sql(A,start,end):return A.sql[start.start:end.end+1]
	def _is_connected(A):return A._prev and A._curr and A._prev.end+1==A._curr.start
	def _advance(A,times=1):
		A._index+=times;A._curr=seq_get(A._tokens,A._index);A._next=seq_get(A._tokens,A._index+1)
		if A._index>0:A._prev=A._tokens[A._index-1];A._prev_comments=A._prev.comments
		else:A._prev=_A;A._prev_comments=_A
	def _retreat(A,index):
		B=index
		if B!=A._index:A._advance(B-A._index)
	def _warn_unsupported(A):
		if len(A._tokens)<=1:return
		B=A._find_sql(A._tokens[0],A._tokens[-1])[:A.error_message_context];logger.warning(f"'{B}' contains unsupported syntax. Falling back to parsing as a 'Command'.")
	def _parse_command(A):A._warn_unsupported();return A.expression(exp.Command,comments=A._prev_comments,this=A._prev.text.upper(),expression=A._parse_string())
	def _try_parse(A,parse_method,retreat=_B):
		'\n        Attemps to backtrack if a parse function that contains a try/catch internally raises an error.\n        This behavior can be different depending on the uset-set ErrorLevel, so _try_parse aims to\n        solve this by setting & resetting the parser state accordingly\n        ';C=A._index;D=A.error_level;A.error_level=ErrorLevel.IMMEDIATE
		try:B=parse_method()
		except ParseError:B=_A
		finally:
			if not B or retreat:A._retreat(C)
			A.error_level=D
		return B
	def _parse_comment(A,allow_exists=_C):
		D=A._prev;E=A._parse_exists()if allow_exists else _A;A._match(TokenType.ON);F=A._match_text_seq(_U);B=A._match_set(A.CREATABLES)and A._prev
		if not B:return A._parse_as_command(D)
		if B.token_type in(TokenType.FUNCTION,TokenType.PROCEDURE):C=A._parse_user_defined_function(kind=B.token_type)
		elif B.token_type==TokenType.TABLE:C=A._parse_table(alias_tokens=A.COMMENT_TABLE_ALIAS_TOKENS)
		elif B.token_type==TokenType.COLUMN:C=A._parse_column()
		else:C=A._parse_id_var()
		A._match(TokenType.IS);return A.expression(exp.Comment,this=C,kind=B.text,expression=A._parse_string(),exists=E,materialized=F)
	def _parse_to_table(A):B=A._parse_table_parts(schema=_C);return A.expression(exp.ToTableProperty,this=B)
	def _parse_ttl(A):
		def D():
			B=A._parse_bitwise()
			if A._match_text_seq(_AS):return A.expression(exp.MergeTreeTTLAction,this=B,delete=_C)
			if A._match_text_seq('RECOMPRESS'):return A.expression(exp.MergeTreeTTLAction,this=B,recompress=A._parse_bitwise())
			if A._match_text_seq(_F,'DISK'):return A.expression(exp.MergeTreeTTLAction,this=B,to_disk=A._parse_string())
			if A._match_text_seq(_F,'VOLUME'):return A.expression(exp.MergeTreeTTLAction,this=B,to_volume=A._parse_string())
			return B
		E=A._parse_csv(D);F=A._parse_where();B=A._parse_group();C=_A
		if B and A._match(TokenType.SET):C=A._parse_csv(A._parse_set_item)
		return A.expression(exp.MergeTreeTTL,expressions=E,where=F,group=B,aggregates=C)
	def _parse_statement(A):
		if A._curr is _A:return
		if A._match_set(A.STATEMENT_PARSERS):return A.STATEMENT_PARSERS[A._prev.token_type](A)
		if A._match_set(A.dialect.tokenizer.COMMANDS):return A._parse_command()
		B=A._parse_expression();B=A._parse_set_operations(B)if B else A._parse_select();return A._parse_query_modifiers(B)
	def _parse_drop(A,exists=_B):
		C=A._prev;E=A._match(TokenType.TEMPORARY);F=A._match_text_seq(_U);B=A._match_set(A.CREATABLES)and A._prev.text.upper()
		if not B:return A._parse_as_command(C)
		G=A._match_text_seq(_B0);H=exists or A._parse_exists();I=A._parse_table_parts(schema=_C,is_db_reference=A._prev.token_type==TokenType.SCHEMA);J=A._parse_on_property()if A._match(TokenType.ON)else _A
		if A._match(TokenType.L_PAREN,advance=_B):D=A._parse_wrapped_csv(A._parse_types)
		else:D=_A
		return A.expression(exp.Drop,comments=C.comments,exists=H,this=I,expressions=D,kind=A.dialect.CREATABLE_KIND_MAPPING.get(B)or B,temporary=E,materialized=F,cascade=A._match_text_seq(_A6),constraints=A._match_text_seq('CONSTRAINTS'),purge=A._match_text_seq('PURGE'),cluster=J,concurrently=G)
	def _parse_exists(A,not_=_B):return A._match_text_seq('IF')and(not not_ or A._match(TokenType.NOT))and A._match(TokenType.EXISTS)
	def _parse_create(A):
		K='COLUMNSTORE';H=A._prev;R=A._prev_comments;S=H.token_type==TokenType.REPLACE or A._match_pair(TokenType.OR,TokenType.REPLACE)or A._match_pair(TokenType.OR,TokenType.ALTER);T=A._match_pair(TokenType.OR,TokenType.REFRESH);U=A._match(TokenType.UNIQUE)
		if A._match_text_seq(_AK,K):I=_C
		elif A._match_text_seq(_At,K)or A._match_text_seq(K):I=_B
		else:I=_A
		if A._match_pair(TokenType.TABLE,TokenType.FUNCTION,advance=_B):A._advance()
		E=_A;B=A._match_set(A.CREATABLES)and A._prev
		if not B:
			E=A._parse_properties();B=A._match_set(A.CREATABLES)and A._prev
			if not E or not B:return A._parse_as_command(H)
		V=A._match_text_seq(_B0);W=A._parse_exists(not_=_C);G=_A;C=_A;J=_A;L=_A;M=_A;N=_A;O=_A
		def D(temp_props):
			A=temp_props;nonlocal E
			if E and A:E.expressions.extend(A.expressions)
			elif A:E=A
		if B.token_type in(TokenType.FUNCTION,TokenType.PROCEDURE):
			G=A._parse_user_defined_function(kind=B.token_type);D(A._parse_properties());C=A._match(TokenType.ALIAS)and A._parse_heredoc();D(A._parse_properties())
			if not C:
				if A._match(TokenType.COMMAND):C=A._parse_as_command(A._prev)
				else:
					M=A._match(TokenType.BEGIN);X=A._match_text_seq('RETURN')
					if A._match(TokenType.STRING,advance=_B):C=A._parse_string();D(A._parse_properties())
					else:C=A._parse_statement()
					N=A._match_text_seq('END')
					if X:C=A.expression(exp.Return,this=C)
		elif B.token_type==TokenType.INDEX:
			if not A._match(TokenType.ON):F=A._parse_id_var();P=_B
			else:F=_A;P=_C
			G=A._parse_index(index=F,anonymous=P)
		elif B.token_type in A.DB_CREATABLES:
			Y=A._parse_table_parts(schema=_C,is_db_reference=B.token_type==TokenType.SCHEMA);A._match(TokenType.COMMA);D(A._parse_properties(before=_C));G=A._parse_schema(this=Y);D(A._parse_properties());A._match(TokenType.ALIAS)
			if not A._match_set(A.DDL_SELECT_TOKENS,advance=_B):D(A._parse_properties())
			if B.token_type==TokenType.SEQUENCE:C=A._parse_types();D(A._parse_properties())
			else:C=A._parse_ddl_select()
			if B.token_type==TokenType.TABLE:
				D(A._parse_properties());J=[]
				while _C:
					F=A._parse_index();D(A._parse_properties())
					if not F:break
					else:A._match(TokenType.COMMA);J.append(F)
			elif B.token_type==TokenType.VIEW:
				if A._match_text_seq(_E,_I,'SCHEMA','BINDING'):L=_C
			Z=A._match_text_seq('SHALLOW')
			if A._match_texts(A.CLONE_KEYWORDS):a=A._prev.text.lower()=='copy';O=A.expression(exp.Clone,this=A._parse_table(schema=_C),shallow=Z,copy=a)
		if A._curr and not A._match_set((TokenType.R_PAREN,TokenType.COMMA),advance=_B):return A._parse_as_command(H)
		Q=B.text.upper();return A.expression(exp.Create,comments=R,this=G,kind=A.dialect.CREATABLE_KIND_MAPPING.get(Q)or Q,replace=S,refresh=T,unique=U,expression=C,exists=W,properties=E,indexes=J,no_schema_binding=L,begin=M,end=N,clone=O,concurrently=V,clustered=I)
	def _parse_sequence_properties(A):
		B=exp.SequenceProperties();C=[];E=A._index
		while A._curr:
			A._match(TokenType.COMMA)
			if A._match_text_seq(_Aa):A._match_text_seq(_D);A._match_text_seq(_K);B.set(_Ab,A._parse_term())
			elif A._match_text_seq(_k):B.set('minvalue',A._parse_term())
			elif A._match_text_seq(_j):B.set('maxvalue',A._parse_term())
			elif A._match(TokenType.START_WITH)or A._match_text_seq(_Ac):A._match_text_seq(_K);B.set(_A7,A._parse_term())
			elif A._match_text_seq('CACHE'):B.set('cache',A._parse_number()or _C)
			elif A._match_text_seq('OWNED',_D):B.set('owned',_A if A._match_text_seq('NONE')else A._parse_column())
			else:
				D=A._parse_var_from_options(A.CREATE_SEQUENCE,raise_unmatched=_B)
				if D:C.append(D)
				else:break
		B.set('options',C if C else _A);return _A if A._index==E else B
	def _parse_property_before(A):
		A._match(TokenType.COMMA);B={'no':A._match_text_seq(_I),'dual':A._match_text_seq('DUAL'),'before':A._match_text_seq('BEFORE'),'default':A._match_text_seq(_W),'local':A._match_text_seq(_Q)and _Q or A._match_text_seq(_P,_Q)and'NOT LOCAL','after':A._match_text_seq(_Ad),'minimum':A._match_texts(('MIN','MINIMUM')),'maximum':A._match_texts(('MAX','MAXIMUM'))}
		if A._match_texts(A.PROPERTY_PARSERS):
			C=A.PROPERTY_PARSERS[A._prev.text.upper()]
			try:return C(A,**{B:A for(B,A)in B.items()if A})
			except TypeError:A.raise_error(f"Cannot parse property '{A._prev.text}'")
	def _parse_wrapped_properties(A):return A._parse_wrapped_csv(A._parse_property)
	def _parse_property(A):
		if A._match_texts(A.PROPERTY_PARSERS):return A.PROPERTY_PARSERS[A._prev.text.upper()](A)
		if A._match(TokenType.DEFAULT)and A._match_texts(A.PROPERTY_PARSERS):return A.PROPERTY_PARSERS[A._prev.text.upper()](A,default=_C)
		if A._match_text_seq('COMPOUND',_w):return A._parse_sortkey(compound=_C)
		if A._match_text_seq(_l,'SECURITY'):return A.expression(exp.SqlSecurityProperty,definer=A._match_text_seq(_AL))
		D=A._index;B=A._parse_column()
		if not A._match(TokenType.EQ):A._retreat(D);return A._parse_sequence_properties()
		if isinstance(B,exp.Column):B=B.to_dot()if len(B.parts)>1 else exp.var(B.name)
		C=A._parse_bitwise()or A._parse_var(any_token=_C)
		if isinstance(C,exp.Column):C=exp.var(C.name)
		return A.expression(exp.Property,this=B,value=C)
	def _parse_stored(A):A._match(TokenType.ALIAS);B=A._parse_string()if A._match_text_seq(_B1)else _A;C=A._parse_string()if A._match_text_seq('OUTPUTFORMAT')else _A;return A.expression(exp.FileFormatProperty,this=A.expression(exp.InputOutputFormat,input_format=B,output_format=C)if B or C else A._parse_var_or_string()or A._parse_number()or A._parse_id_var())
	def _parse_unquoted_field(B):
		A=B._parse_field()
		if isinstance(A,exp.Identifier)and not A.quoted:A=exp.var(A)
		return A
	def _parse_property_assignment(A,exp_class,**B):A._match(TokenType.EQ);A._match(TokenType.ALIAS);return A.expression(exp_class,this=A._parse_unquoted_field(),**B)
	def _parse_properties(A,before=_A):
		B=[]
		while _C:
			if before:C=A._parse_property_before()
			else:C=A._parse_property()
			if not C:break
			for D in ensure_list(C):B.append(D)
		if B:return A.expression(exp.Properties,expressions=B)
	def _parse_fallback(A,no=_B):return A.expression(exp.FallbackProperty,no=no,protection=A._match_text_seq('PROTECTION'))
	def _parse_security(A):
		if A._match_texts((_AL,'INVOKER')):B=A._prev.text.upper();return A.expression(exp.SecurityProperty,this=B)
	def _parse_settings_property(A):return A.expression(exp.SettingsProperty,expressions=A._parse_csv(A._parse_assignment))
	def _parse_volatile_property(A):
		if A._index>=2:B=A._tokens[A._index-2]
		else:B=_A
		if B and B.token_type in A.PRE_VOLATILE_TOKENS:return exp.VolatileProperty()
		return A.expression(exp.StabilityProperty,this=exp.Literal.string('VOLATILE'))
	def _parse_retention_period(A):B=A._parse_number();C=f"{B} "if B else'';D=A._parse_var(any_token=_C);return exp.var(f"{C}{D}")
	def _parse_system_versioning_property(A,with_=_B):
		A._match(TokenType.EQ);B=A.expression(exp.WithSystemVersioningProperty,**{_m:_C,_n:with_})
		if A._match_text_seq('OFF'):B.set(_m,_B);return B
		A._match(TokenType.ON)
		if A._match(TokenType.L_PAREN):
			while A._curr and not A._match(TokenType.R_PAREN):
				if A._match_text_seq('HISTORY_TABLE',_K):B.set(_N,A._parse_table_parts())
				elif A._match_text_seq('DATA_CONSISTENCY_CHECK',_K):B.set('data_consistency',A._advance_any()and A._prev.text.upper())
				elif A._match_text_seq('HISTORY_RETENTION_PERIOD',_K):B.set(_B2,A._parse_retention_period())
				A._match(TokenType.COMMA)
		return B
	def _parse_data_deletion_property(A):
		A._match(TokenType.EQ);C=A._match_text_seq(_J)or not A._match_text_seq('OFF');B=A.expression(exp.DataDeletionProperty,on=C)
		if A._match(TokenType.L_PAREN):
			while A._curr and not A._match(TokenType.R_PAREN):
				if A._match_text_seq('FILTER_COLUMN',_K):B.set('filter_column',A._parse_column())
				elif A._match_text_seq('RETENTION_PERIOD',_K):B.set(_B2,A._parse_retention_period())
				A._match(TokenType.COMMA)
		return B
	def _parse_distributed_property(A):
		F='RANDOM';E='HASH';B=E;C=_A
		if A._match_text_seq(_D,E):C=A._parse_wrapped_csv(A._parse_id_var)
		elif A._match_text_seq(_D,F):B=F
		D=_A
		if A._match_text_seq('BUCKETS')and not A._match_text_seq(_u):D=A._parse_number()
		return A.expression(exp.DistributedByProperty,expressions=C,kind=B,buckets=D,order=A._parse_order())
	def _parse_duplicate(A):A._match_text_seq(_o);B=A._parse_wrapped_csv(A._parse_id_var,optional=_B);return A.expression(exp.DuplicateKeyProperty,expressions=B)
	def _parse_with_property(A):
		if A._match_text_seq('(',_Ar):B=A._parse_system_versioning_property(with_=_C);A._match_r_paren();return B
		if A._match(TokenType.L_PAREN,advance=_B):return A._parse_wrapped_properties()
		if A._match_text_seq('JOURNAL'):return A._parse_withjournaltable()
		if A._match_texts(A.VIEW_ATTRIBUTES):return A.expression(exp.ViewAttributeProperty,this=A._prev.text.upper())
		if A._match_text_seq(_b):return A._parse_withdata(no=_B)
		elif A._match_text_seq(_I,_b):return A._parse_withdata(no=_C)
		if A._match(TokenType.SERDE_PROPERTIES,advance=_B):return A._parse_serde_properties(with_=_C)
		if A._match(TokenType.SCHEMA):return A.expression(exp.WithSchemaBindingProperty,this=A._parse_var_from_options(A.SCHEMA_BINDING_OPTIONS))
		if not A._next:return
		return A._parse_withisolatedloading()
	def _parse_definer(A):
		A._match(TokenType.EQ);B=A._parse_id_var();A._match(TokenType.PARAMETER);C=A._parse_id_var()or A._match(TokenType.MOD)and A._prev.text
		if not B or not C:return
		return exp.DefinerProperty(this=f"{B}@{C}")
	def _parse_withjournaltable(A):A._match(TokenType.TABLE);A._match(TokenType.EQ);return A.expression(exp.WithJournalTableProperty,this=A._parse_table_parts())
	def _parse_log(A,no=_B):return A.expression(exp.LogProperty,no=no)
	def _parse_journal(A,**B):return A.expression(exp.JournalProperty,**B)
	def _parse_checksum(A):
		A._match(TokenType.EQ);B=_A
		if A._match(TokenType.ON):B=_C
		elif A._match_text_seq('OFF'):B=_B
		return A.expression(exp.ChecksumProperty,on=B,default=A._match(TokenType.DEFAULT))
	def _parse_cluster(A,wrapped=_B):return A.expression(exp.Cluster,expressions=A._parse_wrapped_csv(A._parse_ordered)if wrapped else A._parse_csv(A._parse_ordered))
	def _parse_clustered_by(A):
		A._match_text_seq(_D);A._match_l_paren();C=A._parse_csv(A._parse_column);A._match_r_paren()
		if A._match_text_seq('SORTED',_D):A._match_l_paren();B=A._parse_csv(A._parse_ordered);A._match_r_paren()
		else:B=_A
		A._match(TokenType.INTO);D=A._parse_number();A._match_text_seq('BUCKETS');return A.expression(exp.ClusteredByProperty,expressions=C,sorted_by=B,buckets=D)
	def _parse_copy_property(A):
		if not A._match_text_seq('GRANTS'):A._retreat(A._index-1);return
		return A.expression(exp.CopyGrantsProperty)
	def _parse_freespace(A):A._match(TokenType.EQ);return A.expression(exp.FreespaceProperty,this=A._parse_number(),percent=A._match(TokenType.PERCENT))
	def _parse_mergeblockratio(A,no=_B,default=_B):
		if A._match(TokenType.EQ):return A.expression(exp.MergeBlockRatioProperty,this=A._parse_number(),percent=A._match(TokenType.PERCENT))
		return A.expression(exp.MergeBlockRatioProperty,no=no,default=default)
	def _parse_datablocksize(A,default=_A,minimum=_A,maximum=_A):
		A._match(TokenType.EQ);C=A._parse_number();B=_A
		if A._match_texts(('BYTES','KBYTES','KILOBYTES')):B=A._prev.text
		return A.expression(exp.DataBlocksizeProperty,size=C,units=B,default=default,minimum=minimum,maximum=maximum)
	def _parse_blockcompression(A):
		A._match(TokenType.EQ);C=A._match_text_seq('ALWAYS');D=A._match_text_seq('MANUAL');E=A._match_text_seq('NEVER');F=A._match_text_seq(_W);B=_A
		if A._match_text_seq('AUTOTEMP'):B=A._parse_schema()
		return A.expression(exp.BlockCompressionProperty,always=C,manual=D,never=E,default=F,autotemp=B)
	def _parse_withisolatedloading(A):
		B=A._index;C=A._match_text_seq(_I);D=A._match_text_seq('CONCURRENT')
		if not A._match_text_seq('ISOLATED','LOADING'):A._retreat(B);return
		E=A._parse_var_from_options(A.ISOLATED_LOADING_OPTIONS,raise_unmatched=_B);return A.expression(exp.IsolatedLoadingProperty,no=C,concurrent=D,target=E)
	def _parse_locking(A):
		F='VIEW'
		if A._match(TokenType.TABLE):C=_c
		elif A._match(TokenType.VIEW):C=F
		elif A._match(TokenType.ROW):C=_L
		elif A._match_text_seq(_A4):C=_A4
		else:C=_A
		if C in(_A4,_c,F):E=A._parse_table_parts()
		else:E=_A
		if A._match(TokenType.FOR):D=_M
		elif A._match(TokenType.IN):D=_p
		else:D=_A
		if A._match_text_seq(_Ae):B=_Ae
		elif A._match_texts(('EXCL',_AV)):B=_AV
		elif A._match_text_seq(_A8):B=_A8
		elif A._match_text_seq(_Y):B=_Y
		elif A._match_text_seq(_AW):B=_AW
		elif A._match_text_seq(_AJ):B=_AJ
		else:B=_A
		G=A._match_text_seq('OVERRIDE');return A.expression(exp.LockingProperty,this=E,kind=C,for_or_in=D,lock_type=B,override=G)
	def _parse_partition_by(A):
		if A._match(TokenType.PARTITION_BY):return A._parse_csv(A._parse_assignment)
		return[]
	def _parse_partition_bound_spec(A):
		def C():
			if A._match_text_seq(_k):return exp.var(_k)
			if A._match_text_seq(_j):return exp.var(_j)
			return A._parse_bitwise()
		B=_A;D=_A;E=_A;F=_A
		if A._match(TokenType.IN):B=A._parse_wrapped_csv(A._parse_bitwise)
		elif A._match(TokenType.FROM):E=A._parse_wrapped_csv(C);A._match_text_seq(_F);F=A._parse_wrapped_csv(C)
		elif A._match_text_seq(_E,'(','MODULUS'):B=A._parse_number();A._match_text_seq(',','REMAINDER');D=A._parse_number();A._match_r_paren()
		else:A.raise_error('Failed to parse partition bound spec.')
		return A.expression(exp.PartitionBoundSpec,this=B,expression=D,from_expressions=E,to_expressions=F)
	def _parse_partitioned_of(A):
		if not A._match_text_seq('OF'):A._retreat(A._index-1);return
		C=A._parse_table(schema=_C)
		if A._match(TokenType.DEFAULT):B=exp.var(_W)
		elif A._match_text_seq(_M,_A9):B=A._parse_partition_bound_spec()
		else:A.raise_error('Expecting either DEFAULT or FOR VALUES clause.')
		return A.expression(exp.PartitionedOfProperty,this=C,expression=B)
	def _parse_partitioned_by(A):A._match(TokenType.EQ);return A.expression(exp.PartitionedByProperty,this=A._parse_schema()or A._parse_bracket(A._parse_field()))
	def _parse_withdata(A,no=_B):
		C='STATISTICS'
		if A._match_text_seq('AND',C):B=_C
		elif A._match_text_seq('AND',_I,C):B=_B
		else:B=_A
		return A.expression(exp.WithDataProperty,no=no,statistics=B)
	def _parse_contains_property(A):
		if A._match_text_seq(_l):return A.expression(exp.SqlReadWriteProperty,this='CONTAINS SQL')
	def _parse_modifies_property(A):
		if A._match_text_seq(_l,_b):return A.expression(exp.SqlReadWriteProperty,this='MODIFIES SQL DATA')
	def _parse_no_property(A):
		if A._match_text_seq('PRIMARY','INDEX'):return exp.NoPrimaryIndexProperty()
		if A._match_text_seq(_l):return A.expression(exp.SqlReadWriteProperty,this='NO SQL')
	def _parse_on_property(A):
		B='COMMIT'
		if A._match_text_seq(B,'PRESERVE',_q):return exp.OnCommitProperty()
		if A._match_text_seq(B,_AS,_q):return exp.OnCommitProperty(delete=_C)
		return A.expression(exp.OnProperty,this=A._parse_schema(A._parse_id_var()))
	def _parse_reads_property(A):
		if A._match_text_seq(_l,_b):return A.expression(exp.SqlReadWriteProperty,this='READS SQL DATA')
	def _parse_distkey(A):return A.expression(exp.DistKeyProperty,this=A._parse_wrapped(A._parse_id_var))
	def _parse_create_like(A):
		D=A._parse_table(schema=_C);B=[]
		while A._match_texts(('INCLUDING','EXCLUDING')):
			E=A._prev.text.upper();C=A._parse_id_var()
			if not C:return
			B.append(A.expression(exp.Property,this=E,value=exp.var(C.this.upper())))
		return A.expression(exp.LikeProperty,this=D,expressions=B)
	def _parse_sortkey(A,compound=_B):return A.expression(exp.SortKeyProperty,this=A._parse_wrapped_id_vars(),compound=compound)
	def _parse_character_set(A,default=_B):A._match(TokenType.EQ);return A.expression(exp.CharacterSetProperty,this=A._parse_var_or_string(),default=default)
	def _parse_remote_with_connection(A):A._match_text_seq(_E,_B3);return A.expression(exp.RemoteWithConnectionModelProperty,this=A._parse_table_parts())
	def _parse_returns(A):
		B:0;C=_A;D=A._match(TokenType.TABLE)
		if D:
			if A._match(TokenType.LT):
				B=A.expression(exp.Schema,this=_c,expressions=A._parse_csv(A._parse_struct_types))
				if not A._match(TokenType.GT):A.raise_error(_B4)
			else:B=A._parse_schema(exp.var(_c))
		elif A._match_text_seq(_G,_J,_G,'INPUT'):C=_C;B=_A
		else:B=A._parse_types()
		return A.expression(exp.ReturnsProperty,this=B,is_table=D,null=C)
	def _parse_describe(A):
		D=A._match_set(A.CREATABLES)and A._prev.text;B=A._match_texts(('EXTENDED','FORMATTED','HISTORY'))and A._prev.text.upper()
		if A._match(TokenType.DOT):B=_A;A._retreat(A._index-2)
		E=A._parse_table(schema=_C);C=A._parse_properties();F=C.expressions if C else _A;G=A._parse_partition();return A.expression(exp.Describe,this=E,style=B,kind=D,expressions=F,partition=G)
	def _parse_multitable_inserts(A,comments):
		E=A._prev.text.upper();C=[]
		def D():
			if A._match(TokenType.WHEN):B=A._parse_disjunction();A._match(TokenType.THEN)
			else:B=_A
			C=A._match(TokenType.ELSE)
			if not A._match(TokenType.INTO):return
			return A.expression(exp.ConditionalInsert,this=A.expression(exp.Insert,this=A._parse_table(schema=_C),expression=A._parse_derived_table_values()),expression=B,else_=C)
		B=D()
		while B is not _A:C.append(B);B=D()
		return A.expression(exp.MultitableInserts,kind=E,comments=comments,expressions=C,source=A._parse_table())
	def _parse_insert(A):
		B=ensure_list(A._prev_comments);F=A._parse_hint();G=A._match(TokenType.OVERWRITE);H=A._match(TokenType.IGNORE);I=A._match_text_seq(_Q);D=_A;C=_A
		if A._match_text_seq('DIRECTORY'):E=A.expression(exp.Directory,this=A._parse_var_or_string(),local=I,row_format=A._parse_row_format(match_row=_C))
		else:
			if A._match_set((TokenType.FIRST,TokenType.ALL)):B+=ensure_list(A._prev_comments);return A._parse_multitable_inserts(B)
			if A._match(TokenType.OR):D=A._match_texts(A.INSERT_ALTERNATIVES)and A._prev.text
			A._match(TokenType.INTO);B+=ensure_list(A._prev_comments);A._match(TokenType.TABLE);C=A._match(TokenType.FUNCTION);E=A._parse_table(schema=_C,parse_partition=_C)if not C else A._parse_function()
		J=A._parse_returning();return A.expression(exp.Insert,comments=B,hint=F,is_function=C,this=E,stored=A._match_text_seq('STORED')and A._parse_stored(),by_name=A._match_text_seq(_D,'NAME'),exists=A._parse_exists(),where=A._match_pair(TokenType.REPLACE,TokenType.WHERE)and A._parse_assignment(),partition=A._match(TokenType.PARTITION_BY)and A._parse_partitioned_by(),settings=A._match_text_seq('SETTINGS')and A._parse_settings_property(),expression=A._parse_derived_table_values()or A._parse_ddl_select(),conflict=A._parse_on_conflict(),returning=J or A._parse_returning(),overwrite=G,alternative=D,ignore=H,source=A._match(TokenType.TABLE)and A._parse_table())
	def _parse_kill(A):B=exp.var(A._prev.text)if A._match_texts((_B3,_Af))else _A;return A.expression(exp.Kill,this=A._parse_primary(),kind=B)
	def _parse_on_conflict(A):
		B=A._match_text_seq(_J,'CONFLICT');C=A._match_text_seq(_J,_Ap,_o)
		if not B and not C:return
		D=_A;E=_A
		if B:
			if A._match_text_seq(_J,'CONSTRAINT'):E=A._parse_id_var()
			elif A._match(TokenType.L_PAREN):D=A._parse_csv(A._parse_id_var);A._match_r_paren()
		G=A._parse_var_from_options(A.CONFLICT_ACTIONS)
		if A._prev.token_type==TokenType.UPDATE:A._match(TokenType.SET);F=A._parse_csv(A._parse_equality)
		else:F=_A
		return A.expression(exp.OnConflict,duplicate=C,expressions=F,action=G,conflict_keys=D,constraint=E)
	def _parse_returning(A):
		if not A._match(TokenType.RETURNING):return
		return A.expression(exp.Returning,expressions=A._parse_csv(A._parse_expression),into=A._match(TokenType.INTO)and A._parse_table_part())
	def _parse_row(A):
		if not A._match(TokenType.FORMAT):return
		return A._parse_row_format()
	def _parse_serde_properties(A,with_=_B):
		B=with_;C=A._index;B=B or A._match_text_seq(_E)
		if not A._match(TokenType.SERDE_PROPERTIES):A._retreat(C);return
		return A.expression(exp.SerdeProperties,**{_H:A._parse_wrapped_properties(),_n:B})
	def _parse_row_format(A,match_row=_B):
		C='TERMINATED'
		if match_row and not A._match_pair(TokenType.ROW,TokenType.FORMAT):return
		if A._match_text_seq(_Ag):D=A._parse_string();E=A._parse_serde_properties();return A.expression(exp.RowFormatSerdeProperty,this=D,serde_properties=E)
		A._match_text_seq('DELIMITED');B={}
		if A._match_text_seq('FIELDS',C,_D):
			B['fields']=A._parse_string()
			if A._match_text_seq('ESCAPED',_D):B['escaped']=A._parse_string()
		if A._match_text_seq('COLLECTION','ITEMS',C,_D):B['collection_items']=A._parse_string()
		if A._match_text_seq('MAP','KEYS',C,_D):B['map_keys']=A._parse_string()
		if A._match_text_seq('LINES',C,_D):B['lines']=A._parse_string()
		if A._match_text_seq(_G,'DEFINED','AS'):B['null']=A._parse_string()
		return A.expression(exp.RowFormatDelimitedProperty,**B)
	def _parse_load(A):
		if A._match_text_seq(_b):B=A._match_text_seq(_Q);A._match_text_seq('INPATH');C=A._parse_string();D=A._match(TokenType.OVERWRITE);A._match_pair(TokenType.INTO,TokenType.TABLE);return A.expression(exp.LoadData,this=A._parse_table(schema=_C),local=B,overwrite=D,inpath=C,partition=A._parse_partition(),input_format=A._match_text_seq(_B1)and A._parse_string(),serde=A._match_text_seq(_Ag)and A._parse_string())
		return A._parse_as_command(A._prev)
	def _parse_delete(A):
		B=_A;C=A._prev_comments
		if not A._match(TokenType.FROM,advance=_B):B=A._parse_csv(A._parse_table)or _A
		D=A._parse_returning();return A.expression(exp.Delete,comments=C,tables=B,this=A._match(TokenType.FROM)and A._parse_table(joins=_C),using=A._match(TokenType.USING)and A._parse_table(joins=_C),cluster=A._match(TokenType.ON)and A._parse_on_property(),where=A._parse_where(),returning=D or A._parse_returning(),limit=A._parse_limit())
	def _parse_update(A):B=A._prev_comments;C=A._parse_table(joins=_C,alias_tokens=A.UPDATE_ALIAS_TOKENS);D=A._match(TokenType.SET)and A._parse_csv(A._parse_equality);E=A._parse_returning();return A.expression(exp.Update,comments=B,**{_N:C,_H:D,_d:A._parse_from(joins=_C),'where':A._parse_where(),'returning':E or A._parse_returning(),_AU:A._parse_order(),_h:A._parse_limit()})
	def _parse_uncache(A):
		if not A._match(TokenType.TABLE):A.raise_error('Expecting TABLE after UNCACHE')
		return A.expression(exp.Uncache,exists=A._parse_exists(),this=A._parse_table(schema=_C))
	def _parse_cache(A):
		C=A._match_text_seq('LAZY');A._match(TokenType.TABLE);D=A._parse_table(schema=_C);B=[]
		if A._match_text_seq('OPTIONS'):A._match_l_paren();E=A._parse_string();A._match(TokenType.EQ);F=A._parse_string();B=[E,F];A._match_r_paren()
		A._match(TokenType.ALIAS);return A.expression(exp.Cache,this=D,lazy=C,options=B,expression=A._parse_select(nested=_C))
	def _parse_partition(A):
		if not A._match(TokenType.PARTITION):return
		return A.expression(exp.Partition,expressions=A._parse_wrapped_csv(A._parse_assignment))
	def _parse_value(A):
		if A._match(TokenType.L_PAREN):C=A._parse_csv(A._parse_expression);A._match_r_paren();return A.expression(exp.Tuple,expressions=C)
		B=A._parse_expression()
		if B:return A.expression(exp.Tuple,expressions=[B])
	def _parse_projections(A):return A._parse_expressions()
	def _parse_select(A,nested=_B,table=_B,parse_subquery_alias=_C,parse_set_operation=_C):
		D=table;F=A._parse_with()
		if F:
			B=A._parse_statement()
			if not B:A.raise_error('Failed to parse any statement following CTE');return F
			if _n in B.arg_types:B.set(_n,F)
			else:A.raise_error(f"{B.key} does not support CTE");B=F
			return B
		C=A._parse_from()if A._match(TokenType.FROM,advance=_B)else _A
		if A._match(TokenType.SELECT):
			I=A._prev_comments;J=A._parse_hint()
			if A._next and not A._next.token_type==TokenType.DOT:G=A._match(TokenType.ALL);E=A._match_set(A.DISTINCT_TOKENS)
			else:G,E=_A,_A
			K=A._match(TokenType.ALIAS)and A._match_texts(('STRUCT',_A5))and A._prev.text.upper()
			if E:E=A.expression(exp.Distinct,on=A._parse_value()if A._match(TokenType.ON)else _A)
			if G and E:A.raise_error('Cannot specify both ALL and DISTINCT after SELECT')
			L=A._parse_limit(top=_C);M=A._parse_projections();B=A.expression(exp.Select,kind=K,hint=J,distinct=E,expressions=M,limit=L);B.comments=I;H=A._parse_into()
			if H:B.set('into',H)
			if not C:C=A._parse_from()
			if C:B.set(_d,C)
			B=A._parse_query_modifiers(B)
		elif(D or nested)and A._match(TokenType.L_PAREN):
			if A._match(TokenType.PIVOT):B=A._parse_simplified_pivot()
			elif A._match(TokenType.FROM):B=exp.select('*').from_(t.cast(exp.From,A._parse_from(skip_from_token=_C)))
			else:
				B=A._parse_table()if D else A._parse_select(nested=_C,parse_set_operation=_B)
				if D and isinstance(B,exp.Values)and B.alias:N=B.args[_O].pop();B=exp.Table(this=B,alias=N)
				B=A._parse_query_modifiers(A._parse_set_operations(B))
			A._match_r_paren();return A._parse_subquery(B,parse_alias=parse_subquery_alias)
		elif A._match(TokenType.VALUES,advance=_B):B=A._parse_derived_table_values()
		elif C:B=exp.select('*').from_(C.this,copy=_B)
		elif A._match(TokenType.SUMMARIZE):D=A._match(TokenType.TABLE);B=A._parse_select()or A._parse_string()or A._parse_table();return A.expression(exp.Summarize,this=B,table=D)
		elif A._match(TokenType.DESCRIBE):B=A._parse_describe()
		elif A._match_text_seq('STREAM'):B=A.expression(exp.Stream,this=A._parse_function())
		else:B=_A
		return A._parse_set_operations(B)if parse_set_operation else B
	def _parse_with(A,skip_with_token=_B):
		if not skip_with_token and not A._match(TokenType.WITH):return
		D=A._prev_comments;E=A._match(TokenType.RECURSIVE);B=_A;C=[]
		while _C:
			C.append(A._parse_cte())
			if B:C[-1].add_comments(B)
			if not A._match(TokenType.COMMA)and not A._match(TokenType.WITH):break
			else:A._match(TokenType.WITH)
			B=A._prev_comments
		return A.expression(exp.With,comments=D,expressions=C,recursive=E)
	def _parse_cte(A):
		B=A._parse_table_alias(A.ID_VAR_TOKENS)
		if not B or not B.this:A.raise_error('Expected CTE to have alias')
		A._match(TokenType.ALIAS);D=A._prev_comments
		if A._match_text_seq(_P,_U):C=_B
		elif A._match_text_seq(_U):C=_C
		else:C=_A
		return A.expression(exp.CTE,this=A._parse_wrapped(A._parse_statement),alias=B,materialized=C,comments=D)
	def _parse_table_alias(A,alias_tokens=_A):
		E=A._match(TokenType.ALIAS);B=A._parse_id_var(any_token=E,tokens=alias_tokens or A.TABLE_ALIAS_TOKENS)or A._parse_string_as_identifier();F=A._index
		if A._match(TokenType.L_PAREN):C=A._parse_csv(A._parse_function_parameter);A._match_r_paren()if C else A._retreat(F)
		else:C=_A
		if not B and not C:return
		D=A.expression(exp.TableAlias,this=B,columns=C)
		if isinstance(B,exp.Identifier):D.add_comments(B.pop_comments())
		return D
	def _parse_subquery(A,this,parse_alias=_C):
		if not this:return
		return A.expression(exp.Subquery,this=this,pivots=A._parse_pivots(),alias=A._parse_table_alias()if parse_alias else _A,sample=A._parse_table_sample())
	def _implicit_unnests_to_explicit(E,this):
		C=this;from sqlglot.optimizer.normalize_identifiers import normalize_identifiers as F;G={F(C.args[_d].this.copy(),dialect=E.dialect).alias_or_name}
		for(J,H)in enumerate(C.args.get(_AA)or[]):
			A=H.this;B=A.copy();B.meta['maybe_column']=_C;B=F(B,dialect=E.dialect)
			if isinstance(A,exp.Table)and not H.args.get(_m):
				if B.parts[0].name in G:
					D=A.to_column();I=exp.Unnest(expressions=[D])
					if isinstance(A.args.get(_O),exp.TableAlias):D.replace(D.this);exp.alias_(I,_A,table=[A.args[_O].this],copy=_B)
					A.replace(I)
			G.add(B.alias_or_name)
		return C
	def _parse_query_modifiers(B,this):
		A=this
		if isinstance(A,(exp.Query,exp.Table)):
			for F in B._parse_joins():A.append(_AA,F)
			for G in iter(B._parse_lateral,_A):A.append('laterals',G)
			while _C:
				if B._match_set(B.QUERY_MODIFIER_PARSERS,advance=_B):
					H=B.QUERY_MODIFIER_PARSERS[B._curr.token_type];E,C=H(B)
					if C:
						A.set(E,C)
						if E==_h:
							D=C.args.pop(_i,_A)
							if D:D=exp.Offset(expression=D);A.set(_i,D);I=C.expressions;C.set(_H,_A);D.set(_H,I)
						continue
				break
		if B.SUPPORTS_IMPLICIT_UNNEST and A and A.args.get(_d):A=B._implicit_unnests_to_explicit(A)
		return A
	def _parse_hint(A):
		if A._match(TokenType.HINT):
			B=[]
			for C in iter(lambda:A._parse_csv(lambda:A._parse_function()or A._parse_var(upper=_C)),[]):B.extend(C)
			if not A._match_pair(TokenType.STAR,TokenType.SLASH):A.raise_error('Expected */ after HINT')
			return A.expression(exp.Hint,expressions=B)
	def _parse_into(A):
		if not A._match(TokenType.INTO):return
		B=A._match(TokenType.TEMPORARY);C=A._match_text_seq(_AR);A._match(TokenType.TABLE);return A.expression(exp.Into,this=A._parse_table(schema=_C),temporary=B,unlogged=C)
	def _parse_from(A,joins=_B,skip_from_token=_B):
		if not skip_from_token and not A._match(TokenType.FROM):return
		return A.expression(exp.From,comments=A._prev_comments,this=A._parse_table(joins=joins))
	def _parse_match_recognize_measure(A):return A.expression(exp.MatchRecognizeMeasure,window_frame=A._match_texts(('FINAL','RUNNING'))and A._prev.text.upper(),this=A._parse_expression())
	def _parse_match_recognize(A):
		H='MATCHES';G='PER'
		if not A._match(TokenType.MATCH_RECOGNIZE):return
		A._match_l_paren();I=A._parse_partition_by();J=A._parse_order();K=A._parse_csv(A._parse_match_recognize_measure)if A._match_text_seq('MEASURES')else _A
		if A._match_text_seq('ONE',_L,G,_g):D=exp.var('ONE ROW PER MATCH')
		elif A._match_text_seq(_Z,_q,G,_g):
			B='ALL ROWS PER MATCH'
			if A._match_text_seq('SHOW',_T,H):B+=' SHOW EMPTY MATCHES'
			elif A._match_text_seq('OMIT',_T,H):B+=' OMIT EMPTY MATCHES'
			elif A._match_text_seq(_E,'UNMATCHED',_q):B+=' WITH UNMATCHED ROWS'
			D=exp.var(B)
		else:D=_A
		if A._match_text_seq(_Ad,_g,'SKIP'):
			B='AFTER MATCH SKIP'
			if A._match_text_seq('PAST',_AB,_L):B+=' PAST LAST ROW'
			elif A._match_text_seq(_F,'NEXT',_L):B+=' TO NEXT ROW'
			elif A._match_text_seq(_F,_AC):B+=f" TO FIRST {A._advance_any().text}"
			elif A._match_text_seq(_F,_AB):B+=f" TO LAST {A._advance_any().text}"
			E=exp.var(B)
		else:E=_A
		if A._match_text_seq('PATTERN'):
			A._match_l_paren()
			if not A._curr:A.raise_error(_Ah,A._curr)
			C=1;L=A._curr
			while A._curr and C>0:
				if A._curr.token_type==TokenType.L_PAREN:C+=1
				if A._curr.token_type==TokenType.R_PAREN:C-=1
				M=A._prev;A._advance()
			if C>0:A.raise_error(_Ah,A._curr)
			F=exp.var(A._find_sql(L,M))
		else:F=_A
		N=A._parse_csv(A._parse_name_as_expression)if A._match_text_seq('DEFINE')else _A;A._match_r_paren();return A.expression(exp.MatchRecognize,partition_by=I,order=J,measures=K,rows=D,after=E,pattern=F,define=N,alias=A._parse_table_alias())
	def _parse_lateral(A):
		C=A._match_pair(TokenType.CROSS,TokenType.APPLY)
		if not C and A._match_pair(TokenType.OUTER,TokenType.APPLY):C=_B
		if C is not _A:B=A._parse_select(table=_C);D=_A;F=_A
		elif A._match(TokenType.LATERAL):B=A._parse_select(table=_C);D=A._match(TokenType.VIEW);F=A._match(TokenType.OUTER)
		else:return
		if not B:
			B=A._parse_unnest()or A._parse_function()or A._parse_id_var(any_token=_B)
			while A._match(TokenType.DOT):B=exp.Dot(this=B,expression=A._parse_function()or A._parse_id_var(any_token=_B))
		if D:G=A._parse_id_var(any_token=_B);H=A._parse_csv(A._parse_id_var)if A._match(TokenType.ALIAS)else[];E=A.expression(exp.TableAlias,this=G,columns=H)
		elif isinstance(B,(exp.Subquery,exp.Unnest))and B.alias:E=B.args[_O].pop()
		else:E=A._parse_table_alias()
		return A.expression(exp.Lateral,this=B,view=D,outer=F,alias=E,cross_apply=C)
	def _parse_join_parts(A):return A._match_set(A.JOIN_METHODS)and A._prev,A._match_set(A.JOIN_SIDES)and A._prev,A._match_set(A.JOIN_KINDS)and A._prev
	def _parse_using_identifiers(B):
		def A():
			A=B._parse_column()
			if isinstance(A,exp.Column):return A.this
			return A
		return B._parse_wrapped_csv(A,optional=_C)
	def _parse_join(A,skip_join_token=_B,parse_bracket=_B):
		M='using';H=skip_join_token
		if A._match(TokenType.COMMA):return A.expression(exp.Join,this=A._parse_table())
		G=A._index;E,F,C=A._parse_join_parts();I=A._prev.text if A._match_texts(A.JOIN_HINTS)else _A;J=A._match(TokenType.JOIN)or C and C.token_type==TokenType.STRAIGHT_JOIN
		if not H and not J:A._retreat(G);C=_A;E=_A;F=_A
		K=A._match_pair(TokenType.OUTER,TokenType.APPLY,_B);L=A._match_pair(TokenType.CROSS,TokenType.APPLY,_B)
		if not H and not J and not K and not L:return
		B={_N:A._parse_table(parse_bracket=parse_bracket)}
		if E:B['method']=E.text
		if F:B[_AD]=F.text
		if C:B['kind']=C.text
		if I:B['hint']=I
		if A._match(TokenType.MATCH_CONDITION):B['match_condition']=A._parse_wrapped(A._parse_comparison)
		if A._match(TokenType.ON):B[_m]=A._parse_assignment()
		elif A._match(TokenType.USING):B[M]=A._parse_using_identifiers()
		elif not(K or L)and not isinstance(B[_N],exp.Unnest)and not(C and C.token_type==TokenType.CROSS):
			G=A._index;D=list(A._parse_joins())
			if D and A._match(TokenType.ON):B[_m]=A._parse_assignment()
			elif D and A._match(TokenType.USING):B[M]=A._parse_using_identifiers()
			else:D=_A;A._retreat(G)
			B[_N].set(_AA,D if D else _A)
		N=[B for A in(E,F,C)if A for B in A.comments];return A.expression(exp.Join,comments=N,**B)
	def _parse_opclass(A):
		B=A._parse_assignment()
		if A._match_texts(A.OPCLASS_FOLLOW_KEYWORDS,advance=_B):return B
		if not A._match_set(A.OPTYPE_FOLLOW_TOKENS,advance=_B):return A.expression(exp.Opclass,this=B,expression=A._parse_table_parts())
		return B
	def _parse_index_params(A):
		C=A._parse_var(any_token=_C)if A._match(TokenType.USING)else _A
		if A._match(TokenType.L_PAREN,advance=_B):B=A._parse_wrapped_csv(A._parse_with_operator)
		else:B=_A
		D=A._parse_wrapped_id_vars()if A._match_text_seq('INCLUDE')else _A;E=A._parse_partition_by();F=A._match(TokenType.WITH)and A._parse_wrapped_properties();G=A._parse_var(any_token=_C)if A._match_text_seq(_AQ,'INDEX',_B5)else _A;H=A._parse_where();I=A._parse_field()if A._match(TokenType.ON)else _A;return A.expression(exp.IndexParameters,using=C,columns=B,include=D,partition_by=E,where=H,with_storage=F,tablespace=G,on=I)
	def _parse_index(A,index=_A,anonymous=_B):
		B=index
		if B or anonymous:C=_A;D=_A;E=_A;A._match(TokenType.ON);A._match(TokenType.TABLE);F=A._parse_table_parts(schema=_C)
		else:
			C=A._match(TokenType.UNIQUE);D=A._match_text_seq('PRIMARY');E=A._match_text_seq('AMP')
			if not A._match(TokenType.INDEX):return
			B=A._parse_id_var();F=_A
		G=A._parse_index_params();return A.expression(exp.Index,this=B,table=F,unique=C,primary=D,amp=E,params=G)
	def _parse_table_hints(A):
		B=[]
		if A._match_pair(TokenType.WITH,TokenType.L_PAREN):B.append(A.expression(exp.WithTableHint,expressions=A._parse_csv(lambda:A._parse_function()or A._parse_var(any_token=_C))));A._match_r_paren()
		else:
			while A._match_set(A.TABLE_INDEX_HINT_TOKENS):
				C=exp.IndexTableHint(this=A._prev.text.upper());A._match_set((TokenType.INDEX,TokenType.KEY))
				if A._match(TokenType.FOR):C.set('target',A._advance_any()and A._prev.text.upper())
				C.set(_H,A._parse_wrapped_id_vars());B.append(C)
		return B or _A
	def _parse_table_part(A,schema=_B):return not schema and A._parse_function(optional_parens=_B)or A._parse_id_var(any_token=_B)or A._parse_string_as_identifier()or A._parse_placeholder()
	def _parse_table_parts(B,schema=_B,is_db_reference=_B,wildcard=_B):
		F=is_db_reference;E=schema;D=_A;C=_A;A=B._parse_table_part(schema=E)
		while B._match(TokenType.DOT):
			if D:A=B.expression(exp.Dot,this=A,expression=B._parse_table_part(schema=E))
			else:D=C;C=A;A=B._parse_table_part(schema=E)or''
		if wildcard and B._is_connected()and(isinstance(A,exp.Identifier)or not A)and B._match(TokenType.STAR):
			if isinstance(A,exp.Identifier):A.args[_N]+='*'
			else:A=exp.Identifier(this='*')
		J=A.pop_comments()if isinstance(A,exp.Expression)else _A
		if F:D=C;C=A;A=_A
		if not A and not F:B.raise_error(f"Expected table name but got {B._curr}")
		if not C and F:B.raise_error(f"Expected database name but got {B._curr}")
		A=B.expression(exp.Table,comments=J,this=A,db=C,catalog=D);G=B._parse_changes()
		if G:A.set('changes',G)
		H=B._parse_historical_data()
		if H:A.set('when',H)
		I=B._parse_pivots()
		if I:A.set(_r,I)
		return A
	def _parse_table(A,schema=_B,joins=_B,alias_tokens=_A,parse_bracket=_B,is_db_reference=_B,parse_partition=_B):
		G=schema;F=parse_partition;H=A._parse_lateral()
		if H:return H
		I=A._parse_unnest()
		if I:return I
		J=A._parse_derived_table_values()
		if J:return J
		C=A._parse_select(table=_C)
		if C:
			if not C.args.get(_r):C.set(_r,A._parse_pivots())
			return C
		D=parse_bracket and A._parse_bracket(_A);D=A.expression(exp.Table,this=D)if D else _A;E=A._match_text_seq(_q,'FROM')and A._parse_wrapped_csv(A._parse_table);E=A.expression(exp.Table,rows_from=E)if E else _A;K=A._match(TokenType.ONLY);B=t.cast(exp.Expression,D or E or A._parse_bracket(A._parse_table_parts(schema=G,is_db_reference=is_db_reference)))
		if K:B.set('only',K)
		A._match_text_seq('*');F=F or A.SUPPORTS_PARTITION_SELECTION
		if F and A._match(TokenType.PARTITION,advance=_B):B.set('partition',A._parse_partition())
		if G:return A._parse_schema(this=B)
		L=A._parse_version()
		if L:B.set('version',L)
		if A.dialect.ALIAS_POST_TABLESAMPLE:B.set(_A0,A._parse_table_sample())
		M=A._parse_table_alias(alias_tokens=alias_tokens or A.TABLE_ALIAS_TOKENS)
		if M:B.set(_O,M)
		if isinstance(B,exp.Table)and A._match_text_seq('AT'):return A.expression(exp.AtIndex,this=B.to_column(copy=_B),expression=A._parse_id_var())
		B.set('hints',A._parse_table_hints())
		if not B.args.get(_r):B.set(_r,A._parse_pivots())
		if not A.dialect.ALIAS_POST_TABLESAMPLE:B.set(_A0,A._parse_table_sample())
		if joins:
			for N in A._parse_joins():B.append(_AA,N)
		if A._match_pair(TokenType.WITH,TokenType.ORDINALITY):B.set('ordinality',_C);B.set(_O,A._parse_table_alias())
		return B
	def _parse_version(A):
		if A._match(TokenType.TIMESTAMP_SNAPSHOT):D=_Ay
		elif A._match(TokenType.VERSION_SNAPSHOT):D='VERSION'
		else:return
		if A._match_set((TokenType.FROM,TokenType.BETWEEN)):B=A._prev.text.upper();E=A._parse_bitwise();A._match_texts((_F,'AND'));F=A._parse_bitwise();C=A.expression(exp.Tuple,expressions=[E,F])
		elif A._match_text_seq('CONTAINED',_p):B='CONTAINED IN';C=A.expression(exp.Tuple,expressions=A._parse_wrapped_csv(A._parse_bitwise))
		elif A._match(TokenType.ALL):B=_Z;C=_A
		else:A._match_text_seq('AS','OF');B='AS OF';C=A._parse_type()
		return A.expression(exp.Version,this=D,expression=C,kind=B)
	def _parse_historical_data(A):
		D=A._index;B=_A
		if A._match_texts(A.HISTORICAL_DATA_PREFIX):
			E=A._prev.text.upper();F=A._match(TokenType.L_PAREN)and A._match_texts(A.HISTORICAL_DATA_KIND)and A._prev.text.upper();C=A._match(TokenType.FARROW)and A._parse_bitwise()
			if C:A._match_r_paren();B=A.expression(exp.HistoricalData,this=E,kind=F,expression=C)
			else:A._retreat(D)
		return B
	def _parse_changes(A):
		if not A._match_text_seq('CHANGES','(','INFORMATION','=>'):return
		B=A._parse_var(any_token=_C);A._match_r_paren();return A.expression(exp.Changes,information=B,at_before=A._parse_historical_data(),end=A._parse_historical_data())
	def _parse_unnest(A,with_alias=_C):
		if not A._match(TokenType.UNNEST):return
		D=A._parse_wrapped_csv(A._parse_equality);C=A._match_pair(TokenType.WITH,TokenType.ORDINALITY);B=A._parse_table_alias()if with_alias else _A
		if B:
			if A.dialect.UNNEST_COLUMN_ONLY:
				if B.args.get(_AE):A.raise_error('Unexpected extra column alias in unnest.')
				B.set(_AE,[B.this]);B.set(_N,_A)
			E=B.args.get(_AE)or[]
			if C and len(D)<len(E):C=E.pop()
		if not C and A._match_pair(TokenType.WITH,TokenType.OFFSET):A._match(TokenType.ALIAS);C=A._parse_id_var(any_token=_B,tokens=A.UNNEST_OFFSET_ALIAS_TOKENS)or exp.to_identifier(_i)
		return A.expression(exp.Unnest,expressions=D,alias=B,offset=C)
	def _parse_derived_table_values(A):
		B=A._match_pair(TokenType.L_PAREN,TokenType.VALUES)
		if not B and not(A._match_text_seq(_A9)or A._match_text_seq(_e,_A9)):return
		C=A._parse_csv(A._parse_value);D=A._parse_table_alias()
		if B:A._match_r_paren()
		return A.expression(exp.Values,expressions=C,alias=D or A._parse_table_alias())
	def _parse_table_sample(A,as_modifier=_B):
		if not A._match(TokenType.TABLE_SAMPLE)and not(as_modifier and A._match_text_seq(_AQ,'SAMPLE')):return
		G=_A;D=_A;H=_A;E=_A;I=_A;F=_A;B=A._parse_var(tokens=(TokenType.ROW,),upper=_C);K=A._match(TokenType.L_PAREN)
		if A.TABLESAMPLE_CSV:C=_A;J=A._parse_csv(A._parse_primary)
		else:J=_A;C=A._parse_factor()if A._match(TokenType.NUMBER,advance=_B)else A._parse_primary()or A._parse_placeholder()
		if A._match_text_seq('BUCKET'):G=A._parse_number();A._match_text_seq('OUT','OF');D=D=A._parse_number();A._match(TokenType.ON);H=A._parse_field()
		elif A._match_set((TokenType.PERCENT,TokenType.MOD)):E=C
		elif A._match(TokenType.ROWS)or not A.dialect.TABLESAMPLE_SIZE_IS_PERCENT:I=C
		else:E=C
		if K:A._match_r_paren()
		if A._match(TokenType.L_PAREN):B=A._parse_var(upper=_C);F=A._match(TokenType.COMMA)and A._parse_number();A._match_r_paren()
		elif A._match_texts(('SEED',_Aw)):F=A._parse_wrapped(A._parse_number)
		if not B and A.DEFAULT_SAMPLING_METHOD:B=exp.var(A.DEFAULT_SAMPLING_METHOD)
		return A.expression(exp.TableSample,expressions=J,method=B,bucket_numerator=G,bucket_denominator=D,bucket_field=H,percent=E,size=I,seed=F)
	def _parse_pivots(A):return list(iter(A._parse_pivot,_A))or _A
	def _parse_joins(A):return iter(A._parse_join,_A)
	def _parse_simplified_pivot(A):
		def B():B=A._parse_bitwise();return A._parse_in(B)if A._match(TokenType.IN)else B
		C=A._parse_table();D=A._match(TokenType.ON)and A._parse_csv(B);E=A._match(TokenType.USING)and A._parse_csv(lambda:A._parse_alias(A._parse_function()));F=A._parse_group();return A.expression(exp.Pivot,this=C,expressions=D,using=E,group=F)
	def _parse_pivot_in(A):
		def C():
			C=A._parse_select_or_expression();A._match(TokenType.ALIAS);B=A._parse_bitwise()
			if B:
				if isinstance(B,exp.Column)and not B.db:B=B.this
				return A.expression(exp.PivotAlias,this=C,alias=B)
			return C
		D=A._parse_column()
		if not A._match_pair(TokenType.IN,TokenType.L_PAREN):A.raise_error('Expecting IN (')
		if A._match(TokenType.ANY):B=ensure_list(exp.PivotAny(this=A._parse_order()))
		else:B=A._parse_csv(C)
		A._match_r_paren();return A.expression(exp.In,this=D,expressions=B)
	def _parse_pivot(A):
		J=A._index;G=_A
		if A._match(TokenType.PIVOT):D=_B
		elif A._match(TokenType.UNPIVOT):
			D=_C
			if A._match_text_seq('INCLUDE',_R):G=_C
			elif A._match_text_seq(_x,_R):G=_B
		else:return
		C=[]
		if not A._match(TokenType.L_PAREN):A._retreat(J);return
		if D:C=A._parse_csv(A._parse_column)
		else:C=A._parse_csv(lambda:A._parse_alias(A._parse_function()))
		if not C:A.raise_error("Failed to parse PIVOT's aggregation list")
		if not A._match(TokenType.FOR):A.raise_error('Expecting FOR')
		K=A._parse_pivot_in();L=A._match_text_seq(_W,_J,_G)and A._parse_wrapped(A._parse_bitwise);A._match_r_paren();E=A.expression(exp.Pivot,expressions=C,field=K,unpivot=D,include_nulls=G,default_on_null=L)
		if not A._match_set((TokenType.PIVOT,TokenType.UNPIVOT),advance=_B):E.set(_O,A._parse_table_alias())
		if not D:
			M=A._pivot_column_names(t.cast(t.List[exp.Expression],C));H=[]
			for I in E.args['field'].expressions:
				F=I.sql()if A.IDENTIFY_PIVOT_STRINGS else I.alias_or_name
				for B in M:
					if A.PREFIXED_PIVOT_COLUMNS:B=f"{B}_{F}"if B else F
					else:B=f"{F}_{B}"if B else F
					H.append(exp.to_identifier(B))
			E.set(_AE,H)
		return E
	def _pivot_column_names(A,aggregations):return[A.alias for A in aggregations]
	def _parse_prewhere(A,skip_where_token=_B):
		if not skip_where_token and not A._match(TokenType.PREWHERE):return
		return A.expression(exp.PreWhere,comments=A._prev_comments,this=A._parse_assignment())
	def _parse_where(A,skip_where_token=_B):
		if not skip_where_token and not A._match(TokenType.WHERE):return
		return A.expression(exp.Where,comments=A._prev_comments,this=A._parse_assignment())
	def _parse_group(A,skip_group_by_token=_B):
		E='all'
		if not skip_group_by_token and not A._match(TokenType.GROUP_BY):return
		B=defaultdict(list)
		if A._match(TokenType.ALL):B[E]=_C
		elif A._match(TokenType.DISTINCT):B[E]=_B
		while _C:
			F=A._index;B[_H].extend(A._parse_csv(lambda:_A if A._match_set((TokenType.CUBE,TokenType.ROLLUP),advance=_B)else A._parse_assignment()));C=A._index;D=A._match(TokenType.WITH)
			if A._match(TokenType.ROLLUP):B['rollup'].append(A._parse_cube_or_rollup(exp.Rollup,with_prefix=D))
			elif A._match(TokenType.CUBE):B['cube'].append(A._parse_cube_or_rollup(exp.Cube,with_prefix=D))
			elif A._match(TokenType.GROUPING_SETS):B['grouping_sets'].append(A.expression(exp.GroupingSets,expressions=A._parse_wrapped_csv(A._parse_grouping_set)))
			elif A._match_text_seq('TOTALS'):B['totals']=_C
			if C<=A._index<=C+1:A._retreat(C);break
			if F==A._index:break
		return A.expression(exp.Group,**B)
	def _parse_cube_or_rollup(A,kind,with_prefix=_B):return A.expression(kind,expressions=[]if with_prefix else A._parse_wrapped_csv(A._parse_column))
	def _parse_grouping_set(A):
		if A._match(TokenType.L_PAREN):B=A._parse_csv(A._parse_column);A._match_r_paren();return A.expression(exp.Tuple,expressions=B)
		return A._parse_column()
	def _parse_having(A,skip_having_token=_B):
		if not skip_having_token and not A._match(TokenType.HAVING):return
		return A.expression(exp.Having,this=A._parse_assignment())
	def _parse_qualify(A):
		if not A._match(TokenType.QUALIFY):return
		return A.expression(exp.Qualify,this=A._parse_assignment())
	def _parse_connect(A,skip_start_token=_B):
		C='PRIOR'
		if skip_start_token:B=_A
		elif A._match(TokenType.START_WITH):B=A._parse_assignment()
		else:return
		A._match(TokenType.CONNECT_BY);D=A._match_text_seq('NOCYCLE');A.NO_PAREN_FUNCTION_PARSERS[C]=lambda self:self.expression(exp.Prior,this=self._parse_bitwise());E=A._parse_assignment();A.NO_PAREN_FUNCTION_PARSERS.pop(C)
		if not B and A._match(TokenType.START_WITH):B=A._parse_assignment()
		return A.expression(exp.Connect,start=B,connect=E,nocycle=D)
	def _parse_name_as_expression(A):return A.expression(exp.Alias,alias=A._parse_id_var(any_token=_C),this=A._match(TokenType.ALIAS)and A._parse_assignment())
	def _parse_interpolate(A):
		if A._match_text_seq('INTERPOLATE'):return A._parse_wrapped_csv(A._parse_name_as_expression)
	def _parse_order(A,this=_A,skip_order_token=_B):
		B=_A
		if not skip_order_token and not A._match(TokenType.ORDER_BY):
			if not A._match(TokenType.ORDER_SIBLINGS_BY):return this
			B=_C
		return A.expression(exp.Order,this=this,expressions=A._parse_csv(A._parse_ordered),siblings=B)
	def _parse_sort(A,exp_class,token):
		if not A._match(token):return
		return A.expression(exp_class,expressions=A._parse_csv(A._parse_ordered))
	def _parse_ordered(A,parse_method=_A):
		H='nulls_are_small';D=parse_method;B=D()if D else A._parse_assignment()
		if not B:return
		if B.name.upper()==_Z and A.dialect.SUPPORTS_ORDER_BY_ALL:B=exp.var(_Z)
		I=A._match(TokenType.ASC);C=A._match(TokenType.DESC)or I and _B;E=A._match_text_seq(_R,_AC);J=A._match_text_seq(_R,_AB);F=E or _B;K=E or J
		if not K and(not C and A.dialect.NULL_ORDERING==H or C and A.dialect.NULL_ORDERING!=H)and A.dialect.NULL_ORDERING!='nulls_are_last':F=_C
		if A._match_text_seq(_E,'FILL'):G=A.expression(exp.WithFill,**{_d:A._match(TokenType.FROM)and A._parse_bitwise(),'to':A._match_text_seq(_F)and A._parse_bitwise(),'step':A._match_text_seq('STEP')and A._parse_bitwise(),'interpolate':A._parse_interpolate()})
		else:G=_A
		return A.expression(exp.Ordered,this=B,desc=C,nulls_first=F,with_fill=G)
	def _parse_limit(A,this=_A,top=_B,skip_limit_token=_B):
		if skip_limit_token or A._match(TokenType.TOP if top else TokenType.LIMIT):
			G=A._prev_comments
			if top:
				D=A._match(TokenType.L_PAREN);B=A._parse_term()if D else A._parse_number()
				if D:A._match_r_paren()
			else:B=A._parse_term()
			if A._match(TokenType.COMMA):E=B;B=A._parse_term()
			else:E=_A
			H=A.expression(exp.Limit,this=this,expression=B,offset=E,comments=G,expressions=A._parse_limit_by());return H
		if A._match(TokenType.FETCH):
			C=A._match_set((TokenType.FIRST,TokenType.NEXT));C=A._prev.text.upper()if C else _AC;I=A._parse_field(tokens=A.FETCH_TOKENS);J=A._match(TokenType.PERCENT);A._match_set((TokenType.ROW,TokenType.ROWS));K=A._match_text_seq('ONLY');F=A._match_text_seq(_E,'TIES')
			if K and F:A.raise_error('Cannot specify both ONLY and WITH TIES in FETCH clause')
			return A.expression(exp.Fetch,direction=C,count=I,percent=J,with_ties=F)
		return this
	def _parse_offset(A,this=_A):
		if not A._match(TokenType.OFFSET):return this
		B=A._parse_term();A._match_set((TokenType.ROW,TokenType.ROWS));return A.expression(exp.Offset,this=this,expression=B,expressions=A._parse_limit_by())
	def _parse_limit_by(A):return A._match_text_seq(_D)and A._parse_csv(A._parse_bitwise)
	def _parse_locks(A):
		C=[]
		while _C:
			if A._match_text_seq(_M,_AZ):D=_C
			elif A._match_text_seq(_M,_A8)or A._match_text_seq('LOCK',_p,_A8,'MODE'):D=_B
			else:break
			E=_A
			if A._match_text_seq('OF'):E=A._parse_csv(lambda:A._parse_table(schema=_C))
			B=_A
			if A._match_text_seq('NOWAIT'):B=_C
			elif A._match_text_seq('WAIT'):B=A._parse_primary()
			elif A._match_text_seq('SKIP','LOCKED'):B=_B
			C.append(A.expression(exp.Lock,update=D,expressions=E,wait=B))
		return C
	def _parse_set_operations(A,this):
		B=this
		while B and A._match_set(A.SET_OPERATIONS):
			F=A._prev.token_type
			if F==TokenType.UNION:C=exp.Union
			elif F==TokenType.EXCEPT:C=exp.Except
			else:C=exp.Intersect
			I=A._prev.comments
			if A._match(TokenType.DISTINCT):D=_C
			elif A._match(TokenType.ALL):D=_B
			else:
				D=A.dialect.SET_OP_DISTINCT_BY_DEFAULT[C]
				if D is _A:A.raise_error(f"Expected DISTINCT or ALL for {C.__name__}")
			J=A._match_text_seq(_D,'NAME');E=A._parse_select(nested=_C,parse_set_operation=_B);B=A.expression(C,comments=I,this=B,distinct=D,by_name=J,expression=E)
		if isinstance(B,exp.SetOperation)and A.MODIFIERS_ATTACHED_TO_SET_OP:
			E=B.expression
			if E:
				for G in A.SET_OP_MODIFIERS:
					H=E.args.get(G)
					if H:B.set(G,H.pop())
		return B
	def _parse_expression(A):return A._parse_alias(A._parse_assignment())
	def _parse_assignment(A):
		B=A._parse_disjunction()
		if not B and A._next and A._next.token_type in A.ASSIGNMENT:B=exp.column(t.cast(str,A._advance_any(ignore_reserved=_C)and A._prev.text))
		while A._match_set(A.ASSIGNMENT):
			if isinstance(B,exp.Column)and len(B.parts)==1:B=B.this
			B=A.expression(A.ASSIGNMENT[A._prev.token_type],this=B,comments=A._prev_comments,expression=A._parse_assignment())
		return B
	def _parse_disjunction(A):return A._parse_tokens(A._parse_conjunction,A.DISJUNCTION)
	def _parse_conjunction(A):return A._parse_tokens(A._parse_equality,A.CONJUNCTION)
	def _parse_equality(A):return A._parse_tokens(A._parse_comparison,A.EQUALITY)
	def _parse_comparison(A):return A._parse_tokens(A._parse_range,A.COMPARISON)
	def _parse_range(B,this=_A):
		A=this;A=A or B._parse_bitwise();D=B._match(TokenType.NOT)
		if B._match_set(B.RANGE_PARSERS):
			C=B.RANGE_PARSERS[B._prev.token_type](B,A)
			if not C:return A
			A=C
		elif B._match(TokenType.ISNULL):A=B.expression(exp.Is,this=A,expression=exp.Null())
		if B._match(TokenType.NOTNULL):A=B.expression(exp.Is,this=A,expression=exp.Null());A=B.expression(exp.Not,this=A)
		if D:A=B._negate_range(A)
		if B._match(TokenType.IS):A=B._parse_is(A)
		return A
	def _negate_range(B,this=_A):
		A=this
		if not A:return A
		return B.expression(exp.Not,this=A)
	def _parse_is(A,this):
		B=this;F=A._index-1;E=A._match(TokenType.NOT)
		if A._match_text_seq('DISTINCT','FROM'):G=exp.NullSafeEQ if E else exp.NullSafeNEQ;return A.expression(G,this=B,expression=A._parse_bitwise())
		if A._match(TokenType.JSON):
			H=A._match_texts(A.IS_JSON_PREDICATE_KIND)and A._prev.text.upper()
			if A._match_text_seq(_E):C=_C
			elif A._match_text_seq(_AF):C=_B
			else:C=_A
			I=A._match(TokenType.UNIQUE);A._match_text_seq('KEYS');D=A.expression(exp.JSON,**{_N:H,_n:C,'unique':I})
		else:
			D=A._parse_primary()or A._parse_null()
			if not D:A._retreat(F);return
		B=A.expression(exp.Is,this=B,expression=D);return A.expression(exp.Not,this=B)if E else B
	def _parse_in(A,this,alias=_B):
		B=this;D=A._parse_unnest(with_alias=_B)
		if D:B=A.expression(exp.In,this=B,unnest=D)
		elif A._match_set((TokenType.L_PAREN,TokenType.L_BRACKET)):
			E=A._prev.token_type==TokenType.L_PAREN;C=A._parse_csv(lambda:A._parse_select_or_expression(alias=alias))
			if len(C)==1 and isinstance(C[0],exp.Query):B=A.expression(exp.In,this=B,query=C[0].subquery(copy=_B))
			else:B=A.expression(exp.In,this=B,expressions=C)
			if E:A._match_r_paren(B)
			elif not A._match(TokenType.R_BRACKET,expression=B):A.raise_error('Expecting ]')
		else:B=A.expression(exp.In,this=B,field=A._parse_field())
		return B
	def _parse_between(A,this):B=A._parse_bitwise();A._match(TokenType.AND);C=A._parse_bitwise();return A.expression(exp.Between,this=this,low=B,high=C)
	def _parse_escape(A,this):
		if not A._match(TokenType.ESCAPE):return this
		return A.expression(exp.Escape,this=this,expression=A._parse_string())
	def _parse_interval(A,match_interval=_C):
		D=A._index
		if not A._match(TokenType.INTERVAL)and match_interval:return
		if A._match(TokenType.STRING,advance=_B):B=A._parse_primary()
		else:B=A._parse_term()
		if not B or isinstance(B,exp.Column)and not B.table and not B.this.quoted and B.name.upper()=='IS':A._retreat(D);return
		C=A._parse_function()or not A._match(TokenType.ALIAS,advance=_B)and A._parse_var(any_token=_C,upper=_C)
		if B and B.is_number:B=exp.Literal.string(B.to_py())
		elif B and B.is_string:
			E=exp.INTERVAL_STRING_RE.findall(B.name)
			if len(E)==1:
				if C:A._retreat(A._index-1)
				B=exp.Literal.string(E[0][0]);C=A.expression(exp.Var,this=E[0][1].upper())
		if A.INTERVAL_SPANS and A._match_text_seq(_F):C=A.expression(exp.IntervalSpan,this=C,expression=A._parse_var(any_token=_C,upper=_C))
		F=A.expression(exp.Interval,this=B,unit=C);D=A._index;A._match(TokenType.PLUS)
		if A._match_set((TokenType.STRING,TokenType.NUMBER),advance=_B):return A.expression(exp.Add,this=F,expression=A._parse_interval(match_interval=_B))
		A._retreat(D);return F
	def _parse_bitwise(A):
		B=A._parse_term()
		while _C:
			if A._match_set(A.BITWISE):B=A.expression(A.BITWISE[A._prev.token_type],this=B,expression=A._parse_term())
			elif A.dialect.DPIPE_IS_STRING_CONCAT and A._match(TokenType.DPIPE):B=A.expression(exp.DPipe,this=B,expression=A._parse_term(),safe=not A.dialect.STRICT_STRING_CONCAT)
			elif A._match(TokenType.DQMARK):B=A.expression(exp.Coalesce,this=B,expressions=ensure_list(A._parse_term()))
			elif A._match_pair(TokenType.LT,TokenType.LT):B=A.expression(exp.BitwiseLeftShift,this=B,expression=A._parse_term())
			elif A._match_pair(TokenType.GT,TokenType.GT):B=A.expression(exp.BitwiseRightShift,this=B,expression=A._parse_term())
			else:break
		return B
	def _parse_term(A):
		B=A._parse_factor()
		while A._match_set(A.TERM):
			E=A.TERM[A._prev.token_type];F=A._prev_comments;G=A._parse_factor();B=A.expression(E,this=B,comments=F,expression=G)
			if isinstance(B,exp.Collate):
				D=B.expression
				if isinstance(D,exp.Column)and len(D.parts)==1:
					C=D.this
					if isinstance(C,exp.Identifier):B.set(_s,C if C.quoted else exp.var(C.name))
		return B
	def _parse_factor(A):
		C=A._parse_exponent if A.EXPONENT else A._parse_unary;B=C()
		while A._match_set(A.FACTOR):
			D=A.FACTOR[A._prev.token_type];F=A._prev_comments;E=C()
			if not E and D is exp.IntDiv and A._prev.text.isalpha():A._retreat(A._index-1);return B
			B=A.expression(D,this=B,comments=F,expression=E)
			if isinstance(B,exp.Div):B.args['typed']=A.dialect.TYPED_DIVISION;B.args['safe']=A.dialect.SAFE_DIVISION
		return B
	def _parse_exponent(A):return A._parse_tokens(A._parse_unary,A.EXPONENT)
	def _parse_unary(A):
		if A._match_set(A.UNARY_PARSERS):return A.UNARY_PARSERS[A._prev.token_type](A)
		return A._parse_at_time_zone(A._parse_type())
	def _parse_type(A,parse_interval=_C,fallback_to_identifier=_B):
		D=parse_interval and A._parse_interval()
		if D:return D
		E=A._index;B=A._parse_types(check_func=_C,allow_identifiers=_B)
		if isinstance(B,exp.Cast):return A._parse_column_ops(B)
		if B:
			F=A._index;C=A._parse_primary()
			if isinstance(C,exp.Literal):
				G=A.TYPE_LITERAL_PARSERS.get(B.this)
				if G:return G(A,C,B)
				return A.expression(exp.Cast,this=C,to=B)
			if B.expressions and F-E>1:A._retreat(F);return A._parse_column_ops(B)
			A._retreat(E)
		if fallback_to_identifier:return A._parse_id_var()
		C=A._parse_column();return C and A._parse_column_ops(C)
	def _parse_type_size(B):
		A=B._parse_type()
		if not A:return
		if isinstance(A,exp.Column)and not A.table:A=exp.var(A.name.upper())
		return B.expression(exp.DataTypeParam,this=A,expression=B._parse_var(any_token=_C))
	def _parse_types(A,check_func=_B,schema=_B,allow_identifiers=_C):
		H=allow_identifiers;G=schema;F=check_func;I=A._index;B=_A;Q=A._match_text_seq('SYSUDTLIB','.')
		if not A._match_set(A.TYPE_TOKENS):
			M=H and A._parse_id_var(any_token=_B,tokens=(TokenType.VAR,))
			if isinstance(M,exp.Identifier):
				N=A.dialect.tokenize(M.sql(dialect=A.dialect))
				if len(N)!=1:A.raise_error('Unexpected identifier',A._prev)
				if N[0].token_type in A.TYPE_TOKENS:A._prev=N[0]
				elif A.dialect.SUPPORTS_USER_DEFINED_TYPES:
					O=M.name
					while A._match(TokenType.DOT):O=f"{O}.{A._advance_any()and A._prev.text}"
					B=exp.DataType.build(O,udt=_C)
				else:A._retreat(A._index-1);return
			else:return
		D=A._prev.token_type
		if D==TokenType.PSEUDO_TYPE:return A.expression(exp.PseudoType,this=A._prev.text.upper())
		if D==TokenType.OBJECT_IDENTIFIER:return A.expression(exp.ObjectIdentifier,this=A._prev.text.upper())
		if D==TokenType.MAP and A._match(TokenType.L_BRACKET):
			V=A._parse_types(check_func=F,schema=G,allow_identifiers=H)
			if not A._match(TokenType.FARROW):A._retreat(I);return
			W=A._parse_types(check_func=F,schema=G,allow_identifiers=H)
			if not A._match(TokenType.R_BRACKET):A._retreat(I);return
			return exp.DataType(this=exp.DataType.Type.MAP,expressions=[V,W],nested=_C,prefix=Q)
		P=D in A.NESTED_TYPE_TOKENS;K=D in A.STRUCT_TYPE_TOKENS;X=D in A.AGGREGATE_TYPE_TOKENS;C=_A;J=_B
		if A._match(TokenType.L_PAREN):
			if K:C=A._parse_csv(lambda:A._parse_struct_types(type_required=_C))
			elif P:
				C=A._parse_csv(lambda:A._parse_types(check_func=F,schema=G,allow_identifiers=H))
				if D==TokenType.NULLABLE and len(C)==1:B=C[0];B.set('nullable',_C);A._match_r_paren();return B
			elif D in A.ENUM_TYPE_TOKENS:C=A._parse_csv(A._parse_equality)
			elif X:
				R=A._parse_function(anonymous=_C)or A._parse_id_var(any_token=_B,tokens=(TokenType.VAR,))
				if not R or not A._match(TokenType.COMMA):return
				C=A._parse_csv(lambda:A._parse_types(check_func=F,schema=G,allow_identifiers=H));C.insert(0,R)
			else:
				C=A._parse_csv(A._parse_type_size)
				if D==TokenType.VECTOR and len(C)==2:C[0]=exp.DataType.build(C[0].name,dialect=A.dialect)
			if not C or not A._match(TokenType.R_PAREN):A._retreat(I);return
			J=_C
		E=_A
		if P and A._match(TokenType.LT):
			if K:C=A._parse_csv(lambda:A._parse_struct_types(type_required=_C))
			else:C=A._parse_csv(lambda:A._parse_types(check_func=F,schema=G,allow_identifiers=H))
			if not A._match(TokenType.GT):A.raise_error(_B4)
			if A._match_set((TokenType.L_BRACKET,TokenType.L_PAREN)):
				E=A._parse_csv(A._parse_assignment)
				if not E and K:E=_A;A._retreat(A._index-1)
				else:A._match_set((TokenType.R_BRACKET,TokenType.R_PAREN))
		if D in A.TIMESTAMPS:
			if A._match_text_seq(_E,_AG,_AH):J=_B;Y=exp.DataType.Type.TIMETZ if D in A.TIMES else exp.DataType.Type.TIMESTAMPTZ;B=exp.DataType(this=Y,expressions=C)
			elif A._match_text_seq(_E,_Q,_AG,_AH):J=_B;B=exp.DataType(this=exp.DataType.Type.TIMESTAMPLTZ,expressions=C)
			elif A._match_text_seq(_AF,_AG,_AH):J=_B
		elif D==TokenType.INTERVAL:
			L=A._parse_var(upper=_C)
			if L:
				if A._match_text_seq(_F):L=exp.IntervalSpan(this=L,expression=A._parse_var(upper=_C))
				B=A.expression(exp.DataType,this=A.expression(exp.Interval,unit=L))
			else:B=A.expression(exp.DataType,this=exp.DataType.Type.INTERVAL)
		if J and F:
			Z=A._index;a=A._parse_string()
			if not a:A._retreat(I);return
			A._retreat(Z)
		if not B:
			if A._match_text_seq('UNSIGNED'):
				S=A.SIGNED_TO_UNSIGNED_TYPE_TOKEN.get(D)
				if not S:A.raise_error(f"Cannot convert {D.value} to unsigned.")
				D=S or D
			B=exp.DataType(this=exp.DataType.Type[D.value],expressions=C,nested=P,prefix=Q)
			if E is not _A:b=exp.Struct if K else exp.Array;B=exp.cast(b(expressions=E),B,copy=_B)
		elif C:B.set(_H,C)
		while A._match(TokenType.LIST):B=exp.DataType(this=exp.DataType.Type.LIST,expressions=[B],nested=_C)
		I=A._index;T=A._match(TokenType.ARRAY)
		while A._curr:
			c=A._prev.token_type;d=A._match(TokenType.L_BRACKET)
			if not d and not T:break
			T=_B;E=A._parse_csv(A._parse_assignment)or _A
			if E and not G and(not A.dialect.SUPPORTS_FIXED_SIZE_ARRAYS or c==TokenType.ARRAY):A._retreat(I);break
			B=exp.DataType(this=exp.DataType.Type.ARRAY,expressions=[B],values=E,nested=_C);A._match(TokenType.R_BRACKET)
		if A.TYPE_CONVERTERS and isinstance(B.this,exp.DataType.Type):
			U=A.TYPE_CONVERTERS.get(B.this)
			if U:B=U(t.cast(exp.DataType,B))
		return B
	def _parse_struct_types(A,type_required=_B):
		C=A._index
		if A._curr and A._next and A._curr.token_type in A.TYPE_TOKENS and A._next.token_type in A.TYPE_TOKENS:B=A._parse_id_var()
		else:B=A._parse_type(parse_interval=_B,fallback_to_identifier=_C)or A._parse_id_var()
		A._match(TokenType.COLON)
		if type_required and not isinstance(B,exp.DataType)and not A._match_set(A.TYPE_TOKENS,advance=_B):A._retreat(C);return A._parse_types()
		return A._parse_column_def(B)
	def _parse_at_time_zone(A,this):
		if not A._match_text_seq('AT',_AG,_AH):return this
		return A.expression(exp.AtTimeZone,this=this,zone=A._parse_unary())
	def _parse_column(A):
		B=A._parse_column_reference();C=A._parse_column_ops(B)if B else A._parse_bracket(B)
		if A.dialect.SUPPORTS_COLUMN_JOIN_MARKS and C:C.set('join_mark',A._match(TokenType.JOIN_MARKER))
		return C
	def _parse_column_reference(A):
		B=A._parse_field()
		if not B and A._match(TokenType.VALUES,advance=_B)and A.VALUES_FOLLOWED_BY_PAREN and(not A._next or A._next.token_type!=TokenType.L_PAREN):B=A._parse_id_var()
		if isinstance(B,exp.Identifier):B=A.expression(exp.Column,comments=B.pop_comments(),this=B)
		return B
	def _parse_colon_as_variant_extract(A,this):
		C=this;D=[];E=[];H=_A
		while A._match(TokenType.COLON):
			F=A._index;B=A._parse_column_ops(A._parse_field(any_token=_C,tokens=(TokenType.SELECT,)))
			while isinstance(B,exp.Cast):D.append(B.to);B=B.this
			if D:J=next(A for(A,B)in enumerate(A._tokens[F:])if B.token_type==TokenType.DCOLON);I=A._tokens[F+J-1]
			else:I=A._prev
			if B:
				if isinstance(B,exp.Identifier)and B.quoted:H=_C
				E.append(A._find_sql(A._tokens[F],I))
		if E:
			G=A.dialect.to_json_path(exp.Literal.string('.'.join(E)))
			if G:G.set('escape',H)
			C=A.expression(exp.JSONExtract,this=C,expression=G,variant_extract=_C)
			while D:C=A.expression(exp.Cast,this=C,to=D.pop())
		return C
	def _parse_dcolon(A):return A._parse_types()
	def _parse_column_ops(B,this):
		F='table';A=this;A=B._parse_bracket(A)
		while B._match_set(B.COLUMN_OPERATORS):
			E=B._prev.token_type;D=B.COLUMN_OPERATORS.get(E)
			if E==TokenType.DCOLON:
				C=B._parse_dcolon()
				if not C:B.raise_error('Expected type')
			elif D and B._curr:C=B._parse_column_reference()or B._parse_bracket()
			else:C=B._parse_field(any_token=_C,anonymous_func=_C)
			if isinstance(C,exp.Func)and A:A=exp.replace_tree(A,lambda n:(B.expression(exp.Dot,this=n.args.get(F),expression=n.this)if n.table else n.this)if isinstance(n,exp.Column)else n)
			if D:A=D(B,A,C)
			elif isinstance(A,exp.Column)and not A.args.get('catalog'):A=B.expression(exp.Column,comments=A.comments,this=C,table=A.this,db=A.args.get(F),catalog=A.args.get('db'))
			else:A=B.expression(exp.Dot,this=A,expression=C)
			A=B._parse_bracket(A)
		return B._parse_colon_as_variant_extract(A)if B.COLON_IS_VARIANT_EXTRACT else A
	def _parse_primary(A):
		if A._match_set(A.PRIMARY_PARSERS):
			D=A._prev.token_type;E=A.PRIMARY_PARSERS[D](A,A._prev)
			if D==TokenType.STRING:
				C=[E]
				while A._match(TokenType.STRING):C.append(exp.Literal.string(A._prev.text))
				if len(C)>1:return A.expression(exp.Concat,expressions=C)
			return E
		if A._match_pair(TokenType.DOT,TokenType.NUMBER):return exp.Literal.number(f"0.{A._prev.text}")
		if A._match(TokenType.L_PAREN):
			G=A._prev_comments;F=A._parse_select()
			if F:C=[F]
			else:C=A._parse_expressions()
			B=A._parse_query_modifiers(seq_get(C,0))
			if not B and A._match(TokenType.R_PAREN,advance=_B):B=A.expression(exp.Tuple)
			elif isinstance(B,exp.UNWRAPPED_QUERIES):B=A._parse_subquery(this=B,parse_alias=_B)
			elif isinstance(B,exp.Subquery):B=A._parse_subquery(this=A._parse_set_operations(B),parse_alias=_B)
			elif len(C)>1 or A._prev.token_type==TokenType.COMMA:B=A.expression(exp.Tuple,expressions=C)
			else:B=A.expression(exp.Paren,this=B)
			if B:B.add_comments(G)
			A._match_r_paren(expression=B);return B
	def _parse_field(A,any_token=_B,tokens=_A,anonymous_func=_B):
		C=anonymous_func;B=any_token
		if C:D=A._parse_function(anonymous=C,any_token=B)or A._parse_primary()
		else:D=A._parse_primary()or A._parse_function(anonymous=C,any_token=B)
		return D or A._parse_id_var(any_token=B,tokens=tokens)
	def _parse_function(A,functions=_A,anonymous=_B,optional_parens=_C,any_token=_B):
		B=_B
		if A._match(TokenType.L_BRACE,advance=_B)and A._next and A._next.text.upper()=='FN':A._advance(2);B=_C
		C=A._parse_function_call(functions=functions,anonymous=anonymous,optional_parens=optional_parens,any_token=any_token)
		if B:A._match(TokenType.R_BRACE)
		return C
	def _parse_function_call(A,functions=_A,anonymous=_B,optional_parens=_C,any_token=_B):
		K=optional_parens;J=anonymous;I=functions
		if not A._curr:return
		L=A._curr.comments;C=A._curr.token_type;B=A._curr.text;G=B.upper();E=A.NO_PAREN_FUNCTION_PARSERS.get(G)
		if K and E and C not in A.INVALID_FUNC_NAME_TOKENS:A._advance();return A._parse_window(E(A))
		if not A._next or A._next.token_type!=TokenType.L_PAREN:
			if K and C in A.NO_PAREN_FUNCTIONS:A._advance();return A.expression(A.NO_PAREN_FUNCTIONS[C])
			return
		if any_token:
			if C in A.RESERVED_TOKENS:return
		elif C not in A.FUNC_TOKENS:return
		A._advance(2);E=A.FUNCTION_PARSERS.get(G)
		if E and not J:B=E(A)
		else:
			M=A.SUBQUERY_PREDICATES.get(C)
			if M and A._curr.token_type in(TokenType.SELECT,TokenType.WITH):B=A.expression(M,comments=L,this=A._parse_select());A._match_r_paren();return B
			if I is _A:I=A.FUNCTIONS
			H=I.get(G);N=G in A.FUNCTIONS_WITH_ALIASED_ARGS;D=A._parse_csv(lambda:A._parse_lambda(alias=N))
			if N:D=A._kv_to_prop_eq(D)
			if H and not J:
				if'dialect'in H.__code__.co_varnames:F=H(D,dialect=A.dialect)
				else:F=H(D)
				F=A.validate_expression(F,D)
				if not A.dialect.NORMALIZE_FUNCTIONS:F.meta['name']=B
				B=F
			else:
				if C==TokenType.IDENTIFIER:B=exp.Identifier(this=B,quoted=_C)
				B=A.expression(exp.Anonymous,this=B,expressions=D)
		if isinstance(B,exp.Expression):B.add_comments(L)
		A._match_r_paren(B);return A._parse_window(B)
	def _to_prop_eq(A,expression,index):return expression
	def _kv_to_prop_eq(B,expressions):
		C=[]
		for(D,A)in enumerate(expressions):
			if isinstance(A,B.KEY_VALUE_DEFINITIONS):
				if isinstance(A,exp.Alias):A=B.expression(exp.PropertyEQ,this=A.args.get(_O),expression=A.this)
				if not isinstance(A,exp.PropertyEQ):A=B.expression(exp.PropertyEQ,this=exp.to_identifier(A.this.name),expression=A.expression)
				if isinstance(A.this,exp.Column):A.this.replace(A.this.this)
			else:A=B._to_prop_eq(A,D)
			C.append(A)
		return C
	def _parse_function_parameter(A):return A._parse_column_def(A._parse_id_var())
	def _parse_user_defined_function(A,kind=_A):
		B=A._parse_id_var()
		while A._match(TokenType.DOT):B=A.expression(exp.Dot,this=B,expression=A._parse_id_var())
		if not A._match(TokenType.L_PAREN):return B
		C=A._parse_csv(A._parse_function_parameter);A._match_r_paren();return A.expression(exp.UserDefinedFunction,this=B,expressions=C,wrapped=_C)
	def _parse_introducer(A,token):
		B=token;C=A._parse_primary()
		if C:return A.expression(exp.Introducer,this=B.text,expression=C)
		return A.expression(exp.Identifier,this=B.text)
	def _parse_session_parameter(A):
		C=_A;B=A._parse_id_var()or A._parse_primary()
		if B and A._match(TokenType.DOT):C=B.name;B=A._parse_var()or A._parse_primary()
		return A.expression(exp.SessionParameter,this=B,kind=C)
	def _parse_lambda_arg(A):return A._parse_id_var()
	def _parse_lambda(A,alias=_B):
		C=A._index
		if A._match(TokenType.L_PAREN):
			D=t.cast(t.List[t.Optional[exp.Expression]],A._parse_csv(A._parse_lambda_arg))
			if not A._match(TokenType.R_PAREN):A._retreat(C)
		else:D=[A._parse_lambda_arg()]
		if A._match_set(A.LAMBDAS):return A.LAMBDAS[A._prev.token_type](A,D)
		A._retreat(C);B:0
		if A._match(TokenType.DISTINCT):B=A.expression(exp.Distinct,expressions=A._parse_csv(A._parse_assignment))
		else:B=A._parse_select_or_expression(alias=alias)
		return A._parse_limit(A._parse_order(A._parse_having_max(A._parse_respect_or_ignore_nulls(B))))
	def _parse_schema(A,this=_A):
		B=this;C=A._index
		if not A._match(TokenType.L_PAREN):return B
		if A._match_set(A.SELECT_START_TOKENS):A._retreat(C);return B
		D=A._parse_csv(lambda:A._parse_constraint()or A._parse_field_def());A._match_r_paren();return A.expression(exp.Schema,this=B,expressions=D)
	def _parse_field_def(A):return A._parse_column_def(A._parse_field(any_token=_C))
	def _parse_column_def(A,this):
		B=this
		if isinstance(B,exp.Column):B=B.this
		D=A._parse_types(schema=_C)
		if A._match_text_seq(_M,'ORDINALITY'):return A.expression(exp.ColumnDef,this=B,ordinality=_C)
		C=[]
		if not D and A._match(TokenType.ALIAS)or A._match_texts(('ALIAS',_U)):F=A._prev.text.upper()==_U;G=exp.ComputedColumnConstraint(this=A._parse_assignment(),persisted=F or A._match_text_seq('PERSISTED'),not_null=A._match_pair(TokenType.NOT,TokenType.NULL));C.append(A.expression(exp.ColumnConstraint,kind=G))
		elif D and A._match_pair(TokenType.ALIAS,TokenType.L_PAREN,advance=_B):A._match(TokenType.ALIAS);C.append(A.expression(exp.ColumnConstraint,kind=exp.TransformColumnConstraint(this=A._parse_field())))
		while _C:
			E=A._parse_column_constraint()
			if not E:break
			C.append(E)
		if not D and not C:return B
		return A.expression(exp.ColumnDef,this=B,kind=D,constraints=C)
	def _parse_auto_increment(A):
		B=_A;C=_A
		if A._match(TokenType.L_PAREN,advance=_B):D=A._parse_wrapped_csv(A._parse_bitwise);B=seq_get(D,0);C=seq_get(D,1)
		elif A._match_text_seq(_Ac):B=A._parse_bitwise();A._match_text_seq(_Aa);C=A._parse_bitwise()
		if B and C:return exp.GeneratedAsIdentityColumnConstraint(start=B,increment=C)
		return exp.AutoIncrementColumnConstraint()
	def _parse_auto_property(A):
		if not A._match_text_seq('REFRESH'):A._retreat(A._index-1);return
		return A.expression(exp.AutoRefreshProperty,this=A._parse_var(upper=_C))
	def _parse_compress(A):
		if A._match(TokenType.L_PAREN,advance=_B):return A.expression(exp.CompressColumnConstraint,this=A._parse_wrapped_csv(A._parse_bitwise))
		return A.expression(exp.CompressColumnConstraint,this=A._parse_bitwise())
	def _parse_generated_as_identity(A):
		E='cycle'
		if A._match_text_seq(_D,_W):F=A._match_pair(TokenType.ON,TokenType.NULL);B=A.expression(exp.GeneratedAsIdentityColumnConstraint,this=_B,on_null=F)
		else:A._match_text_seq('ALWAYS');B=A.expression(exp.GeneratedAsIdentityColumnConstraint,this=_C)
		A._match(TokenType.ALIAS)
		if A._match_text_seq(_L):
			C=A._match_text_seq(_Ac)
			if not C:A._match(TokenType.END)
			G=A._match_text_seq('HIDDEN');return A.expression(exp.GeneratedAsRowColumnConstraint,start=C,hidden=G)
		H=A._match_text_seq(_y)
		if A._match(TokenType.L_PAREN):
			if A._match(TokenType.START_WITH):B.set(_A7,A._parse_bitwise())
			if A._match_text_seq(_Aa,_D):B.set(_Ab,A._parse_bitwise())
			if A._match_text_seq(_k):B.set('minvalue',A._parse_bitwise())
			if A._match_text_seq(_j):B.set('maxvalue',A._parse_bitwise())
			if A._match_text_seq(_A3):B.set(E,_C)
			elif A._match_text_seq(_I,_A3):B.set(E,_B)
			if not H:B.set(_s,A._parse_range())
			elif not B.args.get(_A7)and A._match(TokenType.NUMBER,advance=_B):D=A._parse_csv(A._parse_bitwise);B.set(_A7,seq_get(D,0));B.set(_Ab,seq_get(D,1))
			A._match_r_paren()
		return B
	def _parse_inline(A):A._match_text_seq('LENGTH');return A.expression(exp.InlineLengthColumnConstraint,this=A._parse_bitwise())
	def _parse_not_constraint(A):
		if A._match_text_seq(_G):return A.expression(exp.NotNullColumnConstraint)
		if A._match_text_seq(_As):return A.expression(exp.CaseSpecificColumnConstraint,not_=_C)
		if A._match_text_seq(_M,'REPLICATION'):return A.expression(exp.NotForReplicationColumnConstraint)
		A._retreat(A._index-1)
	def _parse_column_constraint(A):
		if A._match(TokenType.CONSTRAINT):B=A._parse_id_var()
		else:B=_A
		if A._match_texts(A.CONSTRAINT_PARSERS):return A.expression(exp.ColumnConstraint,this=B,kind=A.CONSTRAINT_PARSERS[A._prev.text.upper()](A))
		return B
	def _parse_constraint(A):
		if not A._match(TokenType.CONSTRAINT):return A._parse_unnamed_constraint(constraints=A.SCHEMA_UNNAMED_CONSTRAINTS)
		return A.expression(exp.Constraint,this=A._parse_id_var(),expressions=A._parse_unnamed_constraints())
	def _parse_unnamed_constraints(A):
		B=[]
		while _C:
			C=A._parse_unnamed_constraint()or A._parse_function()
			if not C:break
			B.append(C)
		return B
	def _parse_unnamed_constraint(A,constraints=_A):
		if A._match(TokenType.IDENTIFIER,advance=_B)or not A._match_texts(constraints or A.CONSTRAINT_PARSERS):return
		B=A._prev.text.upper()
		if B not in A.CONSTRAINT_PARSERS:A.raise_error(f"No parser found for schema constraint {B}.")
		return A.CONSTRAINT_PARSERS[B](A)
	def _parse_unique_key(A):return A._parse_id_var(any_token=_B)
	def _parse_unique(A):A._match_text_seq(_o);return A.expression(exp.UniqueColumnConstraint,nulls=A._match_text_seq(_R,_P,'DISTINCT'),this=A._parse_schema(A._parse_unique_key()),index_type=A._match(TokenType.USING)and A._advance_any()and A._prev.text,on_conflict=A._parse_on_conflict())
	def _parse_key_constraint_options(A):
		C=[]
		while _C:
			if not A._curr:break
			if A._match(TokenType.ON):
				B=_A;E=A._advance_any()and A._prev.text
				if A._match_text_seq(_I,'ACTION'):B=_B6
				elif A._match_text_seq(_A6):B=_A6
				elif A._match_text_seq(_Ai):B=_Ai
				elif A._match_pair(TokenType.SET,TokenType.NULL):B='SET NULL'
				elif A._match_pair(TokenType.SET,TokenType.DEFAULT):B='SET DEFAULT'
				else:A.raise_error('Invalid key constraint')
				C.append(f"ON {E} {B}")
			else:
				D=A._parse_var_from_options(A.KEY_CONSTRAINT_OPTIONS,raise_unmatched=_B)
				if not D:break
				C.append(D.name)
		return C
	def _parse_references(A,match=_C):
		if match and not A._match(TokenType.REFERENCES):return
		B=_A;C=A._parse_table(schema=_C);D=A._parse_key_constraint_options();return A.expression(exp.Reference,this=C,expressions=B,options=D)
	def _parse_foreign_key(A):
		D=A._parse_wrapped_id_vars();E=A._parse_references();C={}
		while A._match(TokenType.ON):
			if not A._match_set((TokenType.DELETE,TokenType.UPDATE)):A.raise_error('Expected DELETE or UPDATE')
			F=A._prev.text.lower()
			if A._match_text_seq(_I,'ACTION'):B=_B6
			elif A._match(TokenType.SET):A._match_set((TokenType.NULL,TokenType.DEFAULT));B='SET '+A._prev.text.upper()
			else:A._advance();B=A._prev.text.upper()
			C[F]=B
		return A.expression(exp.ForeignKey,expressions=D,reference=E,**C)
	def _parse_primary_key_part(A):return A._parse_field()
	def _parse_period_for_system_time(A):
		if not A._match(TokenType.TIMESTAMP_SNAPSHOT):A._retreat(A._index-1);return
		B=A._parse_wrapped_id_vars();return A.expression(exp.PeriodForSystemTimeConstraint,this=seq_get(B,0),expression=seq_get(B,1))
	def _parse_primary_key(A,wrapped_optional=_B,in_props=_B):
		B=A._match_set((TokenType.ASC,TokenType.DESC))and A._prev.token_type==TokenType.DESC
		if not in_props and not A._match(TokenType.L_PAREN,advance=_B):return A.expression(exp.PrimaryKeyColumnConstraint,desc=B)
		C=A._parse_wrapped_csv(A._parse_primary_key_part,optional=wrapped_optional);D=A._parse_key_constraint_options();return A.expression(exp.PrimaryKey,expressions=C,options=D)
	def _parse_bracket_key_value(A,is_map=_B):return A._parse_slice(A._parse_alias(A._parse_assignment(),explicit=_C))
	def _parse_odbc_datetime_literal(A):
		"\n        Parses a datetime column in ODBC format. We parse the column into the corresponding\n        types, for example `{d'yyyy-mm-dd'}` will be parsed as a `Date` column, exactly the\n        same as we did for `DATE('yyyy-mm-dd')`.\n\n        Reference:\n        https://learn.microsoft.com/en-us/sql/odbc/reference/develop-app/date-time-and-timestamp-literals\n        ";A._match(TokenType.VAR);B=A.ODBC_DATETIME_LITERALS[A._prev.text.lower()];C=A.expression(exp_class=B,this=A._parse_string())
		if not A._match(TokenType.R_BRACE):A.raise_error(_B7)
		return C
	def _parse_bracket(A,this=_A):
		B=this
		if not A._match_set((TokenType.L_BRACKET,TokenType.L_BRACE)):return B
		C=A._prev.token_type
		if C==TokenType.L_BRACE and A._curr and A._curr.token_type==TokenType.VAR and A._curr.text.lower()in A.ODBC_DATETIME_LITERALS:return A._parse_odbc_datetime_literal()
		D=A._parse_csv(lambda:A._parse_bracket_key_value(is_map=C==TokenType.L_BRACE))
		if C==TokenType.L_BRACKET and not A._match(TokenType.R_BRACKET):A.raise_error('Expected ]')
		elif C==TokenType.L_BRACE and not A._match(TokenType.R_BRACE):A.raise_error(_B7)
		if C==TokenType.L_BRACE:B=A.expression(exp.Struct,expressions=A._kv_to_prop_eq(D))
		elif not B:B=build_array_constructor(exp.Array,args=D,bracket_kind=C,dialect=A.dialect)
		else:
			E=A.ARRAY_CONSTRUCTORS.get(B.name.upper())
			if E:return build_array_constructor(E,args=D,bracket_kind=C,dialect=A.dialect)
			D=apply_index_offset(B,D,-A.dialect.INDEX_OFFSET);B=A.expression(exp.Bracket,this=B,expressions=D)
		A._add_comments(B);return A._parse_bracket(B)
	def _parse_slice(A,this):
		if A._match(TokenType.COLON):return A.expression(exp.Slice,this=this,expression=A._parse_assignment())
		return this
	def _parse_case(A):
		C=[];B=_A;D=A._prev_comments;E=A._parse_assignment()
		while A._match(TokenType.WHEN):F=A._parse_assignment();A._match(TokenType.THEN);G=A._parse_assignment();C.append(A.expression(exp.If,this=F,true=G))
		if A._match(TokenType.ELSE):B=A._parse_assignment()
		if not A._match(TokenType.END):
			if isinstance(B,exp.Interval)and B.this.sql().upper()=='END':B=exp.column('interval')
			else:A.raise_error('Expected END after CASE',A._prev)
		return A.expression(exp.Case,comments=D,this=E,ifs=C,default=B)
	def _parse_if(A):
		if A._match(TokenType.L_PAREN):B=A._parse_csv(A._parse_assignment);C=A.validate_expression(exp.If.from_arg_list(B),B);A._match_r_paren()
		else:
			D=A._index-1
			if A.NO_PAREN_IF_COMMANDS and D==0:return A._parse_as_command(A._prev)
			E=A._parse_assignment()
			if not E:A._retreat(D);return
			A._match(TokenType.THEN);F=A._parse_assignment();G=A._parse_assignment()if A._match(TokenType.ELSE)else _A;A._match(TokenType.END);C=A.expression(exp.If,this=E,true=F,false=G)
		return C
	def _parse_next_value_for(A):
		if not A._match_text_seq(_A5,_M):A._retreat(A._index-1);return
		return A.expression(exp.NextValueFor,this=A._parse_column(),order=A._match(TokenType.OVER)and A._parse_wrapped(A._parse_order))
	def _parse_extract(A):
		B=A._parse_function()or A._parse_var_or_string(upper=_C)
		if A._match(TokenType.FROM):return A.expression(exp.Extract,this=B,expression=A._parse_bitwise())
		if not A._match(TokenType.COMMA):A.raise_error('Expected FROM or comma after EXTRACT',A._prev)
		return A.expression(exp.Extract,this=B,expression=A._parse_bitwise())
	def _parse_gap_fill(A):A._match(TokenType.TABLE);C=A._parse_table();A._match(TokenType.COMMA);B=[C,*A._parse_csv(A._parse_lambda)];D=exp.GapFill.from_arg_list(B);return A.validate_expression(D,B)
	def _parse_cast(A,strict,safe=_A):
		F='zone';C=A._parse_assignment()
		if not A._match(TokenType.ALIAS):
			if A._match(TokenType.COMMA):return A.expression(exp.CastToStrType,this=C,to=A._parse_string())
			A.raise_error('Expected AS after CAST')
		D=_A;B=A._parse_types()
		if A._match(TokenType.FORMAT):
			E=A._parse_string();D=A._parse_at_time_zone(E)
			if not B:B=exp.DataType.build(exp.DataType.Type.UNKNOWN)
			if B.this in exp.DataType.TEMPORAL_TYPES:
				C=A.expression(exp.StrToDate if B.this==exp.DataType.Type.DATE else exp.StrToTime,this=C,format=exp.Literal.string(format_time(E.this if E else'',A.dialect.FORMAT_MAPPING or A.dialect.TIME_MAPPING,A.dialect.FORMAT_TRIE or A.dialect.TIME_TRIE)),safe=safe)
				if isinstance(D,exp.AtTimeZone)and isinstance(C,exp.StrToTime):C.set(F,D.args[F])
				return C
		elif not B:A.raise_error('Expected TYPE after CAST')
		elif isinstance(B,exp.Identifier):B=exp.DataType.build(B.name,udt=_C)
		elif B.this==exp.DataType.Type.CHAR:
			if A._match(TokenType.CHARACTER_SET):B=A.expression(exp.CharacterSet,this=A._parse_var_or_string())
		return A.expression(exp.Cast if strict else exp.TryCast,this=C,to=B,format=D,safe=safe,action=A._parse_var_from_options(A.CAST_ACTIONS,raise_unmatched=_B))
	def _parse_string_agg(A):
		if A._match(TokenType.DISTINCT):
			B=[A.expression(exp.Distinct,expressions=[A._parse_assignment()])]
			if A._match(TokenType.COMMA):B.extend(A._parse_csv(A._parse_assignment))
		else:B=A._parse_csv(A._parse_assignment)
		C=A._index
		if not A._match(TokenType.R_PAREN)and B:B[-1]=A._parse_limit(this=A._parse_order(this=B[-1]));return A.expression(exp.GroupConcat,this=B[0],separator=seq_get(B,1))
		if not A._match_text_seq('WITHIN',_Aj):A._retreat(C);return A.validate_expression(exp.GroupConcat.from_arg_list(B),B)
		A._match_l_paren();D=A._parse_order(this=seq_get(B,0));return A.expression(exp.GroupConcat,this=D,separator=seq_get(B,1))
	def _parse_convert(A,strict,safe=_A):
		C=A._parse_bitwise()
		if A._match(TokenType.USING):B=A.expression(exp.CharacterSet,this=A._parse_var())
		elif A._match(TokenType.COMMA):B=A._parse_types()
		else:B=_A
		return A.expression(exp.Cast if strict else exp.TryCast,this=C,to=B,safe=safe)
	def _parse_decode(G):
		'\n        There are generally two variants of the DECODE function:\n\n        - DECODE(bin, charset)\n        - DECODE(expression, search, result [, search, result] ... [, default])\n\n        The second variant will always be parsed into a CASE expression. Note that NULL\n        needs special treatment, since we need to explicitly check for it with `IS NULL`,\n        instead of relying on pattern matching.\n        ';C=G._parse_csv(G._parse_assignment)
		if len(C)<3:return G.expression(exp.Decode,this=seq_get(C,0),charset=seq_get(C,1))
		B,*D=C
		if not B:return
		E=[]
		for(A,F)in zip(D[::2],D[1::2]):
			if not A or not F:return
			if isinstance(A,exp.Literal):E.append(exp.If(this=exp.EQ(this=B.copy(),expression=A),true=F))
			elif isinstance(A,exp.Null):E.append(exp.If(this=exp.Is(this=B.copy(),expression=exp.Null()),true=F))
			else:H=exp.or_(exp.EQ(this=B.copy(),expression=A),exp.and_(exp.Is(this=B.copy(),expression=exp.Null()),exp.Is(this=A.copy(),expression=exp.Null()),copy=_B),copy=_B);E.append(exp.If(this=H,true=F))
		return exp.Case(ifs=E,default=D[-1]if len(D)%2==1 else _A)
	def _parse_json_key_value(A):
		A._match_text_seq(_o);B=A._parse_column();A._match_set(A.JSON_KEY_VALUE_SEPARATOR_TOKENS);A._match_text_seq(_A5);C=A._parse_bitwise()
		if not B and not C:return
		return A.expression(exp.JSONKeyValue,this=B,expression=C)
	def _parse_format_json(B,this):
		A=this
		if not A or not B._match_text_seq(_e,'JSON'):return A
		return B.expression(exp.FormatJson,this=A)
	def _parse_on_condition(A):
		if A.dialect.ON_CONDITION_EMPTY_BEFORE_ERROR:B=A._parse_on_handling(_T,*A.ON_CONDITION_TOKENS);C=A._parse_on_handling(_a,*A.ON_CONDITION_TOKENS)
		else:C=A._parse_on_handling(_a,*A.ON_CONDITION_TOKENS);B=A._parse_on_handling(_T,*A.ON_CONDITION_TOKENS)
		D=A._parse_on_handling(_G,*A.ON_CONDITION_TOKENS)
		if not B and not C and not D:return
		return A.expression(exp.OnCondition,empty=B,error=C,null=D)
	def _parse_on_handling(A,on,*C):
		for B in C:
			if A._match_text_seq(B,_J,on):return f"{B} ON {on}"
		D=A._index
		if A._match(TokenType.DEFAULT):
			E=A._parse_bitwise()
			if A._match_text_seq(_J,on):return E
			A._retreat(D)
	@t.overload
	def _parse_json_object(self,agg):...
	@t.overload
	def _parse_json_object(self,agg):...
	def _parse_json_object(A,agg=_B):
		C=A._parse_star();D=[C]if C else A._parse_csv(lambda:A._parse_format_json(A._parse_json_key_value()));E=A._parse_on_handling(_G,_G,'ABSENT');B=_A
		if A._match_text_seq(_E,_z):B=_C
		elif A._match_text_seq(_AF,_z):B=_B
		A._match_text_seq('KEYS');F=A._match_text_seq('RETURNING')and A._parse_format_json(A._parse_type());G=A._match_text_seq('ENCODING')and A._parse_var();return A.expression(exp.JSONObjectAgg if agg else exp.JSONObject,expressions=D,null_handling=E,unique_keys=B,return_type=F,encoding=G)
	def _parse_json_column_def(A):
		if not A._match_text_seq('NESTED'):B=A._parse_id_var();C=A._parse_types(allow_identifiers=_B);D=_A
		else:B=_A;C=_A;D=_C
		E=A._match_text_seq('PATH')and A._parse_string();F=D and A._parse_json_schema();return A.expression(exp.JSONColumnDef,this=B,kind=C,path=E,nested_schema=F)
	def _parse_json_schema(A):A._match_text_seq(_Ak);return A.expression(exp.JSONSchema,expressions=A._parse_wrapped_csv(A._parse_json_column_def,optional=_C))
	def _parse_json_table(A):B=A._parse_format_json(A._parse_bitwise());C=A._match(TokenType.COMMA)and A._parse_string();D=A._parse_on_handling(_a,_a,_G);E=A._parse_on_handling(_T,_a,_G);F=A._parse_json_schema();return exp.JSONTable(this=B,schema=F,path=C,error_handling=D,empty_handling=E)
	def _parse_match_against(A):
		C='EXPANSION';D=A._parse_csv(A._parse_column);A._match_text_seq(')','AGAINST','(');E=A._parse_string()
		if A._match_text_seq(_p,'NATURAL','LANGUAGE','MODE'):
			B='IN NATURAL LANGUAGE MODE'
			if A._match_text_seq(_E,_Af,C):B=f"{B} WITH QUERY EXPANSION"
		elif A._match_text_seq(_p,'BOOLEAN','MODE'):B='IN BOOLEAN MODE'
		elif A._match_text_seq(_E,_Af,C):B='WITH QUERY EXPANSION'
		else:B=_A
		return A.expression(exp.MatchAgainst,this=E,expressions=D,modifier=B)
	def _parse_open_json(A):
		C=A._parse_bitwise();D=A._match(TokenType.COMMA)and A._parse_string()
		def E():B=A._parse_field(any_token=_C);C=A._parse_types();D=A._parse_string();E=A._match_pair(TokenType.ALIAS,TokenType.JSON);return A.expression(exp.OpenJSONColumnDef,this=B,kind=C,path=D,as_json=E)
		B=_A
		if A._match_pair(TokenType.R_PAREN,TokenType.WITH):A._match_l_paren();B=A._parse_csv(E)
		return A.expression(exp.OpenJSON,this=C,path=D,expressions=B)
	def _parse_position(A,haystack_first=_B):
		B=A._parse_csv(A._parse_bitwise)
		if A._match(TokenType.IN):return A.expression(exp.StrPosition,this=A._parse_bitwise(),substr=seq_get(B,0))
		if haystack_first:C=seq_get(B,0);D=seq_get(B,1)
		else:D=seq_get(B,0);C=seq_get(B,1)
		return A.expression(exp.StrPosition,this=C,substr=D,position=seq_get(B,2))
	def _parse_predict(A):A._match_text_seq('MODEL');B=A._parse_table();A._match(TokenType.COMMA);A._match_text_seq(_c);return A.expression(exp.Predict,this=B,expression=A._parse_table(),params_struct=A._match(TokenType.COMMA)and A._parse_bitwise())
	def _parse_join_hint(A,func_name):B=A._parse_csv(A._parse_table);return exp.JoinHint(this=func_name.upper(),expressions=B)
	def _parse_substring(A):
		B=t.cast(t.List[t.Optional[exp.Expression]],A._parse_csv(A._parse_bitwise))
		if A._match(TokenType.FROM):B.append(A._parse_bitwise())
		if A._match(TokenType.FOR):
			if len(B)==1:B.append(exp.Literal.number(1))
			B.append(A._parse_bitwise())
		return A.validate_expression(exp.Substring.from_arg_list(B),B)
	def _parse_trim(A):
		D=_A;E=_A;B=_A
		if A._match_texts(A.TRIM_TYPES):D=A._prev.text.upper()
		C=A._parse_bitwise()
		if A._match_set((TokenType.FROM,TokenType.COMMA)):
			F=A._prev.token_type==TokenType.FROM or A.TRIM_PATTERN_FIRST;B=A._parse_bitwise()
			if F:C,B=B,C
		if A._match(TokenType.COLLATE):E=A._parse_bitwise()
		return A.expression(exp.Trim,this=C,position=D,expression=B,collation=E)
	def _parse_window_clause(A):return A._match(TokenType.WINDOW)and A._parse_csv(A._parse_named_window)
	def _parse_named_window(A):return A._parse_window(A._parse_id_var(),alias=_C)
	def _parse_respect_or_ignore_nulls(A,this):
		B=this
		if A._match_text_seq(_AX,_R):return A.expression(exp.IgnoreNulls,this=B)
		if A._match_text_seq('RESPECT',_R):return A.expression(exp.RespectNulls,this=B)
		return B
	def _parse_having_max(A,this):
		if A._match(TokenType.HAVING):A._match_texts(('MAX','MIN'));max=A._prev.text.upper()!='MIN';return A.expression(exp.HavingMax,this=this,expression=A._parse_column(),max=max)
		return this
	def _parse_window(A,this,alias=_B):
		H=alias;B=this;D=B;E=D.comments if isinstance(D,exp.Expression)else _A
		if A._match_pair(TokenType.FILTER,TokenType.L_PAREN):A._match(TokenType.WHERE);B=A.expression(exp.Filter,this=B,expression=A._parse_where(skip_where_token=_C));A._match_r_paren()
		if A._match_text_seq('WITHIN',_Aj):F=A._parse_wrapped(A._parse_order);B=A.expression(exp.WithinGroup,this=B,expression=F)
		if isinstance(B,exp.AggFunc):
			C=B.find(exp.IgnoreNulls,exp.RespectNulls)
			if C and C is not B:C.replace(C.this);B=A.expression(C.__class__,this=B)
		B=A._parse_respect_or_ignore_nulls(B)
		if H:G=_A;A._match(TokenType.ALIAS)
		elif not A._match_set(A.WINDOW_BEFORE_PAREN_TOKENS):return B
		else:G=A._prev.text.upper()
		if E and isinstance(D,exp.Expression):D.pop_comments()
		if not A._match(TokenType.L_PAREN):return A.expression(exp.Window,comments=E,this=B,alias=A._parse_id_var(_B),over=G)
		O=A._parse_id_var(any_token=_B,tokens=A.WINDOW_ALIAS_TOKENS);I=A._match(TokenType.FIRST)
		if A._match_text_seq(_AB):I=_B
		P,F=A._parse_partition_and_order();J=A._match_set((TokenType.ROWS,TokenType.RANGE))and A._prev.text
		if J:A._match(TokenType.BETWEEN);K=A._parse_window_spec();A._match(TokenType.AND);L=A._parse_window_spec();M=A.expression(exp.WindowSpec,kind=J,start=K[_Al],start_side=K[_AD],end=L[_Al],end_side=L[_AD])
		else:M=_A
		A._match_r_paren();N=A.expression(exp.Window,comments=E,this=B,partition_by=P,order=F,spec=M,alias=O,over=G,first=I)
		if A._match_set(A.WINDOW_BEFORE_PAREN_TOKENS,advance=_B):return A._parse_window(N,alias=H)
		return N
	def _parse_partition_and_order(A):return A._parse_partition_by(),A._parse_order()
	def _parse_window_spec(A):B='UNBOUNDED';A._match(TokenType.BETWEEN);return{_Al:A._match_text_seq(B)and B or A._match_text_seq('CURRENT',_L)and'CURRENT ROW'or A._parse_bitwise(),_AD:A._match_texts(A.WINDOW_SIDES)and A._prev.text}
	def _parse_alias(A,this,explicit=_B):
		B=this;C=A._match(TokenType.ALIAS);D=A._prev_comments or[]
		if explicit and not C:return B
		if A._match(TokenType.L_PAREN):G=A.expression(exp.Aliases,comments=D,this=B,expressions=A._parse_csv(lambda:A._parse_id_var(C)));A._match_r_paren(G);return G
		E=A._parse_id_var(C,tokens=A.ALIAS_TOKENS)or A.STRING_ALIASES and A._parse_string_as_identifier()
		if E:
			D.extend(E.pop_comments());B=A.expression(exp.Alias,comments=D,this=B,alias=E);F=B.this
			if not B.comments and F and F.comments:B.comments=F.pop_comments()
		return B
	def _parse_id_var(A,any_token=_C,tokens=_A):
		B=A._parse_identifier()
		if not B and(any_token and A._advance_any()or A._match_set(tokens or A.ID_VAR_TOKENS)):C=A._prev.token_type==TokenType.STRING;B=A.expression(exp.Identifier,this=A._prev.text,quoted=C)
		return B
	def _parse_string(A):
		if A._match_set(A.STRING_PARSERS):return A.STRING_PARSERS[A._prev.token_type](A,A._prev)
		return A._parse_placeholder()
	def _parse_string_as_identifier(A):return exp.to_identifier(A._match(TokenType.STRING)and A._prev.text,quoted=_C)
	def _parse_number(A):
		if A._match_set(A.NUMERIC_PARSERS):return A.NUMERIC_PARSERS[A._prev.token_type](A,A._prev)
		return A._parse_placeholder()
	def _parse_identifier(A):
		if A._match(TokenType.IDENTIFIER):return A.expression(exp.Identifier,this=A._prev.text,quoted=_C)
		return A._parse_placeholder()
	def _parse_var(A,any_token=_B,tokens=_A,upper=_B):
		B=tokens
		if any_token and A._advance_any()or A._match(TokenType.VAR)or(A._match_set(B)if B else _B):return A.expression(exp.Var,this=A._prev.text.upper()if upper else A._prev.text)
		return A._parse_placeholder()
	def _advance_any(A,ignore_reserved=_B):
		if A._curr and(ignore_reserved or A._curr.token_type not in A.RESERVED_TOKENS):A._advance();return A._prev
	def _parse_var_or_string(A,upper=_B):return A._parse_string()or A._parse_var(any_token=_C,upper=upper)
	def _parse_primary_or_var(A):return A._parse_primary()or A._parse_var(any_token=_C)
	def _parse_null(A):
		if A._match_set(A.NULL_TOKENS):return A.PRIMARY_PARSERS[TokenType.NULL](A,A._prev)
		return A._parse_placeholder()
	def _parse_boolean(A):
		if A._match(TokenType.TRUE):return A.PRIMARY_PARSERS[TokenType.TRUE](A,A._prev)
		if A._match(TokenType.FALSE):return A.PRIMARY_PARSERS[TokenType.FALSE](A,A._prev)
		return A._parse_placeholder()
	def _parse_star(A):
		if A._match(TokenType.STAR):return A.PRIMARY_PARSERS[TokenType.STAR](A,A._prev)
		return A._parse_placeholder()
	def _parse_parameter(A):B=A._parse_identifier()or A._parse_primary_or_var();return A.expression(exp.Parameter,this=B)
	def _parse_placeholder(A):
		if A._match_set(A.PLACEHOLDER_PARSERS):
			B=A.PLACEHOLDER_PARSERS[A._prev.token_type](A)
			if B:return B
			A._advance(-1)
	def _parse_star_op(A,*C):
		if not A._match_texts(C):return
		if A._match(TokenType.L_PAREN,advance=_B):return A._parse_wrapped_csv(A._parse_expression)
		B=A._parse_expression();return[B]if B else _A
	def _parse_csv(B,parse_method,sep=TokenType.COMMA):
		C=parse_method;A=C();D=[A]if A is not _A else[]
		while B._match(sep):
			B._add_comments(A);A=C()
			if A is not _A:D.append(A)
		return D
	def _parse_tokens(A,parse_method,expressions):
		D=expressions;C=parse_method;B=C()
		while A._match_set(D):B=A.expression(D[A._prev.token_type],this=B,comments=A._prev_comments,expression=C())
		return B
	def _parse_wrapped_id_vars(A,optional=_B):return A._parse_wrapped_csv(A._parse_id_var,optional=optional)
	def _parse_wrapped_csv(A,parse_method,sep=TokenType.COMMA,optional=_B):return A._parse_wrapped(lambda:A._parse_csv(parse_method,sep=sep),optional=optional)
	def _parse_wrapped(A,parse_method,optional=_B):
		B=A._match(TokenType.L_PAREN)
		if not B and not optional:A.raise_error(_B8)
		C=parse_method()
		if B:A._match_r_paren()
		return C
	def _parse_expressions(A):return A._parse_csv(A._parse_expression)
	def _parse_select_or_expression(A,alias=_B):return A._parse_select()or A._parse_set_operations(A._parse_expression()if alias else A._parse_assignment())
	def _parse_ddl_select(A):return A._parse_query_modifiers(A._parse_set_operations(A._parse_select(nested=_C,parse_subquery_alias=_B)))
	def _parse_transaction(A):
		C=_A
		if A._match_texts(A.TRANSACTION_KIND):C=A._prev.text
		A._match_texts((_X,'WORK'));D=[]
		while _C:
			B=[]
			while A._match(TokenType.VAR):B.append(A._prev.text)
			if B:D.append(_S.join(B))
			if not A._match(TokenType.COMMA):break
		return A.expression(exp.Transaction,this=C,modes=D)
	def _parse_commit_or_rollback(A):
		B=_A;C=_A;D=A._prev.token_type==TokenType.ROLLBACK;A._match_texts((_X,'WORK'))
		if A._match_text_seq(_F):A._match_text_seq('SAVEPOINT');C=A._parse_id_var()
		if A._match(TokenType.AND):B=not A._match_text_seq(_I);A._match_text_seq('CHAIN')
		if D:return A.expression(exp.Rollback,savepoint=C)
		return A.expression(exp.Commit,chain=B)
	def _parse_refresh(A):A._match(TokenType.TABLE);return A.expression(exp.Refresh,this=A._parse_string()or A._parse_table())
	def _parse_add_column(A):
		if not A._match_text_seq(_f):return
		A._match(TokenType.COLUMN);C=A._parse_exists(not_=_C);B=A._parse_field_def()
		if B:
			B.set('exists',C)
			if A._match_texts((_AC,_Ad)):D=A._prev.text;E=A.expression(exp.ColumnPosition,this=A._parse_column(),position=D);B.set('position',E)
		return B
	def _parse_drop_column(B):
		A=B._match(TokenType.DROP)and B._parse_drop()
		if A and not isinstance(A,exp.Command):A.set('kind',A.args.get('kind','COLUMN'))
		return A
	def _parse_drop_partition(A,exists=_A):return A.expression(exp.DropPartition,expressions=A._parse_csv(A._parse_partition),exists=exists)
	def _parse_alter_table_add(A):
		C=A._index-1
		if A._match_set(A.ADD_CONSTRAINT_TOKENS,advance=_B):return A._parse_csv(lambda:A.expression(exp.AddConstraint,expressions=A._parse_csv(A._parse_constraint)))
		A._retreat(C)
		if not A.ALTER_TABLE_ADD_REQUIRED_FOR_EACH_COLUMN and A._match_text_seq(_f):return A._parse_wrapped_csv(A._parse_field_def,optional=_C)
		if A._match_text_seq(_f,_Ak):
			B=A._parse_schema()
			if B:return[B]
			return[]
		return A._parse_wrapped_csv(A._parse_add_column,optional=_C)
	def _parse_alter_table_alter(A):
		if A._match_texts(A.ALTER_ALTER_PARSERS):return A.ALTER_ALTER_PARSERS[A._prev.text.upper()](A)
		A._match(TokenType.COLUMN);B=A._parse_field(any_token=_C)
		if A._match_pair(TokenType.DROP,TokenType.DEFAULT):return A.expression(exp.AlterColumn,this=B,drop=_C)
		if A._match_pair(TokenType.SET,TokenType.DEFAULT):return A.expression(exp.AlterColumn,this=B,default=A._parse_assignment())
		if A._match(TokenType.COMMENT):return A.expression(exp.AlterColumn,this=B,comment=A._parse_string())
		if A._match_text_seq('DROP',_P,_G):return A.expression(exp.AlterColumn,this=B,drop=_C,allow_null=_C)
		if A._match_text_seq(_v,_P,_G):return A.expression(exp.AlterColumn,this=B,allow_null=_B)
		A._match_text_seq(_v,_b);A._match_text_seq('TYPE');return A.expression(exp.AlterColumn,this=B,dtype=A._parse_types(),collate=A._match(TokenType.COLLATE)and A._parse_term(),using=A._match(TokenType.USING)and A._parse_assignment())
	def _parse_alter_diststyle(A):
		if A._match_texts((_Z,'EVEN',_u)):return A.expression(exp.AlterDistStyle,this=exp.var(A._prev.text.upper()))
		A._match_text_seq(_o,_AM);return A.expression(exp.AlterDistStyle,this=A._parse_column())
	def _parse_alter_sortkey(A,compound=_A):
		B=compound
		if B:A._match_text_seq(_w)
		if A._match(TokenType.L_PAREN,advance=_B):return A.expression(exp.AlterSortKey,expressions=A._parse_wrapped_id_vars(),compound=B)
		A._match_texts((_u,'NONE'));return A.expression(exp.AlterSortKey,this=exp.var(A._prev.text.upper()),compound=B)
	def _parse_alter_table_drop(A):
		B=A._index-1;C=A._parse_exists()
		if A._match(TokenType.PARTITION,advance=_B):return A._parse_csv(lambda:A._parse_drop_partition(exists=C))
		A._retreat(B);return A._parse_csv(A._parse_drop_column)
	def _parse_alter_table_rename(A):
		if A._match(TokenType.COLUMN):
			D=A._parse_exists();B=A._parse_column();E=A._match_text_seq(_F);C=A._parse_column()
			if B is _A or E is _A or C is _A:return
			return A.expression(exp.RenameColumn,this=B,to=C,exists=D)
		A._match_text_seq(_F);return A.expression(exp.RenameTable,this=A._parse_table(schema=_C))
	def _parse_alter_table_set(A):
		D='file_format';C='option';B=A.expression(exp.AlterSet)
		if A._match(TokenType.L_PAREN,advance=_B)or A._match_text_seq(_c,'PROPERTIES'):B.set(_H,A._parse_wrapped_csv(A._parse_assignment))
		elif A._match_text_seq('FILESTREAM_ON',advance=_B):B.set(_H,[A._parse_assignment()])
		elif A._match_texts(('LOGGED',_AR)):B.set(C,exp.var(A._prev.text.upper()))
		elif A._match_text_seq(_AF)and A._match_texts(('CLUSTER','OIDS')):B.set(C,exp.var(f"WITHOUT {A._prev.text.upper()}"))
		elif A._match_text_seq('LOCATION'):B.set('location',A._parse_field())
		elif A._match_text_seq(_Ae,'METHOD'):B.set('access_method',A._parse_field())
		elif A._match_text_seq(_B5):B.set('tablespace',A._parse_field())
		elif A._match_text_seq('FILE',_e)or A._match_text_seq('FILEFORMAT'):B.set(D,[A._parse_field()])
		elif A._match_text_seq('STAGE_FILE_FORMAT'):B.set(D,A._parse_wrapped_options())
		elif A._match_text_seq('STAGE_COPY_OPTIONS'):B.set('copy_options',A._parse_wrapped_options())
		elif A._match_text_seq('TAG')or A._match_text_seq('TAGS'):B.set('tag',A._parse_csv(A._parse_assignment))
		else:
			if A._match_text_seq(_Ag):B.set('serde',A._parse_field())
			B.set(_H,[A._parse_properties()])
		return B
	def _parse_alter(A):
		B=A._prev;C=A._match_set(A.ALTERABLES)and A._prev
		if not C:return A._parse_as_command(B)
		F=A._parse_exists();G=A._match_text_seq('ONLY');H=A._parse_table(schema=_C);I=A._parse_on_property()if A._match(TokenType.ON)else _A
		if A._next:A._advance()
		D=A.ALTER_PARSERS.get(A._prev.text.upper())if A._prev else _A
		if D:
			E=ensure_list(D(A));J=A._match_text_seq(_P,'VALID');K=A._parse_csv(A._parse_property)
			if not A._curr and E:return A.expression(exp.Alter,this=H,kind=C.text.upper(),exists=F,actions=E,only=G,options=K,cluster=I,not_valid=J)
		return A._parse_as_command(B)
	def _parse_merge(A):
		A._match(TokenType.INTO);B=A._parse_table()
		if B and A._match(TokenType.ALIAS,advance=_B):B.set(_O,A._parse_table_alias())
		A._match(TokenType.USING);C=A._parse_table();A._match(TokenType.ON);D=A._parse_assignment();return A.expression(exp.Merge,this=B,using=C,on=D,expressions=A._parse_when_matched(),returning=A._parse_returning())
	def _parse_when_matched(A):
		C=[]
		while A._match(TokenType.WHEN):
			F=not A._match(TokenType.NOT);A._match_text_seq('MATCHED');G=_B if A._match_text_seq(_D,'TARGET')else A._match_text_seq(_D,_AP);H=A._parse_assignment()if A._match(TokenType.AND)else _A;A._match(TokenType.THEN)
			if A._match(TokenType.INSERT):
				D=A._parse_star()
				if D:B=A.expression(exp.Insert,this=D)
				else:B=A.expression(exp.Insert,this=exp.var(_L)if A._match_text_seq(_L)else A._parse_value(),expression=A._match_text_seq(_A9)and A._parse_value())
			elif A._match(TokenType.UPDATE):
				E=A._parse_star()
				if E:B=A.expression(exp.Update,expressions=E)
				else:B=A.expression(exp.Update,expressions=A._match(TokenType.SET)and A._parse_csv(A._parse_equality))
			elif A._match(TokenType.DELETE):B=A.expression(exp.Var,this=A._prev.text)
			else:B=A._parse_var_from_options(A.CONFLICT_ACTIONS)
			C.append(A.expression(exp.When,matched=F,source=G,condition=H,then=B))
		return C
	def _parse_show(A):
		B=A._find_parser(A.SHOW_PARSERS,A.SHOW_TRIE)
		if B:return B(A)
		return A._parse_as_command(A._prev)
	def _parse_set_item_assignment(A,kind=_A):
		C=kind;E=A._index
		if C in(_V,_A1)and A._match_text_seq(_X):return A._parse_set_transaction(global_=C==_V)
		D=A._parse_primary()or A._parse_column();F=A._match_texts((_K,_F))
		if not D or A.SET_REQUIRES_ASSIGNMENT_DELIMITER and not F:A._retreat(E);return
		B=A._parse_statement()or A._parse_id_var()
		if isinstance(B,(exp.Column,exp.Identifier)):B=exp.var(B.name)
		G=A.expression(exp.EQ,this=D,expression=B);return A.expression(exp.SetItem,this=G,kind=C)
	def _parse_set_transaction(A,global_=_B):A._match_text_seq(_X);B=A._parse_csv(lambda:A._parse_var_from_options(A.TRANSACTION_CHARACTERISTICS));return A.expression(exp.SetItem,expressions=B,kind=_X,**{'global':global_})
	def _parse_set_item(A):B=A._find_parser(A.SET_PARSERS,A.SET_TRIE);return B(A)if B else A._parse_set_item_assignment(kind=_A)
	def _parse_set(A,unset=_B,tag=_B):
		B=A._index;C=A.expression(exp.Set,expressions=A._parse_csv(A._parse_set_item),unset=unset,tag=tag)
		if A._curr:A._retreat(B);return A._parse_as_command(A._prev)
		return C
	def _parse_var_from_options(A,options,raise_unmatched=_C):
		E=A._curr
		if not E:return
		B=E.text.upper();D=options.get(B);F=A._index;A._advance()
		for C in D or[]:
			if isinstance(C,str):C=C,
			if A._match_text_seq(*C):B=f"{B} {_S.join(C)}";break
		else:
			if D or D is _A:
				if raise_unmatched:A.raise_error(f"Unknown option {B}")
				A._retreat(F);return
		return exp.var(B)
	def _parse_as_command(A,start):
		B=start
		while A._curr:A._advance()
		C=A._find_sql(B,A._prev);D=len(B.text);A._warn_unsupported();return exp.Command(this=C[:D],expression=C[D:])
	def _parse_dict_property(A,this):
		B=[];A._match_l_paren();C=A._parse_id_var()
		if A._match(TokenType.L_PAREN):
			while _C:
				D=A._parse_id_var();E=A._parse_primary()
				if not D and E is _A:break
				B.append(A.expression(exp.DictSubProperty,this=D,value=E))
			A._match(TokenType.R_PAREN)
		A._match_r_paren();return A.expression(exp.DictProperty,this=this,kind=C.this if C else _A,settings=B)
	def _parse_dict_range(A,this):
		A._match_l_paren();B=A._match_text_seq('MIN')
		if B:min=A._parse_var()or A._parse_primary();A._match_text_seq('MAX');max=A._parse_var()or A._parse_primary()
		else:max=A._parse_var()or A._parse_primary();min=exp.Literal.number(0)
		A._match_r_paren();return A.expression(exp.DictRange,this=this,min=min,max=max)
	def _parse_comprehension(A,this):
		B=A._index;C=A._parse_column()
		if not A._match(TokenType.IN):A._retreat(B-1);return
		D=A._parse_column();E=A._parse_assignment()if A._match_text_seq('IF')else _A;return A.expression(exp.Comprehension,this=this,expression=C,iterator=D,condition=E)
	def _parse_heredoc(A):
		E='No closing $ found';C='$'
		if A._match(TokenType.HEREDOC_STRING):return A.expression(exp.Heredoc,this=A._prev.text)
		if not A._match_text_seq(C):return
		B=[C];D=_A
		if A._is_connected():A._advance();B.append(A._prev.text.upper())
		else:A.raise_error(E)
		if B[-1]!=C:
			if A._is_connected()and A._match_text_seq(C):D=B[-1];B.append(C)
			else:A.raise_error(E)
		F=A._curr
		while A._curr:
			if A._match_text_seq(*B,advance=_B):G=A._find_sql(F,A._prev);A._advance(len(B));return A.expression(exp.Heredoc,this=G,tag=D)
			A._advance()
		A.raise_error(f"No closing {"".join(B)} found")
	def _find_parser(A,parsers,trie):
		if not A._curr:return
		E=A._index;B=[]
		while _C:
			C=A._curr.text.upper();F=C.split(_S);B.append(C);A._advance();D,trie=in_trie(trie,F)
			if D==TrieResult.FAILED:break
			if D==TrieResult.EXISTS:G=parsers[_S.join(B)];return G
		A._retreat(E)
	def _match(A,token_type,advance=_C,expression=_A):
		if not A._curr:return
		if A._curr.token_type==token_type:
			if advance:A._advance()
			A._add_comments(expression);return _C
	def _match_set(A,types,advance=_C):
		if not A._curr:return
		if A._curr.token_type in types:
			if advance:A._advance()
			return _C
	def _match_pair(A,token_type_a,token_type_b,advance=_C):
		if not A._curr or not A._next:return
		if A._curr.token_type==token_type_a and A._next.token_type==token_type_b:
			if advance:A._advance(2)
			return _C
	def _match_l_paren(A,expression=_A):
		if not A._match(TokenType.L_PAREN,expression=expression):A.raise_error(_B8)
	def _match_r_paren(A,expression=_A):
		if not A._match(TokenType.R_PAREN,expression=expression):A.raise_error(_Ah)
	def _match_texts(A,texts,advance=_C):
		if A._curr and A._curr.token_type!=TokenType.STRING and A._curr.text.upper()in texts:
			if advance:A._advance()
			return _C
	def _match_text_seq(A,*C,advance=_C):
		B=A._index
		for D in C:
			if A._curr and A._curr.token_type!=TokenType.STRING and A._curr.text.upper()==D:A._advance()
			else:A._retreat(B);return
		if not advance:A._retreat(B)
		return _C
	def _replace_lambda(F,node,expressions):
		B=node
		if not B:return B
		G={A.name:A.args.get('to')or _B for A in expressions}
		for A in B.find_all(exp.Column):
			E=G.get(A.parts[0].name)
			if E is not _A:
				C=A.to_dot()if A.table else A.this
				if E:C=F.expression(exp.Cast,this=C,to=E)
				D=A.parent
				while isinstance(D,exp.Dot):
					if not isinstance(D.parent,exp.Dot):D.replace(C);break
					D=D.parent
				else:
					if A is B:B=C
					else:A.replace(C)
		return B
	def _parse_truncate_table(A):
		F='CONTINUE';E='RESTART';G=A._prev
		if A._match(TokenType.L_PAREN):A._retreat(A._index-2);return A._parse_function()
		C=A._match(TokenType.DATABASE);A._match(TokenType.TABLE);H=A._parse_exists(not_=_B);I=A._parse_csv(lambda:A._parse_table(schema=_C,is_db_reference=C));J=A._parse_on_property()if A._match(TokenType.ON)else _A
		if A._match_text_seq(E,_y):B=E
		elif A._match_text_seq(F,_y):B=F
		else:B=_A
		if A._match_text_seq(_A6)or A._match_text_seq(_Ai):D=A._prev.text
		else:D=_A
		K=A._parse_partition()
		if A._curr:return A._parse_as_command(G)
		return A.expression(exp.TruncateTable,expressions=I,is_database=C,exists=H,cluster=J,identity=B,option=D,partition=K)
	def _parse_with_operator(A):
		B=A._parse_ordered(A._parse_opclass)
		if not A._match(TokenType.WITH):return B
		C=A._parse_var(any_token=_C);return A.expression(exp.WithOperator,this=B,op=C)
	def _parse_wrapped_options(A):
		C='FORMAT_NAME';A._match(TokenType.EQ);A._match(TokenType.L_PAREN);B=[]
		while A._curr and not A._match(TokenType.R_PAREN):
			if A._match_text_seq(C,_K):D=A.expression(exp.Property,this=exp.var(C),value=A._parse_field());B.append(D)
			else:B.append(A._parse_property())
			A._match(TokenType.COMMA)
		return B
	def _parse_copy_parameters(A):
		E=TokenType.COMMA if A.dialect.COPY_PARAMS_ARE_CSV else _A;C=[]
		while A._curr and not A._match(TokenType.R_PAREN,advance=_B):
			F=A._parse_var(any_token=_C);D=A._prev.text.upper();A._match(TokenType.EQ);A._match(TokenType.ALIAS);B=A.expression(exp.CopyParameter,this=F)
			if D in A.COPY_INTO_VARLEN_OPTIONS and A._match(TokenType.L_PAREN,advance=_B):B.set(_H,A._parse_wrapped_options())
			elif D==_A_:B.set(_s,A._parse_field())
			else:B.set(_s,A._parse_unquoted_field())
			C.append(B);A._match(E)
		return C
	def _parse_credentials(A):
		B=A.expression(exp.Credentials)
		if A._match_text_seq('STORAGE_INTEGRATION',_K):B.set('storage',A._parse_field())
		if A._match_text_seq('CREDENTIALS'):C=A._parse_wrapped_options()if A._match(TokenType.EQ)else A._parse_field();B.set('credentials',C)
		if A._match_text_seq(_Az):B.set('encryption',A._parse_wrapped_options())
		if A._match_text_seq('IAM_ROLE'):B.set('iam_role',A._parse_field())
		if A._match_text_seq('REGION'):B.set('region',A._parse_field())
		return B
	def _parse_file_location(A):return A._parse_field()
	def _parse_copy(A):
		B=A._prev;A._match(TokenType.INTO);C=A._parse_select(nested=_C,parse_subquery_alias=_B)if A._match(TokenType.L_PAREN,advance=_B)else A._parse_table(schema=_C);D=A._match(TokenType.FROM)or not A._match_text_seq(_F);E=A._parse_csv(A._parse_file_location);F=A._parse_credentials();A._match_text_seq(_E);G=A._parse_wrapped(A._parse_copy_parameters,optional=_C)
		if A._curr:return A._parse_as_command(B)
		return A.expression(exp.Copy,this=C,kind=D,credentials=F,files=E,params=G)
	def _parse_normalize(A):return A.expression(exp.Normalize,this=A._parse_bitwise(),form=A._match(TokenType.COMMA)and A._parse_var())
	def _parse_star_ops(A):
		if A._match_text_seq(_Ak,'(',advance=_B):
			B=A._parse_function()
			if isinstance(B,exp.Columns):B.set('unpack',_C)
			return B
		return A.expression(exp.Star,**{'except':A._parse_star_op('EXCEPT',_x),'replace':A._parse_star_op(_AY),'rename':A._parse_star_op(_AT)})
	def _parse_grant_privilege(A):
		B=[]
		while A._curr and not A._match_set(A.PRIVILEGE_FOLLOW_TOKENS,advance=_B):B.append(A._curr.text.upper());A._advance()
		C=exp.var(_S.join(B));D=A._parse_wrapped_csv(A._parse_column)if A._match(TokenType.L_PAREN,advance=_B)else _A;return A.expression(exp.GrantPrivilege,this=C,expressions=D)
	def _parse_grant_principal(A):
		C=A._match_texts(('ROLE',_Aj))and A._prev.text.upper();B=A._parse_id_var()
		if not B:return
		return A.expression(exp.GrantPrincipal,this=B,kind=C)
	def _parse_grant(A):
		B=A._prev;D=A._parse_csv(A._parse_grant_privilege);A._match(TokenType.ON);E=A._match_set(A.CREATABLES)and A._prev.text.upper();C=A._try_parse(A._parse_table_parts)
		if not C or not A._match_text_seq(_F):return A._parse_as_command(B)
		F=A._parse_csv(A._parse_grant_principal);G=A._match_text_seq(_E,'GRANT','OPTION')
		if A._curr:return A._parse_as_command(B)
		return A.expression(exp.Grant,privileges=D,kind=E,securable=C,principals=F,grant_option=G)
	def _parse_overlay(A):return A.expression(exp.Overlay,**{_N:A._parse_bitwise(),_s:A._match_text_seq('PLACING')and A._parse_bitwise(),_d:A._match_text_seq('FROM')and A._parse_bitwise(),'for':A._match_text_seq(_M)and A._parse_bitwise()})