from __future__ import annotations
_E='join_key'
_D='expression'
_C='distinct'
_B='condition'
_A=None
import math,typing as t
from sqlglot import alias,exp
from sqlglot.helper import name_sequence
from sqlglot.optimizer.eliminate_joins import join_condition
class Plan:
	def __init__(A,expression):A.expression=expression.copy();A.root=Step.from_expression(A.expression);A._dag={}
	@property
	def dag(self):
		A=self
		if not A._dag:
			B={};C={A.root}
			while C:
				D=C.pop();B[D]=set()
				for E in D.dependencies:B[D].add(E);C.add(E)
			A._dag=B
		return A._dag
	@property
	def leaves(self):return(A for(A,B)in self.dag.items()if not B)
	def __repr__(A):return f"Plan\n----\n{repr(A.root)}"
class Step:
	@classmethod
	def from_expression(g,expression,ctes=_A):
		'\n        Builds a DAG of Steps from a SQL expression so that it\'s easier to execute in an engine.\n        Note: the expression\'s tables and subqueries must be aliased for this method to work. For\n        example, given the following expression:\n\n        SELECT\n          x.a,\n          SUM(x.b)\n        FROM x AS x\n        JOIN y AS y\n          ON x.a = y.a\n        GROUP BY x.a\n\n        the following DAG is produced (the expression IDs might differ per execution):\n\n        - Aggregate: x (4347984624)\n            Context:\n              Aggregations:\n                - SUM(x.b)\n              Group:\n                - x.a\n            Projections:\n              - x.a\n              - "x".""\n            Dependencies:\n            - Join: x (4347985296)\n              Context:\n                y:\n                On: x.a = y.a\n              Projections:\n              Dependencies:\n              - Scan: x (4347983136)\n                Context:\n                  Source: x AS x\n                Projections:\n              - Scan: y (4343416624)\n                Context:\n                  Source: y AS y\n                Projections:\n\n        Args:\n            expression: the expression to build the DAG from.\n            ctes: a dictionary that maps CTEs to their corresponding Step DAG by name.\n\n        Returns:\n            A Step DAG corresponding to `expression`.\n        ';F=True;D=ctes;B=expression;D=D or{};B=B.unnest();U=B.args.get('with')
		if U:
			D=D.copy()
			for V in U.expressions:A=Step.from_expression(V.this,D);A.name=V.alias;D[A.name]=A
		W=B.args.get('from')
		if isinstance(B,exp.Select)and W:A=Scan.from_expression(W.this,D)
		elif isinstance(B,exp.SetOperation):A=SetOperation.from_expression(B,D)
		else:A=Scan()
		X=B.args.get('joins')
		if X:K=Join.from_joins(X,D);K.name=A.name;K.source_name=A.name;K.add_dependency(A);A=K
		G=[];L={};O={};e=name_sequence('_a_')
		def P(expression):
			C=expression;B=tuple(C.find_all(exp.AggFunc))
			if B:O[C]=_A
			for D in B:
				for A in D.unnest_operands():
					if isinstance(A,exp.Column):continue
					if A not in L:L[A]=e()
					A.replace(exp.column(L[A],quoted=F))
			return bool(B)
		def Y(step):step.operands=tuple(alias(A,B)for(A,B)in L.items());step.aggregations=list(O)
		for M in B.expressions:
			if M.find(exp.AggFunc):G.append(exp.column(M.alias_or_name,A.name,quoted=F));P(M)
			else:G.append(M)
		Z=B.args.get('where')
		if Z:A.condition=Z.this
		Q=B.args.get('group')
		if Q or O:
			C=Aggregate();C.source=A.name;C.name=A.name;R=B.args.get('having')
			if R:
				if P(exp.alias_(R.this,'_h',quoted=F)):C.condition=exp.column('_h',A.name,quoted=F)
				else:C.condition=R.this
			Y(C);C.group={f"_g{A}":B for(A,B)in enumerate(Q.expressions if Q else[])};H={}
			for(a,S)in C.group.items():
				H[S]=a
				if isinstance(S,exp.Column):H[S.name]=a
			for f in G:
				for E in f.walk():
					I=H.get(E)
					if I:E.replace(exp.column(I,A.name))
			if C.condition:
				for E in C.condition.walk():
					I=H.get(E)or H.get(E.name)
					if I:E.replace(exp.column(I,A.name))
			C.add_dependency(A);A=C
		T=B.args.get('order')
		if T:
			if isinstance(A,Aggregate):
				for(b,c)in enumerate(T.expressions):
					if P(exp.alias_(c.this,f"_o_{b}",quoted=F)):c.this.replace(exp.column(f"_o_{b}",A.name,quoted=F))
				Y(C)
			N=Sort();N.name=A.name;N.key=T.expressions;N.add_dependency(A);A=N
		A.projections=G
		if isinstance(B,exp.Select)and B.args.get(_C):J=Aggregate();J.source=A.name;J.name=A.name;J.group={B.alias_or_name:exp.column(col=B.alias_or_name,table=A.name)for B in G or B.expressions};J.add_dependency(A);A=J
		d=B.args.get('limit')
		if d:A.limit=int(d.text(_D))
		return A
	def __init__(A):A.name=_A;A.dependencies=set();A.dependents=set();A.projections=[];A.limit=math.inf;A.condition=_A
	def add_dependency(A,dependency):B=dependency;A.dependencies.add(B);B.dependents.add(A)
	def __repr__(A):return A.to_s()
	def to_s(A,level=0):
		E=level;F='  '*E;B=f"{F}    ";D=A._to_s(f"{B}  ")
		if D:D=[f"{B}Context:"]+D
		C=[f"{F}- {A.id}",*D,f"{B}Projections:"]
		for G in A.projections:C.append(f"{B}  - {G.sql()}")
		if A.condition:C.append(f"{B}Condition: {A.condition.sql()}")
		if A.limit is not math.inf:C.append(f"{B}Limit: {A.limit}")
		if A.dependencies:
			C.append(f"{B}Dependencies:")
			for H in A.dependencies:C.append('  '+H.to_s(E+1))
		return'\n'.join(C)
	@property
	def type_name(self):return self.__class__.__name__
	@property
	def id(self):B=self;A=B.name;A=f" {A}"if A else'';return f"{B.type_name}:{A} ({id(B)})"
	def _to_s(A,_indent):return[]
class Scan(Step):
	@classmethod
	def from_expression(F,expression,ctes=_A):
		C=ctes;B=expression;D=B;E=B.alias_or_name
		if isinstance(B,exp.Subquery):D=B.this;A=Step.from_expression(D,C);A.name=E;return A
		A=Scan();A.name=E;A.source=B
		if C and D.name in C:A.add_dependency(C[D.name])
		return A
	def __init__(A):super().__init__();A.source=_A
	def _to_s(A,indent):return[f"{indent}Source: {A.source.sql()if A.source else"-static-"}"]
class Join(Step):
	@classmethod
	def from_joins(F,joins,ctes=_A):
		B=Join()
		for A in joins:C,D,E=join_condition(A);B.joins[A.alias_or_name]={'side':A.side,_E:D,'source_key':C,_B:E};B.add_dependency(Scan.from_expression(A.this,ctes))
		return B
	def __init__(A):super().__init__();A.source_name=_A;A.joins={}
	def _to_s(D,indent):
		A=indent;B=[f"{A}Source: {D.source_name or D.name}"]
		for(F,C)in D.joins.items():
			B.append(f"{A}{F}: {C["side"]or"INNER"}");E=', '.join(str(A)for A in t.cast(list,C.get(_E)or[]))
			if E:B.append(f"{A}Key: {E}")
			if C.get(_B):B.append(f"{A}On: {C[_B].sql()}")
		return B
class Aggregate(Step):
	def __init__(A):super().__init__();A.aggregations=[];A.operands=();A.group={};A.source=_A
	def _to_s(C,indent):
		A=indent;B=[f"{A}Aggregations:"]
		for D in C.aggregations:B.append(f"{A}  - {D.sql()}")
		if C.group:
			B.append(f"{A}Group:")
			for D in C.group.values():B.append(f"{A}  - {D.sql()}")
		if C.condition:B.append(f"{A}Having:");B.append(f"{A}  - {C.condition.sql()}")
		if C.operands:
			B.append(f"{A}Operands:")
			for D in C.operands:B.append(f"{A}  - {D.sql()}")
		return B
class Sort(Step):
	def __init__(A):super().__init__();A.key=_A
	def _to_s(C,indent):
		A=indent;B=[f"{A}Key:"]
		for D in C.key:B.append(f"{A}  - {D.sql()}")
		return B
class SetOperation(Step):
	def __init__(A,op,left,right,distinct=False):super().__init__();A.op=op;A.left=left;A.right=right;A.distinct=distinct
	@classmethod
	def from_expression(F,expression,ctes=_A):
		A=expression;assert isinstance(A,exp.SetOperation);B=Step.from_expression(A.left,ctes);B.name=B.name or'left';C=Step.from_expression(A.right,ctes);C.name=C.name or'right';D=F(op=A.__class__,left=B.name,right=C.name,distinct=bool(A.args.get(_C)));D.add_dependency(B);D.add_dependency(C);E=A.args.get('limit')
		if E:D.limit=int(E.text(_D))
		return D
	def _to_s(A,indent):
		B=[]
		if A.distinct:B.append(f"{indent}Distinct: {A.distinct}")
		return B
	@property
	def type_name(self):return self.op.__name__