from __future__ import annotations
_C=False
_B=None
_A=True
import os,typing as t
from enum import auto
from sqlglot.errors import SqlglotError,TokenError
from sqlglot.helper import AutoName
from sqlglot.trie import TrieResult,in_trie,new_trie
if t.TYPE_CHECKING:from sqlglot.dialects.dialect import DialectType
try:from sqlglotrs import Tokenizer as RsTokenizer,TokenizerDialectSettings as RsTokenizerDialectSettings,TokenizerSettings as RsTokenizerSettings,TokenTypeSettings as RsTokenTypeSettings;USE_RS_TOKENIZER=os.environ.get('SQLGLOTRS_TOKENIZER','1')=='1'
except ImportError:USE_RS_TOKENIZER=_C
class TokenType(AutoName):L_PAREN=auto();R_PAREN=auto();L_BRACKET=auto();R_BRACKET=auto();L_BRACE=auto();R_BRACE=auto();COMMA=auto();DOT=auto();DASH=auto();PLUS=auto();COLON=auto();DCOLON=auto();DQMARK=auto();SEMICOLON=auto();STAR=auto();BACKSLASH=auto();SLASH=auto();LT=auto();LTE=auto();GT=auto();GTE=auto();NOT=auto();EQ=auto();NEQ=auto();NULLSAFE_EQ=auto();COLON_EQ=auto();AND=auto();OR=auto();AMP=auto();DPIPE=auto();PIPE=auto();PIPE_SLASH=auto();DPIPE_SLASH=auto();CARET=auto();CARET_AT=auto();TILDA=auto();ARROW=auto();DARROW=auto();FARROW=auto();HASH=auto();HASH_ARROW=auto();DHASH_ARROW=auto();LR_ARROW=auto();DAT=auto();LT_AT=auto();AT_GT=auto();DOLLAR=auto();PARAMETER=auto();SESSION_PARAMETER=auto();DAMP=auto();XOR=auto();DSTAR=auto();BLOCK_START=auto();BLOCK_END=auto();SPACE=auto();BREAK=auto();STRING=auto();NUMBER=auto();IDENTIFIER=auto();DATABASE=auto();COLUMN=auto();COLUMN_DEF=auto();SCHEMA=auto();TABLE=auto();WAREHOUSE=auto();STREAMLIT=auto();VAR=auto();BIT_STRING=auto();HEX_STRING=auto();BYTE_STRING=auto();NATIONAL_STRING=auto();RAW_STRING=auto();HEREDOC_STRING=auto();UNICODE_STRING=auto();BIT=auto();BOOLEAN=auto();TINYINT=auto();UTINYINT=auto();SMALLINT=auto();USMALLINT=auto();MEDIUMINT=auto();UMEDIUMINT=auto();INT=auto();UINT=auto();BIGINT=auto();UBIGINT=auto();INT128=auto();UINT128=auto();INT256=auto();UINT256=auto();FLOAT=auto();DOUBLE=auto();DECIMAL=auto();DECIMAL32=auto();DECIMAL64=auto();DECIMAL128=auto();UDECIMAL=auto();BIGDECIMAL=auto();CHAR=auto();NCHAR=auto();VARCHAR=auto();NVARCHAR=auto();BPCHAR=auto();TEXT=auto();MEDIUMTEXT=auto();LONGTEXT=auto();MEDIUMBLOB=auto();LONGBLOB=auto();TINYBLOB=auto();TINYTEXT=auto();NAME=auto();BINARY=auto();VARBINARY=auto();JSON=auto();JSONB=auto();TIME=auto();TIMETZ=auto();TIMESTAMP=auto();TIMESTAMPTZ=auto();TIMESTAMPLTZ=auto();TIMESTAMPNTZ=auto();TIMESTAMP_S=auto();TIMESTAMP_MS=auto();TIMESTAMP_NS=auto();DATETIME=auto();DATETIME64=auto();DATE=auto();DATE32=auto();INT4RANGE=auto();INT4MULTIRANGE=auto();INT8RANGE=auto();INT8MULTIRANGE=auto();NUMRANGE=auto();NUMMULTIRANGE=auto();TSRANGE=auto();TSMULTIRANGE=auto();TSTZRANGE=auto();TSTZMULTIRANGE=auto();DATERANGE=auto();DATEMULTIRANGE=auto();UUID=auto();GEOGRAPHY=auto();NULLABLE=auto();GEOMETRY=auto();HLLSKETCH=auto();HSTORE=auto();SUPER=auto();SERIAL=auto();SMALLSERIAL=auto();BIGSERIAL=auto();XML=auto();YEAR=auto();UNIQUEIDENTIFIER=auto();USERDEFINED=auto();MONEY=auto();SMALLMONEY=auto();ROWVERSION=auto();IMAGE=auto();VARIANT=auto();OBJECT=auto();INET=auto();IPADDRESS=auto();IPPREFIX=auto();IPV4=auto();IPV6=auto();ENUM=auto();ENUM8=auto();ENUM16=auto();FIXEDSTRING=auto();LOWCARDINALITY=auto();NESTED=auto();AGGREGATEFUNCTION=auto();SIMPLEAGGREGATEFUNCTION=auto();TDIGEST=auto();UNKNOWN=auto();VECTOR=auto();ALIAS=auto();ALTER=auto();ALWAYS=auto();ALL=auto();ANTI=auto();ANY=auto();APPLY=auto();ARRAY=auto();ASC=auto();ASOF=auto();AUTO_INCREMENT=auto();BEGIN=auto();BETWEEN=auto();BULK_COLLECT_INTO=auto();CACHE=auto();CASE=auto();CHARACTER_SET=auto();CLUSTER_BY=auto();COLLATE=auto();COMMAND=auto();COMMENT=auto();COMMIT=auto();CONNECT_BY=auto();CONSTRAINT=auto();COPY=auto();CREATE=auto();CROSS=auto();CUBE=auto();CURRENT_DATE=auto();CURRENT_DATETIME=auto();CURRENT_TIME=auto();CURRENT_TIMESTAMP=auto();CURRENT_USER=auto();DECLARE=auto();DEFAULT=auto();DELETE=auto();DESC=auto();DESCRIBE=auto();DICTIONARY=auto();DISTINCT=auto();DISTRIBUTE_BY=auto();DIV=auto();DROP=auto();ELSE=auto();END=auto();ESCAPE=auto();EXCEPT=auto();EXECUTE=auto();EXISTS=auto();FALSE=auto();FETCH=auto();FILTER=auto();FINAL=auto();FIRST=auto();FOR=auto();FORCE=auto();FOREIGN_KEY=auto();FORMAT=auto();FROM=auto();FULL=auto();FUNCTION=auto();GLOB=auto();GLOBAL=auto();GRANT=auto();GROUP_BY=auto();GROUPING_SETS=auto();HAVING=auto();HINT=auto();IGNORE=auto();ILIKE=auto();ILIKE_ANY=auto();IN=auto();INDEX=auto();INNER=auto();INSERT=auto();INTERSECT=auto();INTERVAL=auto();INTO=auto();INTRODUCER=auto();IRLIKE=auto();IS=auto();ISNULL=auto();JOIN=auto();JOIN_MARKER=auto();KEEP=auto();KEY=auto();KILL=auto();LANGUAGE=auto();LATERAL=auto();LEFT=auto();LIKE=auto();LIKE_ANY=auto();LIMIT=auto();LIST=auto();LOAD=auto();LOCK=auto();MAP=auto();MATCH_CONDITION=auto();MATCH_RECOGNIZE=auto();MEMBER_OF=auto();MERGE=auto();MOD=auto();MODEL=auto();NATURAL=auto();NEXT=auto();NOTNULL=auto();NULL=auto();OBJECT_IDENTIFIER=auto();OFFSET=auto();ON=auto();ONLY=auto();OPERATOR=auto();ORDER_BY=auto();ORDER_SIBLINGS_BY=auto();ORDERED=auto();ORDINALITY=auto();OUTER=auto();OVER=auto();OVERLAPS=auto();OVERWRITE=auto();PARTITION=auto();PARTITION_BY=auto();PERCENT=auto();PIVOT=auto();PLACEHOLDER=auto();POSITIONAL=auto();PRAGMA=auto();PREWHERE=auto();PRIMARY_KEY=auto();PROCEDURE=auto();PROPERTIES=auto();PSEUDO_TYPE=auto();QUALIFY=auto();QUOTE=auto();RANGE=auto();RECURSIVE=auto();REFRESH=auto();RENAME=auto();REPLACE=auto();RETURNING=auto();REFERENCES=auto();RIGHT=auto();RLIKE=auto();ROLLBACK=auto();ROLLUP=auto();ROW=auto();ROWS=auto();SELECT=auto();SEMI=auto();SEPARATOR=auto();SEQUENCE=auto();SERDE_PROPERTIES=auto();SET=auto();SETTINGS=auto();SHOW=auto();SIMILAR_TO=auto();SOME=auto();SORT_BY=auto();START_WITH=auto();STORAGE_INTEGRATION=auto();STRAIGHT_JOIN=auto();STRUCT=auto();SUMMARIZE=auto();TABLE_SAMPLE=auto();TAG=auto();TEMPORARY=auto();TOP=auto();THEN=auto();TRUE=auto();TRUNCATE=auto();UNCACHE=auto();UNION=auto();UNNEST=auto();UNPIVOT=auto();UPDATE=auto();USE=auto();USING=auto();VALUES=auto();VIEW=auto();VOLATILE=auto();WHEN=auto();WHERE=auto();WINDOW=auto();WITH=auto();UNIQUE=auto();VERSION_SNAPSHOT=auto();TIMESTAMP_SNAPSHOT=auto();OPTION=auto()
_ALL_TOKEN_TYPES=list(TokenType)
_TOKEN_TYPE_TO_INDEX={B:A for(A,B)in enumerate(_ALL_TOKEN_TYPES)}
class Token:
	__slots__='token_type','text','line','col','start','end','comments'
	@classmethod
	def number(A,number):'Returns a NUMBER token with `number` as its text.';return A(TokenType.NUMBER,str(number))
	@classmethod
	def string(A,string):'Returns a STRING token with `string` as its text.';return A(TokenType.STRING,string)
	@classmethod
	def identifier(A,identifier):'Returns an IDENTIFIER token with `identifier` as its text.';return A(TokenType.IDENTIFIER,identifier)
	@classmethod
	def var(A,var):'Returns an VAR token with `var` as its text.';return A(TokenType.VAR,var)
	def __init__(A,token_type,text,line=1,col=1,start=0,end=0,comments=_B):'Token initializer.\n\n        Args:\n            token_type: The TokenType Enum.\n            text: The text of the token.\n            line: The line that the token ends on.\n            col: The column that the token ends on.\n            start: The start index of the token.\n            end: The ending index of the token.\n            comments: The comments to attach to the token.\n        ';B=comments;A.token_type=token_type;A.text=text;A.line=line;A.col=col;A.start=start;A.end=end;A.comments=[]if B is _B else B
	def __repr__(A):B=', '.join(f"{B}: {getattr(A,B)}"for B in A.__slots__);return f"<Token {B}>"
class _Tokenizer(type):
	def __new__(D,clsname,bases,attrs):
		A=super().__new__(D,clsname,bases,attrs)
		def C(arr):return dict((A,A)if isinstance(A,str)else(A[0],A[1])for A in arr)
		def B(token_type,arr):return{A:(B,token_type)for(A,B)in C(arr).items()}
		A._QUOTES=C(A.QUOTES);A._IDENTIFIERS=C(A.IDENTIFIERS);A._FORMAT_STRINGS={**{C+A:(B,TokenType.NATIONAL_STRING)for(A,B)in A._QUOTES.items()for C in('n','N')},**B(TokenType.BIT_STRING,A.BIT_STRINGS),**B(TokenType.BYTE_STRING,A.BYTE_STRINGS),**B(TokenType.HEX_STRING,A.HEX_STRINGS),**B(TokenType.RAW_STRING,A.RAW_STRINGS),**B(TokenType.HEREDOC_STRING,A.HEREDOC_STRINGS),**B(TokenType.UNICODE_STRING,A.UNICODE_STRINGS)};A._STRING_ESCAPES=set(A.STRING_ESCAPES);A._IDENTIFIER_ESCAPES=set(A.IDENTIFIER_ESCAPES);A._COMMENTS={**dict((A,_B)if isinstance(A,str)else(A[0],A[1])for A in A.COMMENTS),'{#':'#}'};A._KEYWORD_TRIE=new_trie(B.upper()for B in(*A.KEYWORDS,*A._COMMENTS,*A._QUOTES,*A._FORMAT_STRINGS)if' 'in B or any(A in B for A in A.SINGLE_TOKENS))
		if USE_RS_TOKENIZER:E=RsTokenizerSettings(white_space={A:_TOKEN_TYPE_TO_INDEX[B]for(A,B)in A.WHITE_SPACE.items()},single_tokens={A:_TOKEN_TYPE_TO_INDEX[B]for(A,B)in A.SINGLE_TOKENS.items()},keywords={A:_TOKEN_TYPE_TO_INDEX[B]for(A,B)in A.KEYWORDS.items()},numeric_literals=A.NUMERIC_LITERALS,identifiers=A._IDENTIFIERS,identifier_escapes=A._IDENTIFIER_ESCAPES,string_escapes=A._STRING_ESCAPES,quotes=A._QUOTES,format_strings={A:(B,_TOKEN_TYPE_TO_INDEX[C])for(A,(B,C))in A._FORMAT_STRINGS.items()},has_bit_strings=bool(A.BIT_STRINGS),has_hex_strings=bool(A.HEX_STRINGS),comments=A._COMMENTS,var_single_tokens=A.VAR_SINGLE_TOKENS,commands={_TOKEN_TYPE_TO_INDEX[A]for A in A.COMMANDS},command_prefix_tokens={_TOKEN_TYPE_TO_INDEX[A]for A in A.COMMAND_PREFIX_TOKENS},heredoc_tag_is_identifier=A.HEREDOC_TAG_IS_IDENTIFIER,string_escapes_allowed_in_raw_strings=A.STRING_ESCAPES_ALLOWED_IN_RAW_STRINGS,nested_comments=A.NESTED_COMMENTS);F=RsTokenTypeSettings(bit_string=_TOKEN_TYPE_TO_INDEX[TokenType.BIT_STRING],break_=_TOKEN_TYPE_TO_INDEX[TokenType.BREAK],dcolon=_TOKEN_TYPE_TO_INDEX[TokenType.DCOLON],heredoc_string=_TOKEN_TYPE_TO_INDEX[TokenType.HEREDOC_STRING],raw_string=_TOKEN_TYPE_TO_INDEX[TokenType.RAW_STRING],hex_string=_TOKEN_TYPE_TO_INDEX[TokenType.HEX_STRING],identifier=_TOKEN_TYPE_TO_INDEX[TokenType.IDENTIFIER],number=_TOKEN_TYPE_TO_INDEX[TokenType.NUMBER],parameter=_TOKEN_TYPE_TO_INDEX[TokenType.PARAMETER],semicolon=_TOKEN_TYPE_TO_INDEX[TokenType.SEMICOLON],string=_TOKEN_TYPE_TO_INDEX[TokenType.STRING],var=_TOKEN_TYPE_TO_INDEX[TokenType.VAR],heredoc_string_alternative=_TOKEN_TYPE_TO_INDEX[A.HEREDOC_STRING_ALTERNATIVE]);A._RS_TOKENIZER=RsTokenizer(E,F)
		else:A._RS_TOKENIZER=_B
		return A
class Tokenizer(metaclass=_Tokenizer):
	SINGLE_TOKENS={'(':TokenType.L_PAREN,')':TokenType.R_PAREN,'[':TokenType.L_BRACKET,']':TokenType.R_BRACKET,'{':TokenType.L_BRACE,'}':TokenType.R_BRACE,'&':TokenType.AMP,'^':TokenType.CARET,':':TokenType.COLON,',':TokenType.COMMA,'.':TokenType.DOT,'-':TokenType.DASH,'=':TokenType.EQ,'>':TokenType.GT,'<':TokenType.LT,'%':TokenType.MOD,'!':TokenType.NOT,'|':TokenType.PIPE,'+':TokenType.PLUS,';':TokenType.SEMICOLON,'/':TokenType.SLASH,'\\':TokenType.BACKSLASH,'*':TokenType.STAR,'~':TokenType.TILDA,'?':TokenType.PLACEHOLDER,'@':TokenType.PARAMETER,'#':TokenType.HASH,"'":TokenType.UNKNOWN,'`':TokenType.UNKNOWN,'"':TokenType.UNKNOWN};BIT_STRINGS:t.List[str|t.Tuple[str,str]]=[];BYTE_STRINGS:t.List[str|t.Tuple[str,str]]=[];HEX_STRINGS:t.List[str|t.Tuple[str,str]]=[];RAW_STRINGS:t.List[str|t.Tuple[str,str]]=[];HEREDOC_STRINGS:t.List[str|t.Tuple[str,str]]=[];UNICODE_STRINGS:t.List[str|t.Tuple[str,str]]=[];IDENTIFIERS:t.List[str|t.Tuple[str,str]]=['"'];IDENTIFIER_ESCAPES=['"'];QUOTES:t.List[t.Tuple[str,str]|str]=["'"];STRING_ESCAPES=["'"];VAR_SINGLE_TOKENS:t.Set[str]=set();HEREDOC_TAG_IS_IDENTIFIER=_C;HEREDOC_STRING_ALTERNATIVE=TokenType.VAR;STRING_ESCAPES_ALLOWED_IN_RAW_STRINGS=_A;NESTED_COMMENTS=_A;_COMMENTS:t.Dict[str,str]={};_FORMAT_STRINGS:t.Dict[str,t.Tuple[str,TokenType]]={};_IDENTIFIERS:t.Dict[str,str]={};_IDENTIFIER_ESCAPES:t.Set[str]=set();_QUOTES:t.Dict[str,str]={};_STRING_ESCAPES:t.Set[str]=set();_KEYWORD_TRIE:t.Dict={};_RS_TOKENIZER:t.Optional[t.Any]=_B;KEYWORDS:t.Dict[str,TokenType]={**{f"{{%{A}":TokenType.BLOCK_START for A in('','+','-')},**{f"{A}%}}":TokenType.BLOCK_END for A in('','+','-')},**{f"{{{{{A}":TokenType.BLOCK_START for A in('+','-')},**{f"{A}}}}}":TokenType.BLOCK_END for A in('+','-')},'/*+':TokenType.HINT,'==':TokenType.EQ,'::':TokenType.DCOLON,'||':TokenType.DPIPE,'>=':TokenType.GTE,'<=':TokenType.LTE,'<>':TokenType.NEQ,'!=':TokenType.NEQ,':=':TokenType.COLON_EQ,'<=>':TokenType.NULLSAFE_EQ,'->':TokenType.ARROW,'->>':TokenType.DARROW,'=>':TokenType.FARROW,'#>':TokenType.HASH_ARROW,'#>>':TokenType.DHASH_ARROW,'<->':TokenType.LR_ARROW,'&&':TokenType.DAMP,'??':TokenType.DQMARK,'~~~':TokenType.GLOB,'~~':TokenType.LIKE,'~~*':TokenType.ILIKE,'~*':TokenType.IRLIKE,'ALL':TokenType.ALL,'ALWAYS':TokenType.ALWAYS,'AND':TokenType.AND,'ANTI':TokenType.ANTI,'ANY':TokenType.ANY,'ASC':TokenType.ASC,'AS':TokenType.ALIAS,'ASOF':TokenType.ASOF,'AUTOINCREMENT':TokenType.AUTO_INCREMENT,'AUTO_INCREMENT':TokenType.AUTO_INCREMENT,'BEGIN':TokenType.BEGIN,'BETWEEN':TokenType.BETWEEN,'CACHE':TokenType.CACHE,'UNCACHE':TokenType.UNCACHE,'CASE':TokenType.CASE,'CHARACTER SET':TokenType.CHARACTER_SET,'CLUSTER BY':TokenType.CLUSTER_BY,'COLLATE':TokenType.COLLATE,'COLUMN':TokenType.COLUMN,'COMMIT':TokenType.COMMIT,'CONNECT BY':TokenType.CONNECT_BY,'CONSTRAINT':TokenType.CONSTRAINT,'COPY':TokenType.COPY,'CREATE':TokenType.CREATE,'CROSS':TokenType.CROSS,'CUBE':TokenType.CUBE,'CURRENT_DATE':TokenType.CURRENT_DATE,'CURRENT_TIME':TokenType.CURRENT_TIME,'CURRENT_TIMESTAMP':TokenType.CURRENT_TIMESTAMP,'CURRENT_USER':TokenType.CURRENT_USER,'DATABASE':TokenType.DATABASE,'DEFAULT':TokenType.DEFAULT,'DELETE':TokenType.DELETE,'DESC':TokenType.DESC,'DESCRIBE':TokenType.DESCRIBE,'DISTINCT':TokenType.DISTINCT,'DISTRIBUTE BY':TokenType.DISTRIBUTE_BY,'DIV':TokenType.DIV,'DROP':TokenType.DROP,'ELSE':TokenType.ELSE,'END':TokenType.END,'ENUM':TokenType.ENUM,'ESCAPE':TokenType.ESCAPE,'EXCEPT':TokenType.EXCEPT,'EXECUTE':TokenType.EXECUTE,'EXISTS':TokenType.EXISTS,'FALSE':TokenType.FALSE,'FETCH':TokenType.FETCH,'FILTER':TokenType.FILTER,'FIRST':TokenType.FIRST,'FULL':TokenType.FULL,'FUNCTION':TokenType.FUNCTION,'FOR':TokenType.FOR,'FOREIGN KEY':TokenType.FOREIGN_KEY,'FORMAT':TokenType.FORMAT,'FROM':TokenType.FROM,'GEOGRAPHY':TokenType.GEOGRAPHY,'GEOMETRY':TokenType.GEOMETRY,'GLOB':TokenType.GLOB,'GROUP BY':TokenType.GROUP_BY,'GROUPING SETS':TokenType.GROUPING_SETS,'HAVING':TokenType.HAVING,'ILIKE':TokenType.ILIKE,'IN':TokenType.IN,'INDEX':TokenType.INDEX,'INET':TokenType.INET,'INNER':TokenType.INNER,'INSERT':TokenType.INSERT,'INTERVAL':TokenType.INTERVAL,'INTERSECT':TokenType.INTERSECT,'INTO':TokenType.INTO,'IS':TokenType.IS,'ISNULL':TokenType.ISNULL,'JOIN':TokenType.JOIN,'KEEP':TokenType.KEEP,'KILL':TokenType.KILL,'LATERAL':TokenType.LATERAL,'LEFT':TokenType.LEFT,'LIKE':TokenType.LIKE,'LIMIT':TokenType.LIMIT,'LOAD':TokenType.LOAD,'LOCK':TokenType.LOCK,'MERGE':TokenType.MERGE,'NATURAL':TokenType.NATURAL,'NEXT':TokenType.NEXT,'NOT':TokenType.NOT,'NOTNULL':TokenType.NOTNULL,'NULL':TokenType.NULL,'OBJECT':TokenType.OBJECT,'OFFSET':TokenType.OFFSET,'ON':TokenType.ON,'OR':TokenType.OR,'XOR':TokenType.XOR,'ORDER BY':TokenType.ORDER_BY,'ORDINALITY':TokenType.ORDINALITY,'OUTER':TokenType.OUTER,'OVER':TokenType.OVER,'OVERLAPS':TokenType.OVERLAPS,'OVERWRITE':TokenType.OVERWRITE,'PARTITION':TokenType.PARTITION,'PARTITION BY':TokenType.PARTITION_BY,'PARTITIONED BY':TokenType.PARTITION_BY,'PARTITIONED_BY':TokenType.PARTITION_BY,'PERCENT':TokenType.PERCENT,'PIVOT':TokenType.PIVOT,'PRAGMA':TokenType.PRAGMA,'PRIMARY KEY':TokenType.PRIMARY_KEY,'PROCEDURE':TokenType.PROCEDURE,'QUALIFY':TokenType.QUALIFY,'RANGE':TokenType.RANGE,'RECURSIVE':TokenType.RECURSIVE,'REGEXP':TokenType.RLIKE,'RENAME':TokenType.RENAME,'REPLACE':TokenType.REPLACE,'RETURNING':TokenType.RETURNING,'REFERENCES':TokenType.REFERENCES,'RIGHT':TokenType.RIGHT,'RLIKE':TokenType.RLIKE,'ROLLBACK':TokenType.ROLLBACK,'ROLLUP':TokenType.ROLLUP,'ROW':TokenType.ROW,'ROWS':TokenType.ROWS,'SCHEMA':TokenType.SCHEMA,'SELECT':TokenType.SELECT,'SEMI':TokenType.SEMI,'SET':TokenType.SET,'SETTINGS':TokenType.SETTINGS,'SHOW':TokenType.SHOW,'SIMILAR TO':TokenType.SIMILAR_TO,'SOME':TokenType.SOME,'SORT BY':TokenType.SORT_BY,'START WITH':TokenType.START_WITH,'STRAIGHT_JOIN':TokenType.STRAIGHT_JOIN,'TABLE':TokenType.TABLE,'TABLESAMPLE':TokenType.TABLE_SAMPLE,'TEMP':TokenType.TEMPORARY,'TEMPORARY':TokenType.TEMPORARY,'THEN':TokenType.THEN,'TRUE':TokenType.TRUE,'TRUNCATE':TokenType.TRUNCATE,'UNION':TokenType.UNION,'UNKNOWN':TokenType.UNKNOWN,'UNNEST':TokenType.UNNEST,'UNPIVOT':TokenType.UNPIVOT,'UPDATE':TokenType.UPDATE,'USE':TokenType.USE,'USING':TokenType.USING,'UUID':TokenType.UUID,'VALUES':TokenType.VALUES,'VIEW':TokenType.VIEW,'VOLATILE':TokenType.VOLATILE,'WHEN':TokenType.WHEN,'WHERE':TokenType.WHERE,'WINDOW':TokenType.WINDOW,'WITH':TokenType.WITH,'APPLY':TokenType.APPLY,'ARRAY':TokenType.ARRAY,'BIT':TokenType.BIT,'BOOL':TokenType.BOOLEAN,'BOOLEAN':TokenType.BOOLEAN,'BYTE':TokenType.TINYINT,'MEDIUMINT':TokenType.MEDIUMINT,'INT1':TokenType.TINYINT,'TINYINT':TokenType.TINYINT,'INT16':TokenType.SMALLINT,'SHORT':TokenType.SMALLINT,'SMALLINT':TokenType.SMALLINT,'INT128':TokenType.INT128,'HUGEINT':TokenType.INT128,'UHUGEINT':TokenType.UINT128,'INT2':TokenType.SMALLINT,'INTEGER':TokenType.INT,'INT':TokenType.INT,'INT4':TokenType.INT,'INT32':TokenType.INT,'INT64':TokenType.BIGINT,'LONG':TokenType.BIGINT,'BIGINT':TokenType.BIGINT,'INT8':TokenType.TINYINT,'UINT':TokenType.UINT,'DEC':TokenType.DECIMAL,'DECIMAL':TokenType.DECIMAL,'DECIMAL32':TokenType.DECIMAL32,'DECIMAL64':TokenType.DECIMAL64,'DECIMAL128':TokenType.DECIMAL128,'BIGDECIMAL':TokenType.BIGDECIMAL,'BIGNUMERIC':TokenType.BIGDECIMAL,'LIST':TokenType.LIST,'MAP':TokenType.MAP,'NULLABLE':TokenType.NULLABLE,'NUMBER':TokenType.DECIMAL,'NUMERIC':TokenType.DECIMAL,'FIXED':TokenType.DECIMAL,'REAL':TokenType.FLOAT,'FLOAT':TokenType.FLOAT,'FLOAT4':TokenType.FLOAT,'FLOAT8':TokenType.DOUBLE,'DOUBLE':TokenType.DOUBLE,'DOUBLE PRECISION':TokenType.DOUBLE,'JSON':TokenType.JSON,'JSONB':TokenType.JSONB,'CHAR':TokenType.CHAR,'CHARACTER':TokenType.CHAR,'NCHAR':TokenType.NCHAR,'VARCHAR':TokenType.VARCHAR,'VARCHAR2':TokenType.VARCHAR,'NVARCHAR':TokenType.NVARCHAR,'NVARCHAR2':TokenType.NVARCHAR,'BPCHAR':TokenType.BPCHAR,'STR':TokenType.TEXT,'STRING':TokenType.TEXT,'TEXT':TokenType.TEXT,'LONGTEXT':TokenType.LONGTEXT,'MEDIUMTEXT':TokenType.MEDIUMTEXT,'TINYTEXT':TokenType.TINYTEXT,'CLOB':TokenType.TEXT,'LONGVARCHAR':TokenType.TEXT,'BINARY':TokenType.BINARY,'BLOB':TokenType.VARBINARY,'LONGBLOB':TokenType.LONGBLOB,'MEDIUMBLOB':TokenType.MEDIUMBLOB,'TINYBLOB':TokenType.TINYBLOB,'BYTEA':TokenType.VARBINARY,'VARBINARY':TokenType.VARBINARY,'TIME':TokenType.TIME,'TIMETZ':TokenType.TIMETZ,'TIMESTAMP':TokenType.TIMESTAMP,'TIMESTAMPTZ':TokenType.TIMESTAMPTZ,'TIMESTAMPLTZ':TokenType.TIMESTAMPLTZ,'TIMESTAMP_LTZ':TokenType.TIMESTAMPLTZ,'TIMESTAMPNTZ':TokenType.TIMESTAMPNTZ,'TIMESTAMP_NTZ':TokenType.TIMESTAMPNTZ,'DATE':TokenType.DATE,'DATETIME':TokenType.DATETIME,'INT4RANGE':TokenType.INT4RANGE,'INT4MULTIRANGE':TokenType.INT4MULTIRANGE,'INT8RANGE':TokenType.INT8RANGE,'INT8MULTIRANGE':TokenType.INT8MULTIRANGE,'NUMRANGE':TokenType.NUMRANGE,'NUMMULTIRANGE':TokenType.NUMMULTIRANGE,'TSRANGE':TokenType.TSRANGE,'TSMULTIRANGE':TokenType.TSMULTIRANGE,'TSTZRANGE':TokenType.TSTZRANGE,'TSTZMULTIRANGE':TokenType.TSTZMULTIRANGE,'DATERANGE':TokenType.DATERANGE,'DATEMULTIRANGE':TokenType.DATEMULTIRANGE,'UNIQUE':TokenType.UNIQUE,'VECTOR':TokenType.VECTOR,'STRUCT':TokenType.STRUCT,'SEQUENCE':TokenType.SEQUENCE,'VARIANT':TokenType.VARIANT,'ALTER':TokenType.ALTER,'ANALYZE':TokenType.COMMAND,'CALL':TokenType.COMMAND,'COMMENT':TokenType.COMMENT,'EXPLAIN':TokenType.COMMAND,'GRANT':TokenType.GRANT,'OPTIMIZE':TokenType.COMMAND,'PREPARE':TokenType.COMMAND,'VACUUM':TokenType.COMMAND,'USER-DEFINED':TokenType.USERDEFINED,'FOR VERSION':TokenType.VERSION_SNAPSHOT,'FOR TIMESTAMP':TokenType.TIMESTAMP_SNAPSHOT};WHITE_SPACE:t.Dict[t.Optional[str],TokenType]={' ':TokenType.SPACE,'\t':TokenType.SPACE,'\n':TokenType.BREAK,'\r':TokenType.BREAK};COMMANDS={TokenType.COMMAND,TokenType.EXECUTE,TokenType.FETCH,TokenType.SHOW,TokenType.RENAME};COMMAND_PREFIX_TOKENS={TokenType.SEMICOLON,TokenType.BEGIN};NUMERIC_LITERALS:t.Dict[str,str]={};COMMENTS=['--',('/*','*/')];__slots__='sql','size','tokens','dialect','_start','_current','_line','_col','_comments','_char','_end','_peek','_prev_token_line','_rs_dialect_settings'
	def __init__(A,dialect=_B):
		from sqlglot.dialects import Dialect as B;A.dialect=B.get_or_raise(dialect)
		if USE_RS_TOKENIZER:A._rs_dialect_settings=RsTokenizerDialectSettings(unescaped_sequences=A.dialect.UNESCAPED_SEQUENCES,identifiers_can_start_with_digit=A.dialect.IDENTIFIERS_CAN_START_WITH_DIGIT)
		A.reset()
	def reset(A):A.sql='';A.size=0;A.tokens=[];A._start=0;A._current=0;A._line=1;A._col=0;A._comments=[];A._char='';A._end=_C;A._peek='';A._prev_token_line=-1
	def tokenize(A,sql):
		'Returns a list of tokens corresponding to the SQL string `sql`.';B=sql
		if USE_RS_TOKENIZER:return A.tokenize_rs(B)
		A.reset();A.sql=B;A.size=len(B)
		try:A._scan()
		except Exception as C:D=max(A._current-50,0);E=min(A._current+50,A.size-1);F=A.sql[D:E];raise TokenError(f"Error tokenizing '{F}'")from C
		return A.tokens
	def _scan(A,until=_B):
		D=until
		while A.size and not A._end:
			B=A._current
			while B<A.size:
				C=A.sql[B]
				if C.isspace()and(C==' 'or C=='\t'):B+=1
				else:break
			E=B-A._current if B>A._current else 1;A._start=B;A._advance(E)
			if not A._char.isspace():
				if A._char.isdigit():A._scan_number()
				elif A._char in A._IDENTIFIERS:A._scan_identifier(A._IDENTIFIERS[A._char])
				else:A._scan_keywords()
			if D and D():break
		if A.tokens and A._comments:A.tokens[-1].comments.extend(A._comments)
	def _chars(A,size):
		if size==1:return A._char
		B=A._current-1;C=B+size;return A.sql[B:C]if C<=A.size else''
	def _advance(A,i=1,alnum=_C):
		if A.WHITE_SPACE.get(A._char)is TokenType.BREAK:
			if not(A._char=='\r'and A._peek=='\n'):A._col=1;A._line+=1
		else:A._col+=i
		A._current+=i;A._end=A._current>=A.size;A._char=A.sql[A._current-1];A._peek=''if A._end else A.sql[A._current]
		if alnum and A._char.isalnum():
			E=A._col;B=A._current;C=A._end;D=A._peek
			while D.isalnum():E+=1;B+=1;C=B>=A.size;D=''if C else A.sql[B]
			A._col=E;A._current=B;A._end=C;A._peek=D;A._char=A.sql[B-1]
	@property
	def _text(self):A=self;return A.sql[A._start:A._current]
	def _add(A,token_type,text=_B):
		C=token_type;B=text;A._prev_token_line=A._line
		if A._comments and C==TokenType.SEMICOLON and A.tokens:A.tokens[-1].comments.extend(A._comments);A._comments=[]
		A.tokens.append(Token(C,text=A._text if B is _B else B,line=A._line,col=A._col,start=A._start,end=A._current-1,comments=A._comments));A._comments=[]
		if C in A.COMMANDS and A._peek!=';'and(len(A.tokens)==1 or A.tokens[-2].token_type in A.COMMAND_PREFIX_TOKENS):
			D=A._current;E=len(A.tokens);A._scan(lambda:A._peek==';');A.tokens=A.tokens[:E];B=A.sql[D:A._current].strip()
			if B:A._add(TokenType.STRING,B)
	def _scan_keywords(A):
		E=0;C=_B;D=A._text;B=D;F=_C;G=_C;K=A._KEYWORD_TRIE;H=B in A.SINGLE_TOKENS
		while D:
			if G:I=TrieResult.PREFIX
			else:I,K=in_trie(K,B.upper())
			if I==TrieResult.FAILED:break
			if I==TrieResult.EXISTS:C=D
			L=A._current+E;E+=1
			if L<A.size:
				B=A.sql[L];H=H or B in A.SINGLE_TOKENS;J=B.isspace()
				if not J or not F:
					if J:B=' '
					D+=B;F=J;G=_C
				else:G=_A
			else:B='';break
		if C:
			if A._scan_string(C):return
			if A._scan_comment(C):return
			if F or H or not B:A._advance(E-1);C=C.upper();A._add(A.KEYWORDS[C],text=C);return
		if A._char in A.SINGLE_TOKENS:A._add(A.SINGLE_TOKENS[A._char],text=A._char);return
		A._scan_var()
	def _scan_comment(A,comment_start):
		B=comment_start
		if B not in A._COMMENTS:return _C
		G=A._line;C=len(B);E=A._COMMENTS[B]
		if E:
			A._advance(C);F=1;D=len(E)
			while not A._end:
				if A._chars(D)==E:
					F-=1
					if not F:break
				A._advance(alnum=_A)
				if A.NESTED_COMMENTS and not A._end and A._chars(D)==B:A._advance(C);F+=1
			A._comments.append(A._text[C:-D+1]);A._advance(D-1)
		else:
			while not A._end and A.WHITE_SPACE.get(A._peek)is not TokenType.BREAK:A._advance(alnum=_A)
			A._comments.append(A._text[C:])
		if G==A._prev_token_line:A.tokens[-1].comments.extend(A._comments);A._comments=[];A._prev_token_line=A._line
		return _A
	def _scan_number(A):
		if A._char=='0':
			D=A._peek.upper()
			if D=='B':return A._scan_bits()if A.BIT_STRINGS else A._add(TokenType.NUMBER)
			elif D=='X':return A._scan_hex()if A.HEX_STRINGS else A._add(TokenType.NUMBER)
		E=_C;B=0
		while _A:
			if A._peek.isdigit():A._advance()
			elif A._peek=='.'and not E:
				if A.tokens and A.tokens[-1].token_type==TokenType.PARAMETER:return A._add(TokenType.NUMBER)
				E=_A;A._advance()
			elif A._peek in('-','+')and B==1:B+=1;A._advance()
			elif A._peek.upper()=='E'and not B:B+=1;A._advance()
			elif A._peek.isidentifier():
				F=A._text;C=''
				while A._peek.strip()and A._peek not in A.SINGLE_TOKENS:C+=A._peek;A._advance()
				G=A.KEYWORDS.get(A.NUMERIC_LITERALS.get(C.upper(),''))
				if G:A._add(TokenType.NUMBER,F);A._add(TokenType.DCOLON,'::');return A._add(G,C)
				elif A.dialect.IDENTIFIERS_CAN_START_WITH_DIGIT:return A._add(TokenType.VAR)
				A._advance(-len(C));return A._add(TokenType.NUMBER,F)
			else:return A._add(TokenType.NUMBER)
	def _scan_bits(A):
		A._advance();B=A._extract_value()
		try:int(B,2);A._add(TokenType.BIT_STRING,B[2:])
		except ValueError:A._add(TokenType.IDENTIFIER)
	def _scan_hex(A):
		A._advance();B=A._extract_value()
		try:int(B,16);A._add(TokenType.HEX_STRING,B[2:])
		except ValueError:A._add(TokenType.IDENTIFIER)
	def _extract_value(A):
		while _A:
			B=A._peek.strip()
			if B and B not in A.SINGLE_TOKENS:A._advance(alnum=_A)
			else:break
		return A._text
	def _scan_string(A,start):
		B=start;F=_B;C=TokenType.STRING
		if B in A._QUOTES:D=A._QUOTES[B]
		elif B in A._FORMAT_STRINGS:
			D,C=A._FORMAT_STRINGS[B]
			if C==TokenType.HEX_STRING:F=16
			elif C==TokenType.BIT_STRING:F=2
			elif C==TokenType.HEREDOC_STRING:
				A._advance()
				if A._char==D:E=''
				else:E=A._extract_string(D,raw_string=_A,raise_unmatched=not A.HEREDOC_TAG_IS_IDENTIFIER)
				if E and A.HEREDOC_TAG_IS_IDENTIFIER and(A._end or not E.isidentifier()):
					if not A._end:A._advance(-1)
					A._advance(-len(E));A._add(A.HEREDOC_STRING_ALTERNATIVE);return _A
				D=f"{B}{E}{D}"
		else:return _C
		A._advance(len(B));G=A._extract_string(D,raw_string=C==TokenType.RAW_STRING)
		if F:
			try:int(G,F)
			except Exception:raise TokenError(f"Numeric string contains invalid characters from {A._line}:{A._start}")
		A._add(C,G);return _A
	def _scan_identifier(A,identifier_end):A._advance();B=A._extract_string(identifier_end,escapes=A._IDENTIFIER_ESCAPES);A._add(TokenType.IDENTIFIER,B)
	def _scan_var(A):
		while _A:
			B=A._peek.strip()
			if B and(B in A.VAR_SINGLE_TOKENS or B not in A.SINGLE_TOKENS):A._advance(alnum=_A)
			else:break
		A._add(TokenType.VAR if A.tokens and A.tokens[-1].token_type==TokenType.PARAMETER else A.KEYWORDS.get(A._text.upper(),TokenType.VAR))
	def _extract_string(A,delimiter,escapes=_B,raw_string=_C,raise_unmatched=_A):
		F=raw_string;D=escapes;B=delimiter;C='';E=len(B);D=A._STRING_ESCAPES if D is _B else D
		while _A:
			if not F and A.dialect.UNESCAPED_SEQUENCES and A._peek and A._char in A.STRING_ESCAPES:
				G=A.dialect.UNESCAPED_SEQUENCES.get(A._char+A._peek)
				if G:A._advance(2);C+=G;continue
			if(A.STRING_ESCAPES_ALLOWED_IN_RAW_STRINGS or not F)and A._char in D and(A._peek==B or A._peek in D)and(A._char not in A._QUOTES or A._char==A._peek):
				if A._peek==B:C+=A._peek
				else:C+=A._char+A._peek
				if A._current+1<A.size:A._advance(2)
				else:raise TokenError(f"Missing {B} from {A._line}:{A._current}")
			else:
				if A._chars(E)==B:
					if E>1:A._advance(E-1)
					break
				if A._end:
					if not raise_unmatched:return C+A._char
					raise TokenError(f"Missing {B} from {A._line}:{A._start}")
				H=A._current-1;A._advance(alnum=_A);C+=A.sql[H:A._current-1]
		return C
	def tokenize_rs(A,sql):
		if not A._RS_TOKENIZER:raise SqlglotError('Rust tokenizer is not available')
		try:
			B=A._RS_TOKENIZER.tokenize(sql,A._rs_dialect_settings)
			for C in B:C.token_type=_ALL_TOKEN_TYPES[C.token_type_index]
			return B
		except Exception as D:raise TokenError(str(D))