_C=False
_B=None
_A=True
from sqlparse import sql,tokens as T
from sqlparse.utils import recurse,imt
T_NUMERICAL=T.Number,T.Number.Integer,T.Number.Float
T_STRING=T.String,T.String.Single,T.String.Symbol
T_NAME=T.Name,T.Name.Placeholder
def _group_matching(tlist,cls):
	'Groups Tokens that have beginning and end.';C=tlist;B=cls;D=[];E=0
	for(I,A)in enumerate(list(C)):
		F=I-E
		if A.is_whitespace:continue
		if A.is_group and not isinstance(A,B):_group_matching(A,B);continue
		if A.match(*B.M_OPEN):D.append(F)
		elif A.match(*B.M_CLOSE):
			try:G=D.pop()
			except IndexError:continue
			H=F;C.group_tokens(B,G,H);E+=H-G
def group_brackets(tlist):_group_matching(tlist,sql.SquareBrackets)
def group_parenthesis(tlist):_group_matching(tlist,sql.Parenthesis)
def group_case(tlist):_group_matching(tlist,sql.Case)
def group_if(tlist):_group_matching(tlist,sql.If)
def group_for(tlist):_group_matching(tlist,sql.For)
def group_begin(tlist):_group_matching(tlist,sql.Begin)
def group_typecasts(tlist):
	def A(token):return token.match(T.Punctuation,'::')
	def B(token):return token is not _B
	def C(tlist,pidx,tidx,nidx):return pidx,nidx
	D=E=B;_group(tlist,sql.Identifier,A,D,E,C)
def group_tzcasts(tlist):
	def A(token):return token.ttype==T.Keyword.TZCast
	def B(token):return token is not _B
	def C(token):A=token;return A is not _B and(A.is_whitespace or A.match(T.Keyword,'AS')or A.match(*sql.TypedLiteral.M_CLOSE))
	def D(tlist,pidx,tidx,nidx):return pidx,nidx
	_group(tlist,sql.Identifier,A,B,C,D)
def group_typed_literal(tlist):
	A=tlist
	def D(token):return imt(token,m=sql.TypedLiteral.M_OPEN)
	def E(token):return isinstance(token,sql.TypedLiteral)
	def B(token):return token is not _B
	def F(token):A=token;return A is not _B and A.match(*sql.TypedLiteral.M_CLOSE)
	def G(token):A=token;return A is not _B and A.match(*sql.TypedLiteral.M_EXTEND)
	def C(tlist,pidx,tidx,nidx):return tidx,nidx
	_group(A,sql.TypedLiteral,D,B,F,C,extend=_C);_group(A,sql.TypedLiteral,E,B,G,C,extend=_A)
def group_period(tlist):
	def A(token):
		for(A,B)in((T.Punctuation,'.'),(T.Operator,'->'),(T.Operator,'->>')):
			if token.match(A,B):return _A
		return _C
	def B(token):A=sql.SquareBrackets,sql.Identifier;B=T.Name,T.String.Symbol;return imt(token,i=A,t=B)
	def C(token):return _A
	def D(tlist,pidx,tidx,nidx):A=nidx;B=sql.SquareBrackets,sql.Function;C=T.Name,T.String.Symbol,T.Wildcard,T.String.Single;D=tlist[A]if A is not _B else _B;E=imt(D,i=B,t=C);return(pidx,A)if E else(pidx,tidx)
	_group(tlist,sql.Identifier,A,B,C,D)
def group_as(tlist):
	def A(token):A=token;return A.is_keyword and A.normalized=='AS'
	def B(token):A=token;return A.normalized=='NULL'or not A.is_keyword
	def C(token):A=token;B=T.DML,T.DDL,T.CTE;return not imt(A,t=B)and A is not _B
	def D(tlist,pidx,tidx,nidx):return pidx,nidx
	_group(tlist,sql.Identifier,A,B,C,D)
def group_assignment(tlist):
	def A(token):return token.match(T.Assignment,':=')
	def B(token):A=token;return A is not _B and A.ttype not in(T.Keyword,)
	def C(tlist,pidx,tidx,nidx):A=nidx;B=T.Punctuation,';';C,D=tlist.token_next_by(m=B,idx=A);A=C or A;return pidx,A
	D=E=B;_group(tlist,sql.Assignment,A,D,E,C)
def group_comparison(tlist):
	B=sql.Parenthesis,sql.Function,sql.Identifier,sql.Operation,sql.TypedLiteral;C=T_NUMERICAL+T_STRING+T_NAME
	def A(token):return token.ttype==T.Operator.Comparison
	def D(token):
		A=token
		if imt(A,t=C,i=B):return _A
		elif A and A.is_keyword and A.normalized=='NULL':return _A
		else:return _C
	def E(tlist,pidx,tidx,nidx):return pidx,nidx
	F=G=D;_group(tlist,sql.Comparison,A,F,G,E,extend=_C)
@recurse(sql.Identifier)
def group_identifier(tlist):
	B=tlist;C=T.String.Symbol,T.Name;A,D=B.token_next_by(t=C)
	while D:B.group_tokens(sql.Identifier,A,A);A,D=B.token_next_by(t=C,idx=A)
@recurse(sql.Over)
def group_over(tlist):
	A=tlist;B,C=A.token_next_by(m=sql.Over.M_OPEN)
	while C:
		D,E=A.token_next(B)
		if imt(E,i=sql.Parenthesis,t=T.Name):A.group_tokens(sql.Over,B,D)
		B,C=A.token_next_by(m=sql.Over.M_OPEN,idx=B)
def group_arrays(tlist):
	A=sql.SquareBrackets,sql.Identifier,sql.Function;B=T.Name,T.String.Symbol
	def C(token):return isinstance(token,sql.SquareBrackets)
	def D(token):return imt(token,i=A,t=B)
	def E(token):return _A
	def F(tlist,pidx,tidx,nidx):return pidx,tidx
	_group(tlist,sql.Identifier,C,D,E,F,extend=_A,recurse=_C)
def group_operator(tlist):
	B=T_NUMERICAL+T_STRING+T_NAME;C=sql.SquareBrackets,sql.Parenthesis,sql.Function,sql.Identifier,sql.Operation,sql.TypedLiteral
	def A(token):return imt(token,t=(T.Operator,T.Wildcard))
	def D(token):A=token;return imt(A,i=C,t=B)or A and A.match(T.Keyword,('CURRENT_DATE','CURRENT_TIME','CURRENT_TIMESTAMP'))
	def E(tlist,pidx,tidx,nidx):tlist[tidx].ttype=T.Operator;return pidx,nidx
	F=G=D;_group(tlist,sql.Operation,A,F,G,E,extend=_C)
def group_identifier_list(tlist):
	A=T.Keyword,('null','role');B=sql.Function,sql.Case,sql.Identifier,sql.Comparison,sql.IdentifierList,sql.Operation;C=T_NUMERICAL+T_STRING+T_NAME+(T.Keyword,T.Comment,T.Wildcard)
	def D(token):return token.match(T.Punctuation,',')
	def E(token):return imt(token,i=B,m=A,t=C)
	def F(tlist,pidx,tidx,nidx):return pidx,nidx
	G=H=E;_group(tlist,sql.IdentifierList,D,G,H,F,extend=_A)
@recurse(sql.Comment)
def group_comments(tlist):
	A=tlist;B,D=A.token_next_by(t=T.Comment)
	while D:
		C,E=A.token_not_matching(lambda tk:imt(tk,t=T.Comment)or tk.is_newline,idx=B)
		if E is not _B:C,E=A.token_prev(C,skip_ws=_C);A.group_tokens(sql.Comment,B,C)
		B,D=A.token_next_by(t=T.Comment,idx=B)
@recurse(sql.Where)
def group_where(tlist):
	A=tlist;B,E=A.token_next_by(m=sql.Where.M_OPEN)
	while E:
		D,C=A.token_next_by(m=sql.Where.M_CLOSE,idx=B)
		if C is _B:C=A._groupable_tokens[-1]
		else:C=A.tokens[D-1]
		D=A.token_index(C);A.group_tokens(sql.Where,B,D);B,E=A.token_next_by(m=sql.Where.M_OPEN,idx=B)
@recurse()
def group_aliased(tlist):
	A=tlist;C=sql.Parenthesis,sql.Function,sql.Case,sql.Identifier,sql.Operation,sql.Comparison;B,D=A.token_next_by(i=C,t=T.Number)
	while D:
		E,F=A.token_next(B)
		if isinstance(F,sql.Identifier):A.group_tokens(sql.Identifier,B,E,extend=_A)
		B,D=A.token_next_by(i=C,t=T.Number,idx=B)
@recurse(sql.Function)
def group_functions(tlist):
	A=tlist;D=_C;E=_C;F=_C
	for C in A.tokens:
		if C.value.upper()=='CREATE':D=_A
		if C.value.upper()=='TABLE':E=_A
		if C.value=='AS':F=_A
	if D and E and not F:return
	B,G=A.token_next_by(t=T.Name)
	while G:
		H,K=A.token_next(B)
		if isinstance(K,sql.Parenthesis):
			L,I=A.token_next(H)
			if I and isinstance(I,sql.Over):J=L
			else:J=H
			A.group_tokens(sql.Function,B,J)
		B,G=A.token_next_by(t=T.Name,idx=B)
@recurse(sql.Identifier)
def group_order(tlist):
	'Group together Identifier and Asc/Desc token';B=tlist;A,C=B.token_next_by(t=T.Keyword.Order)
	while C:
		D,E=B.token_prev(A)
		if imt(E,i=sql.Identifier,t=T.Number):B.group_tokens(sql.Identifier,D,A);A=D
		A,C=B.token_next_by(t=T.Keyword.Order,idx=A)
@recurse()
def align_comments(tlist):
	B=tlist;A,C=B.token_next_by(i=sql.Comment)
	while C:
		D,E=B.token_prev(A)
		if isinstance(E,sql.TokenList):B.group_tokens(sql.TokenList,D,A,extend=_A);A=D
		A,C=B.token_next_by(i=sql.Comment,idx=A)
def group_values(tlist):
	B=tlist;A,C=B.token_next_by(m=(T.Keyword,'VALUES'));E=A;D=-1
	while C:
		if isinstance(C,sql.Parenthesis):D=A
		A,C=B.token_next(A)
	if D!=-1:B.group_tokens(sql.Values,E,D,extend=_A)
def group(stmt):
	for A in[group_comments,group_brackets,group_parenthesis,group_case,group_if,group_for,group_begin,group_over,group_functions,group_where,group_period,group_arrays,group_identifier,group_order,group_typecasts,group_tzcasts,group_typed_literal,group_operator,group_comparison,group_as,group_aliased,group_assignment,align_comments,group_identifier_list,group_values]:A(stmt)
	return stmt
def _group(tlist,cls,match,valid_prev=lambda t:_A,valid_next=lambda t:_A,post=_B,extend=_A,recurse=_A):
	'Groups together tokens that are joined by a middle token. i.e. x < y';K=extend;J=valid_next;I=valid_prev;H=match;E=cls;B=tlist;L=0;F,C=_B,_B
	for(N,A)in enumerate(list(B)):
		D=N-L
		if D<0:continue
		if A.is_whitespace:continue
		if recurse and A.is_group and not isinstance(A,E):_group(A,E,H,I,J,post,K)
		if H(A):
			O,P=B.token_next(D)
			if C and I(C)and J(P):G,M=post(B,F,D,O);Q=B.group_tokens(E,G,M,extend=K);L+=M-G;F,C=G,Q;continue
		F,C=D,A