'SQL Lexer'
_A=None
import re
from threading import Lock
from io import TextIOBase
from sqlparse import tokens,keywords
from sqlparse.utils import consume
class Lexer:
	'The Lexer supports configurable syntax.\n    To add support for additional keywords, use the `add_keywords` method.';_default_instance=_A;_lock=Lock()
	@classmethod
	def get_default_instance(A):
		'Returns the lexer instance used internally\n        by the sqlparse core functions.'
		with A._lock:
			if A._default_instance is _A:A._default_instance=A();A._default_instance.default_initialization()
		return A._default_instance
	def default_initialization(A):'Initialize the lexer with default dictionaries.\n        Useful if you need to revert custom syntax settings.';A.clear();A.set_SQL_REGEX(keywords.SQL_REGEX);A.add_keywords(keywords.KEYWORDS_COMMON);A.add_keywords(keywords.KEYWORDS_ORACLE);A.add_keywords(keywords.KEYWORDS_MYSQL);A.add_keywords(keywords.KEYWORDS_PLPGSQL);A.add_keywords(keywords.KEYWORDS_HQL);A.add_keywords(keywords.KEYWORDS_MSACCESS);A.add_keywords(keywords.KEYWORDS_SNOWFLAKE);A.add_keywords(keywords.KEYWORDS_BIGQUERY);A.add_keywords(keywords.KEYWORDS)
	def clear(A):'Clear all syntax configurations.\n        Useful if you want to load a reduced set of syntax configurations.\n        After this call, regexps and keyword dictionaries need to be loaded\n        to make the lexer functional again.';A._SQL_REGEX=[];A._keywords=[]
	def set_SQL_REGEX(A,SQL_REGEX):'Set the list of regex that will parse the SQL.';B=re.IGNORECASE|re.UNICODE;A._SQL_REGEX=[(re.compile(A,B).match,C)for(A,C)in SQL_REGEX]
	def add_keywords(A,keywords):'Add keyword dictionaries. Keywords are looked up in the same order\n        that dictionaries were added.';A._keywords.append(keywords)
	def is_keyword(D,value):
		"Checks for a keyword.\n\n        If the given value is in one of the KEYWORDS_* dictionary\n        it's considered a keyword. Otherwise, tokens.Name is returned.\n        ";A=value;B=A.upper()
		for C in D._keywords:
			if B in C:return C[B],A
		else:return tokens.Name,A
	def get_tokens(D,text,encoding=_A):
		"\n        Return an iterable of (tokentype, value) pairs generated from\n        `text`. If `unfiltered` is set to `True`, the filtering mechanism\n        is bypassed even if filters are defined.\n\n        Also preprocess the text, i.e. expand tabs and strip it if\n        wanted and applies registered filters.\n\n        Split ``text`` into (tokentype, text) pairs.\n\n        ``stack`` is the initial stack (default: ``['root']``)\n        ";E=encoding;A=text
		if isinstance(A,TextIOBase):A=A.read()
		if isinstance(A,str):0
		elif isinstance(A,bytes):
			if E:A=A.decode(E)
			else:
				try:A=A.decode('utf-8')
				except UnicodeDecodeError:A=A.decode('unicode-escape')
		else:raise TypeError('Expected text or file-like object, got {!r}'.format(type(A)))
		F=enumerate(A)
		for(G,H)in F:
			for(I,C)in D._SQL_REGEX:
				B=I(A,G)
				if not B:continue
				elif isinstance(C,tokens._TokenType):yield(C,B.group())
				elif C is keywords.PROCESS_AS_KEYWORD:yield D.is_keyword(B.group())
				consume(F,B.end()-G-1);break
			else:yield(tokens.Error,H)
def tokenize(sql,encoding=_A):'Tokenize sql.\n\n    Tokenize *sql* using the :class:`Lexer` and return a 2-tuple stream\n    of ``(token type, value)`` items.\n    ';return Lexer.get_default_instance().get_tokens(sql,encoding)